/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock
var cluster;
var provider;
var timer = 0;
var count = 0, goodCount = 0;
var types;
var regions;
var regionsAttributes = new Object();
var selectedRegions;
var images;
var netmap;
var tunnels;
var message;
var cloudCategory;
var waitCount = 0;
var primaryCommitTime = 0;
var clouderrors;
var badpassword = false;

var myDefRegion = 'us-east-1';

var TYPE_VPC = 'VPC';
var TYPE_EC2 = 'EC2';
var cloudTypes = new Array(TYPE_VPC, TYPE_EC2);
var cloudnets = new Object(); // contains cloud networks. Use cloudnets[TYPE_VPC] / cloudnets[TYPE_EC2]

var COMMIT_TIME_DIFF = 3000;
var DEBUG = 0; // KDR: TODO -1

function onLoad() {
  dock = getDock();
  println("Add Cloud Provider Wizard initialized: " + this.name);
  
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  
  message = document.getElementById('message');
  message.value = 'Please enter cloud account information:';

  if(myDialog.arguments.clouddirector) {
    document.title = 'Add Cloud Director Wizard';
    var obj = document.getElementById('dialogtitle');
    if(obj) obj.value = document.title;
    
    document.getElementById('deck').selectedIndex = 3;
    provider = myDialog.arguments.provider;
    netmap = cluster.findNetMapNetwork();
    regions = cluster.find('EC2Region');
    types = cluster.find('EC2Type');
    images = cluster.find('EC2AMI');
    regionNetworks(true);
  } else if(DEBUG >= 0) {
    document.getElementById('deck').selectedIndex = DEBUG;
    if(DEBUG >= 0) {
      var l = readListFromFile('/home/koen/ec2.info');
      if(l.length >= 5) {
        document.getElementById('accountName').value = l[0];
        document.getElementById('username').value = l[1];
        document.getElementById('accountId').value = l[2];
        document.getElementById('accountKey').value = l[3];
        document.getElementById('secretKey').value = l[4];
        myDefRegion = 'eu-west-1';
      }
    }
    if(DEBUG >= 1) {
      provider = cluster.find('CloudProvider', 'Amazon EC2');
      regions = cluster.find('EC2Region');
      types = cluster.find('EC2Type');
      images = cluster.find('EC2AMI');      
    }
    if(DEBUG >= 3) {
      netmap = cluster.findNetMapNetwork();
    }
    if(DEBUG == 3) {
      regionNetworks();
    } else if(DEBUG == 4) {
      addCloudNetworks();
    } else if(DEBUG == 5) {
      regionNetworks();
      tunnels = cluster.findTunnelNetworks();
      masterInterfaces();
    } else if(DEBUG == 6) {
      tunnels = cluster.findTunnelNetworks();
      regionNetworks();
      directors();
    } else if(DEBUG == 7) {
      primaryCommitTime = new Date();
      primaryCommitTime = primaryCommitTime.getTime();
      netmapip();
    } else if(DEBUG == 8) {
      finalize();
    }
  }

}

function next() {
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);
  switch(index) {
  case(0) :
    if(!checkname()) return;
    break;
  case(1) :
    if(checkdefault()) return;
    break;
  case(2) :
    if(!checknetmap()) return;
    break;
  case(3):
    if(!checktunnels()) return;
    break;
  case(4) :
    if(!checkcloudnets()) return;
    break;
  case(5):
    if(!checkmaster()) return;
    break;
  case(6):
    if(!checkdirector()) return;
    break;
  case(7):
    if(!setNetmapip()) return;
    break;
  }
  index++;
  if(index == 2) {
    netmap = cluster.findNetMapNetwork();
    if(netmap) index++;
  } else if(index == 7) {
    if(!netmapip(true)) index++;
  }
  switch(index) {
  case(1) :
    count = 0;
    message.height = '64px';
    message.value = 'Waiting for data from Amazon EC2';
    timer = window.setTimeout('checkStatus();', 3000);
    waitIcon();
    break;
  case(2):
    addNetMapNetwork();
    break;
  case(3):
    regionNetworks();
    break;
  case(4):
    addCloudNetworks();
    break;
  case(5):
    masterInterfaces();
    break;
  case(6):
    directors();
    break;
  case(7):
    netmapip();
    break;
  case(8):
    finalize();
  }
  document.getElementById('deck').selectedIndex = index;
  document.getElementById('prev').setAttribute('disabled', index == 0);
  document.getElementById('next').setAttribute('hidden', index == pages);
  document.getElementById('next').setAttribute('disabled', timer != 0);
  document.getElementById('finish').setAttribute('hidden', index < pages);
}

function prev() {
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);
  var back = true;
  switch(index) {
    case(3):
      break;
  }
  if(back) {
    index--;
    switch(index) {
      case(0):
        types = new Array();
        regions = new Array();
        images = new Array();
        document.getElementById('defaults').setAttribute('hidden', true);
        document.getElementById('wait').removeAttribute('hidden');
        break;
    }
    document.getElementById('deck').selectedIndex = index;
    document.getElementById('prev').setAttribute('disabled', index == 0);
    document.getElementById('next').setAttribute('hidden', index == pages);
    document.getElementById('next').removeAttribute('disabled');
    document.getElementById('finish').setAttribute('hidden', index < pages);
  }
}

function checkname() {
  var name = document.getElementById('accountName').value;
  if(name.length == 0) {
    dock.displayError('Name should be specified');
    return false;
  } else if(!badpassword) {
    var old = cluster.find('CloudProvider', name);
    if(old) {
      dock.displayError('A cloud provider with that name alread exists');
      return false;
    }
  }
  if(document.getElementById('username').value.length == 0) {
    dock.displayError('Username should be specified');
    return false;
  }
  if(document.getElementById('accountId').value.length == 0) {
    dock.displayError('Accound ID should be specified');
    return false;
  }
  if(document.getElementById('accountKey').value.length == 0) {
    dock.displayError('AWS account key should be specified');
    return false;
  }
  if(document.getElementById('secretKey').value.length == 0) {
    dock.displayError('AWS secret key should be specified');
    return false;
  }
  if(!badpassword) {
    provider = new dock.cvEC2Provider();
    provider.name = name;
    provider = cluster.addObject(provider, false, true);
  }
  provider.set('accountId', document.getElementById('accountId').value.replace(/[-\s]+/g, '').trim());
  provider.set('username', document.getElementById('username').value.trim());
  provider.set('accessKeyId', document.getElementById('accountKey').value.trim());
  provider.set('accessKeySecret', document.getElementById('secretKey').value.trim());  
  return provider.commitNonThreaded();
}

function checkdefault() {
  var region = parseInt(document.getElementById('regions').selectedItem.getAttribute('key'));
  if(region == 0) {
    dock.displayError('Set default region');
    return false;
  }
  var type = parseInt(document.getElementById('types').selectedItem.getAttribute('key'));
  if(type == 0) {
    dock.displayError('Set default cloud director type');
    return false;
  }
  var directorType = parseInt(document.getElementById('directorTypes').selectedItem.getAttribute('key'));
  if(directorType == 0) {
    dock.displayError('Set default cloud director type');
    return false;
  }
  var image = parseInt(document.getElementById('images').selectedItem.getAttribute('key'));
  provider.set('defaultRegion', region);
  provider.set('defaultType', type);
  provider.set('defaultDirectorType', directorType);  
  provider.set('defaultAMI', image);
  return !provider.commitNonThreaded();
}

function checknetmap() {
  var name = document.getElementById('netmap').value;
  if(name.length == 0) {
    dock.displayError('NetMap network name needs to be set');
    return false;
  } else {
    var old = cluster.find('Network', name);
    if(old) {
      dock.displayError('A network with that name alread exists');
      return false;
    }
  }
  var ip = document.getElementById('netmap-0').value + '.' + document.getElementById('netmap-1').value + '.' + document.getElementById('netmap-2').value + '.' + document.getElementById('netmap-3').value;
  if(!regexMatch(ip, dock.REGEX_IPv4)) {
    dock.displayError(ip + ' is not a valid ip');
    return false;
  }
  var bits = parseInt(document.getElementById('netmap-bits').value);
  if((bits <= 0) || (bits > 31)) {
    dock.displayError('Netmask bits needs to be a value between 0 and 31');
    return false;
  }
  netmap = new dock.cvNetwork();
  netmap.name = name;
  netmap = cluster.addObject(netmap, false, true);
  netmap.set('baseAddress', ip);
  netmap.set('netmaskBits', bits);
  netmap.set('type', 'NETMAP');
  waitIcon();
  netmap.commitNonThreaded();
  unwaitIcon();
  return true;
}

function checkcloudnets() {
  var statusOK = true;

  if (document.getElementById('defaultvpc').getAttribute('hidden') == 'false') {
    statusOK = checkcloudnet(TYPE_VPC);
  }

  if (statusOK && (document.getElementById('ec2classic').getAttribute('hidden') == 'false')) {
    statusOK = checkcloudnet(TYPE_EC2);
  }

  return statusOK;
}

function checkcloudnet(type) {
  if(eval(document.getElementById('existing' + type + 'cloudnetwork').getAttribute('on'))) {
    var item = document.getElementById(type + 'cloudnetwork').selectedItem;
    if(!item) {
      dock.displayError('Select an existing cloud network, or create a new one');
      return false;
    }
    var key = parseInt(item.getAttribute('key'));
    cloudnets[type] = cluster.find(key);
    if(!cloudnets[type]) {
      dock.displayError('Selected cloud network key not found: ' + key);
      return false;      
    }
  } else {
    var name = document.getElementById(type + 'cloud').value;
    if(name.length == 0) {
      dock.displayError('Cloud network name needs to be set');
      return false;
    } else {
      var old = cluster.find('Network', name);
      if(old) {
        dock.displayError('A network with that name alread exists');
        return false;
      }
    }
    var ip = document.getElementById(type + 'cloud-0').value + '.' + document.getElementById(type + 'cloud-1').value + '.' + document.getElementById(type + 'cloud-2').value + '.' + document.getElementById(type + 'cloud-3').value;
    if(!regexMatch(ip, dock.REGEX_IPv4)) {
      dock.displayError(ip + ' is not a valid ip');
      return false;
    }
    var bits = parseInt(document.getElementById(type + 'cloud-bits').value);
    if((bits <= 0) || (bits > 31)) {
      dock.displayError('Netmask bits needs to be a value between 0 and 31');
      return false;
    }
    cloudnets[type] = new dock.cvNetwork();
    cloudnets[type].name = name;
    cloudnets[type] = cluster.addObject(cloudnets[type], false, true);
    cloudnets[type].set('domainName', name + '.cluster');
    cloudnets[type].set('baseAddress', ip);
    cloudnets[type].set('netmaskBits', bits);
    cloudnets[type].set('type', 'CLOUD');
    waitIcon();
    cloudnets[type].commitNonThreaded();
    unwaitIcon();
  }
  
  return true;
}

function checktunnels() {
  tunnels = new Array();
  var n = 0;
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var nwn = document.getElementById('textbox-' + name).value;
      if(nwn.length == 0) {
        dock.displayError('Cloud network name needs to be set');
        return false;
//       } else {
//         var old = cluster.find('Network', name);
//         if(old) {
//           dock.displayError('A network with name "' + nwn + '" alread exists');
//           return false;
//         }
      }
      var ip = document.getElementById('ip-' + name + '-0').value + '.' + document.getElementById('ip-' + name + '-1').value + '.' + document.getElementById('ip-' + name + '-2').value + '.' + document.getElementById('ip-' + name + '-3').value;
      if(!regexMatch(ip, dock.REGEX_IPv4)) {
        dock.displayError(ip + ' is not a valid ip');
        return false;
      }
      var bits = parseInt(document.getElementById('ip-' + name + '-bits').value);
      if((bits <= 0) || (bits > 31)) {
        dock.displayError('Netmask bits needs to be a value between 0 and 31');
        return false;
      }
      n++;
    }
  }
  if(n <= 0) {
    dock.displayError('Select at least on region');
    return false;
  }

  selectedRegions = new Array();

  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var nwn = document.getElementById('textbox-' + name).value;
      var ip = document.getElementById('ip-' + name + '-0').value + '.' + document.getElementById('ip-' + name + '-1').value + '.' + document.getElementById('ip-' + name + '-2').value + '.' + document.getElementById('ip-' + name + '-3').value;
      var bits = parseInt(document.getElementById('ip-' + name + '-bits').value);
      var tunnel = cluster.find('Network', nwn);
      if(!tunnel) {
        tunnel = new dock.cvNetwork();
        tunnel.name = nwn;
        tunnel = cluster.addObject(tunnel, false, true);
      }
      tunnel.set('baseAddress', ip);
      tunnel.set('netmaskBits', bits);
      tunnel.set('type', 'TUNNEL');
      waitIcon();
      tunnel.commitNonThreaded();
      unwaitIcon();
      tunnels.push(tunnel);
      selectedRegions.push(regions[i]);
    }
  }

  return true;
}

function createTunnelInterface(name, ip, nw) {
  var intf = new dock.cvNetworkTunnelInterface();
  intf = new dock.cvObject(cluster, intf);
  intf.set('name', name);
  if(isObject(nw)) {
    intf.set('network', nw.get('uniqueKey'));
  } else {
    intf.set('network', nw);
  }
  intf.set('ip', ip);
  intf.set('modified', true);
  intf.set('toBeRemoved', false);
  return intf;
}

function createNetMapInterface(name, ip, nw) {
  var intf = new dock.cvNetworkNetMapInterface();
  intf = new dock.cvObject(cluster, intf);
  intf.set('name', name);
  if(isObject(nw)) {
    intf.set('network', nw.get('uniqueKey'));
  } else {
    intf.set('network', nw);
  }
  intf.set('ip', ip);
  intf.set('modified', true);
  intf.set('toBeRemoved', false);
  return intf;
}

function createPhysicalInterface(name, ip, nw) {
  var intf = new dock.cvNetworkPhysicalInterface();
  intf = new dock.cvObject(cluster, intf);
  intf.set('name', name);
  if(isObject(nw)) {
    intf.set('network', nw.get('uniqueKey'));
  } else {
    intf.set('network', nw);
  }
  if(ip == '0.0.0.0') intf.set('dhcp', true);
  intf.set('ip', ip);
  intf.set('modified', true);
  intf.set('toBeRemoved', false);
  return intf;
}

function addCloudDirectorRole(node) {
  var roles = node.get('roles');
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == 'CloudDirectorRole') return;
  }
  var one = new dock.cvCloudDirectorRole();
  one = new dock.cvObject(node.cluster, one);
  one.set('modified', true);
  one.set('toBeRemoved', false);
  roles.push(one.object);
  node.set('roles', roles);
}

function addCloudGatewayRole(node) {
  var roles = node.get('roles');
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == 'CloudGatewayRole') return;
  }
  var one = new dock.cvCloudGatewayRole();
  one = new dock.cvObject(node.cluster, one);
  one.set('modified', true);
  one.set('toBeRemoved', false);
  roles.push(one.object);
  node.set('roles', roles);
}

function addStorageRole(node) {
  var roles = node.get('roles');
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == 'StorageRole') return;
  }
  var one = new dock.cvStorageRole();
  one = new dock.cvObject(node.cluster, one);
  one.set('modified', true);
  one.set('toBeRemoved', false);
  roles.push(one.object);
  node.set('roles', roles);
}

function removeSchedulerRoles(node) {
  var schedulers = ['SGEClientRole', 'SGEServerRole', 'TorqueClientRole', 'TorqueServerRole', 'OpenLavaServerRole', 'OpenLavaClientRole', 'LSFServerRole', 'LSFClientRole', 'PbsProServerRole', 'PbsProClientRole', 'SlurmServerRole', 'SlurmClientRole'];
  var roles = node.get('roles');
  for(var i = 0; i < roles.length; i++) {
    roles[i].toBeRemoved = (schedulers.find(roles[i].childType) >= 0);
  }
  node.set('roles', roles);
}

function createEBSStorage(name, drive, size) {
  var one = new dock.cvEC2EBSStorage();
  one = new dock.cvObject(cluster, one);
  one.set('name', name);
  one.set('drive', drive);
  one.set('size', size);
  one.set('modified', true);
  one.set('toBeRemoved', false);
  return one;
}

function createEphermeralStorage(name, drive) {
  var one = new dock.cvEC2EphemeralStorage();                       
  one = new dock.cvObject(cluster, one);
  one.set('name', name);
  one.set('drive', drive);
  one.set('modified', true);
  one.set('toBeRemoved', false);
  return one;
}

function noDupInterfaces(list, intf) {
  for(var i = 0; i < list.length; i++) {
    if((list[i].network == intf.network) && (list[i].ip == intf.ip)) return false;
  }
  return true;
}

function checkmaster() {
  var primary = cluster.getBasePartition();
  var secondary = cluster.find(primary.get('primaryMaster'));
  primary = cluster.find(primary.get('primaryMaster'));
  var interfacesP = primary.get('networks');
  var interfacesS = new Array()
  if(secondary) interfacesS = secondary.get('networks');

  var usedP = new Array();
  for(var i = 0; i < interfacesP.length; i++) {
    usedP.push(interfacesP[i].name);
  }
  var usedS = new Array();
  for(var i = 0; i < interfacesS.length; i++) {
    usedS.push(interfacesS[i].name);
  }
  
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var tun = document.getElementById('masterinterface-' + name).value;
      if(tun.indexOf('(') < 0) {
        if(usedP.find(tun) >= 0) {
          dock.displayError('Head node ' + primary.get('hostname') + ' already has ' + tun + ' interface');
          return false;
        }
        if(usedS.find(tun) >= 0) {
          dock.displayError('Head node ' + secondary.get('hostname') + ' already has ' + tun + ' interface');
          return false;
        }
        var ip = document.getElementById('masterip-' + name + '-0').value + '.' + document.getElementById('masterip-' + name + '-1').value + '.' + document.getElementById('masterip-' + name + '-2').value + '.' + document.getElementById('masterip-' + name + '-3').value;
        if(!regexMatch(ip, dock.REGEX_IPv4)) {
          dock.displayError(ip + ' is not a valid ip');
          return false;
        }
      }
    }
  }

  var j = 0;
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var tun = document.getElementById('masterinterface-' + name).value;
      if(tun.indexOf('(') < 0) {
        var ip = document.getElementById('masterip-' + name + '-0').value + '.' + document.getElementById('masterip-' + name + '-1').value + '.' + document.getElementById('masterip-' + name + '-2').value + '.' + document.getElementById('masterip-' + name + '-3').value;    
        var intf = createTunnelInterface(tun, ip, tunnels[j]);
        if(noDupInterfaces(interfacesP, intf.object)) {
          interfacesP.push(intf.object);
          primary.set('networks', interfacesP);
        }
        if(secondary) {
          var intf = createTunnelInterface(tun, ip, tunnels[j]);
          if(noDupInterfaces(interfacesS, intf.object)) {
            interfacesS.push(intf.object);
            secondary.set('networks', interfacesS);
          }
        }
      }
      j++;
    }
  }

  addCloudGatewayRole(primary);

  if(secondary) {
    addCloudGatewayRole(secondary);
  }

  var fsid = 0, fsexportsS;
  var fsexports = primary.get('fsexports');
  for(var i = 0; i < fsexports.length; i++) {
    if(fsid < fsexports[i].fsid) fsid = fsexports[i].fsid;
  }
  if(secondary) {
    fsexportsS = primary.get('fsexports');
    for(var i = 0; i < fsexportsS.length; i++) {
      if(fsid < fsexportsS[i].fsid) fsid = fsexportsS[i].fsid;
    }
  }

  primaryCommitTime = new Date();
  primaryCommitTime = primaryCommitTime.getTime();

  waitIcon();
  // KDR: home no longer needed because of TS code
//   for(var j = 0; j < tunnels.length; j++) {
//     var hosts = '!' + tunnels[j].get('uniqueKey') + '!';
//     var f = false;
//     for(var i = 0; i < fsexports.length; i++) {
//       if((fsexports[i].path == '/home') && (fsexports[i].hosts == hosts)) {
//         f = true;
//         break;
//       }
//     }
//     fsid++;
//     if(!f) {
//       var one = new dock.cvFSExport();
//       one = new dock.cvObject(cluster, one);
//       one.set('name', '/home@' + tunnels[j].resolveName());
//       one.set('path', '/home');
//       one.set('allowWrite', true);
//       one.set('hosts', hosts);
//       one.set('modified', true);
//       one.set('toBeRemoved', false);      
//       one.set('fsid', fsid);
//       fsexports.push(one.object);
//       primary.set('fsexports', fsexports);
//     }
//     if(secondary) {
//       var f = false;
//       for(var i = 0; i < fsexportsS.length; i++) {
//         if((fsexportsS[i].path == '/home') && (fsexportsS[i].hosts == hosts)) {
//           f = true;
//           break;
//         }
//       }
//       if(!f) {
//         var one = new dock.cvFSExport();
//         one = new dock.cvObject(cluster, one);
//         one.set('name', '/home@' + tunnels[j].resolveName());
//         one.set('path', '/home');
//         one.set('allowWrite', true);
//         one.set('hosts', hosts);
//         one.set('modified', true);
//         one.set('toBeRemoved', false);
//         one.set('fsid', fsid);
//         fsexportsS.push(one.object);
//         secondary.set('fsexports', fsexportsS);
//       }
//     }
//   }
  primary.commitNonThreaded();
  if(secondary) secondary.commitNonThreaded();
  unwaitIcon();

  for(var j = 0; j < tunnels.length; j++) {
    if(!tunnels[j].get('management')) {
      tunnels[j].set('management', true);
      tunnels[j].commitNonThreaded();
    }
  }
  
  return true;
}

function createCloudCategory(category) {
  var object = category.clone();
  object.modified = true;
  object.toBeRemoved = false;
  object.name = 'cloud-director';
  var finalize = new Array();
  finalize.push("#!/bin/bash");
  finalize.push("# Cloud directors need to have ip_forwarding enabled (when it uses multiple openvpn processes)");
  finalize.push("perl -pi -e 's/net\.ipv4\.ip_forward = 0/net.ipv4.ip_forward = 1/' /localdisk/etc/sysctl.d/90-cm-sysctl.conf");
  finalize.push("perl -pi -e 's/net\.ipv4\.ip_forward = 0/#net.ipv4.ip_forward = 1/' /localdisk/etc/sysctl.conf");
  finalize.push("if [ -e /localdisk/etc/sysconfig/sysctl ]; then");
  finalize.push("  perl -pi -e 's/IP_FORWARD=\"no\"/IP_FORWARD=\"yes\"/' /localdisk/etc/sysconfig/sysctl");
  finalize.push("fi");
  object.finalize = finalize.join('\n');
  
  object = cluster.addObject(object, false);
  var fsmounts = object.get('fsmounts');
  for(var i = 0; i < fsmounts.length; i++) {
    if(fsmounts[i].mountpoint == '/cm/shared') {
      fsmounts[i].toBeRemoved = true;
    } else if(fsmounts[i].mountpoint == '/home') {
      fsmounts[i].toBeRemoved = true;
    }
  }

  /* we don't add exports to the category, but to cloud directors (see function "checkdirector")
  var fsexports = object.get('fsexports');
  for (var i = 0; i < cloudTypes.length; i++) {
    var type = cloudTypes[i];
    if (cloudnets[type]) {
      var one = new dock.cvFSExport();
      one = new dock.cvObject(cluster, one);
      one.set('name', '/cm/shared@' + cloudnets[type].resolveName());
      one.set('path', '/cm/shared');
      one.set('allowWrite', true);
      one.set('hosts', '!' + cloudnets[type].get('uniqueKey') + '!');
      one.set('modified', true);
      one.set('toBeRemoved', false);
      fsexports.push(one.object);
      var one = new dock.cvFSExport();
      one = new dock.cvObject(cluster, one);
      one.set('name', '/home@' + cloudnets[type].resolveName());
      one.set('path', '/home');
      one.set('allowWrite', true);
      one.set('hosts', '!' + cloudnets[type].get('uniqueKey') + '!');
      one.set('modified', true);
      one.set('toBeRemoved', false);
      fsexports.push(one.object);
    }
  }
  object.set('fsexports', fsexports);
  */

  addStorageRole(object);
  removeSchedulerRoles(object);
  return object;
}

function checkdirector() {
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var hostname = document.getElementById('director-' + name).value;
      var old = cluster.find('Device', hostname);
      if(old) {
        dock.displayError('A device with hostname ' + hostname + ' already exists');
        return false;
      }
      var ip = document.getElementById('directorip-' + name + '-0').value + '.' + document.getElementById('directorip-' + name + '-1').value + '.' + document.getElementById('directorip-' + name + '-2').value + '.' + document.getElementById('directorip-' + name + '-3').value;
      if(!regexMatch(ip, dock.REGEX_IPv4)) {
        dock.displayError(ip + ' is not a valid ip');
        return false;
      }
    }
  }

  var base = cluster.getBasePartition();
  
  var j = 0;
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var hostname = document.getElementById('director-' + name).value;
      var ip = document.getElementById('directorip-' + name + '-0').value + '.' + document.getElementById('directorip-' + name + '-1').value + '.' + document.getElementById('directorip-' + name + '-2').value + '.' + document.getElementById('directorip-' + name + '-3').value;
      var node = new dock.cvCloudNode();
      node.hostname = hostname;
      node = cluster.addObject(node, false, false);
      node.set('partition', base.get('uniqueKey'));
      node.set('category', cloudCategory.get('uniqueKey'));
      var interfaces = new Array();
      var intf = createTunnelInterface('tun0', ip, tunnels[j]);
      interfaces.push(intf.object);
      var attributes = regionsAttributes[regions[i].get('uniqueKey')];
      var type = "";
      if (attributes.supports.indexOf(TYPE_EC2) != -1) {
        type = TYPE_EC2;
      } else if (attributes.defaultVPC != '') {
        type = TYPE_VPC;
      }
      var intf = createPhysicalInterface('eth0', '0.0.0.0', cloudnets[type]);
      interfaces.push(intf.object);
      node.set('networks', interfaces);
      node.set('provisioningNetwork', interfaces[0].uniqueKey);
      node.set('managementNetwork', tunnels[j].get('uniqueKey'));
      node.set('powerControl', 'cloud');
      addCloudDirectorRole(node);
      var cloudsettings = node.get('cloudSettings');
      if(cloudsettings) {
        if(cloudsettings.childType == 'EC2Settings') {
          cloudsettings.provider = provider.get('uniqueKey');
          cloudsettings.region = regions[i].get('uniqueKey');
          var storage = new Array();
          var s = createEBSStorage('ebs', 'sdb', 42 * 1024 * 1024 * 1024);
          storage.push(s.object);
          var s = createEphermeralStorage('ephemeral0', 'sdc');
          storage.push(s.object);
          cloudsettings.storage = storage;
          cloudsettings.modified = true;
        }
      }

      // add fsexports to node, NOT to category
      var fsexports = node.get('fsexports');
      if (cloudnets[type]) {
        var one = new dock.cvFSExport();
        one = new dock.cvObject(cluster, one);
        one.set('name', '/cm/shared@' + cloudnets[type].resolveName());
        one.set('path', '/cm/shared');
        one.set('allowWrite', true);
        one.set('hosts', '!' + cloudnets[type].get('uniqueKey') + '!');
        one.set('modified', true);
        one.set('toBeRemoved', false);
        fsexports.push(one.object);
        var one = new dock.cvFSExport();
        one = new dock.cvObject(cluster, one);
        one.set('name', '/home@' + cloudnets[type].resolveName());
        one.set('path', '/home');
        one.set('allowWrite', true);
        one.set('hosts', '!' + cloudnets[type].get('uniqueKey') + '!');
        one.set('modified', true);
        one.set('toBeRemoved', false);
        fsexports.push(one.object);
      }
      node.set('fsexports', fsexports);
      cluster.addObject(node, false, true);
      node.commitNonThreaded();
      j++;
    }
  }
  return true;
}

function checkStatus() {
  timer = 0;
  count++;
  if((clouderrors && clouderrors.length > 0) || (count > 40)) {    
    var msg = "Unable to retrieve data from cloud provider, verify account information.";
    if(clouderrors && clouderrors.length > 0) msg += "\n\nLatest errors from Amazon EC2:\n" + clouderrors.join('\n');
    dock.displayError(msg);
    unwaitIcon();
    badpassword = true;
    clouderrors = new Array();
    prev();
    return;
  }
  if(count >= 1) {
    dock.workerpool.getWorker(cluster.actualurl).call('cmcloud', 'getLatestCloudErrors', null, function(code, data) {
        if(code == 0) {
          this.current.clouderrors = data;
        } else {
          dock.jsonCallError(this, code, data);
        }
      }, cluster);
    }
  types = cluster.find('EC2Type');
  if(types.length == 0) {
    println('Still no types, count = ' + count);
    timer = window.setTimeout('checkStatus();', 3000);
    return;
  }
  regions = cluster.find('EC2Region');
  if(regions.length == 0) {
    println('Still no regions, count = ' + count);
    timer = window.setTimeout('checkStatus();', 3000);
    return;
  }
  images = cluster.find('EC2AMI');
  if(images.length == 0) {
    println('Still no images, count = ' + count);
    timer = window.setTimeout('checkStatus();', 3000);
    return;
  }

  goodCount++;
  if(goodCount <= 3) {
    println('Good, wait again anyway, count = ' + goodCount);
    timer = window.setTimeout('checkStatus();', 5000);
    return;
  }
  
  unwaitIcon();
  message.value = 'Please select default values:';
  
  timer = 0;
  document.getElementById('next').removeAttribute('disabled');
  
  document.getElementById('wait').setAttribute('hidden', true);  
  document.getElementById('defaults').removeAttribute('hidden');

  var found = 0;
  var list = document.getElementById('regions');
  var popup = list.firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var item = document.createElement('menuitem');
    item.setAttribute('key', regions[i].get('uniqueKey'));
    item.setAttribute('label', name);
    popup.appendChild(item);
    if(name == myDefRegion) found = i;
  }
  list.selectedIndex = found;
  
  var found = 0;
  var list = document.getElementById('types');
  var popup = list.firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < types.length; i++) {
    var name = types[i].resolveName();
    var item = document.createElement('menuitem');
    item.setAttribute('key', types[i].get('uniqueKey'));
    item.setAttribute('label', name);
    popup.appendChild(item);
    if(name == 't1.micro') found = i;
  }
  list.selectedIndex = found;

  var found = 0;
  var list = document.getElementById('directorTypes');
  var popup = list.firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < types.length; i++) {
    var name = types[i].resolveName();
    var item = document.createElement('menuitem');
    item.setAttribute('key', types[i].get('uniqueKey'));
    item.setAttribute('label', name);
    popup.appendChild(item);
    if(name == 'm1.large') found = i;
  }
  list.selectedIndex = found;

  var latest = '';
  var found = 0;
  var m = 0;
  var list = document.getElementById('images');
  var popup = list.firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < images.length; i++) {
    var name = images[i].resolveName();
    var item = document.createElement('menuitem');
    item.setAttribute('key', images[i].get('uniqueKey'));
    item.setAttribute('label', name);
    popup.appendChild(item);
    var nn = nameNumber(name);
    if(nn[0] == 'brightinstaller-') {
      if(nn[1] > m) {
        latest = name;
        m = nn[1];
        found = i;
      }
    }
  }
  if(m) {
    item.setAttribute('key', 0);
    item.setAttribute('label', 'latest:' + latest);
    popup.appendChild(item);
    list.selectedIndex = popup.childNodes.length - 1;
  } else {
    list.selectedIndex = found;
  }
}

function disableSiblings(item, value) {
  item = item.nextSibling;
  while(item) {
    item.setAttribute('disabled', value);
    item = item.nextSibling;
  }
}

function addNetMapNetwork() {
  message.height = '96px';
  message.value = "The NetMap network is used to make local cluster nodes accessible from the cloud. All nodes in the local cluster will be assigned an IP address in the NetMap network.\n\nPlease choose an unused IP subnet for the NetMap network:";
}

function addCloudNetworks() {
  message.height = '64px';
  message.value = "The cloud network is a network that represents the internal network of the cloud provider.";

  var vpcmessage = document.getElementById('vpcmessage');
  var ec2message = document.getElementById('ec2message');
  vpcmessage.value = "\n\nPlease select a cloud network for regions supporting only 'EC2-VPC' platform: ";
  ec2message.value = "\n\nPlease select a cloud network for regions supporting 'EC2-Classic' platform: ";

  var vpcRegions = new Array();
  var ec2Regions = new Array();
  for (var i = 0; i < selectedRegions.length; ++i) {
    var key = selectedRegions[i].object.uniqueKey;
    if (regionsAttributes[key].supports.indexOf(TYPE_EC2) != -1) {
      ec2Regions.push(selectedRegions[i].object.name);      
    }
    if (regionsAttributes[key].supports.indexOf(TYPE_VPC) != -1) {
    }
    if (regionsAttributes[key].defaultVPC != '') {
      vpcRegions.push(selectedRegions[i].object.name);
    }
  }

  if (vpcRegions.length && ec2Regions.length) {
    message.height = '96px';
    message.value += "\n\nSome of the selected regions only support 'EC2-VPC' platform, while others support 'EC2-Classic' platform. Those 2 platforms by default require different base network addresses, which means that 2 different cloud networks must be configured.";
  } else if (vpcRegions.length) {
    message.value += "\n\nThe selected regions only support 'EC2-VPC' platform. The CIDR block for a default VPC is always 172.31.0.0/16.";
  } else if (ec2Regions.length) {
    message.value += "\n\nThe selected regions support 'EC2-Classic' platform. The suggested CIDR block is 10.0.0.0/8.";
  }

  if (vpcRegions.length) {
    vpcmessage.value += vpcRegions + ".";
    showCloudNetworkForm('VPCcloudnetwork', 'existingVPCcloudnetwork', 'newVPCcloudnetwork', '172.31.0.0', '16');
    document.getElementById('defaultvpc').setAttribute('hidden', false);
  }
  if (ec2Regions.length) {
    ec2message.value += ec2Regions + ".";
    showCloudNetworkForm('EC2cloudnetwork', 'existingEC2cloudnetwork', 'newEC2cloudnetwork', '10.0.0.0', '8');
    document.getElementById('ec2classic').setAttribute('hidden', false);
  }
}

function showCloudNetworkForm(listId, existingNetId, newNetId, baseAddress, netmaskBits) {
  var list = document.getElementById(listId);
  var networks = cluster.findCloudNetworks(baseAddress, netmaskBits);
  if(networks.length) {
    var popup = list.firstChild;
    while(popup.firstChild) popup.removeChild(popup.firstChild);
    for(var i = 0; i < networks.length; i++) {
      var name = networks[i].resolveName();
      var item = document.createElement('menuitem');
      item.setAttribute('key', networks[i].get('uniqueKey'));
      item.setAttribute('label', name);
      popup.appendChild(item);
    }
    list.selectedIndex = 0;        
    var on = document.getElementById(existingNetId);
    var off = document.getElementById(newNetId);
    on.setAttribute('on', true);
  } else {
    var off = document.getElementById(existingNetId);
    var on = document.getElementById(newNetId);
    on.setAttribute('on', true);
    list.setAttribute('disabled', true);
  }
}

function setVPCCloudNetwork(index) {
  setCloudNetwork(index, 'existingVPCcloudnetwork', 'newVPCcloudnetwork');
}

function setEC2CloudNetwork(index) {
  setCloudNetwork(index, 'existingEC2cloudnetwork', 'newEC2cloudnetwork');
}

function setCloudNetwork(index, existingNetId, newNetId) {
  var on, off;
  if(index == 0) {
    on = document.getElementById(existingNetId);
    off = document.getElementById(newNetId);
  } else {
    off = document.getElementById(existingNetId);
    on = document.getElementById(newNetId);
  }
  on.setAttribute('on', true);
  off.setAttribute('on', false);
}

function regionNetworks(disableExisting) {
  disableExisting = isundefined(disableExisting, false);
  message.height = '120px';
  message.value = "For each of the cloud regions that will be used, a tunnel network needs to be defined. A tunnel network is used to make cloud nodes accessible within the cluster.\n\nPlease select the regions that will be used and choose an unused IP subnet for the tunnel network in each range:";

  // to get 'next' button disabled
  timer = window.setTimeout('', 0);
  document.getElementById('next').setAttribute('disabled', timer != 0);

  var free = new Array();
  for(var i = 16; i < 30; i++) {
    free.push(i);
  }
  var networks = cluster.findTunnelNetworks();
  var removedNetworks = new Object();
  for(var i = 0; i < networks.length; i++) {
    if(networks[i].get('netmaskBits') == 16) {
      var ip = networks[i].get('baseAddress').split('.');
      if((ip.length == 4) && (ip[0] == '172')) {
        var ip1 = myParseInt(ip[1])
        free.remove(ip1);
        removedNetworks[networks[i].resolveName()] = ip1;
      }
    }
  }
  
  var networkregions = document.getElementById('networkregions');
  while(networkregions.childNodes > 2) networkregions.removeChild(networkregions.lastChild);  

  var tunnelregions = new Object(); // tunnels already used
  var hasRegion = new Array();
  if(disableExisting) {
    var cds = cluster.find('CloudNode');
    for(var i = 0; i < cds.length; i++) {
      if(cds[i].hasCloudDirectorRole()) {
        var regionKey = cds[i].getCloudRegion().get('uniqueKey');
        var crn = cds[i].getCloudRegion().resolveName();
        hasRegion.push(crn);
        if(removedNetworks.hasOwnProperty(crn)) delete removedNetworks[crn];

        var cdsNetworks = cds[i].get('networks');
        for (var j = 0; j < cdsNetworks.length; j++) {
          var key = cdsNetworks[j].network;
          var net = cluster.find(key).object;
          if (net.type == 'TUNNEL') {
            tunnelregions[regionKey] = net.uniqueKey;
          }
        }
      }
    }
    /*
    for(var name in removedNetworks) {
      free.push(removedNetworks[name]);
    }
    free = free.sort();
    */
  }
  
  var defregion = provider.get('defaultRegion');
  getRegionAttributes(provider.object.uniqueKey, defregion);

  var j = 0; // counter for free
  for(var i = 0; i < regions.length; i++) {
    var regionKey = regions[i].get('uniqueKey');
    if(regionKey != defregion) {
      getRegionAttributes(provider.object.uniqueKey, regionKey);
    }
    var tunnel = cluster.find(tunnelregions[regionKey]);
    var tunnelName;
    var tunnelBaseAddress;
    var tunnelNetmaskBits;
    if (tunnel) {
      tunnelName = tunnel.resolveName();
      if (tunnel.get('baseAddress')) {
        tunnelBaseAddress = tunnel.get('baseAddress').split('.');
      }
      tunnelNetmaskBits = tunnel.get('netmaskBits');
    }
    var name = regions[i].resolveName();
    var row = document.createElement('row');
    row.setAttribute('align', 'center');
    var check;
    var disabled = (hasRegion.find(name) >= 0);
    if(disabled) {
      check = document.createElement('shadowlabel');
      check.setAttribute('style', 'padding-left: 10px');
      check.setAttribute('value', name);
    } else {
      check = document.createElement('checkimage');
      check.setAttribute('oncommand', 'useRegion(' + i + ');');
      check.setAttribute('label', name);
      if(regionKey == defregion) check.setAttribute('checked', true);
    }
    check.setAttribute('id', 'check-' + name);
    row.appendChild(check);
    var textbox = document.createElement('textbox');
    if(disabled || (regionKey != defregion)) textbox.setAttribute('disabled', true);    
    textbox.setAttribute('id', 'textbox-' + name);
    if (disabled && tunnel) {
      textbox.setAttribute('value', tunnelName);
    } else {
      textbox.setAttribute('value', name);
    }
    row.appendChild(textbox);    
    var hbox = document.createElement('hbox');
    hbox.setAttribute('align', 'center');
    var textbox = document.createElement('textbox');
    textbox.setAttribute('id', 'ip-' + name + '-0');
    if(disabled || (regionKey != defregion)) textbox.setAttribute('disabled', true);
    textbox.setAttribute('class', 'ip');
    if (disabled && tunnel && tunnelBaseAddress && (tunnelBaseAddress.length == 4)) {
      textbox.setAttribute('value', tunnelBaseAddress[0]);
    } else {
      textbox.setAttribute('value', '172');
    }
    hbox.appendChild(textbox);    
    var textbox = document.createElement('textbox');
    textbox.setAttribute('id', 'ip-' + name + '-1');
    if(disabled || (regionKey != defregion)) textbox.setAttribute('disabled', true);
    textbox.setAttribute('class', 'ip');
    if (disabled && tunnel && tunnelBaseAddress && (tunnelBaseAddress.length == 4)) {
      textbox.setAttribute('value', tunnelBaseAddress[1]);
    } else {
      if(j < free.length) {
        textbox.setAttribute('value', free[j]);
      } else {
        textbox.setAttribute('value', j + 32 - free.length);
      }
      j++;
    }
    hbox.appendChild(textbox);    
    var textbox = document.createElement('textbox');
    textbox.setAttribute('id', 'ip-' + name + '-2');
    if(disabled || (regionKey != defregion)) textbox.setAttribute('disabled', true);
    textbox.setAttribute('class', 'ip');
    if (disabled && tunnel && tunnelBaseAddress && (tunnelBaseAddress.length == 4)) {
      textbox.setAttribute('value', tunnelBaseAddress[2]);
    } else {
      textbox.setAttribute('value', '0');
    }
    hbox.appendChild(textbox);    
    var textbox = document.createElement('textbox');
    textbox.setAttribute('id', 'ip-' + name + '-3');
    if(disabled || (regionKey != defregion)) textbox.setAttribute('disabled', true);
    textbox.setAttribute('class', 'ip');
    if (disabled && tunnel && tunnelBaseAddress && (tunnelBaseAddress.length == 4)) {
      textbox.setAttribute('value', tunnelBaseAddress[3]);
    } else {
      textbox.setAttribute('value', '0');
    }
    hbox.appendChild(textbox);    
    var slash = document.createElement('shadowlabel');
    slash.setAttribute('value', '/');
    hbox.appendChild(slash);
    var textbox = document.createElement('textbox');
    textbox.setAttribute('id', 'ip-' + name + '-bits');
    if(disabled || (regionKey != defregion)) textbox.setAttribute('disabled', true);
    textbox.setAttribute('class', 'ip');
    if (disabled && tunnel) {
      textbox.setAttribute('value', tunnelNetmaskBits);
    } else {
      textbox.setAttribute('value', '16');
    }
    hbox.appendChild(textbox);
    row.appendChild(hbox);
    var lastbox = document.createElement('hbox');
    lastbox.setAttribute('id', 'box-vpc' + regionKey);
    if (regionsAttributes[regionKey] == undefined) {
      var image = document.createElement('image');
      image.setAttribute('style', 'margin-left: 10px');
      image.setAttribute('id', 'throbber' + regionKey);
      image.setAttribute('src', 'chrome://cmgui/content/icons/throbber.gif');
      lastbox.appendChild(image);
    }
    var label = document.createElement('label');
    label.setAttribute('style', 'margin-left: 0px');
    label.setAttribute('disabled', true);    
    label.setAttribute('id', 'label-vpc' + regionKey);
    lastbox.appendChild(label);
    row.appendChild(lastbox);

    networkregions.appendChild(row);
  }
}

function useRegion(i) {
  var name = regions[i].resolveName();
  var check = document.getElementById('check-' + name);
  if(check.checked) {
    document.getElementById('textbox-' + name).removeAttribute('disabled');
    document.getElementById('ip-' + name + '-0').removeAttribute('disabled');
    document.getElementById('ip-' + name + '-1').removeAttribute('disabled');
    document.getElementById('ip-' + name + '-2').removeAttribute('disabled');
    document.getElementById('ip-' + name + '-3').removeAttribute('disabled');
    document.getElementById('ip-' + name + '-bits').removeAttribute('disabled');
  } else {
    document.getElementById('textbox-' + name).setAttribute('disabled', true);
    document.getElementById('ip-' + name + '-0').setAttribute('disabled', true);
    document.getElementById('ip-' + name + '-1').setAttribute('disabled', true);
    document.getElementById('ip-' + name + '-2').setAttribute('disabled', true);
    document.getElementById('ip-' + name + '-3').setAttribute('disabled', true);
    document.getElementById('ip-' + name + '-bits').setAttribute('disabled', true);
  }
}

function masterInterfaces() {
  message.height = '64px';
  message.value = "The head node(s) needs a tunnel network interface on each tunnel network.\nPlease assign an IP address for the head node(s) on each tunnel network:";
  
  var masterinterfaces = document.getElementById('masterinterfaces');
  while(masterinterfaces.childNodes > 2) masterinterfaces.removeChild(masterinterfaces.lastChild);  

  var master = cluster.getBasePartition();
  master = cluster.find(master.get('primaryMaster'));
  var interfaces = master.get('networks');
  
  var free = new Array();
  for(var i = 0; i < interfaces.length + regions.length; i++) {
    free.push(i);
  }
  var tunRegions = new Object();
  for(var i = 0; i < interfaces.length; i++) {
    var nn = nameNumber(interfaces[i].name);
    if(nn[0] == 'tun') {
      free.remove(myParseInt(nn[1]));
      var network = cluster.find(interfaces[i].network);
      if(network) tunRegions[network.get('name')] = interfaces[i];
    }
  }
  
  var j = 0;
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);
    if(check.checked) {
      var tunnel = tunnels[j];
      var ip = tunnel.get('baseAddress');
      var bits = tunnel.get('netmaskBits');
      var offset = ((1 << bits) - 1) - 1; // master 254
      ip = plusIP(ip, offset);
      ip = ip.split('.');
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var check = document.createElement('shadowlabel');
      check.setAttribute('value', name);
      row.appendChild(check);
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'masterinterface-' + name);
      if(tunRegions.hasOwnProperty(name)) {
        textbox.setAttribute('value', tunRegions[name].name + ' (exists)');
      } else {
        textbox.setAttribute('value', 'tun' + free[j]);
        j++;
      }
      row.appendChild(textbox);    
      var hbox = document.createElement('hbox');
      hbox.setAttribute('align', 'center');
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'masterip-' + name + '-0');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[0]);
      hbox.appendChild(textbox);    
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'masterip-' + name + '-1');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[1]);
      hbox.appendChild(textbox);    
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'masterip-' + name + '-2');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[2]);
      hbox.appendChild(textbox);    
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'masterip-' + name + '-3');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[3]);
      hbox.appendChild(textbox);    
      row.appendChild(hbox);
      masterinterfaces.appendChild(row);
    }
  }
}

function directors() {
  cloudCategory = cluster.find('Category', 'cloud-director');
  if(!cloudCategory) {
    var base = cluster.getBasePartition();
    var category = cluster.find(base.get('defaultCategory'));
    cloudCategory = createCloudCategory(category);
    waitIcon();
    cloudCategory.commitNonThreaded();
    unwaitIcon();
  }
  
  message.height = '64px';
  message.value = "A cloud director needs to be present in each region.\nPlease assign an IP address on the tunnel network for the cloud director in each region:";
  
  var clouddirectors = document.getElementById('clouddirectors');
  while(clouddirectors.childNodes > 2) clouddirectors.removeChild(clouddirectors.lastChild);  

  var j = 0;
  for(var i = 0; i < regions.length; i++) {
    var name = regions[i].resolveName();
    var check = document.getElementById('check-' + name);        
    if(check.checked) {      
      var tunnel = tunnels[j];
      var ip = tunnel.get('baseAddress');
      var bits = tunnel.get('netmaskBits');
      var offset = ((1 << bits) - 1) - 4; // cloud director 251      
      ip = plusIP(ip, offset);
      ip = ip.split('.');
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var check = document.createElement('shadowlabel');
      check.setAttribute('value', name);
      row.appendChild(check);
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'director-' + name);
      textbox.setAttribute('value', name + '-director');
      row.appendChild(textbox);    
      var hbox = document.createElement('hbox');
      hbox.setAttribute('align', 'center');
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'directorip-' + name + '-0');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[0]);
      hbox.appendChild(textbox);    
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'directorip-' + name + '-1');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[1]);
      hbox.appendChild(textbox);    
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'directorip-' + name + '-2');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[2]);
      hbox.appendChild(textbox);    
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'directorip-' + name + '-3');
      textbox.setAttribute('class', 'ip');
      textbox.setAttribute('value', ip[3]);
      hbox.appendChild(textbox);    
      row.appendChild(hbox);
      clouddirectors.appendChild(row);
      j++;
    }
  }  
}

function netmapip(test) {
  test = isundefined(test, false);
  var spaces = new Array();
  
  if(!test) {
    var now = new Date();
    now = now.getTime();
    var left = COMMIT_TIME_DIFF - (now - primaryCommitTime);
    println("+++++++ Time left: " + left);
    if(left > 0) timer = window.setTimeout('enableNext();', left);
    spaces[0] = '';
    for(var i = 1; i < 32; i++) {
      spaces[i] = spaces[i - 1] + ' ';
    }
  }
  var base = netmap.get('baseAddress');
  var netmask = netmap.get('netmaskBits');
           //          1         2         3         4
           // 12345678901234567890123456789012345678901234567
  var text = "Hostname        NetMap IP\n";
  text +=    "-------------------------------\n";
  var nodes = cluster.find('Node');
  for(var i = 0; i < nodes.length; i++) {
    if(dock.baseChildTypeCheck(nodes[i].object, 'CloudNode')) continue;
    if(nodes[i].get('uniqueKey') < dock.MAX_LOCAL_KEY) continue;
    if(hasNetMapIP(nodes[i])) continue;
    if(test) return true;
    var hostname = nodes[i].get('hostname');
    var ip = getManagementIP(nodes[i]);
    if(ip[0] == 0) continue;
   
    text += hostname + spaces[Math.max(1, 16 - hostname.length)];
//     text += ip[1] + spaces[Math.max(1, 16 - ip[1].length)];
    text += moveIP(ip[1], ip[0].get('baseAddress'), ip[0].get('netmaskBits'), base, netmask) + "\n";    
  }
  if(text.length <= 2) return false;
  
  message.height = '96px';
  message.value = "It is recommended that all local devices are assigned IP address in the NetMap network. The table below contains a list of all local devices with their proposed NetMap IP. The values in the NetMap column may be modified at this stage if desired. Removing a device from the list below, will cause it not to be assigned an IP address in the NetMap range.";
  document.getElementById('data').value = text;
  
  return true;
}

function enableNext() {
  var next = document.getElementById('next');
  next.removeAttribute('disabled');
  timer = 0;
}

function setNetmapip() {
  var data = document.getElementById('data').value.split("\n");
  for(var i = 2; i < data.length; i++) {
    var l = data[i].split(/\s+/);
    if((l.length == 0) || ((l.length == 1) && (l[0].length == 0))) continue;
    if(l.length != 2) {
      dock.displayError("Each line should contain: hostname  management-ip  netmap-ip\nThis is not the case for line " + i + "\n" + l);
      printall(l);
      return false;
    }
    var node = cluster.find('Device', l[0]);
    if(!node) {
      dock.displayError(l[0] + ' was not found');
      return false;
    }
    if(!regexMatch(l[1], dock.REGEX_IPv4)) {
      dock.displayError(l[1] + ' is not a valid ip');
      return false;
    }    
  }
  waitIcon();
  var deviceMap = cluster.resolveTypeMap('Device');
  for(var i = 2; i < data.length; i++) {
    var l = data[i].split(/\s+/);
    if((l.length == 0) || ((l.length == 1) && (l[0].length == 0))) continue;
    if(!deviceMap.hasOwnProperty(l[0])) continue;
    var node = deviceMap[l[0]];
    var interfaces = node.get('networks');
    for(var j = 0; j < interfaces.length; j++) {
      if(interfaces[j].name == 'map0') {
        interfaces = 0;
        break;
      }
    }
    if(interfaces) {
      var intf = createNetMapInterface('map0', l[1], netmap);
      interfaces.push(intf.object);
      node.set('networks', interfaces);
      node.commit();
    }
  }
  return true;
}

function finalize() {
  unwaitIcon();
  message.setAttribute('hidden', true);
  var text = "Successfully added cloud provider " + provider.resolveName() + ".\n\n";
  text += "Next steps:\n";
  text += "- Power on cloud directors in all regions and wait for these to come up.\n";
  text += "- Create cloud nodes by using the Create Cloud Nodes wizard.\n";
  text += "- Power on cloud nodes.\n";
  document.getElementById('finalize').value = text;
}

function finish() {  
  close();
  cluster.updateRack = true;
  myDialog.onOk();
}

function cancel() {
  if(!!provider && (provider.get('uniqueKey') < dock.MAX_LOCAL_KEY)) {
    provider.remove();
  }
  cluster.updateRack = true;
  close();
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("wait");
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("auto");
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}

function passwordToggle() {
  var obj = document.getElementById('accountKey');
  if(obj.getAttribute('type') == 'password') {
    obj.removeAttribute('type');
  } else {
    obj.setAttribute('type', 'password');
  }
  var obj = document.getElementById('secretKey');
  if(obj.getAttribute('type') == 'password') {
    obj.removeAttribute('type');
  } else {
    obj.setAttribute('type', 'password');
  }  
}

function getRegionAttributes(providerKey, regionKey) {
  waitIcon();
  dock.workerpool.getWorker(cluster.actualurl).call('cmcloud', 'getRegionAttributes', [providerKey, regionKey], function(code, data) {
    if(code == 0) {
      regionAttributesCallback(regionKey, data);
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, cluster);
}

function regionAttributesCallback(region, data) {
  unwaitIcon();
  var objTh = document.getElementById('throbber' + region);
  if (objTh) {
    objTh.setAttribute('src', '');
  }

  var objLab = document.getElementById('label-vpc' + region);
  if (objLab) {
    objLab.setAttribute('disabled', false);
    if (data.defaultVPC) {
      objLab.setAttribute('value', 'yes');
    } else {
      objLab.setAttribute('value', 'no');
    }

    regionsAttributes[region] = data;

    if (waitCount == 0) {
      enableNext();
    }
  }
}
