/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var current;
var myDialog;
var dock;
var categories;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  newEdit = true;
  current = new dock.cvMetric();
  current = new dock.cvObject(myDialog.arguments.cluster, current, 0, 0, false);
  current.set('metricClass', 'PROTOTYPE');
  current.set('paramPermission', 'PARAM_DISALLOWED');

  refresh();
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('command', '^');
  text('descr', '^');

  var row = document.getElementById('categories');
  categories = current.cluster.find('Category');
  for(var i = 0; i < categories.length; i++) {
    var check = document.createElement('checkimage');
    check.setAttribute('id', 'isForCategory' + categories[i].resolveName());
    check.setAttribute('label', categories[i].resolveName());
    row.appendChild(check);
  }
}

function ok() {
  if(!window.closed) {
    if(current.get('isCustom')) {
      if(blank(current.get('name'))) {
        dock.displayError("Name cannot be empty");
        return;
      }
      if(blank(current.get('command'))) {
        dock.displayError("Command cannot be empty");
        return;
      }

      if(newEdit) {
        myDialog.arguments.cluster.addObject(current);
      }

      var list = new Object();
      list[dock.ALL_MASTERNODES] = 'isForMaster';
      list[dock.ALL_ETHERNETSWITCHES] = 'isForEthernet';
      list[dock.ALL_MYRINETSWITCHES] = 'isForMyrinet';
      list[dock.ALL_IBSWITCHES] = 'isForIb';
      list[dock.ALL_POWERDISTRIBUTIONUNITS] = 'isForPdu';
      list[dock.ALL_RACKSENSORS] = 'isForRackSensor';
      list[dock.ALL_GENERICS] = 'isForGeneric';
      list[dock.ALL_CHASSIS] = 'isForChassis';
      list[dock.ALL_GPUUNITS] = 'isForGpuUnit';

      var toSave = new Array();
      var toSaveObjects = new Array();
      for(var key in list) {
        var check = document.getElementById(list[key]);
        var value = check.getAttribute('checked');
        if(eval(value)) {
          var monconf = current.cluster.find(key);
          toSaveObjects.push(monconf);
          toSave.push(current.cluster.getMonConfName(key));
          var metrics = monconf.get('metrics');
          var add = new dock.cvMonMetricConf();
          add = new dock.cvObject(monconf.cluster, add);
          add.set('metric', current.get('uniqueKey'));
          metrics.push(add.object);
          monconf.set('metrics', metrics);
        }
      }
      
      for(var i = 0; i < categories.length; i++) {
        var name = categories[i].resolveName();
        var check = document.getElementById('isForCategory' + name);
        var value = check.getAttribute('checked');
        if(eval(value)) {
          var monconf = current.cluster.find(categories[i].get('monConfId'));
          toSaveObjects.push(monconf);
          toSave.push(name);
          var metrics = monconf.get('metrics');
          var add = new dock.cvMonMetricConf();
          add = new dock.cvObject(monconf.cluster, add);
          add.set('metric', current.get('uniqueKey'));
          metrics.push(add.object);
          monconf.set('metrics', metrics);
        }
      }
      var commitMonConf = function() {
        for(var i = 0; i < toSaveObjects.length; i++) {          
          toSaveObjects[i].commit();
        }
      }
      var args = new Object();
      args['question'] = 'Make sure you save the metric: ' + current.resolveName() + '.\nAnd the monitoring setups for: ' + toSave.join(', ') + '.\n\nPress save to save them now.\nNote that all other monitoring configurations will also be saved.'
      args['yeslabel'] = 'Save'
      args['yesaccesskey'] = 'S'
      args['nolabel'] = 'Ok'
      args['noaccesskey'] = 'O'
      var d = new dock.cvDialog("question.xul", args);
      d.onOk = function() {
        current.commit(false, commitMonConf);
      }
      dock.dialogs.showDialog(d);
    }
    myDialog.onOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    close();
  }
}
