#!/usr/bin/perl

use File::Copy;

foreach my $file (@ARGV) {
  print "+++++ $file +++++\n";
  &addId($file);
}

sub addId() {
  my $file = shift;
  open(DAT, $file) || die("Could not open file!");
  my @lines=<DAT>;
  close(DAT);
  
  my @ids;
  my @out;
  my $hasoverlay = 0;
  my $update = 0;
  foreach my $line(@lines) {
    if($line =~ m/^\s+<shadowtab.+id="(\w+)"/) {
      push(@ids, $1);
    } elsif($line =~ m/^\s*<iframe.*\s+id="(\w+)"/) {
      my $top = shift(@ids)."_iframe";
      if($top ne $1) {
        $line =~ s/id="\w+"/id="$top"/;
        $update = 1;
      }
    } elsif($line =~ m/^\s*<iframe/) {
      my $top = shift(@ids)."_iframe";
      $line =~ s/<iframe/<iframe id="$top"/;
      $update = 1;      
    } elsif($line =~ m/^\s*<\?xul-overlay.*$file/) {
      $hasoverlay = 1;
    } elsif($line =~ m/^\s*<page/) {
      if($hasoverlay == 0) {
        push @out, "<?xul-overlay href=\"chrome://cmgui/content/overlay/blank/$file\"?>\n";
        push @out, "\n";
        $hasoverlay = 1;
        $update = 1;
      }
    }
    push @out, $line;
  }
  if($update > 0) {
    print "Updating file\n";
    open(DAT, ">$file") || die("Could not open file!");
    foreach my $line(@out) {
      print DAT $line;
    }
    close(DAT);
  }
  my $blank = "overlay/blank/$file";
  if(not -e $blank) {
    print "Add blank overlay $blank\n";
    copy("overlay/blank/blank.template.xul", $blank);
    `svn add $blank`;
  }
}
