/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var myDialog;
var dock;
var cluster;
var subobject;
var parent;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  object = myDialog.arguments.object;
  current = myDialog.arguments.networkingbackend;
  subobject = myDialog.arguments.subobject;
  parent = myDialog.arguments.parent;

  old = subobject.old(false, true);
  current = new dock.cvObject(cluster, current);
  refresh();
}

function refresh() {
  text('name');
  kenum({
    what: 'childType',
    list: [['FlannelNetworkingUdpBackend', 'UDP'], ['FlannelNetworkingVxLanBackend', 'VxLan']],
    elementNodeId: 'childType',
    onCommandFunction: changeType
  });
  if (current.get('childType') == 'FlannelNetworkingUdpBackend') {
    document.getElementById('vniEditor').setAttribute('hidden', true);
  } else {
    document.getElementById('vniEditor').setAttribute('hidden', false);
    text('vni', '^[0-9]+$');
  }
  text('port', '^[0-9]+$');
}

function changeType() {
  var new_networkingbackend;
  if (current.get('childType') == 'FlannelNetworkingUdpBackend') {
    new_networkingbackend = new dock.cvFlannelNetworkingUdpBackend();
  } else {
    new_networkingbackend = new dock.cvFlannelNetworkingVxLanBackend();
    new_networkingbackend.vni = '';
  }
  new_networkingbackend.name = '';
  new_networkingbackend.port = '';

  var networkingbackends = subobject.get('networkingbackends');
  networkingbackends.splice(0, networkingbackends.length, new_networkingbackend);
  subobject.set("networkingbackends", networkingbackends);
  subobject.set('modified', true);

  current = new dock.cvObject(cluster, new_networkingbackend);
  refresh();
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(blank(current.get('port') + '')) {
      dock.displayError("Port cannot be empty");
      return;
    }
    if ((current.get('childType') == 'FlannelNetworkingVxLanBackend')
        && blank(current.get('vni') + '')) {
      dock.displayError("VNI cannot be empty");
      return;
    }
    subobject.set('modified', true);
    dock.currentTab.contentWindow.refresh();
    parent.refresh();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    subobject.old(old);
    close();
  }
}

