/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var openstack;
var object;
var old;
var current;
var myDialog;
var dock;
var cluster;
var subobject;
var parent;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  object = myDialog.arguments.object;
  current = myDialog.arguments.placeholder;
  subobject = myDialog.arguments.subobject;
  parent = myDialog.arguments.parent;

  old = subobject.old(false, true);
  current = new dock.cvObject(cluster, current);
  refresh();
}

function refresh() {
  text('queue');
  text('baseNodeName');
  text('maxNodes', '^(<auto>|[0-9]{1,10})$');
  resolve('templateNode', 'SlaveNode');
  setfocus('queue');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('queue'))) {
      dock.displayError("Queue name cannot be empty");
      return;
    }
    if(blank(current.get('baseNodeName'))) {
      dock.displayError("Base node name cannot be empty");
      return;
    }
    object.set('modified', true);
    dock.currentTab.contentWindow.refresh();
    parent.refresh();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    subobject.old(old);
    close();
  }
}

