/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  old = current.old(false, true);
  refresh(true);
}

function refresh(onload) {
  text('prefix');
  check('externalServer');
  text('var');
  refreshCgroups(onload);
}

function refreshCgroups(onload) {
  var cgroups = current.get('cgroups');
  check('cgroups', false, 'enabled');
  check('cgroups', false, 'autoMount');
  check('cgroups', false, 'linuxCgroupAccounting');
  check('cgroups', false, 'processTracking');
  text('cgroups', '^', 'mountPoint');

  var enabled = 'true';
  if(onload) {
    enabled=cgroups.enabled;
  } else {
    var obj = document.getElementById('cgroupsenabled');
    enabled = !obj.checked;
  }
  for(var i=1; i<=5; i++) {
    document.getElementById('cg_hbox' + i).setAttribute('hidden', !eval(enabled));
  }

  refreshCgroupsResourceEnforce(cgroups);
}

function refreshCgroupsResourceEnforce(cgroups) {
  var ress = cgroups.resourceEnforce;
  var rows = document.getElementById('cgroupsresourceEnforce');
  if(rows) {
    while(rows.firstChild) rows.removeChild(rows.firstChild);
    var last = ress.length - 1;
    while(last >= 0) {
      if(!ress[last].toBeRemoved) break;
      last--;
    }
    for(var i = 0; i < ress.length; i++) {
      if(ress[i].toBeRemoved) continue;
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', 'cgroups_ress_' + i + '_name');
      textbox.setAttribute('type', 'text');
      textbox.setAttribute('width', '165px');
      textbox.setAttribute('value', ress[i]);
      row.appendChild(textbox);

      var button = document.createElement('button');
      button.setAttribute('class', 'minus-button');
      button.setAttribute('oncommand', 'removeResource(' + i + ');');
      row.appendChild(button);

      if(i == last) {
        var button = document.createElement('button');
        button.setAttribute('class', 'plus-button');
        button.setAttribute('oncommand', 'addResource();');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      rows.appendChild(row);
    }
    if(last < 0) {
      var row = document.createElement('row');
      var button = document.createElement('button');
      button.setAttribute('class', 'plus-button');
      button.setAttribute('oncommand', 'addResource();');
      row.appendChild(button);
      rows.appendChild(row);
    }
  } else {
    println('No rows for ' + ress.childType);
  }
}

function addResource() {
  updateResourceEnforceFromRows();
  var cgroups = current.get('cgroups');
  cgroups.resourceEnforce.push("");
  cgroups.modified = true;
  current.set('cgroups', cgroups);
  current.set('modified', true);
  refreshCgroupsResourceEnforce(cgroups);
}

function removeResource(i) {
  updateResourceEnforceFromRows();
  var cgroups = current.get('cgroups');
  var ress = cgroups.resourceEnforce;
  if((i >= 0)) {
    ress.splice(i, 1);
    current.set("cgroups", cgroups);
  }
  current.set('modified', true);
  refreshCgroups(true);
}

function updateResourceEnforceFromRows() {
  var ress = document.getElementById('cgroupsresourceEnforce');
  if(ress) {
    var ress2 = [];
    for(var i = 0; i < ress.children.length; i++) {
      var row = ress.children[i];
      for(var c=0; c<row.children.length; c++) {
        var el = row.children[c];
        if(el.tagName == "textbox") {
          ress2.push(el.value);
        }
      }
    }
    var cgroups = current.get('cgroups');
    if(cgroups.resourceEnforce != ress2) {
      cgroups.resourceEnforce = ress2;
      cgroups.modified = true
      current.set("cgroups", cgroups);
    }
  }
}

function ok() {
  if(current.get('modified')) object.set('modified', true);
  updateResourceEnforceFromRows();
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}

