/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  old = current.old(false, true);
  refresh(true);
}

function refresh(onload) {
  text('prefix');
  check('externalServer');
  text('cell');
  refreshCgroups(onload);
}

function refreshCgroups(onload) {
  var cgroups = current.get('cgroups');
  check('cgroups', false, 'enabled');
  check('cgroups', false, 'autoMount');
  check('cgroups', false, 'cpuset');
  check('cgroups', false, 'freezer');
  check('cgroups', false, 'freezePeTasks');
  check('cgroups', false, 'keeling');
  check('cgroups', false, 'forcedNuma');
  check('cgroups', false, 'vmemLimit');
  check('cgroups', false, 'memFreeHard');
  check('cgroups', false, 'memFreeSoft');

  text('cgroups', '^', 'minMemoryLimit');
  text('cgroups', '^', 'mountPoint');

  var enabled = 'true';
  if(onload) {
    enabled=!cgroups.enabled;
  } else {
    var obj = document.getElementById('cgroupsenabled');
    enabled = obj.checked;
  }
  for(var i=0; i<=10; i++) {
    document.getElementById('cg_hbox' + i).setAttribute('hidden', eval(enabled));
  }
}

function ok() {
  if(current.get('modified')) object.set('modified', true);
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}







