/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var cluster;
var provider;
var current;
var myDialog;
var dock;
var domain = 'vpc';

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  document.getElementById('message').value = "Please select a region inside which the static IP is to be allocated.";
  document.getElementById('message2').value = "\nOnce allocated, it will be possible to associate the static IP with new cloud instances located within private clouds inside the selected region.";

  if (myDialog.arguments.cloudProvider) {
    provider = myDialog.arguments.cloudProvider.object;
    cluster = myDialog.arguments.cloudProvider.cluster;
    current = new dock.cvCloudStaticIP();
    current = new dock.cvObject(cluster, current);
  }

  var regions = cluster.find('EC2Region');
  for (var i = 0; i < regions.length; i++) {
    regions[i] = [regions[i].get('uniqueKey'), regions[i].resolveName()];
  }

  kenum('cloudRegion', regions);

  // select default region
  var regionDrop = document.getElementById('cloudRegion');
  for (var i = 0; i < regionDrop.itemCount; i++) {
    if (regionDrop.getItemAtIndex(i).getAttribute('key') == provider.defaultRegion) {
      regionDrop.selectedIndex = i;
      break;
    }
  }

}

function ok() {
  var regionKey = parseInt(document.getElementById('cloudRegion').selectedItem.getAttribute('key'));
  dock.workerpool.getWorker(cluster.actualurl).call('cmcloud', 'allocateStaticIP', [provider.uniqueKey, regionKey, domain], function(code, data) {
    if(code == 0) {
      allocateCallback(data);
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, cluster);
}

function cancel() {
  if(!window.closed) {
    close();
  }
}

function allocateCallback(data) {
  if(!window.closed) {
    close();
  }
  if (data.success) {
    dock.currentTab.contentWindow.refresh();
  } else {
    dock.displayError('Error while allocating the selected ' + singular);
  }
}
