/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh request" + ' - ' + document.documentURI);
  
  dock.workerpool.getWorker(current.actualurl).call('cmcert', 'getAutoSign', null, function(code, data) {
    if(code == 0) {
      document.getElementById('autosign').setAttribute('checked', data);
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, current);

  dock.workerpool.getWorker(current.actualurl).call('cmcert', 'getCertificateRequests', null, function(code, data) {
    if(code == 0) {
      setCallbackResult(data);
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, current);
}

function setCallbackResult(value) {
  var list = value;
  tree = document.getElementById('tree');

  data = new Array();
  for(var i = 0; i < list.length; i++) {
    data.push(createTreeItem(list[i]));
  }
  for(var i = list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.requestId;
  item['requestId'] = one.requestId;
  item['name'] = one.commonName;
  item['country'] = one.country;
  item['organization'] = one.organization;
  switch(one.clientType) {
  case(2) : item['type'] = 'cmsh'; break;
  case(3) : item['type'] = 'Node'; break;
  case(4) : item['type'] = 'cmgui'; break;
  case(5) : item['type'] = 'Installer'; break;
  default : item['type'] = 'Custom';
  }
  return item;
}

function showRequest() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a request");
  } else if(select.length > 1) {
    dock.displayError("Please select only one request");
  } else {
    dock.workerpool.getWorker(current.actualurl).call('cmcert', 'getCertificateRequest', parseInt(select[0]), function(code, data) {
      if(code == 0) {
        var args = new Object();
        args['cluster'] = current;
        args['request'] = data
        if(args['request']) {
          var d = new dock.cvDialog("issuecertificate.xul", args);
          d.onOk = function() {
            refresh();
          }
          dock.dialogs.showDialog(d);
        } else {
          dock.displayError("Request no longer found");
          refresh();
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
}

function issueRequest() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a request");
  } else if(select.length > 1) {
    dock.displayError("Please select only one request");
  } else {
    dock.workerpool.getWorker(current.actualurl).call('cmcert', 'getCertificateRequest', parseInt(select[0]), function(code, data) {
      if(code == 0) {
        var args = new Object();
        args['cluster'] = current;
        args['request'] = data
        if(args['request']) {
          var d = new dock.cvDialog("issuecertificate.xul", args);
          d.onOk = function() {
            refresh();
          }
          dock.dialogs.showDialog(d);
        } else {
          dock.displayError("Request no longer found");
          refresh();
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
}

function denyRequest() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a request");
  } else {
    var args = new Object();
    args['title'] = 'Deny Certificate Request';
    args['question'] = 'Reason';
    args['default'] = 'access denied';
    args['known'] = new Array();
    var d = new dock.cvDialog("newobject.xul", args);
    d.onOk = function(reason) {
      for(var i = 0; i < select.length; i++) {
        dock.workerpool.getWorker(current.actualurl).call('cmcert', 'removeCertificateRequest', [parseint(select[i]), reason], function(code, data) {
          if(code == 0) {
            if(!data) println("Deny certificate failed: " + parseint(select[i]));
          } else {
            dock.jsonCallError(this, code, data);
          }
          refresh();
        }, current);
      }
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function autosign() {
  dock.workerpool.getWorker(current.actualurl).call('cmcert', 'setAutoSign', document.getElementById('autosign').checked, function(code, data) {
    if(code != 0) {
      dock.jsonCallError(this, code, data);
    }
    refresh();
  }, current);
}
