/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var serv;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [current.findNotToBeRemoved("Profile"), 0];
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh profiles" + ' - ' + document.documentURI);
  serv = current.find("CMService");
  var list = current.find("Profile");
  var vbox = document.getElementById('profiles');
  while(vbox.firstChild) vbox.removeChild(vbox.firstChild);
  var hbox;
  for(var i = 0; i < list.length; i++) {
    if((i % 2) == 0) {
      hbox = document.createElement('hbox');
      hbox.setAttribute('equalsize', "always");
      hbox.setAttribute('flex', '1');
      vbox.appendChild(hbox);
    }
    hbox.appendChild(createItem(list[i]));
  }
  if((list.length % 2) == 0) {
    hbox = document.createElement('hbox');
    hbox.setAttribute('equalsize', "always");
    hbox.setAttribute('flex', '1');
    vbox.appendChild(hbox);
  }
  hbox.appendChild(createAddItem());
  if((list.length % 2) == 0) {
    var spacer = document.createElement('spacer');
    spacer.setAttribute('flex', '1');
    hbox.appendChild(spacer);
  }
}

function createAddItem() {
  var hbox = document.createElement('hbox');
  hbox.setAttribute('class', 'staticdata');
  hbox.setAttribute('align', 'center');
  hbox.setAttribute('flex', '1');
  var vbox = document.createElement('vbox');
  vbox.setAttribute('align', 'center');
  vbox.setAttribute('flex', '1');

  var button = document.createElement('button');
  button.setAttribute('class', 'addcluster-button');
  button.setAttribute('oncommand', 'addProfile()');
  vbox.appendChild(button);
  var label = document.createElement('label');
  label.setAttribute('value', 'Add Profile');
  label.setAttribute('class', 'staticdataheader');
  vbox.appendChild(label);

  hbox.appendChild(vbox);
  return hbox;
}

function createItem(profile) {
  var pname = profile.get('name');
  var mytok = profile.get('tokens');
  var access = profile.get('accessServices');

  var vbox = document.createElement('vbox');
  vbox.setAttribute('class', 'staticdata');
  vbox.setAttribute('flex', '1');
  var hbox = document.createElement('hbox');
  var label = document.createElement('shadowlabel');
//   if((pname == "admin") || (pname == "node")) {
//     label.setAttribute('value', pname + " (read-only)");
//   } else {
    label.setAttribute('value', pname);
//   }
  label.setAttribute('class', 'staticdataheader');
  hbox.appendChild(label);
  var spacer = document.createElement('spacer');
  spacer.setAttribute('flex', 1);
  hbox.appendChild(spacer);
  var button = document.createElement('button');
  button.setAttribute('class', 'close-button');
  button.setAttribute('oncommand', 'deleteProfile("' + pname + '", ' + profile.get('uniqueKey') + ')');
  hbox.appendChild(button);
  var line = document.createElement('hbox');
  line.setAttribute('class', 'staticdottedline');
  vbox.appendChild(hbox);
  var spacer = document.createElement('spacer');
  spacer.setAttribute('height', '3px');
  vbox.appendChild(spacer);
  vbox.appendChild(line);

  var hbox = document.createElement('hbox');
  hbox.setAttribute('flex', '1');
  var vbox1 = document.createElement('vbox');
  var image = document.createElement('image');
  image.setAttribute('src', 'chrome://cmgui/content/icons/User_32.png');
  vbox1.appendChild(image);
  hbox.appendChild(vbox1);
  var tree = document.createElement('tree');
  tree.setAttribute('profile', pname);
  tree.setAttribute('class', 'profiletree');
  tree.setAttribute('flex', '1');
  tree.setAttribute('seltype', "single");
  tree.setAttribute('hidecolumnpicker', "true");
  var cols = document.createElement('treecols');
  cols.setAttribute('class', 'profiletreecols');
  var col = document.createElement('treecol');
  col.setAttribute('class', 'profiletreecol');
  col.setAttribute('primary', true);
  col.setAttribute('flex', '1');
  cols.appendChild(col);
  tree.appendChild(cols);

  var child = document.createElement('treechildren');
  child.setAttribute('id', pname + 'list');
  child.setAttribute('onclick', "changeToken(event);");
  child.setAttribute('class', 'profilelist');
  for(var i = 0; i < serv.length; i++) {
    var name = serv[i].get('name');
    if(name == 'openstack') {
      name = 'CMOpenStack';
    } else {
      name = 'CM' + firstUpper(name);      
    }
    var item = document.createElement('treeitem');
    item.setAttribute('container', "true");
    var row = document.createElement('treerow');
    var cell = document.createElement('treecell');
    cell.setAttribute('label', name);
    row.appendChild(cell);
    item.appendChild(row);
    var cc = document.createElement('treechildren')
    var ite = document.createElement('treeitem');
    ite.setAttribute('key', name);
    var row = document.createElement('treerow');
    var cell = document.createElement('treecell');
    var icon = 'chrome://cmgui/content/icons/check2.png';
    if((access.find(name) < 0) && (pname != "admin")) {
      cell.setAttribute('src', 'chrome://cmgui/content/icons/check0.png');
    } else {
      icon = 'chrome://cmgui/content/icons/check1.png';
      cell.setAttribute('src', 'chrome://cmgui/content/icons/check1.png');
    }
    cell.setAttribute('label', ' Access');
    cell.setAttribute('id', pname + '_' + name);
    row.appendChild(cell);
    ite.appendChild(row);

    cc.appendChild(ite);

    var tokens = serv[i].get('tokens');
    item.setAttribute('open', tokens.length > 0);
    for(var j = 0; j < tokens.length; j++) {
      var ite = document.createElement('treeitem');
      ite.setAttribute('key', name + ':' + tokens[j]);
      var row = document.createElement('treerow');
      var cell = document.createElement('treecell');
      if((mytok.find(tokens[j]) < 0) && (pname != "admin")) {
        cell.setAttribute('src', 'chrome://cmgui/content/icons/check0.png');
      } else {
        cell.setAttribute('src', icon);
      }
      cell.setAttribute('label', ' ' + tokens[j]);
      cell.setAttribute('id', pname + '_' + tokens[j]);
      row.appendChild(cell);
      ite.appendChild(row);
      cc.appendChild(ite);
    }
    item.appendChild(cc);
    child.appendChild(item);
  }
  tree.appendChild(child);
  hbox.appendChild(tree);

  vbox.appendChild(hbox);
  return vbox;
}

function changeToken(event) {
  var name = event.target.getAttribute('id');
  var ro = ((name == "adminlist") || (name == "nodelist"));
  var select = selectedNormal(name);
  if(select.length == 1) {
    var profile = current.find("Profile", name.substr(0, name.length - 4));
    var tokens = profile.get('tokens');
    var access = profile.get('accessServices');
    select = select[0].split(':');
    if(select.length == 1) {
      var index = access.find(select[0]);
      var item = document.getElementById(profile.get('name') + '_' + select[0]);
      if(ro) {
        dock.displayInfo("This profile cannot be changed");
      } else {
        if(index < 0) {
          access.push(select[0]);
          item.setAttribute('src', 'chrome://cmgui/content/icons/check1.png');
        } else {
          access.splice(index, 1);
          item.setAttribute('src', 'chrome://cmgui/content/icons/check0.png');
        }
        profile.set('modified', true, 0, false);
        profile.set('accessServices', access, 0, false);
        item = item.parentNode.parentNode;
        while(item.nextSibling) {
          item = item.nextSibling;
          var image = item.firstChild.firstChild.getAttribute('src');
          var n;
          if(index < 0) {
            n = image.replace('2', '1');
          } else {
            n = image.replace('1', '2');
          }
          if(n != image) item.firstChild.firstChild.setAttribute('src', n);
        }
      }
    } else {
      if(ro) {
        dock.displayInfo("This profile cannot be changed");
      } else {
        var index = access.find(select[0]);
        if(index < 0) {
          dock.displayInfo('Access to this service was disabled');
        } else {
          index = tokens.find(select[1]);
          var item = document.getElementById(profile.get('name') + '_' + select[1]);
          if(index < 0) {
            tokens.push(select[1]);
            item.setAttribute('src', 'chrome://cmgui/content/icons/check1.png');
          } else {
            tokens.splice(index, 1);
            item.setAttribute('src', 'chrome://cmgui/content/icons/check0.png');
          }
          profile.set('modified', true, 0, false);
          profile.set('tokens', tokens, 0, false);
        }
      }
    }
  }  
}


function deleteProfile(name, key) {
  if((name == "admin") || (name == "node")) {
    dock.displayInfo("This profile cannot be deleted");
  } else {
    var args = new Object();
    args['question'] = "Are you sure you want to remove this profile?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      current.removeObject(key);
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function addProfile() {
  var args = new Object();
  args['title'] = 'Add new profile';
  args['question'] = 'Name';
  args['known'] = current.known('Profile', 'name');
  args['default'] = '';
  var d = new dock.cvDialog("newobject.xul", args);
  d.onOk = function(name) {
    var object = new dock.cvProfile();
    object.name = name;
    current.addObject(object);
    refresh();
  }
  dock.dialogs.showDialog(d);
}
