/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var cluster;
var retry
var timer = 0;

function onLoad() {
  dock = getDock();
  println("Auto reconnect initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  cluster = myDialog.arguments.cluster;
  retry = 30;

  document.getElementById('close').focus();
  updateMessage();
}

function onUnLoad() {
  cluster.reconnecting = false;
}

function force() {
  if(timer) window.clearTimeout(timer);
  timer = 0;
  retry = 1;
  updateMessage()
}

function updateMessage() {
  retry -= 1;
  if(retry < 0) {
    if(cluster.connected) {
      close();
    } else if(!cluster.connecting) {
      retry = 30;
    }
  } else if(retry == 0) {
    document.getElementById('message').value = "Reconnecting to " + cluster.name;
    cluster.connect();
  } else {
    document.getElementById('message').value = "Connection to " + cluster.name + " was lost.\nReconnecting in " + retry + " seconds ...";
  }
  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('updateMessage();', 1000);
}
