/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var cluster;
var workFile = 0;

function onLoad() {
  dock = getDock();
  println("Burnlog initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  document.getElementById('ok').focus();

  cluster = myDialog.arguments.cluster;
  var select = myDialog.arguments.select;
  var index = 0;
  var nodes = myDialog.arguments.nodes;

  if(!nodes || !isArray(nodes)) {
    nodes = [select];
  } else if(select && nodes.find(select) < 0) {
    nodes.push(select);
  }
  
  if(nodes.length > 0) {
    var node = document.getElementById("node");
    var popup = node.firstChild;
    while(popup.firstChild) popup.removeChild(popup.firstChild);
    nodes = sortByName(nodes, cluster);
    for(var i = 0; i < nodes.length; i++) {
      var key = nodes[i].get('uniqueKey');
      var item = document.createElement("menuitem");
      item.setAttribute("class", "menuitem-iconic");
      item.setAttribute("image", "chrome://cmgui/content/icons/Node_16.png");
      item.setAttribute("key", key);
      item.setAttribute("label", nodes[i].resolveName());
      if(key == select) index = i;
      popup.appendChild(item);
    }
    
    popup.childNodes[index].doCommand();
  } else {
    dock.displayError("No nodes in burnlog");
    close();
  }
}

function onClose() {
  if(workFile) {
    workFile.remove(false);
  }
}

// var MAX_BYTES = 65536;

function refresh() {
  var node = document.getElementById("node");
  var item = node.selectedItem;
  var name = item.getAttribute("label");
  node = parseInt(item.getAttribute("key"));

  if(workFile) {
    workFile.remove(false);
  }

  setDialogTitle("Burn log for node " + name);
  dock.workerpool.getWorker(cluster.actualurl).call('cmdevice', 'burnLog', [node, false], function(code, data) {
      if(code == 0) {
        var file = dock.cacheFile('burnlog.out');
        var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        outputStream.init(file, 0x02 | 0x08 | 0x20, oct0600, 0);
        outputStream.write(data, data.length);
        outputStream.close();
        document.getElementById('message').loadURI('file://' + file.path, null, dock.ENCODING);
        workFile = file;
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, cluster);
}
