/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'Category';
var singular = 'category';
var plural = 'categories';

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.get('uniqueKey');
  item['modified'] = one.get('modified');
  item['name'] = one.get('name');
  if(one.get('childType') == 'NodeCategory') {
    item['defaultImage'] = current.resolveName(one.getSoftwareImage());
    var proxy = one.get('softwareImageProxy');
    if(proxy && (proxy.revisionID == 0)) item['defaultImage'] += ' [latest]';
    item['defaultGateway'] = one.get('defaultGateway');
  }
  return item;
}

// function addObject() {
//   var args = new Object();
//   args['title'] = 'Add new ' + singular;
//   args['question'] = 'Name';
//   args['known'] = current.known(basetype, 'name');
//   args['default'] = '';
//   var d = new dock.cvDialog("newobject.xul", args);
//   d.onOk = function(name) {
//     var object = new dock.cvCategory();
//     object.name = name;
//     current.addObject(object, dock.openAfterCreate);
//     refresh();
//   }
//   dock.dialogs.showDialog(d);
// }

function addObject() {
  var base = current.getBasePartition();
  var original = current.find(base.get('defaultCategory'));
  if(isObject(original)) {
    var args = new Object();
    args['title'] = 'Add new ' + singular;
    args['question'] = 'Name';
    args['known'] = current.known(basetype, 'name');
    args['default'] = '';
    args['children'] = ['Node Category', 'MIC Category'];
    var d = new dock.cvDialog("newchildobject.xul", args);
    d.onOk = function(name, type) {
        if(type == 'Node Category') {
          var object = original.clone();
          object.modified = true;
          object.toBeRemoved = false;
          object.name = name;
          current.addObject(object, dock.openAfterCreate);
        } else {
          var object = createDefaultMICNodeCategory(name, current);
        }
        refresh();
      }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError("Default category not set in base partition");
  }
}

function cloneObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a " + singular + "for cloning");
  } else if(select.length > 1) {
    dock.displayError("Please select only one " + singular);
  } else {
    var original = current.find(select[0]);
    if(isObject(original)) {
      var args = new Object();
      var name = original.get('name');
      args['title'] = 'Clone ' + name;
      args['question'] = 'Name';
      var nn = nameNumber(name);
      if(nn[1].length == 0) nn[1] = '0';
      var index = myParseInt(nn[1]);
      while(true) {
        index++;
        name = nn[0] + sprintf('%0' + nn[1].length + 'd', index);
        if(!current.find(basetype, name)) break;
      }
      args['default'] = name;
      args['known'] = current.known(basetype, 'name');
      var d = new dock.cvDialog("newobject.xul", args);
      d.onOk = function(name) {
        var object = original.clone();
        object.modified = true;
        object.toBeRemoved = false;
        object.name = name;
        current.addObject(object, dock.openAfterCreate);
        refresh();
      }
      dock.dialogs.showDialog(d);
    } else {
      dock.displayError("Original not found, already removed by someone else");
    }
  }
}
