/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'FSExport';
var subfield = 'fsexports';
var singular = 'fs export';
var plural = 'fs exports';
var editfile = 'editfsexport.xul';

function createTreeItem(one, i) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['order'] = i;
  item['name'] = one.name;
  item['path'] = one.path;
  if(startswith(one.hosts, '!') && endswith(one.hosts, '!') && one.hosts.length > 2) {
    var network = current.cluster.find(one.hosts.substr(1, one.hosts.length - 2));
    if(isObject(network)) {
      item['hosts'] = network.resolveName() + " (" + network.get('baseAddress') + '/' + network.get('netmaskBits') + ")";
    } else {
      item['hosts'] = one.hosts;
    }
  } else {
    item['hosts'] = one.hosts;
  }
  item['write'] = one.allowWrite;
  item['async'] = one.async;
  item['rdma'] = one.rdma;
  item['rootSquash'] = one.rootSquash;
  item['allSquash'] = one.allSquash;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  return item;
}

