/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'StaticRoute';
var subfield = 'staticRoutes';
var singular = 'static route';
var plural = 'static routes';
var editfile = 'editstaticroute.xul';

function refresh(use) {
  if (!!use) current = use;
  println("Refresh static routes" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  tree = document.getElementById('tree');
  data = new Array();
  var routes = current.get(subfield);
  for (var i = 0; i < routes.length; i++) {
    if (!routes[i].toBeRemoved || alsoRemoved) {
      data.push(createTreeItem(routes[i], true, i));
    }
  }
  for (var i = routes.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one, free, i) {
  free = isundefined(free, true);
  var item = new Object();
  if (free) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = 0;
  }
  item['name'] = one.name;
  item['gateway'] = one.gateway;
  if (one.network) {
    var network = current.cluster.find(one.network);
    item['destination'] = '(' + network.get('name') + ') ' + network.get('baseAddress') + '/' + network.get('netmaskBits');
  } else {
    item['destination'] = one.ip + '/' + one.netmaskBits;
  }
  item['networkDeviceName'] = one.networkDeviceName;
  item['toBeRemoved'] = one.toBeRemoved;
  return item;
}

