/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var deviceName = 'category';
var deviceNamePlural = 'categories';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh category tasks" + ' - ' + document.documentURI);
    
  var decommissionRow = document.getElementById("decommissionRow");
  if(current.isHadoop() || current.isCeph()) {
    decommissionRow.removeAttribute('hidden');
  } else {
    decommissionRow.setAttribute('hidden', true);
  }
}

function allNodes(needCommit) {
  needCommit = isundefined(needCommit, false);
  var catkey = current.get('uniqueKey');
  var list = new Array();
  var found = current.cluster.find("SlaveNode");
  for(var i = 0; i < found.length; i++) {
    if(catkey == found[i].get('category')) {
      var key = found[i].get('uniqueKey');
      if(key > dock.MAX_LOCAL_KEY) {
        if((!needCommit || !found[i].get('modified')) && !found[i].get('toBeRemoved')) list.push(key);
      }
    }
  }
  return list;
}

function provisioningLog() {
  var args = new Object();
  args['nodes'] = allNodes(false);
  args['cluster'] = current.cluster;
  var d = new dock.cvDialog("synclog.xul", args);
  dock.dialogs.showDialog(d);
}
