/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var globalCurrent;
var current;
var vnictree;
var vnicdata;
var fctree;
var fcdata;

var subfieldvnics = 'vicAdapterSettings';
var subfieldfcs = 'fcAdapterSettings';
var subfieldphysicalnics = 'vicPhysicalInterfaces';
var vniceditfile = 'editucsvnicinterface.xul';
var fceditfile = 'editucsfcinterface.xul';
var singularvnic = 'virtual ethernet interface';
var pluralvnic = 'virtual ethernet interfaces';
var singularfc = 'virtual fibre channel interface';
var pluralfc = 'virtual fibre channel interfaces';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    globalCurrent = use;
  }
  println("Refresh UCS VIC settings" + ' - ' + document.documentURI);
  
  document.getElementById('revert').setAttribute('disabled', globalCurrent.get('uniqueKey') < dock.MAX_LOCAL_KEY);
  document.getElementById('save').setAttribute('disabled', !globalCurrent.get('modified'));
  
  current = globalCurrent.getUCS();
  if(current) {
    current = new dock.cvObject(globalCurrent.cluster, current);
    
    // Virtual Ethernet Interfaces
    vnictree = document.getElementById('vnictree');
    vnicdata = new Array();
    var vnics = current.get(subfieldvnics);
    for(var i = 0; i < vnics.length; i++) {
      if(!vnics[i].toBeRemoved || alsoRemoved) {
        vnicdata.push(createTreeItemVnic(vnics[i], i));
      }
    }
    for(var i = vnics.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
    var select = selected('vniclist');
    loadTable(vnictree, vnicdata);
    setSelected('vniclist', select);

    // Virtual Fibre Channel Interfaces
    fctree = document.getElementById('fctree');
    fcdata = new Array();
    var fcs = current.get(subfieldfcs);
    for(var i = 0; i < fcs.length; i++) {
      if(!fcs[i].toBeRemoved || alsoRemoved) {
        fcdata.push(createTreeItemFc(fcs[i], i));
      }
    }
    for(var i = fcs.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
    var select = selected('fclist');
    loadTable(fctree, fcdata);
    setSelected('fclist', select);

    // Physical Ethernet Interfaces
    var list = document.getElementById('vicphysicalinterfaces');
    while(list.childNodes.length > 2) list.removeChild(list.lastChild);
    var physicalinterfaces = current.get(subfieldphysicalnics);
    for(var i = 0; i < physicalinterfaces.length; i++) {
      list.appendChild(nodeInterfaceRow(physicalinterfaces[i]));      
    }
  }
}

function editVnicSubObject() {
  var select = selected('vniclist');
  if(select.length == 0) {
    dock.displayError('No ' + singularvnic + ' selected');
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = current;
    args['subobject'] = select[0];
    args['detached'] = isundefined(parent.detached, false);
    var d = new dock.cvDialog(vniceditfile, args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError('Please select only one ' + singularvnic);
  }
}

function editFcSubObject() {
  var select = selected('fclist');
  if(select.length == 0) {
    dock.displayError('No ' + singularfc + ' selected');
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = current;
    args['subobject'] = select[0];
    args['detached'] = isundefined(parent.detached, false);
    var d = new dock.cvDialog(fceditfile, args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError('Please select only one ' + singularfc);
  }
}
function createTreeItemVnic(one, i) {
  var item = new Object();
  if(one.uniqueKey) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = -1000 -i;
  }
  item['vnicname'] = one.name;
  item['vnicmacaddress'] = one.mac;
  item['vnicmtu'] = one.mtu;
  item['vnicusnics'] = one.usnicCount;
  item['vnicuplinkport'] = one.uplinkPort;
  item['vniccos'] = one.classOfService; 
  item['vnicvlan'] = 0;
  item['vnicvlanmode'] = 0;
  item['vniciscsiboot'] = one.iscsiBoot;
  item['vnicchannel'] = one.channelNumber;
  item['vnicportprofile'] = one.portProfile; 
  item['vnicuplinkfailover'] = 0;
  item['vnicmodified'] = one.modified;
  item['vnictoBeRemoved'] = one.toBeRemoved;
  return item;
}

function createTreeItemFc(one, i) {
  var item = new Object();
  if(one.uniqueKey) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = -1000 -i;
  }
  item['fcname'] = one.name;
  item['fcwwpn'] = one.wwpn;
  item['fcwwnn'] = one.wwnn;
  item['fcuplink'] = one.uplinkPort;
  item['fcboot'] = one.sanBoot;
  item['fcchannel'] = one.channelNumber;
  item['fcportprofile'] = one.portProfile;
  item['fcmodified'] = one.modified;
  item['fctoBeRemoved'] = one.toBeRemoved;
  return item;
}

function nodeInterfaceRow(iobj) {
  var row = document.createElement('row');
  row.setAttribute("flex", "1");
  row.setAttribute("align", "center");
  row.setAttribute("height", "17px");
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", iobj.portId);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", iobj.mac);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", iobj.linkState);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", iobj.transport);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", iobj.adminSpeed);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", iobj.operSpeed);
  row.appendChild(label);
  return row;
}
