/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function refresh(use) {
  if(!!use) current = use;
  println("Refresh ceph roles" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  var checks = document.getElementsByTagName('checkimage');
  for(var i = 0; i < checks.length; i++) {
    checks[i].checked = false;
    var next = checks[i].nextSibling;
    if(next) next.setAttribute('hidden', true);
  }

  clearLabel('CephMonitor');
  clearLabel('CephOSD');
  clearLabel('RadosGateway');

  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(!roles[i].toBeRemoved && (startswith(roles[i].childType, 'Ceph') || startswith(roles[i].childType, 'Rados'))) {
      if(roles[i].childType == 'CephOSDRole') setCephOSDAssociations(roles[i], false);
      setRole(roles[i], '');
    }
  }

  if(dock.baseChildTypeCheck(current.object, 'SlaveNode')) {
    var cat = current.get('category');
    if(cat) {
      cat = current.cluster.find(cat);
      if(cat) {
        var catroles = cat.get(subfield);
        cat = cat.resolveName();
        for(var i = 0; i < catroles.length; i++) {
          if(!catroles[i].toBeRemoved) {
            var found = false;
            for(var j = 0; !found && (j < roles.length); j++) {
              if(!roles[j].toBeRemoved) {
                found = (catroles[i].childType == roles[j].childType);
              }
            }
            if(!found) {
              if(catroles[i].childType == 'CephOSDRole') setCephOSDAssociations(catroles[i], true);
              setRole(catroles[i], cat);
            }
          }
        }
      }
    }
  }
}

function setCephOSDAssociations(role, category) {
  var rows = document.getElementById('rows' + role.childType);
  if(rows) {
    while(rows.firstChild) rows.removeChild(rows.firstChild);
    var last = role.osdassociations.length - 1;
    while(last >= 0) {
      if(!role.osdassociations[last].toBeRemoved) break;
      last--;
    }
    for(var i = 0; i < role.osdassociations.length; i++) {
      if(role.osdassociations[i].toBeRemoved) continue;
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var textbox = document.createElement('textbox');
      if(category) textbox.setAttribute('disabled', true);
      textbox.setAttribute('id', role.childType + '_osdassociations_' + i + 'name');
      row.appendChild(textbox);
      if(!category) {
        var hbox = document.createElement('vbox');
        hbox.setAttribute('flex', 1);
        var button = document.createElement('button');
        button.setAttribute('class', 'graybutton');
        button.setAttribute('label', 'Advanced');
        button.setAttribute('oncommand', 'editCephOSDAssociations("' + role.childType + '", ' + i + ');');
        hbox.appendChild(button);
        row.appendChild(hbox);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      if(!category) {
        var button = document.createElement('button');
        button.setAttribute('class', 'minus-button');
        button.setAttribute('oncommand', 'removeCephOSDAssociations("' + role.childType + '", ' + i + ');');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      if((i == last) && !category) {
        var button = document.createElement('button');
        button.setAttribute('class', 'plus-button');
        button.setAttribute('oncommand', 'addCephOSDAssociations("' + role.childType + '");');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      rows.appendChild(row);
    }
    if(last < 0) {
      var row = document.createElement('row');
//       var spacer = document.createElement('spacer');
//       row.appendChild(spacer);
//       var spacer = document.createElement('spacer');
//       row.appendChild(spacer);
//       var spacer = document.createElement('spacer');
//       row.appendChild(spacer);
      if(!category) {
        var button = document.createElement('button');
        button.setAttribute('class', 'plus-button');
        button.setAttribute('oncommand', 'addCephOSDAssociations("' + role.childType + '");');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      rows.appendChild(row);
//     } else {
//       if (dock.mainthread.hasPendingEvents()) {
//         println('setCephOSDAssociations has pending events... processing next event');
//         dock.mainthread.processNextEvent(true);
//         println('setCephOSDAssociations has pending events... processing next event... DONE');
//       }
    }
  } else {
    println('No rows for ' + role.childType);
  }
}

function addCephOSDAssociations(type) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == type) {
      var osdassociations = new dock.cvCephOSDAssociation();
      var tmp = new dock.cvObject(current.cluster, osdassociations);
      var m = 0;
      for(var j = 0; j < roles[i].osdassociations.length; j++) {
        var nn = nameNumber(roles[i].osdassociations[j].name);
        if(nn[1].length > 0) m = Math.max(m, myParseInt(nn[1]) + 1);
      }
      osdassociations.name = 'osd' + m;
      roles[i].osdassociations.push(osdassociations);
      roles[i].modified = true;
      current.set('modified', true);
      refresh();
      break;
    }
  }
}

function removeCephOSDAssociations(type, index) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == type) {
      roles[i].osdassociations[index].toBeRemoved = true;
//       roles[i].osdassociations.splice(index, 1);
      roles[i].modified = true;
      current.set('modified', true);
      refresh();
      break;
    }
  }
}

function editCephOSDAssociations(type, index) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == type) {
      var editfile = 'editosdassociations.xul';
      var args = new Object();
      args['object'] = current;
      args['role'] = roles[i];
      args['osdassociations'] = index;
      var d = new dock.cvDialog(editfile, args);
      d.onOk = function() {
        refresh();
      }
      dock.dialogs.showDialog(d);      
      break;
    }
  }
}
