/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var cluster;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  println("Refresh ceph osd" + ' - ' + document.documentURI);
  if(!!use) {
    cluster = use;
    current = use.find('Ceph');
    if(current.length == 1) {
      current = current[0];
    } else {
      current = 0;
      return;
    }        
  }
  
  if(!!cluster.cephState) {
    tree = document.getElementById('tree');
    data = new Array();
    
    var lastNodeKey = 0;
    var lastNodeName;
    var n = Math.min(cluster.cephState.OSDMapNodes.length, cluster.cephState.OSDMapAssocNames.length, cluster.cephState.OSDMapIds.length);
    for(var i = 0; i < n; i++) {
      if(cluster.cephState.OSDMapNodes[i] != lastNodeKey) {
        var node = cluster.find(cluster.cephState.OSDMapNodes[i]);
        if(!node) continue;
        lastNodeName = node.resolveName();
        lastNodeKey = cluster.cephState.OSDMapNodes[i];
      }
      var item = new Object();
      item['osdid'] = "osd." + cluster.cephState.OSDMapIds[i];
      item['hostname'] = lastNodeName;
      item['osdname'] = cluster.cephState.OSDMapAssocNames[i];
      data.push(item);
    }
    var select = selected('list');
    loadTable();
    setSelected('list', select);  
  } else {
    println('Ceph state not defined');
  }
}

function update() {
  // make call to update Ceph map? Not needed because it will be deliverd by event.  
  refresh();
}
