/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  println("Refresh ceph settings" + ' - ' + document.documentURI);
  if(!!use) {
    current = use.find('Ceph');
    if(current.length == 1) {
      current = current[0];
    } else {
      current = 0;
      return;
    }
  } else if(!current) {
    return;
  }
  
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  
  text('name', '^[a-zA-Z]');
  text('version', '^[a-zA-Z]');
  text('configFilePath');
  if(!current.get('bootstrapped')) document.getElementById('bootstrapped').setAttribute('value', '(not bootstrapped)');
  
  text('monitorPort', '^[0-9]+$');
  
  text('monOsdFullRatio', '^[0-9]+(\.[0-9]+)?$');
  text('monOsdNearfullRatio', '^[0-9]+(\.[0-9]+)?$');
  text('monMaxOsd', '^[0-9]+$');
  
  text('osdPoolDefaultSize', '^[0-9]+$');
  text('osdPoolDefaultMinSize', '^[0-9]+$');
  text('osdPoolDefaultPgNum', '^[0-9]+$');
  text('osdPoolDefaultPgpNum', '^[0-9]+$');

  check('filestoreXattrUseOmap');
  
  check('authClusterCephx');
  check('authServiceCephx');
  check('authClientCephx');

  // TODO: check filter
//   var filterString = 'function filter(network) { var currStart = ip2int(current.get("baseAddress")); var currEnd = lastIP(currStart, current.get("netmaskBits")); var netStart = ip2int(network.get("baseAddress")); var netEnd = lastIP(netStart, network.get("netmaskBits")); var netKey = network.get("uniqueKey"); return ((network.get("type") != "CLOUD") || ((netStart < currStart) || (netEnd > currEnd)) || ((network.get("EC2SubnetID") != "") && (current.get("subnets").indexOf(netKey) == -1))); }';
//   var displayString = 'function display(subnet) { return subnet.resolveName() + " (" + subnet.get("baseAddress") + " / " + subnet.get("netmaskBits") + ")"; }';
//   resolveList('publicNetworks', "Public networks:", "Network", '', '', '', filterString, displayString);
//   resolveList('clusterNetworks', "Cluster networks:", "Network", '', '', '', filterString, displayString);

  var isGlobalNetwork = function (network) { return network.get("type") === "GLOBAL"; }
  var eventListener = function () { var saveElement = document.getElementById("save"); if (saveElement) { saveElement.setAttribute("disabled", false); } }
  resolveList('publicNetworks', "Public networks:", "Network", undefined, '<default>', undefined, isGlobalNetwork, undefined, eventListener);
  resolveList('clusterNetworks', "Cluster networks:", "Network", undefined, '<default>', undefined, isGlobalNetwork, undefined, eventListener);
}
