/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  println("Refresh ceph settings" + ' - ' + document.documentURI);
  if(!!use) {
    current = use.find('Ceph');
    if(current.length == 1) {
      current = current[0];
    } else {
      current = 0;
      return;
    }
  } else if(!current) {
    return;
  }
}

function cephStop() {
  var args = new Object();
  args['question'] = "Are you sure you want to stop the entire Ceph?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    dock.waitIcon();
    var key = current.get('uniqueKey');
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmceph', 'stopAllServiceForCeph', key, function(code, data) {
      if(code == 0) {
        if(data.output.length == 0) {
          dock.displayInfo('Ceph stop returned no output and error code: ' + data.code);
        } else {
          dock.displayInfo(data.output);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);  
}

function cephStart() {
  var args = new Object();
  args['question'] = "Are you sure you want to start the entire Ceph?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    dock.waitIcon();
    var key = current.get('uniqueKey');
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmceph', 'startAllServiceForCeph', key, function(code, data) {
      if(code == 0) {
        if(data.output.length == 0) {
          dock.displayInfo('Ceph start returned no output and error code: ' + data.code);
        } else {
          dock.displayInfo(data.output);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);  
}

function cephRestart() {
  var args = new Object();
  args['question'] = "Are you sure you want to restart the entire Ceph?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    dock.waitIcon();
    var key = current.get('uniqueKey');
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmceph', 'restartAllServiceForCeph', key, function(code, data) {
      if(code == 0) {
        if(data.output.length == 0) {
          dock.displayInfo('Ceph restart returned no output and error code: ' + data.code);
        } else {
          dock.displayInfo(data.output);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);  
}
