/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var current;
var myDialog;
var dock;
var container;

function refresh(use) {
  screen();
}

function onLoad() {
  dock = getDock();
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  current = myDialog.arguments.cluster;
  container = myDialog.arguments.container;

  screen();
}

function screen() {
  var
    bootstrapText = "Specifies whether node(s) running this Monitor " +
                    "service must be up during the setup process. It is recommended to use " +
                    "the default value auto.",
    dataPathText = "Specifies a filesystem path for the Monitor's data. By default, " +
                   "the value is /var/lib/ceph/mon/$cluster-$hostname where $cluster is " +
                   "the name of the Ceph instance - usually 'ceph', and $hostname is the " +
                   "node's hostname. It is recommended to use the default value.";

  setAttr('bootstrapTip', 'tooltiptext', bootstrapText);
  setAttr('dataPathTip', 'tooltiptext', dataPathText);

  setAttr('type', 'value', container.baseType + ':');
  setAttr('name', 'value', container.getName());
  setAttr('dataPath', 'value', container.dataPath);

  var options = container.bootstrap_options;
  var drop = document.getElementById('bootstrap');
  var popup = drop.firstChild;
  options.forEach(function(option) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', option);
    popup.appendChild(item);
  });
  drop.selectedIndex = options.indexOf(container.bootstrap);
}

function ok() {
  container.dataPath = getAttr('dataPath', 'value');
  var bootstrapIndex = getAttr('bootstrap', 'selectedIndex', 'notrim');
  container.bootstrap = container.bootstrap_options[bootstrapIndex];

  var validateMessages = container.validate();
  if (validateMessages.length > 0) {
    dock.displayError(validateMessages.join('\n\n'));
    return;
  }
  close();
  if(myDialog.onOk) {
    myDialog.onOk(container);
  }
}

function cancel() {
  close();
  if(myDialog.onCancel) myDialog.onCancel();
  if(myDialog.onClose) myDialog.onClose();
}
