/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var current;
var myDialog;
var dock;
var nodesIndex;

var nodeProperties = [['hostname', 'hostname', false],
                         ['MAC', 'mac', false],
                         ['tag', 'tag', false],
                         ['category', 'category', true],
                         ['installmode', 'installMode', false],
                         ['rack', 'rack', true],
                         ['position', 'rackPosition', false]];
var categoryProperties = [['name', 'name', false]];

// START for node selection
var fieldname = undefined;
var extraName = "''";
var belongs = '0';
var noloop = 'true';
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';
var nodeSelectionProperties;
var subtype;
var currentnodes;
var excludeFunction;

function refresh(use) {
  screen(excludeFunction);
}

function onLoad() {
  dock = getDock();
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  current = myDialog.arguments.cluster;
  subtype = myDialog.arguments.baseType;
  currentnodes = myDialog.arguments.currentnodes;
  excludeFunction = myDialog.arguments.excludeFunction;
  nodeSelectionProperties = (subtype === 'Node') ? nodeProperties : categoryProperties;
  nodesIndex = 'Ceph';

  screen(excludeFunction);
}

function screen() {
  if (typeof excludeFunction  == 'undefined') {
    excludeFromSelection = function(node) { return false; }
  }
  
  var plural = (subtype === 'Node') ? 'Nodes' : 'Categories';
  setDialogTitle('Select ' + plural);
  document.getElementById('allItemsLabel').setAttribute('value', 'All ' + plural);
  document.getElementById('groupnodeslabel').setAttribute('value', plural);
  deviceselect(excludeFunction);
}

function ok() {
  close();
  if(myDialog.onOk) {
    myDialog.onOk(currentnodes);
  }
}

function cancel() {
  close();
  if(myDialog.onCancel) myDialog.onCancel();
  if(myDialog.onClose) myDialog.onClose();
}
