/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var deviceName = 'device';
var deviceNamePlural = 'devices';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh chassis tasks" + ' - ' + document.documentURI);

  var items = document.getElementById('members');
  while(items.childNodes.length > 1) items.removeChild(items.lastChild);

  var members = current.get('members')
  if(members.length == 0) {
    var apc = current.get('powerDistributionUnits');
    document.getElementById('nomembers').removeAttribute('hidden');
    if(current.get('powerControl') == 'apc') {
      document.getElementById('poweron').setAttribute('disabled', apc.length == 0);
      document.getElementById('poweroff').setAttribute('disabled', apc.length == 0);
      document.getElementById('powerreset').setAttribute('disabled', apc.length == 0);
    } else if(current.get('powerControl') == 'none') {
      document.getElementById('poweron').setAttribute('disabled', true);
      document.getElementById('poweroff').setAttribute('disabled', true);
      document.getElementById('powerreset').setAttribute('disabled', true);
    } else {
      document.getElementById('poweron').setAttribute('disabled', false);
      document.getElementById('poweroff').setAttribute('disabled', false);
      document.getElementById('powerreset').setAttribute('disabled', false);
    }
  } else {
    document.getElementById('nomembers').setAttribute('hidden', true);

    var realmembers = new Array();
    var n = members.length;
    if(n > 64) {
      println("The number of ports is very high: " + n + " (disabled)");
    } else {
      for(var i = 0; i < n; i++) {
        var one = current.cluster.find(members[i]);
        if(!!one) {
          realmembers.push(one);
        } else {
          println("Unable to find chassis member: " + members[i]);
        }
      }
    }
    realmembers.sort(function(a,b){return b.resolveName() < a.resolveName()});
    for(var i = 0; i < realmembers.length; i++) {
      var key = realmembers[i].get('uniqueKey');
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var hbox = document.createElement('hbox');
      hbox.setAttribute('pack', 'end');
      var label = document.createElement('label');
      label.setAttribute('value', realmembers[i].resolveName());
      label.setAttribute('class', 'staticdataheader');
      hbox.appendChild(label);
      row.appendChild(hbox);
      var button = document.createElement('button');
      button.setAttribute('class', 'bluebutton');
      button.setAttribute('label', 'Off');
      button.setAttribute('oncommand', 'powerOff(' + key + ')');
      row.appendChild(button);
      var button = document.createElement('button');
      button.setAttribute('class', 'bluebutton');
      button.setAttribute('label', 'On');
      button.setAttribute('oncommand', 'powerOn(' + key + ')');
      row.appendChild(button);
      var button = document.createElement('button');
      button.setAttribute('class', 'bluebutton');
      button.setAttribute('label', 'Reset');
      button.setAttribute('oncommand', 'powerReset(' + key + ')');
      row.appendChild(button);
      items.appendChild(row);
    }
    var key = -1;
    var row = document.createElement('row');
    row.setAttribute('align', 'center');
    var hbox = document.createElement('hbox');
    hbox.setAttribute('pack', 'end');
    var label = document.createElement('label');
    label.setAttribute('value', 'All members');
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);
    var button = document.createElement('button');
    button.setAttribute('class', 'bluebutton');
    button.setAttribute('label', 'On');
    button.setAttribute('oncommand', 'powerOn(' + key + ')');
    row.appendChild(button);
    var button = document.createElement('button');
    button.setAttribute('class', 'bluebutton');
    button.setAttribute('label', 'Off');
    button.setAttribute('oncommand', 'powerOff(' + key + ')');
    row.appendChild(button);
    var button = document.createElement('button');
    button.setAttribute('class', 'bluebutton');
    button.setAttribute('label', 'Reset');
    button.setAttribute('oncommand', 'powerReset(' + key + ')');
    row.appendChild(button);
    items.appendChild(row);
  }
}

function locateInRack() {
  current.cluster.locate(current);
}
