/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function plusIP(ip, plus) {
//   print("PLUS IP: " + ip + " " + plus + " = ");
  var s = ip.split('.');
  if(s.length != 4) return 0;
  for(var i = 0; i < s.length; i++) {
    s[i] = myParseInt(s[i]);
  }
  s[3] += plus;
  var n = 3;
  while((n > 0) && ((s[n] > 255) || (s[n] < 0))) {
    if(s[n] < 0) {
      while(s[n] < 0) {
        s[n] = s[n] + 256;
        s[n - 1] -= 1;
      }
    } else {
      s[n - 1] += Math.floor(s[n] / 256);
      s[n] = s[n] % 256;
    }
    n--;
  }
  s = s.join('.');
//   println(s);
  return s;
}

function inDynamicRange(ip, dys, dye) {
  var s = ip.split('.');
  if(s.length != 4) return true;
  var x = 0;
  for(var i = 0; i < s.length; i++) {
    x = x * 256 + myParseInt(s[i]);
  }
  return ((x >= dys) && (x <= dye));
}

function isFreeIP(ip, list) {
  for(var i = 0; i < list.length; i++) {    
    var ips = list[i].getIPs(false);
    for(var j = 0; j < ips.length; j++) {
      if(ip == ips[j][1]) return false;
    }
  }
  return true;
}

function guessIP(object, name, mac) {
  name = isundefined(name, 'BOOTIF');
  if(dock.GUESSIP) {
    println('guessIP for ' + object.get('hostname'));
    var devices = object.cluster.find('Device');
    var newid = nameNumber(object.get('hostname'));
    var list = object.cluster.find(object.get('childType'));
    if(list.length > 0) {
      var bestmatch = 0;
      var offset = -1;
      for(var i = 0; i < list.length; i++) {
        var oldid = nameNumber(list[i].get('hostname'));
        if(newid[0] == oldid[0]) {
          var ips = list[i].getIPs();
          if((ips.length > 0) && (ips[0][1] != '0.0.0.0')) {
            if((newid.length == 2) && (oldid.length == 2)) {
              var i0 = myParseInt(oldid[1]);
              var i1 = myParseInt(newid[1]);
              var diff = i1 - i0;
              if(bestmatch == 0) {
                bestmatch = list[i];
                offset = diff;
              } else {
                if(diff < 0) {
                  if((offset < 0) && (diff > offset)) {
                    bestmatch = list[i];
                    offset = diff;
                  }
                } else {
                  if((offset < 0) || (diff < offset)) {
                    bestmatch = list[i];
                    offset = diff;      
                  }
                }
              }
            }
          }
        }
      }
      if(bestmatch) {
        var diff = offset;
        println('Best match: ' + bestmatch.get('hostname') + ', diff: ' + diff);
        var oldid = nameNumber(bestmatch.get('hostname'));
        var i0 = myParseInt(oldid[1]);
        var ip = bestmatch.getIPs()[0];
        var network = object.cluster.find(ip[0]);
        var dys = 0;
        var dye = 0;
        var hasdyn = false;
        if(network) {
          var dysip = network.get('dynamicRangeStart').split('.');
          var dyeip = network.get('dynamicRangeEnd').split('.');
          for(var i = 0; i < 4; i++) {
            dys = dys * 256 + myParseInt(dysip[i]);
            dye = dye * 256 + myParseInt(dyeip[i]);
          }
          hasdyn = (dys > 0);
        } else {
          println("No network set for dynamic range check " + ip[0]);
        }
        if(diff == 0) diff = 1;
        do {
          ip[1] = plusIP(ip[1], diff);
          diff = 1;
          if(hasdyn && inDynamicRange(ip[1], dys, dye)) {
            ip[1] = dyeip.join('.');
            ip[1] = plusIP(ip[1], diff);
            println('Set ip to dynamic range end: ' + ip[1]);
          }
        } while(!isFreeIP(ip[1], devices));
        println('found free ip: ' + ip[1]);
        if(dock.baseChildTypeCheck(object.object, 'Node')) {
          var binterface = new dock.cvNetworkPhysicalInterface();
          var work = new dock.cvObject(object.cluster, binterface);
          work.set('network', ip[0]);
          work.set('ip', ip[1]);
          work.set('name', ip[2]);
          if(typeof(mac) != 'undefined') work.set('mac', mac);
          var interfaces = object.get('networks');
          interfaces.push(binterface);
          object.set('networks', interfaces);
          object.set('provisioningNetwork', work.get('uniqueKey'));
        } else {
          object.set('network', ip[0]);
          object.set('ip', ip[1]);
        }
        return;
      } else {
        println('No best match');
      }
    }
    var man = object.get('partition');
    man = object.cluster.find(man);
    if(man) {
      var mank = man.get('managementNetwork');
      man = object.cluster.find(mank);
      if(man) {
        var ip = man.get('baseAddress');
        var network = object.cluster.find(mank);
        var dys = 0;
        var dye = 0;
        var hasdyn = false;
        var dysip = man.get('dynamicRangeStart').split('.');
        var dyeip = man.get('dynamicRangeEnd').split('.');
        for(var i = 0; i < 4; i++) {
          dys = dys * 256 + myParseInt(dysip[i]);
          dye = dye * 256 + myParseInt(dyeip[i]);
        }
        hasdyn = (dys > 0);
        var diff = myParseInt(newid[1]);
        if(diff == 0) diff = 1;
        do {
          ip = plusIP(ip, diff);
          diff = 1;
          if(hasdyn && inDynamicRange(ip, dys, dye)) {
            ip = dyeip.join('.');
            ip = plusIP(ip, diff);
            println('Set ip to dynamic range end: ' + ip);
          }
        } while(!isFreeIP(ip, devices));
        
        println('found free ip (2): ' + ip);
        if(dock.baseChildTypeCheck(object.object, 'Node')) {
          var binterface = new dock.cvNetworkPhysicalInterface();
          var work = new dock.cvObject(object.cluster, binterface);
          work.set('network', mank);
          work.set('ip', ip);
          work.set('name', name);
          if(typeof(mac) != 'undefined') work.set('mac', mac);
          var interfaces = object.get('networks');
          interfaces.push(binterface);
          object.set('networks', interfaces);
          object.set('provisioningNetwork', work.get('uniqueKey'));
        } else {
          object.set('network', mank);
          object.set('ip', ip);
        }
      }
    }
  }
}

function cloneSimpleIP(original, object) {
  var newid = nameNumber(object.hostname);
  var oldid = nameNumber(original.hostname);
  if((newid.length == 2) && (oldid.length == 2)) {
    var i0 = myParseInt(oldid[1]);
    if(i0 > 0) {
      var i1 = myParseInt(newid[1]);
      var ip = object.ip.split('.');
      if(ip.length == 4) {
        if(myParseInt(ip[3]) == i0) {
          object.ip = ip[0] + "." + ip[1] + "." + ip[2] + "." + (i1 % 256);
        } else {
          println("Non clonable ip:"  + ip);
        }
      } else {
        println("Illegal ip:"  + ip);
      }
    }
  }
}

// function cloneSimpleIP(original, object) {
//   var newid = nameNumber(object.hostname);
//   var oldid = nameNumber(original.hostname);
//   if((newid.length == 2) && (oldid.length == 2)) {
//     var i0 = myParseInt(oldid[1]);
//     if(i0 > 0) {
//       var i0a = Math.floor((i0 - 1) / 255);
//       var i0 = ((i0 - 1) % 255) + 1;
//       var i1 = myParseInt(newid[1]);
//       var i1a = Math.floor((i1 - 1) / 255);
//       var i1 = ((i1 - 1) % 255) + 1;
//       var ip = object.ip.split('.');
//       if(ip.length == 4) {
//         if((myParseInt(ip[2]) == i0a) && (myParseInt(ip[3]) == i0)) {
//           object.ip = ip[0] + "." + ip[1] + "." + i1a + "." + i1;
//         } else {
//           println("Non clonable ip:"  + ip);
//         }
//       } else {
//         println("Illegal ip:"  + ip);
//       }
//     }
//   }
// }

function cloneNodeIP(original, object) {
  var newid = nameNumber(object.hostname);
  var oldid = nameNumber(original.hostname);
  if((newid.length == 2) && (oldid.length == 2)) {
    var i0 = myParseInt(oldid[1]);
    if(i0 > 0) {
      var i0a = Math.floor((i0 - 1) / 255);
      var i0 = ((i0 - 1) % 255) + 1;
      var i1 = myParseInt(newid[1]);
      var i1a = Math.floor((i1 - 1) / 255);
      var i1 = ((i1 - 1) % 255) + 1;
      var intf = object.networks;
      for(var i = 0; i < intf.length; i++) {
        var ip = intf[i].ip.split('.');
        if(ip.length == 4) {
          if((myParseInt(ip[2]) == i0a) && (myParseInt(ip[3]) == i0)) {
            if((i1a < 0) || (i1 < 0)) {
              intf[i].ip = '0.0.0.0';
            } else {
              intf[i].ip = ip[0] + "." + ip[1] + "." + i1a + "." + i1;
            }
//           } else {
//             println("Non clonable ip:"  + ip);
//             intf[i].ip = '0.0.0.0';
          }
        } else {
          println("Illegal ip:"  + ip);
//           intf[i].ip = '0.0.0.0';
        }
      }
      object.networks = intf;
      object.modified = true;
    }
  }
}

function ip2int(ip) {
  var s = ip.split('.');
  if(s.length == 4) {
    return (myParseInt(s[0]) * 256 * 256 * 256) + (myParseInt(s[1]) << 16) + (myParseInt(s[2]) << 8) + myParseInt(s[3]);
  }
  return 0;
}

function int2ip(x) {
  var ip = Math.floor(x / (256 * 256 * 256)) + '.';
  ip += ((x >> 16) & 255) + '.'; 
  ip += ((x >> 8) & 255) + '.';
  ip += (x & 255);
  return ip;
}

function moveIP(ip, base0, bits0, base1, bits1) {
  var x = ip2int(ip);
  if(x <= 0) return '';
  x = x - ip2int(base0);
  x = x + ip2int(base1);
  return int2ip(x);
}

function lastIP(ip, mask) {
  return ip + (Math.pow(2, (32 - mask)) - 1);
}

// args: string, int, string, int
function overlappingRanges(base1, mask1, base2, mask2) {
  var start1 = ip2int(base1);
  var end1 = lastIP(start1, mask1);

  var start2 = ip2int(base2);
  var end2 = lastIP(start2, mask2);

  if ((start1 <= end2) && (start2 <= end1)) {
    return true;
  }

  return false;
}
