/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock
var settings;

function onLoad() {
  dock = getDock();
  println("Node Creation Wizard initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  settings = new cvCloneSettings(myDialog.arguments.action, myDialog.arguments.parent, myDialog.arguments.subfield, myDialog.arguments.work, myDialog.arguments.filename);

  if((settings.action == dock.CLONE_SYNC_ONE) && (settings.work.length > 1)) {
    settings.action = dock.CLONE_SYNC_N;
  }
  if(settings.action == dock.CLONE_CREATE) {
    document.getElementById('deck').selectedIndex = 1;
    refresh1();
  } else if(settings.action == dock.CLONE_LOAD) {
    var pages = document.getElementById('deck').childNodes.length - 1;
    var index = 2;
    document.getElementById('deck').selectedIndex = index;
    if((settings.action == dock.CLONE_LOAD) || ((index == 1) && (settings.action == dock.CLONE_CREATE)) || (index == 0)) {
      document.getElementById('prev').setAttribute('disabled', true);
    } else {
      document.getElementById('prev').removeAttribute('disabled');
    }
    document.getElementById('next').setAttribute('hidden', (index == pages));
    document.getElementById('finish').setAttribute('hidden', (index < pages));
    refresh3();
  } else {
    refresh2();
  }

}

function next() {
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);
  switch(index) {
  case(0) :
    if(settings.propsel.length <= 0) {
      dock.displayError('Select at least one property', window);
      return;
    }
    break;
  case(1) :
    var destination = selected('list');
    if(destination.length == 0) {
      dock.displayError('Select at least one destination', window);
      return;
    }
    settings.destination = destination;
    break;
  }
  index++;
  switch(index) {
  case(1) :
    refresh1();
    break;
  case(2):
    refresh3();
    break;
  }
  document.getElementById('deck').selectedIndex = index;
  if((settings.action == dock.CLONE_LOAD) || ((index == 1) && (settings.action == dock.CLONE_CREATE)) || (index == 0)) {
    document.getElementById('prev').setAttribute('disabled', true);
  } else {
    document.getElementById('prev').removeAttribute('disabled');
  }
  document.getElementById('next').setAttribute('hidden', (index == pages));
  document.getElementById('finish').setAttribute('hidden', (index < pages));
}

function prev() {
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);
  var back = true;
  switch(index) {
    case(2):
      settings.removeLastAction();
      break;
  }
  if(back) {
    index--;
    document.getElementById('deck').selectedIndex = index;
    if((settings.action == dock.CLONE_LOAD) || ((index == 1) && (settings.action == dock.CLONE_CREATE)) || (index == 0)) {
      document.getElementById('prev').setAttribute('disabled', true);
    } else {
      document.getElementById('prev').removeAttribute('disabled');
    }
    document.getElementById('next').setAttribute('hidden', (index == pages));
    document.getElementById('finish').setAttribute('hidden', (index < pages));
  }
}

function finish() {
  if(settings.execute()) {
    close();
  }
}

function cancel() {
  close();
}

function refresh1() {
  tree = document.getElementById('tree');
  data = new Array();

  var clusters = dock.connectedClusters();
  var n = settings.parentCount();
  if(n == 0) {
    if((settings.action == dock.CLONE_SYNC_N) || (settings.action == dock.CLONE_CREATE)) {
      for(var i = 0; i < clusters.length; i++) {
        if(clusters[i] != settings.work[0].cluster) {
          data.push(createTreeItem(clusters[i]));
        }
      }
    } else if(settings.action == dock.CLONE_SYNC_ONE) {
      for(var i = 0; i < clusters.length; i++) {
        var onelist = clusters[i].find(settings.work[0].getType());
        for(var j = 0; j < onelist.length; j++) {
          if(onelist[j] != settings.work[0]) {
            data.push(createTreeItem(clusters[i], [onelist[j]]));
          }
        }
      }
    }
  } else if(n == 1) {
    if((settings.action == dock.CLONE_SYNC_N) || (settings.action == dock.CLONE_CREATE)) {
      var p0 = settings.getParent(0);
      var type = p0.getType();
      for(var i = 0; i < clusters.length; i++) {
        var onelist = clusters[i].find(type);
        for(var j = 0; j < onelist.length; j++) {
          if(onelist[j] != p0) {
            data.push(createTreeItem(clusters[i], [onelist[j]]));
          }
        }
      }
    } else if(settings.action == dock.CLONE_SYNC_ONE) {
      var type = settings.getParent(0).getType();
      for(var i = 0; i < clusters.length; i++) {
        var onelist = clusters[i].find(type);
        for(var j = 0; j < onelist.length; j++) {
          var sublist = onelist[j].getFromSubfield(settings.getSubfield(0));
          for(var k = 0; k < sublist.length; k++) {
            if(sublist[k] != settings.work[0]) {
              data.push(createTreeItem(clusters[i], [onelist[j], sublist[k]]));
            }
          }
        }
      }
    }
  } else {
    // TODO
  }

  if(clusters.length > 1) {
    document.getElementById('cluster').removeAttribute('hidden');
  } else {
    document.getElementById('cluster').setAttribute('hidden', true);
  }
  if((settings.parentCount() == 0) && (settings.action != dock.CLONE_SYNC_ONE)) {
    document.getElementById('name').setAttribute('hidden', true);
  } else {
    document.getElementById('name').removeAttribute('hidden');
  }

  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(cluster, object) {
  var item = new Object();
  item['cluster'] = cluster.name;
  item['key'] = cluster.key;
  item['name'] = ''
  if(isArray(object)) {
    for(var i = 0; i < object.length; i++) {
      item['key'] += '|' + object[i].get('uniqueKey');
      if(i > 0) item['name'] += ' : ';
      item['name'] += object[i].resolveName();
    }
  }
  return item;
}

function refresh2() {
  var MIN_ROW = 17;
  var propall = new Array();
  var params = settings.work[0].getClonableParameters();
  params.sort();
  propall = [[ALL]];
  settings.propkeys = new Array();
  for(var i = 0; i < params.length; i++) {
    var one = params[i];
    propall.push(one);
    if(one[3] == '1') settings.propkeys.push(one[0]);
  }

  if(!isArray(settings.propsel)) {
    settings.propsel = [ALL];
  }

  var properties = document.getElementById('properties');
  var cols = properties.parentNode.firstChild.childNodes.length;

  while(properties.firstChild) properties.removeChild(properties.firstChild);
  var n = 0;
  if(propall.length <= MIN_ROW) {
    n = propall.length;
  } else if(propall.length > cols * MIN_ROW) {
    n = Math.ceil(propall.length / cols);
  } else {
    n = MIN_ROW;
  }
  var parentChecked = (settings.propsel.find(propall[0]) >= 0);
  for(var i = 0; i < n; i++) {
    var row = document.createElement("row");
    for(var j = 0; j < cols; j++) {
      var check;
      var k = j * n + i;
      if(k < propall.length) {
        check = document.createElement("checkimage");
        check.setAttribute('checked', (settings.propsel.find(propall[k][0]) >= 0));
        if(k == 0) check.setAttribute('all', true);
        check.setAttribute('parentChecked', (k > 0) && parentChecked);
        var text = propall[k][Math.min(1, propall[k].length - 1)];
        if(text.length == 0) text = propall[k][0];
        if(propall[k][3] == '1') {
          check.setAttribute('iskey', propall[k][3]);
          text += ' (key)';
        }
        check.setAttribute('param', propall[k][0]);
        check.setAttribute('label', text);
        if(propall[k].length == 3) check.setAttribute('tooltiptext', propall[k][2]);
        check.setAttribute('oncommand', 'checkboxproperylist_command(event);');
      } else {
        check = document.createElement("spacer");
      }
      row.appendChild(check);
    }
    properties.appendChild(row);
  }
}

function checkboxproperylist_command(event) {
  var item = event.target;
  var value = item.getAttribute('checked');
  var name = item.getAttribute('param');
  if(typeof(value) == 'string') {
    value = (value == 'true');
  } else {
    value = eval(value);
  }
  if(value) {
    if(settings.propsel.find(name) < 0) {
      settings.propsel.push(name);
    }
  } else {
    var index = settings.propsel.find(name);
    if(index >= 0) {
      settings.propsel.splice(index, 1);
    }
  }
  if(eval(item.getAttribute('all'))) {
    var properties = document.getElementById('properties');
    var row = properties.firstChild;
    while(row) {
      var check = row.firstChild;
      while(check) {
        check.setAttribute('parentChecked', value);
        check = check.nextSibling;
      }
      row = row.nextSibling;
    }
  }
}

function refresh3() {
  if(settings.action == dock.CLONE_LOAD) {
    document.getElementById('saveas').parentNode.setAttribute('hidden', true);
    var data = readfile(settings.filename);
    if(data == 0) {
      dock.displayError('Unable to read file: ' + settings.filename, window);
      close();
    } else if(!settings.load(data)) {
      dock.displayError('File: ' + settings.filename + ' does not contain valid clone operations', window);
      close();
    }
  } else {
    if(!settings.build()) {
      println('Failed to build settings');
      return false;
    }
  }

  document.getElementById('message').value = settings.getOverview();
}

function saveClone() {
  var filename = document.getElementById('saveas').value;
  if(filename.length > 0) {
    var data;
    if(fileExists(filename)) {
      var old = new cvCloneSettings();
      var content = readfile(filename);
      if(content) {
        if(!old.load(content)) {
          dock.displayError(filename + ' does not contain valid clone data', window);
          return false;
        }
        old.merge(settings);
        data = old.save();
      } else {
        dock.displayError(filename + ' does not contain data', window);
        return false;
      }
    } else {
      data = settings.save();
    }
    if(savefile(filename, data)) {
      dock.addOldClone(filename);
    } else {
      dock.displayError('Unable to save file ' + filename, window);
    }
  } else {
    dock.displayError('Specify a filename', window);
  }
}

function browse() {
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Select file", nsIFilePicker.modeSave);
  var path = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
  path.initWithPath(dock.getWorkDirectory());
  fp.displayDirectory = path;
  fp.appendFilter("Clone files","*.clone");
  fp.appendFilters(nsIFilePicker.filterAll);
  var r = fp.show();
  if((r == nsIFilePicker.returnOK) || (r == nsIFilePicker.returnReplace)) {
    document.getElementById('saveas').value = fp.file.path;
  }
}
