
function RegionsWizardScreen(wizard) {
  WizardScreen.call(this, wizard);

  this.configured_regions = {};

  this.initDefaultConfig = function() {
    println('wizard.regions.initDefaultConfig');
    this.configured_regions = {}
    var cluster = current.cluster ? current.cluster : current;
    var cloudProviders = cluster.find('cloudProvider');
    for(var j = 0; j < cloudProviders.length; j++) {
      for(var i =0; i < cloudProviders[j].object.privateClouds.length; i++) {
        var pc = cloudProviders[j].object.privateClouds[i];
        var region_key = pc.region;
        var region = cluster.find(region_key);
        if(region) {
          this.configured_regions[region.get('name')] = true;
        }
      }
    }
  };

  this.selectedRegions = function() {
    var ret = {};
    for(var i = 0; i < wizard.config.modules.clusterextension.vpcs.length; i++) {
      ret[wizard.config.modules.clusterextension.vpcs[i].region] = true;
    }
    return ret;
  };

  this.forward = function() {
    var configured_regions = [];
    for(var i = 0; i < wizard.config.modules.clusterextension.advanced.hardcoded_regions.length; i++) {
      var region = wizard.config.modules.clusterextension.advanced.hardcoded_regions[i];
      var elem = document.getElementById('vpcs-region-' + region);
      if(elem && elem.checked) {
	configured_regions.push(region);
      }
    }
    if(configured_regions.length == 0) {
      this.error = true;
      wizard.common.unhide('vpc-count-error');
    } else {
      wizard.common.hide('vpc-count-error');
      var template = wizard.config.modules.clusterextension.advanced.vpc_object_template;
      wizard.config.modules.clusterextension.vpcs = [];
      for(var i = 0; i < configured_regions.length; i++) {
	var vpc = JSON.parse(JSON.stringify(template));
	vpc.region = configured_regions[i];
	wizard.config.modules.clusterextension.vpcs.push(vpc);
      }
      wizard.deck['regions'].enable_click = true;
      wizard.deck['summary'].enable_click = true;
    }
  };

  this.enter = function() {
    println('enter wizard.regions.enter');
    wizard.common.hide('vpc-count-error');

    var parent = document.getElementById('vpcs-select-regions');
    while (parent.childNodes.length > 1) {
      parent.removeChild(parent.lastChild);
    }
    var conf_parent = document.getElementById('vpcs-configured-regions');
    while (conf_parent.childNodes.length > 1) {
      conf_parent.removeChild(conf_parent.lastChild);
    }
    var selected_regions = this.selectedRegions();
    var has_configured = false;
    for(var i = 0; i < wizard.config.modules.clusterextension.advanced.hardcoded_regions.length; i++) {
      var region = wizard.config.modules.clusterextension.advanced.hardcoded_regions[i];
      var region_label = region;
      var row = document.createElement('row');
      var checkimage = document.createElement('checkimage');
      checkimage.setAttribute('label', region_label);
      row.appendChild(checkimage);
      if(this.configured_regions.hasOwnProperty(region)) {
        checkimage.setAttribute('checked', true);
        checkimage.setAttribute('disabled', true);
        checkimage.setAttribute('style', 'background: #dddddd !important;');
        conf_parent.appendChild(row);
        has_configured = true;
      } else {
        checkimage.setAttribute('id', 'vpcs-region-' + region);
        checkimage.setAttribute('checked', (selected_regions.hasOwnProperty(region)));
        parent.appendChild(row);
      }
    }
    if(has_configured) {
      wizard.common.unhide('configured-regions-box');
    }
  }
}

