function SummaryWizardScreen(wizard) {
  WizardScreen.call(this, wizard);

  this.getIntersectionOfInstanceTypes = function(regions) {
    var n = regions.length;
    var type = {};
    for(var r = 0; r < regions.length; r++) {
      var region = regions[r];
      var lst = wizard._region2instance_types[region];
      for(var i = 0; i < lst.length; i++) {
        if(!type.hasOwnProperty(lst[i])) {
          type[lst[i]] = 0;
        }
        type[lst[i]]++;
      } 
    };
    var ret = [];
    for(var t in type) {
      if(type[t] == n) {
        ret.push(t);
      }
    }
    ret = ret.sort();
    return ret;
  };

  this.forward = function() {
    println('wizard.summary.forward');
    wizard.deck['summary'].enable_click = true;
    wizard.deck['deploy'].enable_click = true;
  };

  this.leave = function() {
    println('wizard.summary.leave');
    var elem = document.getElementById('nextButton');
    elem.setAttribute('label', 'Next');
    elem.setAttribute('accesskey', 'N');
    var select_fields = [
      "default_cloud_director_type",
      "default_cloud_node_type"
    ];
    for(var i = 0; i < select_fields.length; i++) {
      var f = document.getElementById('summary-' + select_fields[i]);
      var elem = f.parentElement.selectedItem;
      if(elem && elem.value) {
        wizard.config.modules.clusterextension[select_fields[i]] = [elem.value];
      } else {
        wizard.config.modules.clusterextension[select_fields[i]] = [];
      }
      for(var j = 0; j < wizard["init_" + select_fields[i]].length; j++) {
        if(!elem || !elem.value || wizard["init_" + select_fields[i]][j] != elem.value) {
          wizard.config.modules.clusterextension[select_fields[i]].push(wizard["init_" + select_fields[i]][j]);
        }
      }
    }
    var f = document.getElementById('summary-default_region');
    var elem = f.parentElement.selectedItem;
    if(elem && elem.value) {
      wizard.config.modules.clusterextension.default_region = elem.value;
    } else {
      wizard.config.modules.clusterextension.default_region = '';
    }
  };

  this.createDefaultTypeItems = function(regions) {
    var select_fields = [
      "default_cloud_director_type",
      "default_cloud_node_type"
    ];
    var values = this.getIntersectionOfInstanceTypes(regions);
    for(var i = 0; i < select_fields.length; i++) {
      var f = document.getElementById('summary-' + select_fields[i]);
      f.parentElement.selectedIndex = -1;
      while (f.firstChild) {
        f.removeChild(f.firstChild);
      }
      for(var j = 0; j < values.length; j++) {
        var menuitem = document.createElement('menuitem');
        menuitem.setAttribute('label', values[j]);
        menuitem.setAttribute('value', values[j]);
        f.appendChild(menuitem);
      }
      var default_values = wizard.config.modules.clusterextension[select_fields[i]];
      for(var j = 0; j < default_values.length; j++) {
        var found = values.indexOf(default_values[j]);
        if(found > -1) {
          f.parentElement.selectedIndex = found;
          break;
        }
      }
    }
  };

  this.createDefaultRegionSelect = function(regions, defaults, selected) {
    var f = document.getElementById('summary-default_region');
    f.parentElement.selectedIndex = -1;
    while (f.firstChild) {
      f.removeChild(f.firstChild);
    }
    for(var j = 0; j < regions.length; j++) {
      var menuitem = document.createElement('menuitem');
      menuitem.setAttribute('label', regions[j]);
      menuitem.setAttribute('value', regions[j]);
      f.appendChild(menuitem);
    }
    var found = -1;
    found = regions.indexOf(selected);
    if(found == -1) {
      for(var j = 0; j < defaults.length; j++) {
        found = regions.indexOf(defaults[j]);
        if(found != -1) {
          break;
        }
      }
    }
    if(found != -1) {
      f.parentElement.selectedIndex = found;
    } else {
      f.parentElement.selectedIndex = 0;
    }
  };

  this.enter = function() {
    println('enter wizard.summary.enter');
    var elem = document.getElementById('nextButton');
    elem.setAttribute('label', 'Deploy');
    elem.setAttribute('accesskey', 'D');
    var summary_elems = [
      "provider_name",
      "account_id",
      "username",
    ];
    for(var i = 0; i < summary_elems.length; i++) {
      var name = 'summary-' + summary_elems[i];
      var value = wizard.config.modules.clusterextension[summary_elems[i]];
      var old_text = document.getElementById(name).textContent;
      document.getElementById(name).textContent = value;
    }
    var regions = [];
    for(var i = 0; i < wizard.config.modules.clusterextension.vpcs.length; i++) {
      regions.push(wizard.config.modules.clusterextension.vpcs[i].region)
    }
    var regions_str = regions.join(', ');
    document.getElementById('summary-regions').textContent = regions_str;
    this.createDefaultTypeItems(regions);

    var default_regions = regions;
    var cluster = current.cluster ? current.cluster : current;
    if(cluster) {
      var cloudProviders = cluster.find('cloudProvider');
      if(cloudProviders) {
        for(var j = 0; j < cloudProviders.length; j++) {
          for(var i =0; i < cloudProviders[j].object.privateClouds.length; i++) {
            var pc = cloudProviders[j].object.privateClouds[i];
            var region_key = pc.region;
            var region = cluster.find(region_key);
            var name = region.get('name');
            if(default_regions.indexOf(name) == -1) {
              default_regions.push(name);
            }
          }
        }
      }
    }
    this.createDefaultRegionSelect(default_regions,
                                   wizard.config.modules.clusterextension.advanced.hardcoded_regions,
                                   wizard.config.modules.clusterextension.default_region);
    wizard.deck['summary'].enable_click = true;
    wizard.deck['deploy'].enable_click = true;
  }
}
