/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;

var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;

  var box = document.getElementById('providers');
  var n = box.childNodes.length;
  var providers = current.find('CloudProvider');

  for(var i = 0; i < providers.length; i++) {
    if(!providers[i].get('toBeRemoved')) {
      box.appendChild(providerItem(providers[i]));
    }
  }
  box.appendChild(addProviderItem());
  for(var i = 0; i < n; i++) {
    box.removeChild(box.firstChild);
  }
}

function providerItem(provider) {
  var box = document.createElement('vbox');
  var box3 = document.createElement('vbox');
  box3.setAttribute('flex', '1');
  box3.setAttribute('class', 'clustertop');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustercaption');
  label.setAttribute('value', provider.get('name'));
  box3.appendChild(label);
  var line = document.createElement('hbox');
  line.setAttribute('class', 'staticdottedline');
  box3.appendChild(line);

  var box4 = document.createElement('hbox');
  box3.setAttribute('style', 'padding: 12px;');
  box4.setAttribute('style', 'margin-left: 2px;');
  var box5 = document.createElement('vbox');
  box5.setAttribute('align', 'center');
  var image = document.createElement('image');
  image.setAttribute('src', 'chrome://cmgui/content/icons/Cloud_32.png');
  box5.appendChild(image);
  box4.appendChild(box5);

  var box6 = document.createElement('hbox');
  box6.setAttribute('style', 'min-width: 320px;');
  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Provider:');
  vbox.appendChild(label);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Username:');
  vbox.appendChild(label);
  box6.appendChild(vbox);

  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  label.setAttribute('value', provider.get('name'));
  vbox.appendChild(label);
  
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  label.setAttribute('value', provider.get('username'));
  if (isReadOnlyCloudProvider(provider)) {
    label.setAttribute('value', '****');
  } else {
    label.setAttribute('value', provider.get('username'));
  }
  vbox.appendChild(label);

  box6.appendChild(vbox);
  box4.appendChild(box6);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '32px');
  box4.appendChild(spacer);

  box3.appendChild(box4);

  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Defined instances:');
  vbox.appendChild(label);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Active instances:');
  vbox.appendChild(label);
  box4.appendChild(vbox);

  var nodes = current.findNodesIn('cloudprovider', provider.get('uniqueKey'));
  var nodesup = 0;
  for(var i = 0; i < nodes.length; i++) {
    if(nodes[i].status && nodes[i].status.status == 'UP') nodesup++;
  }
  
  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  label.setAttribute('value', nodes.length);
  vbox.appendChild(label);
  
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  label.setAttribute('value', nodesup);
  vbox.appendChild(label);

  box4.appendChild(vbox);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '32px');
  box4.appendChild(spacer);

  box3.appendChild(box4);
  
  var box2 = document.createElement('hbox');
  box2.setAttribute('align', 'center');
  box2.setAttribute('class', 'clusterbottom');
  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '3px');
  box2.appendChild(spacer);

  var button = document.createElement('button');
  button.setAttribute('tooltiptext', 'Edit');
  button.setAttribute('class', 'editcluster-button');
  button.setAttribute('oncommand', 'editProvider(' + provider.get('uniqueKey') + ');'); // TODO-CLOUD
  box2.appendChild(button);

  var button = document.createElement('button');
  button.setAttribute('tooltiptext', 'Delete');
  button.setAttribute('class', 'removecluster-button');
  button.setAttribute('oncommand', 'removeProvider(' + provider.get('uniqueKey') + ');'); // TODO-CLOUD
  box2.appendChild(button);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('flex', '1');
  box2.appendChild(spacer);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '5px');
  box2.appendChild(spacer);

  box.appendChild(box3);
  box.appendChild(box2);
  return box;
}

function addProviderItem() {
  var box = document.createElement('vbox');
  box.setAttribute('class', 'staticdatasmall');
  box.setAttribute('pack', 'center');
  var box2 = document.createElement('hbox');
  box2.setAttribute('align', 'center');
  var button = document.createElement('button');
  button.setAttribute('class', 'addcluster-button');
  button.setAttribute('oncommand', 'add();');
  box2.appendChild(button);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Add a new cloud account');
  box2.appendChild(label);

  box.appendChild(box2);
  return box;
}

function add() {
  var args = new Object();
  args['cluster'] = current;
  args['object'] = 0;
  var d = new dock.cvDialog("chrome://cmgui/content/cloud/setup/clusterExtensionWizard.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}

function editProvider(key) {
  var args = new Object();
  args['cluster'] = current;
  args['object'] = key;
  var d = new dock.cvDialog("editcloudprovider.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}

function removeProvider(key) {
  var args = new Object();
  args['question'] = "Are you sure you want to remove this cloud provider?";
  var provider = current.find(key);
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    current.removeObject(key);
    refresh();
  }
  dock.dialogs.showDialog(d);
}
