/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'CloudPrivateCloud';
var subfield = 'privateClouds';
var singular = 'Private cloud';
var plural = 'Private clouds';
var editfile = 'editprivatecloud.xul';

function postrefresh(use) {
  if(!!use) current = use;
  var list = current.get(subfield);
  var modified = current.get('modified');
  if(modified) {
    document.getElementById('savevpc').removeAttribute('disabled');
  } else {
    document.getElementById('savevpc').setAttribute('disabled', true);
  }
}

function createTreeItem(one, i) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['modified'] = one.modified;
  item['name'] = one.name;
  item['vpcID'] = one.vpcID;
  item['mainRouteTable'] = one.mainRouteTable;
  item['defaultACL'] = one.defaultACL;
  item['internetGatewayID'] = one.internetGatewayID;
  var region = current.cluster.find(one.region);
  var regionName = '';
  if (region) {
    regionName = region.resolveName();
  }
  item['region'] = regionName;
  var subNets = new Array();
  for (var j = 0; j < one.subnets.length; j++) {
    var subName = '';
    var sub = current.cluster.find(one.subnets[j]);
    if (sub) {
      subName = sub.resolveName();
      subNets.push(subName);
    }
  }
  item['subnets'] = subNets.join();
  item['baseAddress'] = one.baseAddress;
  item['netmaskBits'] = one.netmaskBits;
  item['securityGroupNode'] = one.securityGroupNode;
  item['securityGroupDirector'] = one.securityGroupDirector;
  return item;
}

function save() {
  var subnetsToCommit = new Array();

  var privateClouds = current.get(subfield);
  for (var i = 0; i < privateClouds.length; i++) {
    if (privateClouds[i].modified) {
      var subnets = privateClouds[i].subnets;
      for (var j = 0; j < subnets.length; j++) {
        var subnet = current.cluster.find(subnets[j]);
        if (subnet && subnet.get('modified')) {
          subnetsToCommit.push(subnets[j]);
        }
      }
    }
  }

  println('tocommit' + subnetsToCommit.length); // FIXME

  // some closures and recursive functions to commit subnets and the current object as last one
  function finalCommit() {
    current.commit();
  }

  function commitChain(i) {
    if (i == -1) {
      finalCommit();
    } else {
      function commitStep() {
        commitChain(i - 1);
      }
      var sub = current.cluster.find(subnetsToCommit[i]);
      sub.commit(0, commitStep, false);
    }
  }

  if (subnetsToCommit.length == 0) {
    current.commit();
  } else if (subnetsToCommit.length == 1) {
    var sub = current.cluster.find(subnetsToCommit[0]);
    sub.commit(0, finalCommit, false);
  } else {
    commitChain(subnetsToCommit.length - 1);
  }

  if(current.object.uniqueKey < dock.MAX_LOCAL_KEY) {
    document.getElementById('revert').setAttribute('disabled', true);
  } else {
    document.getElementById('revert').removeAttribute('disabled');
  }
}

