/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'VirtalNode';
var singular = 'virtual node';
var plural = 'virtual nodes';

// TODO-CLOUD: correct code?
function specialrefresh() {
  println('Refresh ' + singular + ' storage');
  tree = document.getElementById('tree');
  var list = new Array();
  var p = 'v';
  var n = 42;
  for(var i = 1; i <= n; i++) {
    var one = new Object();
    one['key'] = 0;
    one['id'] = 'vol-' + Math.floor(100000 + Math.random() * 900000);
    one['type'] = 'EBS';
    one['size'] = '42GB';
    one['attached'] = p + 'node' + sprintf("%03d", i) + ' (/dev/sda)';
    one['get'] = function(name) { return this[name]; }
    list.push(one);
    if((((i + 5) % 7 == 0) || ((i + 1) % 5 == 0) || ((i + 7) % 8 == 0))) {
      var one = new Object();
      one['key'] = 0;
      one['id'] = 'ephemeral0';
      one['type'] = 'instance-store';
      one['size'] = '1690 GB';
      one['attached'] = p + 'node' + sprintf("%03d", i) + ' (/dev/sdb)';
      one['get'] = function(name) { return this[name]; }
      list.push(one);
    }
  }
  data = new Array();
  var modified = false;
  for(var i = 0; i < list.length; i++) {
    if(!list[i].get('toBeRemoved') || alsoRemoved) {
      data.push(createTreeItem(list[i]));
      modified = modified || list[i].get('modified') || list[i].get('toBeRemoved');
    } else {
      modified = true;
    }
  }
  for(var i = list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);

  if(modified) {
    document.getElementById('save').removeAttribute('disabled');
  } else {
    document.getElementById('save').setAttribute('disabled', true);
  }
  return true;
}

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.get('uniqueKey');
  item['modified'] = one.get('modified');
  item['id'] = one.get('id');
  item['type'] = one.get('type');
  item['size'] = one.get('size');
  item['attached'] = one.get('attached');
  return item;
}

function addObject() {
  var args = new Object();
  args['title'] = 'Add new ' + singular;
  args['question'] = 'Hostname';
  args['known'] = current.known('Device', 'hostname');
  args['default'] = 'vsmp';
  var d = new dock.cvDialog("newobject.xul", args);
  d.onOk = function(name) {
    var object = new dock.cvVirtualNode();
    object.hostname = name;
    var base = current.getBasePartition();
    if(isObject(base)) {
      object.partition = base.object.uniqueKey;
      object.category = base.object.defaultCategory;
    }
    current.addObject(object, dock.openAfterCreate);
    refresh();
  }
  dock.dialogs.showDialog(d);
}

function cloneObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a " + singular + " for cloning");
  } else if(select.length > 1) {
    dock.displayError("Please select only one " + singular);
  } else {
    var original = current.find(select[0]);
    if(isObject(original)) {
      var args = new Object();
      var host = original.get('hostname');
      args['title'] = 'Clone ' + host;
      args['question'] = 'Hostname';
      var nn = nameNumber(host);
      if(nn[1].length == 0) nn[1] = '0';
      var name;
      var index = myParseInt(nn[1]);
      while(true) {
        index++;
        name = nn[0] + sprintf('%0' + nn[1].length + 'd', index);
        if(!current.find('Device', name)) break;
      }
      args['default'] = name;
      args['known'] = current.known('Device', 'hostname');
      var d = new dock.cvDialog("newobject.xul", args);
      d.onOk = function(name) {
        var object = original.clone();
        object.modified = true;
        object.toBeRemoved = false;
        object.hostname = name;
        object.mac = '00:00:00:00:00:00';
        object.tag = '00000000a000';
        object.ethernetSwitch = new dock.cvSwitchPort();
        object.powerDistributionUnits = new Array();
        cloneNodeIP(original.object, object);
        current.addObject(object, dock.openAfterCreate);
        refresh();
      }
      dock.dialogs.showDialog(d);
    } else {
      dock.displayError("Original not found, already removed by someone else");
    }
  }
}

function createWizard() {
  var args = new Object();
  args['cluster'] = current;
  args['basetype'] = basetype;
  var d = new dock.cvDialog("nodewizard.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
