/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;

function onLoad() {
  dock = getDock();
}

function refresh() {
  println("Cluster overview refresh");
  var box = document.getElementById('clusters');
  while(box.firstChild) box.removeChild(box.firstChild);
  for(var i = 0; i < dock.clusterlist.length; i++) {
    if((dock.clusterlist[i].certificate.length == 0) && (dock.generalSettings.showAllBrightVersions || (dock.clusterlist[i].brightVersion == '') || (dock.clusterlist[i].brightVersion == dock.brightVersion))) {
      box.appendChild(clusterItem(dock.clusterlist[i]));
    }
  }
  box.appendChild(addClusterItem());
}

function clusterItem(cluster) {
  var box = document.createElement('vbox');
  var box3 = document.createElement('vbox');
  box3.setAttribute('flex', '1');
  box3.setAttribute('class', 'clustertop');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustercaption');
  if(cluster.name) {
    label.setAttribute('value', cluster.name);
  } else {
    label.setAttribute('value', 'The name of the cluster will be retrieved on first connection');
  }
  box3.appendChild(label);
  var line = document.createElement('hbox');
  line.setAttribute('class', 'staticdottedline');
  box3.appendChild(line);

  var box4 = document.createElement('hbox');
  box3.setAttribute('style', 'padding: 12px;');
  box4.setAttribute('style', 'margin-left: 2px;');
  var box5 = document.createElement('vbox');
  box5.setAttribute('align', 'center');
  var image = document.createElement('image');
  image.setAttribute('src', 'chrome://cmgui/content/icons/Cluster_32.png');
  box5.appendChild(image);
  box4.appendChild(box5);

  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Modified:');
  vbox.appendChild(label);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Connected:');
  vbox.appendChild(label);
  box4.appendChild(vbox);

  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  var list = cluster.modified();
  if(list.length > 0) {
    label.setAttribute('value', 'Yes');
  } else {
    label.setAttribute('value', 'No');
  }
  vbox.appendChild(label);

  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  if(cluster.connected) {
    label.setAttribute('value', 'Yes');
  } else {
    label.setAttribute('value', 'No');
  }
  vbox.appendChild(label);
  box4.appendChild(vbox);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '32px');
  box4.appendChild(spacer);

  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Host:');
  vbox.appendChild(label);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
//   if(cluster.certificate.length == 0) {
  label.setAttribute('value', 'Username:');
//   } else {
//     label.setAttribute('value', 'Certificate:');
//   }
  vbox.appendChild(label);
  box4.appendChild(vbox);

  var vbox = document.createElement('vbox');
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  label.setAttribute('value', cluster.host + ':' + cluster.port);
  vbox.appendChild(label);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clustervalue');
  if(cluster.certificate.length == 0) {
    label.setAttribute('value', cluster.username);
  } else {
    label.setAttribute('value', cluster.certificate);
  }
  vbox.appendChild(label);

  box4.appendChild(vbox);


  box3.appendChild(box4);

  var box2 = document.createElement('hbox');
  box2.setAttribute('align', 'center');
  box2.setAttribute('class', 'clusterbottom');
  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '3px');
  box2.appendChild(spacer);

  var button = document.createElement('button');
  if(cluster.connected) {
    button.setAttribute('class', 'disconnect-button');
    button.setAttribute('tooltiptext', 'Disconnect');
    button.setAttribute('oncommand', 'disconnect(' + cluster.key + ');');
  } else {
    button.setAttribute('class', 'connect-button');
    button.setAttribute('tooltiptext', 'Connect');
    button.setAttribute('oncommand', 'connect(' + cluster.key + ');');
  }
  box2.appendChild(button);

  var button = document.createElement('button');
  button.setAttribute('tooltiptext', 'Edit');
  button.setAttribute('class', 'editcluster-button');
  button.setAttribute('oncommand', 'editCluster(' + cluster.key + ');');
  box2.appendChild(button);

  var button = document.createElement('button');
  button.setAttribute('tooltiptext', 'Delete');
  button.setAttribute('class', 'removecluster-button');
  button.setAttribute('oncommand', 'removeCluster(' + cluster.key + ');');
  box2.appendChild(button);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('flex', '1');
  box2.appendChild(spacer);

  var box5 = document.createElement('vbox');
  box5.setAttribute('align', 'center');
  var image = document.createElement('image');
  if(cluster.connected) {
    image.setAttribute('src', './skin/image/LED_green.png');
  } else {
    image.setAttribute('src', './skin/image/LED_red.png');
  }
  box5.appendChild(image);
  box2.appendChild(box5);

  var spacer = document.createElement('spacer');
  spacer.setAttribute('width', '5px');
  box2.appendChild(spacer);

  box.appendChild(box3);
  box.appendChild(box2);
  return box;
}

function addClusterItem() {
  var box = document.createElement('vbox');
  box.setAttribute('class', 'staticdatasmall');
  box.setAttribute('pack', 'center');
  var box2 = document.createElement('hbox');
  box2.setAttribute('align', 'center');
  var button = document.createElement('button');
  button.setAttribute('class', 'addcluster-button');
  button.setAttribute('oncommand', 'add();');
  box2.appendChild(button);
  var label = document.createElement('shadowlabel');
  label.setAttribute('class', 'clusterproperty');
  label.setAttribute('value', 'Add a new cluster');
  box2.appendChild(label);

  box.appendChild(box2);
  return box;
}

function add() {
  var args = new Object();
  args['cluster'] = 0;
  var d = new dock.cvDialog("editcluster.xul", args);
  d.onOk = function() {
    refresh();
    dock.saveClusters();
  }
  dock.dialogs.showDialog(d);
}

function editCluster(key) {
  var args = new Object();
  args['cluster'] = dock.matchCluster(key);
  var d = new dock.cvDialog("editcluster.xul", args);
  d.onOk = function() {
    refresh();
    dock.saveClusters();
  }
  dock.dialogs.showDialog(d);
}

function removeCluster(key) {
  var cluster = dock.matchCluster(key);
  if(cluster.connected) {
    dock.displayInfo("Disconnect form this cluster before deleting it");
  } else {
    var args = new Object();
    args['question'] = "Are you sure you want to remove this cluster preference?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      dock.removeCluster(cluster);
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function connect(key) {
  var cluster = dock.matchCluster(key);
  if(cluster.connect()) {
    dock.saveClusters();
    refresh();
  }
}

function disconnect(key) {
  var cluster = dock.matchCluster(key);
  if(cluster.disconnect()) refresh();
}
