/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var health = 0;
var oldcluster = 0;

var page = 1;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  addEventListener("resize", onResize, false);
}

function onResize() {
  var svg = document.getElementById("svg");
  svg.setAttribute("height", "25px");
  svg.setAttribute("width", svg.parentNode.boxObject.width);
  svg.setAttribute("height", svg.parentNode.boxObject.height);
  update();
}

function refresh(use) {
  println("Refresh cluster healthview" + ' - ' + document.documentURI);
  if(!!use) {
    var monconf = use.find(dock.ALL_MASTERNODES);
    if(!monconf) return;
    current = use;
    if(!health || (oldcluster != current) || current.updateHealth) {
      current.updateHealth = false;
      var devices = current.allKeys('Device');
//       if((devices.length < dock.generalSettings.maxHealthNodes) || (current.healthDeviceSelection && isArray(current.healthDeviceSelection) && (current.healthDeviceSelection.length < dock.generalSettings.maxHealthNodes))) {
        var oldhealth = health;
        health = new cvHealth(current, document.getElementById("svg"), document.getElementById("box"), devices, document.getElementById("starttime"), document.getElementById("endtime"), document.getElementById("topinfo"));
        health.clearScreen();
        if(!!oldhealth) {
          health.period = oldhealth.period;
          health.alertParam = oldhealth.alertParam;
          health.sort = oldhealth.sort;
        }
        if(document.getElementById('healthdeck').selectedIndex > 1) {
          if(health.period == 0) {
            document.getElementById('healthdeck').selectedIndex = 0;
            document.getElementById('legend').setAttribute('hidden', true);
          } else {
            document.getElementById('healthdeck').selectedIndex = 1;
            document.getElementById('infodeck').selectedIndex = 1;
            document.getElementById('svgheader').removeAttribute('hidden');
            document.getElementById('legend').removeAttribute('hidden');
          }
        }
        var item = document.getElementById('perpage').parentNode.selectedItem;
        if(item) health.pages(parseInt(item.getAttribute('page')));
        var item = document.getElementById('pages').parentNode.selectedItem;
        if(item) health.page = parseInt(item.getAttribute('page'));
        health.setDeviceSelection(current.healthDeviceSelection);        
        health.start();
//       } else {
//         println('Too many nodes for health');
//         document.getElementById('toomany').setAttribute('value', 'Too many devices defined, ' + devices.length + ' > ' + dock.generalSettings.maxHealthNodes + '. Increasing this number ($HOME:/.cm/cmgui/cmgui.settings) may result in an unusable cmgui.');
//         document.getElementById('healthdeck').selectedIndex = 2;        
//         document.getElementById('legend').setAttribute('hidden', true);
//       }
    } else {
      health.setDeviceSelection(current.healthDeviceSelection);
    }
    oldcluster = current;
  } else if(health) {
    health.setDeviceSelection(current.healthDeviceSelection);
  }
  update();
}

function sortBy(event) {
  var item = event.target;
  var sorting = parseInt(item.getAttribute('sort'));
  if(!!health) {
    health.sort = sorting;
    if(health.period == 0) {
      health.update(2);
    } else {
      health.update(0);
    }
  }
}

function setParam(event) {
  var item = event.target;
  var param = item.getAttribute('param');
  if(!!health) {
    health.alertParam = param;
    health.update(2);
  }
}

function setPeriod(event) {
  var item = event.target;
  var time = parseInt(item.getAttribute('time'));
  if(time == 0) {
    document.getElementById('legend').setAttribute('hidden', true);
    document.getElementById('svgbox').setAttribute('hidden', true);
    document.getElementById('svgheader').setAttribute('hidden', true);
    document.getElementById('healthdeck').selectedIndex = 0;
  } else {
    document.getElementById('legend').removeAttribute('hidden');
    document.getElementById('svgbox').removeAttribute('hidden');
    document.getElementById('svgheader').removeAttribute('hidden');
    document.getElementById('healthdeck').selectedIndex = 1;
  }
  if(!!health) {
    health.period = time;
    health.update(2);
  }
}

function update() {
  if(!!health) health.update();
}

function stop() {
  if(!!health) health.stop();
}

function opendevice(key) {
  current.select(key);
}

function showdetails(key) {
  var args = new Object();
  args['cluster'] = current;
  args['current'] = key;
  var d = new dock.cvDialog("healthstatus.xul", args);
  dock.dialogs.show(d);  
}

function selectDevices() {
  var args = new Object();
  args['cluster'] = current;
  args['subtype'] = 'Device';
  if(current.healthDeviceSelection) args['selection'] = current.healthDeviceSelection;
  var d = new dock.cvDialog("deviceselection.xul", args);
  d.apply = function(nodes) {
    if(nodes.length) {
      current.healthDeviceSelection = nodes;
    } else {
      current.healthDeviceSelection = 0;
    }
    health.setDeviceSelection(current.healthDeviceSelection);
    health.update();
  }
  dock.dialogs.show(d);  
}

function createPageMenu(n) {
  var pages = document.getElementById("pages");
  var m = pages.childNodes.length;
  for(var i = n; i < m; i++) pages.removeChild(pages.lastChild);
  for(var i = m + 1; i <= n; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('page', i);
    item.setAttribute('label', i);
    pages.appendChild(item);
  }
}

function updatePageMenu(page) {
  var pages = document.getElementById("pages");
  pages.parentNode.selectedIndex = page - 1;
}

function setPage(index) {
//   println("setPage " + index + " [1," + health.pages() + "]");
  if((index >= 1) && (index <= health.pages())) {
    page = index;
    health.displayPage(page);
  }
}

function perpagemenu(event) {
  var perpage = parseInt(event.target.getAttribute('page'));
  if(perpage != health.perPage) {
    var old = health.perPage * (health.page - 1);
    var n = health.pages(perpage);
    health.displayPage(Math.min(1 + Math.floor(old / perpage), n));
    createPageMenu(n);
  }
}

function pagemenu(event) {
  setPage(parseInt(event.target.getAttribute('page')));
}

function pagetop() {
  setPage(1);
}

function pagebottom() {
  setPage(health.pages());
}

function pageup() {
  setPage(page - 1)
}

function pagedown() {
  setPage(page + 1);
}
