/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function formatBurst(n) {
  if(n < 0) {
    return 'N/A';
  } else {
    return '' + n;
  }
}

function formatExtensions(n) {
  if(n < 0) {
    return '0';
  } else if(n == 0) {
    return 'All';
  } else {
    return '' + n;
  }
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh cluster license" + ' - ' + document.documentURI);

  dock.workerpool.getWorker(current.actualurl).call('cmmain', 'getLicenseInfo', null, function(code, data) {
      if(code == 0) {
        overview = data;
        overviewValue('macAddress');
        overviewValue('licensedNodes');
//         overviewValue('licensedGPUs');
        overviewValue('licensedBurstNodes', formatBurst(overview.licensedBurstNodes));
//         overviewValue('licensedBurstGPUs', formatBurst(overview.licensedBurstGPUs));
        overviewValue('nodeCount');
        overviewValue('burstNodeCount');
        var obj = document.getElementById('burstNodeCountRow');
        obj.setAttribute('hidden', (overview.burstNodeCount <= 0));
        overviewValue('version');
        overviewValue('edition');
        overviewValue('startTime', formatDate(overview.startTime));
        overviewValue('endTime', formatDate(overview.endTime));
        overviewValue('serial');
        overviewValue('licensee');
        overviewValue('licensedHadoopNodes', formatExtensions(overview.licensedHadoopNodes));
        overviewValue('licensedOpenStackNodes', formatExtensions(overview.licensedOpenStackNodes));
        overviewValue('hadoopNodeCount');
        overviewValue('openStackNodeCount');
//         if(overview.licensee.indexOf('Aramco') > 0) {
//           this.current.isKickStart = true;
//           println("Enable kickstart");
//         }
        this.current.setLicenseInfo(overview);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
  
  dock.workerpool.getWorker(current.actualurl).call('cmmain', 'getVersion', null, function(code, data) {
      if(code == 0) {
        overview = data;
        overviewValue('cmVersion');
        overviewValue('cmdaemonVersion');
        overviewValue('cmdaemonBuild');
        overviewValue('databaseVersion');
        this.current.versionInfo = overview;
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}
