/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var topview = 0;
var rack = 0;
var oldcluster = 0;
var first = true;

// var TOPTEST = true;
var TOPTEST = false;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);

  addEventListener("resize", resize, false);
}

function resize() {
  if(rack) rack.resize();
}

function refresh(use) {
  println("Refresh cluster rackview" + ' - ' + document.documentURI);
  if(!!use) {
    var monconf = use.find(dock.ALL_MASTERNODES);
    if(!monconf) {
      var legend = document.getElementById('legend');
      while(legend.firstChild) legend.removeChild(legend.firstChild);

      if(first) {
        first = false;
        dock.displayInfo('No monitoring configuration, most likely because cmdaemon is running with the -M option');
      }
      
      document.getElementById('setup').setAttribute('disabled', true);
    } else {
      document.getElementById('refresh').removeAttribute('disabled');
      document.getElementById('setup').removeAttribute('disabled');
    }

    current = use;
    if(!rack || (oldcluster != current) || current.updateRack) {
      current.updateRack = false;
      dock.rackBlinkKey = new Array();
      var oldZoom = 0;
      var oldMetric = 0
      var oldFill = true;
      if(rack) {
        oldZoom = rack.zoom;
        oldMetric = rack.metrics;
        oldFill = rack.fillNoData
      }
      rack = new RackView(current);
      if(TOPTEST) rack.viewMode = 1;
      if(current.healthDeviceSelection) rack.setDeviceSelection(current.healthDeviceSelection);
      current.rack = rack;
      rack.clearScreen();
      rack.zoom = oldZoom;
      rack.fillNoData = oldFill;
      if(oldMetric) rack.metrics = oldMetric;
      rack.init();
      var item = document.getElementById('racksize').selectedItem;
      var size = parseInt(item.getAttribute('size'));;
      var padding = parseInt(item.getAttribute('padding'));
      if(TOPTEST) {
        rack.drawTop(size, padding);        
      } else {
        rack.draw(size, padding);
      }
      rack.forceRedraw = false;
    }
    oldcluster = current;
  }
  update();
}

function update() {
  if(rack) {
    if(rack.forceRedraw || current.updateRack) {
      println('Refresh rack reinit');
      rack.init();
      var item = document.getElementById('racksize').selectedItem;
      var size = parseInt(item.getAttribute('size'));;
      var padding = parseInt(item.getAttribute('padding'));
      if(TOPTEST) {
        rack.drawTop(size, padding);
      } else {
        rack.draw(size, padding);
      }
      rack.forceRedraw = false;
      current.updateRack = false;
    }
    if(TOPTEST) {
      rack.refreshTop();
    } else {
      rack.refresh();
    }
  }
}

function stop() {
  println(" +++ STOP rack");
  if(rack) rack.stop();
}

function setZoom(value) { // BIG == 0
  document.getElementById('rackzoomout').setAttribute('disabled', value != 0);
  document.getElementById('rackzoomin').setAttribute('disabled', value == 0);
  if(value == 0) {
    rack.size = 16;
    rack.padding = 4;
  } else {
    rack.size = 8;
    rack.padding = 0;
  }
  rack.clear();
  rack.start(true);
}

function setSize(event) {
  var item = event.target;
  rack.clear();
  rack.size = parseInt(item.getAttribute('size'));;
  rack.padding = parseInt(item.getAttribute('padding'));
  rack.forceRedraw = true;
  if(TOPTEST) {
    rack.startTop(true);
    rack.refreshTop();
  } else {
    rack.start(true);
    rack.refresh();
  }
}

function setup() {
  var file = "racksetup.xul";
  var old = dock.dialogs.find(file);
  if(old) {
    if(!old.closed) {
      dock.displayError("A rack setup window is already open", window);
      return;
    }
  }
  var args = new Object();
  args['topview'] = topview;
  args['rack'] = rack;
  var d = new dock.cvDialog(file, args);
  d.parentWindow = window;
  d.apply = function() {
    dock.saveClusters();
  }
  dock.dialogs.show(d);
}

function opendevice(key) {
  current.select(key);
}

function selectDevices() {
  var args = new Object();
  args['cluster'] = current;
  args['subtype'] = 'Device';
  var old;
  var allOld = false;
  if(current.rackDeviceSelection) {
    old = current.rackDeviceSelection.slice();
    args['selection'] = current.rackDeviceSelection;
  } else {
    allOld = true;
    old = new Array();
  }
  var d = new dock.cvDialog("deviceselection.xul", args);
  d.apply = function(nodes) {
    var allNew = false;
    if(nodes.length) {
      current.rackDeviceSelection = nodes;
      old = old.concat(nodes);
    } else {
      current.rackDeviceSelection = 0;
      allNew = true;
    }
    rack.setDeviceSelection(current.rackDeviceSelection);
    rack.updateSelected(old, allOld, allNew);
    // RESET OLD!!
    allOld = false;
    if(current.rackDeviceSelection) {
      old = current.rackDeviceSelection.slice();
    } else {
      allOld = true;
      old = new Array();
    }
  }
  dock.dialogs.show(d);  
}
