/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var MAX_STATE_HISTORY = 5;
var STATE_TIME = 2500;

var currentTab;
var stateHistory = new Array();
var stateTimer = 0;
var refreshTimer = 0;
var refreshTimerCount = 0;
var dock;

/* Menu Handlers */
function cmgui_file_error_console() {
  window.open("chrome://global/content/console.xul", "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
}

function cmgui_extensions() {
  window.openDialog("chrome://mozapps/content/extensions/extensions.xul", "", "chrome,dialog=no,resizable=yes");
}

function cmgui_dom() {
  var windowDS = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"].getService(Components.interfaces.nsIWindowDataSource);
  var tmpNameSpace = {};                         
  var sl = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Components.interfaces.mozIJSSubScriptLoader);
  sl.loadSubScript("chrome://inspector/content/hooks.js", tmpNameSpace);
  tmpNameSpace.inspectDOMDocument(document);
}

function cmgui_testjson() {
  testjson();
}

function cmgui_file_exit() {
  if(generalSettings.quietQuit) {
    onclose();
    window.setTimeout('close();', 1);
  } else {
    var args = new Object();
    args['question'] = 'Are you sure you want to quit?';
    args['check'] = "Don't ask again";
    args['checked'] = generalSettings.quietQuit;
    var d = new cvDialog("question.xul", args);
    d.onOk = function(quiet) {
      generalSettings.quietQuit = quiet;
      onclose();
      waitIcon();
      window.setTimeout('close();', 1);
    }
    dialogs.showDialog(d);
  }
}

function cmgui_chat() {
}

function resetPages() {
  var dock = document.getElementById("tabdeck");
  var child = dock.firstChild;
  while(child) {
    if(!!child.contentWindow.clearPanels) {
      child.contentWindow.clearPanels();
    }
    child = child.nextSibling;
    mainthread.processNextEvent(true);
  }
  loadPages();
}

function loadPages() { // TODO
  println("+++ loadPages +++ doesn't work properly yet +++");
  return;
  
  var dock = document.getElementById("tabdeck");
  var child = dock.firstChild;
  while(child) {
    if(!!child.contentWindow.loadPanels) {
      child.contentWindow.loadPanels();
    }
    child = child.nextSibling;
    mainthread.processNextEvent(true);
  }
}

function collapseTree(level) {
  var tree = document.getElementById("treecluster");
  var view = tree.view;

  var list = new Array();
  var n = view.selection.getRangeCount();
  if(n > 0) {
    var start = new Object();
    var end = new Object();
    view.selection.getRangeAt(n - 1, start, end);
    var selected = parseInt(end.value);
    while(selected >= 0) {
      list.push(selected);
      selected = view.getParentIndex(selected);
    }
  }

  var index = view.rowCount - 1;
  while(index >= 0) {
    if(view.isContainer(index) && view.isContainerOpen(index) && (view.getLevel(index) == level)) {
      tree.view.toggleOpenState(index);
      if(list.find(index) >= 0) view.selection.select(index);
      if(index >= view.rowCount) {
        index = view.rowCount - 1;
      } else {
        index--;
      }
    } else {
      index--;
    }
  }

  if(n <= 0) view.selection.select(0);
}

function cmgui_settings() {
  var args = new Object();
  var d = new cvDialog("settingwindow.xul", args);
  dialogs.showDialog(d);
}


function myappQuitApplication() {
  var Cc = Components.classes;
  var Ci = Components.interfaces;

  var appStartup = Cc['@mozilla.org/toolkit/app-startup;1'].getService(Ci.nsIAppStartup);
  appStartup.quit(Ci.nsIAppStartup.eAttemptQuit);
  
  return true;
}

function cmgui_support_submit_new_problem_report() {
  alert("This should pop up a window where admin can submit a ticket. There is a web-browser component in XUL, so we could just pop up a web-browser to a support web-page.");
}

function cmgui_support_track_problem_reports() {
  alert("This will give admin overview of all open tickets including status information and all correspondence. Admin will be able to submit new information to existing tickets. Again, this could be accomplished through a web-page, so that it works the same way outside of cmgui interface.");
}

function cmgui_support_call_support() {
  alert("First pop up dialog \"Is this an emergency? Yes/No\", then open some sort of instant-messaging or Skype voice connection with technical support");
}

function cmgui_help_help_contents() {

}

function cmgui_help_check_for_updates() {
  alert("Check for updates to cmgui and automatically install them");
}

function cmgui_help_about() {
  var d = new cvDialog("about.xul", new Object());
  dialogs.showDialog(d);
}

function cmgui_support() {
  var args = new Object();
  if(currentObject && currentObject.cluster) {
    args.cluster = currentObject.cluster;
  } else {
    args.cluster = currentObject;
  }
  var d = new cvDialog("support.xul", args);
  dialogs.showDialog(d);
}

function showListOfChanges() {
  var d = new cvDialog("changelist.xul", new Object());
  dialogs.show(d);
}

function showDrillDown() {
  var d = new cvDialog("drilldown.xul", new Object());
  dialogs.show(d);
}

function showTaskManager() {
  var old = dialogs.find("taskmanager.xul");
  if(old) {
    old.focus();
  } else {
    var d = new cvDialog("taskmanager.xul", new Object());
    dialogs.show(d);
  }
}

/* This function is called upon start-up */
function startup() {
  globalinit();
  setDefaults();
  println("Starting cmgui");
  dock = this;
  
  generalSettings.load();
  customMetricBounds.load();

  loadClusters();
  loadAckedEvents();
  loadEventFilters();
  loadEventViewers();
  removeOldPexec();
  initSSL();
  
  var tree = document.getElementById("treecluster");
  tree.view.selection.select(0);

  println(" +++ CL: " + clusterlist.length);
  if(checkLibVersion()) {
    for(var i = 0; i < clusterlist.length; i++) {
      if(clusterlist[i].autoconnect && ((clusterlist[i].brightVersion == '') || (clusterlist[i].brightVersion == dock.brightVersion))) {
        println("Connect");
        if(clusterlist[i].connect()) {
          // DO NOTHING: threaded
/*          println("Select");
          clusterlist[i].select(); // TODO: select the one we want*/
        }
      }
    }
    openViewers();
  }
  addOldCloneCommands();
  loadBookmark();
  
  if(!checkDump()) {
    println("Hide debug menu");
    var menudebug = document.getElementById("menudebug");
    menudebug.setAttribute('hidden', true);
  }
  
  var splash = window.opener;
  if(splash && !splash.closed) splash.close();
  
  loadPages();
}

function showMonitoring(url) {
  var cluster = findObject(url);
  if(!!cluster) {
    dock.waitIcon();
    var args = new Object();
    args['cluster'] = cluster;
    var mon = new cvDialog("monitoring.xul", args);
    dialogs.show(mon);
    dock.unwaitIcon();
  } else {
    displayError("Cluster not found");
  }
}

var CMD_FILTER_REVISION = 20902;
function showFilter(url) {
  var cluster = findObject(url);
  if(!!cluster) {
    if(parseInt(cluster.versionInfo.cmdaemonBuild) < CMD_FILTER_REVISION) {
      displayInfo("Please upgrade your cluster head node cmdaemon to revision " + CMD_FILTER_REVISION + " or above to get monitoring filter support");
    } else {
      dock.waitIcon();
      var args = new Object();
      args['cluster'] = cluster;
      var mon = new cvDialog("detachedmonitoringfiltertab.xul", args);
      dialogs.show(mon);
      dock.unwaitIcon();
    }
  } else {
    displayError("Cluster not found");
  }
}

/* This function is called when the main window is closed */
function onclose() {
  println("Saving settings");
  generalSettings.save();
  saveEventFilters();
  saveEventViewers();
  saveAckedEvents();
  saveClusters();
  dialogs.close();
  closeAllEventViewers();
  println("Close all connections");
  for(var i = 0; i < clusterlist.length; i++) {
    if(clusterlist[i].connected) {
      clusterlist[i].disconnect(true);
    }
  }
  println("Clean up SSL");
  cleanupSSL();
  removeOldPexec();
  return true;
}

function selectSingle(type, currentid, label, image, page) {
  page = isundefined(page, '');
  currentId = currentid;
  var deck = document.getElementById("tabdeck");
  var tab = document.getElementById(type.toLowerCase() + 'tab');
  if(!!tab) {
    if(!!currentTab) currentTab.contentWindow.stop();
    if(tab != currentTab) currentTab = tab;
    deck.selectedIndex = tab.getAttribute('index');
    document.getElementById("myclusters").setAttribute('src', 'chrome://cmgui/content/icons/ClusterManager16.png');
    if(endswith(type, "Folder")) {
      if(currentid == "") { //
        image = image.replace("16", "32");
        currentObject = 0;
        document.getElementById("titleimage").setAttribute('src', image);
        document.getElementById("titlename").setAttribute('value', "Welcome to Bright Cluster Manager");
        document.getElementById("titlecluster").setAttribute('value', '');
        document.getElementById("smalltitleimage").setAttribute('src', '');
        document.getElementById("myclusters").setAttribute('src', 'chrome://cmgui/content/icons/ClusterManager16_2.png');
      } else {
        var url = parseUrl(currentid);
        currentObject = matchCluster(url[1], url[2]);
        image = image.replace("16", "32");
        document.getElementById("titleimage").setAttribute('src', image);
        document.getElementById("titlecluster").setAttribute('value', currentObject.name);
        document.getElementById("titlename").setAttribute('value', label);
        document.getElementById("smalltitleimage").setAttribute('src', 'chrome://cmgui/content/icons/Cluster_16.png');
      }
    } else if(endswith(type, "Setup")) {
      var url = parseUrl(currentid);
      currentObject = matchCluster(url[1], url[2]);
      var img = type.indexOf("Setup");
      img = type.substr(0, img) + "_32.png";
      document.getElementById("titleimage").setAttribute('src', 'chrome://cmgui/content/icons/' + img);
      document.getElementById("titlecluster").setAttribute('value', currentObject.name);
      document.getElementById("titlename").setAttribute('value', label);
      document.getElementById("smalltitleimage").setAttribute('src', 'chrome://cmgui/content/icons/Cluster_16.png');
    } else {
      currentObject = findObject(currentid);
      if(!isObject(currentObject)) {
        var tree = document.getElementById("treecluster");
        var view = tree.view;
        view.selection.select(0);
        currentTab.contentWindow.refresh();        
        displayError("Selected object no longer found, it was most likely deleted");
        return;
      }
      image = image.replace("16", "32");
      document.getElementById("titleimage").setAttribute('src', image);
      if(!!currentObject.cluster) {
        document.getElementById("smalltitleimage").setAttribute('src', 'chrome://cmgui/content/icons/Cluster_16.png');
        document.getElementById("titlecluster").setAttribute('value', currentObject.cluster.name);
        document.getElementById("titlename").setAttribute('value', currentObject.resolveName());
      } else {
        document.getElementById("smalltitleimage").setAttribute('src', '');
        document.getElementById("titlecluster").setAttribute('value', '');
        if(endswith(currentid, "Ceph")) {
          document.getElementById("titlename").setAttribute('value', 'Ceph');
        } else if(endswith(currentid, "IEEL")) {
          document.getElementById("titlename").setAttribute('value', "IEEL");
        } else {
          document.getElementById("titlename").setAttribute('value', currentObject.name);
        }
      }
    }
    tab.contentWindow.refresh(currentObject, page);
    refreshCurrentEventViewers();
  } else {
    println('Tab not found: ' + type);
  }
}

function hasBeenRefreshed(obj) {
  if(obj == currentObject) {
    currentTab.contentWindow.refresh();
  }
}

function setCurrentObject(obj) {
  currentObject = obj;
}

function modifiedFlagChanged(obj) {
  if(!!obj && !!obj.cluster) {
    var key = obj.get('uniqueKey');
    if((key > 0) && !!obj.cluster.objects[obj.get('uniqueKey')]) {
      if(obj == currentObject) {
        currentTab.contentWindow.setSave();
      } else {
        var type = obj.get('baseType');
        if(refreshTypesCheck(currentTab.id, type)) {
          timedOutRefresh();
        }
      }
      updateListOfChanges()
    }
  }
}

function timedOutRefresh(timeout) {
  timeout = isundefined(timeout, 1000);
  if(refreshTimer == 0) {
    refreshTimerCount = 1;
    refreshTimer = window.setTimeout('refreshTimeUp();', timeout);
    println("++++ Start refresh timer: " + timeout + " : " + refreshTimer);
  } else {
    refreshTimerCount++;
  }
}

function refreshTimeUp() {
  println("++++ Refresh timer UP: " + refreshTimerCount + " : " + refreshTimer);
  refreshTimer = 0;
  refreshTimerCount = 0;
  currentTab.contentWindow.refresh();
}

function clearRefreshTimer() {
  if(refreshTimer) {
    println("++++ Clear refresh timer: " + refreshTimer);
    window.clearTimeout(refreshTimer);
    refreshTimer = 0;
    refreshTimerCount = 0;
  }
}

function updateListOfChanges() {
  var clw = dock.dialogs.find("changelist.xul");
  if(dock.generalSettings.autoOpenChanges || clw) {
    if(clw) {
      if(typeof(clw.refresh) == 'function') {
        clw.refresh();
      } else {
        // TODO
      }
    } else {
      showListOfChanges();
    }
  }
}

function selectResource(event) {
  var tree = document.getElementById("treecluster");
  var selected = new Array();

  var start = new Object();
  var end = new Object();
  var firstProperty = 0;
  var message = '';
  for(var t = 0; t < tree.view.selection.getRangeCount(); t++){
    tree.view.selection.getRangeAt(t,start,end);
    for(var v = start.value; v <= end.value; v++) {
      var item = tree.view.getItemAtIndex(v);
      var prop = item.getAttribute("property");
      if((firstProperty == 0) || (firstProperty == prop)) {
        selected.push([prop, item.getAttribute("id"), item.getAttribute("title"), item.firstChild.firstChild.getAttribute("src")]);
        if(firstProperty == 0) firstProperty = prop;
      } else {
        message += item.getAttribute("title") + " is not of the same type as the first object selected first\n";
      }
    }
  }
  var currentid;
  if(selected.length == 1) {
    selectSingle(selected[0][0], selected[0][1], selected[0][2], selected[0][3]);
  } else if(selected.length > 1) { // TODO: multiple selection

  }
  if(message.length > 0) {
    displayError(message);
  }
}

/* EVENT BUTTONS */
function showEventviewer() {
  var splitter = document.getElementById("eventBoxSplitter");
  splitter.setAttribute('state', 'open');
}

function detachEvent() {
  var tabs = document.getElementById("eventTabs");
  var viewer = findViewer(tabs.selectedIndex);
  if(viewer) {
    viewer.detach();
    openViewers();
  }
}

function newEvent() {
  openNewEventViewer();
}

function clearEvent(event) {
  var tabs = document.getElementById("eventTabs");
  var viewer = findViewer(tabs.selectedIndex);
  if(viewer) {
    viewer.clearEvents(event.shiftKey);
  }
}

function filterEvent() {
  var tabs = document.getElementById("eventTabs");
  var viewer = findViewer(tabs.selectedIndex);
  if(viewer) {
    viewer.showFilter();
  }
}

function displayError(message, parentWindow, dialog, timeout, merge) {
  dialog = isundefined(dialog, true);
  timeout = isundefined(timeout, 0);
  merge = isundefined(merge, false);
  if(merge) {
    var old = dialogs.find("error.xul");
    if(old && old.window && typeof(old.window.updateMessage) == 'function') {
      old.window.updateMessage(message);
      old.focus();
      return;
    }
  }    
  var error = new cvDialog("error.xul", message);
  error.timeout = isundefined(timeout, 0);
  if(parentWindow) error.parentWindow = parentWindow;
  if(dialog) {
    dialogs.showDialog(error);
  } else {
    dialogs.show(error);
  }
}

function displayInfo(message, parentWindow, dialog, timeout, merge) {
  dialog = isundefined(dialog, true);
  timeout = isundefined(timeout, 0);
  merge = isundefined(merge, false);
  if(merge) {
    var old = dialogs.find("info.xul");
    if(old && old.window && typeof(old.window.updateMessage) == 'function') {
      old.window.updateMessage(message);
      old.focus();
      return;
    }
  }    
  var error = new cvDialog("info.xul", message);
  error.timeout = isundefined(timeout, 0);
  if(parentWindow) error.parentWindow = parentWindow;
  if(dialog) {
    dialogs.showDialog(error);
  } else {
    dialogs.show(error);
  }
}

function closeEvent() {
  var splitter = document.getElementById("eventBoxSplitter");
  splitter.setAttribute('state', 'collapsed');
}

function searchTree(event) {
  var search = document.getElementById("searchtext");
  search = search.value;
  var tree = document.getElementById("treecluster");

  var index = 0;
  var n = tree.view.selection.getRangeCount();
  if(n > 0) {
    var start = new Object();
    var end = new Object();
    tree.view.selection.getRangeAt(n - 1, start, end);
    index = parseInt(end.value);
  }
  var loop = false;
  while(true) {
    index++;
    try {
      var item = tree.view.getItemAtIndex(index);
      var title = item.getAttribute('title');
      if((title.length > 0) && regexMatch(item.getAttribute('title'), search, 'i')) {
        tree.view.selection.clearSelection();
        tree.view.selection.select(index);
        tree.treeBoxObject.ensureRowIsVisible(index);
        break;
      }
    } catch(e) {
      if(loop) break;
      loop = true;
      index = -1;
    }
  }
}

function openSearch() {
  var search = document.getElementById("searchtree");
  search.removeAttribute('hidden');
  document.getElementById("searchtext").focus();
}

function closeSearch() {
  var search = document.getElementById("searchtree");
  search.setAttribute('hidden', 'true');
}

function popHistory() {
  stateHistory.splice(0, 1);
  if(stateHistory.length > 0) {
    document.getElementById("status").setAttribute('label', stateHistory.join(', '));
    stateTimer = window.setTimeout('popHistory();', STATE_TIME);
  } else {
    document.getElementById("status").setAttribute('label', 'Ready');
    stateTimer = 0;
  }
}

function addHistory(text) {
  stateHistory.push(text);
  if(stateHistory.length > MAX_STATE_HISTORY) stateHistory.splice(0, 1);
  document.getElementById("status").setAttribute('label', stateHistory.join(', '));
  if(stateTimer == 0) stateTimer = window.setTimeout('popHistory();', STATE_TIME);
}

function getCurrentSelection() {
  var cluster = 0;
  var work = 0;
  var parent = 0;
  var subfield = '';
  if(currentObject) {
    if(!!currentTab) {
      if(typeof(currentTab.contentWindow.getCurrentSelection) == 'function') {
        [work, parent, subfield] = currentTab.contentWindow.getCurrentSelection();
        if(isArray(work) && (work.length > 0)) {
          cluster = work[0].cluster;
        }
      }
    }
  }
  return [cluster, work, parent, subfield];
}

function cloneWizard(action, filename) {
  var cluster = 0;
  var work = 0;
  var parent = 0;
  var subfield = 0;

  if(action != dock.CLONE_LOAD) {
    [cluster, work, parent, subfield] = getCurrentSelection();
    if(cluster == 0) {
      dock.displayInfo('Select one or more objects');
      return;
    }
  }
  filename = isundefined(filename, '');
  var args = new Object();
  args['cluster'] = cluster;
  args['work'] = work;
  args['parent'] = parent;
  args['subfield'] = subfield;
  args['action'] = action;
  args['filename'] = filename;
  dock.waitIcon();
  var cw = new cvDialog("clonewizard.xul", args);
  cw.onOk = function() {
    if(!!currentTab) {
      currentTab.contentWindow.refresh();
    }
  }
  dialogs.show(cw);
  dock.unwaitIcon();
}

/// context

function addButtonMenuItem(parent, text, command, separator) {
  if(currentTab.contentWindow.findButton(command, false)) {
    if(!!separator) addMenuSeparator(parent);
    addMenuItem(parent, text, 'findAndClickButton("' + command + '");');
    return true;
  }
  return false;
}

function addMenuItem(parent, text, command) {
  var item = document.createElement("menuitem");
  item.setAttribute('label', text);
  item.setAttribute('oncommand', command);
  parent.appendChild(item);
}

function addMenuSeparator(parent) {
  var item = document.createElement('menuseparator');
  parent.appendChild(item);
}

function findAndClickButton(name) {
  currentTab.contentWindow.findButton(name, true);
}

function changeTreePopup(event) {
  var popup = event.target;
  while(popup.firstChild) popup.removeChild(popup.firstChild);

  var separator = false;
  if(currentObject) {
    if(!!currentObject.object) {
      if(addButtonMenuItem(popup, 'Power on', 'powerOn', separator)) {
        addButtonMenuItem(popup, 'Power off', 'powerOff');
        addButtonMenuItem(popup, 'Power reset', 'powerReset');
        addButtonMenuItem(popup, 'Terminate', 'terminateInstance');
        separator = true;
      }
      if(addButtonMenuItem(popup, 'Shutdown', 'osShutdown', separator)) {
        addButtonMenuItem(popup, 'Reboot', 'osRestart');
        separator = true;
      }
      if(addButtonMenuItem(popup, 'Drain', 'drain', separator)) {
        addButtonMenuItem(popup, 'Undrain', 'undrain');
        separator = true;
      }
      if(addButtonMenuItem(popup, 'Decommission', 'decommission', separator)) {
        addButtonMenuItem(popup, 'Recommission', 'recommission');
        separator = true;
      }
      if(addButtonMenuItem(popup, 'Open', 'openDevice', separator)) {
        addButtonMenuItem(popup, 'Close', 'closeDevice');
        separator = true;
      }
      if(addButtonMenuItem(popup, 'Open', 'openDevices', separator)) {
        addButtonMenuItem(popup, 'Close', 'closeDevices');
        separator = true;
      }
      separator = addButtonMenuItem(popup, 'Root Shell', 'rootShell', separator) || separator;
      separator = addButtonMenuItem(popup, 'Telnet Shell', 'telnetShell', separator) || separator;
      separator = addButtonMenuItem(popup, 'Ssh Shell', 'sshShell', separator) || separator;
      separator = addButtonMenuItem(popup, 'Remote Console', 'solShell', separator) || separator;
      separator = addButtonMenuItem(popup, 'Minicom Console', 'minicomShell', separator) || separator;
      separator = addButtonMenuItem(popup, 'Update', 'syncNode', separator) || separator;
      if(currentObject.get('modified')) {
        if(separator) addMenuSeparator(popup);
        addMenuItem(popup, 'Save', 'currentObject.commit();');
        addMenuItem(popup, 'Revert', 'currentObject.refresh();');
        separator = true;
      }
      if(dock.connectedClustersCount() > 1) {
        if(separator) addMenuSeparator(popup);
        addMenuItem(popup, 'Export to other cluster', 'cloneWizard(' + dock.CLONE_CREATE + ');');
        separator = false;
      }
      if(separator) addMenuSeparator(popup);
      addMenuItem(popup, 'Synchronize values to other ' + currentObject.getType(true, true).toLowerCase(), 'cloneWizard(' + dock.CLONE_SYNC_ONE + ');');
      return true;
    } else {
      if(addButtonMenuItem(popup, 'Setup Wizard', 'addWizardCheck', separator)) {
        return true;
      }
    }
  }
  event.cancelBubble = true;
  event.stopPropagation();
  return false;
}

function doSavedClone(filename) {
  cloneWizard(dock.CLONE_LOAD, filename);
}

function addOldClone(name) {
  if(fileExists(name)) {
    var s = false;
    for(var i = 0; !s && (i < recentCloneFiles.length); i++) {
      s = (name == recentCloneFiles[i]);
    }
    if(!s) {
      recentCloneFiles.push(name);
      var popup = document.getElementById('savedclones');
      var menu = document.createElement('menuitem');
      menu.setAttribute('label', name);
      if(dock.getDirectorySeparator() == "\\") {
        file = file.replace(/([^\\])\\([^\\])/g, "$1\\\\$2");  
      }
      menu.setAttribute('oncommand', "doSavedClone('" + name + "')");
      popup.appendChild(menu);

      saveOldClone();
      popup.parentNode.parentNode.parentNode.removeAttribute('hidden');
    }
    return true
  }
  return false;
}

function addOldCloneCommands() {
  recentCloneFiles = new Array();
  var file = dock.BASE_PATH + "clone.old"
  var data = readListFromFile(file);
  var i = 0;
  var s = false;
  for(var i = 0; i < data.length; i++) {
    if(!addOldClone(data[i])) {
      s = true;
    }
  }
  if(s) saveOldClone();
  if(recentCloneFiles.length == 0) {
    var popup = document.getElementById('savedclones');
    popup.parentNode.parentNode.parentNode.setAttribute('hidden', true);
  }
}

function saveOldClone() {
  var list = new Array();
  for(var i = 0; i < recentCloneFiles.length; i++) {
    list.push(recentCloneFiles[i]);
  }
  var file = dock.BASE_PATH + "clone.old";
  saveListToFile(file, list);
}

function loadBookmark() {
  var file = dock.BASE_PATH + "bookmarks.dat";
  var data = readListFromFile(file);
  bookmarks = new Array();
  for(var i = 0; i < data.length; i++) {
    var a = data[i].split('@');
    if((data[i].length > 0) && (a.length == 2) && (a[0] != '#')) {
      if(addBookmark(a[0], a[1])) {
        bookmarks.push(data[i]);
      }
    }
  }
}

function saveBookmarks() {
  var file = dock.BASE_PATH + "bookmarks.dat";
  saveListToFile(file, bookmarks);
}

function clearBookmarks() {
  var popup = document.getElementById('bookmenu');
  while(popup.childNodes.length > 3) {
    popup.removeChild(popup.lastChild);
  }
}

function addBookmark(url, name) {
  var popup = document.getElementById('bookmenu');
  var menu = document.createElement('menuitem');
  menu.setAttribute('label', name);
  menu.setAttribute('oncommand', "doOpenBookmark('" + url + "')");
  popup.appendChild(menu);
  return true;
}

function doOpenBookmark(url) {
  var a = url.split('|');
  var o = findObject(a[0]);
  if(!isObject(o)) {
    displayError("Object not found, either it was deleted or you are not connected to the cluster");
    return false;
  }
  if(o.isCluster) {
    var ls = a[0].lastIndexOf('/');
    var sub = a[0].substr(ls + 1);
    if(isNumeric(sub)) sub = 0;
    println("Select: " + sub);
    o.select(sub, a[1]);
  } else {
    o.show(a[1]);
  }
  return true;
}

function createBookmark() {
  if(currentObject && currentTab) {
    var tree = document.getElementById("treecluster");
    var view = tree.view;
    var item = false;
    for(var t = 0; t < tree.view.selection.getRangeCount(); t++){
      var start = new Object();
      var end = new Object();
      tree.view.selection.getRangeAt(t,start,end);
      for(var v = start.value; v <= end.value; v++) {
        item = tree.view.getItemAtIndex(v);
        break;
      }
    }
    if(item) {
      var args = new Object();
      page = currentTab.contentWindow.getTab();
      args['title'] = 'Add new bookmark';
      args['question'] = 'Name';
      if(currentObject.cluster) {
        args['default'] = currentObject.cluster.name + ', ' + currentObject.resolveName() + ', ' + page;
      } else {
        var url = item.getAttribute('id');
        var ls = url.lastIndexOf('/');
        var sub = url.substr(ls + 1);
        args['default'] = currentObject.name + ', ' + sub  + ', ' + page;
      }
      var url = item.getAttribute('id') + '|' + page;
      println("Create bookmark for: " + url);
      args['known'] = new Array();
      var d = new cvDialog("newobject.xul", args);
      d.onOk = function(name) {
        if(addBookmark(url, name)) {
          bookmarks.push(url + '@' + name);
          saveBookmarks();
        }
      }
      dialogs.showDialog(d);
    }
  }
}

function manageBookmark() {
  var args = new Object();
  args['bookmarks'] = bookmarks;
  var d = new cvDialog("managebookmarks.xul", args);
  d.onOk = function(data) {
    clearBookmarks();
    bookmarks = new Array();
    for(var i = 0; i < data.length; i++) {
      var a = data[i].split('@');
      if((data[i].length > 0) && (a.length == 2) && (a[0] != '#')) {
        if(addBookmark(a[0], a[1])) {
          bookmarks.push(data[i]);
        }
      }
    }
    saveBookmarks();
  }
  dialogs.showDialog(d);
}
