/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var current;
var myDialog;
var dock;
var old;
var alsoRemoved = false;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.object;
  document.getElementById("monconf").setAttribute('value', myDialog.arguments.name);
  var metric = current.cluster.find(current.get('metric'));
  document.getElementById("metric").setAttribute('value', metric.resolveName());
  document.getElementById("metricParam").setAttribute('value', current.get('metricParam'));
  old = current.get('consolidatorConfArray');
  refresh();
}

function refresh() {
  tree = document.getElementById('tree');
  data = new Array();
  var list = current.get('consolidatorConfArray');
  current.cluster.currentSubObjectType = "ConsolidatorConf";
  current.cluster.currentSubObjectList = list;
  for(var i = 0; i < list.length; i++) {
    if(alsoRemoved || !list[i].toBeRemoved) {
      data.push(createTreeItem(list[i]));
    }
  }
  for(var i = list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['name'] = one.name;
  item['interval'] = one.consInterval;
  item['length'] = one.tableLength;
  item['timeOffset'] = one.timeOffset;
  switch(one.kind) {
  case('AVERAGE'):
    item['kind'] = 'Average';
    break;
  case('MINIMUM'):
    item['kind'] = 'Minimum';
    break;
  case('MAXIMUM'):
    item['kind'] = 'Maximum';
    break;
  default:
    item['kind'] = 'Unknown';
  }
  return item;
}

function newConsolidator() {
  var args = new Object();
  args['object'] = current;
  args['container'] = myDialog.arguments.container;
  args['consolidator'] = 0;
  var d = new dock.cvDialog("editconsolidator.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
function editConsolidator() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("No consolidator selected");
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = current;
    args['container'] = myDialog.arguments.container;
    args['consolidator'] = select[0];
    var d = new dock.cvDialog("editconsolidator.xul", args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError("Please select only one consolidator");
  }
}
function removeConsolidator() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("No consolidator selected");
  } else {
    var args = new Object();
    args['question'] = "Are you sure you want to remove these consolidators?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      for(var i = 0; i < select.length; i++) current.deleteSubObjectFromKey('consolidatorConfArray', select[i]);
      myDialog.arguments.container.set('modified', true);
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function saveConsolidator() {
  close();
}

function revertConsolidator() {
  current.set('consolidatorConfArray', old);
  refresh();
}
