/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function cvCustomMetricBounds() {
  this.bounds = new Object();
}

cvCustomMetricBounds.prototype.save = function() {
  var list = new Array();
  list.push("bounds = " + this.bounds.toSource() + ";");
  saveListToFile(BASE_PATH + "custom.metric.bounds", list);
}

cvCustomMetricBounds.prototype.load = function() {
  var list = readListFromFile(BASE_PATH + "custom.metric.bounds");
  for(var i = 0; i < list.length; i++) {
    try {
      eval('this.' + list[i]);
    } catch(err) {
      println("Error reading custom.metric.bounds: " + err);
    }
  }  
}

cvCustomMetricBounds.prototype.getBounds = function(name) {
  if(this.bounds.hasOwnProperty(name)) return this.bounds[name];
  return [NaN, NaN];
}

cvCustomMetricBounds.prototype.setBounds = function(name, lower, upper) {
  var save = false;
  if(this.bounds.hasOwnProperty(name)) {
    if(isNaN(lower) && isNaN(upper)) {
      delete this.bounds[name];
      save = true;
    } else {
      save = (!isNaN(lower) && (this.bounds[name][0] != lower)) || (!isNaN(upper) && (this.bounds[name][1] != upper));
      this.bounds[name] = [lower, upper];
    }
  } else if(!isNaN(lower) || !isNaN(upper)) {
    save = true;
    this.bounds[name] = [lower, upper];
  }
  if(save) this.save();
}
