/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var DATE_KEY_ENTER = 13;
var DATE_KEY_SPACE = 32;
var DATE_KEY_ESCAPE = 27;

var DATE_FORMAT = 'dd/mmm/yyyy';
var DATE_REGEX = '^[0-9]{1,2}/([1-9]|1[0-2]|Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)/[0-9]{4}$';
var DATETIME_FORMAT = 'dd/mmm/yyyy HH:MM';
var DATETIME_REGEX = '^[0-9]{1,2}/([1-9]|1[0-2]|Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)/[0-9]{4}\\s[0-9]{1,2}:[0-9]{2}$';

function datetext(what, format, value, days) {
  days = isundefined(days, false);
  var obj = document.getElementById(what);
  var dv;
  if(typeof(value) == 'string') {
    var dd = current.get(value);
    if(days) dd = dd * 86400 + 43200;
    dv = new Date();
    dv.setTime(dd * 1000);
    dv = dv.format(format);
    obj.setAttribute('fromobject', true);
  } else {
    dv = value.format(format);
    obj.setAttribute('time', Math.floor(value.getTime() / 1000));
    obj.setAttribute('fromobject', false);
  }
  obj.value = dv;  
  obj.setAttribute('value', dv);
  obj.setAttribute('what', what);
  obj.setAttribute('days', days);
  obj.setAttribute('type', 'timed');
  if(format == DATE_FORMAT) {
    obj.setAttribute('format', DATE_REGEX);
  } else if(format == DATETIME_FORMAT) {
    obj.setAttribute('format', DATETIME_REGEX);
  } else {
    println('Unknown date/time format: ' + format);
  }
  obj.setAttribute('timeout', '100');
  obj.addEventListener("command", datetext_command, true);
  obj.addEventListener("change", datetext_change, true);
  obj.addEventListener("keypress", datetext_keypress, true);
}

function datetext_keypress(event) {
  var text = event.target;
  var value = text.value;
  var format = text.getAttribute('format');
  var what = text.getAttribute('what');
  var days = eval(text.getAttribute('days'));
  var fo = eval(text.getAttribute('fromobject'));
  switch(event.keyCode) {
    case DATE_KEY_ENTER:
      if(regexMatch(value, format, 'i')) {
        text.setAttribute('value', text.value);
        var d = parseDate(value);
        if(fo) {
          var dd = d.getTime() / 1000;
          if(days) dd = Math.floor((dd + 43200) / 86400);
          current.set(what, dd);
        } else {
          text.setAttribute('time', Math.floor(d.getTime() / 1000));
        }
      } else {
        text.value = text.getAttribute('value');
      }
      document.commandDispatcher.advanceFocus();
      break;
    case DATE_KEY_ESCAPE:
      text.value = event.getAttribute('value');
  }
}

function datetext_change(event) {
  var text = event.target;
  var value = text.value;
  var format = text.getAttribute('format');
  var what = text.getAttribute('what');
  var days = eval(text.getAttribute('days'));
  var fo = eval(text.getAttribute('fromobject'));
  if(regexMatch(value, format, 'i')) {
    text.setAttribute('value', value);
    var d = parseDate(value);
    if(fo) {
      var dd = d.getTime() / 1000;
      if(days) dd = Math.floor((dd + 43200) / 86400);
      current.set(what, dd);
    } else {
      text.setAttribute('time', Math.floor(d.getTime() / 1000));
    }
  } else {
    text.value = text.getAttribute('value');
  }
  text.setAttribute("style", "");
}

function datetext_command(event) {
  var text = event.target;
  var value = text.value;
  var format = text.getAttribute('format');
  if(regexMatch(value, format, 'i')) {
    text.setAttribute("style", "");
  } else {
    text.setAttribute("style", "color: red;");
  }
}
