/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function randomMAC(parts, local, unicast) {
  parts = isundefined(parts, 6);
  var mac = new Array();
  for(var i = 0; i < parts; i++) {
    var x = Math.floor(Math.random() * 256);
    if(i == 0) {
      if(isundefined(local, true)) {
        x = x | 2;
      } else {
        x = x & 0xFD;
      }
      if(isundefined(unicast, false)) {
        x = x | 1;
      } else {
        x = x & 0xFE;
      }
    }
    x = x.toString(16);
    while(x.length < 2) {
      x = '0' + x;
    }
    mac.push(x);
  }
  println(mac.join(':'));
  return mac.join(':');
}

function createFSmount(cluster, device, mountpoint, filesystem, mountoptions) {
  var fsmount = new dock.cvFSMount();
  fsmount.device = device;
  fsmount.mountpoint = mountpoint;
  fsmount.filesystem = filesystem;
  fsmount.mountoptions = isundefined(mountoptions, 'defaults');  
  var tmp = new dock.cvObject(cluster, fsmount);
  return fsmount;
}

function createMICOverlay(cluster, name, source, target, type) {
  var overlay = new dock.cvMICOverlay();
  overlay.name = name;
  overlay.source = source;
  overlay.target = target;
  overlay.type = type
  var tmp = new dock.cvObject(cluster, overlay);
  return overlay;  
}

function createKernelModule(cluster, name, parameters) {
  var module = new dock.cvKernelModule();
  module.name = name;
  module.parameters = parameters;
  var tmp = new dock.cvObject(cluster, module);
  return module;  
}

function createDefaultMICNodeCategory(name, cluster) {
  var object = new dock.cvMICNodeCategory();          
  object.modified = true;
  object.toBeRemoved = false;
  object.name = name;
  object = cluster.addObject(object, dock.openAfterCreate);
  var settings = object.get('micSettings');
  var fsmounts = object.get('fsmounts');
  fsmounts.push(createFSmount(cluster, 'devpts', '/dev/pts', 'devpts', 'defaults'));
  fsmounts.push(createFSmount(cluster, 'tmpfs', '/dev/shm', 'tmpfs', 'defaults'));
  fsmounts.push(createFSmount(cluster, 'sysfs', '/sys', 'sysfs', 'defaults'));
  fsmounts.push(createFSmount(cluster, 'proc', '/proc', 'proc', 'defaults'));
  fsmounts.push(createFSmount(cluster, '$localnfsserver:/cm/shared', '/cm/shared', 'nfs', 'rsize=1024,wsize=1024,nolock,intr'));
  fsmounts.push(createFSmount(cluster, '$localnfsserver:/home', '/home', 'nfs', 'rsize=1024,wsize=1024,nolock,intr'));
  object.set('fsmounts', fsmounts);

  if(settings.childType == 'XeonPhiSettings') {
    var dir = '/var/mpss/cm-mounts-mic${index}';
    settings.overlays.push(createMICOverlay(cluster, 'cm-mounts', dir, dir + '.filelist', 'filelist'));
    settings.overlays.push(createMICOverlay(cluster, 'cm-slurm', '/cm/shared/apps/slurm/current/k1om-arch', '/cm/shared/apps/slurm/current/k1om-arch/slurm.filelist', 'filelist'));
    settings.overlays.push(createMICOverlay(cluster, 'cm-munge', '/cm/shared/apps/munge/current/k1om-arch', '/cm/shared/apps/munge/current/k1om-arch/munge.filelist', 'filelist'));
    settings.overlays.push(createMICOverlay(cluster, 'cm-munge-key', '/etc/munge/munge.key', '/etc/munge/munge.key', 'file'));
  }
  return object;
}
