/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var globalCurrent;
var current;
var currentDellSettings;
var bootOrderCache = new Object();
var currentBootOrder = new Object();

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    globalCurrent = use;
  }
  println("-- Category Refresh Dell BIOS settings");
  currentDellSettings = globalCurrent.get('dellSettings');
  if ( currentDellSettings ) {
    currentBootOrder = currentDellSettings.biosBootOrder.split(',');
    current = new dock.cvObject(globalCurrent.cluster, currentDellSettings, globalCurrent);
    kenum("sysprofile", ['PerfPerWattOptimizedDapc', 'PerfPerWatOptimizedOs', 'PerfOptimized', 'DenseCfgOptimized', 'Custom']);     
    kenum("failsafeBaudRate", ['115200', '19200', '57600', '9600']);     
    kenum("remoteTerminal", ['Ansi', 'Vt100Vt220']);     
    kenum("serialCommunication", ['Off' , 'OnConRedirAuto', 'OnConRedirCom', 'OnConRedirCom1', 'OnConRedirCom2', 'OnNoConRedir']);     
    kenum("serialPort", ['Com1', 'Com2', 'Serial1Com2Serial2Com1', 'Serial1Com1Serial2Com2']);     
    kenum("memFrequency", ['1067mhz', '1333mhz','1600mhz', '800mhz', 'MaxPerf', 'MaxReliability']);     
    kenum("memPatrolScrub", ['Disabled', 'Extended', 'Standard']);     
    kenum("memRefreshRate", ['1x', '2x']);     
    kenum("energyPerformanceBias", ['BalancedEfficiency', 'BalancedPerformance', 'LowPower', 'MaxPower']);     
    check("redirectionAfterBoot", false);     
    check("collaborativeCpuPerfCtrl", false);     
    check("l3Cache", false);     
    check('logicalProcessor', false);
    check("monitorMWait", false);     
    check("nodeInterleaving", false);     
    check("energyEfficientTurbo", false);     
    check("ioNonPostedPrefetch", false);     
  }
  /* Populate bios boot order */ 
  loadBootOrder();
}

function loadBootOrder() {
  var dell13gbiosbootorderrows = document.getElementById('dell13gbiosbootorder');
  while(dell13gbiosbootorderrows.firstChild) dell13gbiosbootorderrows.removeChild(dell13gbiosbootorderrows.firstChild);   
  for ( var j = 0; j < currentBootOrder.length; j++ ) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var shadowlabel = document.createElement('shadowlabel');
    shadowlabel.setAttribute('width', '20px');
    shadowlabel.setAttribute('value', parseInt(j + 1));
    var menulist = document.createElement('menulist');
    var menupopup = document.createElement('menupopup');
    menulist.setAttribute('selectedIndex', 0); 
    menulist.setAttribute('id', 'bootorderlist_' + j); 
    menupopup.setAttribute('id', 'bootorder_' + j); 
    for ( var k = 0; k < currentBootOrder.length; k++ ) {
      var trimmed = currentBootOrder[k];
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute('label', trimmed);
      menuitem.setAttribute('id', 'bootdevice_' + trimmed + '_' + j);
      menuitem.setAttribute('oncommand', "updateBootOrder(this);");
      menupopup.appendChild(menuitem);
    }
    menulist.appendChild(menupopup);
    row.appendChild(shadowlabel);
    row.appendChild(menulist);
    dell13gbiosbootorderrows.appendChild(row);
    menulist.selectedIndex = parseInt(j); 
  }
}

function updateBootOrder(elem) {
  var curselid = elem.id.split('_')[2];
  var newsel = elem.id.split('_')[1];
  var newselid = currentBootOrder.indexOf(newsel);
  var prevsel = currentBootOrder[curselid];
  var modified = false;
  var newBootOrder = new Object();
  if ( newsel != prevsel ) {
    currentBootOrder[curselid] = newsel;
    currentBootOrder[newselid] = prevsel;
    loadBootOrder();
    var newbootorder = "";
    for ( var i = 0; i < currentBootOrder.length; i++ ) {
      var trimmed = currentBootOrder[i];
      newbootorder += trimmed + ','; 
    }
    newbootorder = newbootorder.replace(/^,+|,+$/g,"");
    currentDellSettings.biosBootOrder = newbootorder;
    var save = document.getElementById('save');
    if(save) save.removeAttribute('disabled');
    current.set('modified', modified);
  }
}
