/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var globalCurrent;
var current;
var currentDellSettings;
var nictree;
var nicdata;

var niceditfile = 'dell/editcategorydell13gnicintegrated.xul';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    globalCurrent = use;
  }
  println("-- Category Refresh Dell NIC settings");
  currentDellSettings = globalCurrent.get('dellSettings');
  if ( currentDellSettings ) {
    current = new dock.cvObject(globalCurrent.cluster, currentDellSettings, globalCurrent);
    nictree = document.getElementById('nictree');
    nicdata = new Array();
    var nics = current.get('nics');
    for(var i = 0; i < nics.length; i++) {
      if(!nics[i].toBeRemoved || alsoRemoved) {
        nicdata.push(createTreeItemNic(nics[i], i));
      }
    }
    for(var i = nics.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
    var select = selected('niclist');
    loadTable(nictree, nicdata);
    setSelected('niclist', select);
  }
}

function editNicSubObject() {
  var select = selected('niclist');
  if(select.length == 0) {
    dock.displayError('No NIC device selected');
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = current;
    args['subobject'] = select[0];
    args['detached'] = isundefined(parent.detached, false);
    var d = new dock.cvDialog(niceditfile, args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError('Please select only one NIC');
  }
}

function createTreeItemNic(one, i) {
  var item = new Object();
  if(one.uniqueKey) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = -1000 -i;
  }
  item['nicname'] = one.name;
  item['nicbannermessagetimeout'] = one.bannerMessageTimeout;
  item['niclinkspeed'] = one.linkSpeed;
  item['niclinkupdelaytime'] = one.linkUpDelayTime;
  item['niclunbusyretrycount'] = one.lunBusyRetryCount;
  item['nicbootstraptype'] = one.bootStrapType;
  item['nicblinkleds'] = one.blinkLeds;
  item['nicchapauthenable'] = one.chapAuthEnable;
  item['nicdhcpvendorid'] = one.dhcpVendorId;
  item['nicfirsthddtarget'] = one.firstHddTarget;
  item['nicipver'] = one.ipVer;
  item['nichidesetupprompt'] = one.hideSetupPrompt;
  item['niciscsitargetboot'] = one.iscsiTargetBoot;
  item['niciscsiviadhcp'] = one.iscsiViaDHCP;
  item['niclegacybootproto'] = one.legacyBootProto;
  item['nictcpipviadhcp'] = one.tcpIpViaDHCP;
  item['nictcptimestamp'] = one.tcpTimestmp;
  item['nicvlanmode'] = one.vLanMode;
  item['nicvlanid'] = one.vLanId;
  item['nicmodified'] = one.modified;
  item['nictoBeRemoved'] = one.toBeRemoved;
  return item;
}

