/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var cluster;
var current;
var myDialog;
var dock;
var node;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  //printall(myDialog.arguments.object.dellSettingsInfo);
  node = myDialog.arguments.object;
  var currentDellSettings = node.getDellSettings();
  
  setDialogTitle("Node firmware update")
  if(currentDellSettings == 0 || currentDellSettings.devicefirmware == 0) {
    current = new dock.cvDellSettingsFirware();
    current = new dock.cvObject(node.cluster, current);
    refresh();
  } else {
    current = clone(currentDellSettings.devicefirmware);
    current = new dock.cvObject(node.cluster, current);
    refresh();
  }
}

function refresh() {
  text('path');
  text('ftpUser');
  text('ftpPassword');
  check('clearConfig');
}

function cancel() {
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}

function start() {
  dock.waitIcon();
  var args = new Object();
  args['title'] = "Dell firmware update";
  args['question'] = "Proceeding with this operation will apply firmware updates for the selected node. This may trigger a reboot.\n\nDo you really want to continue?";
  args['check'] = "View task manager";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(checked) {
    if (checked) {
      viewTaskManager();
    }
    var nodes = [node.get('uniqueKey')];
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'pupdateDellFirmware', [nodes], function(code, data) {
      if(code == 0) {
        var args = new Object();
        args['taskdata'] = data;
        args['cluster'] = current.cluster;
      } else {
        printall(data);
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);
}
