/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var globalCurrent;
var current;
var currentDellSettings;
var currentLiveDellSettings;
var nictree;
var nicdata;
var livenictree;
var livenicdata;
var live;

var niceditfile = 'dell/editdell13gnicintegrated.xul';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    globalCurrent = use;
  }
  println("-- Refresh Dell NIC settings");
  currentDellSettings = globalCurrent.getDellSettings();
  if ( currentDellSettings ) {
    current = new dock.cvObject(globalCurrent.cluster, currentDellSettings, globalCurrent);
    nictree = document.getElementById('nictree');
    nicdata = new Array();
    var nics = current.get('nics');
    for(var i = 0; i < nics.length; i++) {
      if(!nics[i].toBeRemoved || alsoRemoved) {
        nicdata.push(createTreeItemNic(nics[i], i, ''));
      }
    }
    for(var i = nics.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
    var select = selected('niclist');
    loadTable(nictree, nicdata);
    setSelected('niclist', select);
  }
  println("-- Refresh live Dell NIC settings");
  fillLiveSettings();
}

function editNicSubObject() {
  var select = selected('niclist');
  if(select.length == 0) {
    dock.displayError('No NIC device selected');
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = current;
    args['subobject'] = select[0];
    args['detached'] = isundefined(parent.detached, false);
    var d = new dock.cvDialog(niceditfile, args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError('Please select only one NIC device');
  }
}

function createTreeItemNic(one, i, id) {
  var item = new Object();
  if(one.uniqueKey) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = -1000 -i;
  }
  item[id + 'nicname'] = one.name;
  item[id + 'nicbannermessagetimeout'] = one.bannerMessageTimeout;
  item[id + 'niclinkspeed'] = one.linkSpeed;
  item[id + 'niclinkupdelaytime'] = one.linkUpDelayTime;
  item[id + 'niclunbusyretrycount'] = one.lunBusyRetryCount;
  item[id + 'nicbootstraptype'] = one.bootStrapType;
  item[id + 'nicblinkleds'] = one.blinkLeds;
  item[id + 'nicchapauthenable'] = one.chapAuthEnable;
  item[id + 'nicdhcpvendorid'] = one.dhcpVendorId;
  item[id + 'nicfirsthddtarget'] = one.firstHddTarget;
  item[id + 'nicipver'] = one.ipVer;
  item[id + 'nichidesetupprompt'] = one.hideSetupPrompt;
  item[id + 'niciscsitargetboot'] = one.iscsiTargetBoot;
  item[id + 'niciscsiviadhcp'] = one.iscsiViaDHCP;
  item[id + 'niclegacybootproto'] = one.legacyBootProto;
  item[id + 'nictcpipviadhcp'] = one.tcpIpViaDHCP;
  item[id + 'nictcptimestamp'] = one.tcpTimestmp;
  item[id + 'nicvlanmode'] = one.vLanMode;
  item[id + 'nicvlanid'] = one.vLanId;
  if ( id == '' ) {
    item[id + 'nicmodified'] = one.modified;
    item[id + 'nictoBeRemoved'] = one.toBeRemoved;
  }
  return item;
}

function fillLiveSettings() {
  currentLiveDellSettings = globalCurrent.getLiveDellSettings();
  if ( currentLiveDellSettings ) {
    var currentlive = new dock.cvObject(globalCurrent.cluster, currentLiveDellSettings, currentLiveDellSettings);
    livenictree = document.getElementById('livenictree');
    livenicdata = new Array();
    var nics = currentlive.get('nics');
    for(var i = 0; i < nics.length; i++) {
      if(!nics[i].toBeRemoved || alsoRemoved) {
        livenicdata.push(createTreeItemNic(nics[i], i, 'live'));
      }
    }
    for(var i = nics.length; i < MINTREEITEMS; i++) livenicdata.push(blankTreeItem());
    var select = selected('liveniclist');
    loadTable(livenictree, livenicdata);
    setSelected('liveniclist', select);
  }
}

function showLive(showlive) {
  fillLiveSettings();
  document.getElementById('livenictree').setAttribute('hidden', (showlive.getAttribute('label') == 'Show live') ? true:false);
  document.getElementById('livenictreeheader').setAttribute('hidden', (showlive.getAttribute('label') == 'Show live') ? true:false);
}

