/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;
var firmwareupdatefile = "dell/dell13gfirmwareupdate.xul";
var node;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh DellSettings" + ' - ' + document.documentURI);
 
  document.getElementById('revert').setAttribute('disabled', current.get('uniqueKey') < dock.MAX_LOCAL_KEY);
  document.getElementById('save').setAttribute('disabled', !current.get('modified'));
  refreshLive();
  refreshAll();
}

function refreshLive() {
  overview = current.sysInfo;
  if ( overview ) {
    overviewValue('systemName');
    overviewValue('systemManufacturer');
    overviewValue('vendorTag');
    overviewValue('biosVersion');
    overviewValue('biosDate');
    overviewValue('biosVendor');
    overviewValue('motherboardManufacturer');
    overviewValue('motherboardName');
    overviewValue('nics');
    overviewValue('dellStorage', (overview['dellStorage'] == 0) ? 'None':overview['dellStorage']);
  }
}

function refreshAll() {
  println("-- DellSettings refreshAll");
  for(var i = 0; i < window.frames.length; i++) {
    if(!!window.frames[i].refresh) {
      window.frames[i].refresh(current);
    }
  }
}

function showLive() {
  //println("-- DellSettings showLive/hideLive");
  var showlive = document.getElementById('showlive');
  showlive.setAttribute('label', (showlive.getAttribute('label') == 'Show live') ? 'Hide live':'Show live');
  for(var i = 0; i < window.frames.length; i++) {
    if(!!window.frames[i].showLive) {
      window.frames[i].showLive(showlive);
    }
  }
}

function firmwareUpdate() {
  dock.waitIcon();
  var args = new Object();
  args['title'] = "Dell firmware update";
  args['question'] = "Proceeding with this operation will apply firmware updates for the selected node. This may trigger a reboot.\n\nDo you really want to continue?";
  args['check'] = "View task manager";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(checked) {
    if (checked) {
      viewTaskManager();
    }
    println(current.get('uniqueKey'));
    var nodes = [current.get('uniqueKey')];
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'pupdateDellFirmware', [nodes], function(code, data) {
      if(code == 0) {
        var args = new Object();
        args['taskdata'] = data;
        args['cluster'] = current.cluster;
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);
}

/* Use this function, when we have the ability to override the configured 
 * firmware settings for a node.
function firmwareUpdate() {
  var args = new Object();
  args['object'] = current;
  args['detached'] = isundefined(parent.detached, false);
  var d = new dock.cvDialog(dock.myVersion + firmwareupdatefile, args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
*/

function applyDellSettings() {
  var args = new Object();
  args['title'] = "Apply Dell Settings";
  args['question'] = "Proceeding with this operation will apply the changes in Dell settings, if any and may cause a reboot of the current node.\n\nDo you really want to continue?";
  args['check'] = "View task manager";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(checked) {
    if (checked) {
      viewTaskManager();
    }
    current.applyDellSettings();
  }
  dock.dialogs.showDialog(d);
}
