/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var detached;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  detached = myDialog.arguments.detached;
  if(myDialog.arguments.subobject == 0) {
    newEdit = true;
    setDialogTitle("NIC Integrated Device")
    current = new dock.cvDialog();
    current = new dock.cvObject(current.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('nics', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  //Fill in the values here
  text('name', false);
  text('vLanId', false);
  text('dhcpVendorId', false);
  text('bannerMessageTimeout', false);
  text('linkUpDelayTime', false);
  text('lunBusyRetryCount', false);
  kenum('bootStrapType', ['AutoDetect','BBS','Int18h','Int19h']);
  kenum('ipVer', ['IPv4', 'IPv6']);
  kenum('legacyBootProto', ['PXE','iSCSI','FcoE','NONE']);
  kenum('linkSpeed', ['AutoNeg','10 Mbps Half','10 Mbps Full','100 Mbps Half', '100 Mbps Full']);
  check('blinkLeds', false);
  check('chapAuthEnable', false);
  check('firstHddTarget', false);
  check('hideSetupPrompt', false);
  check('iscsiTargetBoot', false);
  check('iscsiViaDHCP', false);
  check('tcpIpViaDHCP', false);
  check('tcpTimestmp', false);
  check('vLanMode', false);
  if(detached) {
    return;
  } else {
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('');
      list.push(current.object);
      object.set('', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function save() {
  if(!window.closed) {
    //TODO: Do some more validation here
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('');
      list.push(current.object);
      object.set('', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}

function revert() {
}
