/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;
var health;
var timer = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function stop() {
  println("Stop device health");
  if(timer) window.clearTimeout(timer);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) {
    current = use;
  }
  println("Refresh device health" + ' - ' + document.documentURI);

  if(!current || (typeof(current.stateString) != 'function') || (current.stateString() == 'Closed')) {
    var no = new dock.cvGuiNodeOverview();
    updateHealth(new Array());
  } else if(current.cluster.connected) {
    var mpi = current.cluster.allChecksMetricsAsMetricPrmId(current.object.uniqueKey);
    var nodes = [current.object.uniqueKey];
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmmon', 'getLatestPickedRates', [nodes, mpi], function(code, data) {
      if(code == 0) {
        updateHealth(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
  }
}
