/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  var myDialog = dock.dialogs.list[index];
  var current = myDialog.arguments.cluster;
  var drain = myDialog.arguments.drainresult;

  if(myDialog.arguments.drain == 0) {
    setDialogTitle('Drain nodes')
  } else if(myDialog.arguments.drain == 1) {
    setDialogTitle('Undrain nodes')
  } else if(myDialog.arguments.drain == 2) {
    setDialogTitle('Decommission nodes')
  } else if(myDialog.arguments.drain == 3) {
    setDialogTitle('Recommission nodes')
  }

  tree = document.getElementById('tree');
  data = new Array();
  for(var i = 0; i < drain.length; i++) {
    var node = drain[i].node;
    var queue = drain[i].queue;
    var result = drain[i].result;
    var total = Math.min(node.length, queue.length, result.length);
    for(var j = 0; j < total; j++) {
      var item = new Object();
      item['node'] = current.resolveName(node[j]);
      item['queue'] = current.resolveName(queue[j]);
      if(item['queue'].length == 0) {
        item['queue'] = drain[i].scheduler;
      } else if(drain.length > 1) {
        item['queue'] = drain[i].scheduler + ":" + item['queue'];
      }
//     <enum name="Result">
//       <item name="NOTANODE"/>
//       <item name="DRAINED"/>
//       <item name="UNDRAINED"/>
//       <item name="INVALID"/>
//       <item name="FAILED"/>      
//       <item name="UNKNOWN"/>      
//       <item name="DRAINING"/>
//       <item name="DECOMMISSIONED"/>
//       <item name="DECOMMISSIONING"/>
//       <item name="PARTIALLY_DECOMMISSIONED"/>
//     </enum>
      switch(result[j]) {
        case(0) : item['result'] = "Not a node"; break;
        case(1) : {
          if(myDialog.arguments.drain < 2) {
            item['result'] = "Drained"; break;  
          } else {
            item['result'] = "Decommissioned"; break;  
          } }
        case(2) :  {
          if(myDialog.arguments.drain < 2) {
            item['result'] = "Undrained"; break;  
          } else {
            item['result'] = "Recommissioned"; break;  
          } }
        case(3) : item['result'] = "Not in scheduler"; break;
        case(4) : item['result'] = "Failed"; break;
        case(5) : item['result'] = "Unknown"; break;
        case(6) : item['result'] = "Decommissioned"; break;
        case(7) : item['result'] = "Decommissioning"; break;
        case(9) : item['status'] = 'Partially decommissioned'; break;
        default : item['result'] = "Unknown";
      }
      data.push(item);
    }
  }
//   for(var i = data.length; i < 28; i++) data.push(blankTreeItem());
  loadTable();
}
