/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var topview = 0;
var waitCount = 0;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  var myDialog = dock.dialogs.list[index];


  addEventListener("resize", resize, false);
  
  window.setTimeout('refresh();', 50);
}

function resize() {
  if(topview) topview.resize();
}

function refresh() {
  if(!topview) {
    topview = new RackView(0);
    var item = document.getElementById('racksize').selectedItem;
    topview.size = parseInt(item.getAttribute('size'));;
    topview.padding = parseInt(item.getAttribute('padding'));    
    topview.viewMode = RACK_VIEWMODE_CLUSTERS;
  }
  for(var i = 0; i < dock.clusterlist.length; i++) {
    if(dock.clusterlist[i].connected) {
      topview.addOtherCluster(dock.clusterlist[i]);
    }
  }
  if(isEmpty(topview.otherClusters)) {
    dock.displayInfo('Not conneced to any cluster', window);
  } else {
    setview(topview.getView());
    topview.startDrill(true);
    topview.refreshDrill();
  }
}

function setview(list) {
  var box = document.getElementById('view');
  while(box.childNodes.length > 1) box.removeChild(box.lastChild);
  for(var i = 0; i < list.length; i++) {
    var label = document.createElement('shadowlabel');
    label.setAttribute('class', 'staticdataheaderurl');
    label.setAttribute('value', list[i]);
    label.setAttribute('onclick', 'clickView(' + i + ');');
    box.appendChild(label);
//     if(i < 3) {
//       var label = document.createElement('darkshadowlabel');
//       label.setAttribute('class', 'darkstaticdataheader');
//       label.setAttribute('value', '/');
//       box.appendChild(label);
//     }
  }
}

function clickView(index) {
  if(topview.setView(index)) refresh();
}

function opendevice(cluster, key) {
  cluster.select(key);
}

function setup() {
  var file = "racksetup.xul";
  var old = dock.dialogs.find(file);
  if(old) {
    if(!old.closed) {
      dock.displayError("A rack setup window is already open", window);
      return;
    }
  }
  var args = new Object();
  args['topview'] = topview;
  args['rack'] = topview.other;
  var d = new dock.cvDialog(file, args);
  d.parentWindow = window;
  dock.dialogs.show(d);
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
    for(var i = 0; i < window.frames.length; i++) {
      window.frames[i].window.setCursor("wait");
      if(typeof(window.frames[i].waitIcon) == 'function') {
        window.frames[i].waitIcon();
      }
    }
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) {
      window.frames[i].window.setCursor("auto");
      if(typeof(window.frames[i].unwaitIcon) == 'function') {
        window.frames[i].unwaitIcon();
      }
    }
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}

function setSize(event) {
  var item = event.target;
  topview.clear();
  topview.size = parseInt(item.getAttribute('size'));;
  topview.padding = parseInt(item.getAttribute('padding'));
  topview.forceRedraw = true;
  topview.startDrill(true);
  topview.refreshDrill();
}
