/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var cluster;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  if(myDialog.arguments.object == 0) {
    newEdit = true;
    setDialogTitle("New Action")
    current = new dock.cvThreshAction();
    current = new dock.cvObject(myDialog.arguments.cluster, current);
  } else {
    newEdit = false;
    current = cluster.find(myDialog.arguments.object);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
  refresh();
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('command', '^');
  text('descr', '^');
  text('revision');  
  number('scriptTimeout', 0, 120, '', 0);
  kenum('runOnMaster', [[true, 'Master'], [false, 'Node']]);

  if(!current.get('isCustom')) {
    document.getElementById('name').setAttribute('disabled', "true");
    document.getElementById('command').setAttribute('disabled', "true");
    document.getElementById('descr').setAttribute('disabled', "true");
    document.getElementById('runOnMaster').setAttribute('disabled', "true");
    document.getElementById('scriptTimeout').setAttribute('disabled', "true");
    document.getElementById('revision').setAttribute('disabled', "true");
    document.getElementById('ok').setAttribute('disabled', "true");
  } else {
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(blank(current.get('command'))) {
      dock.displayError("Command cannot be empty");
      return;
    }
    if(newEdit) {
      cluster.addObject(current.object);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit && current.get('isCustom')) current.old(old);
    myDialog.doCancel();
    close();
  }
}
