/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var cluster;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  cluster = myDialog.arguments.cluster;
  
  if(object <= 0) {
    newEdit = true;
    setDialogTitle("New Cloud Provider")
    current = new dock.cvEC2Provider(); /* TODO: add other providers */
    current = new dock.cvObject(cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = cluster.find(object);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('username', '^');
  text('accountId', '^');
  text('accessKeyId', '^');
  text('accessKeySecret', '^');
  resolve('defaultRegion', 'EC2Region', '', false);
  var latest = current.cluster.getLatestEC2AMI();
  if(latest) {
    resolve('defaultAMI', 'EC2AMI', '', 'latest:' + latest.resolveName());
  } else {
    resolve('defaultAMI', 'EC2AMI', '', false);
  }
  resolve('defaultType', 'EC2Type', '', false);
  resolve('defaultDirectorType', 'EC2Type', '', false);
//   resolve('defaultAvailabilityZone', '', '', true); // TODO

  if (isReadOnlyCloudProvider(current)) {
    var obj = document.getElementById('username');
    obj.setAttribute('type', 'password');
    obj = document.getElementById('accountId');
    obj.setAttribute('type', 'password');
    obj = document.getElementById('showpass');
    obj.setAttribute('disabled', true);
  }

  setfocus('name');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) cluster.addObject(current, false);
    current.commit();
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(newEdit) {
      current.remove();
    } else {
      current.old(old);
    }
    myDialog.doCancel();
    close();
  }
}


function passwordToggle() {
  var obj = document.getElementById('accessKeyId');
  if(obj.getAttribute('type') == 'password') {
    obj.setAttribute('type', 'timed');
  } else {
    obj.setAttribute('type', 'password');
  }
  var obj = document.getElementById('accessKeySecret');
  if(obj.getAttribute('type') == 'password') {
    obj.setAttribute('type', 'timed');
  } else {
    obj.setAttribute('type', 'password');
  }
}
