/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;

var fieldname = 'nodes';
var displayInTree = false;
var subtype = 'Node';
var singular = 'node';
var plural = 'nodes';
var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['category', 'category', true],
            ['installmode', 'installMode', false],
            ['rack', 'rack.rack', true],
            ['position', 'rack.position', false]];
var belongs = '0';
var noloop = 'true';
var extraName = "''";
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  if(myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New Failover Group")
    current = new dock.cvCMDaemonFailoverGroup();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('failoverGroups', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  
  text('name', '^', '', true, '', newKey);
  text('revision');

  text('warntime', '^[0-9]+$');
  text('deadtime', '^[0-9]+$');
  
  text('mountScript');
  text('unmountScript');
  text('preFailoverScript');
  text('postFailoverScript');
  
  check('disableAutomaticFailover');
  check('alsoTakeOverAfterGraciousShutdown');
  
  deviceselect();
  
  setfocus('name');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('failoverGroups');
      list.push(current.object);
      object.set('failoverGroups', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    dock.currentTab.contentWindow.refresh();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    close();
  }
}
