/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  if(myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New FS Export")
    current = new dock.cvFSExport();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('fsexports', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }

  if(!current.get('isCustom')) {
    document.getElementById('name').setAttribute('disabled', 'true');
    document.getElementById('path').setAttribute('disabled', 'true');
    document.getElementById('revision').setAttribute('disabled', 'true');
    document.getElementById('hostsNetwork').setAttribute('disabled', 'true');
    document.getElementById('hosts').setAttribute('disabled', 'true');
    document.getElementById('isNetwork').setAttribute('disabled', 'true');
    document.getElementById('isnotNetwork').setAttribute('disabled', 'true');
    document.getElementById('anonUid').setAttribute('disabled', 'true');
    document.getElementById('anonGid').setAttribute('disabled', 'true');
    document.getElementById('allowWrite').setAttribute('disabled', 'true');
    document.getElementById('async').setAttribute('disabled', 'true');
    document.getElementById('rootSquash').setAttribute('disabled', 'true');
    document.getElementById('allSquash').setAttribute('disabled', 'true');
    document.getElementById('extraOptions').setAttribute('disabled', 'true');
    document.getElementById('fsid').setAttribute('disabled', 'true');
  }

}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('path', '^');
  textresolve('hosts', '^', 'Network', '!');
  text('anonUid', '^[0-9]{1,5}$');
  text('anonGid', '^[0-9][1,5}$');
  check('allowWrite');
  check('async');
  check('rootSquash');
  check('allSquash');
  check('rdma');
  text('extraOptions', '^');
  text('fsid', '^[0-9]{1,5}$');
  text('revision');
  setfocus('name');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(blank(current.get('path'))) {
      dock.displayError("Path cannot be empty");
      return;
    }
    if(blank(current.get('hosts'))) {
      dock.displayError("Hosts cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('fsexports');
      list.push(current.object);
      object.set('fsexports', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}

function setHostsType(index) {
  if(!eval(document.getElementById('isNetwork').getAttribute('disabled'))) {
    document.getElementById('isNetwork').setAttribute('on', index == 0);
    document.getElementById('isnotNetwork').setAttribute('on', index == 1);
  }
}
