/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  if(myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New FS Mount")
    current = new dock.cvFSMount();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('fsmounts', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('device', '^');
  text('filesystem', '^');
  text('mountpoint', '^', '', true, '', newKey);
  text('mountoptions', '^');
  number('fsck', 0, 2);
  check('dump');
  check('rdma');
  text('revision');
  setfocus('device');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('device'))) {
      dock.displayError("Device cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('fsmounts');
      list.push(current.object);
      object.set('fsmounts', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
