/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  var cluster = myDialog.arguments.cluster;
  if(myDialog.arguments.object <= 0) {
    newEdit = true;
    setDialogTitle("Add group")
    document.getElementById("group").setAttribute('type', 'timed');
    current = new dock.cvGroup();
    current = new dock.cvObject(cluster, current, 0, 0, false);
    refresh();
  } else {
    document.getElementById("group").setAttribute('disabled', "true");
    document.getElementById("group").setAttribute('readonly', "true");
    newEdit = false;
    current = cluster.find(myDialog.arguments.object);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }

  old = current.old(false, true);
  refresh();
}

function refresh() {
  text('group', '^');
  text('groupID', '^(<auto>|[0-9]{1,10})$');
  stringlist('groupMembers', "Members:");
  blankAuto('groupID');
  if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
    setfocus('groupID');
  } else {
    setfocus('group');
  }
}

function blankAuto(name) {
  if(blank(current.get(name))) {
    document.getElementById(name).value = '<auto>';
    document.getElementById(name).setAttribute('value', '<auto>');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('group'))) {
      dock.displayError("Group name cannot be empty");
      return;
    }
    if(newEdit) {
      myDialog.arguments.cluster.addObject(current.object);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
