/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var detached;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  detached = myDialog.arguments.detached;
  if(myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New Kernel Module")
    current = new dock.cvKernelModule();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('modules', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('parameters', '^');
  text('revision');
  if(detached) {
    document.getElementById('name').setAttribute('disabled', true);
    document.getElementById('parameters').setAttribute('disabled', true);
    document.getElementById('revision').setAttribute('disabled', true);
    document.getElementById('ok').setAttribute('hidden', true);
  } else {
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('modules');
      list.push(current.object);
      object.set('modules', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
