/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var cluster;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  if(myDialog.arguments.object == 0) {
    newEdit = true;
    setDialogTitle("New Metric")
    current = new dock.cvMetric();
    current = new dock.cvObject(myDialog.arguments.cluster, current);
  } else {
    newEdit = false;
    current = cluster.find(myDialog.arguments.object);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }

  refresh();
}

function rename(name, valid) {
  var obj = document.getElementById(valid);
  if(!obj) return;
  if(name.length == 0) {
    obj.parentNode.parentNode.removeChild(obj.parentNode);
  } else if(name != dock.DEFAULT_BRANDING) {
    obj.parentNode.firstChild.firstChild.setAttribute('value', name + ' check:');
  }
}

function refresh() {
  var list = current.cluster.metricEnumName(true);
  
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('command', '^');
  text('descr', '^');
  text('unit', '^');
  kenum('paramPermission', [['PARAM_OPTIONAL', 'Optional'],['PARAM_DISALLOWED', 'Disallowed'],['PARAM_REQUIRED', 'Required']]);
  kenum('metricClass', list);
  kenum('retrievalMethod', [['CMDAEMON_RETRIEVAL', 'CMDaemon'],['SNMP', 'SNMP']]);
  kenum('samplingMethod', [['BUFFERING_REMOTELY', 'Sampling on node'],['SAMPLING_ON_DEMAND', 'Sampling on master']]);
  check('isCumulative');

  text('revision');
  text('stateFlappingCount', '^[0-9]+$');

  text('minimum', '-?[0-9]*(\.[0-9])?(e[+-][0-9]+)?');
  text('maximum', '-?[0-9]*(\.[0-9])?(e[+-][0-9]+)?');

  text('scriptTimeout', '^[0-9]+$');
  check('disabled');
  check('disableOnHighLoad');

  text('notes');

  if(!current.get('isCustom')) {
    document.getElementById('name').setAttribute('disabled', 'true');
    document.getElementById('revision').setAttribute('disabled', 'true');
    document.getElementById('descr').setAttribute('disabled', 'true');
    document.getElementById('command').setAttribute('disabled', 'true');
    document.getElementById('scriptTimeout').setAttribute('disabled', 'true');
    document.getElementById('unit').setAttribute('disabled', 'true');
    document.getElementById('paramPermission').setAttribute('disabled', 'true');
    document.getElementById('metricClass').setAttribute('disabled', 'true');
    document.getElementById('retrievalMethod').setAttribute('disabled', 'true');
    document.getElementById('samplingMethod').setAttribute('disabled', 'true');
    document.getElementById('isCumulative').setAttribute('disabled', 'true');
    setfocus('minimum');
  } else {
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(current.get('isCustom')) {
      if(blank(current.get('name'))) {
        dock.displayError("Name cannot be empty");
        return;
      }
      if(blank(current.get('command'))) {
        dock.displayError("Command cannot be empty");
        return;
      }
      if(newEdit) {
        cluster.addObject(current.object);
      }
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
