/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var currentOwner;

var subfield = 'micSettings(XeonPhiSettings)|overlays';

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  if(myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New MICOverlau")
    current = new dock.cvMICOverlay();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey(subfield, myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
  current.parent = new dock.cvObject(object.cluster, object.get('micSettings'), object, 'micSettings');

}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('source', '^');
  text('target', '^');
  text('revision');
  kenum('type', [['rpm', 'RPM'], ['file', 'File'], ['filelist', 'FileList'], ['simple', 'Simple']]);
  kenum('state', [['on', 'On (enabled)'], ['off', 'Off (disabled)']]);
  setfocus('name');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(blank(current.get('source'))) {
      dock.displayError("Source cannot be empty");
      return;
    }
    if(current.get('type') != 'rpm' && blank(current.get('target'))) {
      dock.displayError("Target cannot be empty when this overlay type is used");
      return;
    }

    if(newEdit) {
      var list = object.get(subfield);
      list.push(current.object);
      object.set(subfield, list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}

function setHostsType(index) {
  if(!eval(document.getElementById('isNetwork').getAttribute('disabled'))) {
    document.getElementById('isNetwork').setAttribute('on', index == 0);
    document.getElementById('isnotNetwork').setAttribute('on', index == 1);
  }
}
