/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  if(myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New Metric Configuration")
    current = new dock.cvMonMetricConf();
    current = new dock.cvObject(object.cluster, current);
    var consv = new Array();
    var cons = new dock.cvConsolidatorConf();
    cons.name = "Hour";
    cons.tableLength = 2000;
    cons.timeOffset = 0;
    cons.consInterval = 3600;
    cons.kind = 'AVERAGE';
    cons.toBeRemoved = false;
    var cc = new dock.cvObject(object.cluster, cons);
    consv.push(cons);
    var cons = new dock.cvConsolidatorConf();
    cons.name = "Day";
    cons.tableLength = 1000;
    cons.timeOffset = 0;
    cons.consInterval = 86400;
    cons.kind = 'AVERAGE';
    cons.toBeRemoved = false;
    var cc = new dock.cvObject(object.cluster, cons);
    consv.push(cons);
    var cons = new dock.cvConsolidatorConf();
    cons.name = "Week";
    cons.tableLength = 1000;
    cons.timeOffset = 0;
    cons.consInterval = 604800;
    cons.kind = 'AVERAGE';
    cons.toBeRemoved = false;
    var cc = new dock.cvObject(object.cluster, cons);
    consv.push(cons);
    current.set('consolidatorConfArray', consv);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('metrics', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var title = getDialogTitle();
  resolve('metric', 'Metric');
  if(!newEdit) document.getElementById("metric").setAttribute('disabled', true);
  text('metricParam', '^');
  text('samplingInterval', '^[0-9]+$');
  specialvalues('samplingInterval', [[0, 'N/A']]);
  text('rawTableLength', '^[0-9]+$');
  text('gapThreshold', '^[0-9]+$');
  text('thresholdDuration', '^[0-9]+$');
  text('revision');
  var parent = current.cluster.find(current.get('metric'));
  var dis = false;
  var disl = false;
  if(parent) {
    dis = parent.get('disabled');
    disl = parent.get('disableOnHighLoad');
  }
  check('storeInDatabase');
  check('disabled', dis);
  check('disableOnHighLoad', disl);

  threshActionList('stateFlapping', 'State Flapping:');
  setfocus('metric');
}

function ok() {
  if(!window.closed) {
    if(current.get('metric') == 0) {
      dock.displayError("Metric cannot be empty");
      return;
    }
    var metric = current.cluster.find(current.get('metric'));
    switch(metric.get('paramPermission')) {
    case('PARAM_DISALLOWED') :
      if(!blank(current.get('metricParam'))) {
        dock.displayError("Metric parameter cannot be set");
        return;
      }
      break;
    case('PARAM_REQUIRED') :
      if(blank(current.get('metricParam'))) {
        dock.displayError("Metric parameter has to be set");
        return;
      }
      break;
    case('PARAM_OPTIONAL') :
    }
    if(newEdit) {
      var list = object.get('metrics');
      var key = current.get('metric');
      var param = current.get('metricParam');
      for(var i = 0; i < list.length; i++) {
        if((list[i].metric == key) && (list[i].metricParam == param)) {
          dock.displayError("A metric configuration with that metric/parameter already exits");
          return;
        }
      }
      list.push(current.object);
      object.set('metrics', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
