/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var old;
var current;
var myDialog;
var dock;
var pelist;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.jobqueue;
  old = current.old(false, true);
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmjob', 'getParallelEnvs', 'sge', function(code, data) {
    if(code == 0) {
      pelist = data;
      if(pelist.length == 0) {
        dock.displayInfo('No parallel environments found, make sure sge has been configured properly and is running.');
      }
      refresh();
    } else {
      dock.jsonCallError(this, code, data);
    }
    refresh();
  }, current);
}

function refresh() {
  var newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  text('tmpdir', '^');
  checkboxlist('pelist', pelist);
  text('prolog', '^');
  text('epilog', '^');
  text('minWalltime', '^');
  text('maxWalltime', '^');
  setfocus('name');

  if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
    document.getElementById("name").setAttribute('disabled', 'true');
    document.getElementById("name").setAttribute('readonly', 'true');
    setfocus('tmpdir');
  } else {
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    myDialog.doCancel();
    close();
  }
}
