/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var current;
var object;
var old;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  if (myDialog.arguments.subobject <= 0) {
    newEdit = true;
    setDialogTitle("New Static Route")
    current = new dock.cvStaticRoute();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('staticRoutes', myDialog.arguments.subobject);
    if (isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if (newEdit) newKey = current.get('uniqueKey');
  text('name', '^');
  text('gateway', dock.REGEX_IPv4);

  var nets = current.cluster.find('Network');
  var list = new Array();
  list.push([0, '']);
  for (var i = 0; i < nets.length; i++) {
    var key = nets[i].get('uniqueKey');
    var name = "(" + nets[i].resolveName() + ") " + nets[i].get("baseAddress") + "/" + nets[i].get("netmaskBits");
    list.push([key, name]);
  }
  kenum('network', list);

  var currentNet = current.get('network') == 0 ? 1 : 0;
  setDestinationType(currentNet);
  text('ip', dock.REGEX_IPv4);
  text('netmaskBits', '^');

  var box = document.getElementById('networkDeviceBox');
  if(object.get('childType') == "NodeCategory") {
    var textbox = document.createElement('textbox');
    textbox.setAttribute('id', 'networkDeviceName');
    textbox.setAttribute('width', '100px');
    textbox.setAttribute('type', 'timed');
    box.appendChild(textbox);
    text('networkDeviceName', '^');
  } else {
    var menulist = document.createElement('menulist');
    menulist.setAttribute('id', 'networkDeviceName');
    var menupopup = document.createElement('menupopup');
    menulist.appendChild(menupopup);
    box.appendChild(menulist);

    var nets = object.get('networks');
    var list = new Array();
    list.push(['', 'none']);
    for (var i = 0; i < nets.length; i++) {
      var name = nets[i].name;
      list.push([name, name]);
    }
    kenum('networkDeviceName', list);
  }
  setfocus('name');
}

function cancel() {
  if (!window.closed) {
    if (!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}

function ok() {
  if (!window.closed) {
    if (blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }

    if (eval(document.getElementById('isNetwork').getAttribute('on'))) {
      if (current.object.network == 0) {
        dock.displayError("Destination cannot be empty");
        return;        
      }
      current.object.ip = '0.0.0.0';
      current.object.netmaskBits = '0';
    } else {
      if ((current.object.ip == '0.0.0.0') ||  (current.object.netmaskBits == '0')) {
        dock.displayError("Destination is invalid");
        return;        
      }
      current.object.network = 0;
    }

    if (newEdit) {
      var list = object.get('staticRoutes');
      list.push(current.object);
      object.set('staticRoutes', list);
    } else if (current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function setDestinationType(index) {
  if(!eval(document.getElementById('isNetwork').getAttribute('disabled'))) {
    document.getElementById('isNetwork').setAttribute('on', index == 0);
    document.getElementById('isnotNetwork').setAttribute('on', index == 1);
  }
  if (index == 0) {
    document.getElementById('ip').setAttribute('disabled', true);
    document.getElementById('netmaskBits').setAttribute('disabled', true);
  } else {
    document.getElementById('ip').removeAttribute('disabled');
    document.getElementById('netmaskBits').removeAttribute('disabled');
  }
}
