/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.jobqueue;
  old = current.old(false, true);
  refresh();
}

function refresh() {
  var newKey = current.get('uniqueKey');
  text('name', '^', '', true, '', newKey);
  kenum('type', ['Execution', 'Route']);
  stringlist('routes', 'Route:');
  text('minWalltime', '^');
  text('maxWalltime', '^');
  text('defaultWalltime', '^');
  text('maxQueuable', '^');
  number('priority', -1024, 1024);
  check('started');
  check('enabled');
  check('aclHostEnable');

  if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
    document.getElementById("name").setAttribute('disabled', 'true');
    document.getElementById("name").setAttribute('readonly', 'true');
    setfocus('minWalltime');
  } else {  
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    myDialog.doCancel();
    close();
  }
}
