/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var detached;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  detached = myDialog.arguments.detached;
  if(myDialog.arguments.subobject == 0) {
    newEdit = true;
    setDialogTitle("Virtual fibre channel interface")
    current = new dock.cvDialog();
    current = new dock.cvObject(object.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('fcAdapterSettings', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  var todoAddList = false; // TODO add lists
  text('name', todoAddList);
  text('wwnn', todoAddList);
  text('wwpn', todoAddList);
  text('channelNumber', todoAddList);
  text('adaptorFcGenProfile', todoAddList, 'maxDataFieldSize');
  text('adaptorFcGenProfile', todoAddList, 'mac');
  text('adaptorFcGenProfile', todoAddList, 'vlan');
  text('adaptorFcGenProfile', todoAddList, 'order');
  text('adaptorFcGenProfile', todoAddList, 'classOfService');
  kenum('uplinkPort', todoAddList);
  kenum('portProfile', todoAddList);
  check('sanBoot', todoAddList);
  check('adaptorFcErrorRecoveryProfile', todoAddList, 'fcpErrorRecovery');
  text('adaptorFcErrorRecoveryProfile', todoAddList, 'linkDownTimeout');
  text('adaptorFcErrorRecoveryProfile', todoAddList, 'portDownIoRetryCount');
  text('adaptorFcErrorRecoveryProfile', todoAddList, 'portDownTimeout');
  text('adaptorFcErrorRecoveryProfile', todoAddList, 'resourceAllocationTimeout');
  text('adaptorFcErrorRecoveryProfile', todoAddList, 'errorDetectTimeout');
  kenum('adaptorFcInterruptProfile', todoAddList, 'mode'); 
  text('adaptorFcPortProfile', todoAddList, 'ioThrottleCount'); 
  text('adaptorFcPortProfile', todoAddList, 'lunsPerTarget'); 
  text('adaptorFcPortFLogiProfile', todoAddList, 'retries'); 
  text('adaptorFcPortFLogiProfile', todoAddList, 'timeout'); 
  text('adaptorFcPortPLogiProfile', todoAddList, 'retries'); 
  text('adaptorFcPortPLogiProfile', todoAddList, 'timeout'); 
  text('adaptorFcCdbWorkQueueProfile', todoAddList, 'count');
  text('adaptorFcCdbWorkQueueProfile', todoAddList, 'ringSize');
  text('adaptorFcWorkQueueProfile', todoAddList, 'ringSize');
  text('adaptorFcRecvQueueProfile', todoAddList, 'ringSize');
  if(detached) {
    return;
  } else {
    setfocus('name');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('');
      list.push(current.object);
      object.set('', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
