/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;
var detached;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  detached = myDialog.arguments.detached;
  if(myDialog.arguments.subobject == 0) {
    newEdit = true;
    setDialogTitle("Virtual ethernet interface")
    current = new dock.cvDialog();
    current = new dock.cvObject(current.cluster, current);
    refresh();
  } else {
    newEdit = false;
    current = object.subObjectFromKey('vicAdapterSettings', myDialog.arguments.subobject);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
  }
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  //Fill in the values here
  var todoAddList = false; // TODO add lists
  text('name', todoAddList);
  document.getElementById("name").setAttribute('disabled', 'true');
  text('mtu', todoAddList);
  text('mac', todoAddList);
  text('usnicCount', todoAddList);
  text('channelNumber', todoAddList);
  check('pxeBoot', todoAddList);
  kenum('uplinkPort', todoAddList);
  kenum('portProfile', todoAddList);
  kenum('classOfService', todoAddList);
  text('adaptorEthGenProfile', todoAddList, 'order');
  //text('adaptorEthGenProfile', todoAddList, 'rateLimit');
  check('adaptorEthGenProfile', todoAddList, 'trustedClassOfService');
  text('adaptorEthGenProfile', todoAddList, 'uplinkFailbackTimeout');
  check('adaptorEthGenProfile', todoAddList, 'uplinkFailover');
  text('adaptorEthGenProfile', todoAddList, 'vlan');
  kenum('adaptorEthGenProfile', todoAddList, 'vlanMode');
  text('adaptorEthCompQueueProfile', todoAddList, 'count');
  text('adaptorEthCompQueueProfile', todoAddList, 'ringSize');
  text('adaptorEthWorkQueueProfile', todoAddList, 'count');
  text('adaptorEthWorkQueueProfile', todoAddList, 'ringSize');
  text('adaptorEthInterruptProfile', todoAddList, 'coalescingTime');
  kenum('adaptorEthInterruptProfile', todoAddList, 'coalescingType');
  text('adaptorEthInterruptProfile', todoAddList, 'count');
  kenum('adaptorEthInterruptProfile', todoAddList, 'mode');
  check('adaptorEthOffloadProfile', todoAddList, 'largeReceive');
  check('adaptorEthOffloadProfile', todoAddList, 'tcpRxChecksum');
  check('adaptorEthOffloadProfile', todoAddList, 'tcpTxChecksum');
  check('adaptorEthOffloadProfile', todoAddList, 'tcpSegment');
  check('adaptorIpV6RssHashProfile', todoAddList, 'ipHash');
  check('adaptorIpV6RssHashProfile', todoAddList, 'tcpHash');
  check('adaptorIpV4RssHashProfile', todoAddList, 'ipHash');
  check('adaptorIpV4RssHashProfile', todoAddList, 'tcpHash');
  check('adaptorExtIpV6RssHashProfile', todoAddList, 'ipHash');
  check('adaptorExtIpV6RssHashProfile', todoAddList, 'tcpHash');
  check('adaptorRssProfile', todoAddList, 'receiveSideScaling');
  if(detached) {
    return;
  } else {
    setfocus('name');
  }
}

function save() {
  if(!window.closed) {
    //TODO: Do some more validation here
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('');
      list.push(current.object);
      object.set('', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}
