/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  var cluster = myDialog.arguments.cluster;
  if(myDialog.arguments.object <= 0) {
    newEdit = true;
    setDialogTitle("Add user")
    document.getElementById("userID").setAttribute('type', 'timed');
    current = new dock.cvUser();
    current = new dock.cvObject(cluster, current, 0, 0, false);
    current.set('homeDirOperation', true);
    refresh();
  } else {
    newEdit = false;
    current = cluster.find(myDialog.arguments.object);
    if(isObject(current)) {
      old = current.old(false, true);
      refresh();
    } else {
      dock.displayError("Key no longer valid");
      myDialog.doCancel();
      close();
    }
    if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
      document.getElementById("userID").setAttribute('disabled', 'true');
      document.getElementById("userID").setAttribute('readonly', 'true');
    }
  }

  old = current.old(false, true);
  refresh();
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  text('userID', '^', '', true, '', newKey);
  text('userIDNumber', '^(<auto>|[0-9]{1,10})$');
  text('commonName', '^');
  text('surname', '^');
  //text('groupIDNumber', '^');
  var list = current.cluster.find("Group");
  var i = 0
  while(i < list.length) {
    var gid = list[i].get('groupID');
    if(gid.length > 0) {
      list[i] = [list[i].get('groupID'), list[i].get('group')];
      i++;
    } else {
      list.splice(i, 1);
    }
  }
  list.push(['', '']);
  document.getElementById('groupIDNumber').setAttribute('forceString', true);
  kenum('groupIDNumber', list);
  text('loginShell', '^');
  text('homeDirectory', '^');
  text('password', '');
  text('email', '');

  text('shadowMax', '^[0-9]{1,10}');
  text('shadowMin', '^[0-9]{1,10}');
  text('shadowWarning', '^[0-9]{1,10}');
  text('shadowInactive', '^[0-9]{1,10}');

  document.getElementById('shadowLastChange').value = daysSince1970(current.get('shadowLastChange'));
//   document.getElementById('shadowExpire').value = daysSince1970(current.get('shadowExpire'));
  datetext('shadowExpire', DATE_FORMAT, 'shadowExpire', true);

  document.getElementById('password2').value = current.get('password');
  blankAuto('userIDNumber');
  blankAuto('groupIDNumber');
  blankAuto('loginShell');
  blankAuto('homeDirectory');

  // profiles
  var profList = current.cluster.find("Profile");
  i = 0;
  while(i < profList.length) {
    var profile = profList[i];
    var pname = profile.get('name');
    var nonuser = profile.get('nonuser');
    if (!nonuser) {
      profList[i] = [pname, pname];
      i++;
    } else {
      profList.splice(i, 1);
    }
  }
  profList.push(['', 'none']);
  kenum('profile', profList);

  var r = checkresolvelist('hadoopHDFS', 'HadoopHDFS');
  if(r[1] == 0) r[0].parentNode.setAttribute('hidden', true);

/*
  REMOVED
  TODO: remove in 7.2
  var openStacks = current.cluster.find("OpenStack");
  if(openStacks.length > 0) {
    document.getElementById("OpenStackAccess").removeAttribute('hidden');
  }
*/
  if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
    setfocus('commonName');
  } else {
    setfocus('userID');
  }
}

function blankAuto(name) {
  if(blank(current.get(name))) {
    document.getElementById(name).value = '<auto>';
    document.getElementById(name).setAttribute('value', '<auto>');
    document.getElementById(name).setAttribute('label', '<auto>');
  }
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('userID'))) {
      dock.displayError("User name cannot be empty");
      return;
    }
    if(document.getElementById('password2').value != current.get('password')) {
      dock.displayError("Password mismatch");
      return;
    }
    if(newEdit) {
      myDialog.arguments.cluster.addObject(current);
    }
    myDialog.doOk();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    myDialog.doCancel();
    close();
  }
}

function setDate(name) {
  var args = new Object();
  var t = current.get(name) * 86400;
  var d = new Date();
  d.setTime(t * 1000);
  args['date'] = d;
  var d = new dock.cvDialog("datepickerwindow.xul", args);
  d.parentWindow = window;
  d.onOk = function(date) {
    document.getElementById(name).setAttribute('value', date.format(DATETIME_FORMAT));
    current.set(name, Math.floor(date.getTime() / (1000 * 86400)));
  }
  dock.dialogs.showDialog(d);
}

function advancedWindow(name) {
  if(name == "OpenStackUserSettings") {
    var args = new Object();
    args['object'] = current;
    args['cluster'] = current.cluster;
    var settings = current.get('openStackSettings');
    args['subobject'] = new dock.cvObject(current.cluster, settings);
    println("Advanced: " + "chrome://cmgui/content/openstack/advanced" + name.toLowerCase() + ".xul");
    var d = new dock.cvDialog("chrome://cmgui/content/openstack/advanced" + name.toLowerCase() + ".xul", args);
    d.parentWindow = window;
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

