/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;
var cluster;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  var old = current;
  if(!!use) current = use;
  println("Refresh ethernet switch overview" + ' - ' + document.documentURI);

  var model = document.getElementById('model');
  if(old != current) {
    model.setAttribute('value', '');
    var obj = document.getElementById('ports');
    while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  }

  cluster = current.cluster;  
  overviewValue('state', current.fullStateString());
  
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getNetSwitchOverview', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0 && data) {
        if(model.getAttribute('value') == '') model.setAttribute('value', 'Please wait');
      } else {
        if(model.getAttribute('value') == '') model.setAttribute('value', 'N/A');
        if(code) dock.jsonCallError(this, code, data);
      }
    }, current);
}

function update(event) {
  println("Update ethernet switch overview");
  document.getElementById('model').setAttribute('value', firstLine(event.model, 60));

  var obj = document.getElementById('ports');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = event.status;
  for(var i = 0; i < data.length; i++) {
    switchOverviewRow(obj, i, data[i]);
  }
}
