/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh switch settings" + ' - ' + document.documentURI);
  text('hostname', dock.REGEX_HOSTNAME, '', true);
  text('tag');
  partial('mac', ':', '^[0-9a-fA-F]{2}$', '', true, '00:00:00:00:00:00');
//   partial('ip', '.', dock.REGEX_IPv4);
  text('ip', dock.REGEX_IPv6);
  resolve('network', 'Network', '', true);

  rackPostionSettings();

  numberlist('uplinks', "Uplink:");
  text('lowestPort', '^[0-9]$');

  var list = ['none', 'apc', 'custom'];
  var pwctl = current.get('powerControl');
  if(startswith(pwctl, 'ipmi')) {
    list.push(pwctl);
  }
  kenum('powerControl', list);
  text('customPowerScript');
  text('customPowerScriptArgument');
  text('customPingScript');
  text('customPingScriptArgument');
  text('userdefined1');
  text('userdefined2');
  text('revision');
  text('controlScript');
  text('controlScriptTimeout', '^[0-9]{1,2}$');

  text('readString');
  text('writeString');

  toggle('readString');
  toggle('writeString');
  
  createApc();
}

function toggle(name) {
  var objT = document.getElementById(name);
  var objC = document.getElementById('display_' + name);  
  if(objC.checked) {
    objT.setAttribute('value', objT.value);
    objT.setAttribute('type', 'timed');
  } else {
    objT.setAttribute('type', 'password');
  }
}
