/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var text;
var event;

function onLoad() {
  dock = getDock();
  println("Error initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  event = myDialog.arguments.event;
  formatText();
  document.getElementById('message').value = text;
  document.getElementById('close').focus();

  if(myDialog.arguments.event.ack) {
    document.getElementById('ack').setAttribute('label', 'Unacknowledge');
  }

}

function formatText() {
  text = "Time stamp:\t " + event.date + "\n";
  text += "Cluster:\t\t " + event.cluster + "\n";
  text += "Source node:\t "  + event.source + "\n";
  text += "HWTag:\t\t "  + event.tag + "\n";
  text += "Severity:\t\t " + event.severity + "\n";
  text += "= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =\n";
  if(event.details.length > 0) {
    text += event.details;
  } else {
    text += event.message;
  }
}

function ack() {
  myDialog.onOk();
  close();
}

function report() {
  var data = "Time stamp:\t\t " + current.date + "\n";
  data += "Cluster:\t\t " + current.cluster + "\n";
  data += "Source node:\t\t "  + current.source + "\n";
  data += "HWTag:\t\t\t "  + current.tag + "\n";
  data += "Severity:\t\t " + event.severity + "\n";
  data += "= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =\n";
  data += current.message + "\n";
  if(current.data) data += current.data + "\n";
  data += "= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =\n";
  data += "Cluster information:\n";
  data += "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n";
  var overview = current.clusterObject.licenseInfo;
  data += "CMGui version:\t\t " + dock.cmguiVersion + "\n";
  if(overview) {
    data += "Mac address:\t\t " + overview.macAddress + "\n";
    data += "Licensed nodes:\t\t " + overview.licensedNodes + "\n";
    data += "Mode count:\t\t " + overview.nodeCount + "\n";
    data += "Version:\t\t " + overview.version + "\n";
    data += "Start time:\t\t " + formatDate(overview.startTime) + "\n";
    data += "End time:\t\t " + formatDate(overview.endTime) + "\n";
    data += "Licensee:\t\t " + overview.licensee + "\n";
  } else {
    data += "Error: Unable to retrieve license information!";
  }
  var overview = current.clusterObject.versionInfo;
  if(overview) {
    data += "Cluster Manager version:\t\t " + overview.cmVersion + "\n";
    data += "CMDaemon version:\t " + overview.cmdaemonVersion + "\n";
    data += "CMDaemon build:\t\t " + overview.cmdaemonBuild + "\n";
    data += "Database version:\t " + overview.databaseVersion + "\n";
  } else {
    data += "Error: Unable to retrieve version information!";
  }
  data += "= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =\n";
  var result = postData("http://updates.brightcomputing.com/cgi-bin/cmguireport.cgi", data);
  dock.displayInfo(result);
}
