/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

var dock;
var myDialog;
var filter;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  filter = myDialog.arguments.viewer.filter;

  document.getElementById('apply').setAttribute('disabled', myDialog.arguments.viewer.tab == dock.NEW_TAB);

  refresh();
  document.getElementById('name').focus();
}

function refresh() {
  var timeList = [[3600, '1 hour'], [43200, '12 hours'], [86400, '1 day'], [259200, '3 days'],
                  [608400, '7 days'], [2678400, '1 month'], [31526000, '1 year'], [94578000, '3 years']];
  var myTime = 3600;

  document.getElementById('name').setAttribute('value', filter.name);
  document.getElementById('showAcked').checked = filter.showAcked;
  document.getElementById('message').setAttribute('value', filter.message);
  if(filter.time[1] == 0) {
    setTimeType(1);
    var d = new Date();
    datetext('enddate', DATETIME_FORMAT, d);
    myTime = filter.time[0];
    d.setTime(d.getTime() - myTime * 1000);
    for(var i = 0; i < timeList.length; i++) {
      if(timeList[i][0] == myTime) break;
      if(timeList[i][0] > myTime) {
        timeList.splice(i, 0, [myTime, formatDHM(myTime)]);
        break;
      }
    }
    datetext('startdate', DATETIME_FORMAT, d);
  } else {
    setTimeType(0);
    var d = new Date();
    d.setTime(filter.time[1] * 1000);
    datetext('enddate', DATETIME_FORMAT, d);
    var d = new Date();
    d.setTime(filter.time[0] * 1000);
    datetext('startdate', DATETIME_FORMAT, d);
  }
  var popup = document.getElementById('lasttime').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < timeList.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', timeList[i][1]);
    item.setAttribute('time', timeList[i][0]);
    popup.appendChild(item);
    if(timeList[i][0] == myTime) document.getElementById('lasttime').selectedIndex = i;
  }

  var popup = document.getElementById('severity').firstChild;
  var item = popup.firstChild;
  var index = 0;
  while(item) {
    if(parseInt(item.getAttribute('key')) == filter.severity) break;
    index++;
    item = item.nextSibling;
  }
  popup.parentNode.selectedIndex = index;

  var popup = document.getElementById('maxseverity').firstChild;
  var item = popup.firstChild;
  var index = 0;
  while(item) {
    if(parseInt(item.getAttribute('key')) == filter.maxseverity) break;
    index++;
    item = item.nextSibling;
  }
  popup.parentNode.selectedIndex = index;
  
  var popup = document.getElementById('cluster').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  var item = document.createElement('menuitem');
  item.setAttribute('label', 'All Clusters');
  item.setAttribute('key', 0);
  popup.appendChild(item);
  if(filter.cluster == 0) document.getElementById('cluster').selectedIndex = 0;
  var j = 0;
  for(var i = 0; i < dock.clusterlist.length; i++) {
    if(!blank(dock.clusterlist[i].name) && dock.clusterlist[i].connected) {
      var item = document.createElement('menuitem');
      item.setAttribute('label', dock.clusterlist[i].name);
      item.setAttribute('key', 'key://' + dock.clusterlist[i].key);
      popup.appendChild(item);
      j++;
      if(filter.cluster == dock.clusterlist[i]) {
        document.getElementById('cluster').selectedIndex = j;
      }
    }
  }
  fillNodes(filter.cluster);
}

function fillNodes(cluster) {
  if(cluster && !isObject(cluster)) {
    cluster = dock.findObject(cluster);
  }
  var popup = document.getElementById('node').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  var item = document.createElement('menuitem');
  item.setAttribute('label', 'All Nodes');
  item.setAttribute('key', 0);
  popup.appendChild(item);
  if(filter.source == 0) document.getElementById('node').selectedIndex = 0;
  var item = document.createElement('menuitem');
  item.setAttribute('label', 'Current Node');
  item.setAttribute('key', -1);
  popup.appendChild(item);
  if(filter.source == -1) document.getElementById('node').selectedIndex = 1;
  if(cluster) {
    var nodes = cluster.find('Node');
    for(var i = 0; i < nodes.length; i++) {
      var item = document.createElement('menuitem');
      item.setAttribute('label', nodes[i].get('hostname'));
      item.setAttribute('key', nodes[i].get('uniqueKey'));
      popup.appendChild(item);
      if(filter.source == nodes[i].get('uniqueKey')) document.getElementById('node').selectedIndex = i + 2;
    }
  }
}

function selectSeverity(event) {
//   var item = document.getElementById('severity').selectedItem;
//   if(item) {
//      = dock.findObject(item.getAttribute('key'));
//   }
}

function selectCluster(event) {
  var item = document.getElementById('cluster').selectedItem;
  if(item) {
    var cluster = dock.findObject(item.getAttribute('key'));
    fillNodes(cluster);
  }
}

function setTimeType(index) {
  document.getElementById('between').setAttribute('on', index == 0);
  document.getElementById('last').setAttribute('on', index == 1);
}

function setDate(name) {
  var args = new Object();
  var t = document.getElementById(name).getAttribute('time');
  var d = new Date();
  d.setTime(t * 1000);
  args['date'] = d;
  var d = new dock.cvDialog("datepickerwindow.xul", args);
  d.parentWindow = window;
  d.onOk = function(date) {
    document.getElementById(name).setAttribute('value', date.format(DATETIME_FORMAT));
    document.getElementById(name).setAttribute('time', Math.floor(date.getTime() / 1000));
  }
  dock.dialogs.showDialog(d);
}

function ok() {
  if(apply()) cancel();
}

function store() {
  if(blank(document.getElementById('name').value)) return false;
  filter.name = document.getElementById('name').value;
  filter.message = document.getElementById('message').value;
  filter.showAcked = document.getElementById('showAcked').checked;
  if(eval(document.getElementById('between').getAttribute('on'))) {
    filter.time[0] = parseInt(document.getElementById('startdate').getAttribute('time'));
    filter.time[1] = parseInt(document.getElementById('enddate').getAttribute('time'));
  } else {
    var item = document.getElementById('lasttime').selectedItem;
    if(item) {
      filter.time[0] = item.getAttribute('time');
      filter.time[1] = 0;
    }
  }
  var item = document.getElementById('cluster').selectedItem;
  if(item) {
    filter.cluster = item.getAttribute('key');
    if(filter.cluster && (filter.cluster != '0')) {
      filter.cluster = dock.findObject(filter.cluster);
      filter.cluster = isundefined(filter.cluster, 0);
    } else {
      filter.cluster = 0;
    }
  }
  var item = document.getElementById('node').selectedItem;
  if(item) filter.source = item.getAttribute('key');
  var item = document.getElementById('severity').selectedItem;
  if(item) filter.severity = item.getAttribute('key');
  var item = document.getElementById('maxseverity').selectedItem;
  if(item) filter.maxseverity = item.getAttribute('key');
  return true;
}

function apply() {
  if(store()) {
    myDialog.arguments.viewer.filter = filter;
    myDialog.arguments.viewer.refresh();
    myDialog.onOk();
    return true;
  }
  return false;
}

function cancel() {
  close();
}

function saveEvent() {
  store();
  var xFilter = dock.findFilter(filter.name);
  if(xFilter) {
    var args = new Object();
    args['question'] = "Override existing filter";
    var d = new dock.cvDialog("question.xul", args);
    d.parentWindow = window;
    d.onOk = function() {
      xFilter = filter;
      dock.saveEventFilters();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.eventFilters.push(filter);
    dock.saveEventFilters();
  }
}

function loadEvent() {
  var args = new Object();
  args['title'] = 'Select Event Filter';
  var d = new dock.cvDialog("selectfilter.xul", args);
  d.parentWindow = window;
  d.onOk = function(name) {
    filter = dock.findFilter(name);
    if(filter) {
      myDialog.arguments.viewer.filter = filter.clone();
      refresh();
    }
  }
  dock.dialogs.showDialog(d);
}
