/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var viewer;

function onLoad() {
  dock = getDock();
  tree = document.getElementById('tree');
  if(this.name.length > 0) {
    println("Event page initialized: " + this.name);
    var s = this.name.indexOf('[');
    var e = this.name.indexOf(']');
    var index = this.name.substr(s + 1, e - s - 1);
    refresh(dock.eventViewers[index]);
  }
}

function saveOrder() {
  var order = tree.getAttribute("sortOrder").split(',');
  viewer.order = new Array();
  for(var i = 0; i < order.length; i++) {
    var obj = document.getElementById(order[i]);
    if(obj) viewer.order.push([order[i], obj.getAttribute('sortDirection')]);
  }
}

function refresh(use) {
  if(!!use) {
    viewer = use;
    viewer.frame = window;
  } else {
    saveOrder();
  }
  var list = viewer.filter.apply();
  data = new Array();
  for(var i = 0; i < list.length; i++) {
    data.push(oneTreeItem(list[i]));
  }
  for(var i = list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var order = new Array();
  for(var i = 0; i < viewer.order.length; i++) {
    order.push(viewer.order[i][0]);
    var obj = document.getElementById(viewer.order[i][0]);
    if(obj) obj.setAttribute('sortDirection', viewer.order[i][1]);
  }
  document.getElementById('acked').setAttribute('hidden', !viewer.filter.showAcked);
  tree.setAttribute("sortOrder", order.join(','));
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function oneTreeItem(event) {
  var item = new Object();
  item['key'] = event.key;
  item['severityImage.src'] = event.image;
  item['acked'] = event.ack;
  item['bid'] = sprintf('%08d', event.event.bid);
  item['date'] = event.date;
  item['cluster'] = event.cluster;
  item['source'] = event.source;
  item['message'] = event.message;
  item['severity'] = event.severity;
  return item;
}

function displayEvent(event) {
  var select = selected('list');
  for(var i = 0; i < select.length; i++) {
    dock.showEvent(select[i]);
  }
}
