/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

importScripts('logging.js');

var eventWaitTime = 15;

var debug = false;
var request = 0;
var url = '';
var sessionid = 0;

function jsoncall(data) {  
  if(!request) {
    request = new XMLHttpRequest();
    function ondata() {
      if(debug) {
        dump("jsoncall: output\n");
        if(request) {
          dump(request.responseText);
          dump("\n\n");
        } else {
          dump(request);
          dump("\n\n");
        }
      }
      if(request && request.responseText) {
        try {
          var out = JSON.parse(request.responseText);
          postMessage([0, out]);
          if(typeof(out) == 'number') {
            if(debug) dump("EventWorker: sessionid = " + out + "\n");
            sessionid = out;
          }
        } catch(e) {
          postMessage([2, e]);
        }
      } else {
        postMessage([1, 'Call returned no data']);
      }
      request = null;
    }
    function ontimeout() {
      if(debug) println("jsoncall: timeout");
      postMessage([-2, 'Timeout in XMLHttpRequest']);
      request = null;
    }
    function onerror() {
      if(debug) dump("jsoncall: error\n");
      postMessage([-1, 'Error in XMLHttpRequest']);
      request = null;
    }
    request.onload = ondata;
    request.onerror = onerror;
    if(typeof(request.ontimeout) != 'undefined') { // not for gecko < 12.0
      request.timeout = eventWaitTime * 2000;
      request.ontimeout = ontimeout;
    }
  }
  if(debug) {
    dump("Sending to " + url + "json, bytes = " + data.length + "\n");
    dump(data);
    dump("\n");
  }
  request.open("POST", url + 'json', true);
  request.send(data);
}  

onmessage = function(event) {  
  if(event.data && isArray(event.data) && (typeof(event.data[0]) == 'string')) {
    if(event.data[0] == 'ABORT') {
      sessionid = 0;
      if(request) request.abort();
      if(debug) dump("EventWorker: abort\n");
    } else if(event.data[0] == 'URL') {
      url = event.data[1];
      if(debug) dump("EventWorker: Set url: '" + url + "'\n");
    } else if(event.data[0] == 'LAST') {
      var last = event.data[1];
      if(debug) dump("EventWorker: get last: '" + last + "'\n");
      jsoncall('{"service":"cmsession","call":"getLastEvents","args":[0,' + last + ']}');
    } else if(event.data[0] == 'SESSION') {
      var type = event.data[1];
      if(debug) dump("EventWorker: Set type: '" + type + "'\n");
      jsoncall('{"service":"cmsession","call":"registerSession","arg":' + type + '}');
    } else if(event.data[0] == 'DEBUG') {
      debug = (event.data[1] == 'ON');
    } else {
      jsoncall('{"service":"cmsession","call":"waitForEvents","args":[' + sessionid + ',' + eventWaitTime + ']}');
    }
  } else {
    dump('EventWorker: bad data\n');
    printall(event.data);
    postMessage([-1000, 'bad data']);
  }
}
