/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function setRole(role, category) {
  var obj = document.getElementById('has' + role.childType);
  if(obj) {
    var one = setGenericRole(role, category, obj);
    if(role.childType == 'ProvisioningRole') {
      var checkAll = " \
      function checkAll(work, role, what) { \
        var u = false; \
        var a = 0; \
        var b = 0; \
        if(what == 'allImages') { \
          u = true; \
        } else if(what == 'localImages') { \
          a = role.get('localImages'); \
          b = role.get('sharedImages'); \
        } else if(what == 'sharedImages') { \
          a = role.get('sharedImages'); \
          b = role.get('localImages'); \
        } \
        if(a && b) { \
          for(var i = 0; i < a.length; i++) { \
            for(var j = 0; j < b.length; j++) { \
              if(b[j] == a[i]) { \
                println('remove one'); \
                b.splice(j, 1); \
                u = true; \
                break; \
              } \
            } \
          } \
        } \
        if(u) refresh(); \
      } "
      role_number('maxProvisioningNodes', one, category, 0, 32, '', 0);
      var images = current.cluster.find('SoftwareImage');
      role_checkboxlist('localImages', one, category, images, 'allImages', 'All', 'LOCALDISK', 'NOTALLIMAGES', ['SHAREDSTORAGE'], checkAll);
      role_checkboxlist('sharedImages', one, category, images, 'allImages', 'All', 'SHAREDSTORAGE', 'NOTALLIMAGES', ['LOCALDISK'], checkAll);
      role_checkboxlist('nodegroups', one, category, current.cluster.find('NodeGroup'));
    } else if(role.childType == 'UGEClientRole') {
      role_text('slots', one, category);
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('UGEJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'SGEClientRole') {
      role_text('slots', one, category);
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('SGEJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'TorqueClientRole') {
      role_text('slots', one, category);
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('TorqueJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'PbsProClientRole') {
      role_text('slots', one, category);
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('PbsProJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'SlurmClientRole') {
      role_text('slots', one, category);
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('SlurmJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkbox('powerSavingAllowed', one, category);
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'LSFClientRole') {
      role_text('slots', one, category, '^[0-9]{1,5}|auto$');
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('LSFJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'OpenLavaClientRole') {
      role_text('slots', one, category, '^[0-9]{1,5}|auto$');
      role_text('gpus', one, category, '^[0-9]{1,2}$');
      var list = current.cluster.find('OpenLavaJobQueue');
      for(var i = 0; i < list.length; i++) {
        list[i] = list[i].resolveName();
      }
      role_checkboxlist('queues', one, category, list, 'allQueues', 'All');
    } else if(role.childType == 'TorqueServerRole') {
      role_enum('scheduler', one, ['maui', 'moab', 'torque'], category);
    } else if(role.childType == 'SlurmServerRole') {
      role_enum('scheduler', one, ['backfill', 'builtin', 'maui', 'moab'], category);
    } else if(role.childType == 'CloudDirectorRole') {
      var ip = role.externalIp.split('.');
      if(ip.length == 4) {
        for(var i = 0; i < 4; i++) {
          document.getElementById('CloudDirectorRole_externalIp-' + i).value = ip[i];
        }
      } else {
        for(var i = 0; i < 4; i++) {
          document.getElementById('CloudDirectorRole_externalIp-' + i).value = '0';
        }
      }
    } else if(role.childType == 'MasterRole') {
      // NADA
    } else if(role.childType == 'SubnetManagerRole') {
      role_enum('interconnect', one, ['IB', ['OMNI', "Omni-Path"]], category);
    } else if(role.childType == 'StorageRole') {
      role_text('nfsThreads', one, category, '^[0-9]{1,5}$');
//       role_checkbox('nss', one, category);
    } else if(role.childType == 'BootRole') {
    } else if(role.childType == 'LoginRole') {
    } else if(role.childType == 'MICHostRole') {
    } else if(role.childType == 'CloudGatewayRole') {
    } else if(role.childType == 'SubnetManagerRole') {
    } else if(role.childType == 'OpenLavaServerRole') {
    } else if(role.childType == 'LSFServerRole') {
    } else if(role.childType == 'PbsProServerRole') {
    } else if(role.childType == 'UGEServerRole') {
    } else if(role.childType == 'SGEServerRole') {
    } else if(role.childType == 'FailoverRole') {
    } else if(role.childType == 'HAProxyRole') {
    } else if(role.childType == 'MemcachedRole') {
    } else if(role.childType == 'GaleraRole') {
    } else {
      println("Warning unsupported role: " + role.childType);
    }
  } else {
    if(!startswith(role.childType, 'OpenStack') && !role.childType=="HAProxyRole") {
      println("Warning unknown role: " + role.childType);
    }
  }
}
