/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function createApc() {
  var rows = document.getElementById('powerdistributionunits');
  while(rows.firstChild) rows.removeChild(rows.firstChild);
  var apc = current.get('powerDistributionUnits');
  for(var i = 0; i < apc.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    rows.appendChild(row);
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Power distribution unit:');
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    var menulist = document.createElement("menulist");
    var popup = document.createElement("menupopup");
    menulist.appendChild(popup);
    menulist.setAttribute('id', 'powerDistributionUnits_' + i + 'pdu');
    row.appendChild(menulist);
    resolve('powerDistributionUnits_' + i, 'PowerDistributionUnit', 'pdu');

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Port:');
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    var menulist = document.createElement("menulist");
    var popup = document.createElement("menupopup");
    menulist.appendChild(popup);
    menulist.setAttribute('id', 'powerDistributionUnits_' + i + 'prt');
    row.appendChild(menulist);
    number('powerDistributionUnits_' + i, 0, 32, '', 0, 'prt');

    var minus = document.createElement("button");
    minus.setAttribute('class', 'minus-button');
    minus.setAttribute('oncommand', 'removeApc(' + i + ');');
    row.appendChild(minus);
    if(i == apc.length - 1) {
      var plus = document.createElement("button");
      plus.setAttribute('class', 'plus-button');
      plus.setAttribute('oncommand', 'addApc();');
      row.appendChild(plus);
    } else {
/*      var hbox = document.createElement("hbox");
      hbox.setAttribute('height', '1');
      hbox.setAttribute('width', '450px');
      hbox.setAttribute('style', 'border-top:dotted #bdbdbd 1px; border-bottom:dotted #efefef 1px;');
      rows.appendChild(hbox);*/
    }
  }
  if(apc.length == 0) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    rows.appendChild(row);
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', 'Power distribution unit:');
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    if(!dock.PLUS_LEFT) {
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
    }

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'start');
    hbox.setAttribute('style', 'margin-left: -6px;');
    var plus = document.createElement("button");
    plus.setAttribute('class', 'plus-button');
    plus.setAttribute('oncommand', 'addApc();');
    hbox.appendChild(plus);
    row.appendChild(hbox);
  }
}

function removeApc(index) {
  var args = new Object();
  args['question'] = "Are you sure you want to remove this power distribution unit?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    var list = current.get('powerDistributionUnits');
    if((index >= 0) && (index < list.length)) {
      list.splice(index, 1);
      current.set('powerDistributionUnits', list);
      createApc();
    } else {
      println("Attemp to remove illegal element of: powerDistributionUnits");
      println("  length = " + list.length + ", index = " + index);
    }
  }
  dock.dialogs.showDialog(d);
}

function addApc() {
  var list = current.get('powerDistributionUnits');
  var one = new dock.cvPDUPort();
  var tmp = new dock.cvObject(current.cluster, one);
  list.push(one);
  current.set('powerDistributionUnits', list);
  createApc();
}
