/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function powerOff(key) {
  var delay = current.cluster.setup.powerOffDelay;
  var keys;
  if(typeof(key) == 'undefined') {
    keys = [this.current.get('uniqueKey')];
  } else if(key < 0) {
    keys = current.get('members');
  } else {
    keys = [key];
  }
  var args = new Object();
  args['question'] = "Are you sure you want to power off this " + deviceName + "?";
  args['check'] = "Also closed " + deviceNamePlural;
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(force) {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'powerOff', [keys, delay, current.cluster.sessionid, force, true], function(code, data) {
      if(code == 0) {
        if(!data) {
          dock.displayError("Power off failed");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
  dock.dialogs.showDialog(d);
}

function powerOn(key) {
  var delay = current.cluster.setup.powerOnDelay;
  var keys;
  if(typeof(key) == 'undefined') {
    keys = [this.current.get('uniqueKey')];
  } else if(key < 0) {
    keys = current.get('members');
  } else {
    keys = [key];
  }
  var args = new Object();
  args['question'] = "Are you sure you want to power on this " + deviceName + "?";
  args['check'] = "Also closed " + deviceNamePlural;
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(force) {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'powerOn', [keys, delay, current.cluster.sessionid, force, true], function(code, data) {
      if(code == 0) {
        if(!data) {
          dock.displayError("Power on failed");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
  dock.dialogs.showDialog(d);
}
function powerReset(key) {
  var delay = current.cluster.setup.powerOffDelay;
  var keys;
  if(typeof(key) == 'undefined') {
    keys = [this.current.get('uniqueKey')];
  } else if(key < 0) {
    keys = current.get('members');
  } else {
    keys = [key];
  }
  var args = new Object();
  args['question'] = "Are you sure you want to power reset this " + deviceName +"?";
  args['check'] = "Also closed " + deviceNamePlural;
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(force) {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'powerCycle', [keys, delay, current.cluster.sessionid, force, true], function(code, data) {
      if(code == 0) {
        if(!data) {
          dock.displayError("Power reset failed");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
  dock.dialogs.showDialog(d);
}
