/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function telnetShell() {
  if(current.stateString() == "Up") {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmproc', 'startTelnetOnDevice', current.get('uniqueKey'), function(code, data) {
      if(code == 0) {
        if(data.length) {
          var args = [this.current.cluster.host, this.current.cluster.port, data, this.current.resolveName(), 'Telnet Shell'];
          var d = new dock.cvDialog("remoteshell.xul", args);
          dock.dialogs.showShell(d);
        } else {
          dock.displayInfo("The device did not return a login token");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  } else {
    dock.displayInfo("This device is not up");
  }
}

function sshShell() {
  if(current.stateString() == "Up") {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmproc', 'startSSHOnDevice', current.get('uniqueKey'), function(code, data) {
      if(code == 0) {
        if(data.length) {
          var args = [this.current.cluster.host, this.current.cluster.port, data, this.current.resolveName(), 'Ssh Shell'];
          var d = new dock.cvDialog("remoteshell.xul", args);
          dock.dialogs.showShell(d);
        } else {
          dock.displayInfo("The device did not return a login token");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  } else {
    dock.displayInfo("This device is not up");
  }
}
