/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function checklist(what, list) {
  var listbox = document.getElementById(what);
  while(listbox.firstChild) listbox.removeChild(listbox.firstChild);
  var found = current.get(what);
  for(var i = 0; i < list.length; i++) {
    var item = document.createElement("listitem");
    item.setAttribute('label', list[i]);
    item.setAttribute('type', 'checkbox');
    item.setAttribute('checked', (found.find(list[i]) >= 0));
    listbox.appendChild(item);
  }
  listbox.setAttribute('what', what);
  listbox.setAttribute('oncommand', "buildList('" + what + "');");
}

function buildList(what) {
  var listbox = document.getElementById(what);
  var list = new Array();
  var item = listbox.firstChild;
  while(item) {
    if(item.getAttribute('checked')) list.push(item.getAttribute('label'));
    item = item.nextSibling;
  }
  current.set(what, list);
}

function checkresolvelist(what, type) {
  var listbox = document.getElementById(what);
  while(listbox.firstChild) listbox.removeChild(listbox.firstChild);
  var list = current.cluster.find(type);
  var found = current.get(what);
  for(var i = 0; i < list.length; i++) {
    var item = document.createElement("checkimage");
    var key = list[i].get('uniqueKey');
    item.setAttribute('label', list[i].resolveName());
    item.setAttribute('key', key);
    item.setAttribute('checked', (found.find(key) >= 0));
    item.setAttribute('oncommand', "buildresolveList('" + what + "');");
    item.setAttribute('what', what);
    listbox.appendChild(item);
  }
  return [listbox, list.length];
}

function buildresolveList(what) {
  var listbox = document.getElementById(what);
  var list = new Array();
  var item = listbox.firstChild;
  while(item) {
    if(item.getAttribute('checked') == 'true') list.push(parseInt(item.getAttribute('key')));
    item = item.nextSibling;
  }
  printall(list);
  current.set(what, list);
}

function stringlist(what, title, format) {
  format = isundefined(format, '');
  var rows = document.getElementById(what);
  while(rows.firstChild) rows.removeChild(rows.firstChild);
  var found = current.get(what);
  for(var i = 0; i < found.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    if(title.length > 0) {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('pack', 'end');
      var label = document.createElement("shadowlabel");
      label.setAttribute('value', title);
      label.setAttribute('class', 'staticdataheader');
      hbox.appendChild(label);
      row.appendChild(hbox);
    }

    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', what + '_' + i);
    textbox.setAttribute('class', 'stringlist');
    row.appendChild(textbox);

    var minus = document.createElement("button");
    minus.setAttribute('class', 'minus-button');
    minus.setAttribute('oncommand', "removeItem('" + what + "', '" + title + "', '" + format + "', "  + i + ");");
    row.appendChild(minus);
    if(i == found.length - 1) {
      var plus = document.createElement("button");
      plus.setAttribute('class', 'plus-button');
      plus.setAttribute('oncommand', "addItem('" + what + "', '" + title + "', '" + format + "');");
      row.appendChild(plus);
      rows.appendChild(row);
    } else {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('height', '4px');
      rows.appendChild(row);
      rows.appendChild(hbox);
    }
  }
  for(var i = 0; i < found.length; i++) {
    text(what + '_' + i, format);
  }
  if(found.length == 0) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    if(title.length > 0) {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('pack', 'end');
      var label = document.createElement("shadowlabel");
      label.setAttribute('value', title);
      label.setAttribute('class', 'staticdataheader');
      hbox.appendChild(label);
      row.appendChild(hbox);
    }

    if(!dock.PLUS_LEFT) {
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
    }

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'start');
    hbox.setAttribute('style', 'margin-left: -6px;');
    var plus = document.createElement("button");
    plus.setAttribute('class', 'plus-button');
    plus.setAttribute('oncommand', "addItem('" + what + "', '" + title + "', '" + format + "');");
    hbox.appendChild(plus);
    row.appendChild(hbox);
    rows.appendChild(row);
  }
}

function removeItem(what, title, format, index) {
  var list = current.get(what);
  if((index >= 0) && (index < list.length)) {
    if(blank(list[index])) {
      list.splice(index, 1);
      current.set(what, list);
      stringlist(what, title, format);
      return;
    }
  } else {
    println("Attemp to remove illegal element of: " + what);
    println("  length = " + list.length + ", index = " + index);
    return;
  }

  if(title.length) {
    var args = new Object();
    var single = pluralToSingular(title.toLowerCase().replace(':', ''));
    args['question'] = "Are you sure you want to remove this " + single + "?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      var list = current.get(what);
      if((index >= 0) && (index < list.length)) {
        list.splice(index, 1);
        current.set(what, list);
        stringlist(what, title, format);
      }
    }
    dock.dialogs.showDialog(d);
  } else {
    var list = current.get(what);
    if((index >= 0) && (index < list.length)) {
      list.splice(index, 1);
      current.set(what, list);
      stringlist(what, title, format);
    }
  }
}

function addItem(what, title, format) {
  var list = current.get(what);
  list.push('');
  current.set(what, list);
  stringlist(what, title, format);
}

/* SPECIAL CASE: NUMBER */
function numberlist(what, title) {
  var format = '^[0-9]+$';
  var rows = document.getElementById(what);
  while(rows.firstChild) rows.removeChild(rows.firstChild);
  var found = current.get(what);
  for(var i = 0; i < found.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', what + '_' + i);
    textbox.setAttribute('class', 'stringlist');
    row.appendChild(textbox);

    var minus = document.createElement("button");
    minus.setAttribute('class', 'minus-button');
    minus.setAttribute('oncommand', "removeNumberItem('" + what + "', '" + title + "', '" + format + "', "  + i + ");");
    row.appendChild(minus);
    if(i == found.length - 1) {
      var plus = document.createElement("button");
      plus.setAttribute('class', 'plus-button');
      plus.setAttribute('oncommand', "addNumberItem('" + what + "', '" + title + "', '" + format + "');");
      row.appendChild(plus);
      rows.appendChild(row);
    } else {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('height', '4px');
      rows.appendChild(row);
      rows.appendChild(hbox);
    }
  }
  for(var i = 0; i < found.length; i++) {
    text(what + '_' + i, format);
  }
  if(found.length == 0) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    if(!dock.PLUS_LEFT) {
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
    }

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'start');
    hbox.setAttribute('style', 'margin-left: -6px;');
    var plus = document.createElement("button");
    plus.setAttribute('class', 'plus-button');
    plus.setAttribute('oncommand', "addNumberItem('" + what + "', '" + title + "', '" + format + "');");
    hbox.appendChild(plus);
    row.appendChild(hbox);
    rows.appendChild(row);
  }
}

function removeNumberItem(what, title, format, index) {
  var args = new Object();
  var single = pluralToSingular(title.toLowerCase().replace(':', ''));
  args['question'] = "Are you sure you want to remove this " + single + "?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    var list = current.get(what);
    if((index >= 0) && (index < list.length)) {
      list.splice(index, 1);
      current.set(what, list);
      numberlist(what, title, format);
    } else {
      println("Attemp to remove illegal element of: " + what);
      println("  length = " + list.length + ", index = " + index);
    }
  }
  dock.dialogs.showDialog(d);
}

function addNumberItem(what, title, format) {
  var list = current.get(what);
  list.push(0);
  current.set(what, list);
  numberlist(what, title, format);
}

/* SPECIAL CASE: IP */

function iplist(what, title) {
  var format = '^(25[0-5]|2[0-4][0-9]|[0-1]?[0-9]?[0-9])$';
  var rows = document.getElementById(what);
  while(rows.firstChild) rows.removeChild(rows.firstChild);
  var found = current.get(what);
  for(var i = 0; i < found.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    var hbox = document.createElement("hbox");
    for(var j = 0; j < 4; j++) {
      var textbox = document.createElement("textbox");
      textbox.setAttribute('id', what + '_' + i + '-' + j);
      textbox.setAttribute('class', "iplist");
      hbox.appendChild(textbox);
    }
    row.appendChild(hbox);

    var minus = document.createElement("button");
    minus.setAttribute('class', 'minus-button');
    minus.setAttribute('oncommand', "removeIpItem('" + what + "', '" + title + "', '" + format + "', "  + i + ");");
    row.appendChild(minus);
    if(i == found.length - 1) {
      var plus = document.createElement("button");
      plus.setAttribute('class', 'plus-button');
      plus.setAttribute('oncommand', "addIpItem('" + what + "', '" + title + "', '" + format + "');");
      row.appendChild(plus);
      rows.appendChild(row);
    } else {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('height', '4px');
      rows.appendChild(row);
      rows.appendChild(hbox);
    }
  }
  for(var i = 0; i < found.length; i++) {
    partial(what + '_' + i, '.', format);
  }
  if(found.length == 0) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    if(!dock.PLUS_LEFT) {
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
    }

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'start');
    hbox.setAttribute('style', 'margin-left: -6px;');
    var plus = document.createElement("button");
    plus.setAttribute('class', 'plus-button');
    plus.setAttribute('oncommand', "addIpItem('" + what + "', '" + title + "', '" + format + "');");
    hbox.appendChild(plus);
    row.appendChild(hbox);
    rows.appendChild(row);
  }
}

function removeIpItem(what, title, format, index) {
  var list = current.get(what);
  if((index >= 0) && (index < list.length)) {
    if(list[index] == '0.0.0.0') {
      list.splice(index, 1);
      current.set(what, list);
      iplist(what, title, format);
      return;
    }
  } else {
    println("Attemp to remove illegal element of: " + what);
    println("  length = " + list.length + ", index = " + index);
    return;
  }

  var args = new Object();
  var single = pluralToSingular(title.toLowerCase().replace(':', ''));
  args['question'] = "Are you sure you want to remove this " + single + "?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    var list = current.get(what);
    if((index >= 0) && (index < list.length)) {
      list.splice(index, 1);
      current.set(what, list);
      iplist(what, title, format);
    }
  }
  dock.dialogs.showDialog(d);
}

function addIpItem(what, title, format) {
  var list = current.get(what);
  list.push('0.0.0.0');
  current.set(what, list);
  iplist(what, title, format);
}

/* SPECIAL CASE: THRESHOLD ACTIONS */

function threshActionList(what, title, format, dowhen) {
  dowhen = isundefined(dowhen, true);
  dowhen = eval(dowhen);
  format = isundefined(format, '^');
  var rows = document.getElementById(what);
  while(rows.firstChild) rows.removeChild(rows.firstChild);
  var found = current.get(what);
  for(var i = 0; i < found.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    var menu = document.createElement("menulist");
    menu.setAttribute('class', 'tablemenulist');
    var popup = document.createElement("menupopup");
    menu.appendChild(popup);
    menu.setAttribute('id', what + '_' + i + 'threshAction');
    menu.setAttribute('class', 'stringlist');
    row.appendChild(menu);
    var textbox = document.createElement("textbox");
    textbox.setAttribute('id', what + '_' + i + 'actionParam');
    textbox.setAttribute('class', 'stringlist');
    row.appendChild(textbox);

    if(dowhen) {
      var menu = document.createElement("menulist");
      menu.setAttribute('class', 'tablemenulist');
      var popup = document.createElement("menupopup");
      menu.appendChild(popup);
      menu.setAttribute('id', what + '_' + i + 'doWhen');
      menu.setAttribute('class', 'stringlist');
      row.appendChild(menu);
    }

    var minus = document.createElement("button");
    minus.setAttribute('class', 'minus-button');
    minus.setAttribute('oncommand', "removeThreshActionItem('" + what + "', '" + title + "', '" + format + "', "  + i + ", '" + dowhen + "');");
    row.appendChild(minus);
    if(i == found.length - 1) {
      var plus = document.createElement("button");
      plus.setAttribute('class', 'plus-button');
      plus.setAttribute('oncommand', "addThreshActionItem('" + what + "', '" + title + "', '" + format + "', '" + dowhen + "');");
      row.appendChild(plus);
      rows.appendChild(row);
    } else {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('height', '4px');
      rows.appendChild(row);
      rows.appendChild(hbox);
    }
  }
  for(var i = 0; i < found.length; i++) {
    resolve(what + '_' + i, 'ThreshAction', 'threshAction');
    text(what + '_' + i, format, 'actionParam');
    if(dowhen) {
      kenum(what + '_' + i, [['ENTER', 'Enter'],
                            ['DURING', 'During'],
                            ['LEAVE', 'Leave']], 'doWhen');
    }
  }
  if(found.length == 0) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    if(!dock.PLUS_LEFT) {
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
    }

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'start');
    hbox.setAttribute('style', 'margin-left: -6px;');
    var plus = document.createElement("button");
    plus.setAttribute('class', 'plus-button');
    plus.setAttribute('oncommand', "addThreshActionItem('" + what + "', '" + title + "', '" + format + "', '" + dowhen + "');");
    hbox.appendChild(plus);
    row.appendChild(hbox);
    rows.appendChild(row);
  }
}

function removeThreshActionItem(what, title, format, index, dowhen) {
  var args = new Object();
  var single = pluralToSingular(title.toLowerCase().replace(':', ''));
  args['question'] = "Are you sure you want to remove this " + single + "?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    var list = current.get(what);
    if((index >= 0) && (index < list.length)) {
      list.splice(index, 1);
      current.set(what, list);
      threshActionList(what, title, format, dowhen);
    } else {
      println("Attemp to remove illegal element of: " + what);
      println("  length = " + list.length + ", index = " + index);
    }
  }
  dock.dialogs.showDialog(d);
}

function addThreshActionItem(what, title, format, dowhen) {
  var list = current.get(what);
  var one = new dock.cvThreshActionConf();
  list.push(one);
  current.set(what, list);
  threshActionList(what, title, format, dowhen);
}

/* SPECIAL CASE: CHECKBOX LIST */

function checkboxlist(what, list) {
  var vbox = document.getElementById(what);
  while(vbox.firstChild) vbox.removeChild(vbox.firstChild);
  var found = current.get(what);
  for(var i = 0; i < list.length; i++) {
    var check = document.createElement("checkimage");
    check.setAttribute('checked', (found.find(list[i]) >= 0));
    check.setAttribute('what', what);
    check.setAttribute('label', list[i]);
    check.setAttribute('oncommand', 'checkboxlist_command(event);');
    vbox.appendChild(check);
  }
}

function checkboxlist_command(event) {
  var item = event.target;
  var value = item.getAttribute('checked');
  var name = item.getAttribute('label');
  var what = item.getAttribute('what');
  var list = current.get(what);
  if(typeof(value) == "string") {
    value = (value == 'true');
  } else {
    value = eval(value);
  }
  if(value) {
    if(list.find(name) < 0) {
      list.push(name);
      current.set(what, list);
    }
  } else {
    var index = list.find(name);
    if(index >= 0) {
      list.splice(index, 1);
      current.set(what, list);
    }
  }
}

/* SPECIAL CASE: RESOLVE LIST */

function resolveList(what, title, type, subscript, blank, specialChar, excludeFunction, displayFunction, listenerFunction) {
  subscript = isundefined(subscript, '');
  specialChar = isundefined(specialChar, '');
  excludeFunction = isundefined(excludeFunction, false);
  displayFunction = isundefined(displayFunction, false);
  listenerFunction = isundefined(listenerFunction, false);

  var rows = document.getElementById(what);
  while(rows.firstChild) rows.removeChild(rows.firstChild);
  var found = current.get(what);
  for(var i = 0; i < found.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    var menu = document.createElement("menulist");
    menu.setAttribute('class', 'tablemenulist');
    var popup = document.createElement("menupopup");
    menu.appendChild(popup);
    menu.setAttribute('id', what + '_' + i);
    menu.setAttribute('class', 'stringlist');
    row.appendChild(menu);

    var minus = document.createElement("button");
    minus.setAttribute('class', 'minus-button');
    minus.setAttribute('oncommand', "removeResolveItem('" + what + "', '" + title + "', '" + type + "', '" + subscript + "', '" + blank + "', '" + specialChar + "', '" + excludeFunction + "', '" + displayFunction + "', " + i + ", " + listenerFunction + ");");
    row.appendChild(minus);
    if(i == found.length - 1) {
      var plus = document.createElement("button");
      plus.setAttribute('class', 'plus-button');
      plus.setAttribute('oncommand', "addResolveItem('" + what + "', '" + title + "', '" + type + "', '" + subscript + "', '" + blank + "', '" + specialChar + "', '" + excludeFunction + "', '" + displayFunction + "', " + listenerFunction + ");");
      row.appendChild(plus);
      rows.appendChild(row);
    } else {
      var hbox = document.createElement("hbox");
      hbox.setAttribute('height', '4px');
      rows.appendChild(row);
      rows.appendChild(hbox);
    }
  }

  if (dock.mainthread.hasPendingEvents()) {
    println('resolveList has pending events... processing next event');
    dock.mainthread.processNextEvent(false);
    println('resolveList has pending events... processing next event... DONE');
  }
  for(var i = 0; i < found.length; i++) {
    resolve(what + '_' + i, type, subscript, blank, specialChar, excludeFunction, displayFunction);
  }
  if(found.length == 0) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'end');
    var label = document.createElement("shadowlabel");
    label.setAttribute('value', title);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);

    if(!dock.PLUS_LEFT) {
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
      var space = document.createElement("spacer");
      row.appendChild(space);
    }

    var hbox = document.createElement("hbox");
    hbox.setAttribute('pack', 'start');
    hbox.setAttribute('style', 'margin-left: -6px;');
    var plus = document.createElement("button");
    plus.setAttribute('class', 'plus-button');
    plus.setAttribute('oncommand', "addResolveItem('" + what + "', '" + title + "', '" + type + "', '" + subscript + "', '" + blank + "', '" + specialChar + "', '" + excludeFunction + "', '" + displayFunction + "', " + listenerFunction + ");");
    hbox.appendChild(plus);
    row.appendChild(hbox);
    rows.appendChild(row);
  }
}

function removeResolveItem(what, title, type, subscript, blank, specialChar, excludeFunction, displayFunction, index, listenerFunction) {
  var args = new Object();
  var single = pluralToSingular(title.toLowerCase().replace(':', ''));
  args['question'] = "Are you sure you want to remove this " + single + "?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    var list = current.get(what);
    if((index >= 0) && (index < list.length)) {
      list.splice(index, 1);
      current.set(what, list);
      resolveList(what, title, type, subscript, blank, specialChar, excludeFunction, displayFunction);

      if (listenerFunction)
        listenerFunction();
    } else {
      println("Attemp to remove illegal element of: " + what);
      println("  length = " + list.length + ", index = " + index);
    }
  }
  dock.dialogs.showDialog(d);
}

function addResolveItem(what, title, type, subscript, blank, specialChar, excludeFunction, displayFunction, listenerFunction) {
  var list = current.get(what);
  list.push(0);
  current.set(what, list);
  resolveList(what, title, type, subscript, blank, specialChar, excludeFunction, displayFunction);

  if (listenerFunction)
    listenerFunction();
}
