/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */


function newObject() {
  var args = new Object();
  args['cluster'] = current;
  args['object'] = 0;
  var d = new dock.cvDialog(editfile, args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}

function editObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('Please select a ' + singular);
  } else if(select.length > 1) {
    dock.displayError('Please select only one ' + singular);
  } else {
    var args = new Object();
    args['cluster'] = current;
    args['object'] = select[0];
    var d = new dock.cvDialog(editfile, args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function removeObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("No action selected");
  } else {
    var args = new Object();
    if(select.length == 1) {
      args['question'] = "Are you sure you want to remove this " + singular + "?";
    } else {
      args['question'] = "Are you sure you want to remove these " + plural + "?";
    }
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      var builtin = new Array();
      var removed = 0;
      for(var i = 0; i < select.length; i++) {
        var action = current.find(select[i]);
        if(action) {
          if(action.get('isCustom')) {
            current.removeObject(select[i]);
            removed++;
          } else {
            builtin.push(action.get('name'));
          }
        }
      }
      if(builtin.length == 1) {
        dock.displayInfo(builtin.join(',') + ' is a built-in ' + singular + ' and cannot be removed', window);
      } else if(builtin.length > 1) {
        dock.displayInfo(builtin.join(',') + ' are built-in ' + plural + ' and cannot be removed', window);
      }
      if(removed) {
        refresh();
      }
    }
    dock.dialogs.showDialog(d);
  }
}
