/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing, Inc.('Confidential Information').  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    if(current != use) {
      current = use;
      monconf = monconfForCluster[current.key];
      refreshlist();
    }
  } else {
    monconf = monconfForCluster[current.key];
  }
  println('Refresh monitoring setup' + ' - ' + document.documentURI);

  var monconfs = current.find('MonConf');
  var list = document.getElementById('monconf');
  var popup = list.firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  var found = -1;
  for(var i = 0; i < monconfs.length; i++) {
    var name = current.getMonConfName(monconfs[i].get('uniqueKey'));
    if(name.length == 0) continue;
    var item = document.createElement('menuitem');
    item.setAttribute('key', monconfs[i].get('uniqueKey'));
    item.setAttribute('label', name);
    popup.appendChild(item);
    if(monconf && (monconfs[i].get('uniqueKey') == monconf.get('uniqueKey'))) {
      found = i;
    }
  }
  list.selectedIndex = found;
  popup.addEventListener('command', selectmonconf, true);
  refreshlist();
}

function getSelected() {
  return selected('list');
}

function getCurrentSelection() {
  if(monconf) {
    var select = getSelected();
    var list;
    if(select.length > 0) {
      list = monconf.subObjectsFromKeys(subfield, select);
    } else {
      list = monconf.getFromSubfield(subfield);
    }
    return [list, monconf, subfield];
  }
  return [0, 0, 0];
}

function selectmonconf(event) {
  var item = event.target;
  var key = parseInt(item.getAttribute('key'));
  monconf = current.find(key);
  monconfForCluster[current.key] = monconf;
  refreshlist();
}

function newSubObject() {
  var args = new Object();
  args['object'] = monconf;
  args['subobject'] = 0;
  var d = new dock.cvDialog(editfile, args);
  d.onOk = function() {
    refreshlist();
  }
  dock.dialogs.showDialog(d);
}

function editSubObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('No ' + singular + ' selected');
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = monconf;
    args['subobject'] = select[0];
    var d = new dock.cvDialog(editfile, args);
    d.onOk = function() {
      refreshlist();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError('Please select only one ' + singular);
  }
}
function removeSubObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('No ' + singular + ' selected');
  } else {
    var args = new Object();
    if(select.length == 1) {
      args['question'] = 'Are you sure you want to remove this ' + singular + '?';
    } else {
      args['question'] = 'Are you sure you want to remove these ' + plural + '?';
    }
    var d = new dock.cvDialog('question.xul', args);
    d.onOk = function() {
      for(var i = 0; i < select.length; i++) monconf.deleteSubObjectFromKey(subfield ,select[i]);
      refreshlist();
    }
    dock.dialogs.showDialog(d);
  }
}

function saveMonconf() {
  if(monconf) {
    monconf.commit();
    refreshlist();
  } else {
    dock.displayError('No ' + singular + ' selected');
  }
}
function revertMonconf() {
  if(monconf) {
    monconf.refresh();
    refreshlist();
  } else {
    dock.displayError('No ' + singular + ' selected');
  }
}
