/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function addMenuItem(parent, text, command) {
  var item = document.createElement("menuitem");
  item.setAttribute('label', text);
  item.setAttribute('oncommand', command);
  parent.appendChild(item);
}

function addMenuSeparator(parent) {
  var item = document.createElement('menuseparator');
  parent.appendChild(item);
}

function changeOverviewTreePopup(event) {
  var popup = event.target;
  while(popup.firstChild) popup.removeChild(popup.firstChild);

  addMenuItem(popup, 'Edit', 'editObject();');
  if(typeof(basetype) != 'undefined') {
    if(dock.hasClone(basetype)) {
      addMenuItem(popup, 'Clone', 'cloneObject();');
    }
  } else if(dock.hasClone(current.get('baseType'))) {
    addMenuItem(popup, 'Clone', 'cloneObject();');
  }
  addMenuItem(popup, 'Remove', 'removeObject();');

  var nc = dock.connectedClustersCount();
  var select = getSelected();
  if(select!==undefined && select.length == 1) {
    addMenuSeparator(popup);
    addMenuItem(popup, 'Synchronize values to other ' + plural, 'dock.cloneWizard(' + dock.CLONE_SYNC_ONE + ');');
  } else if(nc > 1) {
    addMenuSeparator(popup);
    addMenuItem(popup, 'Synchronize values to namesakes on other clusters', 'dock.cloneWizard(' + dock.CLONE_SYNC_N + ');');
  }
  if(nc > 1) {
    addMenuItem(popup, 'Export to other clusters', 'dock.cloneWizard(' + dock.CLONE_CREATE + ');');
  }
  return true;
}
