/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing, Inc.('Confidential Information').  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);

  tree = document.getElementById('tree');
  initTotalItems();
}

function initTotalItems() {
  if(!document.getElementById('tableTotalItems')) {
    return;
  }
  var instance = this;

  this.updateTotalItems = function() {
    var count = 0;
    if(tree.view && tree.view.rowCount) {
      count = tree.view.rowCount - 1;
    }
    if (count===1) {
      var msg = 'Displaying ' + count + ' item';
    } else {
      var msg = 'Displaying ' + count + ' items';
    }
    document.getElementById('tableTotalItems').setAttribute('value', msg);
  };

  tree.addEventListener('row-count', function (event) {
    instance.updateTotalItems();
  }, false);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + document.title + ' - ' + document.documentURI);
  println('Refresh ' + singular +' folder overview');
  if(typeof(specialrefresh) == 'function') {
    if(specialrefresh()) return;
  }
  var list = current.find(basetype);
  data = new Array();
  var modified = false;
  for(var i = 0; i < list.length; i++) {
    if(!list[i].get('toBeRemoved') || alsoRemoved) {
      var tmp = createTreeItem(list[i]);
      if(tmp === null) continue;
      data.push(tmp);
      modified = modified || list[i].get('modified') || list[i].get('toBeRemoved');
    } else {
      modified = true;
    }
  }
  var select = selected('list');
  loadTable();
  setSelected('list', select);

  if(modified) {
    document.getElementById('save').removeAttribute('disabled');
  } else {
    document.getElementById('save').setAttribute('disabled', true);
  }
  if(typeof(postrefresh) == 'function') {
    if(postrefresh()) return;
  }
}

function getCurrentSelection() {
  var cluster = current;
  if(!!current.cluster) cluster = current.cluster;
  var select = getSelected();
  var list;
  if(select.length > 0) {
    list = new Array();
    for(var i = 0; i < select.length; i++) {
      var one = cluster.find(select[i]);
      if(!!one) list.push(one);
    }
  } else if(dock.CLONE_SELECT_ALL) {
    list = cluster.findNotToBeRemoved(basetype);
  } else {
    list = new Array();
  }
  return [list, 0];
}

function getSelected() {
  return selected('list');
}

function editObject() {
  var cluster = current;
  if(!!current.cluster) cluster = current.cluster;
  var select = getSelected();
  if(select.length == 0) {
    dock.displayError('Please select a ' + singular);
  } else if(select.length > 1) {
    dock.displayError('Please select only one ' + singular);
  } else {
    cluster.select(select[0]);
  }
}

function removeObject() {
  var select = getSelected();
  if(select.length == 0) {
    dock.displayError('Please select a ' + singular);
  } else {
    var cluster = current;
    if(!!current.cluster) cluster = current.cluster;
    var args = new Object();
    if(select.length == 1) {
      args['question'] = 'Are you sure you want to remove this ' + singular + '?';
    } else {
      args['question'] = 'Are you sure you want to remove these ' + plural + '?';
    }
    var d = new dock.cvDialog('question.xul', args);
    d.onOk = function() {
      for(var i = 0; i < select.length; i++) cluster.removeObject(select[i]);
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}
