/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var subfield = 'roles';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  var list = current.getFromSubfield(subfield);
  return [list, current, subfield];
}

function clearLabel(role) {
  var w = 'has' + role + 'Role';
  var obj = document.getElementById(w);
  if(!!obj) {
    var name = obj.getAttribute('label');
    name = name.replace(/\[.*\]\s/, '');
    obj.setAttribute('label', name);
    obj.checked = false;
  } else {
    println("Unable to find: " + w);
  }
}

function checkRole(name) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(name == roles[i].childType) {
      roles[i].toBeRemoved = !roles[i].toBeRemoved;
      if(roles[i].toBeRemoved) current.set('modified', true);
      refresh();
      return;
    }
  }
  var role = eval('new dock.cv' + name + '();');
  role.toBeRemoved = false;
  role.modified = true;
  if(name == 'TorqueClientRole') {
    role.name = 'TorqueClient';
  } else if(name == 'TorqueServerRole') {
    role.name = 'TorqueServer';
  } else if(role.name.length == 0) {
    role.name = name.replace('Role', '').toLowerCase();
  }
  if(typeof(postRoleCheck) == 'function') postRoleCheck(role);
  roles.push(role);
  current.set(subfield, roles);
  refresh();
}

function advancedRole(name, xulFile) {
  xulFile = isundefined(xulFile, "advanced" + name.toLowerCase() + ".xul");
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(name == roles[i].childType) {
      var args = new Object();
      args['object'] = current;
      args['subobject'] = new dock.cvObject(current.cluster, roles[i], current, 'roles');
      var d = new dock.cvDialog(xulFile, args);
      d.onOk = function() {
        refresh();
      };
      dock.dialogs.showDialog(d);
      return;
    }
  }
}

function setGenericRole(role, category, obj, controlEditView) {
  controlEditView = isundefined(controlEditView, true);
  var adv = document.getElementById('advanced' + role.childType);
  var name = obj.getAttribute('label');
  if(category) {
    if(!obj.checked) {
      name = '[' + category + '] ' + name;
      obj.setAttribute('label', name);
      obj.checked = true;
      if(controlEditView) {
        var next = document.getElementById('edit' + role.childType);
        if(next) next.setAttribute('hidden', false);
      }
    }
    if(adv) adv.setAttribute('hidden', true);
  } else {
    obj.setAttribute('label', name);
    obj.checked = true;
    if(controlEditView) {
      var next = document.getElementById('edit' + role.childType);
      if(next) next.setAttribute('hidden', false);
    }
    if(adv) adv.removeAttribute('hidden', true);
  }
  var one = new dock.cvObject(current.cluster, role, current, 'roles');
  return one;
}
