/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */


function addMenuItem(parent, text, command) {
  var item = document.createElement("menuitem");
  item.setAttribute('label', text);
  item.setAttribute('oncommand', command);
  parent.appendChild(item);
}

function addMenuSeparator(parent) {
  var item = document.createElement('menuseparator');
  parent.appendChild(item);
}

function changeOverviewTreePopup(event) {
  var popup = event.target;
  while(popup.firstChild) popup.removeChild(popup.firstChild);

  addMenuItem(popup, 'Edit', 'editSubObject();');
  if(dock.hasClone(basetype)) {
    addMenuItem(popup, 'Clone', 'cloneSubObject();');
  }
  addMenuItem(popup, 'Remove', 'removeSubObject();');

  var select = getSelected();
  var work;
  if(typeof(monconf) == 'undefined') {
    work = current;
  } else {
    work = monconf;
  }

  if(select.length == 1) {
    addMenuSeparator(popup);
    addMenuItem(popup, 'Synchronize values to other ' + plural, 'dock.cloneWizard(' + dock.CLONE_SYNC_ONE + ');');
    addMenuItem(popup, 'Export to other ' + work.getType(true, true), 'dock.cloneWizard(' + dock.CLONE_CREATE + ');');
  } else if(select.length > 1) {
    addMenuSeparator(popup);
    addMenuItem(popup, 'Synchronize values to namesakes beloning to other ' + work.getType(true, true), 'dock.cloneWizard(' + dock.CLONE_SYNC_N + ');');
    addMenuItem(popup, 'Export to other ' + work.getType(true, true), 'dock.cloneWizard(' + dock.CLONE_CREATE + ');');
  }
  return true;
}
