/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function overviewDiskInfo() {
  var obj = document.getElementById('disks');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = overview.disks;
  for(var i = 0; i < data.length; i++) {
    obj.appendChild(diskRow(data[i]));
  }

  function diskRow(data) {
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.name);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.model);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", formatKMG(data.size) + 'B');
    row.appendChild(label);
    return row;
  }
}

function overviewCPUInfo() {
  var obj = document.getElementById('cpus');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = overview.processors;
  for(var i = 0; i < data.length; i++) {
    obj.appendChild(cpuRow(data[i]));
  }

  function cpuRow(data) { // JSWARN: function cpuRow does not always return a value ??
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.ID);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.coreID);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.modelName);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.speed + ' MHz');
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.cacheSize);
    row.appendChild(label);
    row.appendChild(governorsColumn(data));
    return row;
  }
  
  function governorsColumn(data) {
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    var curr = data.currentGovernor;
    var avail = data.availableGovernors.slice(0);
    var govs = curr;
    if (avail.length > 0) {
      for (var i = 0; i < avail.length; ++i) {
        if (curr == avail[i]) {
          avail.splice(i, 1);
          break;
        }
      }
      govs += " (" + avail.join(', ') + ")";
    } else {
      govs += " (N/A)";
    }
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", govs);
    return label;
  }
}

function overviewGPUInfo() {
  var obj = document.getElementById('gpus');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = overview.gpuUnits;
  for(var i = 0; i < data.length; i++) {
    var gpuName = ''
    if(data[i].name.length > 0) {
      gpuName = i;
      if(data[i].name != 'N/A') gpuName += ': ' + data[i].name;
      obj.appendChild(gpuUnit(gpuName, data[i]));
    }
    var driver = data[i].driver;
    var gpus = data[i].gpu;
    for(var j = 0; j < gpus.length; j++) {
      obj.appendChild(gpu(gpuName, j, gpus[j], driver));
    }
  }
  obj = document.getElementById('gpuinfo');
  if(data.length == 0) {
    obj.setAttribute('hidden', true);
  } else {
    obj.removeAttribute('hidden');
  }

  function gpuUnit(i, data) {
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", i);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", '');
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.name);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.serial);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.driver);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.pciSpeed);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.firmware);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.id);
    row.appendChild(label);
    return row;
  }

  function gpu(i, j, data) {
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", i);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", j);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.name);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.serial);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    if(data.driverModel == 'N/A') {
      label.setAttribute("value", driver);
    } else {
      label.setAttribute("value", data.driverModel);
    }
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.pciBusId);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.infoRom);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.uuid);
    row.appendChild(label);
    return row;
  }
}

function overviewMICInfo() {
  var obj = document.getElementById('mics');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = overview.mics;
  for(var i = 0; i < data.length; i++) {
    obj.appendChild(mic(i, data[i]));
  }
  obj = document.getElementById('micinfo');
  if(data.length == 0) {
    obj.setAttribute('hidden', true);
  } else {
    obj.removeAttribute('hidden');
  }

  function mic(i, data) {
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.name);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.id);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.osVersion);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.driverVersion);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.flashVersion);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.pciIndex);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.cores);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.memTotal);
    row.appendChild(label);
    return row;
  }
}

function overviewMemoryInfo() {
  var obj = document.getElementById('memory');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = overview.memory;
  var n = 0;
  for(var i = 0; i < data.length; i++) {
    obj.appendChild(memoryDimm(data[i].location, data[i].size, data[i].speed, data[i].type));
    n++;
  }
  obj = document.getElementById('memoryinfo');
  if(n == 0) {
    obj.setAttribute('hidden', true);
  } else {
    obj.removeAttribute('hidden');
  }

  function memoryDimm(slot, size, speed, type) {
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", slot);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", size);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", speed);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", type);
    row.appendChild(label);
    return row;
  }
}

function overviewInterconnects() {
  var obj = document.getElementById('interconnectinfo');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = overview.interconnects;
  for(var i = 0; i < data.length; i++) {
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data[i]);
    obj.appendChild(label);
  }
  if(data.length == 0) {
    obj.setAttribute('hidden', true);
  } else {
    obj.removeAttribute('hidden');
  }
}

function overviewDellStorageInfo() {
  if (typeof overview.dellStorage == "undefined") {
    var obj = document.getElementById('dellstorageinfo');
    obj.setAttribute('hidden', true);
    return;
  }

  var data = overview.dellStorage;
  var obj = document.getElementById('dellstorageinfo');

  if (typeof data.name == "undefined" || typeof data.diskDrives === "undefined" || typeof data.controllers == "undefined" ||
      data.diskDrives.length == 0 || data.controllers.length == 0) {
    obj = document.getElementById('dellstorageinfo');
    obj.setAttribute('hidden', true);
    return;
  } else {
    obj.setAttribute('hidden', false);
  }

  obj = document.getElementById('name');
  obj.setAttribute("value", data.name);
  obj = document.getElementById('hostOS');
  obj.setAttribute("value", data.hostOS);
  obj = document.getElementById('wwid');
  obj.setAttribute("value", data.wwid);
  obj = document.getElementById('firmwareVersion');
  obj.setAttribute("value", data.firmwareVersion);
  obj = document.getElementById('nvsramVersion');
  obj.setAttribute("value", data.nvsramVersion);
  obj = document.getElementById('amwVersion');
  obj.setAttribute("value", data.amwVersion);
  obj = document.getElementById('isNVSConfiguredForBatteries');
  obj.setAttribute("value", data.isNVSConfiguredForBatteries ? "Yes" : "No");
  obj = document.getElementById('isPhysicalDiskSecurityEnabled');
  obj.setAttribute("value", data.isPhysicalDiskSecurityEnabled ? "Yes" : "No");
  obj = document.getElementById('featurePack');
  obj.setAttribute("value", data.featurePack);
  obj = document.getElementById('featurePackSubmodelID');
  obj.setAttribute("value", data.featurePackSubmodelID);
  obj = document.getElementById('physicalDisksAllowedCount');
  obj.setAttribute("value", data.physicalDisksAllowedCount);
  obj = document.getElementById('physicalDisksUsedCount');
  obj.setAttribute("value", data.physicalDisksUsedCount);
  
  if (typeof data.virtualDisks === "undefined") {
    var obj = document.getElementById('vdisk');
    obj.setAttribute('hidden', true);
  } else {
    var obj = document.getElementById('vdisk');
    var vdisks = data.virtualDisks;
    while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
    var n = 0;
  
    for(var i = 0; i < vdisks.length; i++) {
      obj.appendChild(vdiskmimm(vdisks[i].name, vdisks[i].status, vdisks[i].capacity, vdisks[i].LUN, vdisks[i].diskGroup, vdisks[i].raidLevel));
      n++;
    }

    if (n == 0) {
      obj.setAttribute('hidden', true);
    } else {
      obj.removeAttribute('hidden');
    }
  }

  if (typeof data.diskDrives === "undefined") {
    var obj = document.getElementById('phydisk');
    obj.setAttribute('hidden', true);
  } else {
    var obj = document.getElementById('phydisk');
    while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
    n = 0;
    var phydisks = data.diskDrives;
    for(var i = 0; i < phydisks.length; i++) {
      obj.appendChild(phydiskmimm(phydisks[i].enclosure, phydisks[i].slot, phydisks[i].status,
                      phydisks[i].capacity, phydisks[i].mediaType, phydisks[i].interfaceType,
                      phydisks[i].currentDataRate, phydisks[i].productId, phydisks[i].firmwareVersion));

      n++;
    }

    if (n == 0) {
      obj.setAttribute('hidden', true);
    } else {
      obj.removeAttribute('hidden');
    }
  }

  if (typeof data.controllers === "undefined") {
    var obj = document.getElementById('raidcontroller');
    obj.setAttribute('hidden', true);
  } else {
    var obj = document.getElementById('raidcontroller');
    while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
    n = 0;
    var rc = data.controllers;
    for (var i = 0; i < rc.length; i++) {
      obj.appendChild(controllersmimm(rc[i].enclosure, rc[i].slot, rc[i].status,
                      rc[i].firmwareVersion, rc[i].appwareVersion, rc[i].bootwareVersion,
                      rc[i].NVSRAMVersion, rc[i].productId, rc[i].dateOfManufacture, rc[i].vendor));
      n++;
    }

    if (n == 0) {
      obj.setAttribute('hidden', true);
    } else {
      obj.removeAttribute('hidden');
    }
  }

    function controllersmimm(enclosure,slot,status,firmware,appware,bootware,nvsram,productid,dateofmanufacture,vendor) {
      var row = document.createElement('row');
      row.setAttribute("flex", "1");
      row.setAttribute("align", "center");
      row.setAttribute("height", "17px");
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", enclosure);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", slot);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", status);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", firmware);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", appware);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", bootware);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", nvsram);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", productid);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", dateofmanufacture);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", vendor);
      row.appendChild(label);
      return row;
    }

    function phydiskmimm(enclosure,slot,status,capacity,mediatype,iftype,datarate,productid,firmware) {
      var row = document.createElement('row');
      row.setAttribute("flex", "1");
      row.setAttribute("align", "center");
      row.setAttribute("height", "17px");
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", enclosure);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", slot);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", status);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", formatKMG(capacity)+'B');
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", mediatype);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", iftype);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", datarate);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", productid);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", firmware);
      row.appendChild(label);
      return row;
    }

    function vdiskmimm(name, status, capacity, lun, diskgroup, raidlevel) {
      var row = document.createElement('row');
      row.setAttribute("flex", "1");
      row.setAttribute("align", "center");
      row.setAttribute("height", "17px");
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", name);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", status);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", formatKMG(capacity)+'B');
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", lun);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", diskgroup);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      label.setAttribute("value", raidlevel);
      row.appendChild(label);
      return row;
    }
}
