/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */


function save() {
  var work = current;
  if(typeof(globalCurrent) != 'undefined') work = globalCurrent;
  work.commit();
  if(work.object.uniqueKey < dock.MAX_LOCAL_KEY) {
    document.getElementById('revert').setAttribute('disabled', true);
  } else {
    document.getElementById('revert').removeAttribute('disabled');
  }
}

function revert() {
  var work = current;
  if(typeof(globalCurrent) != 'undefined') work = globalCurrent;
  work.refresh();
  refresh();
}

function saveList(type, always) {
  var cluster = current;
  if(!!cluster.cluster) cluster = cluster.cluster;
  always = isundefined(always, false);
  if(isArray(type)) {
    for(var j = 0; j < type.length; j++) {
      var list = cluster.find(type[j]);
      for(var i = 0; i < list.length; i++) {
        if(list[i].get('modified') || always) list[i].commit();
      }
    }
  } else {
    var list = cluster.find(type);
    for(var i = 0; i < list.length; i++) {
      if(list[i].get('modified') || always) list[i].commit();
    }
  }
}

function revertList(type) {
  var cluster = current;
  if(!!current.cluster) cluster = current.cluster;
  if(isArray(type)) {
    for(var j = 0; j < type.length; j++) {
      var list = cluster.find(type[j]);
      for(var i = 0; i < list.length; i++) {
        if(list[i].get('modified')) {
          if(list[i].object.uniqueKey < dock.MAX_LOCAL_KEY) {
            list[i].remove();
          } else {
            list[i].refresh();
          }
        } else if(list[i].object.uniqueKey < dock.MAX_LOCAL_KEY) {
          println("list[i].object.uniqueKey < dock.MAX_LOCAL_KEY, This should not be!");
        }
      }
    }
  } else {
    var list = cluster.find(type);
    for(var i = 0; i < list.length; i++) {
      if(list[i].get('modified')) {
        if(list[i].object.uniqueKey < dock.MAX_LOCAL_KEY) {
          list[i].remove();
        } else {
          list[i].refresh();
        }
      } else if(list[i].object.uniqueKey < dock.MAX_LOCAL_KEY) {
        println("list[i].object.uniqueKey < dock.MAX_LOCAL_KEY, This should not be!");
      }
    }
  }
  
  if ( type == "ConfigurationOverlay" ) {
     if ( refreshLevel == 2 )    parent.parent.refresh();
     else    parent.refresh();   
  }
  else {
    refresh();
  }

}

function newTextCell(object, text) {
  var cell = document.createElement("treecell");
  cell.setAttribute('label', text);
  return cell;
}

function newCell(object, field) {
  var cell = document.createElement("treecell");
  cell.setAttribute('label', object[field]);
  return cell;
}

function newIndexCell(object, field, list) {
  var cell = document.createElement("treecell");
  cell.setAttribute('label', list[object[field]]);
  return cell;
}

function newThresActionCell(object, field, char) {
  char = isundefined(char, '; ');
  var cell = document.createElement("treecell");
  var values = object[field];
  var text = '';
  for(var i = 0; i < values.length; i++) {
    if(text) text += char;
    var resolve = current.cluster.find(values[i].threshAction);
    if(!!resolve) {
      resolve = resolve.resolveName();
      if(values[i].actionParam.length) {
        text += (resolve + '(' + values[i].actionParam + ')');
      } else {
        text += resolve;
      }
    }
  }
  cell.setAttribute('label', text);
  return cell;
}

function newCheckedCell(object, value) {
  var cell = document.createElement("treecell");
  cell.setAttribute('value', value);
  return cell;
}

function newResolveCell(object, field) {
  var cell = document.createElement("treecell");
  var resolve;
  if(!!current.cluster) {
    resolve = current.cluster.find(object[field]);
  } else {
    resolve = current.find(object[field]);
  }
  if(!!resolve) {
    resolve = resolve.resolveName();
  } else {
    resolve = '';
  }

  cell.setAttribute('label', resolve);
  return cell;
}

function newResolveListCell(object, field) {
  var cell = document.createElement("treecell");
  var cluster;
  if(!!current.cluster) {
    cluster = current.cluster;
  } else {
    cluster = current;
  }
  var list = object[field];
  var resolve = new Array();
  for(var i = 0; i < list.length; i++) {
    var one = cluster.find(list[i]);
    if(!!one) resolve.push(one.resolveName());
  }
  cell.setAttribute('label', dotFormat(resolve));
  return cell;

}

function selected(listTreeName, c) {
  c = isundefined(c, null);
  var list = document.getElementById(listTreeName);
  var tree = list.parentNode;
  var select = new Array();

  var start = new Object();
  var end = new Object();
  if(tree.view && tree.view.selection) {
    for(var t = 0; t < tree.view.selection.getRangeCount(); t++){
      tree.view.selection.getRangeAt(t,start,end);
      for(var v = start.value; v <= end.value; v++) {
        var key = tree.view.getCellText(v, c);
        if(key) select.push(key);
      }
    }
  }
  return select;
}

function setSelected(listTreeName, select, c) {
  c = isundefined(c, null);
  var list = document.getElementById(listTreeName);
  var tree = list.parentNode;
  if(tree.view) {
    for(var j = 0; j < tree.view.rowCount; j++) {
      var key = tree.view.getCellText(j, c);
      if(select.find(key) >= 0) {
        tree.view.selection.toggleSelect(j);
        tree.treeBoxObject.ensureRowIsVisible(j);
      }
    }
  }
}

function clearSelected(listTreeName) {
  var list = document.getElementById(listTreeName);
  var tree = list.parentNode;
  if(tree.view) {
    tree.view.selection.clearSelection();
  }
}

function selectedNormal(listTreeName) {
  var list = document.getElementById(listTreeName);
  var tree = list.parentNode;
  var select = new Array();

  var start = new Object();
  var end = new Object();
  for(var t = 0; t < tree.view.selection.getRangeCount(); t++){
    tree.view.selection.getRangeAt(t,start,end);
    for(var v = start.value; v <= end.value; v++) {
      var item = tree.view.getItemAtIndex(v);
      if(!blank(item.getAttribute("key"))) select.push(item.getAttribute("key"));
    }
  }
  return select;
}

function indexes(list, select) {
  var index = new Array();
  for(var i = 0; i < list.length; i++) {
    if(select.find(list[i].uniqueKey) >= 0) index.push(i);
  }
  if(index.length == select.length) {
    index.sort(function(a, b){return b.item - a.item;});
  } else {
    index = new Array();
  }
  return index;
}
