/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'Group';
var singular = 'group';
var plural = 'groups';

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.get('uniqueKey');
  item['modified'] = one.get('modified');
  item['name'] = one.get('group');
  item['id'] = one.get('groupID');
  item['members'] = one.get('groupMembers').join(' ');
  return item;
}

function addObject() {
  var args = new Object();
  args['cluster'] = current;
  args['object'] = 0;
  var d = new dock.cvDialog("editgroup.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}

function editObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a group");
  } else if(select.length > 1) {
    dock.displayError("Please select only one group");
  } else {
    var args = new Object();
    args['cluster'] = current;
    args['object'] = select[0];
    var d = new dock.cvDialog("editgroup.xul", args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function saveGroupList() {
  var list = current.find(basetype);
  for(var i = 0; i < list.length; i++) {
    if(list[i].get('modified')) {
      list[i].commit();
    }
  }
  refresh();
}

function loadGroupList() {
  var list = current.find(basetype);
  for(var i = 0; i < list.length; i++) {
    if(list[i].get('modified')) {
      if(list[i].get('uniqueKey') < dock.MAX_LOCAL_KEY) {
        list[i].remove();
      }
    } else if(list[i].get('uniqueKey') < dock.MAX_LOCAL_KEY) {
      println("This should not be!");
    }
  }
  current.refresh('getGroups');
  refresh();
}
