/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */


 // this file relies on these files to be previously loaded:
 // . genericnodegroupselect.js
 // . hadoop/objecthelpers.js
 // . hadoop/bigdatapreconditionschecker.js
 // (note that the requisites of those files aren't listed here; check them to know what they require).


  // TODO: in order to use,  genericnodegroupselect.js, these globals must be set:
  var currentnodes = new Array();
  var fieldname = undefined;
  var nodesIndex = '';
  var subtype = 'Node';
  var current;
  var extraName = "''";
  var dock;
  var refresh;
  var checkStatus;
  var nodeSelectionProperties = [['','', false],
              ['hostname', 'hostname', false],
              ['MAC', 'mac', false],
              ['tag', 'tag', false],
              ['category', 'category', true],
              ['installmode', 'installMode', false],
              ['rack', 'rack', true],
              ['position', 'rackPosition', false]];
  var belongs = '0';
  var noloop = 'true';
  var extraEvalOnAdd = '';
  var extraEvalOnRemove = '';
  // end genericnodegroupselect.js globals

function scrollUpMainVbox() {
  scrollUpVboxById('dialogbodyVbox');
}    


function elementGetSubElement(element, subelementAccessor) {
  // element is a DOM/XUL object (like in element = document.getElementById("mywidget"))
  // subelementAccessor is , e.g, "value", or "selectedItem.value"
  // it will return element.subelementAccessor, e.g, document.getElementById("mywidget").selectedItem.value
  var code = "element" + subelementAccessor;
  return eval(code);
}


function applyTransformationsOnElement(element, transformationsArray) {
  if (transformationsArray != null) {
    transformationsArray.every( function(transformation, i) {
          var code = transformation.name + "(element,'" + transformation.accessor  + "')";
          element = eval(code);
        }
    );
  }
  return element;
}


function printObjectOnElement(element, object, labels = null, instructions = { "clearBefore": true }) {
  // will display elements in object as key: value widgets in element
  // for keys (in objects) also present in labels: instead of displaying the name of the key
  // as label, it displays labels[key].

  // a helper function for this function:
  function appendChoice(box, fieldName, fieldValue) {
    var hbox = document.createElement('hbox');
    box.appendChild(hbox);

    var field = document.createElement('shadowlabel');
    field.setAttribute('class', 'staticdataheader');
    field.setAttribute('value', fieldName);
    hbox.appendChild(field);
    var label = document.createElement('label');
    label.setAttribute('value', fieldValue);
    hbox.appendChild(label);
  }

  if ((object == null) || (element == null)) {
    return;
  }
  while(instructions.clearBefore && element.firstChild) {
    element.removeChild(element.firstChild);
  }

  var objectKeys = Object.keys(object);
  objectKeys.every( function (propertyName, i) {
    var label = labels && (labels[propertyName] != null) ? labels[propertyName] : propertyName;
    appendChoice(element, label + ": ", object[propertyName]);
    return true;
  });
}


function repeatString(string, times) {
  var repeatedString = "";
  for (var i = times; i; --i) {
    repeatedString += string;
  }
  return repeatedString;
}


function NodeCache() { // NodeCache class -- known issues: it depends on the global "current" widely used in cmgui
  var nodeHostnameKeyCache = {};
  var nodeKeyHostnameCache = {};

  this.nodeKeyToHostnameTrue = function (nodeKey) {
    var hostname = "";
    var nodeEntity = current.find(nodeKey);
    hostname = nodeEntity.get("hostname");
    nodeHostnameKeyCache[hostname] =  nodeKey;
    nodeKeyHostnameCache[nodeKey]  =  hostname;
    return hostname;
  };


  this.nodeKeyToHostnameCached = function (nodeKey) {
    return (nodeKeyHostnameCache[nodeKey] != null)? nodeKeyHostnameCache[nodeKey] : "";
  };


  this.nodeKeyToHostname = function (nodeKey) {
    var cachedHostname = this.nodeKeyToHostnameCached(nodeKey);
    return cachedHostname ? cachedHostname : this.nodeKeyToHostnameTrue(nodeKey);
  };


  this.hostnameToNodeKeyTrue = function (hostname) {
    // TODO: how to get a nodeKey from a hostname? using current too?
    println("ERROR: calling unimplemented function.");
    nodeHostnameKeyCache[hostname] =  nodeKey;
    nodeKeyHostnameCache[nodeKey]  =  hostname;
    return nodeKey;
  }


  this.hostnameToNodeKeyCached = function (hostname) {
    return (nodeHostnameKeyCache[hostname] != null) ? nodeHostnameKeyCache[hostname] : 0;
  }


  this.hostnameToNodeKey = function(hostname) {
    var cachedNodeKey = this.hostnameToNodeKeyCached(hostname);
    return cachedNodeKey ? cachedNodeKey : this.hostnameToNodeKeyTrue(hostname);
  }


} // NodeCache class


function tests() {
}


function BigDataWizard(callerObjectParam, typeParam) { // BigDataWizard object -- the main object in this file
  var wizardType = typeParam;  // object builder. check addsparkinstance SparkBigDataWizardBuilder() for an example.
  var callerObject = callerObjectParam; // "this" of the callerObject
  var currentnodesPerType = {}; // currentnodes, a global required by genericnodegroupselect.js, can hold only one instance. one needs to store and restore the values if designing an interface where multiple nodeSelection widgets are active.
  var nodeCache = new NodeCache();
  var usersChoicesEntryOfFilesToCheckOnHeadNodes = [];
  var preconditionsChecker;

  // required to ensure the instance name won't match reserved words.
  var FLAVOUR_APACHE = 'Apache';
  var FLAVOUR_CLOUDERA = 'Cloudera';
  var FLAVOUR_HORTON = 'Hortonworks';
  var FLAVOUR_PIVOTAL = 'Pivotal';
  var FLAVOURS = [FLAVOUR_APACHE, FLAVOUR_CLOUDERA, FLAVOUR_HORTON, FLAVOUR_PIVOTAL];
  
  // START for datanode selection
  
  var excludeFunction = undefined;
  
  var excludeFunctionNodesUP = function(node) {
    if (node.status.status != 'UP') {
      return true;
    } else {
      return false;
    }
  };
  
  refresh =
  function refresh(use) {
    if (!!use) current = use;
    deviceselect(excludeFunction);
  }
  // END for datanode selection
  
  var myDialog;
  var userChoices;

  var timer = 0;
  var count = 0;
  var saveFile = '';
  
  var javaRuntimeChecker      = false;
  var tarballExistenceChecker = false;
  
  // START for progress bar and steps
  var PATTERN_FIRST_LINE = /^##### cmgui #####$/g;
  var PATTERN_GENERIC = /^### ([^#]+) ### (STARTED|FINISHED|FAILED)$/g;
  var PATTERN_PERC = /^### (\d{1,3})$/g;
  var stepsList;
  var progressPerc = 0;
  // END for progress bar and steps
  
  function onLoad() {
    dock = getDock();
    userChoices = wizardType.getUserChoices();
    println("Add "+ wizardType  +" Instance Wizard initialized: " + callerObject.name);
  
    var s = callerObject.name.indexOf('[');
    var e = callerObject.name.indexOf(']');
    var index = callerObject.name.substr(s + 1, e - s - 1);
    myDialog = dock.dialogs.list[index];
  
    current = myDialog.arguments.cluster;
  
    mainScreen();
  }
  
  function stopAllCheckers()
  {
    if (javaRuntimeChecker) {
      javaRuntimeChecker.stop();
      javaRuntimeChecker = false;
    }
    if (tarballExistenceChecker) {
      tarballExistenceChecker.stop();
      tarballExistenceChecker = false;
    }
  }
  
  function onClose() {
    stopAllCheckers();
  }
  
  function cancel() {
    var args = new Object();
    args['question'] = 'Are you sure you want to quit the wizard?';
    var d = new cvDialog(dock.myVersion + "question.xul", args);
    d.onOk = function() {
      onClose();
      close();
    }
    dock.dialogs.showDialog(d);
  }
  
  function finish() {
    close();
  }
  

  function attributesArrayToString(attributesArray) {
    var string = "";
    var mapElementIdUserChoices = wizardType.mapElementIdUserChoices;
    for (var i = 0; (attributesArray != null) && (i < attributesArray.length); ++i) {
      var attributeName  = attributesArray[i].attributeNameEval?  eval(attributesArray[i].attributeName)  : attributesArray[i].attributeName;
      var attributeValue = attributesArray[i].attributeValueEval? eval(attributesArray[i].attributeValue) : attributesArray[i].attributeValue;
      string += " " + attributeName  + '="' + attributeValue + '"';
    }
    return string;
  }


  function nodeToXML(nodesArray, indentRules = { "indentLevel" : 0, "indentStepSize" : 2, "indentingChar" : " ", "afterTagEnding" : "\n" }) {
    var mapElementIdUserChoices = wizardType.mapElementIdUserChoices;
    var nodeXML = "";
    var indentRulesLevel = indentRules.indentLevel; // keep a local copy of the value, since objects in js are references, and recursion will change it.
    //println("indentRules" + "=" + JSON.stringify(indentRules, null, 2));
    var indentFinalString = repeatString(indentRules.indentingChar, indentRules.indentStepSize*indentRulesLevel);
    //println("level=" + indentRulesLevel + ", string=[" + indentFinalString + "]");
    //print("mapElementIdUserChoices=" + JSON.stringify(mapElementIdUserChoices, null, 2));
    indentRules.indentLevel++;
    if (nodesArray != null) {
      for (var i = 0; i < nodesArray.length; ++i) {
        //println("nodesArray[" + i + "]" + JSON.stringify(nodesArray[i], null, 2));

        var tagName = nodesArray[i].tagNameEval ? eval(nodesArray[i].tagName) : nodesArray[i].tagName;
        var attributesArray  = (nodesArray[i].attributesArray != null) ? nodesArray[i].attributesArray : null;
        var attributesString = attributesArrayToString(attributesArray);
        if ((nodesArray[i].condition) != null && !eval(nodesArray[i].condition)) {
          println("excluding tag " + tagName + ", due to false condition:" + nodesArray[i].condition );
          continue;
        }

        var nodeHeader = indentFinalString + "<"  + tagName + attributesString + ">";
        var nodeFooter = "</" + tagName + ">";
        var nodeBody   = "";

        if (nodesArray[i].text != null) {
          var text = nodesArray[i].textEval?  eval(nodesArray[i].text) : nodesArray[i].text;
          nodeBody += text;
        } else {
          nodeBody += indentRules.afterTagEnding;
          nodeFooter = indentFinalString + nodeFooter;
        }

        if (nodesArray[i].nodesArray != null) {
          nodeBody += nodeToXML(nodesArray[i].nodesArray, indentRules);
        }
        nodeXML += nodeHeader + nodeBody + nodeFooter + indentRules.afterTagEnding;
      }
    }
    indentRules.indentLevel--;
    return nodeXML;
  }


  function deckElementIdToDeckIndex(elementId) {
    var deck = document.getElementById('deck');
    for (var i = 0; i < deck.childNodes.length; i++) {
      var hadoopindex = deck.childNodes[i].getAttribute('hadoopindex');
      if (elementId == hadoopindex) {
        return i;
      }
    }
  }


  function deckIndexToDeckElementId(i) {
    var deck = document.getElementById('deck');
    return deck.childNodes[i].getAttribute('hadoopindex');
  }


  function setDefaultJavaHome(elementId, defaultJavaCheckboxId) {
    onChangeDefaultJavaHomeCheckbox(document.getElementById(defaultJavaCheckboxId), userChoices);
    setJavaHomeBasedOnOS(current, userChoices, document.getElementById(elementId));
  }

  function setDefaultJava180Home(elementId, defaultJavaCheckboxId) {
    onChangeDefaultJavaHomeCheckbox(document.getElementById(defaultJavaCheckboxId), userChoices);
    setJavaHomeBasedOnOS(current, userChoices, document.getElementById(elementId), true);
  }

  function printUserChoicesOnElementId(elementId) {
    var labels = arrayOfObjectsToFlatObject(objectTwoValuesToKeyValueArray(wizardType.mapElementIdUserChoices, "usersChoicesEntry", "humanReadable", true));
    printObjectOnElement(document.getElementById(elementId), userChoices, labels);
  }


  function displayNodesSelection(nodeSelectionType) {
    // nodeSelectionType must be "Zookeeper", "Datanodes", or any other magic indexes that
    // can be used with genericnodegroupselect.js: it will look for a listbox called
    // 'groupnodes' + nodeSelectionType, e.g. groupnodesZookeeper or groupnodesDatanodes
    // if a bad nodeSelectionType, genericnodegroupselect.js will fail, complaining that
    // lba is undefined.

    // load the selections stored of the last time the widget was drawn for nodeSelectionType.
    // we need to load it in the global currentnodes for genericnodegroupselect.js (since
    // it can manage only one nodeSelection list per time)
    currentnodes =
      (currentnodesPerType[nodeSelectionType] != null) ?  currentnodesPerType[nodeSelectionType] : new Array();

    // go genericnodegroupselect.js:
    nodesIndex = nodeSelectionType;
    excludeFunction = excludeFunctionNodesUP;
    deviceselect(excludeFunction);

    // store the selections
    currentnodesPerType[nodesIndex] = currentnodes;
  }


  function validate_currentnodes(rulesArray) {
    if (rulesArray == null) {
      return true;
    }
    var validated = true;
    validated &= rulesArray.every( function(rule, i) {
        println("rule=" + JSON.stringify(rule, null, 2));
        if (eval("currentnodes.length " + rule.condition)) {
          dock.displayError(rule.errorMessage);
          return false;
        }
        return true;
      }
    )
    return validated;
  }

  // returns true if arr1 is a subset of arr2
  function checkNodesSeeds(nodes1, nodes2, message) {
    var arr1 = currentnodesPerType[nodes1];
    var arr2 = currentnodesPerType[nodes2];
    if (arr1.length > arr2.length) {
      dock.displayError(message);
      return false;
    }
    for (var i = 0; i < arr1.length; i++) {
      if (arr2.indexOf(arr1[i]) < 0) {
	dock.displayError(message);
	return false;
      }
    }
    return true;
  }

  function updateNodenameListOnUserChoices() {
    // copy the object property currentnodesPerTypeKeys into the UserChoices object,
    // but, instead of keeping the NodeKeys (as in currentnodesPerTypeKeys), transform
    // them into Hostnames. finally transform the nodeKeys array into the dotFormat notation.
    var currentnodesPerTypeKeys = Object.keys(currentnodesPerType);
    currentnodesPerTypeKeys.forEach(function(key1, index1){
        userChoices[key1] = new Array();
        currentnodesPerType[key1].forEach(function(key2, index2){
          userChoices[key1][index2] = nodeCache.nodeKeyToHostname(currentnodesPerType[key1][index2]);
        });
        userChoices[key1] = dotFormat(userChoices[key1].sort());
    });
  }


  function remoteRequisitesSatisfiedOrPrompt(timeout = 2000) {
    println(new Date());
    // not testing if preconditionsChecker is true: this function is only supposed to be called when it is true.
    return preconditionsChecker.checkPrerequisites(function() { println("timeout and step."); setTimeout(step("next"), timeout); });
  }


  function displayPreconditionsCheckAtElement(elementId) {
  // Get a helper for displaying verificationSteps (it wraps around one DOM element)
    if (!preconditionsChecker) {
      preconditionsChecker = new BigDataPreconditionCheckUtil(
      current, // used to determine (active) headnode
      dock,    // ,,
      MultipleCheckersProgressStepDisplayer(elementId), // used to update progress in UI
        {
        'check_tarballs' : [ BigDataPreconditionCheckUtilTarget.HEADNODES_ONLY,
                             bidimensionalObjectToFlatArray(usersChoicesEntryOfFilesToCheckOnHeadNodes),
                             'summaryPage'
                           ],
        'check_javahome' : [ BigDataPreconditionCheckUtilTarget.INVOLVED_NODES,
                             userChoices.javaHome
                           ],
        'involved_nodes' : bidimensionalObjectToFlatArray(currentnodesPerType),

        'auto_start'     : true // invokes this.run() after constructing
        }
      );
    }

  }


  function step(direction) {
    // direction must be "stay", "next"  or "previous"
    var mapElementIdUserChoices = wizardType.mapElementIdUserChoices;
    var deckStateMachine = wizardType.deckStateMachine;
    var deckStateMachineKeys = Object.keys(deckStateMachine);
    var currentDeckIndex = document.getElementById('deck').selectedIndex;
    var currentDeckElementId = deckIndexToDeckElementId(currentDeckIndex);
    println('... next from ' + currentDeckElementId + ', index=' + currentDeckIndex);

    // ensure userChoices object is up-to-date with the nodes in nodeSelection widgets:
    updateNodenameListOnUserChoices();
    bidimensionalObjectToFlatArray(usersChoicesEntryOfFilesToCheckOnHeadNodes);
    bidimensionalObjectToFlatArray(currentnodesPerType);


    // find the current step of the wizard
    var currentDeckState;
    var currentDeckStateId;
    deckStateMachineKeys.forEach( function (deckStateMachineKey, deckStateMachineIndex) {
       if (currentDeckElementId == deckStateMachine[deckStateMachineKey].elementId) {
         currentDeckStateId = deckStateMachineKey;
         currentDeckState = deckStateMachine[deckStateMachineKey];
       }
    });
    println('... currentDeckStateId=' + currentDeckStateId);

    // don't step ahead if the source step can't be validated:
    var nodeRulesArray = currentDeckState.nodesRules != null? currentDeckState.nodesRules : new Array();
    if((direction == "next") &&
      (!checkLayoutValues(mapElementIdUserChoices, currentDeckStateId, nodeRulesArray))) {
      println("... will stay on step:" + currentDeckStateId  +  ".");
      printall(userChoices);
      return;
    }

    // if going backwards, clear the latest precondition check.
    // this is necessary because:
    // . preconditionsChecker can't be created much earlier (needs information gathered in the wizard)
    // . the preconditionsChecker has to be cleared (problems when running multiple instances on the same DOM element)
    // . it mustn't be cleared if the user stays (remember: step("next") may stay if eval(condition) is never satisfied)
    // so, a safe criteria to clear a preconditionsChecker is when previous is clicked.
    if(direction == "previous"){
      if (preconditionsChecker) preconditionsChecker.stopAll();
      preconditionsChecker = null;
    }

    // find which is the next or previous step of the wizard, by test the conditions of the current one.
    // if not found, default to staying on the current step, without warning or throwing:
    var nextOrPreviousStateId = currentDeckStateId;
    if (currentDeckState[direction] != null) {
      Object.keys(currentDeckState[direction]).forEach ( function (deckStateId, unusedIndex) {
        var condition = currentDeckState[direction][deckStateId];
        if (eval(condition)){
          nextOrPreviousStateId = deckStateId;
          }
      });
    }

    // execute pre-next logic
    if (direction == 'next') {
      var currentDeckState = deckStateMachine[currentDeckElementId];
      if (currentDeckState && currentDeckState.beforeNext != null) {
        for (var i = 0; (currentDeckState.beforeNext != null) && (i < currentDeckState.beforeNext.length); ++i) {
          eval(currentDeckState.beforeNext[i]);
        }
      }
    }

    // actual step, realizable in the DOM:
    var nextOrPreviousDeckState = deckStateMachine[nextOrPreviousStateId];
    println('... going to ' + nextOrPreviousStateId + ', index=' +  deckElementIdToDeckIndex(nextOrPreviousDeckState.elementId));
    document.getElementById('deck').selectedIndex = deckElementIdToDeckIndex(nextOrPreviousDeckState.elementId);

    // enable or disable buttons, accordingly to the availability of directions in the state to follow:
    // previous hidden and disabled in the 1ts screen, visible but disabled in the last, visible and enabled in the others
    document.getElementById('prev').setAttribute('hidden',     nextOrPreviousDeckState.previous == null);
    document.getElementById('prev').setAttribute('disabled',   nextOrPreviousDeckState.previous == null);
    document.getElementById('prev').setAttribute('disabled',   nextOrPreviousDeckState.next     == null);
    // next hidden and disabled in the last screen, visible and enabled in the others
    document.getElementById('next').setAttribute('hidden',     nextOrPreviousDeckState.next     == null);
    document.getElementById('next').setAttribute('disabled',   nextOrPreviousDeckState.next     == null);
    // finish hidden and disabled in all screens, visible but disabled in the  the last one
    document.getElementById('finish').setAttribute('hidden',   nextOrPreviousDeckState.next     != null);
    document.getElementById('finish').setAttribute('disabled', nextOrPreviousDeckState.next     == null);

    // fill layout, accordingly to the mapElementIdUserChoices defined by the instance:
    var mapElementIdUserChoices = wizardType.mapElementIdUserChoices;
    fillLayoutsWithDefaultValues(mapElementIdUserChoices, nextOrPreviousStateId);

    // finish layout, accordingly to the extraSteps defined in the mapElementIdUserChoices of the instance
    // (these steps normally include setDefaultJavaHome() or displayNodesSelection() calls):
    if (nextOrPreviousDeckState.extraSteps != null) {
      for (var i = 0; (nextOrPreviousDeckState.extraSteps != null) && (i < nextOrPreviousDeckState.extraSteps.length); ++i) {
        eval(nextOrPreviousDeckState.extraSteps[i]);
      }
    }
    printall(userChoices);
    tests();
    scrollUpMainVbox();
  }


  function next() {
    step("next");
    return;
  }
  
  function prev() {
    step("previous");
    return;
  }
  
  function fillHostDropdown(popupId, nodes, addEmpty) {
    addEmpty = !!addEmpty;
    var drop = document.getElementById(popupId);
    var popup = drop.firstChild;
    if (!popup) {
      println("!!! ERROR !!!: has no menupopup");
      return;
    }
    while (popup.firstChild) popup.removeChild(popup.firstChild);
    if (addEmpty) {
      var item = document.createElement('menuitem');
      item.setAttribute('key', 0);
      item.setAttribute('label', '');
      popup.appendChild(item);
    }
    for (var i = 0; i < nodes.length; i++) {
      if (!excludeFunctionNodesUP(nodes[i])) {
        var host = nodes[i].get('hostname'),
            uniqueKey = nodes[i].get('uniqueKey'),
            item = document.createElement('menuitem');
        item.setAttribute('key', host);
        item.setAttribute('label', host);
        item.setAttribute('uniqueKey', uniqueKey);
        popup.appendChild(item);
      }
    }
  }
  
  // TODO: move this function to an object of its own, together with validation.
  function fillLayoutsWithDefaultValues(mapElementIdUserChoices, deckId) {
    // this function reads mapElementIdUserChoices, defined by instances of this class
    //  ( addsparkinstancewizard.js) to actually change
    // the key element's attributeToSet with its attributeToSetValue
    var deckElementsIdArray = mapElementIdUserChoices[deckId];
    for (var deckElementId in deckElementsIdArray) {
      if (deckElementsIdArray.hasOwnProperty(deckElementId)) {
        var deckElementIdUserChoicesTuple = deckElementsIdArray[deckElementId];
        // println(" " + deckElementId + "=" + JSON.stringify(deckElementIdUserChoicesTuple, null, 2) );
        if (deckElementIdUserChoicesTuple.usersChoicesEntry == null || userChoices[deckElementIdUserChoicesTuple.usersChoicesEntry] == null) {
          var deckElement = document.getElementById(deckElementId);
          if (deckElementIdUserChoicesTuple.value != null ) {
            deckElement.value = deckElementIdUserChoicesTuple.value;
          }
          if (deckElementIdUserChoicesTuple.attributeToSet != null && deckElementIdUserChoicesTuple.attributeToSetValue != null) {
            deckElement.setAttribute(deckElementIdUserChoicesTuple.attributeToSet,
                deckElementIdUserChoicesTuple.attributeToSetValue);
          }
        } else {
          println("userChoices[" + deckElementIdUserChoicesTuple.usersChoicesEntry + "]=" + userChoices[deckElementIdUserChoicesTuple.usersChoicesEntry] );
        }
      }
    }
  }

  // START deck DECK_MAIN
  function mainScreen() {
    step("stay");
    return;
  }

  function validate(name, as, nameHumanReadable) {
    // as may be: 
    // instanceName
    // lenghtNotZero
    // integerBiggerThanZero
    if (!nameHumanReadable) {
      nameHumanReadable = name;
    }

    if (typeof as === 'function') {
      var ret = as();
      if (ret === true) return true;
      dock.displayError(nameHumanReadable + ' ' + ret);
      return false;
    }
    else if (as == "instanceName") {
      var upperFlavours = FLAVOURS.map(String.toUpperCase);
      if (name.length == 0) {
        dock.displayError('Instance name should be specified');
        return false;
      } else if (name.indexOf(' ') >= 0) {
        dock.displayError('Instance name cannot contain spaces');
        return false;
      } else if (upperFlavours.indexOf(name.toUpperCase()) != -1) {
        dock.displayError('Instance name cannot match the name of a distribution.');
        return false;
      } else if (/^[_a-zA-Z][a-zA-Z0-9_]*$/.exec(name) === null) {
        dock.displayError('Instance name should consist solely of letters, numbers and underscores, and beginning with a letter or underscore.');
        return false;
      } else {
        var hadoops = current.find('HadoopHDFS');
        if (hadoops) {
          for (var i = 0; i < hadoops.length; i++) {
            if (hadoops[i].get('name') == name) {
              dock.displayError('An instance with the same name is already installed');
              return false;
            }
          }
        }
      }
      return true;
    } else if (as == "integerBiggerThanZero") {
      if (name <= 0) {
        dock.displayError(nameHumanReadable + ' should be bigger than zero');
        return false;
        }
      return true;
    } else if (as == "lenghtNotZero") {
      if (name.length == 0) {
        dock.displayError(nameHumanReadable + ' should be specified');
        return false;
        }
      return true;
    } else if (as == "memorySettingOrEmpty") {
      if (name.length == 0) {
	return true;
      } else if (!regexMatch(name, '^[0-9]+[KMGTP]$')) {
	dock.displayError(nameHumanReadable + ' is not a valid memory setting (examples: 4G, 800M)');
        return false;
      } else {
	return true;        
      }
    }
  }

  function checkLayoutValues(mapElementIdUserChoicesAll, deckId, nodeRulesArray) {
    // provides the validation of values in the deck deckId, accordingly to the rules
    // defined by mapElementIdUserChoices and nodeRulesArray
    // TODO: by mistake, mapElementIdUserChoicesAll should be called mapElementIdUserChoices, and 
    // mapElementIdUserChoices should be called deckMapElementIdUserChoices, or something like this.
    var elementsIdArray = Object.keys(mapElementIdUserChoicesAll[deckId]);
    var mapElementIdUserChoices = mapElementIdUserChoicesAll[deckId];
    var keepValidating = true;
    // TODO: many things here shouldn't depend on validate_as being set:
    for (var i = 0; keepValidating && i < elementsIdArray.length; ++i) {
        var elementId = elementsIdArray[i];
        // println("elementId=" + elementId);
        if (mapElementIdUserChoices[elementId].validate_as != null ) {
          // println("validate_as=" + mapElementIdUserChoices[elementId].validate_as);

          var elementAttributeValue = document.getElementById(elementId)[mapElementIdUserChoices[elementId].attributeToSet] != null?
            document.getElementById(elementId)[mapElementIdUserChoices[elementId].attributeToSet]:
            document.getElementById(elementId).getAttribute(mapElementIdUserChoices[elementId].attributeToSet);
          // println("elementAttributeValue=" + elementAttributeValue + "=" + JSON.stringify(elementAttributeValue, null, 2));

          if (mapElementIdUserChoices[elementId].transformations != null) {
            elementAttributeValue = applyTransformationsOnElement(elementAttributeValue, mapElementIdUserChoices[elementId].transformations);
            // println("after elementAttributeValue=" + elementAttributeValue + "=" + JSON.stringify(elementAttributeValue, null, 2));
          }

          elementAttributeValue = String(elementAttributeValue).trim();
          var as =  mapElementIdUserChoices[elementId].validate_as;
          var humanReadable = mapElementIdUserChoices[elementId].humanReadable != null ?
            mapElementIdUserChoices[elementId].humanReadable :
            elementId;
          keepValidating &= validate(elementAttributeValue, as, humanReadable);
          var usersChoicesEntry = mapElementIdUserChoices[elementId].usersChoicesEntry != null?
            mapElementIdUserChoices[elementId].usersChoicesEntry :
            elementId;
          // put values in userChoices
          userChoices[usersChoicesEntry] = elementAttributeValue;
          // test if it is a file to be checked on headnode
          if(mapElementIdUserChoices[elementId].checkFileOnHeadnode) {
             usersChoicesEntryOfFilesToCheckOnHeadNodes[usersChoicesEntry] = [ elementAttributeValue ];
          }
        }
    }
    keepValidating &= validate_currentnodes(nodeRulesArray);
    return keepValidating;
  }

  
  
  function showConfiguration() {
  
    var args = new Object();
    args['title'] = 'XML Configuration';
    args['style'] = 'background-color: white !important;';
    args['text'] = nodeToXML(wizardType.getConfigurationFileToBeDisplayedStructure());
    var d = new cvDialog(dock.myVersion + "showtext.xul", args);
    dock.dialogs.showDialog(d);
  }
  
  function saveConfiguration() {
    saveSetup(true);
  }
  
  function saveSetup(saveas) {
  
    var file = saveFile;
    if (saveas || (saveFile.length == 0)) {
      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
      if (saveas) {
        fp.init(window, "Save XML setup file as", nsIFilePicker.modeSave);
      } else {
        fp.init(window, "Save XML setup file", nsIFilePicker.modeSave);
      }
      var path = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      path.initWithPath(dock.BASE_PATH);
      fp.displayDirectory = path;
      fp.appendFilter("XML setup files", "*.xml");
      var res = fp.show();
      if ((res == nsIFilePicker.returnOK) || (res == nsIFilePicker.returnReplace)) {
        file = fp.file.path;
        if (!endswith(file, '.xml')) file += '.xml';
      } else {
        return;
      }
    }
    println(file);
    savefile(file, nodeToXML(wizardType.getConfigurationFileToBeDisplayedStructure()));
    saveFile = file;
  }
  /**
   * Given information on which UI elements to read for node unique keys (collected in summary())
   *  read all these uniqueKey values and return them (unique)
   */
  function getNodeKeysUsedByNewHadoopInstance(readNodeKeysFromUserChoicesBucket, readNodeKeysFromDropDownBoxes)
  {
    var nodeKeysUsedByNewHadoopInstance = [], i, dropdownElement, key;
  
    // Merge all userChoices.xyzKeys Arrays into nodeKeysUsedByNewHadoopInstance.
    for (i=0; i<readNodeKeysFromUserChoicesBucket.length; i++) {
      if (!userChoices[readNodeKeysFromUserChoicesBucket[i]])
        continue;
  
      // concat but filter out elements already in the array first
      nodeKeysUsedByNewHadoopInstance = nodeKeysUsedByNewHadoopInstance.concat(
        userChoices[readNodeKeysFromUserChoicesBucket[i]].filter(
          function (item) {
            return nodeKeysUsedByNewHadoopInstance.indexOf(item) < 0;
          }
        )
      );
    }
  
    // Merge all selected dropdown values into nodeKeysUsedByNewHadoopInstance.
    for (i=0; i<readNodeKeysFromDropDownBoxes.length; i++) {
      dropdownElement = document.getElementById(readNodeKeysFromDropDownBoxes[i]);
      if (!(dropdownElement && dropdownElement.selectedItem)) continue;
  
      key = parseInt(dropdownElement.selectedItem.getAttribute('uniqueKey'));
      if (key && nodeKeysUsedByNewHadoopInstance.indexOf(key) < 0)
        nodeKeysUsedByNewHadoopInstance.push(key);
    }
  
    return nodeKeysUsedByNewHadoopInstance;
  }
  // END deck SUMMARY
  
  // START deck DEPLOY
  function deploy() {
    var xmlConfig = nodeToXML(wizardType.configurationFileStructure);
    document.getElementById('dialogtitle').setAttribute('value', 'Installation progress');
    var text = "\n" + wizardType + " configuration for instance '" + userChoices.instanceName + "' has been written. A " + wizardType +" instance is being installed. Installation progress is shown below.";
    document.getElementById('deployMessage').setAttribute('value', text);
  
    if (xmlConfig != "") {
      var id = 0;
      overviewBar('progressBar', 0, 100);
      stepsList = new Array();
      var remoteCallParameters = wizardType.getRemoteCallParameters();
      dock.workerpool.getWorker(current.actualurl).call(remoteCallParameters.service, remoteCallParameters.remoteCall, [remoteCallParameters.remoteCallType, xmlConfig], function(code, data) {
        if(code == 0) {
          id = data.setupExecutionID;
          timer = window.setTimeout('checkStatus(' + id +');', 1000);
        } else {
          dock.jsonCallError(this, code, data);
        }
      }, current);
    } else {
      println('not running');
    }
  }
  
  checkStatus = function checkStatus(id) {
    timer = 0;
    count++;
    if (count > 2000) {
      return;
    }
  
    dock.workerpool.getWorker(current.actualurl).call('cmhadoop', 'getHadoopSetupExecution', [id], function(code, data) {
      if(code == 0) {
        if (!data) {
          dock.displayError('A Hadoop instance is already being installed.');
          return;
        }
        var currentProgress = "";
        var stepsCounter = 0;
        for (var i = 0; i < data.datacout.length; i++) {
          var matched = false;
  
          if (data.datacout[i].match(PATTERN_FIRST_LINE)) {
            document.getElementById('deployProgress').removeAttribute('hidden');
            matched = true;
          }
          var m;
          do {
            m = PATTERN_GENERIC.exec(data.datacout[i]);
            if (m) {
              matched = true;
              //println('matching m = ' + m);
              stepsList[stepsCounter++] = m;
            }
          } while (m);
          var m2 = PATTERN_PERC.exec(data.datacout[i]);
          if (m2) {
            matched = true;
            //println('matching m2 = ' + m2);
            progressPerc = m2[1];
          }
  
          if (!matched) {
            currentProgress += data.datacout[i];
            currentProgress += "\n";
          }
        }
        var deployStepsDisplay = new ProgressStepDisplayer('deploySteps');
  
        deployStepsDisplay.clearAll();
  
        // merge stepsList (this collapses the no longer relevant messages:
        //  {A started, A finished, B started, B finished, C started} -> {A finished, B finished, C started})
        var mergedStepsList = new Array();
        for (var i = 0; i < stepsList.length; i++) {
          var item = stepsList[i];
          if (stepsList[i-1]) {
            var previousItem = stepsList[i-1];
            if (item[1] == previousItem[1]) {
              mergedStepsList[mergedStepsList.length-1] = item;
            } else {
              mergedStepsList.push(item);
            }
          } else {
            mergedStepsList.push(item);
          }
        }
  
        for (var i = 0; i < mergedStepsList.length; i++) {
          deployStepsDisplay.add(mergedStepsList[i][2], mergedStepsList[i][1]);
        }
  
        overviewBar('progressBar', progressPerc, 100);
  
        var deployOutput = document.getElementById('deployOutput');
        deployOutput.value = currentProgress;
        var ti = document.getAnonymousNodes(deployOutput)[0].childNodes[0];
        ti.scrollTop = ti.scrollHeight;
  
        if (data.finishedAt == 0) {
          document.getElementById('canc').setAttribute('disabled', true);
          document.getElementById('prev').setAttribute('disabled', true);
          timer = window.setTimeout('checkStatus(' + id +');', 3000);
        } else if (data.successful) {
          overviewBar('progressBar', 100, 100);
          document.getElementById('finish').setAttribute('disabled', false);
        } else { // failed
          document.getElementById('prev').setAttribute('disabled', false);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
  }
  // END deck DEPLOY
  
  // TODO: make script to remove these.
  this.refresh = function(use) {  refresh(use); };
  this.onLoad = function() {  onLoad(); };
  this.stopAllCheckers = function() {  stopAllCheckers(); };
  this.onClose = function() {  onClose(); };
  this.cancel = function() {  cancel(); };
  this.finish = function() {  finish(); };
  this.getNumericIndexFromDeckString = function(deckString) {  getNumericIndexFromDeckString(deckString); };
  this.step = function(direction) {  step(direction); };
  this.next = function() {  next(); };
  this.prev = function() {  prev(); };
  this.fillHostDropdown = function(popupId, nodes, addEmpty) {  fillHostDropdown(popupId, nodes, addEmpty); };
  this.fillLayoutsWithDefaultValues = function (deckElementsIdArray) { fillLayoutsWithDefaultValues(deckElementsIdArray); };
  this.mainScreen = function() {  mainScreen(); };
  this.changeAllDataRoot = function() {  wizardType.changeAllDataRoot(); };
  this.onChangeDefaultJavaHomeCheckbox = function (elem) { return onChangeDefaultJavaHomeCheckbox(elem, wizardType.getUserChoices()); };
  this.checkNameEtc = function() {  checkNameEtc(); };
  this.setOptions = function(num) {  setOptions(num); };
  this.journalnodesSelection = function() {  journalnodesSelection(); };
  this.checkJournalnodes = function() {  checkJournalnodes(); };
  this.masternodesSelection = function() {  masternodesSelection(); };
  this.checkMasternodes = function() {  checkMasternodes(); };
  this.datanodesSelection = function() {  datanodesSelection(); };
  this.checkDatanodes = function() {  checkDatanodes(); };
  this.zookeeperNodes = function() {  zookeeperNodes(); };
  this.checkZookeeperNodes = function() {  checkZookeeperNodes(); };
  this.hbaseNodes = function() {  hbaseNodes(); };
  this.checkHbaseNodes = function() {  checkHbaseNodes(); };
  this.checkJavaParams = function() {  wizardType.checkJavaParams(); };
  this.summary = function() {  summary(); };
  this.checkPrerequisitesHadoop = function() {  checkPrerequisitesHadoop(); };
  this.appendChoice = function(box, fieldName, fieldValue) {  appendChoice(box, fieldName, fieldValue); };
  this.showConfiguration = function() {  showConfiguration(); };
  this.saveConfiguration = function() {  saveConfiguration(); };
  this.saveSetup = function(saveas) {  saveSetup(saveas); };
  this.getNodeKeysUsedByNewHadoopInstance = function(readNodeKeysFromUserChoicesBucket, readNodeKeysFromDropDownBoxes) {  getNodeKeysUsedByNewHadoopInstance(readNodeKeysFromUserChoicesBucket, readNodeKeysFromDropDownBoxes); };
  this.formatErrorMessage = function(errorMessage, failedNodes, maxNumberNodes, showDetailedErrors) {  formatErrorMessage(errorMessage, failedNodes, maxNumberNodes, showDetailedErrors); };
  this.startHadoopTarballsChecking = function(verificationSteps, headnodeKeys, tarballsToCheckOnHeadNodes) {  startHadoopTarballsChecking(verificationSteps, headnodeKeys, tarballsToCheckOnHeadNodes); };
  this.startJavaRuntimeChecking = function(verificationSteps, nodeKeysUsedByNewHadoopInstance) {  startJavaRuntimeChecking(verificationSteps, nodeKeysUsedByNewHadoopInstance); };
  this.deploy = function() {  deploy(); };
  this.checkStatus = function(id) {  checkStatus(id); };
  this.createXMLconfigFile = function(includeAll) {  createXMLconfigFile(includeAll); };
  this.addTextNode = function(doc, node, name, value) {  addTextNode(doc, node, name, value); };

  println("BigDataWizard constructor, calls onLoad(). type=" + wizardType + ".");
  onLoad();

} // BigDataWizard object end
