/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var DEBUG = false;

var FLAVOUR_APACHE = 'Apache';
var FLAVOUR_CLOUDERA = 'Cloudera';
var FLAVOUR_HORTON = 'Hortonworks';
var FLAVOUR_PIVOTAL = 'Pivotal';
var FLAVOURS = [FLAVOUR_APACHE, FLAVOUR_CLOUDERA, FLAVOUR_HORTON, FLAVOUR_PIVOTAL];

// stuff for deck management START
var DECK_MAIN = 'main';
var DECK_DISTRO = 'distro';
var DECK_JOURNALNODES = 'journalnodes';
var DECK_MASTERNODES = 'masternodes';
var DECK_DATANODES = 'datanodes';
var DECK_ZOOKEEPER = 'zookeeper';
var DECK_HBASE = 'hbase';
var DECK_SUMMARY = 'summary';
var DECK_DEPLOY = 'deploy';
var currentDeck = '';
// stuff for deck management END

// START for datanode selection
var fieldname = undefined;
var subtype = 'Node';
var extraName = "''";
var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['category', 'category', true],
            ['installmode', 'installMode', false],
            ['rack', 'rack', true],
            ['position', 'rackPosition', false]];
var belongs = '0';
var noloop = 'true';
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

var currentnodes = new Array();
var nodesIndex = '';
var excludeFunction = undefined;

var excludeFunctionNodesUP = function(node) {
  if (node.status.status != 'UP') {
    return true;
  } else {
    return false;
  }
};

function refresh(use) {
  if (!!use) current = use;
  deviceselect(excludeFunction);
}
// END for datanode selection

var dock;
var myDialog;
var current;
var userChoices;
var lustreSupported = false;
var yarnHaSupported = false;
var kmsAvailable = false;

var timer = 0;
var count = 0;
var saveFile = '';

var hadoopPreconditionsChecker = false;

// START for progress bar and steps
var PATTERN_FIRST_LINE = /^##### cmgui #####$/g;
var PATTERN_GENERIC = /^### ([^#]+) ### (STARTED|FINISHED|FAILED)$/g;
var PATTERN_PERC = /^### (\d{1,3})$/g;
var stepsList;
var progressPerc = 0;
// END for progress bar and steps

var tarballWizardExtender = false;
// Comment the following line to disable the smart tarball feature in the Wizard
tarballWizardExtender = new HadoopWizardExtenderWithActualTarballInformation();

var displayInfoToUser = false; // will be re-used for getting the old hash in successive calls to showSelectedTarballs()
var liveTarballCheckerTimer = null;
var liveTarballCheckerLastChecked = null;

function onLoad() {
  dock = getDock();
  userChoices = {};

  println("Add Hadoop Instance Wizard initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.cluster;

  userChoices.kmsHost = "";
  userChoices.useSsl = "false";
  userChoices.sslOnly = "false";
  userChoices.nameNodePort = 8020;
  userChoices.nameNodeHttpPort = 50070;
  userChoices.nameNodeHttpsPort = 50470;
  userChoices.secondaryNameNodeHttpPort = 50090;
  userChoices.secondaryNameNodeHttpsPort = 50091;
  userChoices.HAnameServiceID = 'mycluster';
  userChoices.HAnameNodeID1 = 'nn1';
  userChoices.HAnameNodeID2 = 'nn2';
  userChoices.HAnameNodePort = 8020;
  userChoices.HAnameNodeHttpPort = 50070;
  userChoices.HAnameNodeHttpsPort = 50470;
  userChoices.HAjournalPort = 8485;
  userChoices.HAjournalHttpPort = 8480;
  userChoices.HAjournalHttpsPort = 8481;
  userChoices.federationClusterID = 'mycluster';
  userChoices.federationNameNodeIDs = ['nn1', 'nn2', 'nn3', 'nn4'];
  userChoices.federationNameNodeMountPoints = ['/user', '/tmp', '/staging', '/hbase'];
  userChoices.federationNameNodePorts = ['8020', '8020', '8020', '8020'];
  userChoices.federationNameNodeHttpPorts = ['50070', '50070', '50070', '50070'];
  userChoices.federationNameNodeHttpsPorts = ['50470', '50470', '50470', '50470'];
  userChoices.federationSecondaryNameNodeHttpPorts = ['50090', '50090', '50090', '50090'];
  userChoices.federationSecondaryNameNodeHttpsPorts = ['50490', '50490', '50490', '50490'];
  userChoices.jobTrackerPort = 9000;
  userChoices.jobTrackerHttpPort = 50030;
  userChoices.dataNodePort = 50010;
  userChoices.dataNodeIpcPort = 50020;
  userChoices.dataNodeHttpPort = 50075;
  userChoices.dataNodeHttpsPort = 50475;
  userChoices.taskTrackerHttpPort = 50060;
  userChoices.nodeManagerLocalizerPort = 8040;
  userChoices.nodeManagerWebAppPort = 8042;
  userChoices.nodeManagerWebAppHttpsPort = 8044;
  userChoices.nodeManagerShufflePort = 8091;
  userChoices.yarnServerResourceManagerPort = 8032;
  userChoices.yarnServerResourceManagerSchedulerPort = 8030;
  userChoices.yarnServerResourceManagerWebAppPort = 8088;
  userChoices.yarnServerResourceManagerWebAppHttpsPort = 8090;
  userChoices.yarnServerResourceManagerRtPort = 8031;
  userChoices.yarnServerResourceManagerAdminPort = 8033;
  userChoices.yarnServerJobHistoryPort = 10020;
  userChoices.yarnServerJobHistoryWebAppPort = 19888;
  userChoices.yarnServerJobHistoryWebAppHttpsPort = 19890;
  userChoices.yarnServerTimelinePort = 10021;
  userChoices.yarnServerTimelineWebAppPort = 8188;
  userChoices.yarnServerTimelineWebAppHttpsPort = 8190;
  userChoices.zookeeperClientPort = 2181;
  userChoices.zookeeperServerPort = 2888;
  userChoices.zookeeperElectionPort = 3888;
  userChoices.hbaseMasterPort = 60000;
  userChoices.hbaseMasterInfoPort = 60010;
  userChoices.hbaseRegionServerPort = 60020;
  userChoices.hbaseRegionServerInfoPort = 60030;
  userChoices.useDefaultJavaHome = true;

  mainScreen();
}

function onClose() {
  if (hadoopPreconditionsChecker) {
    hadoopPreconditionsChecker.stopAll();
    hadoopPreconditionsChecker = false;
  }
}

function cancel() {
  var args = new Object();
  args['question'] = 'Are you sure you want to quit the wizard?';
  var d = new cvDialog(dock.myVersion + "question.xul", args);
  d.onOk = function() {
    onClose();
    close();
  }
  dock.dialogs.showDialog(d);
}

function finish() {
  close();
}

function getNumericIndexFromDeckString(deckString) {
  // get index for nextDeck
  var deck = document.getElementById('deck');
  for (var i = 0; i < deck.childNodes.length; i++) {
    var hadoopindex = deck.childNodes[i].getAttribute('hadoopindex');
    if (deckString == hadoopindex) {
      return i;
    }
  }
}

function next() {
  println('next from ' + currentDeck);
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);

  if (currentDeck == DECK_MAIN) {
    if (!checkNameEtc()) return;
    currentDeck = DECK_DISTRO;
    distroSelection();
  } else if (currentDeck == DECK_DISTRO) {
    if (!checkDistro()) return;
    if (userChoices.haManual || userChoices.haAuto) { // jump to journal
      currentDeck = DECK_JOURNALNODES;
      journalnodesSelection();
    } else {
      currentDeck = DECK_MASTERNODES;
      masternodesSelection();
    }
  } else if (currentDeck == DECK_JOURNALNODES) {
    if (!checkJournalnodes()) return;
    currentDeck = DECK_MASTERNODES;
    masternodesSelection();
  } else if (currentDeck == DECK_MASTERNODES) {
    if (!checkMasternodes()) return;
    currentDeck = DECK_DATANODES;
    datanodesSelection();
  } else if (currentDeck == DECK_DATANODES) {
    if (!checkDatanodes()) return;
    if (userChoices.installZooKeeper) {
      currentDeck = DECK_ZOOKEEPER;
      zookeeperNodes();
    } else {
      currentDeck = DECK_SUMMARY;
      summary();
    }
  } else if (currentDeck == DECK_ZOOKEEPER) {
    if (!checkZookeeperNodes()) return;
    if (userChoices.installHBase) {
      currentDeck = DECK_HBASE;
      hbaseNodes();
    } else {
      currentDeck = DECK_SUMMARY;
      summary();
    }
  } else if (currentDeck == DECK_HBASE) {
    if (!checkHbaseNodes()) return;
    currentDeck = DECK_SUMMARY;
    summary();
  } else if (currentDeck == DECK_SUMMARY) {
    if (hadoopPreconditionsChecker && !hadoopPreconditionsChecker.checkPrerequisites(next)) {
      return;
    }
    currentDeck = DECK_DEPLOY;
    deploy();
  }
  index = getNumericIndexFromDeckString(currentDeck);

  println('going to ' + currentDeck + ' (' + index + ')');

  document.getElementById('deck').selectedIndex = index;
  document.getElementById('prev').setAttribute('hidden', index == 0);
  document.getElementById('prev').setAttribute('disabled', index == 0);
  document.getElementById('next').setAttribute('hidden', index == pages);
  document.getElementById('finish').setAttribute('hidden', index < pages);
  document.getElementById('finish').setAttribute('disabled', true);

  scrollUpVboxById('dialogbodyVbox');
}

function prev() {
  println('prev from ' + currentDeck);
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);

  if (currentDeck == DECK_DISTRO) {
    currentDeck = DECK_MAIN;
    mainScreen();
  } else if (currentDeck == DECK_JOURNALNODES) {
    currentDeck = DECK_DISTRO;
    distroSelection();
  } else if (currentDeck == DECK_MASTERNODES) {
    if (userChoices.haManual || userChoices.haAuto) {
      currentDeck = DECK_JOURNALNODES;
      journalnodesSelection();
    } else {
      currentDeck = DECK_DISTRO;
      distroSelection();
    }
  } else if (currentDeck == DECK_DATANODES) {
    currentDeck = DECK_MASTERNODES;
    masternodesSelection();
  } else if (currentDeck == DECK_ZOOKEEPER) {
    currentDeck = DECK_DATANODES;
    datanodesSelection();
  } else if (currentDeck == DECK_HBASE) {
    currentDeck = DECK_ZOOKEEPER;
    zookeeperNodes();
  } else if (currentDeck == DECK_SUMMARY) {
    if (userChoices.installHBase) {
      currentDeck = DECK_HBASE;
      hbaseNodes();
    } else if (userChoices.installZooKeeper) {
      currentDeck = DECK_ZOOKEEPER;
      zookeeperNodes();
    } else {
      currentDeck = DECK_DATANODES;
      datanodesSelection();
    }
  } else if (currentDeck == DECK_DEPLOY) {
    currentDeck = DECK_SUMMARY;
    summary();
  }

  index = getNumericIndexFromDeckString(currentDeck);

  println('going to ' + currentDeck + ' (' + index + ')');

  document.getElementById('deck').selectedIndex = index;
  document.getElementById('prev').setAttribute('disabled', index == 0);
  document.getElementById('next').setAttribute('hidden', index == pages);
  document.getElementById('next').removeAttribute('disabled');
  document.getElementById('finish').setAttribute('hidden', index < pages);
  document.getElementById('finish').setAttribute('disabled', true);

  scrollUpVboxById('dialogbodyVbox');
}

function fillHostDropdown(popupId, nodes, addEmpty) {
  addEmpty = !!addEmpty;
  var drop = document.getElementById(popupId);
  var popup = drop.firstChild;
  if (!popup) {
    println("!!! ERROR !!!: has no menupopup");
    return;
  }
  while (popup.firstChild) popup.removeChild(popup.firstChild);
  if (addEmpty) {
    var item = document.createElement('menuitem');
    item.setAttribute('key', 0);
    item.setAttribute('label', '');
    popup.appendChild(item);
  }
  for (var i = 0; i < nodes.length; i++) {
    if (!excludeFunctionNodesUP(nodes[i])) {
      var host = nodes[i].get('hostname'),
          uniqueKey = nodes[i].get('uniqueKey'),
          item = document.createElement('menuitem');
      item.setAttribute('key', host);
      item.setAttribute('label', host);
      item.setAttribute('uniqueKey', uniqueKey);
      popup.appendChild(item);
    }
  }
}

// START deck DECK_MAIN
function mainScreen() {
  currentDeck = DECK_MAIN;

  document.getElementById('dialogtitle').setAttribute('value', 'Hadoop main details');
  var text = "Please set the name of the instance and the Java home directory. Also set the root directory for where Hadoop stores its data. By default it is set to:\n/var/lib/hadoop/{instanceName}/\n\nMultiple root directories can be set using a comma to separate them.\nExample: '/data1,/data2'";
  document.getElementById('mainMessage').setAttribute('value', text);
  document.getElementById('instanceName').value = 'hdfs1';
  if (!userChoices.genericDataRoot) {
    document.getElementById('genericDataRoot').value = '/var/lib/hadoop/hdfs1/';
  }

  text = "NameNode and DataNodes will use by default the 'Generic data root'. However, it's possible to specify dedicated directories for them.\nExample: '/datann1,/datann2'";
  document.getElementById('secondMessage').setAttribute('value', text);
  if (!userChoices.namenodeDataDirs) {
    document.getElementById('namenodeDataDirs').value = '/var/lib/hadoop/hdfs1/';
  }
  if (!userChoices.datanodeDataDirs) {
    document.getElementById('datanodeDataDirs').value = '/var/lib/hadoop/hdfs1/';
  }

  var defaultJavaHomeElem = document.getElementById('defaultJavaHome'),
      defaultJavaCheckbox = document.getElementById('useDefaultJavaHome');

  defaultJavaCheckbox.checked = userChoices.useDefaultJavaHome;
  onChangeDefaultJavaHomeCheckbox(defaultJavaCheckbox, userChoices);

  setJavaHomeBasedOnOS(current, userChoices, defaultJavaHomeElem, true);
}

function changeAllDataRoot() {
  if (document.getElementById('instanceName').value.length > 0) {
    var instanceName = document.getElementById('instanceName').value.trim();
    var root = '/var/lib/hadoop/' + instanceName + '/';
    document.getElementById('genericDataRoot').value = root;
    document.getElementById('namenodeDataDirs').value = root;
    document.getElementById('datanodeDataDirs').value = root;
  }
}

function checkNameEtc() {
  var name = document.getElementById('instanceName').value.trim();
  var upperFlavours = FLAVOURS.map(String.toUpperCase);
  if (name.length == 0) {
    dock.displayError('Instance name should be specified');
    return false;
  } else if (name.indexOf(' ') >= 0) {
    dock.displayError('Instance name cannot contain spaces');
    return false;
  } else if (upperFlavours.indexOf(name.toUpperCase()) != -1) {
    dock.displayError('Instance name cannot match the name of a Hadoop distribution.');
    return false;
  } else if (/^[_a-zA-Z][a-zA-Z0-9_]*$/.exec(name) === null) {
    dock.displayError('Instance name should consist solely of letters, numbers and underscores, and beginning with a letter or underscore.');
    return false;
  } else {
    var hadoops = current.find('HadoopHDFS');
    if (hadoops) {
      for (var i = 0; i < hadoops.length; i++) {
        if (hadoops[i].get('name') == name) {
          dock.displayError('A Hadoop instance with the same name is already installed');
          return false;
        }
      }
    }
  }
  if (!document.getElementById('useDefaultJavaHome').checked && document.getElementById('javaHome').value.length == 0) {
    dock.displayError('Java home should be specified');
    return false;
  }
  if (document.getElementById('useDefaultJavaHome').checked && document.getElementById('javaHome').value.length == 0) {
    dock.displayError('Default Java home could not be detected, please specify one yourself');
    document.getElementById('useDefaultJavaHome').checked = false;
    onChangeDefaultJavaHomeCheckbox(document.getElementById('useDefaultJavaHome'), userChoices);
    return false;
  }
  if (document.getElementById('genericDataRoot').value.length == 0) {
    dock.displayError('Data root should be specified');
    return false;
  }
  userChoices.instanceName = document.getElementById('instanceName').value.trim();

  if (document.getElementById('useDefaultJavaHome').checked) {
    userChoices.javaHome = document.getElementById('defaultJavaHome').value.trim();
  } else {
    userChoices.javaHome = document.getElementById('javaHome').value.trim();
  }
  userChoices.genericDataRoot = document.getElementById('genericDataRoot').value.trim();
  if (document.getElementById('namenodeDataDirs').value != document.getElementById('genericDataRoot').value.trim()) {
    userChoices.namenodeDataDirs = document.getElementById('namenodeDataDirs').value.trim();
  }
  if (document.getElementById('datanodeDataDirs').value != document.getElementById('genericDataRoot').value.trim()) {
    userChoices.datanodeDataDirs = document.getElementById('datanodeDataDirs').value.trim();
  }
  return true;
}
// END deck DECK_MAIN

// START deck DECK_DISTRO
function distroSelection() {
  currentDeck = DECK_DISTRO;
  document.getElementById('dialogtitle').setAttribute('value', 'Hadoop distribution/version selection');
  document.getElementById('distroMessage').setAttribute('value', 'Please select Hadoop distribution/version. Depending on your selection, different options will be shown in the section at the bottom.\n\nYou can optionally install ZooKeeper and HBase.\n\nAll the tarballs proposed in the dropdowns are available at\nhttp://support.brightcomputing.com/bigdata/');
  var distroSelect = document.getElementById('distro');
  var popup = distroSelect.firstChild;
  if (!popup) {
    println("!!! ERROR !!!: has no menupopup");
    return;
  }
  while (popup.firstChild) popup.removeChild(popup.firstChild);
  for (var i = 0; i < SUPPORTED_DISTROS.length; i++) {
    var name = SUPPORTED_DISTROS[i][0];
    var basedOn = SUPPORTED_DISTROS[i][1];
    var item = document.createElement('menuitem');
    var text = name;
    if (basedOn != '') {
      text += '   (' + basedOn + ')';
    }
    item.setAttribute('key', name);
    item.setAttribute('label', text);
    popup.appendChild(item);
  }
  popup.addEventListener('command', distro_command, true);

  if (DEBUG) {
    distroSelect.selectedIndex = 1;
    setDistro(1);
  }

  if (tarballWizardExtender !== false) {
    var updater = GetReturnValuesFromPreConditionChecker(tarballWizardExtender.getReturnValues.bind(tarballWizardExtender));
    hadoopPreconditionsChecker = new BigDataPreconditionCheckUtil(
      current, // used to determine (active) headnode
      dock,    // ,,
      updater, // used to update progress in UI
      {
        'get_tarballs': [BigDataPreconditionCheckUtilTarget.HEADNODES_ONLY],
        'auto_start': false
      }
    );
    updater.setChecker(hadoopPreconditionsChecker);
    hadoopPreconditionsChecker.run();
  }
}

function distro_command(event) {
  var item = event.target;
  var selectedIndex = item.parentNode.parentNode.selectedIndex;
  setDistro(selectedIndex);
}

function setDistro(index) {
  var version = SUPPORTED_DISTROS[index][2];
  document.getElementById('hadoopTarball').value = CM_LOCAL_PREFIX + SUPPORTED_DISTROS[index][3];
  if (tarballWizardExtender !== false) {
    tarballWizardExtender.clear();
    var res = tarballWizardExtender.resolve('hadoopTarball', SUPPORTED_DISTROS[index][3]);
    if (res !== false) {
      document.getElementById('hadoopTarballAvail').selectedIndex = res[0];
      document.getElementById('hadoopTarballCorrected').value = CM_LOCAL_PREFIX + res[1]
    }
  }

  if (SUPPORTED_DISTROS[index][4] == '') {
    document.getElementById('zooKeeperTarball').value = 'included in Hadoop tarball';
    document.getElementById('zooKeeperTarball').setAttribute('readonly', true);
    document.getElementById('zooKeeperTarball').readOnly = true;
    document.getElementById('zooKeeperTarballAvail').selectedIndex = -1;
    if (tarballWizardExtender) {
      tarballWizardExtender.showTarballNotAvailableInfo('zooKeeperTarball', true, 'This tarball is included in the Hadoop tarball.');
    }
  } else {
    document.getElementById('zooKeeperTarball').value = CM_LOCAL_PREFIX + SUPPORTED_DISTROS[index][4];
    document.getElementById('zooKeeperTarball').setAttribute('readonly', false);
    document.getElementById('zooKeeperTarball').readOnly = false;
    var res = tarballWizardExtender && tarballWizardExtender.resolve('zooKeeperTarball', SUPPORTED_DISTROS[index][4]);
    if (res !== false) {
      document.getElementById('zooKeeperTarballAvail').selectedIndex = res[0];
      document.getElementById('zooKeeperTarballCorrected').value = CM_LOCAL_PREFIX + res[1]
    }
  }
  if (SUPPORTED_DISTROS[index][5] == '') {
    document.getElementById('hbaseTarball').value = 'included in Hadoop tarball';
    document.getElementById('hbaseTarball').setAttribute('readonly', true);
    document.getElementById('hbaseTarball').readOnly = true;
    document.getElementById('hbaseTarballAvail').selectedIndex = -1;
    if (tarballWizardExtender) {
      tarballWizardExtender.showTarballNotAvailableInfo('hbaseTarball', true, 'This tarball is included in the Hadoop tarball.');
    }
  } else {
    document.getElementById('hbaseTarball').value = CM_LOCAL_PREFIX + SUPPORTED_DISTROS[index][5];
    var res = tarballWizardExtender && tarballWizardExtender.resolve('hbaseTarball', SUPPORTED_DISTROS[index][5]);
    if (res !== false) {
      document.getElementById('hbaseTarballAvail').selectedIndex = res[0];
      document.getElementById('hbaseTarballCorrected').value = CM_LOCAL_PREFIX + res[1]
    }
    document.getElementById('hbaseTarball').setAttribute('readonly', false);
    document.getElementById('hbaseTarball').readOnly = false;
  }
  lustreSupported = SUPPORTED_DISTROS[index][6];
  yarnHaSupported = SUPPORTED_DISTROS[index][7];
  kmsAvailable = SUPPORTED_DISTROS[index][8];

  userChoices.major = version;

  if (version == 1) {
    setOptions(0);
    document.getElementById('haManualBox').setAttribute('hidden', true);
    document.getElementById('haAutoBox').setAttribute('hidden', true);
    document.getElementById('nnFedBox').setAttribute('hidden', true);
    document.getElementById('lustreBox').setAttribute('hidden', true);
  } else {
    document.getElementById('haManualBox').setAttribute('hidden', false);
    document.getElementById('haAutoBox').setAttribute('hidden', false);
    document.getElementById('nnFedBox').setAttribute('hidden', false);
  }

  if (lustreSupported) {
    document.getElementById('lustreBox').setAttribute('hidden', false);
  } else {
    document.getElementById('lustreBox').setAttribute('hidden', true);
  }
  if (yarnHaSupported) {
    document.getElementById('yarnHaBox').setAttribute('hidden', false);
  } else {
    document.getElementById('yarnHaBox').setAttribute('hidden', true);
  }
  showKnownIncompatibilities();
  showSelectedTarballs();
}

function showSelectedTarballs() {
  if (displayInfoToUser === false) {
    displayInfoToUser = MultipleCheckersProgressStepDisplayer('earlyTarballVerificationSteps');
  }

  // determine exactly which tarballs have now been selected by the user
  var hadoop_tarball = document.getElementById('hadoopTarball').value;
  var zookeeper_tarball = document.getElementById('zooKeeperTarball').value;
  var hbase_tarball = document.getElementById('hbaseTarball').value;
  var tarballsAvailElem = document.getElementById('hadoopTarballAvail');
  if (tarballWizardExtender && tarballWizardExtender.isActive()) {
    if (!document.getElementById('specifyCustomTarball').checked) {
      var index = document.getElementById('hadoopTarballAvail').selectedIndex;
      if (index !== -1)
        hadoop_tarball = CM_LOCAL_PREFIX + tarballWizardExtender.getDropDownValue('hadoopTarball', index);
    }
    if (!document.getElementById('specifyCustomTarballZk').checked) {
      var index = document.getElementById('zooKeeperTarballAvail').selectedIndex;
      if (index !== -1)
        zookeeper_tarball = CM_LOCAL_PREFIX + tarballWizardExtender.getDropDownValue('zooKeeperTarball', index);
    }
    if (!document.getElementById('specifyCustomTarballHBase').checked) {
      var index = document.getElementById('hbaseTarballAvail').selectedIndex;
      if (index !== -1)
        hbase_tarball = CM_LOCAL_PREFIX + tarballWizardExtender.getDropDownValue('hbaseTarball', index);
    }
  }

  // keep an array of actual tarballs we can check later with the headnode if they exist at all
  var check_tarballs = [hadoop_tarball];
  if (document.getElementById('installZooKeeper').getAttribute('on') == 'true' && zookeeper_tarball !== false) {
    check_tarballs.push(zookeeper_tarball);
  }
  if (document.getElementById('installHBase').getAttribute('on') == 'true' && hbase_tarball !== false) {
    check_tarballs.push(hbase_tarball);
  }

  // add some uniqueness checking, i.e., keyup (control or left arrow) can trigger updates
  //   if we already checked the given set of tarballs there is no need to do it again
  var currentTarballsToCheck = check_tarballs.join(',');
  if (liveTarballCheckerLastChecked == currentTarballsToCheck) {
    return;
  }
  liveTarballCheckerLastChecked = currentTarballsToCheck;

  // show the user what has been selected
  displayInfoToUser.clearProgressLines('GetTarballs')
  displayInfoToUser.addProgressLine('GetTarballs', 'INFO', 'Selected tarball for Hadoop: ' + hadoop_tarball);

  if (document.getElementById('installZooKeeper').getAttribute('on') == 'true') {
    if (zookeeper_tarball === false)
      displayInfoToUser.addProgressLine('GetTarballs', 'INFO', 'ZooKeeper is included in the Hadoop tarball.');
    else {
      displayInfoToUser.addProgressLine('GetTarballs', 'INFO', 'Selected tarball for ZooKeeper: ' + zookeeper_tarball);
    }
  }
  if (document.getElementById('installHBase').getAttribute('on') == 'true') {
    if (hbase_tarball === false)
      displayInfoToUser.addProgressLine('GetTarballs', 'INFO', 'HBase is included in the Hadoop tarball.');
    else {
      displayInfoToUser.addProgressLine('GetTarballs', 'INFO', 'Selected tarball for HBase: ' + hbase_tarball);
    }
  }
  displayInfoToUser.display();

  // check with the headnode can be implemented here
  var updater = new GetReturnValuesFromPreConditionChecker(function (isCompleted, returnValues) {
    if (!isCompleted)
      return;
    var displayInfoToUser = MultipleCheckersProgressStepDisplayer('earlyTarballVerificationSteps');
    displayInfoToUser.clearProgressLines('GetTarballs');
    for (var i=0; i<returnValues.length; i++) {
      var tarball = returnValues[i][0];
      var isFound = returnValues[i][1];

      var status = isFound ? 'FINISHED' : 'FAILED';
      var text = tarball  + ' (' + (isFound ? 'found' : 'not found') + ' on server)';
      var project = '';

      if (i === 0) {
        project = 'Hadoop';
      } else if (i === 1) {
        project = 'ZooKeeper';
        if (zookeeper_tarball === false) {
          text = 'included in Hadoop tarball.';
        }
      } else if (i === 2) { // HBase
        project = 'HBase';
        if (zookeeper_tarball === false) {
          text = 'included in Hadoop tarball.';
        }
      }
      displayInfoToUser.addProgressLine('GetTarballs', status, 'Selected tarball for ' + project + ': ' + text);
    }
    displayInfoToUser.display('GetTarballs');
  });
  var tmp = new BigDataPreconditionCheckUtil(
    current, // used to determine (active) headnode
    dock,    // ,,
    updater, // used to update progress in UI
    {
      'check_tarballs' : [
         BigDataPreconditionCheckUtilTarget.HEADNODES_ONLY,
         check_tarballs,
        'tarballSelectPage'
      ],
      'auto_start': false
    }
  );
  updater.setChecker(tmp);
  // add some easing (if two changes occur within 1 second, the first one is cancelled and so on..)
  if (liveTarballCheckerTimer !== null) {
    clearTimeout(liveTarballCheckerTimer);
    liveTarballCheckerTimer = null;
  }
  liveTarballCheckerTimer = setTimeout(function () { tmp.run(); }, 1000);
}

function setOptions(num) {
  // determine values to be set for radio buttons, true is enable it, false is disable, null means no action.
  // null is used in case Yarn HA is clicked, as Yarn HA's behavior is separate from the other checkboxes.
  var setYarnHA            = num === 5 ? !(document.getElementById('yarnHa').getAttribute('on') === 'true') : null; // toggle
  var setSingleNameNode    = num === 0 ? true : (num === 5 ? null : false);
  var setHAManual          = num === 1 ? true : (num === 5 ? null : false);
  var setHAAuto            = num === 2 ? true : (num === 5 ? null : false);
  var setNNFed             = num === 3 ? true : (num === 5 ? null : false);
  var setLustre            = num === 4 ? true : (num === 5 ? null : false);

  // update the radios in case they are to be set to either true or false (null means no action)
  if (setSingleNameNode !== null) document.getElementById('singleNameNode').setAttribute('on', setSingleNameNode);
  if (setHAManual !== null) document.getElementById('haManual').setAttribute('on', setHAManual);
  if (setHAAuto !== null) document.getElementById('haAuto').setAttribute('on', setHAAuto);
  if (setNNFed !== null) document.getElementById('nnFed').setAttribute('on', setNNFed);
  if (setLustre !== null) document.getElementById('lustre').setAttribute('on', setLustre);
  if (setYarnHA !== null) document.getElementById('yarnHa').setAttribute('on', setYarnHA);

  // for HA Auto and Yarn HA read the current checkbox values, as they are important for determining if ZK should be enabled
  var isHAAuto = document.getElementById('haAuto').getAttribute('on') === 'true';
  var isYarnHA = document.getElementById('yarnHa').getAttribute('on') === 'true';

  // if ZooKeeper was ever enabled by the user, we will never disable it in case it's theoretically unneeded by install options
  var wasZookeeperOptionEverSetByTheUser    = document.getElementById('installZooKeeper').getAttribute('data-set-by-user') === 'true';
  var optionWasSetByUser                    = false;
  var isZookeeperNeeded                     = isYarnHA || isHAAuto;

  // update Zookeeper selection (again, only if the user didn't specify it manually)
  setInstallZooKeeper(isZookeeperNeeded || wasZookeeperOptionEverSetByTheUser, optionWasSetByUser);
  showKnownIncompatibilities();
}

function setInstallZooKeeper(flag, optionWasSetByUser = true) {
  flag = !!flag;
  document.getElementById('installZooKeeper').setAttribute('on', flag === true);
  document.getElementById('notInstallZooKeeper').setAttribute('on', flag === false);
  for (var elems=document.getElementsByClassName('zooKeeperTarballBox'), i=0; i<elems.length; i++) {
    elems[i].setAttribute('hidden', flag === false);
  }

  var wasZookeeperOptionEverSetByTheUser = document.getElementById('installZooKeeper').getAttribute('data-set-by-user') === 'true';
  document.getElementById('installZooKeeper').setAttribute('data-set-by-user', optionWasSetByUser || wasZookeeperOptionEverSetByTheUser);

  showKnownIncompatibilities();
  showSelectedTarballs();
}

function setInstallHBase(flag) {
  flag = !!flag;
  document.getElementById('installHBase').setAttribute('on', flag === true);
  document.getElementById('notInstallHBase').setAttribute('on', flag === false);
  for (var elems=document.getElementsByClassName('hbaseTarballBox'), i=0; i<elems.length; i++) {
    elems[i].setAttribute('hidden', flag === false);
  }
  if (flag) {
    // HBase requires ZooKeeper
    setInstallZooKeeper(true, false);
  } else {
    // If the user didn't tick ZooKeeper we can also disable it when unticking HBase
    var wasZookeeperOptionEverSetByTheUser = document.getElementById('installZooKeeper').getAttribute('data-set-by-user') === 'true';
    println("wasZookeeperOptionEverSetByTheUser = " + (wasZookeeperOptionEverSetByTheUser ? "true" : "false"));
    if (!wasZookeeperOptionEverSetByTheUser) {
      setInstallZooKeeper(false, false);
    }
  }

  showKnownIncompatibilities();
  showSelectedTarballs();
}

function showKnownIncompatibilities() {
  var text = '';
  var selectedIndex = document.getElementById('distro').selectedIndex;

  if (document.getElementById('installHBase').getAttribute('on') == 'true') {
    if (selectedIndex == APACHE_27X_INDEX) {
      text = APACHE_27X_HBASE_WARN;
    } else if (lustreSupported) {
      if (document.getElementById('lustre').getAttribute('on') == 'true') {
        text = 'HBase is not supported when using LustreFS backend';
      }
    }
  }
  document.getElementById('optionsMessage').value = text;
}

function checkDistro() {
  if (document.getElementById('distro').label.length == 0) {
    dock.displayError('Hadoop distribution should be selected');
    return false;
  }
  if (document.getElementById('hadoopTarball').value.length == 0 &&
      document.getElementById('hadoopTarballCorrected').value.length == 0
  ){
    dock.displayError('Hadoop tarball should be specified');
    return false;
  }
  if (document.getElementById('installZooKeeper').getAttribute('on') == 'true') {
    if (document.getElementById('zooKeeperTarball').value.length == 0 &&
        document.getElementById('zooKeeperTarballCorrected').value.length == 0
    ){
      dock.displayError('ZooKeeper tarball should be specified');
      return false;
    }
  }
  if (document.getElementById('installHBase').getAttribute('on') == 'true') {
    if (document.getElementById('hbaseTarball').value.length == 0 &&
        document.getElementById('hbaseTarballCorrected').value.length == 0
    ){
      dock.displayError('HBase tarball should be specified');
      return false;
    }
  }

  userChoices.distro = document.getElementById('distro').label;
  userChoices.distroIndex = document.getElementById('distro').selectedIndex;

  function setTarball(data) {
    var userChoicesSettingIndex = data[0];
    var tarballTextElementId = data[1];
    var tarballCorrectedTextElementId = data[2];
    var customTarballCheckboxElementId = data[3];
    if (document.getElementById(tarballCorrectedTextElementId).value.trim() !== '') {
      // consider the value from the drop down (which is stored in the (hidden) ".*Corrected" textbox
      if (document.getElementById(customTarballCheckboxElementId).checked) {
        // user overruled the drop down by specifying their own, so use hadoopTarball (default) textbox.
        userChoices[userChoicesSettingIndex] = document.getElementById(tarballTextElementId).value.trim();
      } else {
        // user didn't overrule the drop down, so use the corrected textbox.
        userChoices[userChoicesSettingIndex] = document.getElementById(tarballCorrectedTextElementId).value.trim();
      }
    } else {
      // the extended tarball wizard probably didn't work, so just fallback on the old behavior, use
      // the hadoopTarball textbox always..
      userChoices[userChoicesSettingIndex] = document.getElementById(tarballTextElementId).value.trim();
    }
  }

  setTarball(['hadoopTarball', 'hadoopTarball', 'hadoopTarballCorrected', 'specifyCustomTarball']);

  if (document.getElementById('installZooKeeper').getAttribute('on') == 'true') {
    userChoices.installZooKeeper = true;
    setTarball(['zooKeeperTarball', 'zooKeeperTarball', 'zooKeeperTarballCorrected', 'specifyCustomTarballZk']);
  } else {
    userChoices.installZooKeeper = false;
  }
  if (document.getElementById('installHBase').getAttribute('on') == 'true') {
    userChoices.installHBase = true;
    setTarball(['hbaseTarball', 'hbaseTarball', 'hbaseTarballCorrected', 'specifyCustomTarballHBase']);
  } else {
    userChoices.installHBase = false;
  }
  userChoices.singleNameNode = (document.getElementById('singleNameNode').getAttribute('on') == 'true');
  userChoices.haManual = (document.getElementById('haManual').getAttribute('on') == 'true');
  userChoices.haAuto = (document.getElementById('haAuto').getAttribute('on') == 'true');
  userChoices.installFederation = (document.getElementById('nnFed').getAttribute('on') == 'true');
  userChoices.lustre = (document.getElementById('lustre').getAttribute('on') == 'true');
  userChoices.yarnHaManual = (document.getElementById('yarnHa').getAttribute('on') == 'true');
  userChoices.yarnHaAuto = (document.getElementById('yarnHa').getAttribute('on') == 'true');

  if (userChoices.haAuto && !userChoices.installZooKeeper) {
    dock.displayError('ZooKeeper must be installed to enable NameNode HA with automatic failover');
    return false;
  }
  if (userChoices.yarnHaAuto && !userChoices.installZooKeeper) {
    dock.displayError('ZooKeeper must be installed to enable YARN HA with automatic failover');
    return false;
  }
  if (userChoices.installHBase && !userChoices.installZooKeeper) {
    dock.displayError('ZooKeeper must be installed to use HBase');
    return false;
  }

  var selectedIndex = document.getElementById('distro').selectedIndex;
  if (document.getElementById('installHBase').getAttribute('on') == 'true') {
    if (lustreSupported) {
      if (document.getElementById('lustre').getAttribute('on') == 'true') {
        dock.displayError('HBase is not supported when using LustreFS backend');
        return false;
      }
    }
  }

  return true;
}
// END deck DECK_DISTRO

// START deck DECK_JOURNALNODES
function journalnodesSelection() {
  currentDeck = DECK_JOURNALNODES;

  document.getElementById('dialogtitle').setAttribute('value', 'JournalNodes selection');
  var text = "Hadoop uses JournalNodes to guarantee High Availability for HDFS metadata.\nThere must be at least 3 JournalNodes. Selecting more than 3 hosts is possible, provided that the number of selected hosts is an odd number (e.g. 3, 5, 7).\n\nPlease select JournalNodes:";
  document.getElementById('journalnodesMessage').setAttribute('value', text);

  nodesIndex = 'Journal';
  if (userChoices.HAjournalNodeKeys && (userChoices.HAjournalNodeKeys.length > 0)) {
    currentnodes = userChoices.HAjournalNodeKeys;
  } else {
    currentnodes = new Array();
  }
  excludeFunction = excludeFunctionNodesUP;
  document.getElementById('groupnodeslabel').value = 'JournalNodes';
  deviceselect(excludeFunction);
}

function checkJournalnodes() {
  if (currentnodes.length < 3) {
    dock.displayError('At least 3 Journal Node hosts should be selected');
    return false;
  }
  if ((currentnodes.length % 2) == 0) {
    dock.displayError('An odd number of Journal Node hosts should be selected');
    return false;
  }
  var jnNodes = new Array();
  var jnNodeKeys = new Array();
  for (var i = 0; i < currentnodes.length; i++) {
    var node = current.find(currentnodes[i]);
    if (node) {
      jnNodes.push(node.get('hostname'));
      jnNodeKeys.push(node.get('uniqueKey'));
    }
  }
  userChoices.HAjournalNodes = dotFormat(jnNodes.sort());
  userChoices.HAjournalNodeKeys = jnNodeKeys;
  return true;
}
// END deck DECK_JOURNALNODES

// START deck DECK_MASTERNODES
function masternodesSelection() {
  currentDeck = DECK_MASTERNODES;

  var major = userChoices.major;
  var nodes = current.find('Node');

  document.getElementById('dialogtitle').setAttribute('value', 'Nodes selection');
  var masternodesMessage1 = 'Hadoop uses NameNode and Secondary NameNode hosts to store metadata about HDFS. NameNode and Secondary NameNode should be different hosts. Please select NameNode and Secondary NameNode hosts.';
  var masternodesMessage2 = '';
  var masternodesMessage3 = '';

  document.getElementById('singleNameNodeSelection').setAttribute('hidden', true);
  document.getElementById('haSelection').setAttribute('hidden', true);
  document.getElementById('fedSelection').setAttribute('hidden', true);
  document.getElementById('lustreMountSelection').setAttribute('hidden', true);
  document.getElementById('jobTrackerSelection').setAttribute('hidden', true);
  document.getElementById('yarnServerSelection').setAttribute('hidden', true);
  document.getElementById('yarnHaSelection').setAttribute('hidden', true);

  if (major == 1) {
    masternodesMessage2 = 'Hadoop uses JobTracker host to manage compute resources for users\' applications.';
    document.getElementById('singleNameNodeSelection').setAttribute('hidden', false);
    fillHostDropdown('nameNode', nodes);
    fillHostDropdown('secondaryNameNode', nodes);
    document.getElementById('jobTrackerSelection').setAttribute('hidden', false);
    fillHostDropdown('jobTracker', nodes);
  } else {
    if (userChoices.singleNameNode) {
      document.getElementById('singleNameNodeSelection').setAttribute('hidden', false);
      fillHostDropdown('nameNode', nodes);
      fillHostDropdown('secondaryNameNode', nodes);
    } else if (userChoices.haManual || userChoices.haAuto) {
      masternodesMessage1 = 'Hadoop HA for NameNodes relies on two NameNodes:\n- NameNode 1 (started in \'Active\' status)\n- NameNode 2 (started in \'Standby\' status)\nNameNodes should be different hosts.';
      document.getElementById('haSelection').setAttribute('hidden', false);
      fillHostDropdown('nameNode1', nodes);
      fillHostDropdown('nameNode2', nodes);
    } else if (userChoices.installFederation) {
      masternodesMessage1 = 'Hadoop HDFS Federation uses multiple independent NameNodes/namespaces in order to scale the name service horizontally. Client applications will use \'viewfs\' file system to manage multiple namespaces.';
      masternodesMessage1 += '\n\nPlease select 4 independent pairs of NameNodes/Secondary NameNodes. Each pair will manage a different namespace, identified by specific IDs and \'mount points\' inside the federated HDFS.';
      document.getElementById('fedSelection').setAttribute('hidden', false);
      fillHostDropdown('fedNameNode1', nodes);
      fillHostDropdown('fedSecondaryNameNode1', nodes);
      fillHostDropdown('fedNameNode2', nodes);
      fillHostDropdown('fedSecondaryNameNode2', nodes);
      fillHostDropdown('fedNameNode3', nodes);
      fillHostDropdown('fedSecondaryNameNode3', nodes);
      fillHostDropdown('fedNameNode4', nodes);
      fillHostDropdown('fedSecondaryNameNode4', nodes);
    } else if (userChoices.lustre) {
      masternodesMessage1 = "Hadoop uses LustreFS to store its data. Please set the path to use as root dir for Hadoop:\n\nExample: if the Lustre mount is '/mnt/lustre', the suggested path is '/mnt/lustre/hadoop'.";
      document.getElementById('lustreMountSelection').setAttribute('hidden', false);
    }

    if (userChoices.yarnHaManual || userChoices.yarnHaAuto) {
      masternodesMessage2 = 'Hadoop HA for YARN relies on two ResourceManagers:\n- ResourceManager 1 (started in \'Active\' status)\n- ResourceManager 2 (started in \'Standby\' status)\nResourceManagers should be different hosts.';
      document.getElementById('yarnHaSelection').setAttribute('hidden', false);
      fillHostDropdown('yarnServer1', nodes);
      fillHostDropdown('yarnServer2', nodes);
    } else {
      masternodesMessage2 = 'Hadoop uses the YARN server to manage compute resources for users\' applications.';
      document.getElementById('yarnServerSelection').setAttribute('hidden', false);
      fillHostDropdown('yarnServer', nodes);
    }
  }

  if (kmsAvailable) {
    masternodesMessage3 = 'The selected Hadoop version supports the Key Management Server, that can be used for transparent encryption. Please select (optionally) a KMS host.';
    document.getElementById('kmsServerSelection').setAttribute('hidden', false);
    fillHostDropdown('kmserver', nodes, true);
  } else {
    masternodesMessage3 = '';
    document.getElementById('kmsServerSelection').setAttribute('hidden', true);
  }

  document.getElementById('masternodesMessage1').value = masternodesMessage1;
  document.getElementById('masternodesMessage2').value = masternodesMessage2;
  document.getElementById('masternodesMessage3').value = masternodesMessage3;

  if (DEBUG) {
    document.getElementById('nameNode').selectedIndex = 1;
    document.getElementById('secondaryNameNode').selectedIndex = 2;
    document.getElementById('nameNode1').selectedIndex = 1;
    document.getElementById('nameNode2').selectedIndex = 2;
    document.getElementById('yarnServer').selectedIndex = 3;
  }
}

function checkMasternodes() {
  var major = userChoices.major;
  var nodes = current.find('Node');

  if (userChoices.singleNameNode) {
    if (document.getElementById('nameNode').label.length == 0) {
      dock.displayError('NameNode host should be selected');
      return false;
    }
    if (document.getElementById('secondaryNameNode').label.length == 0) {
      dock.displayError('Secondary NameNode host should be selected');
      return false;
    }
    userChoices.nameNodeHost = document.getElementById('nameNode').label;
    userChoices.secondaryNameNodeHost = document.getElementById('secondaryNameNode').label;
  } else if (userChoices.haManual || userChoices.haAuto) {
    if (document.getElementById('nameNode1').label.length == 0) {
      dock.displayError('NameNode 1 host should be selected');
      return false;
    }
    if (document.getElementById('nameNode2').label.length == 0) {
      dock.displayError('NameNode 2 host should be selected');
      return false;
    }
    if (document.getElementById('nameNode1').label == document.getElementById('nameNode2').label) {
      dock.displayError('NameNodes should be different hosts');
      return false;
    }
    userChoices.HAnameNode1 = document.getElementById('nameNode1').label;
    userChoices.HAnameNode2 = document.getElementById('nameNode2').label;
  } else if (userChoices.installFederation) {
    if (document.getElementById('fedNameNode1').label.length == 0) {
      dock.displayError('NameNode 1 host should be selected');
      return false;
    }
    if (document.getElementById('fedSecondaryNameNode1').label.length == 0) {
      dock.displayError('Secondary NameNode 1 host should be selected');
      return false;
    }
    if (document.getElementById('fedNameNode2').label.length == 0) {
      dock.displayError('NameNode 2 host should be selected');
      return false;
    }
    if (document.getElementById('fedSecondaryNameNode2').label.length == 0) {
      dock.displayError('Secondary NameNode 2 host should be selected');
      return false;
    }
    if (document.getElementById('fedNameNode3').label.length == 0) {
      dock.displayError('NameNode 3 host should be selected');
      return false;
    }
    if (document.getElementById('fedSecondaryNameNode3').label.length == 0) {
      dock.displayError('Secondary NameNode 3 host should be selected');
      return false;
    }
    if (document.getElementById('fedNameNode4').label.length == 0) {
      dock.displayError('NameNode 4 host should be selected');
      return false;
    }
    if (document.getElementById('fedSecondaryNameNode4').label.length == 0) {
      dock.displayError('Secondary NameNode 4 host should be selected');
      return false;
    }
    userChoices.federationNameNodeHosts = [document.getElementById('fedNameNode1').label, document.getElementById('fedNameNode2').label, document.getElementById('fedNameNode3').label, document.getElementById('fedNameNode4').label];
    userChoices.federationSecondaryNameNodeHosts = [document.getElementById('fedSecondaryNameNode1').label, document.getElementById('fedSecondaryNameNode2').label, document.getElementById('fedSecondaryNameNode3').label, document.getElementById('fedSecondaryNameNode4').label];
    if(sort_unique(userChoices.federationNameNodeHosts.slice()).length < 4) {
      dock.displayError('NameNodes should be different hosts');
      return false;
    }
    if(sort_unique(userChoices.federationSecondaryNameNodeHosts.slice()).length < 4) {
      dock.displayError('Secondary NameNodes should be different hosts');
      return false;
    }
  } else if (userChoices.lustre) {
    if (document.getElementById('lustreMount').value.length == 0) {
      dock.displayError('Lustre mount shoud be specified');
      return false;
    }
    userChoices.lustreMount = document.getElementById('lustreMount').value.trim();
  }

  if (major == 1) {
    if (document.getElementById('jobTracker').label.length == 0) {
      dock.displayError('JobTracker host should be selected');
      return false;
    }
    userChoices.jobTrackerHost = document.getElementById('jobTracker').label;
  } else if (userChoices.yarnHaAuto) {
    if (document.getElementById('yarnServer1').label.length == 0) {
      dock.displayError('YARN server 1 host should be selected');
      return false;
    }
    if (document.getElementById('yarnServer2').label.length == 0) {
      dock.displayError('YARN server 2 host should be selected');
      return false;
    }
    if (document.getElementById('yarnServer1').label == document.getElementById('yarnServer2').label) {
      dock.displayError('ResourceManagers should be different hosts');
      return false;
    }
    userChoices.yarnServerHost1 = document.getElementById('yarnServer1').label;
    userChoices.yarnServerHost2 = document.getElementById('yarnServer2').label;
  } else {
    if (document.getElementById('yarnServer').label.length == 0) {
      dock.displayError('YARN server host should be selected');
      return false;
    }
    userChoices.yarnServerHost = document.getElementById('yarnServer').label;
  }
  if (kmsAvailable) {
    userChoices.kmsHost = document.getElementById('kmserver').label;
  } else {
    userChoices.kmsHost = '';
  }
  return true;
}
// END deck DECK_MASTERNODES

// START deck DATANODES
function datanodesSelection() {
  currentDeck = DECK_DATANODES;

  document.getElementById('dialogtitle').setAttribute('value', 'DataNodes selection');
  var text = "Hadoop DataNodes store data and act as worker-nodes to run Hadoop jobs.\nIt's best to use at least 3 DataNodes (this is enforced in this setup). Only nodes in status UP are shown.\n\nPlease select DataNodes:";
  document.getElementById('datanodesMessage').setAttribute('value', text);

  nodesIndex = 'Datanodes';
  currentnodes = new Array();
  if (userChoices.dataNodeKeys && (userChoices.dataNodeKeys.length > 0)) {
    currentnodes = userChoices.dataNodeKeys;
  } else {
    currentnodes = new Array();
  }
  excludeFunction = excludeFunctionNodesUP;
  document.getElementById('groupnodeslabel').value = 'DataNodes';
  deviceselect(excludeFunction);
}

function checkDatanodes() {
  var allDataNodes = new Array();
  for (var i = 0; i < currentnodes.length; i++) {
    if (allDataNodes.indexOf(currentnodes[i]) == -1) {
      allDataNodes.push(currentnodes[i]);
    }
  }
  if (allDataNodes.length < 3) {
    dock.displayError('At least 3 DataNodes should be selected');
    return false;
  }
  var dataNodes = new Array();
  var dataNodeKeys = new Array();
  for (var i = 0; i < currentnodes.length; i++) {
    var node = current.find(currentnodes[i]);
    if (node) {
      dataNodes.push(node.get('hostname'));
      dataNodeKeys.push(node.get('uniqueKey'));
    }
  }
  userChoices.dataNodes = dotFormat(dataNodes.sort());
  userChoices.dataNodeKeys = dataNodeKeys;
  return true;
}
// END deck DATANODES

// START deck ZOOKEEPER
function zookeeperNodes() {
  currentDeck = DECK_ZOOKEEPER;

  document.getElementById('dialogtitle').setAttribute('value', 'ZooKeeper hosts selection');
  var text = "ZooKeeper works as an ensemble of ZooKeeper hosts. There must be at least 3 hosts. Selecting more than 3 nodes is possible, provided that the number of selected hosts is an odd number (e.g. 3, 5, 7).\n\nPlease select ZooKeeper hosts:";
  document.getElementById('zookeeperMessage').setAttribute('value', text);
  nodesIndex = 'Zookeeper';
  currentnodes = new Array();
  if (userChoices.zookeeperHostKeys && (userChoices.zookeeperHostKeys.length > 0)) {
    currentnodes = userChoices.zookeeperHostKeys;
  } else {
    currentnodes = new Array();
  }
  excludeFunction = excludeFunctionNodesUP;
  deviceselect(excludeFunction);
  document.getElementById('groupnodeslabel').value = 'ZooKeeper nodes';
}

function checkZookeeperNodes() {
  if (currentnodes.length < 3) {
    dock.displayError('At least 3 ZooKeeper hosts should be selected');
    return false;
  }
  if ((currentnodes.length % 2) == 0) {
    dock.displayError('An odd number of ZooKeeper hosts should be selected');
    return false;
  }
  var zooNodes = new Array();
  var zooNodeKeys = new Array();
  for (var i = 0; i < currentnodes.length; i++) {
    var node = current.find(currentnodes[i]);
    if (node) {
      zooNodes.push(node.get('hostname'));
      zooNodeKeys.push(node.get('uniqueKey'));
    }
  }
  userChoices.zookeeperHosts = dotFormat(zooNodes.sort());
  userChoices.zookeeperHostKeys = zooNodeKeys;
  return true;
}
// END deck ZOOKEEPER

// START deck HBASE
function hbaseNodes() {
  document.getElementById('dialogtitle').setAttribute('value', 'HBase hosts selection');
  var text = "HBase works with a Master and one or more RegionServers. HBase tables are split into 'regions', distributed across RegionServers. There must be at least 1 RegionServer.'"
  if (userChoices.hbaseTarball.indexOf('hbase-1.') != -1) {
    text += '\n\n' + HBASE_100_WARN;
  }
  text += '\n\nPlease select Master and RegionServer host(s):';
  document.getElementById('hbaseMessage').setAttribute('value', text);
  var nodes = current.find('Node');
  fillHostDropdown('hbaseMaster', nodes);
  nodesIndex = 'Hbase';
  if (userChoices.hbaseRegionServerKeys && (userChoices.hbaseRegionServerKeys.length > 0)) {
    currentnodes = userChoices.hbaseRegionServerKeys;
  } else {
    currentnodes = new Array();
  }
  excludeFunction = excludeFunctionNodesUP;
  deviceselect(excludeFunction);
  document.getElementById('groupnodeslabel').value = 'HBase regionservers';
}

function checkHbaseNodes() {
  if (document.getElementById('hbaseMaster').label.length == 0) {
    dock.displayError('HBase master host should be selected');
    return false;
  }
  if (currentnodes.length == 0) {
    dock.displayError('At least 1 HBase regionserver should be selected');
    return false;
  }
  userChoices.hbaseMaster = document.getElementById('hbaseMaster').label;
  var hbaseNodes = new Array();
  var hbaseNodeKeys = new Array();
  for (var i = 0; i < currentnodes.length; i++) {
    var node = current.find(currentnodes[i]);
    if (node) {
      hbaseNodes.push(node.get('hostname'));
      hbaseNodeKeys.push(node.get('uniqueKey'));
    }
  }
  if (userChoices.hbaseTarball.indexOf('hbase-1.') != -1) {
    if (hbaseNodes.indexOf(userChoices.hbaseMaster) != -1) {
      dock.displayError(HBASE_100_WARN);
      return false;
    }
  }
  userChoices.hbaseRegionServers = dotFormat(hbaseNodes.sort());
  userChoices.hbaseRegionServerKeys = hbaseNodeKeys;
  return true;
}
// END deck HBASE

// START deck SUMMARY
function summary() {
  var nodeKeysUsedByNewHadoopInstance   = [],
      readNodeKeysFromUserChoicesBucket = [],
      readNodeKeysFromDropDownBoxes     = [],
      tarballsToCheckOnHeadNodes        = [],
      masterNodes;

  document.getElementById('dialogtitle').setAttribute('value', 'Summary of choices');
  var text = "The selected choices are shown below. They will be used to create an XML configuration file.\n";
  document.getElementById('summaryChoicesMessage').setAttribute('value', text);

  printall(userChoices);

  var box = document.getElementById('summaryChoices');
  while (box.firstChild) box.removeChild(box.firstChild);
  appendChoice(box, 'Instance name: ', userChoices.instanceName);
  appendChoice(box, 'Java home: ', userChoices.javaHome);
  appendChoice(box, 'Data root: ', userChoices.genericDataRoot);
  if (userChoices.namenodeDataDirs) {
    appendChoice(box, 'NameNode data root: ', userChoices.namenodeDataDirs);
  }
  if (userChoices.datanodeDataDirs) {
    appendChoice(box, 'DataNode data root: ', userChoices.datanodeDataDirs);
  }
  appendChoice(box, 'Hadoop distribution/version: ', userChoices.distro);
  appendChoice(box, 'Hadoop tarball: ', userChoices.hadoopTarball);
  tarballsToCheckOnHeadNodes.push(userChoices.hadoopTarball);
  if (userChoices.installZooKeeper) {
    appendChoice(box, 'ZooKeeper tarball: ', userChoices.zooKeeperTarball);
    tarballsToCheckOnHeadNodes.push(userChoices.zooKeeperTarball);
  }
  if (userChoices.installHBase) {
    appendChoice(box, 'HBase tarball: ', userChoices.hbaseTarball);
    tarballsToCheckOnHeadNodes.push(userChoices.hbaseTarball);
  }
  if (userChoices.singleNameNode) {
    appendChoice(box, 'NameNode host: ', userChoices.nameNodeHost);
    appendChoice(box, 'Secondary NameNode host: ', userChoices.secondaryNameNodeHost);
    readNodeKeysFromDropDownBoxes.push('nameNode');
    readNodeKeysFromDropDownBoxes.push('secondaryNameNode');
  } else if (userChoices.haManual || userChoices.haAuto) {
    appendChoice(box, 'JournalNode hosts: ', userChoices.HAjournalNodes);
    appendChoice(box, 'NameNode 1 host: ', userChoices.HAnameNode1);
    appendChoice(box, 'NameNode 2 host: ', userChoices.HAnameNode2);
    readNodeKeysFromDropDownBoxes.push('nameNode1');
    readNodeKeysFromDropDownBoxes.push('nameNode2');
    readNodeKeysFromUserChoicesBucket.push('HAjournalNodeKeys');
  } else if (userChoices.installFederation) {
    appendChoice(box, 'Federation nn1 (/user): ', userChoices.federationNameNodeHosts[0]);
    appendChoice(box, 'Federation nn2 (/tmp): ', userChoices.federationNameNodeHosts[1]);
    appendChoice(box, 'Federation nn3 (/staging): ', userChoices.federationNameNodeHosts[2]);
    appendChoice(box, 'Federation nn4 (/hbase): ', userChoices.federationNameNodeHosts[3]);
    appendChoice(box, 'Federation snn1 (/user): ', userChoices.federationSecondaryNameNodeHosts[0]);
    appendChoice(box, 'Federation snn2 (/tmp): ', userChoices.federationSecondaryNameNodeHosts[1]);
    appendChoice(box, 'Federation snn3 (/staging): ', userChoices.federationSecondaryNameNodeHosts[2]);
    appendChoice(box, 'Federation snn4 (/hbase): ', userChoices.federationSecondaryNameNodeHosts[3]);
    readNodeKeysFromDropDownBoxes.push('fedNameNode1');
    readNodeKeysFromDropDownBoxes.push('fedNameNode2');
    readNodeKeysFromDropDownBoxes.push('fedNameNode3');
    readNodeKeysFromDropDownBoxes.push('fedNameNode4');
    readNodeKeysFromDropDownBoxes.push('fedSecondaryNameNode1');
    readNodeKeysFromDropDownBoxes.push('fedSecondaryNameNode2');
    readNodeKeysFromDropDownBoxes.push('fedSecondaryNameNode3');
    readNodeKeysFromDropDownBoxes.push('fedSecondaryNameNode4');
  } else if (userChoices.lustre) {
    appendChoice(box, 'Lustre FS mount: ', userChoices.lustreMount);
  }
  if (userChoices.major == 1) {
    appendChoice(box, 'JobTracker host: ', userChoices.jobTrackerHost);
    readNodeKeysFromDropDownBoxes.push('jobTracker');
  } else if (userChoices.yarnHaManual || userChoices.yarnHaAuto) {
    appendChoice(box, 'YARN server 1 host: ', userChoices.yarnServerHost1);
    appendChoice(box, 'YARN server 2 host: ', userChoices.yarnServerHost2);
    readNodeKeysFromDropDownBoxes.push('yarnServer1');
    readNodeKeysFromDropDownBoxes.push('yarnServer2');
  } else {
    appendChoice(box, 'YARN server host: ', userChoices.yarnServerHost);
    readNodeKeysFromDropDownBoxes.push('yarnServer');
  }
  appendChoice(box, 'DataNode hosts: ', userChoices.dataNodes);
  readNodeKeysFromUserChoicesBucket.push('dataNodeKeys');
  if (kmsAvailable && (userChoices.kmsHost != '')) {
    appendChoice(box, 'KMS host: ', userChoices.kmsHost);
    readNodeKeysFromDropDownBoxes.push('kmserver');
  }
  if (userChoices.installZooKeeper) {
    appendChoice(box, 'ZooKeeper hosts: ', userChoices.zookeeperHosts);
    readNodeKeysFromUserChoicesBucket.push('zookeeperHostKeys');
  }
  if (userChoices.installHBase) {
    appendChoice(box, 'HBase Master: ', userChoices.hbaseMaster);
    appendChoice(box, 'HBase RegionServer(s): ', userChoices.hbaseRegionServers);
    readNodeKeysFromDropDownBoxes.push('hbaseMaster');
    readNodeKeysFromUserChoicesBucket.push('hbaseRegionServerKeys');
  }

  text = "\n\nBy pressing 'Next' a temporary XML file will be created with the selected configuration and a Hadoop instance will be installed using this XML file.\n\nAlternatively, clicking the 'Save Configuration' button will produce an XML configuration file which can be further customized, if needed, and then used as the input configuration file for the cm-hadoop-setup command line utility.\nPress 'Show Configuration' to get the Hadoop deployment configuration as XML.";
  document.getElementById('summaryMessage').setAttribute('value', text);

  // Stop any previous run
  if (hadoopPreconditionsChecker) {
    hadoopPreconditionsChecker.stopAll();
  }
  // Get a helper for displaying verificationSteps (it wraps around one DOM element)
  hadoopPreconditionsChecker = new BigDataPreconditionCheckUtil(
    current, // used to determine (active) headnode
    dock,    // ,,
    MultipleCheckersProgressStepDisplayer('verificationSteps'), // used to update progress in UI
    {
      'check_tarballs' : [ BigDataPreconditionCheckUtilTarget.HEADNODES_ONLY,
                           tarballsToCheckOnHeadNodes,
                           'summaryPage'
                         ],
      'check_javahome' : [ BigDataPreconditionCheckUtilTarget.INVOLVED_NODES,
                           userChoices.javaHome
                         ],
      // Headnode(s) can be and are determined inside BigDataPreconditionCheckUtil constructor. Involved nodes need to be given.
      'involved_nodes' : getNodeKeysUsedByNewHadoopInstance(readNodeKeysFromUserChoicesBucket, readNodeKeysFromDropDownBoxes),

      'auto_start'     : true // invokes this.run() after constructing
    }
  );
}

function appendChoice(box, fieldName, fieldValue) {
  var hbox = document.createElement('hbox');
  box.appendChild(hbox);
  var field = document.createElement('shadowlabel');
  field.setAttribute('class', 'staticdataheader');
  field.setAttribute('value', fieldName);
  hbox.appendChild(field);
  var label = document.createElement('label');
  label.setAttribute('value', fieldValue);
  hbox.appendChild(label);
}

function showConfiguration() {
  var xmlConfig = "";
  var beautifiedXml = "";
  try {
    xmlConfig = createXMLconfigFile();
    beautifiedXml = vkbeautify.xml(xmlConfig);
  } catch (err) {
    println('exception ' + err + ' while generation xml file');
    dock.displayError('Error while generating XML file');
    return false;
  }

  var args = new Object();
  args['title'] = 'Hadoop configuration';
  args['style'] = 'background-color: white !important;';
  args['text'] = beautifiedXml;
  var d = new cvDialog(dock.myVersion + "showtext.xul", args);
  dock.dialogs.showDialog(d);
}

function saveConfiguration() {
  saveSetup(true);
}

function saveSetup(saveas) {
  var xmlConfig = "";
  var beautifiedXml = "";
  try {
    xmlConfig = createXMLconfigFile();
    beautifiedXml = vkbeautify.xml(xmlConfig);
  } catch (err) {
    println('exception ' + err + ' while generation xml file');
    dock.displayError('Error while generating XML file');
    return false;
  }

  var file = saveFile;
  if (saveas || (saveFile.length == 0)) {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    if (saveas) {
      fp.init(window, "Save Hadoop setup as", nsIFilePicker.modeSave);
    } else {
      fp.init(window, "Save Hadoop setup", nsIFilePicker.modeSave);
    }
    var path = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    path.initWithPath(dock.BASE_PATH);
    fp.displayDirectory = path;
    fp.appendFilter("Hadoop setups", "*.xml");
    var res = fp.show();
    if ((res == nsIFilePicker.returnOK) || (res == nsIFilePicker.returnReplace)) {
      file = fp.file.path;
      if (!endswith(file, '.xml')) file += '.xml';
    } else {
      return;
    }
  }
  println(file);
  savefile(file, beautifiedXml);
  saveFile = file;
}
/**
 * Given information on which UI elements to read for node unique keys (collected in summary())
 *  read all these uniqueKey values and return them (unique)
 */
function getNodeKeysUsedByNewHadoopInstance(readNodeKeysFromUserChoicesBucket, readNodeKeysFromDropDownBoxes)
{
  var nodeKeysUsedByNewHadoopInstance = [], i, dropdownElement, key;

  // Merge all userChoices.xyzKeys Arrays into nodeKeysUsedByNewHadoopInstance.
  for (i=0; i<readNodeKeysFromUserChoicesBucket.length; i++) {
    if (!userChoices[readNodeKeysFromUserChoicesBucket[i]])
      continue;

    // concat but filter out elements already in the array first
    nodeKeysUsedByNewHadoopInstance = nodeKeysUsedByNewHadoopInstance.concat(
      userChoices[readNodeKeysFromUserChoicesBucket[i]].filter(
        function (item) {
          return nodeKeysUsedByNewHadoopInstance.indexOf(item) < 0;
        }
      )
    );
  }

  // Merge all selected dropdown values into nodeKeysUsedByNewHadoopInstance.
  for (i=0; i<readNodeKeysFromDropDownBoxes.length; i++) {
    dropdownElement = document.getElementById(readNodeKeysFromDropDownBoxes[i]);
    if (!(dropdownElement && dropdownElement.selectedItem)) continue;

    key = parseInt(dropdownElement.selectedItem.getAttribute('uniqueKey'));
    if (key && nodeKeysUsedByNewHadoopInstance.indexOf(key) < 0)
      nodeKeysUsedByNewHadoopInstance.push(key);
  }

  return nodeKeysUsedByNewHadoopInstance;
}

// END deck SUMMARY

// START deck DEPLOY
function deploy() {
  var xmlConfig = "";
  try {
    xmlConfig = createXMLconfigFile(true);
  } catch (err) {
    println('exception ' + err + ' while generation xml file');
    dock.displayError('Error while generating XML file');
    return false;
  }

  document.getElementById('dialogtitle').setAttribute('value', 'Installation progress');
  var text = "\nHadoop configuration for instance '" + userChoices.instanceName + "' has been written. A Hadoop instance is being installed. Installation progress is shown below.";
  document.getElementById('deployMessage').setAttribute('value', text);

  if (xmlConfig != "") {
    var id = 0;
    overviewBar('progressBar', 0, 100);
    stepsList = new Array();
    dock.workerpool.getWorker(current.actualurl).call('cmhadoop', 'executeHadoopSetup', [0, xmlConfig], function(code, data) {
      if(code == 0) {
        id = data.setupExecutionID;
        timer = window.setTimeout('checkStatus(' + id +');', 1000);
      } else {
        document.getElementById('canc').setAttribute('disabled', false);
        document.getElementById('prev').setAttribute('disabled', false);
        dock.jsonCallError(this, code, data);
      }
    }, current);
  } else {
    println('not running');
  }
}

function checkStatus(id) {
  timer = 0;
  count++;
  if (count > 2000) {
    return;
  }

  dock.workerpool.getWorker(current.actualurl).call('cmhadoop', 'getHadoopSetupExecution', [id], function(code, data) {
    if(code == 0) {
      if (!data) {
        dock.displayError('A Hadoop instance is already being installed.');
        return;
      }
      var currentProgress = "";
      var stepsCounter = 0;
      for (var i = 0; i < data.datacout.length; i++) {
        var matched = false;

        if (data.datacout[i].match(PATTERN_FIRST_LINE)) {
          document.getElementById('deployProgress').removeAttribute('hidden');
          matched = true;
        }
        var m;
        do {
          m = PATTERN_GENERIC.exec(data.datacout[i]);
          if (m) {
            matched = true;
            //println('matching m = ' + m);
            stepsList[stepsCounter++] = m;
          }
        } while (m);
        var m2 = PATTERN_PERC.exec(data.datacout[i]);
        if (m2) {
          matched = true;
          //println('matching m2 = ' + m2);
          progressPerc = m2[1];
        }

        if (!matched) {
          currentProgress += data.datacout[i];
          currentProgress += "\n";
        }
      }
      var deployStepsDisplay = new ProgressStepDisplayer('deploySteps');

      deployStepsDisplay.clearAll();

      // merge stepsList (this collapses the no longer relevant messages:
      //  {A started, A finished, B started, B finished, C started} -> {A finished, B finished, C started})
      var mergedStepsList = new Array();
      for (var i = 0; i < stepsList.length; i++) {
        var item = stepsList[i];
        if (stepsList[i-1]) {
          var previousItem = stepsList[i-1];
          if (item[1] == previousItem[1]) {
            mergedStepsList[mergedStepsList.length-1] = item;
          } else {
            mergedStepsList.push(item);
          }
        } else {
          mergedStepsList.push(item);
        }
      }

      for (var i = 0; i < mergedStepsList.length; i++) {
        deployStepsDisplay.add(mergedStepsList[i][2], mergedStepsList[i][1]);
      }

      overviewBar('progressBar', progressPerc, 100);

      var deployOutput = document.getElementById('deployOutput');
      deployOutput.value = currentProgress;
      var ti = document.getAnonymousNodes(deployOutput)[0].childNodes[0];
      ti.scrollTop = ti.scrollHeight;

      if (data.finishedAt == 0) {
        document.getElementById('canc').setAttribute('disabled', true);
        document.getElementById('prev').setAttribute('disabled', true);
        timer = window.setTimeout('checkStatus(' + id +');', 3000);
      } else if (data.successful) {
        overviewBar('progressBar', 100, 100);
        document.getElementById('finish').setAttribute('disabled', false);
      } else { // failed
        document.getElementById('canc').setAttribute('disabled', false);
        document.getElementById('prev').setAttribute('disabled', false);
      }
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, current);
}
// END deck DEPLOY

// START xml stuff
function createXMLconfigFile(includeAll) {
  includeAll = isundefined(includeAll, false);

  var xmlConfig = undefined;

  var doc = document.implementation.createDocument("", "hadoopConfig", null);

  // archive
  addTextNode(doc, doc.documentElement, "archive", userChoices.hadoopTarball);

  // javahome
  addTextNode(doc, doc.documentElement, "javahome", userChoices.javaHome);

  // instance
  var instanceElem = doc.createElement("instance");
  doc.documentElement.appendChild(instanceElem);

  // name
  addTextNode(doc, instanceElem, "name", userChoices.instanceName);

  // dataroot
  addTextNode(doc, instanceElem, "dataroot", userChoices.genericDataRoot);
  if (userChoices.namenodeDataDirs) {
    addTextNode(doc, instanceElem, "namenodedatadirs", userChoices.namenodeDataDirs);
  }
  if (userChoices.datanodeDataDirs) {
    addTextNode(doc, instanceElem, "datanodedatadirs", userChoices.datanodeDataDirs);
  }

  // security
  var securityElem = doc.createElement("security");
  instanceElem.appendChild(securityElem);
  addTextNode(doc, securityElem, "kmshost", userChoices.kmsHost);
  addTextNode(doc, securityElem, "usessl", userChoices.useSsl);
  addTextNode(doc, securityElem, "sslonly", userChoices.sslOnly);

  if (userChoices.lustre) {
    var afsElem = doc.createElement("afs");
    instanceElem.appendChild(afsElem);
    addTextNode(doc, afsElem, "fstype", "lustre");
    addTextNode(doc, afsElem, "fsroot", userChoices.lustreMount);
  } else if (userChoices.installFederation) {
    var federationElem = doc.createElement("federation");
    instanceElem.appendChild(federationElem);
    federationElem.setAttribute("enabled", userChoices.installFederation.toString());
    addTextNode(doc, federationElem, "clusterid", userChoices.federationClusterID);
    for (var i = 0; i < userChoices.federationNameNodeIDs.length; i++) {
      var elem = doc.createElement("namenode");
      federationElem.appendChild(elem);
      addTextNode(doc, elem, "id", userChoices.federationNameNodeIDs[i]);
      addTextNode(doc, elem, "mountpoint", userChoices.federationNameNodeMountPoints[i]);
      addTextNode(doc, elem, "host", userChoices.federationNameNodeHosts[i]);
      addTextNode(doc, elem, "port", userChoices.federationNameNodePorts[i]);
      addTextNode(doc, elem, "httpport", userChoices.federationNameNodeHttpPorts[i]);
      addTextNode(doc, elem, "httpsport", userChoices.federationNameNodeHttpsPorts[i]);
    }
    for (var i = 0; i < userChoices.federationNameNodeIDs.length; i++) {
      var elem = doc.createElement("secondarynamenode");
      federationElem.appendChild(elem);
      addTextNode(doc, elem, "id", userChoices.federationNameNodeIDs[i]);
      addTextNode(doc, elem, "host", userChoices.federationSecondaryNameNodeHosts[i]);
      addTextNode(doc, elem, "httpport", userChoices.federationSecondaryNameNodeHttpPorts[i]);
      addTextNode(doc, elem, "httpsport", userChoices.federationSecondaryNameNodeHttpsPorts[i]);
    }
  } else if (userChoices.haManual || userChoices.haAuto) {
    var elem = doc.createElement("ha");
    instanceElem.appendChild(elem);
    elem.setAttribute("enabled", userChoices.haManual.toString());
    elem.setAttribute("auto", userChoices.haAuto.toString());
    if (userChoices.haAuto) {
      elem.setAttribute("enabled", "true");
    }
    addTextNode(doc, elem, "nameserviceid", userChoices.HAnameServiceID);
    addTextNode(doc, elem, "namenodeid1", userChoices.HAnameNodeID1);
    addTextNode(doc, elem, "namenodeid2", userChoices.HAnameNodeID2);
    addTextNode(doc, elem, "namenode1", userChoices.HAnameNode1);
    addTextNode(doc, elem, "namenode2", userChoices.HAnameNode2);
    addTextNode(doc, elem, "namenodeport", userChoices.HAnameNodePort);
    addTextNode(doc, elem, "namenodehttpport", userChoices.HAnameNodeHttpPort);
    addTextNode(doc, elem, "namenodehttpsport", userChoices.HAnameNodeHttpsPort);
    addTextNode(doc, elem, "journalnodes", userChoices.HAjournalNodes);
    addTextNode(doc, elem, "journalport", userChoices.HAjournalPort);
    addTextNode(doc, elem, "journalhttpport", userChoices.HAjournalHttpPort);
    addTextNode(doc, elem, "journalhttpsport", userChoices.HAjournalHttpsPort);
  } else {
    // namenode
    var elem = doc.createElement("namenode");
    instanceElem.appendChild(elem);
    addTextNode(doc, elem, "host", userChoices.nameNodeHost);
    addTextNode(doc, elem, "port", userChoices.nameNodePort);
    addTextNode(doc, elem, "httpport", userChoices.nameNodeHttpPort);
    addTextNode(doc, elem, "httpsport", userChoices.nameNodeHttpsPort);
    // secondarynamenode
    elem = doc.createElement("secondarynamenode");
    instanceElem.appendChild(elem);
    addTextNode(doc, elem, "host", userChoices.secondaryNameNodeHost);
    addTextNode(doc, elem, "httpport", userChoices.secondaryNameNodeHttpPort);
    addTextNode(doc, elem, "httpsport", userChoices.secondaryNameNodeHttpsPort);
  }

  if (userChoices.major == 1) {
    // jobtracker
    var elem = doc.createElement("jobtracker");
    instanceElem.appendChild(elem);
    addTextNode(doc, elem, "host", userChoices.jobTrackerHost);
    addTextNode(doc, elem, "port", userChoices.jobTrackerPort);
    addTextNode(doc, elem, "httpport", userChoices.jobTrackerHttpPort);
  }

  // datanodes
  var elem = doc.createElement("datanodes");
  instanceElem.appendChild(elem);
  if (userChoices.dataNodes != "") {
    addTextNode(doc, elem, "hosts", userChoices.dataNodes);
  }
  addTextNode(doc, elem, "port", userChoices.dataNodePort);
  addTextNode(doc, elem, "ipcport", userChoices.dataNodeIpcPort);
  addTextNode(doc, elem, "httpport", userChoices.dataNodeHttpPort);
  addTextNode(doc, elem, "httpsport", userChoices.dataNodeHttpsPort);
  if (userChoices.major == 1) {
    addTextNode(doc, elem, "tasktrackerhttpport", userChoices.taskTrackerHttpPort);
  } else {
    addTextNode(doc, elem, "nodemanagerlocalizerport", userChoices.nodeManagerLocalizerPort);
    addTextNode(doc, elem, "nodemanagerwebappport", userChoices.nodeManagerWebAppPort);
    addTextNode(doc, elem, "nodemanagerwebapphttpsport", userChoices.nodeManagerWebAppHttpsPort);
    addTextNode(doc, elem, "nodemanagershuffleport", userChoices.nodeManagerShufflePort);
  }
  if (userChoices.major == 2) {
    elem = doc.createElement("yarnserver");
    instanceElem.appendChild(elem);
    if (userChoices.yarnHaAuto) {
      var haelem = doc.createElement("yarnha");
      elem.appendChild(haelem);
      haelem.setAttribute("enabled", userChoices.yarnHaManual.toString());
      haelem.setAttribute("auto", userChoices.yarnHaAuto.toString());
      if (userChoices.yarnHaAuto) {
        haelem.setAttribute("enabled", "true");
      }
      addTextNode(doc, haelem, "clusterid", "mycluster");
      addTextNode(doc, haelem, "resourcemanagerids", "rm1,rm2");
      addTextNode(doc, haelem, "resourcemanagehosts", userChoices.yarnServerHost1 + "," + userChoices.yarnServerHost2);
    } else {
      addTextNode(doc, elem, "host", userChoices.yarnServerHost);
    }
    addTextNode(doc, elem, "port", userChoices.yarnServerResourceManagerPort);
    addTextNode(doc, elem, "schedulerport", userChoices.yarnServerResourceManagerSchedulerPort);
    addTextNode(doc, elem, "webappport", userChoices.yarnServerResourceManagerWebAppPort);
    addTextNode(doc, elem, "webapphttpsport", userChoices.yarnServerResourceManagerWebAppHttpsPort);
    addTextNode(doc, elem, "rtport", userChoices.yarnServerResourceManagerRtPort);
    addTextNode(doc, elem, "adminport", userChoices.yarnServerResourceManagerAdminPort);
    addTextNode(doc, elem, "historyport", userChoices.yarnServerJobHistoryPort);
    addTextNode(doc, elem, "historywebappport", userChoices.yarnServerJobHistoryWebAppPort);
    addTextNode(doc, elem, "historywebapphttpsport", userChoices.yarnServerJobHistoryWebAppHttpsPort);
    addTextNode(doc, elem, 'timelineport', userChoices.yarnServerTimelinePort);
    addTextNode(doc, elem, 'timelinewebappport', userChoices.yarnServerTimelineWebAppPort);
    addTextNode(doc, elem, 'timelinewebapphttpsport', userChoices.yarnServerTimelineWebAppHttpsPort);
  }

  if (userChoices.installZooKeeper) {
    // zookeeper
    elem = doc.createElement("zookeeper");
    instanceElem.appendChild(elem);
    addTextNode(doc, elem, "archive", userChoices.zooKeeperTarball);
    addTextNode(doc, elem, "hosts", userChoices.zookeeperHosts);
    addTextNode(doc, elem, "clientport", userChoices.zookeeperClientPort);
    addTextNode(doc, elem, "serverport", userChoices.zookeeperServerPort);
    addTextNode(doc, elem, "electionport", userChoices.zookeeperElectionPort);
  }

  if (userChoices.installHBase) {
    // hbase
    elem = doc.createElement("hbase");
    instanceElem.appendChild(elem);
    addTextNode(doc, elem, "archive", userChoices.hbaseTarball);
    addTextNode(doc, elem, "master", userChoices.hbaseMaster);
    addTextNode(doc, elem, "masterport", userChoices.hbaseMasterPort);
    addTextNode(doc, elem, "masterinfoport", userChoices.hbaseMasterInfoPort);
    addTextNode(doc, elem, "regionservers", userChoices.hbaseRegionServers);
    addTextNode(doc, elem, "regionserverport", userChoices.hbaseRegionServerPort)
    addTextNode(doc, elem, "regionserverinfoport", userChoices.hbaseRegionServerInfoPort)
  }

  xmlConfig = new XMLSerializer().serializeToString(doc);
  return xmlConfig;
}

function addTextNode(doc, node, name, value) {
  var elem = doc.createElement(name);
  var text = doc.createTextNode(value);
  elem.appendChild(text);
  node.appendChild(elem);
}
// END xml stuff
