/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function refresh(use) {
  if(!!use) current = use;
  println("Refresh hadoop" + ' - ' + document.documentURI);
  var checks = document.getElementsByTagName('checkimage');
  for(var i = 0; i < checks.length; i++) {
    checks[i].checked = false;
    var next = checks[i].nextSibling;
    if(next) next.setAttribute('hidden', true);
  }

  clearLabel('HadoopNameNode');
  clearLabel('HadoopSecondaryNameNode');
  clearLabel('HadoopDataNode');
  clearLabel('HadoopJobTracker');
  clearLabel('HadoopTaskTracker');
  clearLabel('HadoopYARNServer');
  clearLabel('HadoopYARNClient');
  clearLabel('HadoopHBaseServer');
  clearLabel('HadoopHBaseClient');
  clearLabel('HadoopZooKeeper');
  clearLabel('HadoopJournal');
  clearLabel('HadoopNFSGateway');
  clearLabel('HadoopKMServer');
  clearLabel('HadoopHive');
  clearLabel('HadoopSqoop');
  clearLabel('HadoopSparkYARN');
  clearLabel('HadoopSparkMaster');
  clearLabel('HadoopSparkWorker');

  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(!roles[i].toBeRemoved && startswith(roles[i].childType, 'Hadoop')) {
      setHadoopConfig(roles[i], false);
      setRole(roles[i], '');
    }
  }

  if(dock.baseChildTypeCheck(current.object, 'SlaveNode')) {
    var cat = current.get('category');
    if(cat) {
      cat = current.cluster.find(cat);
      if(cat) {
        var catroles = cat.get(subfield);
        cat = cat.resolveName();
        for(var i = 0; i < catroles.length; i++) {
          if(!catroles[i].toBeRemoved) {
            var found = false;
            for(var j = 0; !found && (j < roles.length); j++) {
              if(!roles[j].toBeRemoved) {
                found = (catroles[i].childType == roles[j].childType);
              }
            }
            if(!found) {
              setHadoopConfig(catroles[i], cat);
              setRole(catroles[i], cat);
            }
          }
        }
      }
    }
  }
}

function setHadoopConfig(role, category) {
  var rows = document.getElementById('rows' + role.childType);
  if(rows) {
    while(rows.firstChild) rows.removeChild(rows.firstChild);
    var last = role.config.length - 1;
    while(last >= 0) {
      if(!role.config[last].toBeRemoved) break;
      last--;
    }
    for(var i = 0; i < role.config.length; i++) {
      if(role.config[i].toBeRemoved) continue;
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var menulist = document.createElement('menulist');
      var menupopup = document.createElement('menupopup');
      menulist.setAttribute('disabled', true);
      menulist.setAttribute('id', role.childType + '_config_' + i + 'hdfs');
      menulist.appendChild(menupopup);
      row.appendChild(menulist);
      /*
      if(!category) {
        var hbox = document.createElement('vbox');
        hbox.setAttribute('flex', 1);
        var button = document.createElement('button');
        button.setAttribute('class', 'graybutton');
        button.setAttribute('label', 'Advanced');
        button.setAttribute('oncommand', 'editHadoopConfig("' + role.childType + '", ' + i + ');');
        hbox.appendChild(button);
        row.appendChild(hbox);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      if(!category) {
        var button = document.createElement('button');
        button.setAttribute('class', 'minus-button');
        button.setAttribute('oncommand', 'removeHadoopConfig("' + role.childType + '", ' + i + ');');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      if((i == last) && !category) {
        var button = document.createElement('button');
        button.setAttribute('class', 'plus-button');
        button.setAttribute('oncommand', 'addHadoopConfig("' + role.childType + '");');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }*/
      rows.appendChild(row);
    }
    /*
    if(last < 0) {
      var row = document.createElement('row');
      if(!category) {
        var button = document.createElement('button');
        button.setAttribute('class', 'plus-button');
        button.setAttribute('oncommand', 'addHadoopConfig("' + role.childType + '");');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      rows.appendChild(row);
    }*/
  } else {
    println('No rows for ' + role.childType);
  }
}

function addHadoopConfig(type) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == type) {
      type = type.replace('Role', 'HDFSConfiguration');
      var config = eval('new dock.cv' + type);
      var tmp = new dock.cvObject(current.cluster, config);
      roles[i].config.push(config);
      roles[i].modified = true;
      current.set('modified', true);
      refresh();
      break;
    }
  }
}

function removeHadoopConfig(type, index) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == type) {
      roles[i].config[index].toBeRemoved = true;
//       roles[i].config.splice(index, 1);
      roles[i].modified = true;
      current.set('modified', true);
      refresh();
      break;
    }
  }
}

function editHadoopConfig(type, index) {
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == type) {
      var editfile = dock.myVersion + 'edit' + type.replace('Role', 'HDFSConfiguration').toLowerCase() + '.xul';
      var args = new Object();
      args['object'] = current;
      args['role'] = roles[i];
      args['config'] = index;
      var d = new dock.cvDialog(editfile, args);
      d.onOk = function() {
        refresh();
      }
      dock.dialogs.showDialog(d);      
      break;
    }
  }
}
