/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

var oldcluster = 0;
var allHadoopNodeKeys;

var PATTERN_ID = /^metriclist(\d+)$/g;

var timer = 0;

function getCurrentSelection() {
  return [[current], 0, ""];
}


function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh HBase Tab" + ' - ' + document.documentURI);

  var isHBase = current.checkHadoopService('HBase');
  
  // executed if HBase installed (e.g., call to cmdaemon for HBase details overview)
  if (isHBase) {
    for(var i = 0; i < window.frames.length; i++)  window.frames[i].refresh(current);  
    update();
  
    var cluster = current.cluster;
    if(cluster != oldcluster) {
      setCallbackResult(new dock.cvGuiClusterOverview());    
      oldcluster = cluster;
    }  
  }

}


function update() {
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getHadoopHdfsDetailHBase', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;
  
  // printall(overview);
 
  overviewBar('hbasemasterJVMMemory', overview.hbasemaster_MemHeapUsed+overview.hbasemaster_MemNonHeapUsed, overview.hbasemaster_MemHeapCommitted+overview.hbasemaster_MemNonHeapCommitted, 'B', true);
  overviewBar('totalregionserverJVMMemory', overview.total_hbaseregserver_MemHeapUsed+overview.total_hbaseregserver_MemNonHeapUsed, overview.total_hbaseregserver_MemHeapCommitted+overview.total_hbaseregserver_MemNonHeapCommitted, 'B', true);

  document.getElementById('regionserversInfo').setAttribute('value', overview.totalRegionServers + " live / " + overview.deadRegionServers + " dead");
  document.getElementById('regionserversDecommissioned').setAttribute('value', overview.decommissionedRegionServers + " decommissioned");
  document.getElementById('regionsInfo').setAttribute('value', overview.totalNumRegions + " total, " + overview.average_hbaseregserver_NumRegions + " per RegionServer on average");
  document.getElementById('regionsInTransition').setAttribute('value', overview.numRegionsInTransition + " total, " + overview.numRegionsInTransitionExceedingThreshold + " longer than threshold");
  document.getElementById('requestsInfo').setAttribute('value', overview.total_hbaseregserver_NumRequests + " total, " + overview.total_hbaseregserver_NumReadRequests + " reads, " + overview.total_hbaseregserver_NumWriteRequests + " writes");
  document.getElementById('cacheHitsInfo').setAttribute('value', overview.average_hbaseregserver_blockCacheHitCount + " hits, " + overview.average_hbaseregserver_blockCacheMissCount + " misses");

  overviewValue('totalNumStoreFiles');
  overviewValue('totalSizeStoreFiles');
  overviewValue('ageLongestRegionInTransition');

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 500);  

}  

