/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function isComponentInstalled(currentObject, componentName) {
  // TODO: https://jira.brightcomputing.com:8443/browse/CM-5736
  return false;
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh Hadoop settings" + ' - ' + document.documentURI);

  //printallR(current.object.serializationsClasses); 

  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  
  text('name', '^[a-zA-Z]');
  // text('version', '^');
  //text('distribution', '^');
  document.getElementById('distributionVersion').setAttribute('value', current.get('distribution') + " " + current.get('version') + " (" + current.get('description') + ")");
  //text('description', '^');
  
  text('configurationDirectory', '^');
  text('installationDirectory', '^');
 
  text('tmpDirectory', '^');
  text('logDir', '^');
  text('dataRootDirectory', '^');

  var isHDFS = current.checkHadoopService('HDFS');
  
  if (isHDFS) {
    document.getElementById('topologyInfo').removeAttribute('hidden');
    document.getElementById('mapreduceFrameworkNameInfo').removeAttribute('hidden');
    document.getElementById('alternativeWLMInfo').removeAttribute('hidden');
    document.getElementById('hdfsBalancer').removeAttribute('hidden');
    document.getElementById('hdfsConfiguration').removeAttribute('hidden');

    kenum('balancerPolicy', [['dataNode', 'datanode'],['blockpool', 'blockpool']]);
    text('balancerPeriod', '^');
    text('balancerThreshold', '^');

    text('blockSize', '^');
    text('replicationFactor', '^');
    text('maxReplicationFactor', '^');
    //number('replicationFactor', 1, 512);
    //number('maxReplicationFactor', 1, 512);
    
    text('blockReportDelay', '^');
    text('bufferSize', '^');
    text('umask', '^');

    text('connectionMaxIdleTime', '^');
    text('connectionIdleThreshold', '^');
    text('connectionMaxRetries', '^');
  
    //  stringlist('serializationsClasses', 'Serialization class:');
    var arrayAttributeListable = new SingleArrayAttributeListable(current, 'serializationsClasses');
    var textboxDoubleListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxDoubleListDataViewMapper.setNewItem(['']);
    textboxDoubleListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '160px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'serClassesDiv',
      'dataViewMapper': textboxDoubleListDataViewMapper
    });
    addDelListWidget.populate();

    stringlist('compressionCodecs', 'Compression codec:');
    check('webhdfs');
    check('permission');
    check('useHTTPS');

    kenum('topology', [['NONE', 'None'],['SWITCH', 'Switch'],['RACK', 'Rack']]);
    kenum('mapreduceFrameworkName', [['YARN', 'YARN'],['IGNITE', 'Ignite']]);
  }
  else {
    document.getElementById('topologyInfo').setAttribute('hidden', true);
    document.getElementById('hdfsBalancer').setAttribute('hidden', true);
    document.getElementById('hdfsConfiguration').setAttribute('hidden', true);
  }

  if (current.object.lustreFS) { 
    kenum('alternativeWLM', [['SLURM', 'SLURM'],['', 'Default']]);
    document.getElementById('alternativeWLMInfo').setAttribute("hidden", false);
    println("lustreFS true");
  } else {
    document.getElementById('alternativeWLMInfo').setAttribute("hidden", true);
    println("lustreFS false");
  }

  if (isComponentInstalled(current, 'Ignite')) { 
    document.getElementById('mapreduceFrameworkNameInfo').setAttribute("hidden", false);
    println("Ignite installed true");
  } else {
    document.getElementById('mapreduceFrameworkNameInfo').setAttribute("hidden", true);
    println("Ignite installed false");
  }

  // shows installation/configuration details for a corresponding Hadoop service if it is installed
  if ( current.checkHadoopService('HBase') ) {
    document.getElementById('hbase-inst').setAttribute("hidden", false);
    text('hbaseInstallDirectory', '^');
    text('hbaseConfigDirectory', '^');
  }

  if ( current.checkHadoopService('Spark') ) {
    document.getElementById('spark-inst').setAttribute("hidden", false);
    text('sparkInstallDirectory', '^');
    text('sparkConfigDirectory', '^');
  }

  if ( current.checkHadoopService('ZooKeeper') ) {
    document.getElementById('zookeeper-inst').setAttribute("hidden", false);
    text('zookeeperInstallDirectory', '^');
    text('zookeeperConfigDirectory', '^');
  }

  if ( current.checkHadoopService('Hive') ) {
    document.getElementById('hive-inst').setAttribute("hidden", false);
    text('hiveInstallDirectory', '^');
    text('hiveConfigDirectory', '^');
  }

  if ( current.checkHadoopService('Sqoop') ) {
    document.getElementById('sqoop-inst').setAttribute("hidden", false);
    text('sqoopInstallDirectory', '^');
    text('sqoopConfigDirectory', '^');
  }

  if ( current.checkHadoopService('AccumuloMaster') ) {
    document.getElementById('accumulo-inst').setAttribute('hidden', false);
    text('accumuloInstallDirectory', '^');
    text('accumuloConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('AccumuloTablet') ) {
    document.getElementById('accumulo-inst').setAttribute('hidden', false);
    text('accumuloInstallDirectory', '^');
    text('accumuloConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('Drill') ) {
    document.getElementById('drill-inst').setAttribute('hidden', false);
    text('drillInstallDirectory', '^');
    text('drillConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('Pig') ) {
    document.getElementById('pig-inst').setAttribute('hidden', false);
    text('pigInstallDirectory', '^');
    text('pigConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('FlinkJobManager') ) {
    document.getElementById('flink-inst').setAttribute('hidden', false);
    text('flinkInstallDirectory', '^');
    text('flinkConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('FlinkTaskManager') ) {
    document.getElementById('flink-inst').setAttribute('hidden', false);
    text('flinkInstallDirectory', '^');
    text('flinkConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('StormSupervisor') ) {
    document.getElementById('storm-inst').setAttribute('hidden', false);
    text('stormInstallDirectory', '^');
    text('stormConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('StormNimbus') ) {
    document.getElementById('storm-inst').setAttribute('hidden', false);
    text('stormInstallDirectory', '^');
    text('stormConfigDirectory', '^');
  }
 
  if ( current.checkHadoopService('KafkaServer') ) {
    document.getElementById('kafka-inst').setAttribute('hidden', false);
    text('kafkaInstallDirectory', '^');
    text('kafkaConfigDirectory', '^');
  }

  if ( current.checkHadoopService('Zeppelin') ) {
    document.getElementById('zeppelin-inst').setAttribute('hidden', false);
    text('zeppelinInstallDirectory', '^');
    text('zeppelinConfigDirectory', '^');
  }

  if ( current.checkHadoopService('AlluxioMaster') ) {
    document.getElementById('alluxio-inst').setAttribute('hidden', false);
    text('alluxioInstallDirectory', '^');
    text('alluxioConfigDirectory', '^');
  }

  if ( current.checkHadoopService('AlluxioWorker') ) {
    document.getElementById('alluxio-inst').setAttribute('hidden', false);
    text('alluxioInstallDirectory', '^');
    text('alluxioConfigDirectory', '^');
  }

  if ( current.checkHadoopService('Cassandra') ) {
    document.getElementById('cassandra-inst').setAttribute('hidden', false);
    text('cassandraInstallDirectory', '^');
    text('cassandraConfigDirectory', '^');
  }
}
