/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function hideAllTabs(tabs) {
  var child = tabs.firstChild;
  while(child) {
    child.setAttribute('hidden', true);
    child = child.nextSibling;
  }
}

function unhideAllTabs(tabs) {
  var child = tabs.firstChild;
  while(child) {
    child.removeAttribute('hidden');
    child = child.nextSibling;
  }
}

function postrefresh(use) {
  if(!!use) current = use;

  if(!!current) {
    var cluster = current;
    if(!!current.cluster) cluster = current.cluster;

    var tabs = document.getElementById("tabs");

    if (!isCorrectlyConfigured(cluster, current.object.uniqueKey)) {
      hideAllTabs(tabs);
      return;
    } else {
      unhideAllTabs(tabs);      
    }
    
    if(tabs) {
      var child = tabs.firstChild;
      var isHBase = current.checkHadoopService('HBase');  
      var isZookeeper = current.checkHadoopService('ZooKeeper');  
      var isHDFS = current.checkHadoopService('HDFS');
      var isYARN = current.checkHadoopService('YARN');
      var isMRv1 = current.checkHadoopService('MRv1');
      
      var hidden = false;
      var i = 0;
      while(child) {
        if(child.hasAttribute('hdfs')) {
          if(isHDFS && eval(child.getAttribute('hdfs'))) {
            child.removeAttribute('hidden');
          } else {
            child.setAttribute('hidden', true);
          }
        } else if(child.hasAttribute('hbase')) {
          if(isHBase && eval(child.getAttribute('hbase'))) {
            child.removeAttribute('hidden');
          } else {
            child.setAttribute('hidden', true);
          }
        } else if(child.hasAttribute('zookeeper')) {
          if(isZookeeper && eval(child.getAttribute('zookeeper'))) {
            child.removeAttribute('hidden');
          } else {
            child.setAttribute('hidden', true);
          }
        } else if(child.hasAttribute('yarn')) {
          if(isYARN && eval(child.getAttribute('yarn'))) {
            child.removeAttribute('hidden');
          } else {
            child.setAttribute('hidden', true);
          }
        } else if(child.hasAttribute('mapreduce')) {
          if(isMRv1 && eval(child.getAttribute('mapreduce'))) {
            child.removeAttribute('hidden');
          } else {
            child.setAttribute('hidden', true);
          }
        } else if(child.hasAttribute('morehadoop')) { // hidden for Spark
          if(current.object.isSparkInstance) {
            child.setAttribute('hidden', true);
          } else {
            child.removeAttribute('hidden');
          }
        } else if(child.hasAttribute('security')) { // hidden for Spark standalone and Cassandra
          if(current.object.isSparkInstance || current.object.isCassandraInstance) {
            child.setAttribute('hidden', true);
          } else {
            child.removeAttribute('hidden');
          }
        }
        hidden = hidden || ((tabs.selectedIndex == i) && child.hasAttribute('hidden') && (child.getAttribute('hidden') == 'true'));
        child = child.nextSibling;
        ++i;
      }
    }
    if(hidden) tabs.selectedIndex = 0;
  }
}
