/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

var oldcluster = 0;
var allHadoopNodeKeys;

var PATTERN_ID = /^metriclist(\d+)$/g;

var timer = 0;

function getCurrentSelection() {
  return [[current], 0, ""];
}


function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh MapReduce Tab" + ' - ' + document.documentURI);

  var isMRv1 = current.checkHadoopService('MRv1');
  
  if (isMRv1) {
    for(var i = 0; i < window.frames.length; i++)    window.frames[i].refresh(current);
    update();
  
    var cluster = current.cluster;
    if(cluster != oldcluster) {
      setCallbackResult(new dock.cvGuiClusterOverview());    
      oldcluster = cluster;
    }  
  }

}

function update() {
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getHadoopHdfsDetailMapreduce', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;
  
  // printall(overview);

  overviewBar('jobtrackerJVMMemory', overview.jobtracker_MemHeapUsed+overview.jobtracker_MemNonHeapUsed, overview.jobtracker_MemHeapCommitted+overview.jobtracker_MemNonHeapCommitted, 'B', true);
  overviewBar('totaltasktrackerJVMMemory', overview.total_tasktracker_MemHeapUsed+overview.total_tasktracker_MemNonHeapUsed, overview.total_tasktracker_MemHeapCommitted+overview.total_tasktracker_MemNonHeapCommitted, 'B', true);
  
  overviewValue('jobtracker_map_slots');
  overviewValue('jobtracker_reduce_slots');
  
  document.getElementById('tasktrackersLiveDead').setAttribute('value', overview.jobtracker_trackers + " live / " + overview.jobtracker_trackers_blacklisted + " dead");
  document.getElementById('tasktrackersOtherStatus').setAttribute('value', overview.jobtracker_trackers_decommissioned + " decommissioned");
  document.getElementById('jobsStatus').setAttribute('value', overview.jobtracker_Jobs_running + " running, " + overview.jobtracker_Jobs_submitted + " submitted, " + overview.jobtracker_Jobs_completed + " completed, " + overview.jobtracker_Jobs_failed + " failed");
  document.getElementById('mapsInfo').setAttribute('value', overview.jobtracker_maps_running + " running, " + overview.jobtracker_maps_launched + " launched, " + overview.jobtracker_maps_completed + " completed, " + overview.jobtracker_maps_failed + " failed, " + overview.jobtracker_maps_killed + " killed");
  document.getElementById('reducesInfo').setAttribute('value', overview.jobtracker_reduces_running + " running, " + overview.jobtracker_reduces_launched + " launched, " + overview.jobtracker_reduces_completed + " completed, " + overview.jobtracker_reduces_failed + " failed, " + overview.jobtracker_reduces_killed + " killed");

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 500);  

}  
