/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var oldcluster = 0;
var allHadoopNodeKeys;

var graphs;
var NUM_GRAPHS = 4;
var PATTERN_ID = /^metriclist(\d+)$/g;
// choose appropriate defaults
var DEFAULT_METRICS = ['_datanode_dfs_used', '_namenode_GcCount', '_resourcemanager_AllocatedContainers', '_resourcemanager_PublishAvgTime'];
var DEFAULT_METRICS_SPARK = ['_sparkworker_MemHeapUsage', '_sparkworker_MemNonHeapUsage', '_sparkworker_WorkerCoresused', '_sparkworker_WorkerExecutors'];
var DEFAULT_METRICS_CASSANDRA = ['_cassandra_MemHeapUsed', '_cassandra_MemHeapMax', '_cassandra_MemNonHeapInit', '_cassandra_MemNonHeapUsed'];
var DEFAULT_TYPES = [1, 5, 1, 5];
var BIGDATA_GRAPHS_FOR = 'Monitoring tab';



function onLoad() {
  dock = getDock();
  graphs = new Array();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh Hadoop Monitoring Tab" + ' - ' + document.documentURI);

  var cluster = current.cluster;
  if(cluster != oldcluster) {
    if(graphs.length == 0) { // init
      for (var i = 0; i < NUM_GRAPHS; i++) {
        graphs[i] = new cvGraph(cluster, document.getElementById("svg" + i), document.getElementById("box" + i));
        graphs[i].WM = 32;
        graphs[i].HM = 61;
        graphs[i].legend = -1;
      }
    } else {
      for (var i = 0; i < graphs.length; i++) {
        graphs[i].cluster = cluster;
        graphs[i].deviceMetric[0].nodes = allHadoopNodeKeys;
        graphs[i].clearScreen();
      }
    }
    oldcluster = cluster;
  }  

  for(var i = 0; i < graphs.length; i++) {
    refreshGraph(cluster, i);
  }
}
