/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var nodesUp;
var nodesDown;
var nodesClosed;

var overview;
var timer = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh Spark operations" + ' - ' + document.documentURI);
  // update();
}

function startSpark() {
  var args = new Object();
  var hdfskey = current.get('uniqueKey');
  var hdfsname = current.get('name');
  args['question'] = "Start all Spark services on " + hdfsname + "?";
  var d = new dock.cvDialog(dock.myVersion + "question.xul", args);

  d.onOk = function() {
    dock.waitIcon();

     dock.workerpool.getWorker(current.cluster.actualurl).call('cmhadoop', 'startServiceForHDFS', [hdfskey, 5], function(code, data) {
      if(code == 0) {
        if(data.output.length == 0) {
          dock.displayInfo('Spark start returned no output and error code: ' + data.code);
        } else {
          dock.displayInfo(data.output);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);
}

function stopSpark() {
  var args = new Object();
  var hdfskey = current.get('uniqueKey');
  var hdfsname = current.get('name');
  args['question'] = "Stop all Spark services on " + hdfsname + "?";
  var d = new dock.cvDialog(dock.myVersion + "question.xul", args);

  d.onOk = function() {
    dock.waitIcon();

     dock.workerpool.getWorker(current.cluster.actualurl).call('cmhadoop', 'stopServiceForHDFS', [hdfskey, 5], function(code, data) {
      if(code == 0) {
        if(data.output.length == 0) {
          dock.displayInfo('Spark stop returned no output and error code: ' + data.code);
        } else {
          dock.displayInfo(data.output);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);
}

function restartSpark() {
  var args = new Object();
  var hdfskey = current.get('uniqueKey');
  var hdfsname = current.get('name');
  args['question'] = "Restart all Spark services on " + hdfsname + "?";
  var d = new dock.cvDialog(dock.myVersion + "question.xul", args);

  d.onOk = function() {
    dock.waitIcon();

     dock.workerpool.getWorker(current.cluster.actualurl).call('cmhadoop', 'restartServiceForHDFS', [hdfskey, 5], function(code, data) {
      if(code == 0) {
        if(data.output.length == 0) {
          dock.displayInfo('Spark restart returned no output and error code: ' + data.code);
        } else {
          dock.displayInfo(data.output);
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  }
  dock.dialogs.showDialog(d);
}


