/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

var oldcluster = 0;
var allHadoopNodeKeys;

var PATTERN_ID = /^metriclist(\d+)$/g;

var timer = 0;

function getCurrentSelection() {
  return [[current], 0, ""];
}


function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh Spark Tab" + ' - ' + document.documentURI);

  var isSpark = current.checkHadoopService('Spark');
  var isSparkYARN = current.checkHadoopService('Spark-YARN');

  if (!isSpark) {
    document.getElementById('noSpark').removeAttribute('hidden');
    document.getElementById('withSpark').setAttribute('hidden','true');      
    document.getElementById('withSparkYARN').setAttribute('hidden','true');      
  }  
  else if (isSparkYARN) {
    document.getElementById('withSparkYARN').removeAttribute('hidden');
    document.getElementById('withSpark').setAttribute('hidden','true');
    document.getElementById('noSpark').setAttribute('hidden','true');
    
  } else {
    document.getElementById('withSpark').removeAttribute('hidden');
    document.getElementById('withSparkYARN').setAttribute('hidden','true');
    document.getElementById('noSpark').setAttribute('hidden','true');            

    for(var i = 0; i < window.frames.length; i++)  window.frames[i].refresh(current);  
    update();
  
    var cluster = current.cluster;
    if(cluster != oldcluster) {
      setCallbackResult(new dock.cvGuiClusterOverview());    
      oldcluster = cluster;
    }  
  }

}

function update() {
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getHadoopHdfsDetailSpark', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;
  
  // printall(overview);
  overviewBar('sparkmasterJVMMemory', overview.sparkmaster_MemHeapUsed+overview.sparkmaster_MemNonHeapUsed, overview.sparkmaster_MemHeapCommitted+overview.sparkmaster_MemNonHeapCommitted, 'B', true);
  overviewBar('totalsparkworkerJVMMemory', overview.total_sparkworker_MemHeapUsed+overview.total_sparkworker_MemNonHeapUsed, overview.total_sparkworker_MemHeapCommitted+overview.total_sparkworker_MemNonHeapCommitted, 'B', true);

  document.getElementById('sparkWorkersStatus').setAttribute('value', overview.sparkActiveWorkers + " live / " + overview.sparkLostWorkers + " dead");

  document.getElementById('applicationsInfo').setAttribute('value', overview.sparkAppsRunning + " running, " + overview.sparkAppsFailed + " failed, " + overview.sparkAppsCompleted + " completed");

  document.getElementById('coresInfo').setAttribute('value', overview.sparkTotalCores + " total, " + overview.sparkUsedCores + " used");

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 500);  

}
