/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var roleName = 'HadoopSqoopRole';

function onLoad() {
  dock = getDock();
  var configindex = window.frameElement.id.split("_").pop();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  refresh(parent.configs2pass[roleName]);
}

function refresh(use) {
  if(!!use) current = use;
  println('Refresh ' + hadoopservicenames[roleName] + " settings - " + document.documentURI);

  var names = dotFormatKeys(current.cluster, parent.nodesapplied2pass[roleName]);
  document.getElementById('nodesapplied').setAttribute("value", names);
  println(hadoopservicenames[roleName] + " configuration is applied to " + names);

  // depending on Sqoop major version, i.e. Sqoop1 or Sqoop2
  // show corresponding settings
  // NOTE: as of July 2015, Sqoop1 versions are 1.4.x and Sqoop2 versions 
  //       are 1.99.x; Sqoop2 versions are likely to change and hence modifications 
  //       should be appled
  
  // get Sqoop version 
  var sqoopversion = current.object.version;
  
  if ( sqoopversion.substring(0,4) != '1.99' ) {
    document.getElementById('sqoop1').removeAttribute('hidden');
    text('metastoreServerLocation', '');  
    text('metastoreServerPort', '^[0-9]+$');
    check('metastoreClientAutoconnect');
    text('metastoreClientAutoconnectUrl', '');
    text('metastoreClientAutoconnectUsername', '');
    text('metastoreClientAutoconnectPassword', '');
    text('metastoreClientRecordPassword', '')
    check('serializeJobOptions');
    stringlist('connectionFactories', 'Connection factories:');
    stringlist('toolPlugins', 'Tool plugins:');
    stringlist('specializedConnectors', 'Specialized connectors:');
  }
  else {
    document.getElementById('sqoop2').removeAttribute('hidden');
    text('serverMetastoreDirectory', '');  
    text('adminPort', '^[0-9]+$');
    text('httpPort', '^[0-9]+$');
    text('repositoryMaximumConnections', '^[0-9]+$');
  }
}

