/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

var oldcluster = 0;
var allHadoopNodeKeys;

var PATTERN_ID = /^metriclist(\d+)$/g;

var timer = 0;

function getCurrentSelection() {
  return [[current], 0, ""];
}


function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh YARN Tab" + ' - ' + document.documentURI);

  var isYARN = current.checkHadoopService('YARN');
  
  if (isYARN) {
    for(var i = 0; i < window.frames.length; i++)    window.frames[i].refresh(current);
    update();
  
    var cluster = current.cluster;
    if(cluster != oldcluster) {
      setCallbackResult(new dock.cvGuiClusterOverview());    
      oldcluster = cluster;
    }  
  }

}

function update() {
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getHadoopHdfsDetailYARN', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;

  // print YARN-overview object
  // printall(overview);

   overviewBar('resourcemanagerJVMMemory', overview.resourcemanager_MemHeapUsed+overview.resourcemanager_MemNonHeapUsed, overview.resourcemanager_MemHeapCommitted+overview.resourcemanager_MemNonHeapCommitted, 'B', true);
   overviewBar('totalnodemanagerJVMMemory', overview.total_nodemanager_MemHeapUsed+overview.total_nodemanager_MemNonHeapUsed, overview.total_nodemanager_MemHeapCommitted+overview.total_nodemanager_MemNonHeapCommitted, 'B', true);

  document.getElementById('nodemanagersLiveDead').setAttribute('value', overview.resourcemanager_activeNodes + " live / " + overview.resourcemanager_lostNodes + " dead");
  document.getElementById('nodemanagersOtherStatus').setAttribute('value', overview.resourcemanager_decommissionedNodes + " decommissioned, " + overview.resourcemanager_unhealthyNodes + " unhealthy, " + overview.resourcemanager_rebootedNodes + " rebooted");
  document.getElementById('applicationsStatus').setAttribute('value', overview.appsRunning + " running, " + overview.appsPending + " pending, " + overview.appsSubmitted + " submitted");
  document.getElementById('applicationsMoreInfo').setAttribute('value', overview.appsCompleted + " completed, " + overview.appsFailed + " failed, " + overview.resourcemanager_AppsKilled + " killed");
  document.getElementById('containersStatus').setAttribute('value', overview.resourcemanager_AllocatedContainers + " allocated, " + overview.resourcemanager_PendingContainers + " pending, " + overview.resourcemanager_ReservedContainers + " reserved");

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 500);  

}  
