/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

var oldcluster = 0;
var allHadoopNodeKeys;

var PATTERN_ID = /^metriclist(\d+)$/g;

var timer = 0;

function getCurrentSelection() {
  return [[current], 0, ""];
}


function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}


function refresh(use) {
  if(!!use) current = use;
  println("Refresh ZooKeeper Tab" + ' - ' + document.documentURI);

  var isZookeeper = current.checkHadoopService('ZooKeeper');

  // executed if Zookeeper installed (e.g., call to cmdaemon for Zkpr details overview)
  if (isZookeeper)  {
    for(var i = 0; i < window.frames.length; i++)  window.frames[i].refresh(current);  
    update();
  
    var cluster = current.cluster;
    if(cluster != oldcluster) {
      setCallbackResult(new dock.cvGuiClusterOverview());    
      oldcluster = cluster;
    }  
  }

}

function update() {
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getHadoopHdfsDetailZookeeper', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;
  
  // printall(overview);

  overviewValue('zk_version');
  overviewValue('zk_outstanding_requests');
  overviewValue('zk_znode_count');
  overviewValue('zk_watch_count');

  document.getElementById('zkprServersInfo').setAttribute('value', (overview.zk_num_running_servers-overview.zk_followers) + " leader, " + overview.zk_followers + " followers");

  document.getElementById('zkprAverageLatency').setAttribute('value', overview.zk_avg_latency + " / " + overview.zk_min_latency + " / " + overview.zk_max_latency);  

  document.getElementById('zkprPacketsInfo').setAttribute('value', overview.zk_packets_received + " received, " + overview.zk_packets_sent + " sent");   

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 500);  

}  

