/*
 * Copyright (c) 2004-2017 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

// NOTE: ALL CHANGES IN THIS FILE MUST BE MERGED INTO 7.1, beyond 7.2

// name, basedOn, major, tar, zooTar, hbaseTar, lustre, yarha, kms
var APACHE_121 = ['Apache Hadoop 1.2.1', '', 1,
                  'hadoop-1.2.1.tar.gz', 'zookeeper-3.4.11.tar.gz', 'hbase-0.98.24-hadoop1-bin.tar.gz',
                  false, false, false];
var APACHE_27X = ['Apache Hadoop 2.7.x', '', 2,
                  'hadoop-2.7.4.tar.gz', 'zookeeper-3.4.11.tar.gz', 'hbase-1.3.1-bin.tar.gz',
                  false, true, true];
var APACHE_29X = ['Apache Hadoop 2.9.x', '', 2,
                  'hadoop-2.9.0.tar.gz', 'zookeeper-3.4.11.tar.gz', 'hbase-1.3.1-bin.tar.gz',
                  false, true, true];
var CLOUDERA_CDH47X = ['Cloudera CDH 4.7.x', 'based on Hadoop 2.0.0', 2,
                       'hadoop-2.0.0-cdh4.7.1.tar.gz', 'zookeeper-3.4.5-cdh4.7.1.tar.gz', 'hbase-0.94.15-cdh4.7.1.tar.gz',
                       false, false, false];
var CLOUDERA_CDH59X = ['Cloudera CDH 5.9.x', 'based on Hadoop 2.6.0', 2,
                       'hadoop-2.6.0-cdh5.9.3.tar.gz', 'zookeeper-3.4.5-cdh5.9.3.tar.gz', 'hbase-1.2.0-cdh5.9.3.tar.gz',
                       false, true, true];
var CLOUDERA_CDH510X = ['Cloudera CDH 5.10.x', 'based on Hadoop 2.6.0', 2,
                        'hadoop-2.6.0-cdh5.10.2.tar.gz', 'zookeeper-3.4.5-cdh5.10.2.tar.gz', 'hbase-1.2.0-cdh5.10.2.tar.gz',
                       false, true, true];
var CLOUDERA_CDH511X = ['Cloudera CDH 5.11.x', 'based on Hadoop 2.6.0', 2,
                        'hadoop-2.6.0-cdh5.11.2.tar.gz', 'zookeeper-3.4.5-cdh5.11.2.tar.gz', 'hbase-1.2.0-cdh5.11.2.tar.gz',
                        false, true, true];
var CLOUDERA_CDH512X = ['Cloudera CDH 5.12.x', 'based on Hadoop 2.6.0', 2,
                        'hadoop-2.6.0-cdh5.12.1.tar.gz', 'zookeeper-3.4.5-cdh5.12.1.tar.gz', 'hbase-1.2.0-cdh5.12.1.tar.gz',
                        false, true, true];
var CLOUDERA_CDH513X = ['Cloudera CDH 5.13.x', 'based on Hadoop 2.6.0', 2,
                        'hadoop-2.6.0-cdh5.13.1.tar.gz', 'zookeeper-3.4.5-cdh5.13.1.tar.gz', 'hbase-1.2.0-cdh5.13.1.tar.gz',
                        false, true, true];
var HORTON_HDP13X = ['Hortonworks HDP 1.3.x', 'based on Hadoop 1.2.0', 1,
                     'hadoop-1.2.0.1.3.11.0-26.tar.gz', 'zookeeper-3.4.5.1.3.11.0-26.tar.gz', 'hbase-0.94.6.1.3.11.0-26-security.tar.gz',
                     false, false, false];
var HORTON_HDP21X = ['Hortonworks HDP 2.1.x', 'based on Hadoop 2.4.0', 2,
                     'hadoop-2.4.0.2.1.15.0-946.tar.gz', 'zookeeper-3.4.5.2.1.15.0-946.tar.gz', 'hbase-0.98.0.2.1.15.0-946-hadoop2.tar.gz',
                     false, true, false];
var HORTON_HDP22X = ['Hortonworks HDP 2.2.x', 'based on Hadoop 2.6.0', 2,
                     'hadoop-2.6.0.2.2.9.0-3393.tar.gz', 'zookeeper-3.4.6.2.2.9.0-3393.tar.gz', 'hbase-0.98.4.2.2.9.0-3393-hadoop2.tar.gz',
                     false, true, true];
var HORTON_HDP23X = ['Hortonworks HDP 2.3.x', 'based on Hadoop 2.7.1', 2,
                     'hadoop-2.7.1.2.3.6.0-3796.tar.gz', 'zookeeper-3.4.6.2.3.6.0-3796.tar.gz', 'hbase-1.1.2.2.3.6.0-3796.tar.gz',
                     false, true, true];
var HORTON_HDP24X = ['Hortonworks HDP 2.4.x', 'based on Hadoop 2.7.1', 2,
                     'hadoop-2.7.1.2.4.3.0-227.tar.gz', 'zookeeper-3.4.6.2.4.3.0-227.tar.gz', 'hbase-1.1.2.2.4.3.0-227.tar.gz',
                     false, true, true];
var HORTON_HDP25X = ['Hortonworks HDP 2.5.x', 'based on Hadoop 2.7.3', 2,
                     'hadoop-2.7.3.2.5.6.0-40.tar.gz', 'zookeeper-3.4.6.2.5.6.0-40.tar.gz', 'hbase-1.1.2.2.5.6.0-40.tar.gz',
                     false, true, true];
var HORTON_HDP26X = ['Hortonworks HDP 2.6.x', 'based on Hadoop 2.7.3', 2,
                     'hadoop-2.7.3.2.6.3.0-235.tar.gz', 'zookeeper-3.4.6.2.6.3.0-235.tar.gz', 'hbase-1.1.2.2.6.3.0-235.tar.gz',
                     false, true, true];
var PIVOTAL_PHD210 = ['Pivotal HD 2.1.0', 'based on Hadoop 2.2.0', 2,
                      'PHD-2.1.0.0-175.tar.gz', '', '',
                      false, false, false];
var PIVOTAL_PHD30X = ['Pivotal HD 3.0.x', 'based on Hadoop 2.6.0', 2,
                      'PHD-3.0.1.0-1-centos6.tar.gz', '', '',
                      false, true, false];

var SUPPORTED_DISTROS = [APACHE_121, APACHE_27X, APACHE_29X, CLOUDERA_CDH47X, CLOUDERA_CDH59X, CLOUDERA_CDH510X, CLOUDERA_CDH511X, CLOUDERA_CDH512X, CLOUDERA_CDH513X, HORTON_HDP13X, HORTON_HDP21X, HORTON_HDP22X, HORTON_HDP23X, HORTON_HDP24X, HORTON_HDP25X, HORTON_HDP26X, PIVOTAL_PHD210, PIVOTAL_PHD30X];
var CM_LOCAL_PREFIX = '/cm/local/apps/hadoop/';
var APACHE_27X_INDEX = 1;

var APACHE_27X_HBASE_WARN = 'Apache Hadoop 2.7.x needs HBase release 1.0.0 or higher to work correctly.';
var HBASE_100_WARN = 'Starting with HBase 1.0.0, HBase Master embeds a RegionServer. The same host cannot be used for both Master and RegionServer services.';
var NEWEST_SPARK_STANDALONE = 'spark-2.2.1-bin-hadoop2.7.tgz'
var ZOOKEEPER_FOR_NEWEST_SPARK_STANDALONE = 'zookeeper-3.4.11.tar.gz'
var NEWEST_CASSANDRA = 'apache-cassandra-3.11.1-bin.tar.gz'
var NEWEST_JOLOKIA_FOR_CASSANDRA = 'jolokia-jvm-1.3.7-agent.jar'
