/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh head node folder networks" + ' - ' + document.documentURI);

  var nodes = current.find("MasterNode");
  var all = new Array();
  var n = 0;
  for(var i = 0; i < nodes.length; i++) {
    var interfaces = nodes[i].get('networks');
    for(var j = 0; j < interfaces.length; j++) {
      if(all.find(interfaces[j].name) < 0) all.push(interfaces[j].name);
    }
  }
  all.sort();

  var cols = document.getElementById('cols');
  while(cols.childNodes.length > 1) cols.removeChild(cols.lastChild);
  for(var i = 0; i < all.length; i++) {
    var spl = document.createElement('splitter');
    spl.setAttribute('class',"tree-splitter");
    cols.appendChild(spl);
    var col = document.createElement('treecol');
    col.setAttribute('flex',"1");
    col.setAttribute('id',"network_" + all[i]);
    col.setAttribute('label',"Network (" + all[i] + ")");
    col.setAttribute('class',"generictreecol");
    col.setAttribute('onclick',"sort(this);");
    col.setAttribute('sortActive',true);
    col.setAttribute('sortDirection',"ascending");
    cols.appendChild(col);
    var spl = document.createElement('splitter');
    spl.setAttribute('class',"tree-splitter");
    cols.appendChild(spl);
    var col = document.createElement('treecol');
    col.setAttribute('flex',"1");
    col.setAttribute('id',"ip_" + all[i]);
    col.setAttribute('label',"IP (" + all[i] + ")");
    col.setAttribute('class',"generictreecol");
    col.setAttribute('onclick',"sort(this);");
    col.setAttribute('sortActive',true);
    col.setAttribute('sortDirection',"ascending");
    cols.appendChild(col);
  }

  tree = document.getElementById('tree');
  data = new Array();
  var list = new Array();
  for(j = 0; j < all.length; j++) list.push(0);
  for(var i = 0; i < nodes.length; i++) {
    var interfaces = nodes[i].get('networks');
    for(j = 0; j < all.length; j++) list[j] = ['',''];
    for(var j = 0; j < interfaces.length; j++) {
      if(interfaces[j].network) {
        var index = all.find(interfaces[j].name);
        var network = current.find(interfaces[j].network);
        if(network) list[index] = [network.resolveName(), interfaces[j].ip];
      }
    }
    var item = new Object();
    item['hostname'] = nodes[i].get('hostname');
    for(j = 0; j < all.length; j++) {
      item["network_" + all[j]] = list[j][0];
      item["ip_" + all[j]] = list[j][1];
    }
    data.push(item);
  }
  for(var i = data.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  loadTable();
  dock.addHistory('Head Node network overview refreshed');
}

function editObject() {
  var cluster = current;
  if(!!current.cluster) cluster = current.cluster;
  var select = getSelected();
  if(select.length == 0) {
    dock.displayError('Please select a ' + singular);
  } else if(select.length > 1) {
    dock.displayError('Please select only one ' + singular);
  } else {
    cluster.select(select[0], 'network');
  }
}
