/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var timer = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh head node folder status" + ' - ' + document.documentURI);

  var nodes = current.allKeys('MasterNode');
  dock.workerpool.getWorker(current.actualurl).call('cmgui', 'getNodeStatus', [nodes], function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(status) {
  var nodes = current.allKeys('MasterNode');
  tree = document.getElementById('tree');
  data = new Array();
  for(var i = 0; i < nodes.length; i++) {
    data.push(oneTreeItem(current.find(nodes[i]), status[i]));
  }
//   for(var i = status.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
  dock.addHistory('Head Node status refreshed');

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('refresh();', dock.generalSettings.statusRefresh * 1000);
}

function stop() {
  if(timer) window.clearTimeout(timer);
  timer = 0;
}

function oneTreeItem(one, state) {
  var item = new Object();
  item['key'] = one.get('uniqueKey');
  item['image.src'] = "chrome://cmgui/content/icons/Node-" + one.stateString() + "_16.png"
  item['hostname'] = one.get('hostname');
  item['state'] = one.fullStateString();
  item['uptime'] = formatDays(state.uptime);
  if(kisNaN(state.usageUser)) {
    item['usage'] = "Undefined";
  } else {
    item['usage'] = sprintf("%.1f", 100 * state.usageUser) + "% user, " + sprintf("%.1f", 100 * state.usageSystem) + "% system, " + sprintf("%.1f", 100 * state.usageIdle) + "% idle";
  }
  item['loadaverage'] = state.load1 + ", " + state.load5 + ", " + state.load15;
  item['memory'] = formatKMGselect(state.memoryUsed, 'B');
  item['swap'] = formatKMGselect(state.swapUsed, 'B');
  return item;
}

