/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh head node settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  text('hostname', dock.REGEX_HOSTNAME, '', true);
  text('tag');
  partial('mac', ':', '^[0-9a-fA-F]{2}$', '', true, '00:00:00:00:00:00', 0, '6..21', '00');

  rackPostionSettings();

  var list = ['none', 'apc', 'ipmi0', 'ilo0', 'drac0', 'custom', 'cloud'];
  if(current.cluster.isUCS()) list.push('cimc0');
  var networks = current.get('networks');
  for(var i = 0; i < networks.length; i++) {
    var name = networks[i].name;
    if((list.find(name) < 0) && (startswith(name, 'ipmi') || startswith(name, 'ilo') || startswith(name, 'cimc') || startswith(name, 'drac'))) {
      list.push(name);
    }    
  }
  var pwctl = current.get('powerControl');
  if((list.find(pwctl) < 0) && (startswith(pwctl, 'ipmi') || startswith(pwctl, 'ilo') || startswith(pwctl, 'cimc') || startswith(pwctl, 'drac'))) {
    list.push(pwctl);
  }
  list.sort();
  kenum('powerControl', list);
  text('customPowerScript');
  text('customPowerScriptArgument');
  text('customPingScript');
  text('customPingScriptArgument');
  text('customRemoteConsoleScript');
  text('customRemoteConsoleScriptArgument');
  text('userdefined1');
  text('userdefined2');
  text('revision');
  text('pxelabel');
  text('cpuspeedGovernor', '^[a-z]*$');
  createApc();

  resolve('ethernetSwitch', 'EthernetSwitch', 'ethernetSwitch', true);
  number('ethernetSwitch', dock.MINSWITCHPORTS, dock.MAXSWITCHPORTS, '', dock.BLACKSWITCHPORTS, 'prt');
}
