/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var cluster;
var current;
var dock;
var waitCount = 0;

function onLoad() {
  dock = getDock();
  println("Check now initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  current = cluster.find(myDialog.arguments.current);

  document.getElementById('ok').focus();
  refresh();

}

function refresh() {
  waitIcon();
  var mpi = current.cluster.allChecksMetricsAsMetricPrmId(current.get('uniqueKey'));
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmmon', 'getLatestPickedRates', [[current.get('uniqueKey')], mpi], function(code, data) {
      if(code == 0) {
        updateHealth(data, true, this.current.get('hostname'));
      } else {
        dock.jsonCallError(this, code, data);
      }
      unwaitIcon();
    }, current);
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("wait");
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("auto");
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}
