/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;
var timer = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  println(".Refresh: " + document.title + ' - ' + document.documentURI);
  if(!!use) {
    current = use;
  }
  update();
}

function update() {
  if(!current.connected) return;
  dock.workerpool.getWorker(current.actualurl).call('lustre', 'getUsers', [0, 0, false], function(code, data) {
    if ( data.errorMessage && ! blank(data.errorMessage) ) {
      current.lustreErrorCache(data.errorMessage);
    }
    if(code == 0) {
      setCallbackResult(data.users);
    } else {
      dock.jsonCallError(this, code, data.errorMessage);
    }
  }, current);
}

function setCallbackResult(value) {
  overview = value;
  if(overview == null) return;
  var list = document.getElementById('users');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);

  for(var j = 0; j < overview.length; j++) {
    list.appendChild(userRow(overview[j]), j);
  }
  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 1000);
}

function userRow(user, j) {
  var row = document.createElement('row');
  row.setAttribute("class", "staticdatarow");
  row.setAttribute("flex", "1");
  row.setAttribute("align", "center");
  row.setAttribute("height", "19px");
  if(j % 2 == 1) row.setAttribute("style", "background-color: #e3e3e3;");

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", user.id);
  label.setAttribute("ondblclick", "showServerDetails();");
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", user.username); 
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", user.fullName);
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", user.email);
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", user.groupsNames);
  row.appendChild(label);

  return row;
}
