/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;
var timer = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  println(".Refresh: " + document.title + ' - ' + document.documentURI);
  if(!!use) {
    current = use;
  }
  update();
}

function update() {
  if(!current.connected) return;
  dock.workerpool.getWorker(current.actualurl).call('lustre', 'getVolumes', [0, 0, false], function(code, data) {
    if ( data.errorMessage && ! blank(data.errorMessage) ) {
      current.lustreErrorCache(data.errorMessage);
    }
    if(code == 0) {
      setCallbackResult(data.volumes);
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, current);
}

function setCallbackResult(value) {
  overview = value;
  if(overview == null) return;
  
  var list = document.getElementById('volumes');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);

  for(var j = 0; j < overview.length; j++) {
    list.appendChild(volumeRow(overview[j], j));
  }
  
  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('update();', dock.generalSettings.statusRefresh * 1000);
  
}

function volumeRow(volume, j) {
  var volumenodes = "";
  var vl = volume.volumeNodes;
  for ( var k = 0; k < vl.length; k++  ) {
    volumenodes = volumenodes + " " + vl[k].hostLabel;
  }

  var row = document.createElement('row');
  row.setAttribute("class", "staticdatarow");
  row.setAttribute("flex", "1");
  row.setAttribute("align", "center");
  row.setAttribute("height", "19px");
  if(j % 2 == 1) row.setAttribute("style", "background-color: #e3e3e3;");

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", volume.label);
  label.setAttribute("ondblclick", "showServerDetails();");
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", volume.kind); 
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", volume.status);
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", volume.filesystemType);
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", formatKMGselect(volume.size, 'B'));
  row.appendChild(label);

  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", volumenodes);
  row.appendChild(label);
  
  return row;
}
