/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function initHadoopOverview(file) {
  var data = '\n\
Tab: DFS datanodes\n\
Size: 2x2\n\
Graph: DFS blocks\n\
$name_datanode_BlocksRead, sum, line\n\
$name_datanode_BlocksRemoved, sum, line\n\
$name_datanode_BlocksReplicated, sum, line\n\
$name_datanode_BlocksVerified, sum, line\n\
$name_datanode_BlocksWritten, sum, line\n\
\n\
Graph: DFS I/O\n\
$name_datanode_BytesRead, sum\n\
$name_datanode_BytesWritten, sum\n\
\n\
Graph: DFS timings(1)\n\
$name_datanode_ReadBlockOpAvgTime, min, line\n\
$name_datanode_ReadBlockOpAvgTime, avg, line\n\
$name_datanode_ReadBlockOpAvgTime, max, line\n\
$name_datanode_WriteBlockOpAvgTime, min, line\n\
$name_datanode_WriteBlockOpAvgTime, avg, line\n\
$name_datanode_WriteBlockOpAvgTime, max, line\n\
\n\
Graph: DFS timings(2)\n\
$name_datanode_HeartbeatsAvgTime, whisker\n\
\n\
Tab: DFS file system\n\
Size: 2x2\n\
Graph: FS blocks\n\
$name_namenode_MissingBlocks, sum, line\n\
$name_namenode_ExcessBlocks, sum, line\n\
$name_namenode_CurruptBlocks, sum, line\n\
$name_namenode_BlocksVerified, sum, line\n\
$name_namenode_PendingReplicationBlocks, sum, line\n\
$name_namenode_BlocksTotal, sum, line\n\
\n\
Graph: FS files\n\
$name_namenode_FilesTotal, sum\n\
\n\
Graph: FS replication\n\
$name_namenode_PendingDeletionBlocks, sum, line\n\
$name_namenode_ExcessBlocks, sum, line\n\
$name_namenode_CurruptBlocks, sum, line\n\
$name_namenode_BlocksVerified, sum, line\n\
$name_namenode_BlocksTotal, sum, line\n\
\n\
Graph: FS transactions\n\
$name_namenode_TransactionsBatchedInSync, sum, line\n\
$name_namenode_TransactionsNumOps, sum, line\n\
$name_namenode_TransactionsSinceLastCheckpoint, sum, line\n\
$name_namenode_TransactionsSinceLastLogRoll, sum, line\n\
\n\
Tab: Hadoop summary\n\
Size: 2x2\n\
Graph: Logs\n\
$name_namenode_LogError, sum, line\n\
$name_namenode_LogFatal, sum, line\n\
$name_namenode_LogWarn, sum, line\n\
\n\
Graph: JVM memory\n\
$name_namenode_MemNonHeapUsed, sum\n\
$name_namenode_MemHeapUsed, sum\n\
\n\
Graph: DFS I/O\n\
$name_datanode_BlocksRead, sum, line\n\
$name_datanode_BlocksRemoved, sum, line\n\
Graph: Jobs\n\
$name_resourcemanager_AppsSubmitted, sum\n\
$name_resourcemanager_AppsRunning, sum\n\
\n\
Tab: RPC operations\n\
Size: 2x2\n\
Graph: Block operations\n\
$name_namenode_BlockReportNumOps, sum\n\
$name_namenode_BlockReceivedAndDeletedNumOps, sum\n\
$name_namenode_AddBlockNumOps, sum\n\
\n\
Graph: Heartbeat operations\n\
$name_datanode_HeartbeatsNumOps, sum\n\
$name_nodemanager_HeartbeatsNumOps, sum\n\
\n\
Graph: Job operations\n\
$name_resourcemanager_SubmitApplicationNumOps, sum\n\
$name_resourcemanager_RegisterApplicationMasterNumOps, sum\n\
\n\
Graph: FS operations\n\
$name_namenode_MkdirsNumOps, sum, line\n\
$name_namenode_RenameNumOps, sum, line\n\
$name_namenode_DeleteNumOps, sum, line\n\
$name_namenode_CreateNumOps, sum, line\n\
\n\
Tab: RPC time\n\
Size: 2x2\n\
Graph: Blocks average time\n\
$name_namenode_BlockReceivedAndDeletedAvgTime, sum, line\n\
$name_namenode_AddBlockAvgTime, sum, line\n\
$name_namenode_BlockReportAvgTime, sum, line\n\
\n\
Graph: Heartbeat average time\n\
$name_datanode_HeartbeatsAvgTime, sum, line\n\
$name_nodemanager_HeartbeatsAvgTime, sum, line\n\
$name_resourcemanager_HeartbeatsAvgTime, sum, line\n\
\n\
Graph: Job average times\n\
$name_resourcemanager_RegisterApplicationMasterAvgTime, sum, line\n\
$name_resourcemanager_SubmitApplicationAvgTime, sum, line\n\
\n\
Graph: FS replication\n\
$name_namenode_MkdirsAvgTime, sum, line\n\
$name_namenode_RenameAvgTime, sum, line\n\
$name_namenode_DeleteAvgTime, sum, line\n\
$name_namenode_CreateAvgTime, sum, line\n\
\n\
Tab: Yarn queue\n\
Size: 2x2\n\
Graph: Applications\n\
$name_resourcemanager_ActiveApplications, sum, line\n\
$name_resourcemanager_AppsCompleted, sum, line\n\
$name_resourcemanager_AppsRunning, sum, line\n\
$name_resourcemanager_AppsPending, sum, line\n\
$name_resourcemanager_AppsSubmitted, sum, line\n\
\n\
Graph: Containers\n\
$name_nodemanager_ContainersRunning, sum, line\n\
$name_nodemanager_ContainersIniting, sum, line\n\
$name_nodemanager_ContainersKilled, sum, line\n\
$name_nodemanager_ContainersCompleted, sum, line\n\
$name_nodemanager_ContainersLaunched, sum, line\n\
$name_nodemanager_AllocatedContainers, sum, line\n\
\n\
Graph: Applications by duration\n\
$name_resourcemanager_Running_0, sum, line\n\
$name_resourcemanager_Running_1440, sum, line\n\
$name_resourcemanager_Running_300, sum, line\n\
$name_resourcemanager_Running_60, sum, line\n\
\n\
Graph: Queue containers\n\
$name_resourcemanager_AggregateContainersAllocated, sum, line\n\
$name_resourcemanager_PendingContainers, sum, line\n\
$name_resourcemanager_AggregateContainersReleased, sum, line\n\
\n\
NodeTab: $hostname\n\
Size: 2x2\n\
Graph: Blocks\n\
$name_datanode_BlocksRead, line\n\
$name_datanode_BlocksRemoved, line\n\
$name_datanode_BlocksReplicated, line\n\
$name_datanode_BlocksVerified, line\n\
$name_datanode_BlocksWritten, line\n\
\n\
Graph: DFS timings(1)\n\
$name_datanode_ReadBlockOpAvgTime, line\n\
$name_datanode_WriteBlockOpAvgTime, line\n\
\n\
Graph: DFS timings(2)\n\
$name_datanode_RpcProcessingTimeAvgTime, line\n\
$name_datanode_RpcQueueTimeAvgTime, line\n\
\n\
Graph: Threads\n\
$name_datanode_ThreadsNew, line\n\
$name_datanode_ThreadsBlocked, line\n\
$name_datanode_ThreadsWaiting, line\n\
\n\
#Open node tab by default for\
#node: node001\n\
#node: node002\n\
\n\
';
  return savefile(file, data);
}
