/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var cluster;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  cluster = current.cluster;
  old = current.old(false, true);
  refresh();
}

function refresh() {
  stringlist('etcdEndpoints', '');
  text('etcdPrefix');
  resolve('network', 'Network', '', true, '', function(network) {
    return network.object.name == "globalnet";
  });
  text('subnetlen', '^[0-9]+$');
  text('subnetmin');
  text('subnetmax');

  var networkingbackends = current.get('networkingbackends');
  displayNetworkingBackends(networkingbackends);
}

function displayNetworkingBackends(networkingbackends) {
  var rows = document.getElementById('networkingbackends');
  if(!rows) {
    println('No rows for ' + networkingbackends.childType);
    return;
  }
  //There always must be one networking backend.
  if (networkingbackends.length != 1) {
    println('Error, flannel role has invalid number of networking backends '
        + '(must have exactly one).');
    return;
  }

  while(rows.firstChild) rows.removeChild(rows.firstChild);

  var row = document.createElement('row');
  row.setAttribute('align', 'center');
  var textbox = document.createElement('textbox');
  textbox.setAttribute('id', networkingbackends[0].childType + '_name');
  textbox.setAttribute('type', 'text');
  textbox.setAttribute('width', '165px');
  textbox.setAttribute('readonly', 'true');
  textbox.setAttribute('value', networkingbackends[0].name);
  row.appendChild(textbox);

  var hbox = document.createElement('vbox');
  hbox.setAttribute('flex', 1);
  var button = document.createElement('button');
  button.setAttribute('class', 'graybutton');
  button.setAttribute('label', 'Modify');
  button.setAttribute('oncommand', 'editNetworkingBackend();');
  hbox.appendChild(button);
  row.appendChild(hbox);

  rows.appendChild(row);
}

function editNetworkingBackend() {
  var networkingbackends = current.get('networkingbackends');
  var editfile = 'advancedflannelconfigurationnetworkingbackend.xul';
  var args = new Object();
  args['object'] = object;
  args['subobject'] = current;
  args['cluster'] = cluster;
  args['networkingbackend'] = networkingbackends[0];
  args['parent'] = this;
  var d = new dock.cvDialog(editfile, args);
  d.onOk = function() {
    refresh(false);
  }
  dock.dialogs.showDialog(d);
}

function ok() {
  if(current.get('modified')) object.set('modified', true);
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}

