/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  old = current.old(false, true);
  refresh();
}

function refresh() {
  partial('insecureBindAddress', '.', dock.REGEX_IPv4_PARTIAL);
  partial('secureBindAddress', '.', dock.REGEX_IPv4_PARTIAL);
  text('EtcdPrefix');
  stringlist('EtcdServers', '');
  resolve('serviceNetwork', 'Network', '', true, '', function(network) {
    return network.object.name == "globalnet";
  });
  check('allowedPrivileged');
  stringlist('admissionControl', '');
  text('eventTtl', '^[0-9]+$');

  check('kubeletHttps');
  text('kubeletTimeout', '^[0-9]+$');

  text('logLevel', '^[0-9]+$');
  check('logToStdErr');
  stringlist('options', '');
  text('apiServerCount', '^[0-9]+$');
}

function ok() {
  if(current.get('modified')) object.set('modified', true);
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}

