/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  old = current.old(false, true);
  refresh();
}

function refresh() {
  partial('address', '.', dock.REGEX_IPv4_PARTIAL);
  partial('clusterDns', '.', dock.REGEX_IPv4_PARTIAL);
  stringlist('apiServers', '');
  text('clusterDomain');

  text('spool');
  text('manifestsPath');
  text('hostnameOverride');
  check('enableServer');
  stringlist('hostNetworkSources', '');

  text('cgroupRoot');
  text('dockerSpool');
  text('dockerEndpoint');
  text('resourceContainer');

  check('allowedPrivileged');
  check('createBridge');
  check('registerOnStart');
  check('runOnce');

  stringlist('labels', '');

  text('logLevel', '^[0-9]+$');
  check('logToStdErr');
  text('oomScoreAdjust', '-?[0-9]+$');
  stringlist('options', '');
}

function ok() {
  if(current.get('modified')) object.set('modified', true);
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}

function editTimeouts() {
  var xulfilename = dock.myVersion + 'kube/kubernetesnodetimeouts.xul';
  var args = new Object();
  args['object'] = current;
  var d = new dock.cvDialog(xulfilename, args);
  dock.dialogs.showDialog(d);
}

