/*
 * Copyright (c) 2004-2016 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var getCurrentFunction = "function(base, key) { " +
                            "var role; " +
                            "var roles = base.get('roles'); " +
                            "for(var i = 0; i < roles.length; i++) { " +
                            "  if(roles[i].uniqueKey == key) {" +
                            "    role = roles[i]; " +
                            "  }" +
                            "}; " +
                            "var cat = ''; " +
                            "if(dock.baseChildTypeCheck(base.object, 'SlaveNode')) {" +
                            "  cat = base.get('category'); " +
                            "}; " +
                            "var obj = document.getElementById('has' + role.childType); " +
                            "if(obj) {" +
                            " return setGenericRole(role, cat, obj); " +
                            "} else { "+
                            "  return ''; " +
                            "} " +
                         "}";

function refresh(use) {
  if(!!use) current = use;
  println("Refresh container roles" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  var checks = document.getElementsByTagName('checkimage');
  for(var i = 0; i < checks.length; i++) {
    checks[i].checked = false;
    var next = checks[i].nextSibling;
    if(next) next.setAttribute('hidden', true);
  }

  clearLabel('KubernetesApiServer');
  clearLabel('KubernetesScheduler');
  clearLabel('KubernetesController');
  clearLabel('KubernetesProxy');
  clearLabel('KubernetesNode');

  clearLabel('DockerHost');
  clearLabel('EtcdHost');
  clearLabel('ContainerdHost');
  clearLabel('FlannelHost');
  clearLabel('FlannelConfiguration');
  clearLabel('CgroupSupervisor');

  var roles = current.get('roles');
  for(var i = 0; i < roles.length; i++) {
    if(!roles[i].toBeRemoved) {
      setRole(roles[i], '');
    }
  }

  if(dock.baseChildTypeCheck(current.object, 'SlaveNode')) {
    var cat = current.get('category');
    if(cat) {
      cat = current.cluster.find(cat);
      if(cat) {
        var catroles = cat.get(subfield);
        cat = cat.resolveName();
        for(var i = 0; i < catroles.length; i++) {
          if(!catroles[i].toBeRemoved) {
            var found = false;
            for(var j = 0; !found && (j < roles.length); j++) {
              if(!roles[j].toBeRemoved) {
                found = (catroles[i].childType == roles[j].childType);
              }
            }
            if(!found) {
              setRole(catroles[i], cat);
            }
          }
        }
      }
    }
  }
}

function setRole(role, category) {
  var obj = document.getElementById('has' + role.childType);
  if(obj) {
    var one = setGenericRole(role, category, obj);
    if(role.childType == 'EtcdHostRole') {
      role_text('memberName', one, category);
    } else if(role.childType == 'CgroupSupervisorRole') {
      role_checkbox('collectMetrics', one, category);
    } else if(role.childType == 'DockerHostRole') {
      role_enum('logLevel', one, ['', 'debug', 'info', 'warn', 'error', 'fatal'], category);
    } else if(role.childType == 'KubernetesProxyRole') {
      var old = current;
      current = one; // for resolve()
      resolve('kubernetesCluster_' + 'proxy', 'KubeCluster', '', false);
      current = old;
    } else if(role.childType == 'KubernetesNodeRole') {
      var old = current;
      current = one; // for resolve()
      resolve('kubernetesCluster_' + 'node', 'KubeCluster', '', false, '', false, false, getCurrentFunction);
      current = old;
    } else if(role.childType == 'KubernetesControllerRole') {
      var old = current;
      current = one; // for resolve()
      resolve('kubernetesCluster_' + 'controller', 'KubeCluster', '', false, '', false, false, getCurrentFunction);
      current = old;
    } else if(role.childType == 'KubernetesSchedulerRole') {
      var old = current;
      current = one; // for resolve()
      resolve('kubernetesCluster_' + 'scheduler', 'KubeCluster', '', false, '', false, false, getCurrentFunction);
      current = old;
    } else if(role.childType == 'KubernetesApiServerRole') {
      var old = current;
      current = one; // for resolve()
      resolve('kubernetesCluster_' + 'apiserver', 'KubeCluster', '', false, '', false, false, getCurrentFunction);
      current = old;
    } else if(role.childType == 'ContainerdHostRole') {
      role_enum('runtime', one, ['', 'runc'], category);
    } else if(role.childType == 'FlannelHostRole') {
    } else if(role.childType == 'FlannelConfigurationRole') {
    } else {
      println("Warning unsupported container role: " + role.childType);
    }
  } else {
    println("Warning unknown container role: " + role.childType);
  }
}

