'use strict';

var Context = require('cm-context');
var test  = require('unit.js');
var fs = require("fs");

var dockerManager;

function testSetup() {
  context = new Context(__dirname + '/../docker/');
  dockerManager = context.load('dockerdeployment.js');
}

describe('Device Mapper', function(){
  it('name should be devicemapper', function() {
    testSetup();
    
    var storage_backend = new dockerManager.DeviceMapperStorageBackend();
    test.string(storage_backend.name()).is('devicemapper');
  });

  it('default device should be loopback device', function() {
    testSetup();
    
    var storage_backend = new dockerManager.DeviceMapperStorageBackend();
    test.object(storage_backend.device).hasProperty('data_size');
    test.object(storage_backend.device).hasProperty('metadata_size');
  });

  it('set blockdevice should be ok', function() {
    testSetup();
    
    var storage_backend = new dockerManager.DeviceMapperStorageBackend();
    storage_backend.device = new dockerManager.DeviceMapperBlockDevice('/dev/sda');

    test.object(storage_backend.device).hasProperty('data_device');
    test.string(storage_backend.device.data_device).is('/dev/sda');
  });
});
