/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var HEADER = 80;

function isundefined(x, def) {
  return (typeof(x) == 'undefined') ? def : x;
}

/* test if a variable is an array */
function isArray(obj) {
  if((typeof obj) == "undefined") return false;
  if(! !!obj) return false;
  return (obj.constructor.toString().indexOf("function Array") == 0);
}

/* test if a variable is an array */
function isObject(obj) {
  return ((typeof obj) == "object");
}

/* test if a variable is an array */
function isFunction(obj) {
  if((typeof obj) == "undefined") return false;
  return (obj.constructor.toString().indexOf("function Function") == 0);
}

/* Log to java-console */
function loginfo(str) {
  Components.classes['@mozilla.org/consoleservice;1']
            .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(str);
}

function logerror(str) {
  Components.classes['@mozilla.org/consoleservice;1']
            .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(str);
  dump(str);
}

function logdebug(str) {
  dump(str);
}

function header(txt, len, char) {
  txt = isundefined(txt, "");
  len = isundefined(len, HEADER);
  char = isundefined(char, '=');
  if(txt.length == 0) {
    for(var k = 0; k < len; k++) {
      print(char);
    }
  } else {
    var l = txt.length + 2;
    if(len < l) {
      l = len;
    }
    for(var k = 0; k < (len - 1 - l) / 2; k++) {
      print(char);
    }
    print(" " + txt + " ");
    for(var k = 0; k < (len - l) / 2; k++) {
      print(char);
    }
  }
  print("\n");
}

function headertext(txt, len, char) {
  var text = '';
  txt = isundefined(txt, "");
  len = isundefined(len, HEADER);
  char = isundefined(char, '=');
  if(txt.length == 0) {
    for(var k = 0; k < len; k++) {
      text += char;
    }
  } else {
    var l = txt.length + 2;
    if(len < l) {
      l = len;
    }
    for(var k = 0; k < (len - 1 - l) / 2; k++) {
      text += char;
    }
    text += (" " + txt + " ");
    for(var k = 0; k < (len - l) / 2; k++) {
      text += char;
    }
  }
  return text + "\n";
}

function printallR(obj, isObject) {
  printall(obj, isObject, true, 0);
}

function printall(obj, isObject, recursive, level) {
  isObject = isundefined(isObject, false);
  recursive = isundefined(recursive, false);
  level = isundefined(level, 0);
  var prefix = '';
  for(var k = 0; k < level; k++) { 
    prefix += "  + "; 
  }
  if(!isObject && isArray(obj)) {
    for(var i = 0; i < obj.length; i++) {
      var t = i.toString();
      print(prefix + t + " ");
      for(var k = 0; k < (8 - t.length); k++) { print("."); }
      if(recursive && typeof(obj) == "object") {
        print("\n");
        printall(obj[i], isObject, recursive, level+1);
      } else {
        println(obj[i]);
      }
    }
  } else if(typeof(obj) == "undefined") {
    println(obj);
  } else if(obj == null) {
    println("obj == null");
  } else if(isObject || (typeof(obj) == "object")) {
    var name = obj.toString();
    print(prefix);
    header(name);
    for(var i in obj) {
      try {
        var t = i.toString();
        print(prefix + t + " ");
        for(var k = 0; k < (20 - t.length); k++) { print("."); }
        print(" = ");
        t = typeof(obj[i]);
        if(t == "function") {
          println(t);
        } else {
          println(obj[i]);
        }
      } catch(e) {
        println("Error: " + i);
      }
    }
    print(prefix);
    header();
  } else {
    println(obj);
  }
}

function textall(obj) {
  var text = "";
  if(isArray(obj)) {
    for(var i = 0; i < obj.length; i++) {
      var t = i.toString();
      text += (t + " ");
      for(var k = 0; k < (8 - t.length); k++) { print("."); }
      text += obj[i].toString() + "\n";
    }
  } else if(typeof(obj) == "undefined") {
    text += obj.toString() + "\n";
  } else if(obj == null) {
    text += "obj == null\n";
  } else if(typeof(obj) == "object") {
    var name = obj.toString();
    text += headertext(name);
    for(var i in obj) {
      try {
        var t = i.toString();
        text += (t + " ");
        for(var k = 0; k < (20 - t.length); k++) { text += "."; }
        text += " = ";
        t = typeof(obj[i]);
        if(t == "function") {
          text += t.toString() + "\n";
        } else {
          text += obj[i].toString() + "\n";
        }
      } catch(e) {
        text += "Error: " + i.toString() + "\n";
      }
    }
    text += headertext();
  } else {
    text += obj.toString() + "\n";
  }
  return text;
}

function printprop(obj) {
  if(typeof(obj) == "object") {
    var name = obj.toString();
    header(name);
    for(var i in obj) {
      try {
        var t = i.toString();
        print(t + " ");
        for(var k = 0; k < (22 - t.length); k++) { print("."); }
        print(" ");
        t = typeof(obj[i]);
        if(t == "object") {
          println(obj[i].toString());
        } else {
          println(t);
        }
      } catch(e) {
        println("Error: " + i);
      }
    }
    header();
  } else {
    println("Not an object");
  }
}

function arrayLen(a, name) {
  if(isArray(a)) {
    println(name + ".length = " + a.length);
    for(var i = 0; i < a.length; i++) {
      arrayLen(a[i], name + '[' + i + ']');
    }
  }
}

function printf(s) {
  dump(s);
  dump("\n")
}

function println(s) {
  dump(s);
  dump("\n")
}

function print(s) {
  dump(s);
}

function stackTrace() {
  try {
    some.thing.that.wont.work++;
  } catch(e) {
    printall(e.stack);
  }
}
