/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var bookmarks;
var myDialog;
var names;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  bookmarks = myDialog.arguments.bookmarks;

  refresh();
}

function refresh() {
  tree = document.getElementById('tree');
  data = new Array();
  names = new Array();
  for(var i = 0; i < bookmarks.length; i++) {
    var a = bookmarks[i].split('@');
    if((bookmarks[i].length > 0) && (a.length == 2) && (a[0] != '#')) {
      data.push(createTreeItem(a[1]));
      names.push(a[1]);
    }
  }

  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(name) {
  var item = new Object();
  item['key'] = name;
  item['name'] = name;
  return item;
}

function saveClose() {
  myDialog.onOk(bookmarks);
  close();
}

function remove() {
  var select = bookmarkIndexes(selected('list'));
  for(var i = 0; i < select.length; i++) {
    if(select[i] < bookmarks.length) {
      bookmarks.splice(select[i], 1);
      for(var j = i + 1; j < select.length; j++) {
        if(select[j] > select[i]) select[j]--;
      }
    }
  }
  refresh();
}

function bookmarkIndexes(list) {
  var r = new Array();
  for(var i = 0; i < list.length; i++) {
    r.push(names.find(list[i]));
  }
  return r;
}

function moveup() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('No bookmark selected', window);
  } else {
    var list = bookmarks;
    var index = bookmarkIndexes(select);
    if(index.length == 0) {
      dock.displayError('One or more selected items were not found', window);
    } else {
      var j = 0;
      while((j < index.length) && (index[j] == j)) j++;
      for(var i = 1; (j < index.length) && (i < list.length); i++) {
        if(index[j] == i) {
          var t = list[i - 1];
          list[i - 1] = list[i];
          list[i] = t;
          j++;
        }
      }
      bookmarks = list;
    }
  }
  refresh();
}

function movetop() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('No bookmark selected', window);
  } else {
    var list = bookmarks;
    var index = bookmarkIndexes(select);
    if(index.length == 0) {
      dock.displayError('One or more selected items were not found', window);
    } else {
      var j = 0;
      for(var i = index.length - 1; i >= 0; i--) {
        var t = list.splice(j + index[i], 1)[0];
        list.unshift(t);
        j++;
      }
      bookmarks = list;
    }
  }
  refresh();
}

function movedown() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('No bookmark selected', window);
  } else {
    var list = bookmarks;
    var index = bookmarkIndexes(select);
    if(index.length == 0) {
      dock.displayError('One or more selected items were not found', window);
    } else {
      var j = index.length - 1;
      while((j >= 0) && (index[j] == (list.length + j - index.length))) j--;
      for(var i = list.length - 2; (j >= 0) && (i >= 0); i--) {
        if(index[j] == i) {
          var t = list[i + 1];
          list[i + 1] = list[i];
          list[i] = t;
          j--;
        }
      }
      bookmarks = list;
    }
  }
  refresh();
}

function movebottom() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError('No bookmark selected', window);
  } else {
    var list = bookmarks;
    var index = bookmarkIndexes(select);
    if(index.length == 0) {
      dock.displayError('One or more selected items were not found', window);
    } else {
      var j = 0;
      for(var i = 0; i < index.length; i++) {
        var t = list.splice(index[i] - j, 1)[0];
        list.push(t);
        j++;
      }
      bookmarks = list;
    }
  }
  refresh();
}

