/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var MAX_WIDTH = 64;
var MAX_HEIGHT = 64;

var dock;
var myDialog;
var current;
var cgroup = false;

var fieldname = false;
var displayInTree = true;

var subtype = ['Device', 'NodeGroup'];
var currentnodes;

var waitCount = 0;
var metrics = new Array();

var zoom;
var interval;
var rate;
var legend = 1;

var singular = 'device';
var plural = 'devices';
var belongs = '0';
var noloop = 'true';
var extraName = "''";
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['category', 'category', true],
            ['installmode', 'installMode', false],
            ['rack', 'rack.rack', true],
            ['position', 'rack.position', false]];


function tree_keypress(e) {
  if(e.keyCode == e.DOM_VK_RETURN) {
    var tree = e.target;
    var select = new Array();
    var start = new Object();
    var end = new Object();
    for(var t = 0; t < tree.view.selection.getRangeCount(); t++){
      tree.view.selection.getRangeAt(t,start,end);
      for(var v = start.value; v <= end.value; v++) {
        var item = tree.view.getItemAtIndex(v);
        var data = [item.getAttribute("metric"), item.getAttribute("param"), eval(item.getAttribute("check"))];
        var found = false;
        for(var i = 0; !found && (i < metrics.length); i++) {
          found = (metrics[i][0] == data[0]) && (metrics[i][1] == data[1]);
        }
        if(!found) {
          metrics.push(data);
          updateList();
          return false;
        }
      }
    }
  }
  return true;
}

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  current = myDialog.arguments.cluster;

  interval = dock.generalSettings.intervals;
  rate = dock.generalSettings.monitoringRefresh;
  zoom = [dock.generalSettings.timespan, 0];

  currentnodes = new Array();

  document.getElementById('titlename0').setAttribute('value', current.name);
  document.getElementById('titlename1').setAttribute('value', current.name);
  document.getElementById('titlename2').setAttribute('value', current.name);

  refresh();  
}

function refresh() {
  deviceselect();
}

function refresh1() {
  waitIcon();
  allMetricsAndChecks();
  updateList();
  unwaitIcon();
}

function setTimeType(index) {
  document.getElementById('between').setAttribute('on', index == 0);
  document.getElementById('last').setAttribute('on', index == 1);
}

function setDate(name) {
  var args = new Object();
  var t = document.getElementById(name).getAttribute('time');
  var d = new Date();
  d.setTime(t * 1000);
  args['date'] = d;
  var d = new dock.cvDialog("datepickerwindow.xul", args);
  d.parentWindow = window;
  d.onOk = function(date) {
    document.getElementById(name).setAttribute('value', date.format(DATETIME_FORMAT));
    document.getElementById(name).setAttribute('time', Math.floor(date.getTime() / 1000));
  }
  dock.dialogs.showDialog(d);
}

function refresh2() {
  var intervals = [[0, 'Best'], 10, 25, 50, 100, 200, 500, 1000];
  var rates = [[60, '1 minute'], [120, '2 minutes'], [300, '5 minutes'], [600, '10 minutes'], [1800, '30 minutes'], [3600, '1 hour']];
  var timeList = [[3600, '1 hour'], [43200, '12 hours'], [86400, '1 day'], [259200, '3 days'],
                  [608400, '7 days'], [2678400, '1 month'], [31526000, '1 year'], [94578000, '3 years']];
  var myTime = 3600;

  if(zoom[1] == 0) {
    setTimeType(1);
    var d = new Date();

    datetext('enddate', DATETIME_FORMAT, d);
    myTime = zoom[0];
    d.setTime(d.getTime() - myTime * 1000);
    for(var i = 0; i < timeList.length; i++) {
      if(timeList[i][0] == myTime) break;
      if(timeList[i][0] > myTime) {
        timeList.splice(i, 0, [myTime, formatDHM(myTime)]);
        break;
      }
    }
    datetext('startdate', DATETIME_FORMAT, d);
  } else {
    setTimeType(0);
    var d = new Date();
    d.setTime(zoom[1] * 1000);
    datetext('enddate', DATETIME_FORMAT, d);
    var d = new Date();
    d.setTime(zoom[0] * 1000);
    datetext('startdate', DATETIME_FORMAT, d);
  }
  var popup = document.getElementById('lasttime').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < timeList.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', timeList[i][1]);
    item.setAttribute('time', timeList[i][0]);
    popup.appendChild(item);
    if(timeList[i][0] == myTime) document.getElementById('lasttime').selectedIndex = i;
  }

  for(var i = 0; i < intervals.length; i++) {
    if(timeList[i][0] == interval) break;
    if(timeList[i][0] > interval) {
      timeList.splice(i, 0, interval);
      break;
    }
  }
  var popup = document.getElementById('intervals').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < intervals.length; i++) {
    var item = document.createElement('menuitem');
    var val = intervals[i];
    if(isArray(intervals[i])) {
      item.setAttribute('intervals', intervals[i][0]);
      item.setAttribute('label', intervals[i][1]);
      val = intervals[i][0];
    } else {
      item.setAttribute('label', intervals[i]);
      item.setAttribute('intervals', intervals[i]);
    }
    popup.appendChild(item);
    if(val == interval) document.getElementById('intervals').selectedIndex = i;
  }

  for(var i = 0; i < rates.length; i++) {
    if(rates[i][0] == rate) break;
    if(rates[i][0] > rate) {
      rates.splice(i, 0, [rate, formatDHM(rate)]);
      break;
    }
  }
  var popup = document.getElementById('rate').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < rates.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', rates[i][1]);
    item.setAttribute('time', rates[i][0]);
    popup.appendChild(item);
    if(rates[i][0] == rate) document.getElementById('rate').selectedIndex = i;
  }

  var legends = [[-1, 'None'], [0, 'Top left'], [1, 'Top right'], [2, 'Top right outside'], [3, 'Bottom right outside']];
  var popup = document.getElementById('legend').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < legends.length; i++) {
    var item = document.createElement('menuitem');
    var val = legends[i];
    if(isArray(legends[i])) {
      item.setAttribute('legend', legends[i][0]);
      item.setAttribute('label', legends[i][1]);
      val = legends[i][0];
    } else {
      item.setAttribute('label', legends[i]);
      item.setAttribute('legend', legends[i]);
    }
    popup.appendChild(item);
    if(val == legend) document.getElementById('legend').selectedIndex = i;
  }
}

function cancel() {
  close();
}

function next() {
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);
  switch(index) {
  case(0) :
    if(currentnodes.length == 0) {
      dock.displayError('Select at least one device', window);
      return;
    }
    break;
  case(1) :
    if((metrics.length == 0) || (metrics.length > 4)) {
      dock.displayError('Select between 1 and 4 metrics or healthchecks', window);
      return;
    }
    break;
  }
  index++;
  switch(index) {
  case(1) :
    refresh1();
    break;
  case(2) :
    refresh2();
    break;
  }
  document.getElementById('deck').selectedIndex = index;
  document.getElementById('prev').setAttribute('disabled', index == 0);
  document.getElementById('next').setAttribute('hidden', index == pages);
  document.getElementById('finish').setAttribute('hidden', index < pages);
  document.getElementById('jobfilter').setAttribute('hidden', index > 0);
}

function prev() {
  var pages = document.getElementById('deck').childNodes.length - 1;
  var index = parseInt(document.getElementById('deck').selectedIndex);
  switch(index) {
  case(1) :
  case(2) :
  }
  index--;
  switch(index) {
  case(0) :
    refresh();
  case(1) :
    refresh1();
  }
  document.getElementById('deck').selectedIndex = index;
  document.getElementById('prev').setAttribute('disabled', index == 0);
  document.getElementById('next').setAttribute('hidden', index == pages);
  document.getElementById('finish').setAttribute('hidden', index < pages);
  document.getElementById('jobfilter').setAttribute('hidden', index > 0);
}

function finish() {
  if((metrics.length == 0) || (metrics.length > 4)) {
    dock.displayError('Select between 1 and 4 metrics or healthchecks', window);
    return;
  }

  var finalDevices = new Array();
  for(var i = 0; i < currentnodes.length; i++) {
    var nodes = current.find(currentnodes[i]);
    if(nodes.getType() == 'NodeGroup') {
      nodes = nodes.get('nodes');
    } else {
      nodes = [currentnodes[i]];
    }
    for(var j = 0; j < nodes.length; j++) {
      if(finalDevices.find(nodes[j]) < 0) {
        finalDevices.push(nodes[j]);        
      }
    }
  }  
  
  if(finalDevices.length == 0) {
    if(currentnodes.length == 0) {
      dock.displayError('Select at least one device or group', window);
    } else {
      dock.displayError('Selected group(s) contains no nodes', window);
    }
    return;
  } else if(finalDevices.length > MAX_WIDTH * MAX_HEIGHT) {
    dock.displayError('The maximum number of devices is ' + (MAX_WIDTH * MAX_HEIGHT), window);
    return;
  }
  
  finalDevices = sortKeysByName(finalDevices, current);

  if(eval(document.getElementById('between').getAttribute('on'))) {
    zoom[0] = parseInt(document.getElementById('startdate').getAttribute('time'));
    zoom[1] = parseInt(document.getElementById('enddate').getAttribute('time'));
  } else {
    var item = document.getElementById('lasttime').selectedItem;
    zoom[0] = item.getAttribute('time');
    zoom[1] = 0;
  }

  var item = document.getElementById('rate').selectedItem;
  rate = parseInt(item.getAttribute('time'));
  var item = document.getElementById('intervals').selectedItem;
  interval = parseInt(item.getAttribute('intervals'));
  var item = document.getElementById('legend').selectedItem;
  legend = parseInt(item.getAttribute('legend'));

  var minheight = document.getElementById('minheight').value;
  if(!isNumeric(minheight)) {
    dock.displayError('Minimal graph height needs to be a number between 80 and 512 (pixels)', window);
    return;
  } else {
    minheight = parseInt(minheight);
    if((minheight < 80) || (minheight > 512)) {
      dock.displayError('Minimal graph height needs to be a number between 80 and 512 (pixels)', window);
      return;
    }
  }
  
  var w = document.getElementById('width').value;
  var h = document.getElementById('height').value;
  if(w == '<auto>') {
    if(h == '<auto>') {
      h = Math.min(Math.max(1, Math.ceil(Math.sqrt(finalDevices.length))), MAX_HEIGHT);
      w = Math.max(1, Math.ceil(finalDevices.length / h));
    } else {
      if(isNumeric(h) && (parseInt(h) > 0) && (parseInt(h) <= MAX_HEIGHT)) {
        h = parseInt(h);
        w = Math.ceil(finalDevices.length / h);
        if(w > MAX_WIDTH) {
          dock.displayError('By choosing height so low width is no longer between 1 and ' + MAX_WIDTH, window);
          return;
        }
      } else {
        dock.displayError('Height has to be a positive integer between 1 and ' + MAX_HEIGHT, window);
        return;
      }
    }
  } else {
    if(h == '<auto>') {
      if(isNumeric(w) && (parseInt(w) > 0) && (parseInt(w) <= MAX_WIDTH)) {
        w = parseInt(w);
        h = Math.ceil(finalDevices.length / w);
        if(h > MAX_HEIGHT) {
          dock.displayError('By choosing width so low height is no longer between 1 and ' + MAX_HEIGHT, window);
          return;
        }
      } else {
        dock.displayError('Height has to be a positive integer between 1 and ' + MAX_WIDTH, window);
        return;
      }
    } else {
      if(isNumeric(w) && (parseInt(w) > 0) && (parseInt(w) <= MAX_WIDTH)) {
        w = parseInt(w);
      } else {
        dock.displayError('Height has to be a positive integer between 1 and ' + MAX_WIDTH, window);
        return;
      }
      if(isNumeric(h) && (parseInt(h) > 0) && (parseInt(h) <= MAX_HEIGHT)) {
        h = parseInt(h);
      } else {
        dock.displayError('Height has to be a positive integer between 1 and ' + MAX_HEIGHT, window);
        return;
      }
      if(w * h < finalDevices.length) {
        dock.displayError('Width * height has to be larger than the number of devices (' + finalDevices.length + ')', window);
        return;
      }
    }
  }

  var list = new Array();
  for(var i = 0; i < finalDevices.length; i++) {
    var one = new Array();
    for(var j = 0; j < metrics.length; j++) {
      if(metrics[j][0] > 0) {
        var dmp = new cvGraphDeviceMetric(finalDevices[i], metrics[j][0], metrics[j][1]);
        one.push(dmp);
      }
    }
    list.push(one);
  }
  myDialog.onOk(w, h, list, interval, rate, zoom, minheight, legend);

  close();
}

function allMetricsAndChecks() {
  var cgroupMetrics = 2;
  
  var mmc = current.allMetrics(cgroupMetrics);
  var mmh = current.allChecks(cgroupMetrics);
  
  println(["CGROUPS", cgroupMetrics, cgroup, mmc.length, mmh.length]);
  
  if(cgroupMetrics < 0) {
    mmc = mmc.filter(metricInCGroup, cgroup);
    mmh = mmh.filter(checkInCGroup, cgroup);
  }
  
  println(["FILTER", cgroupMetrics, cgroup, mmc.length, mmh.length]);
  
  if((mmc.length > 0) || (mmh.length > 0)) {
    var men = current.metricEnumName(true, false, cgroupMetrics);
    var metricClass = buildMetricClass('rack', current, men);
    
    for(var j = 0; j < mmc.length; j++) {
      var metric = current.find(mmc[j].metric);
      if(metric) {
        var text = metric.resolveName();
        var mclass = metric.get('metricClass');
        var param = mmc[j].metricParam;
        var translated = mmc[j].translatedMetricParam;
        text += metricParamText(mclass, param, translated, cgroupMetrics);
        if(metric.get('unit')) text += " (" + metric.get('unit') + ")";
        
        var subitem = document.createElement("treeitem");
        subitem.setAttribute("metric", mmc[j].metric);
        subitem.setAttribute("param", mmc[j].metricParam);
        subitem.setAttribute("check", 'false');
        var row = document.createElement("treerow");
        var cell = document.createElement("treecell");
        cell.setAttribute("src", "chrome://cmgui/content/icons/Monitoring_16.png");
        cell.setAttribute("label", " " + text); // space between image and label, css doesn't work
        row.appendChild(cell);
        subitem.appendChild(row);
        mclass = metricClass[mclass];
        if(mclass) {
          var added = false;
          for(var k = 0; k < mclass[2]; k++) {
            var x = mclass[1].childNodes[k].firstChild.firstChild.getAttribute('label').substr(1);
            if(text < x) {
              mclass[1].insertBefore(subitem, mclass[1].childNodes[k]);
              added = true;
              break;
            }
          }
          if(!added) mclass[1].appendChild(subitem);
          mclass[2]++;
        }
      } else {
        println("Metric not found: " + mmc[j].metric);
      }
    }
    for(var j = 0; j < mmh.length; j++) {
      var check = current.find(mmh[j].healthcheck);
      if(check) {
        var text = check.resolveName();
        var mclass = check.get('healthCheckClass');
        var param = mmh[j].healthcheckParam;
        var translated = mmh[j].translatedHealthcheckParam;
        text += metricParamText(mclass, param, translated);
        
        var subitem = document.createElement("treeitem");
        subitem.setAttribute("metric", mmh[j].healthcheck);
        subitem.setAttribute("param", mmh[j].healthcheckParam);
        subitem.setAttribute("check", 'true');
        var row = document.createElement("treerow");
        var cell = document.createElement("treecell");
        cell.setAttribute("src", "chrome://cmgui/content/icons/Health_16.png"); // TODO: Sharif new icon (KDR)
        cell.setAttribute("label", " " + text); // space between image and label, css doesn't work
        row.appendChild(cell);
        subitem.appendChild(row);
        mclass = metricClass[mclass];
        if(mclass) {
          var added = false;
          for(var k = 0; k < mclass[2]; k++) {
            var x = mclass[1].childNodes[k].firstChild.firstChild.getAttribute('label').substr(1);
            if(text < x) {
              mclass[1].insertBefore(subitem, mclass[1].childNodes[k]);
              added = true;
              break;
            }
          }
          if(!added) mclass[1].appendChild(subitem);
          mclass[2]++;
        }
      } else {
        println("health check not found: " + mmh[j].healthcheck);
      }
    }
    var list = document.getElementById('metrics');
    while(list.firstChild) list.removeChild(list.firstChild);
    
    for(var mclass in metricClass) {
      if(metricClass[mclass][2] > 0) {
        list.appendChild(metricClass[mclass][0]);
      }
    }
  }
}

function createMetricType(name) {
  var item = document.createElement("treeitem");
//   item.setAttribute("id", key + "_" + name);
  var row = document.createElement("treerow");
  var cell = document.createElement("treecell");
  cell.setAttribute("src", "chrome://cmgui/content/icons/Category_16.png");
  cell.setAttribute("label", " " + name); // space between image and label, css doesn't work
  row.appendChild(cell);
  item.appendChild(row);
  item.setAttribute("container", "true");
  item.setAttribute("open", "false");
  var child = document.createElement("treechildren");
  item.appendChild(child);
  return [item, child, 0];
}

function removeMetric(index) {
  metrics.splice(index, 1);
  updateList();
}

function updateList() {
  var deck = document.getElementById('metricdeck');
  if(metrics.length == 0) {
    deck.selectedIndex = 0;
  } else {
    deck.selectedIndex = 1;
  }
  var racklist = document.getElementById('rackrows');
  while(racklist.firstChild) racklist.removeChild(racklist.firstChild);

  for(var i = 0; i < metrics.length; ) {
    var item = document.createElement('row');
    item.setAttribute('align', 'center');
    item.setAttribute('param', metrics[i][1]);
    item.setAttribute('metric', metrics[i][0]);
    var image = document.createElement('image');
    if((metrics[i].length > 2) && metrics[i][2]) {
      image.setAttribute('src', 'chrome://cmgui/content/icons/Health_16.png');
    } else {
      image.setAttribute('src', 'chrome://cmgui/content/icons/Monitoring_16.png');
    }
    var label = document.createElement('label');
    var check = current.find(metrics[i][0]);
    if(isObject(check)) {
      var name = check.resolveName()
      if(metrics[i][1].length > 0) name += '[' + metrics[i][1] + ']';
      if(check.get('unit')) name += " (" + check.get('unit') + ")";
      label.setAttribute('value', name);
      item.appendChild(image);
      item.appendChild(label);
      var minus = document.createElement("button");
      minus.setAttribute('class', 'minus-button');
      minus.setAttribute('oncommand', "removeMetric(" + i + ");");
      item.appendChild(minus);
      racklist.appendChild(item);
      i++;
    } else {
      metrics.splice(i, 1);
    }
  }
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("wait");
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("auto");
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}

function selectJob() {
  var args = new Object();
  var d = new dock.cvDialog("monjobselect.xul", args);
  args['cluster'] = current;
  d.onOk = function(nodes, t0, t1, cg) {
    currentnodes = nodes;
    zoom = [t0, (t1 > 0 ? t1 : 0xffffffff)];
    cgroup = cg;
    setTimeType(0);
    refresh();
  }
  dock.dialogs.showDialog(d);
}
