/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock

function onLoad() {
  dock = getDock();
  println("Error initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  document.getElementById('metric').value = "Force " + myDialog.arguments.name + " bounds:";
  
  var low = myDialog.arguments.low;
  var unit = myDialog.arguments.unit;
  var chk = document.getElementById('cmin');
  var txt = document.getElementById('smin');
  if(myDialog.arguments.hasOwnProperty('smin')) {
    chk.setAttribute('checked', true);
    value = myDialog.arguments['smin'];
  } else {
    chk.setAttribute('checked', (low == 0));
    value = myDialog.arguments['min'];
  }
  txt.setAttribute('value', formatKMGselect(value, unit));
  if(low == 0) txt.focus();

  var chk = document.getElementById('cmax');
  var txt = document.getElementById('smax');
  if(myDialog.arguments.hasOwnProperty('smax')) {
    chk.setAttribute('checked', true);
    value = myDialog.arguments['smax'];
  } else {
    chk.setAttribute('checked', (low == 1));
    txt.setAttribute('value', myDialog.arguments['max']);
    value = myDialog.arguments['max'];
  }
  txt.setAttribute('value', formatKMGselect(value, unit));
  if(low == 1) txt.focus();

}

function ok() {
  var smin = NaN;
  var smax = NaN;
  var chk = document.getElementById('cmin');
  if(chk.checked) {
    var txt = document.getElementById('smin').value;
    if(txt.length > 0) {
      smin = parseKMG(txt, true);
      if(isNaN(smin)) {
        dock.displayError(txt + ' does not denote a valid number', window);
        return;
      }
    }
  }
  var chk = document.getElementById('cmax');
  if(chk.checked) {
    var txt = document.getElementById('smax').value;
    if(txt.length > 0) {
      smax = parseKMG(txt, true);
      if(isNaN(smax)) {
        dock.displayError(txt + ' does not denote a valid number', window);
        return;
      }
    }
  }
  if(!isNaN(smin) && !isNaN(smax) && (smin > smax)) {
    dock.displayError('The upper bound needs to be higher than the lower bound', window);
    return;
  }
  myDialog.onOk(smin, smax);
  close();
}
