/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node settings" + ' - ' + document.documentURI);
  
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  text('hostname', dock.REGEX_HOSTNAME, '', true);
  text('tag');  
//   partial('mac', ':', '^[0-9a-fA-F]{2}$', '', false, '00:00:00:00:00:00', 0, '6..21', '00');
  number('indexInsideContainer', 0, 32);

  resolve('host', 'Node', '', '', '', function(node) { return dock.baseChildTypeCheck(node.object, 'MICNode'); } );
  resolve('category', 'MICNodeCategory');
  autorefresh('category');

  var list = ['none', 'apc', 'custom', 'mic'];
  var networks = current.get('networks');
  for(var i = 0; i < networks.length; i++) {
    var name = networks[i].name;
    if((list.find(name) < 0) && (startswith(name, 'ipmi') || startswith(name, 'ilo'))) {
      list.push(name);
    }    
  }
  var pwctl = current.get('powerControl');
  if((list.find(pwctl) < 0) && (startswith(pwctl, 'ipmi') || startswith(pwctl, 'ilo'))) {
    list.push(pwctl);
  }
  list.sort();
  kenum('powerControl', list);
  text('customPowerScript');
  text('customPowerScriptArgument');
  text('userdefined1');
  text('userdefined2');
  text('revision');
}
