/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) {
    current = use;
    setCallbackResult(new dock.cvSysInfoCollector());
  }
  println("Refresh node system information" + ' - ' + document.documentURI);

  dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'getSysInfoCollector', current.get('uniqueKey'), function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;
  if(overview == null) return;
  var mics = overview.mics;
  var index = current.get('indexInsideContainer');
  if(index < mics.length) {
    overview = mics[index];
  } else {
    overview = new dock.cvMICInfo()
  }
  
  var speed = ' ';
  var model = ' ';
  var cache = ' ';
  var cpus = overview.processors;
  if(cpus.length > 0) {
    speed = cpus[0].speed;
    model = cpus[0].modelName;
    cache = cpus[0].cacheSize;
  }
  
  overviewValue('name');
  overviewValue('id');
  overviewValue('serial');
  
  overviewValue('osVersion');
  overviewValue('driverVersion');
  overviewValue('flashVersion');  
  overviewValue('mpssVersion');
  overviewValue('skuVersion');
  overviewValue('smcFirmwareVersion');
  overviewValue('smcBootLoaderVersion');
  
  overviewValue('stepping'); 
  overviewValue('coreSpeed', speed);
  overviewValue('coreModel', model);
  overviewValue('coreCache', cache);
  if(model == ' ') {
    overviewValue('cores', ' ');
  } else {
    overviewValue('cores');
  }
  
  overviewValue('memTotal');
  overviewValue('memSpeed');
  overviewValue('memTechnology');
  overviewValue('memDensity');
  overviewValue('pciSpeed');
    
//   overviewCPUInfo();
}
