/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function minicomShell() {
  var host = current.cluster.find(current.get('host'));
  if(!host) {
    dock.displayInfo("The host node is not set");
  } else if(host.stateString() == "Up") {
    dock.waitIcon();
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmproc', 'startMinicomOnNode', ['root', current.get('uniqueKey')], function(code, data) {
      if(code == 0) {
        if(data.length) {
          var args = [this.current.cluster.host, this.current.cluster.port, data, this.current.resolveName(), 'Minicom Shell', 'false'];
          var d = new dock.cvDialog("remoteshell.xul", args); 
          dock.dialogs.showShell(d);
        } else {
          dock.displayInfo("The node did not return a login token");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      dock.unwaitIcon();
    }, current);
  } else {
    dock.displayInfo("The node " + host.resolveName() + " is not up");
  }
}
