/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'MICOverlay';
var subfield = 'micSettings(XeonPhiSettings)|overlays';
var singular = 'overlay';
var plural = 'overlays';
var editfile = 'editmicoverlay.xul';

function refresh(use) {
  if(!!use) current = use;
  println("Refresh mic overlay" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  tree = document.getElementById('tree');
  data = new Array();
  
  if(current.get('baseType') == 'Device') {
    document.getElementById('showcategory').removeAttribute('hidden');
    if(document.getElementById('showcategory').checked) {
      var category = current.get('category');
      category = current.cluster.find(category);
      if(category) {
        var overlays = category.get(subfield);  
        for(var i = 0; i < overlays.length; i++) {
          if(!overlays[i].toBeRemoved || alsoRemoved) {
            data.push(createTreeItem(overlays[i], -1, false));
          }
        }
      }
    }
  } else {
    document.getElementById('showcategory').setAttribute('hidden', true);
  }
  var overlays = current.get(subfield);  
  for(var i = 0; i < overlays.length; i++) {
    if(!overlays[i].toBeRemoved || alsoRemoved) {
      data.push(createTreeItem(overlays[i], i, true));
    }
  }
  for(var i = overlays.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one, i, owned) {
  var item = new Object();
  if(owned) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = 0;
  }
  item['order'] = i;
  item['name'] = one.name;
  item['source'] = one.source;
  item['target'] = one.target;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  if(one.state.toLowerCase() == 'on') {
    item['state'] = 'On (enabled)';
  } else if(one.state.toLowerCase() == 'off') {
    item['state'] = 'Off (disabled)';
  } else {
    item['state'] = one.state;
  }
  if(one.type.toLowerCase() == 'rpm') {
    item['type'] = 'RPM';
  } else if(one.type.toLowerCase() == 'file') {
    item['type'] = 'File';
  } else if(one.type.toLowerCase() == 'filelist') {
    item['type'] = 'FileList';
  } else if(one.type.toLowerCase() == 'simple') {
    item['type'] = 'Simple';
  } else {
    item['type'] = one.type;
  }
  println('modified: "' + one.modified + '"');
  println('state: "' + one.state + '"');
  println(typeof(one.state));
  println('type: "' + one.type + '"');
  println(typeof(one.type));
  println('object: "' + current.get('modified') + '"');
  return item;
}
