/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function refresh(use) {
  if(!!use) current = use;
  println("Refresh roles" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  var checks = document.getElementsByTagName('checkimage');
  for(var i = 0; i < checks.length; i++) {
    checks[i].checked = false;
    var next = checks[i].nextSibling;
    if(next) next.setAttribute('hidden', true);
  }

  clearLabel('SGEClient');
  clearLabel('TorqueClient');
  clearLabel('PbsProClient');
  clearLabel('SlurmClient');
  clearLabel('LSFClient');
  clearLabel('OpenLavaClient');
  
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(!roles[i].toBeRemoved) {
      setRole(roles[i], '');
    }
  }  

  if((current.get('baseType') == "Device") && dock.baseChildTypeCheck(current.object, 'MICNode')) {
    var cat = current.get('category');
    if(cat) {
      cat = current.cluster.find(cat);
      if(cat) {
        var catroles = cat.get(subfield);
        cat = cat.resolveName();
        for(var i = 0; i < catroles.length; i++) {
          if(!catroles[i].toBeRemoved) {
            var found = false;
            for(var j = 0; !found && (j < roles.length); j++) {
              if(!roles[j].toBeRemoved) {
                found = (catroles[i].childType == roles[j].childType);
              }
            }
            if(!found) setRole(catroles[i], cat);
          }
        }
      }
    }
  }
}
