var dragged;

/* events fired on the draggable target */
// document.addEventListener("drag", function(event) {
// }, false);

document.addEventListener("dragstart", function(event) {
  var list = event.target;
  var tree = list.parentNode;
  var select = new Array();
  var start = new Object();
  var end = new Object();
  
  for(var t = 0; t < tree.view.selection.getRangeCount(); t++) {
    tree.view.selection.getRangeAt(t,start,end);
    for(var v = start.value; v <= end.value; v++) {
      var item = tree.view.getItemAtIndex(v);
      if(item.hasAttribute('key')) {
        dragged = item;
        event.target.style.opacity = .65;
        return;
      }
    }
  }
  
  event.preventDefault();
}, false);

document.addEventListener("dragend", function(event) {
  event.target.style.opacity = "";
}, false);

/* events fired on the drop targets */
document.addEventListener("dragover", function(event) {
  // prevent default to allow drop
  event.preventDefault();
//   var work = find_graph_box(event.target);
//   if(is_drop_zone(work)) {
//     event.preventDefault();
//   }
}, false);

// document.addEventListener("dragenter", function(event) {
//   // highlight potential drop target when the draggable element enters it
//   var work = find_graph_box(event.target);
//   if(is_drop_zone(work)) {
//     work.style.background = "purple";
//   }
// }, false);
// 
// document.addEventListener("dragleave", function(event) {
//   // reset background of potential drop target when the draggable element leaves it
//   var work = find_graph_box(event.target);
//   if(is_drop_zone(work)) {
//     work.style.background = "";
//   }
// }, false);

document.addEventListener("drop", function(event) {
  // prevent default action (open as link for some elements)
  event.preventDefault();
  var work = find_graph_box(event.target);
  if(is_drop_zone(work)) {
    var index = parseInt(work.getAttribute("graphindex"));
    var dmp = new cvGraphDeviceMetric(dragged.getAttribute("key"),
                                      dragged.getAttribute("metric"),
                                      dragged.getAttribute("param"),
                                      dragged.getAttribute("devices"),
                                      parseInt(dragged.getAttribute("startTime")),
                                      parseInt(dragged.getAttribute("endTime")),
                                      true,
                                      dragged.getAttribute("translatedParam"),
                                      dragged.getAttribute("cgroups"),
                                      dragged.getAttribute("user"));
    graphs[index].allowRedraw(true);
    var r = graphs[index].add(dmp);
    if(r == 0) {
      replaceOne(index);
    } else if(r <= -100000) {
      if(r == -100000) {
        dock.displayError("This element cannot be plotted, expand the tree and plot one of the metrics or health checks", window);
      } else if(r == -100002) {
        dock.displayError("Only one heatmap/pie can be plotted in a single graph", window);
      } else {
        dock.displayError("Unknown drag/drop error code: " + r, window);
      }
    } else if(r < 0) {
      dock.displayError("Too many metrics/checks, only " + -r + " are supported", window);
    } else {
      dock.displayError("Incompatible metrics/checks: " + r, window);
    }
  }
}, false);


function is_drop_zone(work) {
  return work &&    
         isObject(work) &&
         work.hasAttribute("dropzone") &&
         work.getAttribute("dropzone");
}

function find_graph_box(work) {
  while(work) {
    if(is_drop_zone(work)) {
      break;
    } else {
      work = work.parentNode;
    }
  }
  return work;
}
