/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var filter = 0;
var oldcluster = 0;
var monfilterinsert = 0;

var page = 1;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function onClose() {
  if(monfilterinsert) monfilterinsert.close();
}

function refresh(use, detached) {
  detached = isundefined(detached, false);
  println("Refresh monitoring filter" + ' - ' + document.documentURI);
  if(!!use) {
    current = use;
    var oldfilter = filter;
    if(detached) {
      filter = new cvMonitoringFilter(current, parent.window);
    } else {
      filter = new cvMonitoringFilter(current, dock);
    }
    if(!!oldfilter) {
      filter.query = oldfilter.query;
    }
  }
}

function execute() {
  var cmd = document.getElementById("command");
  if(!!filter) {
    filter.execute(cmd.value);
  } else {
    println('Filter not initialized');
  }
}

function insert() {
  var args = new Object();
  args['cluster'] = current;
  args['cmdtextbox'] = document.getElementById("command");
  args['filterwindow'] = window;
  monfilterinsert = new dock.cvDialog("monitoringfilterinsert.xul", args);
  dock.dialogs.show(monfilterinsert);
}

function sortBy(event) {
  var item = event.target;
  var sorting = parseInt(item.getAttribute('sort'));
  if(!!filter) {
    filter.sort = sorting;
    if(filter.period == 0) {
      filter.update(2);
    } else {
      filter.update(0);
    }
  }
}

function update() {
  if(!!filter) filter.update();
}

function stop() {
  if(!!filter) filter.stop();
}

function opendevice(key) {
  current.select(key);
}

function createPageMenu(n) {
  var pages = document.getElementById("pages");
  var m = pages.childNodes.length;
  for(var i = n; i < m; i++) pages.removeChild(pages.lastChild);
  for(var i = m + 1; i <= n; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('page', i);
    item.setAttribute('label', i);
    pages.appendChild(item);
  }
}

function updatePageMenu(page) {
  var pages = document.getElementById("pages");
  pages.parentNode.selectedIndex = page - 1;
}

function setPage(index) {
//   println("setPage " + index + " [1," + filter.pages() + "]");
  if((index >= 1) && (index <= filter.pages())) {
    page = index;
    filter.displayPage(page);
  }
}

function perpagemenu(event) {
  var perpage = parseInt(event.target.getAttribute('page'));
  if(perpage != filter.perPage) {
    var old = filter.perPage * (filter.page - 1);
    var n = filter.pages(perpage);
    filter.displayPage(Math.min(1 + Math.floor(old / perpage), n));
    createPageMenu(n);
  }
}

function pagemenu(event) {
  setPage(parseInt(event.target.getAttribute('page')));
}

function pagetop() {
  setPage(1);
}

function pagebottom() {
  setPage(filter.pages());
}

function pageup() {
  setPage(page - 1)
}

function pagedown() {
  setPage(page + 1);
}
