/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var monconf;
var monconfForCluster = new Object();
var alsoRemoved = false;

var basetype = 'MonHealthConf';
var singular = 'health configuration';
var plural = 'health configurations';
var subfield = 'checks';
var editfile = 'editmonhealthconf.xul';

function refreshlist() {
  tree = document.getElementById('tree');
  data = new Array();

  if(monconf) {
    var list = monconf.get('checks');
    for(var i = 0; i < list.length; i++) {
      if(!list[i].toBeRemoved || alsoRemoved) {
        var item = createTreeItem(list[i]);
        if(item) data.push(item);
      }
    }
    for(var i = list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
    var select = selected('list');
    loadTable();
    setSelected('list', select);

    document.getElementById('save').setAttribute("disabled", !monconf.get('modified'));
    document.getElementById('revert').setAttribute("disabled", false);
    document.getElementById('edit').setAttribute("disabled", false);
    document.getElementById('add').setAttribute("disabled", false);
    document.getElementById('remove').setAttribute("disabled", false);

    if(monconf.get('modified')) {
      parent.frames[0].document.getElementById('save').setAttribute("disabled", false);
    }
  } else {
    loadTable();

    document.getElementById('save').setAttribute("disabled", true);
    document.getElementById('revert').setAttribute("disabled", true);
    document.getElementById('edit').setAttribute("disabled", true);
    document.getElementById('add').setAttribute("disabled", true);
    document.getElementById('remove').setAttribute("disabled", true);
  }
}

function createTreeItem(one) {
  var item = new Object();
  var check = current.find(one.healthcheck);
  if(!check) return 0;
  item['healthcheck'] = check.resolveName();
  item['key'] = one.uniqueKey;
  item['parameter'] = one.healthcheckParam;
  if(one.translatedHealthcheckParam.length) {
    item['parameter'] = one.translatedHealthcheckParam + ' (' + one.healthcheckParam + ')';
  } else {
    item['parameter'] = one.healthcheckParam;
  }
  item['loglength'] = one.rawTableLength;
  if(one.samplingInterval == 4294967295) {
    item['interval'] = 'prejob';
  } else if(one.samplingInterval == 0) {
    item['interval'] = 'N/A';
  } else {
    item['interval'] = one.samplingInterval;
  }
  if(one.disabled) {
    item['disabled'] = 'yes';
  } else if(check.get('disabled')) {
    item['disabled'] = 'health check';
  }
  item['storeInDatabase'] = one.storeInDatabase;
  item['passActions'] = thresActionString(current, one, 'passActionConfs');
  item['failActions'] = thresActionString(current, one, 'failActionConfs');
  item['unknownActions'] = thresActionString(current, one, 'unknownActionConfs');
  return item;
}
