/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var myDialog;
var cluster;
var jobs = new Array();

var waitCount = 0;


function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  cluster = myDialog.arguments.cluster;
}

function waitIcon() {
  if(waitCount == 0) {
    window.setCursor("wait");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("wait");
  }
  waitCount++;
}

function unwaitIcon() {
  waitCount--;
  if(waitCount <= 0) {
    window.setCursor("auto");
    for(var i = 0; i < window.frames.length; i++) window.frames[i].window.setCursor("auto");
    if(waitCount < 0) println("Mismatch waitCursor");
    waitCount = 0;
  }
}

function tree_keypress(e) {
  if(e.keyCode == e.DOM_VK_RETURN) {
    ok();
    return false;
  }
  return true;
}

function search() {
  waitIcon();
  var wlm = document.getElementById('wlm').value;
  var queue = document.getElementById('queue').value;
  var jobId = document.getElementById('jobId').value;
  var jobName = document.getElementById('jobName').value;
  var user = document.getElementById('user').value;
  var group = document.getElementById('group').value;
  var t0 = 0;
  var t1 = 0xffffffff;
  var states = 0;
  if(document.getElementById('running').checked) states += 2;
  if(document.getElementById('completed').checked) states += 4;
  if(document.getElementById('failed').checked) states += 8;
  
  dock.workerpool.getWorker(cluster.actualurl).call('cmjob', 'filterJobInfo', [wlm, queue, jobId, jobName, user, group, t0, t1, states, 0, 0xffffffffffffffff], function(code, data) {
      if(code == 0) {
        fill(data);
      } else {
        unwaitIcon();
        dock.jsonCallError(this, code, data);
      }
    }, cluster);
}

function ok(forceClose) {
  var select = selected('list');
  if(select.length == 1) {  
    var job = jobs[select[0] - 1];
    myDialog.onOk(job.nodes, job.startTime, job.endTime, job.cgroup);
  }
  if(forceClose || select.length) close();
}

function cancel() {
  close();
}

function fill(list) {
  jobs = list;
  data = new Array();
  
  tree = document.getElementById('tree');
  var modified = false;
  for(var i = 0; i < list.length; i++) {
    var tmp = createTreeItem(list[i], i);
    if(tmp === null) continue;
    data.push(tmp);
  }
  var select = selected('list');
  loadTable();
  setSelected('list', select);
  unwaitIcon();
}

function createTreeItem(one, i) {
  var item = new Object();
  item['key'] = i + 1;
  item['wlm'] = one.wlm;
  item['queue'] = one.queue;
  item['jobId'] = one.jobId;
  item['jobName'] = one.jobName;
  item['user'] = one.user;
  item['group'] = one.group;
  item['cgroup'] = one.cgroup;
  item['nodes'] = dotFormatKeys(cluster, one.nodes);
  if(one.exitCode) {
    item['state'] = "Failed";
  } else if(one.endTime) {
    item['state'] = "Completed";
  } else {
    item['state'] = "Running";
  }
  item['startTime'] = formatDateTime(one.startTime);
  item['endTime'] = formatDateTime(one.endTime);
  return item;
}
