/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var myDialog;
var settings;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  settings = dock.generalSettings;

  refresh();
}

function refresh() {
  var intervals = [[0, 'Best'], 10, 25, 50, 100, 200, 500, 1000];
  var rates = [[60, '1 minute'], [120, '2 minutes'], [300, '5 minutes'], [600, '10 minutes'], [1800, '30 minutes'], [3600, '1 hour']];
  var timeList = [[3600, '1 hour'], [43200, '12 hours'], [86400, '1 day'], [259200, '3 days'],
                  [608400, '7 days'], [2678400, '1 month'], [31526000, '1 year'], [94578000, '3 years']];
  var myTime = 3600;

//   document.getElementById('cmsh').setAttribute('value', settings.cmsh);

  var popup = document.getElementById('lasttime').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < timeList.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', timeList[i][1]);
    item.setAttribute('time', timeList[i][0]);
    popup.appendChild(item);
    if(timeList[i][0] == settings.timespan) document.getElementById('lasttime').selectedIndex = i;
  }

  var popup = document.getElementById('intervals').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < intervals.length; i++) {
    var item = document.createElement('menuitem');
    var val = intervals[i];
    if(isArray(intervals[i])) {
      item.setAttribute('intervals', intervals[i][0]);
      item.setAttribute('label', intervals[i][1]);
      val = intervals[i][0];
    } else {
      item.setAttribute('label', intervals[i]);
      item.setAttribute('intervals', intervals[i]);
    }
    popup.appendChild(item);
    if(val == settings.intervals) document.getElementById('intervals').selectedIndex = i;
  }

  var popup = document.getElementById('monrate').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < rates.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', rates[i][1]);
    item.setAttribute('time', rates[i][0]);
    popup.appendChild(item);
    if(rates[i][0] == settings.monitoringRefresh) document.getElementById('monrate').selectedIndex = i;
  }
  
  document.getElementById('monitoringAutoFill').checked = settings.monitoringAutoFill;
  document.getElementById('jobOnlyCgroup').checked = settings.jobOnlyCgroup;
}

function ok() {
  apply();
  cancel();
}

function apply() {
  var item = document.getElementById('lasttime').selectedItem;
  if(item) settings.timespan = item.getAttribute('time');
  var item = document.getElementById('monrate').selectedItem;
  if(item) settings.monitoringRefresh = parseInt(item.getAttribute('time'));
  var item = document.getElementById('intervals').selectedItem;
  if(item) settings.intervals = parseInt(item.getAttribute('intervals'));

  settings.monitoringAutoFill = document.getElementById('monitoringAutoFill').checked;
  settings.jobOnlyCgroup = document.getElementById('jobOnlyCgroup').checked;
  
  settings.save();
}

function cancel() {
  close();
}
