/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh network overview" + ' - ' + document.documentURI);
  var key = current.object.uniqueKey;

  var list = document.getElementById('nodes');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  
  var mics = document.getElementById('mics');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  
  var nodes = current.cluster.find("Node");
  for(var i = 0; i < nodes.length; i++) {
    var interfaceNames = nodes[i].get('networks');
    for(var j = 0; j < interfaceNames.length; j++) {
      if(interfaceNames[j].network == key) {
        if(nodes[i].get('childType') == 'MICNode') {
          mics.appendChild(nodeInterfaceRow(nodes[i].get('hostname'), interfaceNames[j].name, interfaceNames[j].ip));
        } else {
          list.appendChild(nodeInterfaceRow(nodes[i].get('hostname'), interfaceNames[j].name, interfaceNames[j].ip));
        }
      }
    }
  }

  var list = document.getElementById('switches');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  var switches = current.cluster.find("Switch");
  for(var i = 0; i < switches.length; i++) {
    if(switches[i].get('network') == key) {
      list.appendChild(deviceRow(switches[i].get('hostname'), switches[i].get('ip')));
    }
  }

  var list = document.getElementById('pdus');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  var pdus = current.cluster.find("PowerDistributionUnit");
  for(var i = 0; i < pdus.length; i++) {
    if(pdus[i].get('network') == key) {
      list.appendChild(deviceRow(pdus[i].get('hostname'), pdus[i].get('ip')));
    }
  }

  var list = document.getElementById('gpus');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  var gpus = current.cluster.find("GpuUnit");
  for(var i = 0; i < gpus.length; i++) {
    if(gpus[i].get('network') == key) {
      list.appendChild(deviceRow(gpus[i].get('hostname'), gpus[i].get('ip')));
    }
  }

  var list = document.getElementById('other');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  var other = current.cluster.find("GenericDevice");
  for(var i = 0; i < other.length; i++) {
    if(other[i].get('network') == key) {
      list.appendChild(deviceRow(other[i].get('hostname'), other[i].get('ip')));
    }
  }  
}

function nodeInterfaceRow(host, interfaceName, ip) {
  var row = document.createElement('row');
  row.setAttribute("flex", "1");
  row.setAttribute("align", "center");
  row.setAttribute("height", "17px");
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", host);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", interfaceName);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", ip);
  row.appendChild(label);
  return row;
}

function deviceRow(host, ip) {
  var row = document.createElement('row');
  row.setAttribute("flex", "1");
  row.setAttribute("align", "center");
  row.setAttribute("height", "17px");
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", host);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", ip);
  row.appendChild(label);
  return row;
}
