/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh network settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  text('name', '^[a-zA-Z]');
  text('domainName', '^');
  partial('baseAddress', '.', dock.REGEX_IPv4_PARTIAL);
  partial('gateway', '.', dock.REGEX_IPv4_PARTIAL);
  check('management');
  kenum('type', [['INTERNAL', 'Internal'], ['GLOBAL', 'Global'], ['EXTERNAL', 'External'], ['TUNNEL', 'Tunnel'], ['CLOUD', 'Cloud'], ['NETMAP', 'NetMap']]);
  check('lockDownDhcpd');
  number('netmaskBits', 0, 32);
  text('mtu', '^[0-9]{1,6}$');
  partial('dynamicRangeStart', '.', dock.REGEX_IPv4_PARTIAL);
  partial('dynamicRangeEnd', '.', dock.REGEX_IPv4_PARTIAL);
  check('bootable');
  text('revision');

  check('IPv6');
  text('ipv6BaseAddress');
  text('ipv6Gateway');
  number('ipv6NetmaskBits', 0, 128);
  
  text('EC2SubnetID', '^');

  var type = current.get('type');
  // availability zone
  var list = new Array();
  if (type == 'CLOUD') {
    var regionKey = 0;
    var providers = current.cluster.find('CloudProvider');
    for (var i = 0; i < providers.length; i++) {
      if (providers[i].get('childType') == 'EC2Provider') {
        var vpcs = providers[i].get('privateClouds');
        for (var j = 0; j < vpcs.length; j++) {
          if ((vpcs[j].childType == 'EC2PrivateCloud') && vpcs[j].subnets.find(current.get('uniqueKey'))) {
            regionKey = vpcs[j].region;
            break;
          }
        }
      }
    }
    var region = current.cluster.find(regionKey);
    if(region) {
      var zones = region.get('availabilityZones');
      var list = new Array();
      list.push('');
      for (var i = 0; i < zones.length; i++) {
        list.push(zones[i].name);
      }
    }
    document.getElementById('EC2AvailabilityZone').removeAttribute('disabled');
  } else {
    document.getElementById('EC2AvailabilityZone').setAttribute('disabled', true);
  }
  kenum('EC2AvailabilityZone', list);
  
  autorefresh('openStackType');
  kenum('openStackType', [['NONE', 'None'], ['FLAT', 'Flat'], ['VLANHOST', 'VLAN Host'], ['VLAN', 'VLAN'], ['VXLANHOST', 'VXLAN Host'], ['OTHER', 'Other']]);
  check('openStackIsShared');
  text('openStackAllocationPoolStart', dock.REGEX_IPv4);
  text('openStackAllocationPoolEnd', dock.REGEX_IPv4);
  text('openStackVlanRange');
  text('openStackVlanID', '^[0-9]+$');
  text('openStackPhysicalNetwork');
  resolve('openStackHostNetwork', 'Network', '', true);
  
  var hideEC2 = (type != 'CLOUD');
  setHidden('allEC2', hideEC2);
  
  var hideOpenStack = !current.cluster.hasOpenStack || (type == 'CLOUD') || (type == 'GLOBAL') || (type == 'NETMAP') || (type == 'TUNNEL');
  setHidden('allOpenStack', hideOpenStack);
  setViewOptionsOfOpenstack();
  
  var external = (type == 'EXTERNAL');
  setHidden('ipv6row', !external);
  autorefresh('type');
}

function setViewOptionsOfOpenstack() {
  var hideOpenStack = (current.get('openStackType') === 'NONE');
  setHidden('openStackIsShared', hideOpenStack);
  setHidden('extraOpenStack', hideOpenStack);
}
