/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  setDialogTitle(myDialog.arguments.title)
  document.getElementById("question").setAttribute('value', myDialog.arguments.question + ':');
  document.getElementById("result").setAttribute('value', myDialog.arguments.default);
  var type = document.getElementById("type");
  var popup = type.firstChild;
  var types = myDialog.arguments.children;
  for(var i = 0; i < types.length; i++) {
    var item = document.createElement("menuitem");
    item.setAttribute('label', types[i]);
    popup.appendChild(item);
  }
  type.setAttribute('label', types[0]);
  document.getElementById("result").focus();
}

function ok() {
  var name = document.getElementById("result").value;
  var type = document.getElementById("type").label;
  if(blank(name)) {
    dock.displayError(myDialog.arguments.question + " cannot be empty");
  } else if(myDialog.arguments.known.find(name) >= 0) {
    dock.displayError("That " + myDialog.arguments.question + " is already taken");
  } else if(!window.closed) {
    close();
    myDialog.onOk(name, type);
  }
}

function cancel() {
  close();
}
