/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var assigned;
var interpol;
var newnodes;
var action;
var actionBit = 0;

var basetype;
var singular;
var plural;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);

  basetype = parent.frames[0].basetype;
  singular = parent.frames[0].singular;
  plural = parent.frames[0].plural;
}

function refresh(use) {	
  if(!!use) {
    if(current != use) {
      assigned = new Object();
      current = use;
    }
  }
  var index = document.getElementById('group').selectedIndex;
  if(actionBit == 0) {
    eval(document.getElementById('group').firstChild.firstChild.getAttribute('oncommand'));
  }
  println("Refresh node folder new nodes" + ' - ' + document.documentURI);

  if(dock.DEMO) {
    var sw = current.find('EthernetSwitch');
    var is = 0;
    var ip = 1;
    var test = new Array();
    var t0 = new Date();
    var a = new Array();
    a.push(0);
    a.push(158);
    a.push(13);
    a.push(54);
    a.push(68);
    a.push(47);
    for(var i = 0; i < 48; i++) {
      var sp = new dock.cvSwitchPort();
      if(sw.length > 0) {
        if((i > 0) && (i % 24 == 0) && (sw.length > 1)) {
          is = (is + 1) % sw.length;
          ip = 1;
        }
        sp.ethernetSwitch = sw[is].get('uniqueKey');
        sp.prt = ip;
        ip++;
      }
      a[5] = (a[5] + i * 64 + (3 + 2 * (i & 4))) % 256;
      test.push(oneNewNode(t0.format("dd/mmm/yyyy HH:MM:ss"), sprintf('%02X:%02X:%02X:%02X:%02X:%02X', a[0], a[1], a[2], a[3], a[4], a[5]), sp));
      var p = 2000;
      if(Math.random() > 0.9) p += 1000;
      t0.setTime(t0.getTime() + p);
    }
    update(test);
  } else {
    dock.workerpool.getWorker(current.actualurl).call('cmdevice', 'getNewNodes', null, function(code, data) {
      if(code == 0) {
        update(data);
        dock.unwaitIcon();
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
    dock.waitIcon();
  }
}

function oneNewNode(t, mac, sp) {
  var newnode = new dock.cvNewNode();
  newnode.appeared = t;
  newnode.mac = mac;
  newnode.switchPort = sp;
  return newnode;
}

function update(value) {
  newnodes = value;
  var list = document.getElementById('list');
  while(list.childNodes.length > 2) list.removeChild(list.lastChild);
  interpolate();

  newnodes = newnodes.sort(function(a, b) {
        return a.appeared > b.appeared;
      });
  
  for(var i = 0; i < newnodes.length; i++) {
    var row = document.createElement("row");
    row.setAttribute('align', 'center');
    var label = document.createElement("label");
    label.setAttribute('value', newnodes[i].mac);
    row.appendChild(label);
    var label = document.createElement("label");
    label.setAttribute('value', newnodes[i].appeared);
    row.appendChild(label);
    var label = document.createElement("label");
    var sw = newnodes[i].switchPort;
    if(sw == null) sw = new dock.cvSwitchPort();
    var sp;
    if(!!sw) {
      sp = current.resolveName(sw.ethernetSwitch);
      if(sp) sp = sp + ':' + sw.prt;
    } else {
      sp = '';
    }
    label.setAttribute('value', sp);
    row.appendChild(label);

    var menulist = document.createElement("menulist");
    menulist.setAttribute('mac', newnodes[i].mac);
    var menupopup = document.createElement("menupopup");
    menupopup.setAttribute('onpopupshowing', 'fillnodes(event);');
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute('label', 'None');
    menuitem.setAttribute('key', 0);
    menupopup.appendChild(menuitem);
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute('label', 'Auto');
    menuitem.setAttribute('key', -1);
    menupopup.appendChild(menuitem);
    if(assigned[newnodes[i].mac] && (assigned[newnodes[i].mac] > 0)) {
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute('label', current.resolveName(assigned[newnodes[i].mac]));
      menuitem.setAttribute('key', assigned[newnodes[i].mac]);
      menupopup.appendChild(menuitem);
    }
    menulist.appendChild(menupopup);
    row.appendChild(menulist);

    var label = document.createElement("label");
    var name = interpol[newnodes[i].mac][1];
    if(name.length == 0) {
      label.setAttribute('value', 'none');
    } else {
      label.setAttribute('value', action + name);
    }
    label.setAttribute('id', 'interpol' + newnodes[i].mac.replace(/\:/g, '_'));
    row.appendChild(label);
    list.appendChild(row);

    if(assigned[newnodes[i].mac] == 0) {
      menulist.selectedIndex = 0;
    } else {
      menulist.selectedIndex = menupopup.childNodes.length - 1;
    }
    menupopup.addEventListener("command", select_node, true);
  }
}

function select_node(event) {
  var item = event.target;
  var key = parseInt(item.getAttribute('key'));
  var mac = item.parentNode.parentNode.getAttribute('mac');
  assigned[mac] = key;
  if(typeof(newnodes) != 'undefined') updateInterpolate();
}

function updateInterpolate() {
  interpolate();
  for(var i = 0; i < newnodes.length; i++) {
    var label = document.getElementById('interpol' + newnodes[i].mac.replace(/\:/g, '_'));
    var name = interpol[newnodes[i].mac][1];
    if(name.length == 0) {
      label.setAttribute('value', 'none');
    } else {
      label.setAttribute('value', action + name);
    }
  }
}

function interpolate() {
  var found = current.find(basetype);
  var keyIndex = new Object();
  for(var i = 0; i < found.length; i++) {
    keyIndex[found[i].object.uniqueKey] = i;
  }
  var usedKeys = new Object();
  for(var mac in assigned) {
    usedKeys[assigned[mac]] = 1;
  }

  var last = -1;
  interpol = new Object();
  for(var i = 0; i < newnodes.length; i++) {
    var mac = newnodes[i].mac;
    var sp = newnodes[i].switchPort;
    if(typeof(assigned[mac]) == 'undefined') assigned[mac] = -1;
    var key = assigned[mac];
    if(key == 0) {
      interpol[mac] = [0, '', 0];
      last = -1;
    } else if(key < 0) {
      if((last >= 0) && (last < found.length)) {
        last++;
        if(usedKeys[found[last].object.uniqueKey]) {
          interpol[mac] = [0, '', 0];
          last = -1;
        } else {
          interpol[mac] = [found[last], found[last].resolveName(), sp];
        }
      } else {
        interpol[mac] = [0, '', 0];
      }
    } else {
      if(typeof(keyIndex[key]) == 'undefined') {
        interpol[mac] = 'Node no longer defined';
      } else {
        last = keyIndex[key];
        interpol[mac] = [found[last], found[last].resolveName(), sp];
      }
    }
  }
}

function fillnodes(event) {
  var popup = event.target;
  var lastKey = parseInt(popup.childNodes[popup.parentNode.selectedIndex].getAttribute('key'));
  var select = -1;
  if(popup.childNodes.length == 3) {
    popup.removeChild(popup.lastChild);
  }
  if(popup.childNodes.length == 2) {
    var found = current.find(basetype);
    for(var i = 0; i < found.length; i++) {
      var item = document.createElement("menuitem");
      item.setAttribute('key', found[i].object.uniqueKey);
      item.setAttribute('label', found[i].resolveName());
      popup.appendChild(item);
      if(found[i].object.uniqueKey == lastKey) {
        select = i + 2;
      }
    }
    if(select >= 0) {
      popup.parentNode.selectedIndex = select;
    } else {
      popup.parentNode.selectedIndex = 1;
    }
  }
}

function setAction(a, b) {
  action = 'Assign ' + a.toLowerCase() + ' to ';
  actionBit = b;
  if(newnodes) updateInterpolate();
}

function assign() {
  var text = new Array();
  for(var mac in interpol) {
    if(interpol[mac][0]) text.push(interpol[mac][1]);
  }
  if(text.length == 0) {
    dock.displayInfo("You must assign at least one node");
  } else {
    text = dotFormat(text);
        
    var args = new Object();
    args['question'] = "Assign nodes and save: " + text + "?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      assignSave(true);
      parent.refresh();
    }
    d.onNo = function() {
      parent.refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function assignSave(save) {
  var fullInstall = document.getElementById('fullInstall').checked;
  for(var mac in interpol) {
    if(interpol[mac][0]) {
      if(fullInstall) {
        interpol[mac][0].set('nextBootInstallMode', 'FULL');
      }
      if(actionBit & 1) {
        interpol[mac][0].set('mac', mac);
      }
      if((actionBit & 2) && (interpol[mac][2] != null) && (typeof(interpol[mac][2]) == 'object')) {
        var sp = interpol[mac][0].get('ethernetSwitch');
        if(!sp) {
          sp = dock.cvSwitchPort();
          var tmp = new dock.cvObject(current, sp);
        }
        sp.ethernetSwitch = interpol[mac][2].ethernetSwitch;
        sp.prt = interpol[mac][2].prt;
        sp.modified = true;
        interpol[mac][0].set('ethernetSwitch', sp);
      }
      if(save) interpol[mac][0].commit();
    }
  }  
}
