/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'FSExport';
var subfield = 'fsexports';
var singular = 'fs export';
var plural = 'fs exports';
var editfile = 'editfsexport.xul';

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node fsexport" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  tree = document.getElementById('tree');
  data = new Array();
  var exports = current.get(subfield);
  for(var i = 0; i < exports.length; i++) {
    if(!exports[i].toBeRemoved || alsoRemoved) {
      data.push(createTreeItem(exports[i], true, i));
    }
  }
  if(current.get('childType') == "MasterNode") {
    document.getElementById('showcategory').setAttribute('hidden', true);
  } else {
    document.getElementById('showcategory').setAttribute('hidden', false);
    if(document.getElementById('showcategory').checked) {
      if(current.get('category')) {
        var category = current.cluster.find(current.get('category'))
        if(category) {
          exports = category.get(subfield);
          for(var i = 0; i < exports.length; i++) {
            data.push(createTreeItem(exports[i], false, -1));
          }
        }
      }
    }
  }
  for(var i = exports.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one, free, i) {
  free = isundefined(free, true);
  var item = new Object();
  if(free) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = 0;
  }
  item['order'] = i;
  item['name'] = one.name;
  item['path'] = one.path;
  if(startswith(one.hosts, '!') && endswith(one.hosts, '!') && one.hosts.length > 2) {
    var network = current.cluster.find(one.hosts.substr(1, one.hosts.length - 2));
    if(isObject(network)) {
      item['hosts'] = network.resolveName() + " (" + network.get('baseAddress') + '/' + network.get('netmaskBits') + ")";
    } else {
      item['hosts'] = one.hosts;
    }
  } else {
    item['hosts'] = one.hosts;
  }
  item['write'] = one.allowWrite;
  item['async'] = one.async;
  item['rdma'] = one.rdma;
  item['rootSquash'] = one.rootSquash;
  item['allSquash'] = one.allSquash;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  item['fsid'] = one.fsid;
  return item;
}
