/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

var basetype = 'FSMount';
var subfield = 'fsmounts';
var singular = 'fs mount';
var plural = 'fs mounts';
var editfile = 'editfsmount.xul';

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node fsmount" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  tree = document.getElementById('tree');
  data = new Array();
  var mounts = current.get(subfield);
  for(var i = 0; i < mounts.length; i++) {
    if(!mounts[i].toBeRemoved || alsoRemoved) {
      data.push(createTreeItem(mounts[i], true, i));
    }
  }
  if(current.get('childType') == "MasterNode") {
    document.getElementById('showcategory').setAttribute('hidden', true);
  } else {
    document.getElementById('showcategory').setAttribute('hidden', false);
    if(document.getElementById('showcategory').checked) {
      if(current.get('category')) {
        var category = current.cluster.find(current.get('category'))
        if(category) {
          mounts = category.get(subfield);
          for(var i = 0; i < mounts.length; i++) {
            data.push(createTreeItem(mounts[i], false, -1));
          }
        }
      }
    }
  }
  for(var i = mounts.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one, free, i) {
  free = isundefined(free, true);
  var item = new Object();
  if(free) {
    item['key'] = one.uniqueKey;
  } else {
    item['key'] = 0;
  }
  item['order'] = i;
  item['device'] = one.device;
  item['mountpoint'] = one.mountpoint;
  item['filesystem'] = one.filesystem;
  item['mountoptions'] = one.mountoptions;
  item['dump'] = one.dump;
  item['rdma'] = one.rdma;
  item['check'] = one.fsck;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  return item;
}

