/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

var alsoRemoved = false;

var basetype = 'GPUSettings';
var subfield = 'gpuSettings';
var singular = 'gpu setting';
var plural = 'gpu settings';
var editfile = 'editgpusettings.xul';

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node " + plural + ' - ' + document.documentURI);

  overview = current.sysInfo;

  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  tree = document.getElementById('tree');
  data = new Array();
  var gpusettings = current.get(subfield);
  for(var i = 0; i < gpusettings.length; i++) {
    if(!gpusettings[i].toBeRemoved || alsoRemoved) {
      data.push(createTreeItem(gpusettings[i]));
    }
  }
  
  if(parseInt(current.cluster.versionInfo.cmdaemonBuild) < 17961) {
    var status = document.getElementById('status');
    if(status) status.setAttribute('hidden', true);
  }
  
  for(var i = gpusettings.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['name'] = one.name;
  item['modified'] = one.modified;
  item['toBeRemoved'] = one.toBeRemoved;
  item['powerLimit'] = one.powerLimit.replace("W", "");
  item['powerMode'] = one.powerMode.replace("_", " ");
  item['eccMode'] = one.eccMode.replace("_", " ");
  item['computeMode'] = one.computeMode.replace("_", " ");
  item['operationMode'] = one.operationMode.replace("_", " ");
  item['persistenceMode'] = one.persistenceMode.replace("_", " ");

  var clockSpeeds = one.clockSpeeds.split("#");
  if (clockSpeeds.length == 2) {
    item['memoryClock'] = clockSpeeds[0];
    item['graphicsClock'] = clockSpeeds[1];
  }

  return item;
}

function sysInfoSet() {
  // no real need for this as it is not doing anything anyway (leaving it in case we don't want to follow up)
  if(current) {
    overview = current.sysInfo;
  } else {
    println('sysInfoSet called without current');
  }
}

function status() {
  var args = new Object();
  args['current'] = current;
  var d = new dock.cvDialog('gpusettingsstatus.xul', args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
