/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var deviceName = 'group';
var deviceNamePlural = 'nodes';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh nodegroup tasks" + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function allNodes(needCommit, alsoMaster) {
  needCommit = isundefined(needCommit, false);
  alsoMaster = isundefined(alsoMaster, true);
  var found = current.get('nodes');
  var list = new Array();
  for(var i = 0; i < found.length; i++) {
    var node = current.cluster.find(found[i]);
    if(node) {
      var key = node.get('uniqueKey');
      if(key > dock.MAX_LOCAL_KEY) {
        if((!needCommit || !node.get('modified')) && !node.get('toBeRemoved')) {
          if(alsoMaster || dock.baseChildTypeCheck(node.object, 'SlaveNode')) {
            list.push(key);
          }
        }
      }
    }
  }
  return list;
}

function locateInRack() {
  current.cluster.locate(current);
}

function provisioningLog() {
  var args = new Object();
  args['nodes'] = allNodes(false, false);
  args['cluster'] = current.cluster;
  var d = new dock.cvDialog("synclog.xul", args);
  dock.dialogs.showDialog(d);
}
