/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node settings" + ' - ' + document.documentURI);
  
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  text('hostname', dock.REGEX_HOSTNAME, '', true);
  text('tag');
  partial('mac', ':', '^[0-9a-fA-F]{2}$', '', false, '00:00:00:00:00:00', 0, '6..21', '00');

  rackPostionSettings();
  
  resolve('category', 'NodeCategory');
  autorefresh('category');

  var from;
  var def = current.get('category');
  if(def) {
    def = current.cluster.find(def);
    if(def) {
      from = def.resolveName();
      def = def.get('managementNetwork');
    }
  }
  if(!def) {
    def = current.get('partition');
    if(def) {
      def = current.cluster.find(def);
      if(def) {
        from = def.resolveName();
        if(def) def = def.get('managementNetwork');
      }
    }
  }
  if(def) {
    def = current.cluster.find(def);
    def = def.resolveName() + ' (' + from + ')';
  } else {
    def = true;
  }

  resolve('managementNetwork', 'Network', '', def);

  text('finalize');
  text('initialize');

  var list = ['none', 'apc', 'ipmi0', 'ilo0', 'drac0', 'custom', 'cloud', 'openstack'];
  if(current.cluster.isUCS()) list.push('cimc0');
  var networks = current.get('networks');
  for(var i = 0; i < networks.length; i++) {
    var name = networks[i].name;
    if((list.find(name) < 0) && (startswith(name, 'ipmi') || startswith(name, 'ilo') || startswith(name, 'cimc') || startswith(name, 'drac'))) {
      list.push(name);
    }    
  }
  var pwctl = current.get('powerControl');
  if((list.find(pwctl) < 0) && (startswith(pwctl, 'ipmi') || startswith(pwctl, 'ilo') || startswith(pwctl, 'cimc') || startswith(name, 'drac'))) {
    list.push(pwctl);
  }
  list.sort();
  kenum('powerControl', list);
  text('customPowerScript');
  text('customPowerScriptArgument');
  text('customPingScript');
  text('customPingScriptArgument');
  text('userdefined1');
  text('userdefined2');
  text('revision');
  text('pxelabel');
  text('customRemoteConsoleScript');
  text('customRemoteConsoleScriptArgument');
  text('cpuspeedGovernor', '^[a-z]*$');
  createApc();

  if(dock.baseChildTypeCheck(current.object, 'SlaveNode')) {
    var category = current.cluster.find(current.get('category'));
    var oc = '';
    if(!!category) {
      check('installBootRecord', category.get('installBootRecord'));
      check('dataNode', category.get('dataNode'));
      oc = category.get('useExclusivelyFor') + '(Category)';
      category = category.get('installMode') + '(Category)';
    } else {
      check('installBootRecord');
      check('dataNode');
      oc = 'UNDEFINED (Category)';
      category = 'UNDEFINED (Category)';
    }
    kenum('installMode', [['', category], 'AUTO', 'FULL', 'MAIN', 'NOSYNC']);
    kenum('useExclusivelyFor', [['Category', oc], '', 'HPC', 'Hadoop', 'Ceph', 'OpenStack']);
    kenum('nextBootInstallMode', ['', 'AUTO', 'FULL', 'MAIN', 'NOSYNC']);
  } else {
    kenum('useExclusivelyFor', ['', 'HPC', 'Hadoop', 'Ceph', 'OpenStack']);
  }
  
  resolve('ethernetSwitch', 'EthernetSwitch', 'ethernetSwitch', true);
  number('ethernetSwitch', dock.MINSWITCHPORTS, dock.MAXSWITCHPORTS, '', dock.BLACKSWITCHPORTS, 'prt');

  kenum('provisioningTransport', [['RSYNCSSH', 'Rsync SSH'], ['RSYNCDAEMON', 'Rsync Daemon']]);
  elementOf('provisioningNetwork', 'networks');
}
