/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) {
    current = use;
    var sic = new dock.cvSysInfoCollector();
    sic.uniqueKey = -1; // KDR: trick see below
    setCallbackResult(sic);
  }
  println("Refresh node system information" + ' - ' + document.documentURI);

  dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'getSysInfoCollector', current.get('uniqueKey'), function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
}

function setCallbackResult(value) {
  overview = value;
  if(overview == null) return;

  overviewValue('osName');
  overviewValue('osVersion');
  overviewValue('osFlavor');
  overviewValue('biosVendor');
  overviewValue('biosVersion');
  overviewValue('biosDate');
  overviewValue('motherboardName');
  overviewValue('motherboardManufacturer');
  overviewValue('systemName');
  overviewValue('systemManufacturer');
  overviewValue('vendorTag');

  overviewDiskInfo();
  overviewCPUInfo();
  overviewMemoryInfo();
  overviewGPUInfo();
  overviewMICInfo();
  overviewInterconnects();
  overviewDellStorageInfo();
  
  if(overview.uniqueKey >= 0) {
    current.sysInfo = value;
    parent.genericFrameUpdate('sysInfoSet');
  }
}
