/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    current = use;
    if(!current.cluster) {
      current = use.getBasePartition();
    }
  }
  println("Refresh device notes" + ' - ' + document.documentURI);
  var obj = document.getElementById("notes");
  obj.value = current.get('notes');
  obj.addEventListener("change", notes_change, true);
  obj.addEventListener("keypress", notes_keypress, true);
  
  if(parent.detached) {
    document.getElementById('saverevert').setAttribute('hidden', true);
  }
}


function notes_keypress(event) {
  var text = document.getElementById("notes");
  var value = text.value;
  switch(event.keyCode) {
    case KEY_ESCAPE:
      text.value = current.get('notes');
      break;
    default:
      var save = document.getElementById('save');
      if(save) {
        save.setAttribute('disabled', false);
        //save.clearAttribute('disabled');
      }
  }
}

function notes_change(event) {
  var xml = document.getElementById("notes").value;
  current.set('notes', xml);
}
