/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var openstack;
var object;
var old;
var current;
var myDialog;
var dock;
var cluster;
var subobject;
var parent;

var fieldname = '';
var displayInTree = false;
var subtype = '';
var singular = 'tenant';
var plural = 'tenants';
var nodeSelectionProperties = [['','', false],
                                 ['name', 'name', false]
                                ];
var belongs = '0';
var noloop = 'true';
var extraName = "''";
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';
var nodesicon = 'Tenant_16.png';

var currentnodes;
var subtypeList;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  object = myDialog.arguments.object;
  subobject = myDialog.arguments.subobject;
  current = myDialog.arguments.role;
  parent =  myDialog.arguments.parent;

  var openstacks = cluster.find('OpenStack');
  if(openstacks.length > 0) {
    openstack = openstacks[0];
  } else {
    println('No OpenStack configuration found');
    return;
  }

  var tenants = openstack.get('openStackTenants');
  subtypeList = new Array();
  for(var i = 0; i < tenants.length; i++) {
    subtypeList.push(new dock.cvObject(cluster, tenants[i], openstack, 'openStackTenants'));
  }

  current = new dock.cvObject(cluster, current);

  if(myDialog.arguments.role <= 0) {
    newEdit = true;
    setDialogTitle("New User Role")
  } else {
    newEdit = false;
  }
  refresh();
}

function refresh() {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');

  text('name');
  text('roleID');

  currentnodes = current.get('tenants');
  deviceselect();

  setfocus('name');
}

function ok() {
  if(!window.closed) {
    if(blank(current.get('name'))) {
      dock.displayError("Name cannot be empty");
      return;
    }
    if(newEdit) {
      var list = object.get('roles');
      list.push(current.object);
      object.set('roles', list);
    } else if(current.get('modified')) {
      object.set('modified', true);
    }
    openstack.set('modified', true);
    dock.currentTab.contentWindow.refresh();
    parent.refresh();
    close();
  }
}

function cancel() {
  if(!window.closed) {
    if(!newEdit) current.old(old);
    close();
  }
}
