/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var object;
var old;
var current;
var myDialog;
var dock;
var cluster;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;

  if(isObject(object)) {
    old = object.old(false, true);
    refresh();
  } else {
    dock.displayError("Key no longer valid");
    myDialog.doCancel();
    close();
  }
}

function refresh() {
  document.getElementById('password2').value = current.get('password');
  check('addToOpenStack');
  check('enabled');
  text('password', '');
  text('userUUID');
  //var roles = current.get('roles');
  //setOpenStackUserRole(roles);
}

function ok() {
  if(current.get('modified')) {
    object.set('modified', true);
    if(document.getElementById('password2').value != current.get('password')) {
      dock.displayError("Password mismatch");
      return;
    }
    if(current.get('password').length > 0) {
      dock.displayInfo("Note: OpenStack user passwords are not kept in Bright Cluster Manager's database, but only kept in Keystone's database. CMGUI will make sure the password is set for the user and will clean it next time in its OpenStack user settings window (but not in the Keystone's database).");
    }
  }
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    object.old(old);
    close();
  }
}
/*
function setOpenStackUserRole(roles) {
  var rows = document.getElementById('userRoles');
  if(rows) {
    while(rows.firstChild) rows.removeChild(rows.firstChild);
    var last = roles.length - 1;
    while(last >= 0) {
      if(!roles[last].toBeRemoved) break;
      last--;
    }
    for(var i = 0; i < roles.length; i++) {
      if(roles[i].toBeRemoved) continue;
      var row = document.createElement('row');
      row.setAttribute('align', 'center');
      var textbox = document.createElement('textbox');
      textbox.setAttribute('id', roles[i].childType + '_' + i + '_name');
      textbox.setAttribute('type', 'text');
      textbox.setAttribute('width', '270px');
      textbox.setAttribute('readonly', 'true');
      textbox.setAttribute('value', roles[i].name);
      row.appendChild(textbox);

      var hbox = document.createElement('vbox');
      hbox.setAttribute('flex', 1);
      var button = document.createElement('button');
      button.setAttribute('class', 'graybutton');
      button.setAttribute('label', 'Modify');
      button.setAttribute('oncommand', 'editOpenStackUserRole(' + i + ');');
      hbox.appendChild(button);
      row.appendChild(hbox);

      var button = document.createElement('button');
      button.setAttribute('class', 'minus-button');
      button.setAttribute('oncommand', 'removeOpenStackUserRole(' + i + ');');
      row.appendChild(button);

      if(i == last) {
        var button = document.createElement('button');
        button.setAttribute('class', 'plus-button');
        button.setAttribute('oncommand', 'addOpenStackUserRole();');
        row.appendChild(button);
      } else {
        var spacer = document.createElement('spacer');
        row.appendChild(spacer);
      }
      rows.appendChild(row);
      document.getElementById('rolesStatus').setAttribute('hidden', 'true');
    }
    if(last < 0) {
      document.getElementById('rolesStatus').setAttribute('hidden', 'false');
      var row = document.createElement('row');
      var button = document.createElement('button');
      button.setAttribute('class', 'graybutton');
      button.setAttribute('label', 'Add User Roles');
      button.setAttribute('oncommand', 'addOpenStackUserRole();');
      row.appendChild(button);
      rows.appendChild(row);
    }
  } else {
    println('No rows for ' + roles.childType);
  }
}

function addOpenStackUserRole() {
  var roles = current.get('roles');
  var role = new dock.cvOpenStackUserRole();
  role.name = '';
  roles.push(role);
  roles.modified = true;
  current.set('modified', true);
  refresh();
}

function removeOpenStackUserRole(i) {
  var roles = current.get('roles');
  roles[i].toBeRemoved = true;
  roles[i].modified = true;
  current.set('modified', true);
  refresh();
}

function editOpenStackUserRole(i) {
  var roles = current.get('roles');
  var editfile = 'chrome://cmgui/content/openstack/advancedopenstackuserrole.xul';
  var args = new Object();
  args['object'] = object;
  args['subobject'] = current;
  args['cluster'] = cluster;
  args['role'] = roles[i];
  args['parent'] = this;
  var d = new dock.cvDialog(editfile, args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
  
}
*/