/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleAgent() {
  this.addTitle = "Add Agent";
  this.editTitle = "Edit Agent";
  this.api = 'Agent';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiAgent = new editorController.dock.cvOpenStackApiAgent();
      cvDataOpenStackApiAgent.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiAgent, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.setEditable = function(editorController) {
    editorController.editable = false;
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('serviceType', '^');
    text('binary', '^');
    text('host', '^');
    text('currentState', '^');
    text('lastSeen', '^');
    text('availabilityZone', '^');
    text('status', '^');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleAgent.prototype = new EditorRuleBase();
EditorRuleAgent.prototype.constructor = EditorRuleAgent;