/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function SubTabConf() {
  this.props = {};

  this.props.Agent = {
    container: 'systeminfo',
    api: 'Agent',
    title: {
      singular: 'Agent',
      plural: 'Agents'
    },
    order: 12
  };

  this.props.Domain = {
    container: 'identity',
    api: 'Domain',
    title: {
      singular: 'Domain',
      plural: 'Domains'
    },
    order: 4
  };

  this.props.Endpoint = {
    container: 'identity',
    api: 'Endpoint',
    title: {
      singular: 'Endpoint',
      plural: 'Endpoints'
    },
    order: 6
  };

  this.props.Flavor = {
    container: 'compute',
    api: 'Flavor',
    title: {
      singular: 'Flavor',
      plural: 'Flavors'
    },
    order: 10,
    'filter': {deleted: false}
  };

  this.props.FloatingIP = {
    container: 'network',
    api: 'FloatingIP',
    title: {
      singular: 'Floating IP',
      plural: 'Floating IPs'
    },
    order: 22
  };

  this.props.Group = {
    container: 'identity',
    api: 'Group',
    title: {
      singular: 'Group',
      plural: 'Groups'
    },
    order: 2
  };

  this.props.HostAggregate = {
    container: 'systeminfo',
    api: 'HostAggregate',
    title: {
      singular: 'Host Aggregate',
      plural: 'Host Aggregates'
    },
    order: 17
  };

  this.props.Hypervisor = {
    container: 'systeminfo',
    api: 'Hypervisor',
    title: {
      singular: 'Hypervisor',
      plural: 'Hypervisors'
    },
    order: 23
  };

  this.props.Image = {
    container: 'compute',
    api: 'Image',
    title: {
      singular: 'Image',
      plural: 'Images'
    },
    order: 11
  };

  this.props.Network = {
    container: 'network',
    api: 'Network',
    title: {
      singular: 'Network',
      plural: 'Networks'
    },
    order: 18
  };

  this.props.Node = {
    container: 'nocontainer',
    api: 'Node',
    title: {
      singular: 'Node',
      plural: 'Nodes'
    },
    order: 24
  };

  this.props.Port = {
    container: 'network',
    api: 'Port',
    title: {
      singular: 'Port',
      plural: 'Ports'
    },
    order: 20
  };

  this.props.Project = {
    container: 'identity',
    api: 'Project',
    title: {
      singular: 'Project',
      plural: 'Projects'
    },
    order: 3
  };

  this.props.Role = {
    container: 'identity',
    api: 'Role',
    title: {
      singular: 'Role',
      plural: 'Roles'
    },
    order: 7
  };

  this.props.RoleAssignment = {
    container: 'identity',
    api: 'RoleAssignment',
    title: {
      singular: 'Role Assignment',
      plural: 'Role Assignments'
    },
    order: 8
  };

  this.props.Router = {
    container: 'network',
    api: 'Router',
    title: {
      singular: 'Router',
      plural: 'Routers'
    },
    order: 21
  };

  this.props.SecurityGroup = {
    container: 'compute',
    api: 'SecurityGroup',
    title: {
      singular: 'Security Group',
      plural: 'Security Groups'
    },
    order: 16
  };

  this.props.Server = {
    container: 'compute',
    api: 'Server',
    title: {
      singular: 'Server',
      plural: 'Servers'
    },
    order: 9
  };

  this.props.Service = {
    container: 'identity',
    api: 'Service',
    title: {
      singular: 'Service',
      plural: 'Services'
    },
    order: 5
  };

  this.props.Subnet = {
    container: 'network',
    api: 'Subnet',
    title: {
      singular: 'Subnet',
      plural: 'Subnets'
    },
    order: 19
  };

  this.props.User = {
    container: 'identity',
    api: 'User',
    title: {
      singular: 'User',
      plural: 'Users'
    },
    order: 1
  };

  this.props.Volume = {
    container: 'compute',
    api: 'Volume',
    title: {
      singular: 'Volume',
      plural: 'Volumes'
    },
    order: 13
  };

  this.props.VolumeSnapshot = {
    container: 'compute',
    api: 'VolumeSnapshot',
    title: {
      singular: 'Volume Snapshot',
      plural: 'Volume Snapshots'
    },
    order: 15
  };

  this.props.VolumeType = {
    container: 'compute',
    api: 'VolumeType',
    title: {
      singular: 'Volume Type',
      plural: 'Volume Types'
    },
    order: 14
  };

  this.getContainer = function(container) {
    var containers = new Array();
    for(var attribute in this.props) {
      if (this.props[attribute].container === container) {
        containers.push(this.props[attribute]);
      }
    }
    containers.sort(function(a, b) {
      if(a.order < b.order) {
        return -1;
      } else if(a.order > b.order) {
        return 1;
      }
      return 0;
    });
    return containers;
  };
}
