/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function getSubTabsFor(cluster, api, key) {
  var subtabs = new Array();
  var one = cluster.find(key);
  if(one) {
    if(api === 'Agent') {
      subtabs = [
      ];
    } else if(api === 'Domain') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.plural,
          filter: {domainKey: key}
        },
        {
          container: subTabConf.props.User.container,
          api: subTabConf.props.User.api,
          title: subTabConf.props.User.title.plural,
          filter: {domainKey: key}
        },
        {
          container: subTabConf.props.Group.container,
          api: subTabConf.props.Group.api,
          title: subTabConf.props.Group.title.plural,
          filter: {domainKey: key}
        },
//        {
//          container: subTabConf.props.Role.container,
//          api: subTabConf.props.Role.api,
//          title: subTabConf.props.Role.title.plural,
//          filter: {domainKey: key}
//        },
        {
          container: subTabConf.props.RoleAssignment.container,
          api: subTabConf.props.RoleAssignment.api,
          title: subTabConf.props.RoleAssignment.title.plural,
          filter: {domainKey: key}
        }
      ];
    } else if(api === 'Endpoint') {
      subtabs = [
        {
          container: subTabConf.props.Service.container,
          api: subTabConf.props.Service.api,
          title: subTabConf.props.Service.title.singular,
          filter: {uniqueKey: one.get('serviceKey')}
        }
      ];
    } else if(api === 'Flavor') {
      subtabs = [
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.plural,
          filter: {flavorKey: key}
        }
/*
 * Disabled until it gets implemented properly in cmdaemon
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.plural,
          filter: {uniqueKey: one.get('projectKeys')}
        }
*/
      ];
    } else if(api === 'FloatingIP') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Network.container,
          api: subTabConf.props.Network.api,
          title: subTabConf.props.Network.title.singular,
          filter: {uniqueKey: one.get('floatingNetworkKey')}
        },
        {
          container: subTabConf.props.Router.container,
          api: subTabConf.props.Router.api,
          title: subTabConf.props.Router.title.singular,
          filter: {uniqueKey: one.get('routerKey')}
        },
        {
          container: subTabConf.props.Port.container,
          api: subTabConf.props.Port.api,
          title: subTabConf.props.Port.title.singular,
          filter: {uniqueKey: one.get('portKey')}
        }
      ];
    } else if(api === 'Group') {
      subtabs = [
        {
          container: subTabConf.props.Domain.container,
          api: subTabConf.props.Domain.api,
          title: subTabConf.props.Domain.title.singular,
          filter: {uniqueKey: one.get('domainKey')}
        },
        {
          container: subTabConf.props.User.container,
          api: subTabConf.props.User.api,
          title: subTabConf.props.User.title.plural,
          filter: {groupKeys: key}
        },
        {
          container: subTabConf.props.RoleAssignment.container,
          api: subTabConf.props.RoleAssignment.api,
          title: subTabConf.props.RoleAssignment.title.plural,
          filter: {groupKey: key}
        }
      ];
    } else if(api === 'HostAggregate') {
      subtabs = [
      ];
    } else if(api === 'Hypervisor') {
      subtabs = [
        {
          container: subTabConf.props.Node.container,
          api: subTabConf.props.Node.api,
          title: subTabConf.props.Node.title.singular,
          filter: {hostname: getHostname(one.get('name'))}
        }
      ];
    } else if(api === 'Image') {
      subtabs = [
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.plural,
          filter: {imageKey: key}
        },
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        }
      ];
    } else if(api === 'Network') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Port.container,
          api: subTabConf.props.Port.api,
          title: subTabConf.props.Port.title.plural,
          filter: {networkKey: key}
        },
        {
          container: subTabConf.props.Subnet.container,
          api: subTabConf.props.Subnet.api,
          title: subTabConf.props.Subnet.title.plural,
          filter: {uniqueKey: one.object.subnetKeys}
        },
        {
          container: subTabConf.props.FloatingIP.container,
          api: subTabConf.props.FloatingIP.api,
          title: subTabConf.props.FloatingIP.title.plural,
          filter: {floatingNetworkKey: key}
        },
        {
          container: subTabConf.props.Router.container,
          api: subTabConf.props.Router.api,
          title: subTabConf.props.Router.title.plural,
          filter: {externalGatewayNetworkKey: key}
        }
      ];
    } else if(api === 'Node') {
      subtabs = [
      ];
    } else if(api === 'Port') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Network.container,
          api: subTabConf.props.Network.api,
          title: subTabConf.props.Network.title.singular,
          filter: {uniqueKey: one.get('networkKey')}
        },
        {
          container: subTabConf.props.FloatingIP.container,
          api: subTabConf.props.FloatingIP.api,
          title: subTabConf.props.FloatingIP.title.plural,
          filter: {portKey: key}
        },
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.singular,
          filter: {UUID: one.get('deviceUUID')}
        },
        {
          container: subTabConf.props.Router.container,
          api: subTabConf.props.Router.api,
          title: subTabConf.props.Router.title.singular,
          filter: {UUID: one.get('deviceUUID')}
        },
        {
          container: subTabConf.props.SecurityGroup.container,
          api: subTabConf.props.SecurityGroup.api,
          title: subTabConf.props.SecurityGroup.title.plural,
          filter: {uniqueKey: one.get('securityGroupKeys')}
        }
      ];
    } else if(api === 'Project') {
      subtabs = [
        {
          container: subTabConf.props.Domain.container,
          api: subTabConf.props.Domain.api,
          title: subTabConf.props.Domain.title.singular,
          filter: {uniqueKey: one.get('domainKey')}
        },
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.FloatingIP.container,
          api: subTabConf.props.FloatingIP.api,
          title: subTabConf.props.FloatingIP.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.Network.container,
          api: subTabConf.props.Network.api,
          title: subTabConf.props.Network.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.Port.container,
          api: subTabConf.props.Port.api,
          title: subTabConf.props.Port.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.Router.container,
          api: subTabConf.props.Router.api,
          title: subTabConf.props.Router.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.Subnet.container,
          api: subTabConf.props.Subnet.api,
          title: subTabConf.props.Subnet.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.Volume.container,
          api: subTabConf.props.Volume.api,
          title: subTabConf.props.Volume.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.VolumeSnapshot.container,
          api: subTabConf.props.VolumeSnapshot.api,
          title: subTabConf.props.VolumeSnapshot.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.RoleAssignment.container,
          api: subTabConf.props.RoleAssignment.api,
          title: subTabConf.props.RoleAssignment.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.Image.container,
          api: subTabConf.props.Image.api,
          title: subTabConf.props.Image.title.plural,
          filter: {projectKey: key}
        },
        {
          container: subTabConf.props.SecurityGroup.container,
          api: subTabConf.props.SecurityGroup.api,
          title: subTabConf.props.SecurityGroup.title.plural,
          filter: {projectKey: key}
        }
/*
 * Disabled until it gets implemented properly in cmdaemon
        {
          container: subTabConf.props.Flavor.container,
          api: subTabConf.props.Flavor.api,
          title: subTabConf.props.Flavor.title.plural,
          filter: {projectKeys: key}
        }
*/
      ];
    } else if(api === 'Role') {
      subtabs = [
//        {
//          container: subTabConf.props.Domain.container,
//          api: subTabConf.props.Domain.api,
//          title: subTabConf.props.Domain.title.singular,
//          filter: {uniqueKey: one.get('domainKey')}
//        },
        {
          container: subTabConf.props.RoleAssignment.container,
          api: subTabConf.props.RoleAssignment.api,
          title: subTabConf.props.RoleAssignment.title.plural,
          filter: {roleKey: key}
        }
      ];
    } else if(api === 'RoleAssignment') {
      subtabs = [
        {
          container: subTabConf.props.Role.container,
          api: subTabConf.props.Role.api,
          title: subTabConf.props.Role.title.singular,
          filter: {uniqueKey: one.get('roleKey')}
        },
        {
          container: subTabConf.props.Domain.container,
          api: subTabConf.props.Domain.api,
          title: subTabConf.props.Domain.title.singular,
          filter: {uniqueKey: one.get('domainKey')}
        },
        {
          container: subTabConf.props.User.container,
          api: subTabConf.props.User.api,
          title: subTabConf.props.User.title.singular,
          filter: {uniqueKey: one.get('userKey')}
        },
        {
          container: subTabConf.props.Group.container,
          api: subTabConf.props.Group.api,
          title: subTabConf.props.Group.title.singular,
          filter: {uniqueKey: one.get('groupKey')}
        },
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        }
      ];
    } else if(api === 'Router') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.FloatingIP.container,
          api: subTabConf.props.FloatingIP.api,
          title: subTabConf.props.FloatingIP.title.plural,
          filter: {routerKey: key}
        },
        {
          container: subTabConf.props.Network.container,
          api: subTabConf.props.Network.api,
          title: 'External gw ' + subTabConf.props.Network.title.singular,
          filter: {uniqueKey: one.get('externalGatewayNetworkKey')}
        },
        {
          container: subTabConf.props.Port.container,
          api: subTabConf.props.Port.api,
          title: subTabConf.props.Port.title.plural,
          filter: {deviceUUID: one.get('UUID'), deviceOwner: 'network:router_.+'}
        }
      ];
    } else if(api === 'SecurityGroup') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.plural,
          filter: {securityGroupKeys: key}
        },
        {
          container: subTabConf.props.Port.container,
          api: subTabConf.props.Port.api,
          title: subTabConf.props.Port.title.plural,
          filter: {securityGroupKeys: key}
        }
      ];
    } else if(api === 'Server') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.User.container,
          api: subTabConf.props.User.api,
          title: subTabConf.props.User.title.singular,
          filter: {uniqueKey: one.get('userKey')}
        },
        {
          container: subTabConf.props.Flavor.container,
          api: subTabConf.props.Flavor.api,
          title: subTabConf.props.Flavor.title.singular,
          filter: {uniqueKey: one.get('flavorKey')}
        },
        {
          container: subTabConf.props.Image.container,
          api: subTabConf.props.Image.api,
          title: subTabConf.props.Image.title.singular,
          filter: {uniqueKey: one.get('imageKey')}
        },
        {
          container: subTabConf.props.Volume.container,
          api: subTabConf.props.Volume.api,
          title: subTabConf.props.Volume.title.plural,
          filter: {attachmentServerKey: key}
        },
        {
          container: subTabConf.props.Port.container,
          api: subTabConf.props.Port.api,
          title: subTabConf.props.Port.title.plural,
          filter: {deviceUUID: one.get('UUID'), deviceOwner: 'compute:.+'}
        },
        {
          container: subTabConf.props.SecurityGroup.container,
          api: subTabConf.props.SecurityGroup.api,
          title: subTabConf.props.SecurityGroup.title.plural,
          filter: {uniqueKey: one.get('securityGroupKeys')}
        }
      ];
    } else if(api === 'Service') {
      subtabs = [
        {
          container: subTabConf.props.Endpoint.container,
          api: subTabConf.props.Endpoint.api,
          title: subTabConf.props.Endpoint.title.plural,
          filter: {serviceKey: key}
        }
      ];
    } else if(api === 'Subnet') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Network.container,
          api: subTabConf.props.Network.api,
          title: subTabConf.props.Network.title.singular,
          filter: {uniqueKey: one.get('networkKey')}
        }
      ];
    } else if(api === 'User') {
      subtabs = [
        {
          container: subTabConf.props.Domain.container,
          api: subTabConf.props.Domain.api,
          title: subTabConf.props.Domain.title.singular,
          filter: {uniqueKey: one.get('domainKey')}
        },
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.plural,
          filter: {userKey: key}
        },
        {
          container: subTabConf.props.Group.container,
          api: subTabConf.props.Group.api,
          title: subTabConf.props.Group.title.plural,
          filter: {uniqueKey: one.object.groupKeys}
        },
        {
          container: subTabConf.props.RoleAssignment.container,
          api: subTabConf.props.RoleAssignment.api,
          title: subTabConf.props.RoleAssignment.title.plural,
          filter: {userKey: key}
        }
      ];
    } else if(api === 'Volume') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Server.container,
          api: subTabConf.props.Server.api,
          title: subTabConf.props.Server.title.singular,
          filter: {uniqueKey: one.get('attachmentServerKey')}
        },
        {
          container: subTabConf.props.Volume.container,
          api: subTabConf.props.Volume.api,
          title: subTabConf.props.Volume.title.singular,
          filter: {uniqueKey: one.get('sourceVolumeKey')}
        },
        {
          container: subTabConf.props.VolumeType.container,
          api: subTabConf.props.VolumeType.api,
          title: subTabConf.props.VolumeType.title.singular,
          filter: {uniqueKey: one.get('volumeTypeKey')}
        },
        {
          container: subTabConf.props.VolumeSnapshot.container,
          api: subTabConf.props.VolumeSnapshot.api,
          title: subTabConf.props.VolumeSnapshot.title.plural,
          filter: {volumeKey: key}
        }
      ];
    } else if(api === 'VolumeSnapshot') {
      subtabs = [
        {
          container: subTabConf.props.Project.container,
          api: subTabConf.props.Project.api,
          title: subTabConf.props.Project.title.singular,
          filter: {uniqueKey: one.get('projectKey')}
        },
        {
          container: subTabConf.props.Volume.container,
          api: subTabConf.props.Volume.api,
          title: subTabConf.props.Volume.title.singular,
          filter: {uniqueKey: one.get('volumeKey')}
        }
      ];
    } else if(api === 'VolumeType') {
      subtabs = [
        {
          container: subTabConf.props.Volume.container,
          api: subTabConf.props.Volume.api,
          title: subTabConf.props.Volume.title.plural,
          filter: {volumeTypeKey: key}
        }
      ];
    }
  } else {
    println("Unable to find: " + key + " for " + api);
  }
  return subtabs;

  function getHostname(fqdn) {
    var hostnameEntity = new HostnameEntity();
    hostnameEntity.setFQDN(fqdn);
    return hostnameEntity.getHostname();
  }
}

var subTabConf = new SubTabConf();
