/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
var newEdit;
var object;
var role;
var old;
var current;
var myDialog;
var dock;
var cluster;
var volumeBackendsVec;
var backendCeph;
var backendFs;
var idx;
var lastIdx;
var list = ['none', 'Ceph', 'NFS'];

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  backendCeph = new dock.cvOpenStackVolumeBackendCeph();
  backendFs  = new dock.cvOpenStackVolumeBackendNFS();

  newEdit = false;
  object = myDialog.arguments.object;
  role = myDialog.arguments.subobject;

  cluster = myDialog.arguments.subobject.cluster;
  volumeBackendsVec = role.get('volumeBackends');

  document.getElementById('deck').selectedIndex = 1; 
  document.getElementById('isCeph').setAttribute('on', true);

  lastIdx = idx = 0;
  if (volumeBackendsVec.length > 0) {
    if (volumeBackendsVec.length >= 2) {
      println("WARN: update cmgui");
    }

    current = 0;
    for (var i = 0; i < volumeBackendsVec.length; ++i) {
      if (!volumeBackendsVec[i].toBeRemoved) {
        current = volumeBackendsVec[i];
        break;
      }
    }

    if (current){
      var baseType = current.baseType;
      var childType = current.childType;
      var backendVolumeType = childType.substr(baseType.length, childType.length);
      current = new dock.cvObject(object.cluster, current, role, 'volumeBackends');
      if (backendVolumeType == 'Ceph') {
        idx = 1;
      } else if (backendVolumeType == 'NFS'){
        idx = 2;
      }
    }
  } else {
    idx = 0;
  }

  setBackendType(idx);
  lastIdx = idx;

}

function refresh(index) {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  document.getElementById('deck').selectedIndex = index;
  switch(index) {
    case(0): none(); break;
    case(1): ceph(); break;
    case(2): filesystem(); break;
  }
}


function none() {
  document.getElementById('baseInfo').setAttribute('hidden', true);
  for (var i = 0; i < volumeBackendsVec.length; ++i) {
    volumeBackendsVec[i].toBeRemoved = true;
  }
  idx = 0;
  current = 0;
}

function ceph() {
  document.getElementById('baseInfo').setAttribute('hidden', false);

  var len = volumeBackendsVec.length;
  idx = 1;

  if (len == 0) {
    current = backendCeph;
    volumeBackendsVec.push(backendCeph);
    current = new dock.cvObject(object.cluster, current, role, 'volumeBackends');
  } else if (len == 1) {
    if (getBackendType(volumeBackendsVec[0]) == 'Ceph') {
      volumeBackendsVec[0].toBeRemoved = false;
      current = volumeBackendsVec[0];
      current = new dock.cvObject(object.cluster, current, role, 'volumeBackends');
    } else {
      current = backendCeph;
      volumeBackendsVec.push(backendCeph);
      current = new dock.cvObject(object.cluster, current, role, 'volumeBackends');
    }
  } else if (len == 2) {
    if (getBackendType(volumeBackendsVec[0]) == 'Ceph') {
      volumeBackendsVec[0].toBeRemoved = false;
      current = volumeBackendsVec[0];
      current = new dock.cvObject(object.cluster, current, role, 'volumeBackends');
    }
    else if (getBackendType(volumeBackendsVec[1]) == 'Ceph') {
      volumeBackendsVec[1].toBeRemoved = false;
      current = volumeBackendsVec[1];
      current = new dock.cvObject(object.cluster, current, role, 'volumeBackends');
    } else {
      return;
    }
  }

  text('name', '');
  text('volumeDriver', '');
  text('rbdPool', '');
  text('rbdMaxCloneDepth', '');
  text('rbdUser', '');
  text('rbdSecretUuid', '');
  text('rbdCephConf', '');
  var check = document.getElementById('rbdFlattenVolumeFromSnapshot');
  if (current.object.rbdFlattenVolumeFromSnapshot) {
    check.setAttribute('rbdFlattenVolumeFromSnapshot', true);
  } else {
    check.setAttribute('rbdFlattenVolumeFromSnapshot', false);
  }

  if ( document.getElementById('volumeDriver').value.length == 0 ){
    document.getElementById('volumeDriver').value = 'cinder.volume.drivers.rbd.RBDDriver';
  }
  setfocus('name');
}

function filesystem() {
  document.getElementById('baseInfo').setAttribute('hidden', false);
  var newKey = 0;
  if (newEdit) newKey = current.get('uniqueKey');

  var len = volumeBackendsVec.length;
  var cur = 0;

  for (var i = 0; i < volumeBackendsVec.length; ++i) {
    if (getBackendType(volumeBackendsVec[i]) == 'NFS') {
      volumeBackendsVec[i].toBeRemoved = false;
      cur = volumeBackendsVec[i];
    } else {
      volumeBackendsVec[i].toBeRemoved = true;
    }
  }
  if (!cur) {
    cur = backendFs;
    if (len > 2) return;
    if (len < 2) volumeBackendsVec.push(backendFs);
  }
  idx = 2;
  current = new dock.cvObject(object.cluster, cur, role, 'volumeBackends');

  text('name', '');
  text('volumeDriver', '');
  text('nfsDiskUtil', '');
  text('nfsMountPointBase', '');
  text('nfsSparsedVolumes', '');
  text('nfsSharesConfig', '');
  stringlist('nfsShares', '');

  if ( document.getElementById('volumeDriver').value.length == 0 ){
    document.getElementById('volumeDriver').value = 'cinder.volume.drivers.nfs.NfsDriver';
  }

  setfocus('name');
}

function ok() {
  if ( idx > 0 ){
    var name = document.getElementById('name').value;
    if ( name.length > 24 ){
      dock.displayError('Name field is too long. Maximum allowed characters is 24.');
      return false;
    }
    if (name == ''){
      dock.displayError('Name field cannot be empty');
      return false;
    }
  }
  if (lastIdx != idx) {
    var args = new Object();
    args['question'] = "Are you sure you want to change the backend from " + list[lastIdx] + " to " + list[idx];
    var d = new dock.cvDialog("chrome://cmgui/content/question.xul", args);
    d.onOk = function(force) {
      if(!window.closed) {
        myDialog.doOk();
        close();
        lastIdx = idx;
        role.set('modified', true);
        object.set('modified', true);
      }
    }
    dock.dialogs.showDialog(d);
  } else {
    if(!window.closed) {
      role.set('modified', true);
      object.set('modified', true);
      myDialog.doOk();
      close();
      lastIdx = idx;
    }
  }
}

function cancel() {
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}

function setBackendType(index) {
  document.getElementById('deck').selectedIndex = index;

  if (!eval(document.getElementById('isNone').getAttribute('disabled'))) {
    document.getElementById('isNone').setAttribute('on', index == 0);
    document.getElementById('isCeph').setAttribute('on', index == 1);
    document.getElementById('isFilesystem').setAttribute('on', index == 2);
  }
  refresh(index);
}

function getBackendType (cur) {
  var baseType = cur.baseType;
  var childType = cur.childType;
  var backendVolumeType = childType.substr(baseType.length, childType.length);
  return backendVolumeType;
}

