/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var role;
var old;
var current;
var myDialog;
var dock;
var cluster;
var imageBackendsVec;
var backendCeph;
var backendCow;
var idx;
var lastIdx;
var list = ['none', 'Ceph', 'Cow'];

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  backendCeph = new dock.cvOpenStackNovaImageBackendCeph();
  backendCow  = new dock.cvOpenStackNovaImageBackendCow();

  newEdit = false;
  object = myDialog.arguments.object;
  role = myDialog.arguments.subobject;

  cluster = myDialog.arguments.subobject.cluster;
  imageBackendsVec = role.get('imageBackends');

  document.getElementById('deck').selectedIndex = 1; 
  document.getElementById('isCeph').setAttribute('on', true);

  lastIdx = idx = 0;
  if (imageBackendsVec.length > 0) {
    if (imageBackendsVec.length >= 2) {
      println("WARN: update cmgui");
    }
    current = 0;
    for (var i = 0; i < imageBackendsVec.length; ++i) {
      if (!imageBackendsVec[i].toBeRemoved) {
        current = imageBackendsVec[i];
        break;
      }
    }

    if (current){
      var baseType = current.baseType;
      var childType = current.childType;
      var backendImageType = childType.substr(baseType.length, childType.length);
      current = new dock.cvObject(object.cluster, current, role, 'imageBackends');

      if (backendImageType == 'Cow')  {
        idx = 2;
      } else if (backendImageType == 'Ceph') {
        idx = 1;
      }
    } else {
      idx = 0;
    }
  }
  setBackendType(idx);
  lastIdx = idx;

}

function refresh(index) {
  document.getElementById('deck').selectedIndex = index;

  switch(index) {
    case(0): none(); break;
    case(1): ceph(); break;
    case(2): filesystem(); break;
  }
}

function none() {
  document.getElementById('baseInfo').setAttribute('hidden', true);
  for (var i = 0; i < imageBackendsVec.length; ++i) {
    imageBackendsVec[i].toBeRemoved = true;
  }

  idx = 0;
  current = 0;
}

function ceph() {
  document.getElementById('baseInfo').setAttribute('hidden', false);

  var len = imageBackendsVec.length;
  idx = 1;

  if (len == 0) {
    current = backendCeph;
    imageBackendsVec.push(backendCeph);
    current = new dock.cvObject(object.cluster, current);
  } else if (len == 1) {
    if (getBackendType(imageBackendsVec[0]) == 'Ceph') {
      imageBackendsVec[0].toBeRemoved = false;
      current = imageBackendsVec[0];
      current = new dock.cvObject(object.cluster, current);
    } else {
      current = backendCeph;
      imageBackendsVec.push(backendCeph);
      current = new dock.cvObject(object.cluster, current);
    }
  } else if (len == 2) {
    if (getBackendType(imageBackendsVec[0]) == 'Ceph') {
      imageBackendsVec[0].toBeRemoved = false;
      current = imageBackendsVec[0];
      current = new dock.cvObject(object.cluster, current);
    }
    else if (getBackendType(imageBackendsVec[1]) == 'Ceph') {
      imageBackendsVec[1].toBeRemoved = false;
      current = imageBackendsVec[1];
      current = new dock.cvObject(object.cluster, current);
    } else {
      return;
    }
  }

  var newKey = 0;
  if (newEdit) newKey = current.get('uniqueKey');
  if ( document.getElementById('libvirtImagesType').value == '' ){
    document.getElementById('libvirtImagesType').value = 'default';
  }
  if ( document.getElementById('name').value == '' ){
    document.getElementById('name').value = 'ceph';
  }
  text('rbdUser', '');
  text('rbdSecretUuid', '');
  text('libvirtImagesRbdPool', '');
  text('libvirtImagesRbdCephConf', '^[0-9]+$');
  setfocus('rbdUser');
  
}

function filesystem() {
  document.getElementById('baseInfo').setAttribute('hidden', false);
  var newKey = 0;
  if (newEdit) newKey = current.get('uniqueKey');

  var len = imageBackendsVec.length;
  idx = 2;

  if (len == 0) {
    current = backendCow;
    imageBackendsVec.push(backendCow);
    current = new dock.cvObject(object.cluster, current);
  } else if (len == 1) {
    if (getBackendType(imageBackendsVec[0]) == 'Cow') {
      imageBackendsVec[0].toBeRemoved = false;
      current = imageBackendsVec[0];
      current = new dock.cvObject(object.cluster, current);
    } else {
      current = backendCow;
      imageBackendsVec.push(backendCow);
      current = new dock.cvObject(object.cluster, current);
    }
  } else if (len == 2) {
    if (getBackendType(imageBackendsVec[0]) == 'Cow') {
      imageBackendsVec[0].toBeRemoved = false;
      current = imageBackendsVec[0];
      current = new dock.cvObject(object.cluster, current);
    }
    else if (getBackendType(imageBackendsVec[1]) == 'Cow') {
      imageBackendsVec[1].toBeRemoved = false;
      current = imageBackendsVec[1];
      current = new dock.cvObject(object.cluster, current);
    } else {
      return;
    }
  }
  
  text('name', '');
  text('libvirtImagesType', '');
  var check = document.getElementById('useCowImages');
  if (current.object.useCowImages) {
    check.setAttribute('checked', true);
  } else {
    check.setAttribute('checked', false);
  }

  if ( document.getElementById('libvirtImagesType').value == '' ){
    document.getElementById('libvirtImagesType').value = 'default';
  }
  if ( document.getElementById('name').value == '' ){
    document.getElementById('name').value = 'cow';
  }

}

function ok() {
  if (lastIdx != idx) {
    var args = new Object();
    args['question'] = "Are you sure you want to change the backend from " + list[lastIdx] + " to " + list[idx];
    var d = new dock.cvDialog("chrome://cmgui/content/question.xul", args);
    d.onOk = function(force) {
      if(!window.closed) {
        role.modified = true;
        object.set('modified', true);
        myDialog.doOk();
        close();
        lastIdx = idx;
      }
    }
    dock.dialogs.showDialog(d);
  } else {
    if(!window.closed) {
      role.modified = true;
      object.set('modified', true);
      myDialog.doOk();
      close();
      lastIdx = idx;
    }
  }
}

function cancel() {
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}

function setBackendType(index) {
  document.getElementById('deck').selectedIndex = index;

  if (!eval(document.getElementById('isNone').getAttribute('disabled'))) {
    document.getElementById('isNone').setAttribute('on', index == 0);
    document.getElementById('isCeph').setAttribute('on', index == 1);
    document.getElementById('isFilesystem').setAttribute('on', index == 2);
  }
  refresh(index);
}

function getBackendType (cur) {
  var baseType = cur.baseType;
  var childType = cur.childType;
  var backendImageType = childType.substr(baseType.length, childType.length);
  return backendImageType;
}
