/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var newEdit;
var object;
var role;
var old;
var current;
var myDialog;
var dock;
var cluster;
var imageBackendsVec;
var backendCeph;
var backendFs;
var idx;
var lastIdx;
var list = ['none', 'Ceph', 'FS'];

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  // myDialog.arguments.object = device
  // subobject = role
  // subobject.object = role, childtype openstack computerole
  // printall(myDialog.arguments.subobject.object.imageBackends[0]);

  backendCeph = new dock.cvOpenStackImageBackendCeph();
  backendFs  = new dock.cvOpenStackImageBackendFS();

  newEdit = false;
  object = myDialog.arguments.object;
  role = myDialog.arguments.subobject;
  cluster = myDialog.arguments.subobject.cluster;
  imageBackendsVec = role.get('imageBackends');

  document.getElementById('deck').selectedIndex = 1; 
  document.getElementById('isCeph').setAttribute('on', true);

  lastIdx = idx = 0;
  if (imageBackendsVec.length > 0) {
    if (imageBackendsVec.length >= 2) {
      println("WARN: update cmgui");
    }

    current = 0;
    for (var i = 0; i < imageBackendsVec.length; ++i) {
      if (!imageBackendsVec[i].toBeRemoved) {
        current = imageBackendsVec[i];
        break;
      }
    }
    if (current) {
      var baseType = current.baseType;
      var childType = current.childType;
      var backendImageType = childType.substr(baseType.length, childType.length);

      current = new dock.cvObject(object.cluster, current, role, 'imageBackends');
      //printall(current);

      if (backendImageType == 'FS')  {
        document.getElementById('name');
        idx = 2;
      } else if (backendImageType == 'Ceph') {
        document.getElementById('name');
        idx = 1;
      }
    }
  } else {
    idx = 0;
  }

  setBackendType(idx);
  lastIdx = idx;

}

function refresh(index) {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  document.getElementById('deck').selectedIndex = index;
  switch(index) {
    case(0): none(); break;
    case(1): ceph(); break;
    case(2): filesystem(); break;
  }
}

function none() {
  document.getElementById('baseInfo').setAttribute('hidden', true);
  for (var i = 0; i < imageBackendsVec.length; ++i) {
    imageBackendsVec[i].toBeRemoved = true;
  }

  idx = 0;
  current = 0;

}

function ceph() {
  document.getElementById('baseInfo').setAttribute('hidden', false);
  var len = imageBackendsVec.length;

  var cur = 0;
  for (var i = 0; i < imageBackendsVec.length; ++i) {
    if (getBackendType(imageBackendsVec[i]) == 'Ceph') {
      cur = imageBackendsVec[i];
      imageBackendsVec[i].toBeRemoved = false;
    } else {
      imageBackendsVec[i].toBeRemoved = true;
    }
  }

  if (!cur) {
    cur = backendCeph;
    if (len > 2) return;
    if (len < 2) imageBackendsVec.push(backendCeph);
  }
  idx = 1;
  current = new dock.cvObject(object.cluster, cur, role, 'imageBackends');

  text('name', '');
  text('defaultStore', '');
  text('rbdStoreUser', '');
  text('rbdStorePool', '');
  text('rbdStoreCephConf', '');
  text('rbdStoreChunkSize', '^[0-9]+$');
  var check = document.getElementById('showImageDirectUrl');
  if (current.object.showImageDirectUrl) {
    check.setAttribute('checked', true);
  }
  else {
    check.setAttribute('checked', false);
  }
  if ( document.getElementById('defaultStore').value.length == 0 ){
    document.getElementById('defaultStore').value = 'rbd';
  }

  setfocus('name');
}

function filesystem() {
  document.getElementById('baseInfo').setAttribute('hidden', false);
  var newKey = 0;
  if (newEdit) newKey = current.get('uniqueKey');

  var len = imageBackendsVec.length;
  var cur = 0;
  for (var i = 0; i < imageBackendsVec.length; ++i) {
    if (getBackendType(imageBackendsVec[i]) == 'FS') {
      imageBackendsVec[i].toBeRemoved = false;
      cur = imageBackendsVec[i];
    } else {
      imageBackendsVec[i].toBeRemoved = true;
    }
  }
  if (!cur) {
    cur = backendFs;
    if (len > 2) return;
    if (len < 2) imageBackendsVec.push(backendFs);
  }
  idx = 2;
  current = new dock.cvObject(object.cluster, cur, role, 'imageBackends');

  text('name', '');
  text('defaultStore', '');
  var check = document.getElementById('showImageDirectUrl');
  if (current.object.showImageDirectUrl) {
    check.setAttribute('checked', true);
  }
  else {
    check.setAttribute('checked', false);
  }
  
  if ( document.getElementById('defaultStore').value.length == 0 ){
    document.getElementById('defaultStore').value = 'file';
  }

  setfocus('name');
}

function ok() {
  if ( idx > 0 ){
    if (document.getElementById('name').value == '' ){
        dock.displayError('Name field cannot be empty');
        return false;
    }
  }
  if (lastIdx != idx) {
    var args = new Object();
    args['question'] = "Are you sure you want to change the backend from " + list[lastIdx] + " to " + list[idx];
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function(force) {
      if(!window.closed) {
        myDialog.doOk();
        close();
        lastIdx = idx;
        role.set('modified', true);
        object.set('modified', true);
      }
    }
    dock.dialogs.showDialog(d);
  } else {
    if(!window.closed) {
      role.set('modified', true);
      object.set('modified', true);
      myDialog.doOk();
      close();
      lastIdx = idx;
    }
  }
}

function cancel() {
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}

function setBackendType(index) {
  document.getElementById('deck').selectedIndex = index;

  if (!eval(document.getElementById('isNone').getAttribute('disabled'))) {
    document.getElementById('isNone').setAttribute('on', index == 0);
    document.getElementById('isCeph').setAttribute('on', index == 1);
    document.getElementById('isFilesystem').setAttribute('on', index == 2);
  }
  refresh(index);
}

function getBackendType (cur) {
  var baseType = cur.baseType;
  var childType = cur.childType;
  var backendImageType = childType.substr(baseType.length, childType.length);
  return backendImageType;
}

