/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var myDialog;


const fieldname = null; //'clusterNodes';
const displayInTree = false;
const subtype = 'Node';
const singular = 'node';
const plural = 'nodes';
const extraName = "''";
const nodeSelectionProperties = [['','', false],
				 ['hostname', 'hostname', false],
				 ['MAC', 'mac', false],
				 ['tag', 'tag', false],
				 ['category', 'category', true],
				 ['installmode', 'installMode', false],
				 ['rack', 'rack', true],
				 ['position', 'rackPosition', false]];
const belongs = '0';
const noloop = 'true';
const extraEvalOnAdd = '';
const extraEvalOnRemove = '';

var currentnodes = new Array();
var nodesIndex = '';
var excludeFunction = undefined;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  var allnodeslabel = "All Nodes";
  var groupnodeslabel = "Selected Nodes";

  document.getElementById('allnodeslabel').value = allnodeslabel;
  document.getElementById('groupnodeslabel').value = groupnodeslabel;
  var node_strings = {};
  for(var i = 0; i < myDialog.arguments.role.object.clusterNodes.length; i++) {
    node_strings[myDialog.arguments.role.object.clusterNodes[i]] = true;
  }
  var tmp_all = myDialog.arguments.role.cluster.find('Node');
  for(var i = 0; i < tmp_all.length; i++) {
    if(node_strings.hasOwnProperty(tmp_all[i].resolveName())) {
      currentnodes.push(tmp_all[i].object.uniqueKey);
    }
  }
  refresh(myDialog.arguments.role);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh galera node selection window" + ' - ' + document.documentURI);
  deviceselect(excludeFunction);
  var revert_button = document.getElementById('revert');
  if(revert_button) {
    revert_button.setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  }
}

function buttonOk() {
  current.object.clusterNodes = [];
  for(var i = 0; i < currentnodes.length; i++)  {
    current.object.clusterNodes.push(current.cluster.resolveName(currentnodes[i]));
  }  
  current.setModified(true);
  myDialog.onOk();
  close();
}
