/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
var newEdit;
var object;
var role;
var old;
var current;
var myDialog;
var dock;
var cluster;
var backupBackendsVec;
var backendCeph;
var idx;
var lastIdx;
var list = ['none','ceph'];

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  backendCeph = new dock.cvOpenStackVolumeBackupBackendCeph();

  newEdit = false;
  object = myDialog.arguments.object;
  role = myDialog.arguments.subobject;
  cluster = myDialog.arguments.subobject.cluster;
  backupBackendsVec = role.get('backupBackends');

  document.getElementById('deck').selectedIndex = 1; 
  document.getElementById('isCeph').setAttribute('on', true);

  lastIdx = idx = 0;
  if (backupBackendsVec.length > 0) {
    if (backupBackendsVec.length >= 2) {
      println("WARN: update cmgui");
    }

    current = 0;
    for (var i = 0; i < backupBackendsVec.length; ++i) {
      if (!backupBackendsVec[i].toBeRemoved) {
        current = backupBackendsVec[i];
        break;
      }
    }

    if (current) {
      var baseType = current.baseType;
      var childType = current.childType;
      var backendBackupType = childType.substr(baseType.length, childType.length);

      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
      if (backendBackupType == 'Ceph') {
        idx = 1;
      }
    }
  } else {
    idx = 0;
  }

  setBackendType(idx);
  lastIdx = idx;
}

function refresh(index) {
  var newKey = 0;
  if(newEdit) newKey = current.get('uniqueKey');
  document.getElementById('deck').selectedIndex = index;
  switch(index) {
    case(0): none(); break;
    case(1): ceph(); break;
  }
}

function none() {
  document.getElementById('baseInfo').setAttribute('hidden', true);
  for (var i = 0; i < backupBackendsVec.length; ++i) {
    backupBackendsVec[i].toBeRemoved = true;
  }
  idx = 0;
  current = 0;
}

function ceph() {
  document.getElementById('baseInfo').setAttribute('hidden', false);

  var len = backupBackendsVec.length;
  idx = 1;

  if (len == 0) {
    current = backendCeph;
    backupBackendsVec.push(backendCeph);
    current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
  } else if (len == 1) {
    if (getBackendType(backupBackendsVec[0]) == 'Ceph') {
      backupBackendsVec[0].toBeRemoved = false;
      current = backupBackendsVec[0];
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    } else {
      current = backendCeph;
      backupBackendsVec.push(backendCeph);
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    }
  } else if (len == 2) {
    if (getBackendType(backupBackendsVec[0]) == 'Ceph') {
      backupBackendsVec[0].toBeRemoved = false;
      current = backupBackendsVec[0];
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    }
    else if (getBackendType(backupBackendsVec[1]) == 'Ceph') {
      backupBackendsVec[1].toBeRemoved = false;
      current = backupBackendsVec[1];
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    } else {
      return;
    }
  }

  text('name', '');
  text('backupCephUser', '');
  text('backupCephChunkSize', '');
  text('backupCephPool', '');
  text('backupCephStripeUnit', '');
  text('backupCephStripeCount', '');
  text('backupDriver', '');
  text('backupCephConf', '');
  var check = document.getElementById('restoreDiscardExcessBytes');
  check.setAttribute('checked', current.object.restoreDiscardExcessBytes == true);
  setfocus('name');
}

function filesystem() {
  document.getElementById('baseInfo').setAttribute('hidden', false);
  var newKey = 0;
  if (newEdit) newKey = current.get('uniqueKey');

  var len = backupBackendsVec.length;
  idx = 2;

  if (len == 0) {
      current = backendFs;
      backupBackendsVec.push(backendFs);
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
  } else if (len == 1) {
    if (getBackendType(backupBackendsVec[0]) == 'NFS') {
      backupBackendsVec[0].toBeRemoved = false;
      current = backupBackendsVec[0];
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    } else {
      current = backendFs;
      backupBackendsVec.push(backendFs);
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    }
  } else if (len == 2) {
    if (getBackendType(backupBackendsVec[0]) == 'NFS') {
      backupBackendsVec[0].toBeRemoved = false;
      current = backupBackendsVec[0];
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    }
    else if (getBackendType(backupBackendsVec[1]) == 'NFS') {
      backupBackendsVec[1].toBeRemoved = false;
      current = backupBackendsVec[1];
      current = new dock.cvObject(object.cluster, current, role, 'backupBackends');
    } else {
      return;
    }
  }

  text('name', '');
  text('nfsDiskUtil', '');
  text('nfsMountPointBase', '');
  text('nfsSparsedVolumes', '');
  text('nfsSharesConfig', '');
  stringlist('nfsShares', '');

  setfocus('name');
}

function ok() {
  if ( idx > 0 ){
    var name = document.getElementById('name').value;
    if ( name.length > 24 ){
      dock.displayError('Name field is too long. Maximum allowed characters is 24.');
      return false;    
    }
    if (name == ''){
      dock.displayError('Name field cannot be empty');
      return false;
    }
  }
  if (lastIdx != idx) {
    var args = new Object();
    args['question'] = "Are you sure you want to change the backend from " + list[lastIdx] + " to " + list[idx];
    var d = new dock.cvDialog("chrome://cmgui/content/question.xul", args);
    d.onOk = function(force) {
      if(!window.closed) {
        myDialog.doOk();
        close();
        lastIdx = idx;
        role.set('modified', true);
        object.set('modified', true);
      }
    }
    dock.dialogs.showDialog(d);
  } else {
    if(!window.closed) {
      role.set('modified', true);
      object.set('modified', true);
      myDialog.doOk();
      close();
      lastIdx = idx;
    }
  }
}

function cancel() {
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}

function setBackendType(index) {
  document.getElementById('deck').selectedIndex = index;

  if (!eval(document.getElementById('isNone').getAttribute('disabled'))) {
    document.getElementById('isNone').setAttribute('on', index == 0);
    document.getElementById('isCeph').setAttribute('on', index == 1);
  }
  refresh(index);
}

function getBackendType (cur) {
  var baseType = cur.baseType;
  var childType = cur.childType;
  var backendBackupType = childType.substr(baseType.length, childType.length);
  return backendBackupType;
}

