/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleEndpoint() {
  this.addTitle = "Add Endpoint";
  this.editTitle = "Edit Endpoint";
  this.editsTitle = "Edit Endpoints";
  this.api = 'Endpoint';

  var urlRegex = /(http[s]?:\/\/)(.*):([0-9]+)([/]?.*)/;

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiEndpoint = new editorController.dock.cvOpenStackApiEndpoint();
      cvDataOpenStackApiEndpoint.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiEndpoint, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  // TODO refactor this
  function dataBindingAndCheckUrl(editorController) {
    this.setUrl = function(editorController) {
      var urlProtocol = document.getElementById('urlProtocol').value;
      var urlHostname = document.getElementById('urlHostname').value;
      var urlPort = document.getElementById('urlPort').value;
      var urlPath = document.getElementById('urlPath').value;
      var url = urlProtocol + urlHostname + ':' + urlPort + urlPath;
      editorController.currentObject.set('url', url);
    };

    document.getElementById('urlProtocol').addEventListener('command', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlHostname').addEventListener('change', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlHostname').addEventListener('keypress', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlPort').addEventListener('change', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlPort').addEventListener('keypress', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlPath').addEventListener('change', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlPath').addEventListener('keypress', this.setUrl.bind(this, editorController), true);

    var urlMatches = editorController.currentObject.get('url').match(urlRegex);
    if(isArray(urlMatches)) {
      document.getElementById('urlProtocol').value = urlMatches[1];
      document.getElementById('urlHostname').value = urlMatches[2];
      document.getElementById('urlPort').value = urlMatches[3];
      document.getElementById('urlPath').value = urlMatches[4];
    } else {
      document.getElementById('urlPath').value = editorController.currentObject.get('url');
    }
  }

  // TODO refactor this
  function dataBindingAndCheckUrls(editorController) {
    this.setUrl = function(editorController) {
      var urlProtocol = document.getElementById('urlProtocol').value;
      var urlHostname = document.getElementById('urlHostname').value;
      for(var ii = 0; ii < editorController.currentObject.length; ii++) {
        var urlMatches = editorController.currentObject[ii].get('url').match(urlRegex);
        if(isArray(urlMatches)) {
          var urlPort = urlMatches[3];
          var urlPath = urlMatches[4];
          var url = urlProtocol + urlHostname + ':' + urlPort + urlPath;
          editorController.currentObject[ii].set('url', url);
        }
      }
    };

    document.getElementById('urlProtocol').addEventListener('command', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlHostname').addEventListener('change', this.setUrl.bind(this, editorController), true);
    document.getElementById('urlHostname').addEventListener('keypress', this.setUrl.bind(this, editorController), true);

    var values = {};
    for(var ii = 0; ii < editorController.currentObject.length; ii++) {
      var urlMatches = editorController.currentObject[ii].get('url').match(urlRegex);
      if(isArray(urlMatches)) {
        values[urlMatches[1]] = '1';
        values[urlMatches[2]] = '1';
      } else {
        values[editorController.currentObject[ii].get('url')] = '1';
      }
    }

    if(Object.keys(values).length===2) {
      var urlMatches = editorController.currentObject[0].get('url').match(urlRegex);
      if(isArray(urlMatches)) {
        document.getElementById('urlProtocol').value = urlMatches[1];
        document.getElementById('urlHostname').value = urlMatches[2];
      }
    }
  }

  this.dataBindingAndCheck = function(editorController) {
    if(editorController.isMultiEdit()) {
      dataBindingAndCheckUrls(editorController);
      multipleText('region', 'region', editorController.currentObject);
    } else {
      this.dataBindingAndCheckCommon(editorController);

      resolve('serviceKey', 'OpenStackApiService');
      extraeval('serviceKey', 'current.correctAllUUID();');
      autorefresh('serviceKey');
      kenum('interface', this.getObjectProperties('interface').enum);

      dataBindingAndCheckUrl(editorController);

      text('region', '^');
      check('enabled');
    }
  };

  this.inputCheck = function(editorController) {
    if(editorController.isAdd()) {
      if(blank(editorController.currentObject.get('name'))) {
        editorController.dock.displayError("Name cannot be empty");
        return false;
      }
    }
    return true;
  };
}

EditorRuleEndpoint.prototype = new EditorRuleBase();
EditorRuleEndpoint.prototype.constructor = EditorRuleEndpoint;