/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleFloatingIP() {
  this.addTitle = "Add Floating IP";
  this.editTitle = "Edit Floating IP";
  this.api = 'FloatingIP';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiFloatingIP = new editorController.dock.cvOpenStackApiFloatingIP();
      cvDataOpenStackApiFloatingIP.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiFloatingIP, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
  	this.dataBindingAndCheckCommon(editorController);

    resolve('portKey', 'OpenStackApiPort');
    extraeval('portKey', 'current.correctAllUUID();');
    autorefresh('portKey');
    resolve('routerKey', 'OpenStackApiRouter');
    extraeval('routerKey', 'current.correctAllUUID();');
    autorefresh('routerKey');
    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');
    resolve('floatingNetworkKey', 'OpenStackApiNetwork');
    extraeval('floatingNetworkKey', 'current.correctAllUUID();');
    autorefresh('floatingNetworkKey');
    text('floatingIPAddress', '^');
    text('fixedIPAddress', '^');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleFloatingIP.prototype = new EditorRuleBase();
EditorRuleFloatingIP.prototype.constructor = EditorRuleFloatingIP;