/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleGroup() {
  this.addTitle = "Add Group";
  this.editTitle = "Edit Group";
  this.api = 'Group';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiGroup = new editorController.dock.cvOpenStackApiGroup();
      cvDataOpenStackApiGroup.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiGroup, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('description');
    resolve('domainKey', 'OpenStackApiDomain');
    extraeval('domainKey', 'current.correctAllUUID();');
    autorefresh('domainKey');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return;
    }
    return true;
  };
}

EditorRuleGroup.prototype = new EditorRuleBase();
EditorRuleGroup.prototype.constructor = EditorRuleGroup;