/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleHypervisor() {
  this.addTitle = "Add Hypervisor";
  this.editTitle = "Edit Hypervisor";
  this.api = 'Hypervisor';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiHypervisor = new editorController.dock.cvOpenStackApiHypervisor();
      cvDataOpenStackApiHypervisor.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiHypervisor, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('type');
    displayfunction('freeDisk', 'formatter.format.DynamiciB(value);');
    parsefunction('freeDisk', 'formatter.parse.DynamiciB(value);');
    text('freeDisk', '^[0-9]+ ?MiB$');
    displayfunction('freeRam', 'formatter.format.DynamiciB(value);');
    parsefunction('freeRam', 'formatter.parse.DynamiciB(value);');
    text('freeRam');
    displayfunction('localStorage', 'formatter.format.DynamiciB(value);');
    parsefunction('localStorage', 'formatter.parse.DynamiciB(value);');
    text('localStorage');
    displayfunction('localStorageUsed', 'formatter.format.DynamiciB(value);');
    parsefunction('localStorageUsed', 'formatter.parse.DynamiciB(value);');
    text('localStorageUsed');
    displayfunction('memory', 'formatter.format.DynamiciB(value);');
    parsefunction('memory', 'formatter.parse.DynamiciB(value);');
    text('memory');
    displayfunction('memoryUsed', 'formatter.format.DynamiciB(value);');
    parsefunction('memoryUsed', 'formatter.parse.DynamiciB(value);');
    text('memoryUsed');
    text('runningVMs');
    text('vcpus');
    text('vcpusUsed');
    text('currentWorkload');
    text('status');
    text('state');
    text('ip');
    text('cpuInfo');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleHypervisor.prototype = new EditorRuleBase();
EditorRuleHypervisor.prototype.constructor = EditorRuleHypervisor;