/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleImage() {
  this.addTitle = "Add Image";
  this.editTitle = "Edit Image";
  this.api = 'Image';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiImage = new editorController.dock.cvOpenStackApiImage();
      cvDataOpenStackApiImage.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiImage, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');
    kenum('containerFormat', this.getObjectProperties('containerFormat').enum);
    kenum('diskFormat', this.getObjectProperties('diskFormat').enum);
    text('createdAt', '^');
    text('updatedAt', '^');
    kenum('visibility', this.getObjectProperties('visibility').enum);
    check('isProtected');
    displayfunction('minDisk', 'formatter.format.GiB(value);');
    parsefunction('minDisk', 'formatter.parse.GiB(value);');
    text('minDisk', '^[0-9]+ ?GiB$');
    displayfunction('minRam', 'formatter.format.MiB(value);');
    parsefunction('minRam', 'formatter.parse.MiB(value);');
    text('minRam', '^[0-9]+ ?MiB$');
    text('file', '^');
    displayfunction('size', 'formatter.format.DynamiciB(value);');
    parsefunction('size', 'formatter.parse.DynamiciB(value);');
    text('size', '^[0-9]+ ?[KMGT]iB$');

    var arrayAttributeListable = new SingleArrayAttributeListable(editorController.currentObject, 'tags');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '190px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'tags',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    setAttributeRecursive(document.getElementById('tags'), 'disabled', 'true');

    text('propertyArchitecture', '^');
    text('propertyHypervisorType', '^');
    text('propertyInstanceUUID', '^');
    text('propertyImgConfigDrive', '^');
    text('propertyKernelID', '^');
    text('propertyOSDistro', '^');
    text('propertyOSVersion', '^');
    text('propertyRamdiskID', '^');
    text('propertyVMMode', '^');
    text('propertyHWDiskBus', '^');
    text('propertyHWRngModel', '^');
    text('propertyHWMachineType', '^');
    text('propertyHWSCSIModel', '^');
    text('propertyHWSerialPortCount', '^');
    text('propertyHWVideoModel', '^');
    text('propertyHWVideoRam', '^');
    text('propertyOSCommandLine', '^');
    text('propertyHWVifModel', '^');
    text('propertyOSType', '^');
    text('propertyAutoDiskConfig', '^');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleImage.prototype = new EditorRuleBase();
EditorRuleImage.prototype.constructor = EditorRuleImage;