/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.credentials = new WizardScreen();

wizard.credentials.initDefaultConfig = function() {
  println('init wizard.credentials.initDefaultConfig');
  printallR(wizard.config.modules);
  wizard.common.setConfig(wizard.config.modules.core, 'mysql_admin_password', Math.random().toString(36).substring(2));
//  wizard.common.setConfig(wizard.config.modules.keystone, 'cloud_admin_password', '');
};

wizard.credentials.enter = function() {
  function initOpenStackAdminPassword() {
    document.getElementById('credentials-openStackPassword').value = document.getElementById('credentials-openStackPassword2').value = wizard.config.modules.keystone.cloud_admin_password;
  }

  println('enter wizard.credentials.enter');
  if (!wizard.credentials.started) {
    wizard.credentials.started = true;
    initOpenStackAdminPassword();
  }
};

wizard.credentials.forward = function(automatic) {
  function isValidPassword(password, errorElementId) {
    if (!password.match(/^.+$/)) {
      wizard.common.displayError(errorElementId, automatic);
      wizard.credentials.error = true;
      return false;
    }
    wizard.common.hide(errorElementId);
    return true;
  }

  function isPasswordConfirmed(password1, password2, errorElementId) {
    if (password1 !== password2) {
      wizard.common.displayError(errorElementId, automatic);
      wizard.credentials.error = true;
      return false;
    }
    wizard.common.hide(errorElementId);
    return true;
  }

  println('forward wizard.credentials.forward');

  if (isValidPassword(document.getElementById('credentials-openStackPassword').value, 'credentials-error-osadminpass-set')) {
    if (isPasswordConfirmed(document.getElementById('credentials-openStackPassword').value, document.getElementById('credentials-openStackPassword2').value, 'credentials-error-osadminpass-match')) {
      wizard.common.setConfig(wizard.config.modules.keystone, 'cloud_admin_password', document.getElementById('credentials-openStackPassword').value);
    }
  }
  printallR('cloud_admin_password:' + wizard.config.modules.keystone.cloud_admin_password);

  return wizard.credentials.error;
};
