/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

wizard.deploy = new DeployWizardScreen();

wizard.deploy.cm_setup_tool_script = 'cm-openstack-setup';
wizard.deploy.cm_setup_tool_name   = 'OpenStack';


wizard.deploy.onEnter = function() {
  wizard.common.hide('deployButton');
}

wizard.deploy.beforeCallSetupExecute = function() {
  wizard.common.unhide('deploy-info');
};

wizard.deploy.onCallSetupExecuteSuccess = function() {
  wizard.deploy.updateInfo();
};

wizard.deploy.onCallSetupExecuteFailed = function() {
  wizard.common.hide('deploy-info');
};

wizard.deploy.onShowDetailedLog = function() {
  wizard.common.hide('deploy-info');
};

wizard.deploy.onHideDetailedLog = function() {
  wizard.common.unhide('deploy-info');
};

wizard.deploy.onShowSuccess = function() {
  wizard.common.hide('deploy-info');
  if(current && current.host) {
    var label = document.getElementById('dashboard-url');
    var url = 'http://' + current.host + ':10080/dashboard';
    var msg = url;
    label.value = msg;
    label.addEventListener('click', 
                           function() {
                             var ioservice = Components.classes["@mozilla.org/network/io-service;1"]
                               .getService(Components.interfaces.nsIIOService);
                             var uriToOpen = ioservice.newURI(url, null, null);
                             var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                               .getService(Components.interfaces.nsIExternalProtocolService);
                             extps.loadURI(uriToOpen, null);
                           }, true);
  }
};

wizard.deploy.updateInfo = function() {
  wizard.deploy.timer_info = window.setTimeout('wizard.deploy.updateInfo();', 20000);
  if (document.getElementById('deploy-output').getAttribute('hidden')==='true'){
    var parent = document.getElementById("deploy-info");
    var current = 0;
    for(var i = 0; i < parent.children.length; i++) {
      if(i > 0) {
        if(parent.children[i].getAttribute('hidden') !== 'true') {
          current = i;
          parent.children[i].setAttribute('hidden', 'true');
        }
      }
    }
    current++;
    if(current >= parent.children.length) {
      current = 1;
    }
    parent.children[current].setAttribute('hidden', 'false');
    var headline = parent.children[current].getAttribute('headline');
    document.getElementById('deploy-info-headline').setAttribute('value', headline);
  }
}

