/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.inboundExternalTraffic = new WizardScreen();

wizard.inboundExternalTraffic.initDefaultConfig = function() {
  println('init wizard.inboundExternalTraffic.initDefaultConfig');
/*
  var networkTable = {
    final: 0,
    name: wizard.config.modules.neutron.external_net_name,
    poolStart: wizard.config.modules.neutron.external_net_allocation_pool_start,
    poolEnd: wizard.config.modules.neutron.external_net_allocation_pool_end
  };
  var externalNetworks = current.findExternalNetworks();
  externalNetworks.reduce(function(networkTable, network) {
    if (networkTable.final<2 && network.get('name') === 'externalnet') {
      networkTable.final = 2;
      networkTable.name = network.get('name');
      networkTable.poolStart = 'x.x.x.0';
      networkTable.poolEnd = 'x.x.x.255';
    } else if (networkTable.final<1) {
      networkTable.final = 1;
      networkTable.name = network.get('name');
      networkTable.poolStart = 'x.x.x.0';
      networkTable.poolEnd = 'x.x.x.255';
    }
    return networkTable;
  }, networkTable);

  wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_allocation_pool_start', networkTable.poolStart);
  wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_allocation_pool_end', networkTable.poolEnd);
  wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_name', networkTable.name);
*/
};

wizard.inboundExternalTraffic.enter = function() {
  function findExternalNetworksWithGateway() {
    var ret = current.findExternalNetworks().filter(function(item) { 
      return item.get('gateway') != '0.0.0.0';
    });
    var networks = current.find('Network');
    for(var i = 0; i < networks.length; i++) {
      if(networks[i].get('type') == 'CLOUD' && 
         networks[i].get('gateway') != '0.0.0.0') {
        ret.push(networks[i]);
      }
    }
    return ret;
  }

  function initConnectivity() {
    if (wizard.config.modules.neutron.external_net_name !== null &&
        ( wizard.config.modules.neutron.external_net_allocation_pool_start !== null ||
          wizard.config.modules.neutron.external_net_allocation_pool_end !== null
        )
       ) {
      document.getElementById('inboundExternalTraffic-connectivity').value = 'floating-ip';
    } else {
      document.getElementById('inboundExternalTraffic-connectivity').value = 'none';
    }
  }

  function initExternalNetworks() {
    var externalNetworks = findExternalNetworksWithGateway(); // current.findExternalNetworks();
    fillListDropdown({
      popupId: 'inboundExternalTraffic-externalNetworks',
      list: externalNetworks,
      selectedElement: {label: wizard.config.modules.neutron.external_net_name, defaultIndex: 0}
    });
  }

  function initFloatingIpsRangeBase() {
    if (ipaddr.isValid(wizard.config.modules.neutron.external_net_allocation_pool_start)) {
      wizard.inboundExternalTraffic.setFloatingIpsRangeStart(ipaddr.parse(wizard.config.modules.neutron.external_net_allocation_pool_start), 32, true);
    }
    if (ipaddr.isValid(wizard.config.modules.neutron.external_net_allocation_pool_end)) {
      wizard.inboundExternalTraffic.setFloatingIpsRangeEnd(ipaddr.parse(wizard.config.modules.neutron.external_net_allocation_pool_end), 32, true);
    }
  }

  println('enter wizard.inboundExternalTraffic.enter');

  if (!wizard.inboundExternalTraffic.started) {
    wizard.inboundExternalTraffic.started = true;
    var externalNetworks = findExternalNetworksWithGateway(); 
    if(externalNetworks.length > 0) {
      // there is at least one externalNetwork with gateway
      wizard.common.hide('inboundExternalTraffic-warning-external-net-has-no-gateway');
      wizard.common.unhide('inboundExternalTraffic-question-enable-floating-ips');
      wizard.common.unhide('inboundExternalTraffic-select-enable-floating-ips');
    }
    else {
      wizard.common.unhide('inboundExternalTraffic-warning-external-net-has-no-gateway');
      wizard.common.hide('inboundExternalTraffic-question-enable-floating-ips');
      wizard.common.hide('inboundExternalTraffic-select-enable-floating-ips');
    }
    initConnectivity();
    initExternalNetworks();
    initFloatingIpsRangeBase();

    wizard.inboundExternalTraffic.setConnectivity();
    wizard.inboundExternalTraffic.setNetworkBase();
  }
};

wizard.inboundExternalTraffic.forward = function(automatic) {
  println('forward wizard.inboundExternalTraffic.forward');

  if (document.getElementById('inboundExternalTraffic-connectivity').value==='floating-ip') {
    var floatingIPsRangeStart = document.getElementById('inboundExternalTraffic-floatingIPsRangeStart-0').value + '.' + document.getElementById('inboundExternalTraffic-floatingIPsRangeStart-1').value + '.' + document.getElementById('inboundExternalTraffic-floatingIPsRangeStart-2').value + '.' + document.getElementById('inboundExternalTraffic-floatingIPsRangeStart-3').value;
    var floatingIPsRangeEnd = document.getElementById('inboundExternalTraffic-floatingIPsRangeEnd-0').value + '.' + document.getElementById('inboundExternalTraffic-floatingIPsRangeEnd-1').value + '.' + document.getElementById('inboundExternalTraffic-floatingIPsRangeEnd-2').value + '.' + document.getElementById('inboundExternalTraffic-floatingIPsRangeEnd-3').value;
    if (wizard.validator.isValidIP(floatingIPsRangeStart, 'inboundExternalTraffic-error-floatingIPsRangeStart-invalid', automatic)) {
      var addrStart = ipaddr.parse(floatingIPsRangeStart);
      var selectedInternalNetwork = wizard.inboundExternalTraffic.getAddressOfSelectedExternalNetwork();
      var netaddrBase = netaddr.create(selectedInternalNetwork.get('baseAddress'), selectedInternalNetwork.get('netmaskBits'));

      if (wizard.validator.isInSelectedNetwork(addrStart, netaddrBase, 'inboundExternalTraffic-error-floatingIPsRangeStart-outsideNetwork', automatic)) {
        if (wizard.validator.isValidIP(floatingIPsRangeEnd, 'inboundExternalTraffic-error-floatingIPsRangeEnd-invalid', automatic)) {
          var addrEnd = ipaddr.parse(floatingIPsRangeEnd);
          if (wizard.validator.isInSelectedNetwork(addrEnd, netaddrBase, 'inboundExternalTraffic-error-floatingIPsRangeEnd-outsideNetwork', automatic)) {
            if (wizard.validator.isValidIPRange(addrStart, addrEnd, 'inboundExternalTraffic-error-floatingIPsRangeEnd-lowerThanStart', automatic)) {
              wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_allocation_pool_start', floatingIPsRangeStart);
              wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_allocation_pool_end', floatingIPsRangeEnd);
              wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_name', document.getElementById('inboundExternalTraffic-externalNetworks').value);
            }
          }
        }
      }
    }
  } else {
    wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_allocation_pool_start', null);
    wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_allocation_pool_end', null);
    wizard.common.setConfig(wizard.config.modules.neutron, 'external_net_name', null);
  }
  return wizard.inboundExternalTraffic.error;
};

wizard.inboundExternalTraffic.resetALLFloatingIPsErrors = function() {
  wizard.common.hide('inboundExternalTraffic-error-floatingIPsRangeStart-invalid');
  wizard.common.hide('inboundExternalTraffic-error-floatingIPsRangeStart-outsideNetwork');

  wizard.common.hide('inboundExternalTraffic-error-floatingIPsRangeEnd-invalid');
  wizard.common.hide('inboundExternalTraffic-error-floatingIPsRangeEnd-outsideNetwork');
  wizard.common.hide('inboundExternalTraffic-error-floatingIPsRangeEnd-lowerThanStart');
};

wizard.inboundExternalTraffic.getAddressOfSelectedExternalNetwork = function() {
  if (document.getElementById('inboundExternalTraffic-externalNetworks').selectedItem) {
    var externalNetworkUniqueKey = document.getElementById('inboundExternalTraffic-externalNetworks').selectedItem.getAttribute('key');
    if (!Number.isNaN(Number(externalNetworkUniqueKey))) {
      return current.find(externalNetworkUniqueKey);
    }
  }
  return null;
};

wizard.inboundExternalTraffic.calcRangeForSelectedExternalNetwork = function() {
  var selectedExternalNetwork = wizard.inboundExternalTraffic.getAddressOfSelectedExternalNetwork();
  if (selectedExternalNetwork) {
    var base = selectedExternalNetwork.get('baseAddress');
    var netmaskBits = selectedExternalNetwork.get('netmaskBits');

    var addrBase = ipaddr.parse(base);

    var do_unset_start = (wizard.config.modules.neutron.external_net_allocation_pool_start === null);
    var do_unset_end   = (wizard.config.modules.neutron.external_net_allocation_pool_end === null);
    var calculatedRange = {start: do_unset_start ? addrBase : wizard.config.modules.neutron.external_net_allocation_pool_start, 
                           end:   do_unset_end ? addrBase   : wizard.config.modules.neutron.external_net_allocation_pool_end, 
                           netmaskbits: netmaskBits, 
                           unset_start: do_unset_start, 
                           unset_end : do_unset_end};

    return calculatedRange;
  }
};

wizard.inboundExternalTraffic.setConnectivity = function() {
  if (document.getElementById('inboundExternalTraffic-connectivity').value==='floating-ip') {
    wizard.common.unhide('inboundExternalTraffic-externalNetworksBox');
    wizard.common.unhide('inboundExternalTraffic-floatingIPsRangeBox');
  } else {
    wizard.common.hide('inboundExternalTraffic-externalNetworksBox');
    wizard.common.hide('inboundExternalTraffic-floatingIPsRangeBox');
  }
},

wizard.inboundExternalTraffic.setNetworkBase = function() {
  var selectedExternalNetwork = wizard.inboundExternalTraffic.calcRangeForSelectedExternalNetwork();
  if (selectedExternalNetwork !== null && selectedExternalNetwork !== undefined) {
    wizard.inboundExternalTraffic.setFloatingIpsRangeStart(selectedExternalNetwork.start, selectedExternalNetwork.netmaskbits, selectedExternalNetwork.unset_start);
    wizard.inboundExternalTraffic.setFloatingIpsRangeEnd(selectedExternalNetwork.end, selectedExternalNetwork.netmaskbits, selectedExternalNetwork.unset_end);
    wizard.inboundExternalTraffic.resetALLFloatingIPsErrors();
  }
};

wizard.inboundExternalTraffic.setFloatingIpsRangeStart = function(addr, netmaskBits, unset) {
  if(typeof addr === "string") {
      addr = ipaddr.parse(addr);
  }
  setBaseNetmask([
    'inboundExternalTraffic-floatingIPsRangeStart-0',
    'inboundExternalTraffic-floatingIPsRangeStart-1',
    'inboundExternalTraffic-floatingIPsRangeStart-2',
    'inboundExternalTraffic-floatingIPsRangeStart-3'
  ], addr, netmaskBits, unset);
};

wizard.inboundExternalTraffic.setFloatingIpsRangeEnd = function(addr, netmaskBits, unset) {
  if(typeof addr === "string") {
      addr = ipaddr.parse(addr);
  }
  setBaseNetmask([
    'inboundExternalTraffic-floatingIPsRangeEnd-0',
    'inboundExternalTraffic-floatingIPsRangeEnd-1',
    'inboundExternalTraffic-floatingIPsRangeEnd-2',
    'inboundExternalTraffic-floatingIPsRangeEnd-3'
  ], addr, netmaskBits, unset);
};
