/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.internalNetwork = new WizardScreen();

wizard.internalNetwork.initDefaultConfig = function() {
  println('init wizard.internalNetwork.initDefaultConfig');

//  wizard.common.setConfig(wizard.config.modules.neutron, 'internal_net_name', 'internalnet');
};

wizard.internalNetwork.enter = function() {
  println('enter wizard.internalNetwork.enter');

  if (!wizard.internalNetwork.started) {
    wizard.internalNetwork.started = true;

    initInternalNetworks();

    wizard.internalNetwork.setInternalNetwork();
  }

  function initInternalNetworks() {
    var internalNetworks = current.findInternalNetworks();
    var cloudNetworks = current.findCloudNetworks();
    for(var i = 0; i < cloudNetworks.length; i++) {
      internalNetworks.push(cloudNetworks[i]);
    }
    fillListDropdown({
      popupId: 'internalNetwork-openStackInternalNetwork',
      list: internalNetworks,
      selectedElement: {label: wizard.config.modules.neutron.internal_net_name, defaultIndex: 0}
    });
    document.getElementById('internalNetwork-openStackInternalNetwork').setAttribute('oncommand', "wizard.internalNetwork.setInternalNetwork()");
  }
};

wizard.internalNetwork.forward = function(automatic) {
  println('forward wizard.internalNetwork.forward');

  var internalNetAllocationPoolStart = document.getElementById('internalNetwork-internalNetAllocationPoolStart-0').value + '.' + document.getElementById('internalNetwork-internalNetAllocationPoolStart-1').value + '.' + document.getElementById('internalNetwork-internalNetAllocationPoolStart-2').value + '.' + document.getElementById('internalNetwork-internalNetAllocationPoolStart-3').value;
  var internalNetAllocationPoolEnd = document.getElementById('internalNetwork-internalNetAllocationPoolEnd-0').value + '.' + document.getElementById('internalNetwork-internalNetAllocationPoolEnd-1').value + '.' + document.getElementById('internalNetwork-internalNetAllocationPoolEnd-2').value + '.' + document.getElementById('internalNetwork-internalNetAllocationPoolEnd-3').value;
  if (wizard.validator.isValidIP(internalNetAllocationPoolStart, 'internalNetwork-error-internalNetAllocationPoolStart-invalid', automatic)) {
    var addrStart = ipaddr.parse(internalNetAllocationPoolStart);
    var selectedInternalNetwork = wizard.internalNetwork.getAddressOfSelectedInternalNetwork();
    var netaddrBase = netaddr.create(selectedInternalNetwork.get('baseAddress'), selectedInternalNetwork.get('netmaskBits'));
    if (wizard.validator.isInSelectedNetwork(addrStart, netaddrBase, 'internalNetwork-error-internalNetAllocationPoolStart-outsideNetwork', automatic)) {
      if (wizard.validator.isValidIP(internalNetAllocationPoolEnd, 'internalNetwork-error-internalNetAllocationPoolEnd-invalid', automatic)) {
        var addrEnd = ipaddr.parse(internalNetAllocationPoolEnd);
        if (wizard.validator.isInSelectedNetwork(addrEnd, netaddrBase, 'internalNetwork-error-internalNetAllocationPoolEnd-outsideNetwork', automatic)) {
          if (wizard.validator.isValidIPRange(addrStart, addrEnd, 'internalNetwork-error-internalNetAllocationPoolEnd-lowerThanStart', automatic)) {
            wizard.common.setConfig(wizard.config.modules.neutron, 'internal_net_allocation_pool_start', internalNetAllocationPoolStart);
            wizard.common.setConfig(wizard.config.modules.neutron, 'internal_net_allocation_pool_end', internalNetAllocationPoolEnd);
            wizard.common.setConfig(wizard.config.modules.neutron, 'internal_net_name', document.getElementById('internalNetwork-openStackInternalNetwork').value);
          }
        }
      }
    }
  }

  printallR('internal_net_name: ' + wizard.config.modules.neutron.internal_net_name);
  printallR('internal_net_allocation_pool_start: ' + wizard.config.modules.neutron.internal_net_allocation_pool_start);
  printallR('internal_net_allocation_pool_end: ' + wizard.config.modules.neutron.internal_net_allocation_pool_end);

  return wizard.internalNetwork.error;
},

wizard.internalNetwork.setInternalNetwork = function() {
  wizard.internalNetwork.setNetworkBase();
  wizard.internalNetwork.checkHostsAgainstInternalNetwork();
};

wizard.internalNetwork.checkHostsAgainstInternalNetwork = function() {
  if (document.getElementById('internalNetwork-openStackInternalNetwork').selectedIndex === -1) {
    return;
  }
  var internalNetKey = document.getElementById('internalNetwork-openStackInternalNetwork').selectedItem.getAttribute('key');

  var nodesDetachedFromSelectedNetwork = current.findBy({
    baseType: ['SlaveNode', 'CloudNode'],
    filter: function(node) {
      if(wizard.common.getConfigOverlay('nova', 'OpenStackHypervisors').nodes.indexOf(node.get('hostname')) !== -1) {
        return !node.object.networks.reduce(function(previousValue, currentValue) {
          //println('reduce ' + node.get('hostname') + ' - '+ internalNetKey + ' =? ' + currentValue.network);
          return (previousValue || internalNetKey==currentValue.network);
        }, false);
      }
      return false;
    }
  });

  if (nodesDetachedFromSelectedNetwork.length > 0) {
    document.getElementById('internalNetwork-internalNetworkMessageWarning').children[1].textContent = 'The following nodes do not have an interface on the ' + document.getElementById('internalNetwork-openStackInternalNetwork').label + ':';
    var ul = document.getElementById('internalNetwork-nodesDetachedFromSelectedNetwork');
    while (ul.firstChild) {
      ul.removeChild(ul.firstChild);
    }
    for (var i = 0; i < nodesDetachedFromSelectedNetwork.length; i++) {
      var li = document.createElementNS("http://www.w3.org/1999/xhtml", "li");
      var txt = document.createTextNode(nodesDetachedFromSelectedNetwork[i].get('hostname'));
      li.appendChild(txt);
      ul.appendChild(li);
    }
    wizard.common.unhide('internalNetwork-internalNetworkMessageWarning');
  } else {
    wizard.common.hide('internalNetwork-internalNetworkMessageWarning');
  }
};

wizard.internalNetwork.resetALLFloatingIPsErrors = function() {
  wizard.common.hide('internalNetwork-error-internalNetAllocationPoolStart-invalid');
  wizard.common.hide('internalNetwork-error-internalNetAllocationPoolStart-outsideNetwork');

  wizard.common.hide('internalNetwork-error-internalNetAllocationPoolEnd-invalid');
  wizard.common.hide('internalNetwork-error-internalNetAllocationPoolEnd-outsideNetwork');
  wizard.common.hide('internalNetwork-error-internalNetAllocationPoolEnd-lowerThanStart');
};

wizard.internalNetwork.getAddressOfSelectedInternalNetwork = function() {
  if (document.getElementById('internalNetwork-openStackInternalNetwork').selectedItem) {
    var internalNetworkUniqueKey = document.getElementById('internalNetwork-openStackInternalNetwork').selectedItem.getAttribute('key');
    if (!Number.isNaN(Number(internalNetworkUniqueKey))) {
      return current.find(internalNetworkUniqueKey);
    }
  }
};

wizard.internalNetwork.calcRangeForSelectedInternalNetwork = function() {
  var selectedInternalNetwork = wizard.internalNetwork.getAddressOfSelectedInternalNetwork();
  if (selectedInternalNetwork) {
    var base = selectedInternalNetwork.get('baseAddress');
    var netmaskBits = selectedInternalNetwork.get('netmaskBits');
    var dynamicRangeStart = selectedInternalNetwork.get('dynamicRangeStart');

    var addrBase = ipaddr.parse(base);
    var calculatedRange = {start: addrBase, end: addrBase, netmaskbits: netmaskBits, unset: true};

    get1Of32thIfPossible(calculatedRange, dynamicRangeStart, netmaskBits);

    return calculatedRange;
  }

  function get1Of32thIfPossible(calculatedRange, ip, netmaskBits) {
    var addr = netaddr.create(ip, netmaskBits);
    var start = ipaddr.parse(addr.add(-(addr.size() / 32)).ip);
    var end = ipaddr.parse(addr.add(-1).ip);

    if (start.match(calculatedRange.start, netmaskBits) && end.match(calculatedRange.end, netmaskBits)) {
      calculatedRange.start = start;
      calculatedRange.end = end;
      calculatedRange.unset = false;
    }
  }
  return null;
};

wizard.internalNetwork.setNetworkBase = function() {
  var selectedInternalNetwork = wizard.internalNetwork.calcRangeForSelectedInternalNetwork();
  if (selectedInternalNetwork !== null) {
    wizard.internalNetwork.setFloatingIpsRangeStart(selectedInternalNetwork.start, selectedInternalNetwork.netmaskbits, selectedInternalNetwork.unset);
    wizard.internalNetwork.setFloatingIpsRangeEnd(selectedInternalNetwork.end, selectedInternalNetwork.netmaskbits, selectedInternalNetwork.unset);
    wizard.internalNetwork.resetALLFloatingIPsErrors();
  }
};

wizard.internalNetwork.setFloatingIpsRangeStart = function(addr, netmaskbits, unset) {
  setBaseNetmask([
    'internalNetwork-internalNetAllocationPoolStart-0',
    'internalNetwork-internalNetAllocationPoolStart-1',
    'internalNetwork-internalNetAllocationPoolStart-2',
    'internalNetwork-internalNetAllocationPoolStart-3'
  ], addr, netmaskbits, unset);
};

wizard.internalNetwork.setFloatingIpsRangeEnd = function(addr, netmaskbits, unset) {
  setBaseNetmask([
    'internalNetwork-internalNetAllocationPoolEnd-0',
    'internalNetwork-internalNetAllocationPoolEnd-1',
    'internalNetwork-internalNetAllocationPoolEnd-2',
    'internalNetwork-internalNetAllocationPoolEnd-3'
  ], addr, netmaskbits, unset);
};

