/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var cluster;

var loadConfig = {};

loadConfig.onLoad = function() {
  dock = getDock();
  println("Loadconfig initialized: " + window.name + ' - ' + document.documentURI);
  var s = window.name.indexOf('[');
  var e = window.name.indexOf(']');
  var index = window.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  setDialogTitle(myDialog.arguments.title);
  document.getElementById('configFile').focus();
};

loadConfig.cancel = function() {
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
};

loadConfig.resetErrors = function() {
  document.getElementById('error-open').setAttribute('hidden', true);
  document.getElementById('error-parse').setAttribute('hidden', true);
};

loadConfig.ok = function() {
  loadConfig.resetErrors();
  var path = document.getElementById('configFile').value;
  var fileContent = readfile(path);

  if (fileContent===0) {
    document.getElementById('error-open').removeAttribute('hidden');
    document.getElementById('configFile').value = '';
    path = '';
    return false;
  }
  try {
    var yamlContent = jsyaml.safeLoad(fileContent);
    if(myDialog.arguments.validation) {
      myDialog.arguments.validation(yamlContent);
    }
  } catch (err) {
    document.getElementById('error-parse').removeAttribute('hidden');
    document.getElementById('configFile').value = '';
    path = '';
    return false;
  }
  if (path === '') {
    dock.displayError('No file selected');
    return false;
  }

  close();
  myDialog.onOk(yamlContent, path);
};

loadConfig.loadFileDialog = function() {
  loadConfig.resetErrors();
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Select a file", nsIFilePicker.modeOpen);
  var path = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
  path.initWithPath(dock.BASE_PATH);
  fp.displayDirectory = path;
  fp.appendFilter("OpenStack setups", "*.yaml");
  fp.appendFilters(nsIFilePicker.filterAll);

  var res = fp.show();
  if ((res == nsIFilePicker.returnOK)) {
    path = fp.fileURL.path;

    if(startswith(getOS(), "WIN")) {
      if(startswith(path, "/")) {
        path = path.substr(1);
      }
      path = path.replace(/%20/g, " ");
      path = path.replace(/\//g, "\\\\");
    }
    document.getElementById('configFile').value = path;
  } else {
    return;
  }
};
