/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.main = new WizardScreen();

wizard.main.initDefaultConfig = function() {
  println('init wizard.main.initDefaultConfig');

//  wizard.dryMode = true;
//  wizard.advancedMode = false;
};

wizard.main.enter = function() {
  println('enter wizard.main.enter');

  if (!wizard.main.started) {
    wizard.main.started = true;
    println("dry run " + wizard.dryMode);
    var allNetworks = current.find('Network');
    document.getElementById('main-openStackNetwokList').value = allNetworks.reduce(function(previousValue, network) {
      if (network.get('openStackType') !== 'NONE') {
        previousValue.push(network.resolveName());
        wizard.common.unhide('main-openStackNetwok');
        //wizard.dryMode = true;
        //printall("main-openStackNetwokList");
        //wizard.forceDryMode = true;
      }
      return previousValue;
    }, []).join(', ');

    if (current.find("OpenStack").length > 0) {
      wizard.dryMode = wizard.forceDryMode = true;
      wizard.common.unhide('main-openStackInstalled');
    } else {
      wizard.common.hide('main-openStackInstalled');
    }

    if (current.find('Ceph').length > 0) {
      wizard.common.hide('main-cephNotInstalled');
    } else {
      wizard.common.unhide('main-cephNotInstalled');
    }

    if (wizard.common.getOSFlavor().match(/CENTOS7u2|CENTOS7u3|RedHat7u2|RedHat7u3|SL7u2/i)===null) {
      document.getElementById('main-unsupportedOSFlavorLabel').textContent = wizard.common.getOSFlavor() + " distribution is not supported.";
      wizard.common.unhide('main-unsupportedOSFlavor');
    }

    if (wizard.dryMode===true) {
      wizard.main.setDryMode(1);
    } else {
      wizard.main.setDryMode(0);
    }

    if (wizard.forceDryMode===true) {
      wizard.common.unhide("already-deployed-warning");
      //wizard.common.disable('main-isNotDryMode');
      //wizard.common.disable('main-isDryMode');
    }
    if (wizard.advancedMode===true) {
      wizard.main.setAdvancedMode(1);
    } else {
      wizard.main.setAdvancedMode(0);
    }
  }
};
wizard.main.configIsLoaded = false;

wizard.main.forward = function(automatic) {
  println('forward wizard.main.forward');
  wizard.advancedMode = (document.getElementById('main-advancedWizardMode').getAttribute('on') === 'true') ? true : false;
  printallR('dryMode: ' + wizard.dryMode);
  printallR('advancedMode: ' + wizard.advancedMode);
  return wizard.main.error;
};

wizard.main.preEnter = function() {
  wizard.common.unhide('loadConfigButton');
};

wizard.main.leave = function(automatic) {
  wizard.common.hide('loadConfigButton');
};

wizard.main.showLearnMore = function() {
  var d = new dock.cvDialog("chrome://cmgui/content/openstack/install/learnMore.xul", new Object());
  dock.dialogs.showDialog(d);
};

wizard.main.setDryMode = function(choice) {
  //setSimpleRadio(choice, ['main-isNotDryMode', 'main-isDryMode']);
  //var is_drymode = (document.getElementById('main-isDryMode').getAttribute('on') === 'true') ? true : false;
  var is_drymode = wizard.dryMode;
  var title = (is_drymode) ? 'OpenStack Instance Wizard (*** DRY-RUN ***)' : 'OpenStack Instance Wizard' ;
  setDialogTitle(title);
};

wizard.main.setAdvancedMode = function(choice) {
  setSimpleRadio(choice, ['main-basicWizardDryMode', 'main-advancedWizardMode']);
};
