/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.networkIsolation = new WizardScreen();

wizard.networkIsolation.initDefaultConfig = function() {
  println('init wizard.networkIsolation.initDefaultConfig');

//  wizard.common.setConfig(wizard.config.modules.neutron, 'user_network_isolation', 'VXLAN');
};

wizard.networkIsolation.enter = function() {
  function initNetworkIsolation() {
    if (wizard.config.modules.neutron.user_network_isolation==='VLAN') {
      wizard.networkIsolation.setNetworkIsolation(1);
    } else {
      wizard.networkIsolation.setNetworkIsolation(0);
    }
  }
  println('enter wizard.networkIsolation.enter');

  if (!wizard.networkIsolation.started) {
    wizard.networkIsolation.started = true;

    initNetworkIsolation();
  }
};

wizard.networkIsolation.forward = function(automatic) {
  function isValid(type) {
    wizard[type].error = false;
    wizard[type].leave(automatic);
    wizard.networkIsolation.error = wizard[type].error;
    return !wizard.networkIsolation.error;
  }
  println('forward wizard.networkIsolation.forward');
  if (document.getElementById('networkIsolation-VLAN').getAttribute('on')==='true') {
    if (isValid('vlanConfiguration')) {
      wizard.common.setConfig(wizard.config.modules.neutron, 'user_network_isolation', 'VLAN');
      if(wizard.config.modules.neutron.l2_agent) {
        wizard.common.setConfig(wizard.config.modules.neutron, 'new_virtual_host_net_interface', []);
      }
    }
  } else {
    if (isValid('vxlanConfiguration')) {
      wizard.common.setConfig(wizard.config.modules.neutron, 'user_network_isolation', 'VXLAN');
    }
  }
  return wizard.networkIsolation.error;
};

wizard.networkIsolation.setNetworkIsolation = function(choice) {
  setSimpleRadio(choice, ['networkIsolation-VXLAN', 'networkIsolation-VLAN']);
  if (choice === 1) {
    wizard.vlanConfiguration.enter();
    wizard.common.unhide('wz-deck-vlan-configuration');
    wizard.common.hide('wz-deck-vxlan-configuration');
  } else {
    wizard.vxlanConfiguration.enter();
    wizard.common.hide('wz-deck-vlan-configuration');
    wizard.common.unhide('wz-deck-vxlan-configuration');
  }
};
