/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.softWareImage = new WizardScreen();

wizard.softWareImage.initDefaultConfig = function() {
  println('init wizard.softWareImage.initDefaultConfig');
  // by default select all (similar to cm-openstack-setup)
  var softwareImages = current.find('SoftwareImage');
  var lst = [];
  softwareImages.forEach(function(softwareImage, index) {
    lst.push(softwareImage.get('path'));
  });
  wizard.common.setConfig(wizard.config.modules.core, 'software_image_paths', lst);
};

wizard.softWareImage.enter = function() {
  println('enter wizard.softWareImage.enter');

  if (!wizard.softWareImage.started) {
    wizard.softWareImage.started = true;

    var softwareImages = current.find('SoftwareImage');

    var rootElement = document.getElementById('softWareImage-selectedSoftwareImages');

    softwareImages.forEach(function(softwareImage, index) {
      var checkImage = document.createElement('checkimage');
      checkImage.setAttribute('label', softwareImage.get('name'));
      checkImage.setAttribute('id', softwareImage.get('uniqueKey'));
      checkImage.setAttribute('path', softwareImage.get('path'));
      checkImage.setAttribute('width', '200px');
      checkImage.style['max-width'] = '200px';
      checkImage.setAttribute('checked', 'false');
      rootElement.appendChild(checkImage);
    });

    for (var i=0; i<rootElement.children.length; i++) {
      if (wizard.config.modules.core.software_image_paths.indexOf(rootElement.children[i].getAttribute('path'))!==-1) {
        rootElement.children[i].setAttribute('checked', 'true');
      }
    }
    if(wizard.config.hasOwnProperty('setup')) {
      if(!wizard.config.hasOwnProperty('setup')) {
        wizard.config.setup = { };
      }
      if(!wizard.config.setup.hasOwnProperty('skip_rpms')) {
        wizard.config.setup.skip_rpms = false;
      }
    }
    if(wizard.config.setup.skip_rpms) {
      document.getElementById('setup-skip_rpms').setAttribute('checked', 'true');
    }
    else {
      document.getElementById('setup-skip_rpms').setAttribute('checked', 'false');
    }
    wizard.softWareImage.showRPMWarning();
  }
};

wizard.softWareImage.forward = function(automatic) {
  function atLeastOneSoftwareImage(list, errorElementId) {
    if (list.length < 1) {
      wizard.common.displayError(errorElementId, automatic);
      wizard.softWareImage.error = true;
      return false;
    }
    wizard.common.hide(errorElementId);
    return true;
  }
  println('forward wizard.softWareImage.forward');

  var softwareImage = [];
  var rootElement = document.getElementById('softWareImage-selectedSoftwareImages');
  for(var i=0; i<rootElement.children.length; i++) {
    if (rootElement.children[i].checked===true) {
      softwareImage.push(rootElement.children[i].getAttribute('path'));
    }
  }

  if (atLeastOneSoftwareImage(softwareImage, 'softWareImage-error-none')) {
    wizard.common.setConfig(wizard.config.modules.core, 'software_image_paths', softwareImage);
  }

  if(document.getElementById('setup-skip_rpms').getAttribute('checked') == 'true') {
    wizard.config.setup.skip_rpms = true;
  }
  else {
    wizard.config.setup.skip_rpms = false;
  }

  for(var mod_name in wizard.config.modules) {
    wizard.common.setConfig(wizard.config.modules[mod_name], 'software_image_paths', softwareImage);
  }
  printallR('software_image_paths: ' + wizard.config.modules.core.software_image_paths);

  return wizard.softWareImage.error;
};

wizard.softWareImage.hideSkipRPM = function() {
  document.getElementById('setup-skipInstallBox').setAttribute('hidden',true);
}

wizard.softWareImage.showSkipRPM = function() {
  document.getElementById('setup-skipInstallBox').setAttribute('hidden',false);
}


wizard.softWareImage.showRPMWarning = function() {
  if(document.getElementById('setup-skip_rpms').getAttribute('checked') == 'true') {
    document.getElementById('setup-skipInstallBox-warning').removeAttribute('hidden');
  }
  else {
    document.getElementById('setup-skipInstallBox-warning').setAttribute('hidden', true);
  }
}
