/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.storeVolumes = new WizardScreen();

wizard.storeVolumes.initDefaultConfig = function() {
  println('init wizard.storeVolumes.initDefaultConfig');
  if (current.find('Ceph').length > 0) {
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'ceph');
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', 'ceph');
  } else {
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'nfs');
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');
  }
};

wizard.storeVolumes.enter = function() {
  function initManageUsers() {
    switch(wizard.config.modules.cinder.volume_backend) {
      case 'ceph':
        wizard.storeVolumes.setStoreVolumes(0);
        break;
      case 'nfs':
        wizard.storeVolumes.setStoreVolumes(1);
        break;
//      case 'gpfs':
//        wizard.storeVolumes.setStoreVolumes(3);
//        break;
//      case 'solidfire':
//        wizard.storeVolumes.setStoreVolumes(4);
//        break;
//      case '3par':
//        wizard.storeVolumes.setStoreVolumes(5);
//        break;
//      case 'netapp':
//        wizard.storeVolumes.setStoreVolumes(6);
//        break;
      case 'other':
      case 'none':
      default:
        wizard.storeVolumes.setStoreVolumes(2);
        break;
    }
  }
  function initCephOptions() {
    if (current.find('Ceph').length === 0) {
      document.getElementById('storeVolumes-CephContainer').removeAttribute('onclick');
      wizard.common.disable('storeVolumes-ceph');
    }
  }
  println('enter wizard.storeVolumes.enter');

  if (!wizard.storeVolumes.started) {
    wizard.storeVolumes.started = true;

    initManageUsers();
    initCephOptions();
  }
};

wizard.storeVolumes.forward = function(automatic) {
  println('forward wizard.storeVolumes.forward');

  if (document.getElementById('storeVolumes-ceph').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'ceph');
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', 'ceph');

  } else if (document.getElementById('storeVolumes-nfs').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'nfs');
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');

  } else if (document.getElementById('storeVolumes-none').getAttribute('on') === 'true') {
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'other');
    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');

//  } else if (document.getElementById('storeVolumes-gpfs').getAttribute('on') === 'true') {
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'gpfs');
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');
//
//  } else if (document.getElementById('storeVolumes-solidfire').getAttribute('on') === 'true') {
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'solidfire');
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');
//
//  } else if (document.getElementById('storeVolumes-3par').getAttribute('on') === 'true') {
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', '3par');
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');
//
//  } else if (document.getElementById('storeVolumes-netapp').getAttribute('on') === 'true') {
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backend', 'netapp');
//    wizard.common.setConfig(wizard.config.modules.cinder, 'volume_backup_backend', '');
//
  }

  printallR('volume_backend: ' + wizard.config.modules.cinder.volume_backend);
  printallR('volume_backup_backend: ' + wizard.config.modules.cinder.volume_backup_backend);

  return wizard.storeVolumes.error;
};

wizard.storeVolumes.setStoreVolumes = function(choice) {
  setSimpleRadio(choice, [
    'storeVolumes-ceph',
    'storeVolumes-nfs',
    'storeVolumes-none',
//    'storeVolumes-gpfs',
//    'storeVolumes-solidfire',
//    'storeVolumes-3par',
//    'storeVolumes-netapp'
  ]);
};
