/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
wizard.vxlanConfiguration = new WizardScreen();

wizard.vxlanConfiguration.initDefaultConfig = function() {
  println('init wizard.vxlanConfiguration.initDefaultConfig');
  /* @todo fixme */
  return;
  var networkTable = {
    final: 0,
    name: wizard.config.modules.neutron.vxlan_host_net_name,
    vxlanRange: wizard.config.modules.neutron.vxlan_host_vxlan_range,
    //baseAddress: wizard.config.modules.neutron.vxlan_host_net_base_address,
    //netmaskBits: wizard.config.modules.neutron.vxlan_host_net_netmask_bits
  };
  var internalNetworks = current.findInternalNetworks();
  internalNetworks.reduce(function(networkTable, network) {
    if (networkTable.final<3 && network.get('openStackType') === 'VXLANHOST') {
      networkTable.final = 3;
      networkTable.name = network.get('name');
      networkTable.vxlanRange = network.get('openStackVlanRange');
      //networkTable.baseAddress = network.get('baseAddress');
      //networkTable.netmaskBits = network.get('netmaskBits');
    } else if (networkTable.final<2 && network.get('name') === 'vxlanhostnet') {
      networkTable.final = 2;
      networkTable.name = network.get('name');
      //networkTable.baseAddress = network.get('baseAddress');
      //networkTable.netmaskBits = network.get('netmaskBits');
    } else if (networkTable.final<1 && network.get('name') !== wizard.config.modules.neutron.internal_net_name) {
      networkTable.final = 1;
      networkTable.name = network.get('name');
      //networkTable.baseAddress = network.get('baseAddress');
      //networkTable.netmaskBits = network.get('netmaskBits');
    }
    return networkTable;
  }, networkTable);

  wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_vxlan_range', networkTable.vxlanRange);
  wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_net_name', networkTable.name);
//  wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_net_base_address', networkTable.baseAddress);
//  wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_net_netmask_bits', networkTable.netmaskBits);
};

wizard.vxlanConfiguration.enter = function() {
  function initVxlanRange() {
    var vxlanRangeStart = 0;
    var vxlanRangeEnd = 0;
    var vxlanHostVxlanRangeMatch = wizard.config.modules.neutron.vxlan_host_vxlan_range.match(/([0-9]+):([0-9]+)/);
    if (vxlanHostVxlanRangeMatch !== null) {
      vxlanRangeStart = vxlanHostVxlanRangeMatch[1];
      vxlanRangeEnd = vxlanHostVxlanRangeMatch[2];
    }
    document.getElementById('vxlanConfiguration-RangeStart').value = vxlanRangeStart;
    document.getElementById('vxlanConfiguration-RangeEnd').value = vxlanRangeEnd;
  }

  function initNewNetName(name) {
    document.getElementById('vxlanConfiguration-NewName').value = name;
  }

  function initBaseAddress() {
    if (ipaddr.isValid(wizard.config.modules.neutron.vxlan_host_net_base_address)) {
      var netAddrBase = ipaddr.parse(wizard.config.modules.neutron.vxlan_host_net_base_address);
      setBaseNetmask([
        'vxlanConfiguration-NewBaseAddress-0',
        'vxlanConfiguration-NewBaseAddress-1',
        'vxlanConfiguration-NewBaseAddress-2',
        'vxlanConfiguration-NewBaseAddress-3'
      ], netAddrBase, 32, false);
    }
  }

  function initNetmaskBits() {
    if (Number.isInteger(parseInt(wizard.config.modules.neutron.vxlan_host_net_netmask_bits))) {
      document.getElementById('vxlanConfiguration-NewNetmaskBits').selectedIndex = parseInt(wizard.config.modules.neutron.vxlan_host_net_netmask_bits);
    }
  }

  println('enter wizard.vxlanConfiguration.enter');

  if (!wizard.vxlanConfiguration.started) {
    wizard.vxlanConfiguration.started = true;


    var internalNetworks = current.findInternalNetworks();
    var newNetName = wizard.config.modules.neutron.vxlan_host_net_name;
    var newNetNameExists = false;
    var internalNetworksForVXLAN = [];
    for (var i = 0; i < internalNetworks.length; i++) {
      if (internalNetworks[i].resolveName() !== wizard.config.modules.neutron.internal_net_name) {
        // Prepend vxlanhostnet type/name so that it is offered first before anything else in the dropdown
        if (internalNetworks[i].get('openStackType') === 'VXLANHOST' || internalNetworks[i].resolveName() === wizard.config.modules.neutron.vxlan_host_net_name) {
          internalNetworksForVXLAN.unshift(internalNetworks[i]);
        } else {
          internalNetworksForVXLAN.push(internalNetworks[i]);
        }
        // Just in order to avoid suggesting a name of an already existing network
        if (internalNetworks[i].resolveName() === wizard.config.modules.neutron.vxlan_host_net_name) {
          newNetName = '';
          newNetNameExists = true;
        }
      }
    }

    fillListDropdown({
      popupId: 'vxlanConfiguration-UseExistingList',
      list: internalNetworksForVXLAN,
      selectedElement: {value: wizard.config.modules.neutron.vxlan_host_net_name, defaultIndex: 0}
    });

    initNewNetName(newNetName);
    initBaseAddress();
    initNetmaskBits();

    initVxlanRange();

    if (internalNetworksForVXLAN.length > 0 && newNetNameExists) {
      wizard.vxlanConfiguration.setVxlanCreationMethod(0);
    } else if (internalNetworksForVXLAN.length > 0 && !newNetNameExists) {
      wizard.vxlanConfiguration.setVxlanCreationMethod(1);
    } else {
      wizard.vxlanConfiguration.setVxlanCreationMethod(1);
      wizard.common.disable('vxlanConfiguration-CreationMethodUse');
      wizard.common.disable('vxlanConfiguration-CreationMethodNew');
      wizard.vxlanConfiguration.setVxlanCreationMethod = function() {};
      document.getElementById('vxlanConfiguration-UseLabel').value = "No available internal networks. The '" + wizard.config.modules.neutron.internal_net_name + "' cannot be used for VXLAN host.";
      wizard.common.unhide('vxlanConfiguration-UseLabel');
      wizard.common.hide('vxlanConfiguration-UseExistingList');
    }
  }
};

wizard.vxlanConfiguration.forward = function(automatic) {
  function isValidInterfaceName(interfaceName, errorElementId) {
    if (!interfaceName.match(/^[a-zA-Z0-9]+$/)) {
      wizard.common.displayError(errorElementId, automatic);
      wizard.vxlanConfiguration.error = true;
      return false;
    }
    wizard.common.hide(errorElementId);
    return true;
  }
  function isValidNumber(password, errorElementId) {
    if (!password.match(/^[0-9]+$/)) {
      wizard.common.displayError(errorElementId, automatic);
      wizard.vxlanConfiguration.error = true;
      return false;
    }
    wizard.common.hide(errorElementId);
    return true;
  }
  function isValidRange(start, end, errorElementId) {
    if (parseInt(start) >= parseInt(end)) {
      wizard.common.displayError(errorElementId, automatic);
      wizard.vxlanConfiguration.error = true;
      return false;
    }
    wizard.common.hide(errorElementId);
    return true;
  }

  println('forward wizard.vxlanConfiguration.forward');

  if (document.getElementById('vxlanConfiguration-CreationMethodNew').getAttribute('on') === 'true') {
    var interfaceName = document.getElementById('vxlanConfiguration-NewName').value;
    var ip = document.getElementById('vxlanConfiguration-NewBaseAddress-0').value + '.' + document.getElementById('vxlanConfiguration-NewBaseAddress-1').value + '.' + document.getElementById('vxlanConfiguration-NewBaseAddress-2').value + '.' + document.getElementById('vxlanConfiguration-NewBaseAddress-3').value;
    var netmaskBits = document.getElementById('vxlanConfiguration-NewNetmaskBits').label;
  } else {
    var interfaceName = document.getElementById('vxlanConfiguration-UseExistingList').label;
    var uniqueKey = document.getElementById('vxlanConfiguration-UseExistingList').selectedItem.getAttribute('key');
    var selectedNetwork = current.find(uniqueKey);
    var ip = selectedNetwork.get('baseAddress');
    var netmaskBits = selectedNetwork.get('netmaskBits');
  }
  netmaskBits = parseInt(netmaskBits);

  if (isValidNumber(document.getElementById('vxlanConfiguration-RangeStart').value, 'vxlanConfiguration-error-rangeStart-invalid')) {
    if (isValidNumber(document.getElementById('vxlanConfiguration-RangeEnd').value, 'vxlanConfiguration-error-rangeEnd-invalid')) {
      if (isValidRange(document.getElementById('vxlanConfiguration-RangeStart').value, document.getElementById('vxlanConfiguration-RangeEnd').value, 'vxlanConfiguration-error-rangeEnd-lower')) {
        if (isValidInterfaceName(interfaceName, 'vxlanConfiguration-error-newName-invalid')) {
          if (wizard.validator.isValidIP(ip, 'vxlanConfiguration-error-newBaseAddress-invalid', automatic)) {
            wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_net_name', interfaceName);
            wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_net_base_address', ip);
            wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_net_netmask_bits', netmaskBits);
            wizard.common.setConfig(wizard.config.modules.neutron, 'vxlan_host_vxlan_range', document.getElementById('vxlanConfiguration-RangeStart').value + ':' + document.getElementById('vxlanConfiguration-RangeEnd').value);
          }
        }
      }
    }
  }

  printallR('vxlan_host_net_name: ' + wizard.config.modules.neutron.vxlan_host_net_name);
  printallR('vxlan_host_net_base_address: ' + wizard.config.modules.neutron.vxlan_host_net_base_address);
  printallR('vxlan_host_net_netmask_bits: ' + wizard.config.modules.neutron.vxlan_host_net_netmask_bits);
  printallR('vxlan_host_vxlan_range: ' + wizard.config.modules.neutron.vxlan_host_vxlan_range);

  return wizard.vxlanConfiguration.error;
};

wizard.vxlanConfiguration.setVxlanCreationMethod = function(choice) {
  setSimpleRadio(choice, ['vxlanConfiguration-CreationMethodUse', 'vxlanConfiguration-CreationMethodNew']);
  if (choice === 1) {
    wizard.common.enable('vxlanConfiguration-NewName');
    wizard.common.enable('vxlanConfiguration-NewBaseAddress-0');
    wizard.common.enable('vxlanConfiguration-NewBaseAddress-1');
    wizard.common.enable('vxlanConfiguration-NewBaseAddress-2');
    wizard.common.enable('vxlanConfiguration-NewBaseAddress-3');
    wizard.common.enable('vxlanConfiguration-NewNetmaskBits');
    wizard.common.disable('vxlanConfiguration-UseExistingList');
  } else {
    wizard.common.disable('vxlanConfiguration-NewName');
    wizard.common.disable('vxlanConfiguration-NewBaseAddress-0');
    wizard.common.disable('vxlanConfiguration-NewBaseAddress-1');
    wizard.common.disable('vxlanConfiguration-NewBaseAddress-2');
    wizard.common.disable('vxlanConfiguration-NewBaseAddress-3');
    wizard.common.disable('vxlanConfiguration-NewNetmaskBits');
    wizard.common.enable('vxlanConfiguration-UseExistingList');
  }
};
