/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var xml;
var path = '';
var cluster;

function onLoad() {
  dock = getDock();
  println("Loadxmlconfig initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  setDialogTitle(myDialog.arguments.title);
  document.getElementById('xmlConfigFile').focus();

  var text = 'If you have an XML configuration file already, you can select it here. Doing this skips all the questions that the wizard asks you when it helps you make an XML configuration file. Instead of answering questions, you get to jump ahead, straight to the OpenStack deployment page of the wizard.';
  document.getElementById('widgetText').value = text;
}

function cancel(){
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}

function ok(){
  if (path === '') {
    dock.displayError('No file selected');
    return false;
  }
  var oParser = new DOMParser();
  var oDOM = oParser.parseFromString(xml, "text/xml");
  if ( oDOM.documentElement.nodeName == "parsererror" ){
    dock.displayError('Error parsing XML file');
    return false;
  } else {
    close();
    myDialog.onOk(xml, path);
  }
}

function loadXmlFileDialog(){
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Select a file", nsIFilePicker.modeOpen);
  path = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
  path.initWithPath(dock.BASE_PATH);
  fp.displayDirectory = path;
  fp.appendFilter("xml openstack setup files", "*.xml");
  fp.appendFilters(nsIFilePicker.filterAll);

  var res = fp.show();
  if ((res == nsIFilePicker.returnOK)) {
    path = fp.fileURL.path;

    if(startswith(getOS(), "WIN")) {
      if(startswith(path, "/")) {
        path = path.substr(1);
      }
      path = path.replace(/%20/g, " ");
      path = path.replace(/\//g, "\\\\");
    }
    document.getElementById('xmlConfigFile').value = path;
    xml = readfile(path);
    if(xml===0) {
      dock.displayError('Unable to open file ' + path);
      document.getElementById('xmlConfigFile').value = '';
      path = '';
    }
  } else {
    return;
  }
}