/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function addWizardCheck() {
  // external net with gateway BLOCK
  var externalNets = current.findExternalNetworks();
  //if (externalNets.length > 0) {
  //if (externalNets[0].get('gateway') == '0.0.0.0') {
  //var text = "External network '" + externalNets[0].resolveName() + "' has no gateway configured.\nOpenStack Setup Wizard cannot be started.";
  //dock.displayError(text);
  //return;
  //}
  //}

  // check number of slavenodes
  var cloudNodes = current.find("CloudNode");
  var slaveNodes = current.find("SlaveNode");
  if ( slaveNodes == 0 && cloudNodes == 0){
    var text = "There are no compute nodes to deploy OpenStack onto. Please configure at least one compute host on the cluster before proceeding with this wizard.";
    dock.displayError(text);
    return;
  }

  // check number of openstacks
  var openstacks = current.find("OpenStack");
  if (openstacks.length > 0) {
    var args = new Object();
    args['question'] = "Only one OpenStack deployment per cluster is currently supported. It seems there already is an OpenStack deployment configured on this cluster. Because of this the OpenStack setup wizard can only be run in a dry run mode. If you want to recreate your OpenStack deployment using the wizard you must first remove all the major components of the existing deployment. Using 'cm-openstack-setup' utility with '--remove' flag might be helpful in removing the existing OpenStack deployment. However, afterwards you might still have to manually reconfigure some elements of your cluster and remove things like e.g. OpenStack networks, network interfaces (otherwise the OpenStack wizard might refuse to proceed past the precheck stage). Are you sure you want to continue?";
    var d = new dock.cvDialog('chrome://cmgui/content/question.xul', args);
    d.onOk = function() {
      addWizard();
    }
    dock.dialogs.showDialog(d);
  } else {
    addWizard();
  }
}

function addWizard() {
  var win = dock.windowMediator.getMostRecentWindow('addOpenStackSetupWizard');
  if ( win ) {
    dock.windowMediator.getMostRecentWindow('addOpenStackSetupWizard').focus();
    return false;
  }
  var args = new Object();
  args['cluster'] = current;
  var d = new dock.cvDialog("chrome://cmgui/content/openstack/install/wizard.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
