/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var basetype = 'OpenStackTenant';
var singular = 'OpenStack Tenant';
var plural = 'OpenStack Tenants';

function onLoad() {
  dock = getDock();
  println(".Load: " + document.title);
}

function refresh(use) {
  if (!!use) current = use;
  println('Refresh ' + document.title);
  println('Refresh ' + singular +' folder overview');
  tree = document.getElementById('tree');
  var list = current.find(basetype);
  data = new Array();
  var modified = false;
  for (var i = 0; i < list.length; i++) {
    data.push(createTreeItem(list[i]));
  }
  for (var i = list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);

  // logout & login again
  logout(current);
  var host = current.host;
  var openstacks = current.find("OpenStack");
  if (openstacks.length > 0) {
    var openstack = openstacks[0];
    if (openstack.object && openstack.get('enabled')) {
      var credentials = openstack.get('credentials');
      var dashboarduser = credentials.brightServiceUserUsername;
      var dashboardpwd = credentials.brightServiceUserPassword;
    }
    if (login(host, dashboarduser, dashboardpwd)) {
      current.openStackloggedin = true;
    }
  }
}

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.get('uniqueKey');
  item['modified'] = one.get('modified');
  item['name'] = one.get('name');
  item['tenantID'] = one.get('tenantID'); 
  item['description'] = one.get('description');
  if (one.get('enabled')) {
    item['enabled'] = true;
  } else {
    item['enabled'] = false;
  }
  return item;
}

function getSelected() {
  return selected('list');
}

function editObject() {
  var cluster = current;
  if (!!current.cluster) cluster = current.cluster;
  var select = getSelected();
  if (select.length == 0) {
    dock.displayError('Please select a ' + singular);
  } else if (select.length > 1) {
    dock.displayError('Please select only one ' + singular);
  } else {
    cluster.select(select[0]);
  }
}
