/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var overlay_controller;
var role_config;
var current;
var is_loaded = false;
var pending_use = null;
var category = "";
var role = null;
var subfield = "roles";
var old;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
  if(location.hash.indexOf('#POPUP') === 0) {
    // page was loaded from node or categories as POPUP
    var s = this.name.indexOf('[');
    var e = this.name.indexOf(']');
    var index = this.name.substr(s + 1, e - s - 1);
    var myDialog = dock.dialogs.list[index];
    current = myDialog.arguments.object;
    var role = myDialog.arguments.subobject;
    var dialogbuttons = document.getElementById('dialogbuttons');
    old = role.old(false, true);
    if(dialogbuttons) {
      dialogbuttons.removeAttribute('hidden');
    }
    var role_label = document.getElementById('role_label');
    if(role_label) {
      if(role.object.childType == 'HAProxyRole') {
        role_label.setAttribute('value', 'HAProxy Role');
        window.resizeTo(800,500);
      }
      else if(role.object.childType == 'MemcachedRole') {
        role_label.setAttribute('value', 'Memcached Role');
      }
      else if(role.object.childType == 'GaleraRole') {
        role_label.setAttribute('value', 'Galera Role');
      }
      else {
        role_label.setAttribute('value', role.object.childType);
      }
    }
    is_loaded = true;
    if(pending_use) {
      refresh(pending_use);
    }
    else {
      refresh(current, role);
    }
  }
  else  {
    // page was loaded from overlay iframe
    overlay_controller = window.parent.overlay_controller;
    role_config = overlay_controller.xulsrc2roles[document.documentURI];
    current = window.parent.current;
    var roles = current.get('roles');
    for(var i = 0; i < roles.length; i++) {
      if(roles[i].childType == role_config.name) {
        role = roles[i];
        break;
      }
    }
    var role_label = document.getElementById('role_label');
    if(role_label) {
      if(role_config.long_label) { 
        role_label.setAttribute('value', role_config.long_label);
      }
      else {
        role_label.setAttribute('value', role_config.label);
      }
    }
    is_loaded = true;
    if(pending_use) {
      refresh(pending_use);
    }
    else {
      var one = new dock.cvObject(current.cluster, role, current, 'roles');
      refresh(current, one);
    }
  }
}

function refresh(use, use_role) {
  if(!is_loaded) {
    pending_use = use;
    return;
  }
  if(!!use) {
    current = use;
  }
  if(!!use_role) {
    role = use_role;
  }
  var child_type = role.get('childType');
  if(initRoles.hasOwnProperty(child_type)) {
    initRoles[child_type](role);
  }
  else {
  }

}

function popupOk() {
  if(role.get('modified')) current.set('modified', true);
  //updateResourceEnforceFromRows();
  close();
  myDialog.onOk();
}

function popupCancel() {
  if(!window.closed) {
    role.old(old);
    close();
  }
}

function ElkCustomConfigInput(role_name, one, field) {
  var toolbar = document.getElementById('toolbar' + role_name);
  var advancedInputElement = document.getElementById(role_name + '_' + field);
  var context = document.getElementById('edit' + role_name);

  function switchToNormalView() {
    advancedInputElement.setAttribute('old_value', (advancedInputElement.getAttribute('value') || ''));
    one.set(field, '');
    if(context) {
      for(var i = 0; i < context.children.length; i++) {
        if(context.children[i].getAttribute('advanced')) {
          context.children[i].setAttribute('hidden', true);          
        }
        else {
          context.children[i].removeAttribute('hidden');
        }
      }
    }
  }

  function switchToCustomView() {
    var value = advancedInputElement.getAttribute('old_value') || '';
    advancedInputElement.setAttribute('value', value);
    one.set(field, value);
    if(context) {
      for(var i = 0; i < context.children.length; i++) {
        if(context.children[i].getAttribute('advanced')) {
          context.children[i].removeAttribute('hidden');
        }
        else {
          context.children[i].setAttribute('hidden', true);
        }
      }
    }
  }

  if(toolbar && toolbar.children.length > 1) {
    toolbar.children[0].addEventListener("command", switchToNormalView, false);
    toolbar.children[1].addEventListener("command", switchToCustomView, false);
    if(one.get(field) != '') {
      toolbar.children[0].removeAttribute('checked');
      toolbar.children[1].setAttribute('checked', true);
      switchToCustomView();
    }
    else {
      toolbar.children[0].setAttribute('checked', true);
      toolbar.children[1].removeAttribute('checked');
      switchToNormalView();
    }
  }
}

function switchAdvancedView(advanced, elementId, clearField = null) {
}


var initRoles = {

  'populateSingleArrayAttributeList' : function(one, field, options={}) {
    var role = one.object;
    var width = options.hasOwnProperty('width') ? options['width'] : '120px';
    // Todo: remove all appearences of this pattern to this 
    var arrayAttributeListable = new SingleArrayAttributeListable(one, field);
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': width}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_' + field,
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
  },

  'OpenStackComputeConductorRole' : function(one) {
    role_text('workersCount', one, '', '^[0-9]*$');
  },

  'OpenStackIdentityApiRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_text('apiPortForAdmin', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_resolve('networkForAdmin', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_text('workers', one, category, '^[0-9]*$');
    role_text('workersForAdmin', one, category, '^[0-9]*$');
    role_enum('tokenPersistenceBackend', one, [['memcachedPool', 'memcachedPool'], ['memcached', 'memcached'], ['sql', 'sql']], category);
    role_checkbox('caching', one, category);
    role_enum('tokenCacheBackend', one, [['memcached', 'memcached'], ['pylibmc', 'pylibmc'], ['bmemcached', 'bmemcached'], ['redis', 'redis'], ['dbm', 'dbm'], ['memory', 'memory'], ['mongo', 'mongo'], ['memcached_pool', 'memcached_pool'], ['none', 'none']], category);
    role_text('memcachedServer', one, category);
    role_checkbox('autoResolveLocalMemcached', one, category);
    role_checkbox('enableAdminEndpoint', one, category);
  },

  'OpenStackComputeConductorRole' : function(one) {
    var role = one.object;
    role_text('workersCount', one, category, '^[0-9]*$');
  },

  'OpenStackComputeRole': function(one) {
    var role = one.object;
    if (category !== "") {
      document.getElementById('OpenStackComputeRole').setAttribute('hidden', true);
    } else {
      document.getElementById('OpenStackComputeRole').removeAttribute('hidden');
    }
    var backendType = 'None/Custom';
    for (var i = 0; i < role.imageBackends.length; ++i ){
      if (!role.imageBackends[i].toBeRemoved) {
        if ( role.imageBackends[i].childType === 'OpenStackNovaImageBackendCow' ){
          backendType = 'Cow';
        } else if ( role.imageBackends[i].childType === 'OpenStackNovaImageBackendCeph' ){
          backendType = 'Ceph';
        }
      }
    }
    var o = document.getElementById('LibVirtBackEnd');
    o.setAttribute('value', backendType);

    role_enum('computeDriver', one, [['DEFAULT_COMPUTE_DRIVER', 'Default'], ['LIBVIRT_DRIVER', 'LibVirt'], ['XEN_API_DRIVER', 'XenAPI'], ['FAKE_DRIVER', 'fake'], ['BAREMETAL_DRIVER', 'BareMetal'], ['VMWARE_ESX_DRIVER', 'VMWareESXDriver'], ['VMWARE_VC_DRIVER', 'VMWareVCDriver']], category);
    role_enum('libvirtDomain', one, [['DEFAULT_DOMAIN', 'Default'], ['KVM_DOMAIN', 'KVM'], ['LXC_DOMAIN', 'LXC'], ['QEMU_DOMAIN', 'QEMU'], ['UML_DOMAIN', 'UML'], ['XEN_DOMAIN', 'OTHER']], category);
    role_enum('libvirtCPUMode', one, [['DEFAULT_CPU_MODE', 'Default'], ['HOST_MODEL_MODE', 'Host Model'], ['HOST_PASSTHROUGH_MODE', 'Host Passthrough'], ['CUSTOM_MODE', 'Custom'], ['NONE_MODE', 'None']], category);
    role_text('libvirtCPUModel', one, category);
    role_enum('libvirtInjectPassword', one, [[null, ''], [true, 'Yes'], [false, 'No']], category);
    role_enum('libvirtInjectKey', one, [[null, ''], [true, 'Yes'], [false, 'No']], category);
    role_text('libvirtInjectPartition', one, category, '^(-2|-1|[0-9]+)$');
    role_text('statePath', one, category, '^.+$');
    role_text('vcpuPinSet', one, category);
    role_checkbox('linuxBridgeEnableSecurityGroup', one, category);
    role_enum('linuxBridgeFirewallDriver', one, [['NOOP', 'neutron.NoopFirewallDriver'], ['IPTABLES', 'neutron.IptablesFirewallDriver']], category);
    role_text('linuxBridgeCustomFirewallDriver', one, category);

    menuListEditable({
      wrapperElementId: 'OpenStackComputeRole_linuxBridgeWrapper',
      menuListElementId: 'OpenStackComputeRole_linuxBridgeFirewallDriver',
      textboxElementId:'OpenStackComputeRole_linuxBridgeCustomFirewallDriver'
    });
    if(category) {
      document.getElementById('OpenStackComputeRole_linuxBridgeWrapper').setAttribute('disabled', 'true');
    } else {
      document.getElementById('OpenStackComputeRole_linuxBridgeWrapper').removeAttribute('disabled');
    }

    role_checkbox('resumeGuestsOnHostBoot', one, category);
    role_text('vifPluggingTimeOut', one, category, '^[0-9]+$');
    role_checkbox('vifPluggingIsFatal', one, category);
    var nFsmount = role.fsmounts.reduce(function(previousValue, currentValue) {
      return (currentValue.toBeRemoved===false) ? ++previousValue : previousValue;
    }, 0);
    var o = document.getElementById('openStackComputeRoleFSMountLabel');
    if(nFsmount>1) {
      o.setAttribute('value', nFsmount + ' filesystem mounts');
    } else if(nFsmount===1) {
      o.setAttribute('value', '1 filesystem mount');
    } else {
      o.setAttribute('value', 'No filesystem mount');
    }
    if(role.libvirtdCustom.length>0) {
      document.getElementById('libvirtdCustom').setAttribute('value', '1 customization');
    } else {
      document.getElementById('libvirtdCustom').setAttribute('value', 'No customizations');
    }
  },

  'OpenStackDashboardRole': function(one) {
    var role = one.object;
    role_text('memcachedServer', one, category);
    role_checkbox('autoResolveLocalMemcached', one, category);
    role_checkbox('allowAllHosts', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'allowedHosts');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_allowedHosts',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_text('apiResultPageSize', one, category, '^[0-9]+$');
    role_text('sessionTimeout', one, category, '^[0-9]+$');
    role_text('apiResultLimit', one, category, '^[0-9]+$');
    role_text('timeZone', one, category);
    role_text('openstackKeystoneUrl', one, category);
    role_checkbox('debug', one, category);
  },
    
  'OpenStackMessageQueueServerRole': function(one) {
    var role = one.object;
    role_enum('messageQueueBackend', one, ['RABBITMQ', 'OTHER'], category);
  },

   
  'OpenStackNodeRole': function(one) {
    var role = one.object;
    if (category !== "") {
      document.getElementById('OpenStackNodeRole').setAttribute('hidden', true);
    } else {
      document.getElementById('OpenStackNodeRole').removeAttribute('hidden');
    }
    role_text('availabilityZone', one, category);
    role_checkbox('configFileCustomizationsAreEnabled', one, category);
    var nCustomizations = 0;
    for(var i = 0; i < role.configFileCustomizations.length; i++) {
      if(role.configFileCustomizations[i].toBeRemoved===false) {
        nCustomizations++;
      }
    }
    var o = document.getElementById('customizations');
    if(nCustomizations>1) {
      o.setAttribute('value', nCustomizations + ' customizations');
    } else if(nCustomizations===1) {
      o.setAttribute('value', '1 customization');
    } else {
      o.setAttribute('value', 'No customizations');
    }
    role_text('customBackendHAProxyHost', one, category);
    role_text('customBackupBackendHAProxyHost', one, category);
    role_checkbox('useOnlyBackendHAProxiesFromSameAZ', one, category);
    role_checkbox('preferCustomBackupBackendHAproxyOverNonup', one, category);
    role_checkbox('fallbackToNonBackendHAProxies', one, category);
    role_checkbox('fallbackToNonUpHAProxies', one, category);
    role_checkbox('useLocalBackendHAProxyIfPossible', one, category);
    role_text('serviceRestartDelay', one, category);
  },
    
  'OpenStackVolumeRole': function(one) {
    var role = one.object;
    if (category !== "" && category !== null) {
      document.getElementById('OpenStackVolumeRole').setAttribute('hidden', true);
    } else {
      document.getElementById('OpenStackVolumeRole').removeAttribute('hidden');
    }
    /* 
    var volumeType = {
      Ceph: 0,
      NFS: 0,
      SolidFire: 0,
      '3PAR': 0,
      GPFS: 0,
      NetApp: 0
    };
    for (var i = 0; i < role.volumeBackends.length; ++i) {
      if (!role.volumeBackends[i].toBeRemoved) {
        if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendCeph' ){
          volumeType.Ceph++;
        } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendNFS' ){
          volumeType.NFS++;
        } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendSolidFire' ){
          volumeType.SolidFire++;
        } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackend3PAR' ){
          volumeType['3PAR']++;
        } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendGPFS' ){
          volumeType.GPFS++;
        } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendNetApp' ){
          volumeType.NetApp++;
        }
      }
    }
    var backendType = '';
    for(var vType in volumeType) {
      if (volumeType.hasOwnProperty(vType)) {
        printall(volumeType);
        if(volumeType[vType]>0) {
          if(backendType !== '') {
            backendType += ' and ';
          }
          backendType += volumeType[vType] + ' ' + vType;
        }
      }
    }
    if(backendType === '') {
      backendType = 'None/custom';
    }
    var o = document.getElementById('volBackEnd');
    o.setAttribute('value', backendType); */
    role_text('glanceApiVersion', one, category);
    document.getElementById('OpenStackVolumeRole').setAttribute('src', "chrome://cmgui/content/openstack/configrole/volume/openstackVolumeRoleBackend.xul");
  },

  'OpenStackVolumeBackupRole': function(one) {    
    var role = one.object;
    if (category !== "") {
      document.getElementById('OpenStackVolumeBackupRole').setAttribute('hidden', true);
    } else {
      document.getElementById('OpenStackVolumeBackupRole').removeAttribute('hidden');
    }
    var backendType = 'None/custom';
    for (var i = 0; i < role.backupBackends.length; ++i) {
      if (!role.backupBackends[i].toBeRemoved) {
        if ( role.backupBackends[i].childType === 'OpenStackVolumeBackupBackendCeph' ){
          backendType = 'Ceph';
          break;
        }
        /*
          else if ( role.backupBackends[i].childType === 'OpenStackVolumeBackupBackendNFS' ){
          backendType = 'NFS';
          break;
          }
        */
      }
    }
    var o = document.getElementById('backupBackEnd');
    o.setAttribute('value', backendType);
  },
    
  'OpenStackComputeApiRole': function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'memcachedServers');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_memcachedServers',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('autoResolveLocalMemcached', one, category);
    role_checkbox('notifyApiFaults', one, category);
    role_text('workers', one, category, '^[0-9]*$');
  },
    
  'OpenStackComputeSchedulerRole': function(one) {
  },

  'OpenStackComputeApiEC2Role': function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_text('workers', one, category, '^[0-9]*$');
  },

  'OpenStackComputeVNCProxyRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_text('novncProxyBaseURL', one, category);
  },

  'OpenStackComputeApiMetadataRole': function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_text('workers', one, category, '^[0-9]*$');
  },
  
  'OpenStackOrchestrationRole': function(one) {
    var role = one.object;
    role_text('workers', one, category, '^[0-9]*$');
  },

  'OpenStackOrchestrationApiRole' : function(one) { 
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_text('apiPortCnf', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    //      role_text('workers', one, category, '^[0-9]*$');
    role_text('maxHeaderLine', one, category, '^[0-9]*$');
  },
  
  'OpenStackVolumeApiRole': function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_text('workers', one, category, '^[0-9]*$');
  },

  'OpenStackVolumeSchedulerRole' : function(one) {
    var role = one.object;
    role_text('volumeScheduleAttempts', one, category, '^[0-9]*$');
  },
  
  'OpenStackObjectApiRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category);
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('allowPublicContainerAccess', one, category);
    role_text('workers', one, category);
  },

  'OpenStackObjectAccountRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category);
    role_resolve('network', one, category, 'Network', '', true);
    role_text('workers', one, category);
  },
  
  'OpenStackObjectContainerRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category);
    role_resolve('network', one, category, 'Network', '', true);
    role_text('workers', one, category);
  },
  
  'OpenStackObjectStoreRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category);
    role_resolve('network', one, category, 'Network', '', true);
    role_text('workers', one, category);
  },

  'OpenStackImageApiRole' : function(one) {
    var role = one.object;
    if (category !== "") {
      document.getElementById('OpenStackImageApiRole').setAttribute('hidden', true);
    } else {
      document.getElementById('OpenStackImageApiRole').removeAttribute('hidden');
    }
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_checkbox('enableHTTPStore', one, category);
    role_text('workers', one, category, '^[0-9]*$');
    var backendType = 'None/custom';
    for (var i = 0; i < role.imageBackends.length; ++i) {
      if (!role.imageBackends[i].toBeRemoved) {
        if ( role.imageBackends[i].childType === 'OpenStackImageBackendCeph' ){
          backendType = 'Ceph';
          break;
        } else if ( role.imageBackends[i].childType === 'OpenStackImageBackendFS' ){
          backendType = 'Filesystem';
          break;
        }
      }
    }
    var o = document.getElementById('glanceBackEnd');
    o.setAttribute('value', backendType);
  },

  'OpenStackImageRegistryRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_text('workers', one, category, '^[0-9]*$');
  },

  'OpenStackNetworkApiRole' : function(one) {
    var role = one.object;
    role_text('apiPort', one, category, '^[0-9]*$');
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_text('workers', one, category, '^[0-9]*$');
  },

  'OpenStackNetworkDHCPAgentRole' : function(one) {
    var role = one.object;
    role_text('DHCPDomain', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'dnsmasqCustom');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_dnsmasqCustom',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
  },

  'OpenStackNetworkL3AgentRole' : function(one) {
    var role = one.object;
    var values = [ [ 'legacy',     'legacy'],
                   [ 'dvr',         'DVR'],
                   [ 'dvr_snat',    'DVR SNAT'] ];
    role_enum('agentmode', one, values, category);
  },


  'OpenStackNetworkLBAgentRole': function(one) {
    role_checkbox('linuxBridgeEnableSecurityGroup', one, category);
    role_enum('linuxBridgeFirewallDriver', one, [['NOOP', 'neutron.NoopFirewallDriver'], 
                                                 ['IPTABLES', 'neutron.IptablesFirewallDriver']], category);
    role_text('linuxBridgeCustomFirewallDriver', one, category);
  },

  'OpenStackNetworkOVSAgentRole' : function(one) {
      role_checkbox('enableDistributedRouters', one, category);
  },

  'OpenStackNetworkMetadataAgentRole' : function(one) {
  },

  'HAProxyRole': function(one) {
    var role = one.object;
    role_text('HAProxyName', one, category);
    role_text('logTag', one, category);
    role_text('description', one, category);
    role_text('log', one, category);
    role_text('maxConnections', one, category);
    role_text('maxConnectionRate', one, category);
    role_checkbox('addEndpointsFromOpenStack', one, category);
    role_checkbox('isBackupBackend', one, category);
    role_checkbox('isOpenStackBackendHAProxy', one, category);
    role_text('availabilityZone', one, category);
    role_checkbox('onlyAutoIncludeEndpointsFromSameAZ', one, category);
    //role_text('backendWeight', one, category);
    role_checkbox('preferIPs', one, category);
    role_checkbox('preserveOpenStackEntriesWithCustomServers', one, category);

    role_checkbox('statsSocketEnabled', one, category);
    document.getElementById('HAProxyRole_statsSocketEnabled').addEventListener("click", function(event) {
      var disabled = !event.target.checked;
      setViewConditional('checkStatsSocketEnabled', disabled);
    }, false);
    role_text('statsSocket', one, category);
    setViewConditional('checkStatsSocketEnabled', !one.get('statsSocketEnabled'));

    role_checkbox('statsEnabled', one, category);
    document.getElementById('HAProxyRole_statsEnabled').addEventListener("click", function(event) {
      var disabled = !event.target.checked;
      setViewConditional('checkStatsEnabled', disabled);
    }, false);

    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'statsScopes');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_statsScopes',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();

    role_text('statsPort', one, category);
    role_checkbox('statsUseAuth', one, category);
    role_text('statsUsername', one, category);
    role_text('statsPassword', one, category);
    role_text('statsURI', one, category);

    setViewConditional('checkStatsEnabled', !one.get('statsEnabled'));

    role_text('openStackEndpointDefaultBindLocation', one, category);
    //TODO openStackEndpointDefaultBindNetwork
    role_text('nbProc', one, category, '^[0-9]+$');
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'cpuMap');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_cpuMap',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();

    /*
      this.sharedSettings = new cvHAProxySharedSettings();
      this.entries = new Array();

      this.openStackEndpointDefaultBindNetwork = 0;

    */

    role_checkbox('includeOpenStackComputeEndpoints', one, category);
    role_checkbox('includeOpenStackComputeMetadataEndpoints', one, category);
    role_checkbox('includeOpenStackComputeEC2Endpoints', one, category);
    role_checkbox('includeOpenStackNetworkEndpoints', one, category);
    role_checkbox('includeOpenStackAuthPublicEndpoints', one, category);
    role_checkbox('includeOpenStackAuthAdminEndpoints', one, category);
    role_checkbox('includeOpenStackImageStorageEndpoints', one, category);
    role_checkbox('includeOpenStackImageStorageRegistries', one, category);
    role_checkbox('includeOpenStackBlockStorageEndpoints', one, category);
    role_checkbox('includeOpenStackOrchestrationEndpoints', one, category);
    role_checkbox('includeOpenStackDashboardEndpoints', one, category);
    role_checkbox('includeOpenStackObjectStorageEndpoints', one, category);
    role_checkbox('includeMemcachedEndpoints', one, category);

    var customHAProxy = 0;
    if(role.customGlobalCode.length) {
      customHAProxy++;
    }
    if(role.customDefaultCode.length) {
      customHAProxy++;
    }
    if(role.customAppendCode.length) {
      customHAProxy++;
    }
    if(customHAProxy>1) {
      document.getElementById('customHAProxy').setAttribute('value', customHAProxy + ' customizations');
    } else if(customHAProxy===1){
      document.getElementById('customHAProxy').setAttribute('value', '1 customization');
    } else {
      document.getElementById('customHAProxy').setAttribute('value', 'No customizations');
    }

    var entriesCount = 0;
    for(var i = 0; i < role.entries.length; i++) {
      if(role.entries[i].toBeRemoved===false) {
        entriesCount++;
      }
    }
    if(entriesCount>1) {
      document.getElementById('entriesHAProxy').setAttribute('value', entriesCount + ' entries');
    } else if(entriesCount===1){
      document.getElementById('entriesHAProxy').setAttribute('value', '1 entry');
    } else {
      document.getElementById('entriesHAProxy').setAttribute('value', 'No entries');
    }
  },

  'MemcachedRole' : function(one) {
    var role = one.object;
    role_text('port', one, category);
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('bindToLocalInterfaceByDefault', one, category);
    role_text('connections', one, category);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
    role_checkbox('daemonize', one, category);
    role_text('user', one, category);
    role_text('initialMemoryCap', one, category);
    role_checkbox('lockMem', one, category);
    role_checkbox('errorOnExhaust', one, category);
    role_checkbox('maxCoreFile', one, category);
    role_checkbox('enableLogFile', one, category);
    role_text('logfile', one, category);
    role_text('logLevel', one, category);
    role_checkbox('disableCAS', one, category);
    role_checkbox('useLargePages', one, category);
    role_text('memGrowthFactor', one, category);
    role_text('minItemSize', one, category);
    role_text('threads', one, category);
    role_text('otherOptions', one, category);
  },


  'GaleraRole' : function(one) {
    var role = one.object;
    role_text('clusterName', one, category);
    role_resolve('network', one, category, 'Network', '', true);
    role_text('apiPort', one, category, '^[0-9]*$');


    var elem = document.getElementById('nodesconfigured'); 
    elem.setAttribute("value", dotFormat(role.clusterNodes));
    role_text('weight', one, category, '^[0-9]*$');
    role_checkbox('allowAutoBootstrap', one, category);
    role_text('adminUsername', one, category);
    role_text('adminPassword', one, category);
    role_checkbox('includeInHAProxy', one, category);
    var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': role.childType + '_frontendHAProxyNames',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    role_checkbox('isBackupEndpoint', one, category);
  },

  // ELK Stack 
  'KibanaRole' : function(one) {
    // Todo validate ip
    role_text('bindHost', one, category, '^[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+$');
    role_text('port', one, category, '^[0-9]+$');
    role_text('elasticUrl', one, category, '^.+$');
    role_text('customConfig', one, category);
    ElkCustomConfigInput('KibanaRole', one, 'customConfig');
  },

  'ElasticSearchRole' : function(one) {
    role_text('clusterName', one, category);
    role_checkbox('includeInHAProxy', one, category);
    this.populateSingleArrayAttributeList(one, 'frontendHAProxyNames', { 'width' : '200px'}); 
    role_resolve('network', one, category, 'Network', '', true);
    role_checkbox('isBackupEndpoint', one, category);
    role_text('apiPort', one, category, '^[0-9]+$');
  }, 

  'LogstashServerRole' : function(one) {
    role_text('sslCert', one, category);
    role_text('sslKey', one, category);
    role_text('port', one, category, '^[0-9]+$');
    role_text('elasticHost', one, category);
    role_text('elasticCluster', one, category);
    role_checkbox('enableStdoutLog', one, category);
    this.populateSingleArrayAttributeList(one, 'localFilesToTrack', { 'width' : '200px'}); 
    role_text('localFilesType', one, category);
    role_text('customConfig', one, category);
    ElkCustomConfigInput('LogstashServerRole', one, 'customConfig');
  }, 

  'LogstashForwarderRole' : function(one) {
    this.populateSingleArrayAttributeList(one, 'servers', { 'width' : '200px'}); 
    role_text('sslCert', one, category);
    // improve: use display and parse function to add units
    role_text('timeout', one, category, '^[0-9]+$');

    this.populateSingleArrayAttributeList(one, 'sysLogFiles', { 'width' : '200px'}); 
    this.populateSingleArrayAttributeList(one, 'apacheFiles', { 'width' : '200px'}); 
    role_text('customConfig', one, category);
    ElkCustomConfigInput('LogstashForwarderRole', one, 'customConfig');
  }
}



/**********************
function refresh(use) {
  if (!!use) current = use;
  println("Refresh OpenStack roles");

  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);

  initView('OpenStackIdentityApi');
  initView('OpenStackComputeConductor');
  initView('OpenStackCompute');
  initView('OpenStackDashboard');
  initView('OpenStackMessageQueueServer');
  initView('OpenStackNetwork');
  initView('OpenStackNode');
  initView('OpenStackComputeApi');
  initView('OpenStackComputeScheduler');
  initView('OpenStackComputeApiEC2');
  initView('OpenStackComputeVNCProxy');
  initView('OpenStackComputeApiMetadata');
  initView('OpenStackOrchestration');
  initView('OpenStackOrchestrationApi');
  initView('OpenStackVolumeApi');
  initView('OpenStackVolumeScheduler');
  initView('OpenStackVolume');
  initView('OpenStackVolumeBackup');
  initView('OpenStackObjectApi');
  initView('OpenStackObjectAccount');
  initView('OpenStackObjectContainer');
  initView('OpenStackObjectStore');
  initView('OpenStackImageApi');
  initView('OpenStackImageRegistry');
  initView('OpenStackNetworkApi');
  initView('HAProxy');
  initView('Memcached');

  var roles = current.get(subfield);
  for (var i = 0; i < roles.length; i++) {
    if (!roles[i].toBeRemoved && (startswith(roles[i].childType, 'OpenStack') || roles[i].childType==="HAProxyRole" || roles[i].childType==="MemcachedRole")) {
      setRole(roles[i], '');
    }
  }

  if (dock.baseChildTypeCheck(current.object, 'SlaveNode')) {
    var cat = current.get('category');
    if (cat) {
      cat = current.cluster.find(cat);
      if (cat) {
        var catroles = cat.get(subfield);
        cat = cat.resolveName();
        for (var i = 0; i < catroles.length; i++) {
          if (!catroles[i].toBeRemoved) {
            var found = false;
            for (var j = 0; !found && (j < roles.length); j++) {
              if (!roles[j].toBeRemoved) {
                found = (catroles[i].childType === roles[j].childType);
              }
            }
            if (!found) {
              setRole(catroles[i], cat);
            }
          }
        }
      }
    }
  }
}
***/



/******************
function setRole(role, category) {
  var obj = document.getElementById('has' + role.childType);
  if (obj) {
    var one = setGenericRole(role, category, obj, false);
    setToolBar(role);
    if (role.childType === 'OpenStackIdentityApiRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_text('apiPortForAdmin', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_resolve('networkForAdmin', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_text('workers', one, category, '^[0-9]*$');
      role_text('workersForAdmin', one, category, '^[0-9]*$');
      role_enum('tokenPersistenceBackend', one, [['memcachedPool', 'memcachedPool'], ['memcached', 'memcached'], ['sql', 'sql']], category);
      role_checkbox('caching', one, category);
      role_enum('tokenCacheBackend', one, [['memcached', 'memcached'], ['pylibmc', 'pylibmc'], ['bmemcached', 'bmemcached'], ['redis', 'redis'], ['dbm', 'dbm'], ['memory', 'memory'], ['mongo', 'mongo'], ['memcached_pool', 'memcached_pool'], ['none', 'none']], category);
      role_text('memcachedServer', one, category);
      role_checkbox('autoResolveLocalMemcached', one, category);
      role_checkbox('enableAdminEndpoint', one, category);
    } else if (role.childType === 'OpenStackComputeConductorRole') {
      role_text('workersCount', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackComputeRole') {
      if (category !== "") {
        document.getElementById('OpenStackComputeRole').setAttribute('hidden', true);
      } else {
        document.getElementById('OpenStackComputeRole').removeAttribute('hidden');
      }
      var backendType = 'None/Custom';
      for (var i = 0; i < role.imageBackends.length; ++i ){
        if (!role.imageBackends[i].toBeRemoved) {
          if ( role.imageBackends[i].childType === 'OpenStackNovaImageBackendCow' ){
            backendType = 'Cow';
          } else if ( role.imageBackends[i].childType === 'OpenStackNovaImageBackendCeph' ){
            backendType = 'Ceph';
          }
        }
      }
      var o = document.getElementById('LibVirtBackEnd');
      o.setAttribute('value', backendType);

      role_enum('computeDriver', one, [['DEFAULT_COMPUTE_DRIVER', 'Default'], ['LIBVIRT_DRIVER', 'LibVirt'], ['XEN_API_DRIVER', 'XenAPI'], ['FAKE_DRIVER', 'fake'], ['BAREMETAL_DRIVER', 'BareMetal'], ['VMWARE_ESX_DRIVER', 'VMWareESXDriver'], ['VMWARE_VC_DRIVER', 'VMWareVCDriver']], category);
      role_enum('libvirtDomain', one, [['DEFAULT_DOMAIN', 'Default'], ['KVM_DOMAIN', 'KVM'], ['LXC_DOMAIN', 'LXC'], ['QEMU_DOMAIN', 'QEMU'], ['UML_DOMAIN', 'UML'], ['XEN_DOMAIN', 'OTHER']], category);
      role_enum('libvirtCPUMode', one, [['DEFAULT_CPU_MODE', 'Default'], ['HOST_MODEL_MODE', 'Host Model'], ['HOST_PASSTHROUGH_MODE', 'Host Passthrough'], ['CUSTOM_MODE', 'Custom'], ['NONE_MODE', 'None']], category);
      role_text('libvirtCPUModel', one, category);
      role_enum('libvirtInjectPassword', one, [[null, ''], [true, 'Yes'], [false, 'No']], category);
      role_enum('libvirtInjectKey', one, [[null, ''], [true, 'Yes'], [false, 'No']], category);
      role_text('libvirtInjectPartition', one, category, '^(-2|-1|[0-9]+)$');
      role_text('statePath', one, category, '^.+$');
      role_text('vcpuPinSet', one, category);
      role_checkbox('linuxBridgeEnableSecurityGroup', one, category);
      role_enum('linuxBridgeFirewallDriver', one, [['NOOP', 'neutron.NoopFirewallDriver'], ['IPTABLES', 'neutron.IptablesFirewallDriver']], category);
      role_text('linuxBridgeCustomFirewallDriver', one, category);

      menuListEditable({
        wrapperElementId: 'OpenStackComputeRole_linuxBridgeWrapper',
        menuListElementId: 'OpenStackComputeRole_linuxBridgeFirewallDriver',
        textboxElementId:'OpenStackComputeRole_linuxBridgeCustomFirewallDriver'
      });
      if(category) {
        document.getElementById('OpenStackComputeRole_linuxBridgeWrapper').setAttribute('disabled', 'true');
      } else {
        document.getElementById('OpenStackComputeRole_linuxBridgeWrapper').removeAttribute('disabled');
      }

      role_checkbox('resumeGuestsOnHostBoot', one, category);
      role_text('vifPluggingTimeOut', one, category, '^[0-9]+$');
      role_checkbox('vifPluggingIsFatal', one, category);
      var nFsmount = role.fsmounts.reduce(function(previousValue, currentValue) {
         return (currentValue.toBeRemoved===false) ? ++previousValue : previousValue;
      }, 0);
      var o = document.getElementById('openStackComputeRoleFSMountLabel');
      if(nFsmount>1) {
        o.setAttribute('value', nFsmount + ' filesystem mounts');
      } else if(nFsmount===1) {
        o.setAttribute('value', '1 filesystem mount');
      } else {
        o.setAttribute('value', 'No filesystem mount');
      }
      if(role.libvirtdCustom.length>0) {
        document.getElementById('libvirtdCustom').setAttribute('value', '1 customization');
      } else {
        document.getElementById('libvirtdCustom').setAttribute('value', 'No customizations');
      }
    } else if (role.childType === 'OpenStackDashboardRole') {
      role_text('memcachedServer', one, category);
      role_checkbox('autoResolveLocalMemcached', one, category);
      role_checkbox('allowAllHosts', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'allowedHosts');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_allowedHosts',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_text('apiResultPageSize', one, category, '^[0-9]+$');
      role_text('sessionTimeout', one, category, '^[0-9]+$');
      role_text('apiResultLimit', one, category, '^[0-9]+$');
      role_text('timeZone', one, category);
      role_text('openstackKeystoneUrl', one, category);
      role_checkbox('debug', one, category);
    } else if (role.childType === 'OpenStackMessageQueueServerRole') {
      role_enum('messageQueueBackend', one, ['RABBITMQ', 'OTHER'], category);
    } else if (role.childType === 'OpenStackNetworkRole') {
      role_text('DHCPDomain', one, category);
      if(role.dnsmasqCustom.length>0) {
        document.getElementById('dnsmasqCustom').setAttribute('value', '1 customization');
      } else {
        document.getElementById('dnsmasqCustom').setAttribute('value', 'No customizations');
      }
    } else if (role.childType === 'OpenStackNodeRole') {
      if (category !== "") {
        document.getElementById('OpenStackNodeRole').setAttribute('hidden', true);
      } else {
        document.getElementById('OpenStackNodeRole').removeAttribute('hidden');
      }
      role_text('availabilityZone', one, category);
      role_checkbox('configFileCustomizationsAreEnabled', one, category);
      var nCustomizations = 0;
      for(var i = 0; i < role.configFileCustomizations.length; i++) {
        if(role.configFileCustomizations[i].toBeRemoved===false) {
          nCustomizations++;
        }
      }
      var o = document.getElementById('customizations');
      if(nCustomizations>1) {
        o.setAttribute('value', nCustomizations + ' customizations');
      } else if(nCustomizations===1) {
        o.setAttribute('value', '1 customization');
      } else {
        o.setAttribute('value', 'No customizations');
      }
      role_text('customBackendHAProxyHost', one, category);
      role_text('customBackupBackendHAProxyHost', one, category);
      role_checkbox('useOnlyBackendHAProxiesFromSameAZ', one, category);
      role_checkbox('preferCustomBackupBackendHAproxyOverNonup', one, category);
      role_checkbox('fallbackToNonBackendHAProxies', one, category);
      role_checkbox('fallbackToNonUpHAProxies', one, category);
      role_checkbox('useLocalBackendHAProxyIfPossible', one, category);
      role_text('serviceRestartDelay', one, category);
    } else if (role.childType === 'OpenStackVolumeRole') {
      if (category !== "") {
        document.getElementById('OpenStackVolumeRole').setAttribute('hidden', true);
      } else {
        document.getElementById('OpenStackVolumeRole').removeAttribute('hidden');
      }
      var volumeType = {
        Ceph: 0,
        NFS: 0,
        SolidFire: 0,
        '3PAR': 0,
        GPFS: 0,
        NetApp: 0
      };
      for (var i = 0; i < role.volumeBackends.length; ++i) {
        if (!role.volumeBackends[i].toBeRemoved) {
          if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendCeph' ){
            volumeType.Ceph++;
          } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendNFS' ){
            volumeType.NFS++;
          } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendSolidFire' ){
            volumeType.SolidFire++;
          } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackend3PAR' ){
            volumeType['3PAR']++;
          } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendGPFS' ){
            volumeType.GPFS++;
          } else if ( role.volumeBackends[i].childType === 'OpenStackVolumeBackendNetApp' ){
            volumeType.NetApp++;
          }
        }
      }
      var backendType = '';
      for(var vType in volumeType) {
        if (volumeType.hasOwnProperty(vType)) {
          if(volumeType[vType]>0) {
            if(backendType !== '') {
              backendType += ' and ';
            }
            backendType += volumeType[vType] + ' ' + vType;
          }
        }
      }
      if(backendType === '') {
        backendType = 'None/custom';
      }
      var o = document.getElementById('volBackEnd');
      o.setAttribute('value', backendType);
      role_text('glanceApiVersion', one, category);
    } else if (role.childType === 'OpenStackVolumeBackupRole') {
      if (category !== "") {
        document.getElementById('OpenStackVolumeBackupRole').setAttribute('hidden', true);
      } else {
        document.getElementById('OpenStackVolumeBackupRole').removeAttribute('hidden');
      }
      var backendType = 'None/custom';
      for (var i = 0; i < role.backupBackends.length; ++i) {
        if (!role.backupBackends[i].toBeRemoved) {
          if ( role.backupBackends[i].childType === 'OpenStackVolumeBackupBackendCeph' ){
            backendType = 'Ceph';
            break;
          }
          
            //else if ( role.backupBackends[i].childType === 'OpenStackVolumeBackupBackendNFS' ){
            //backendType = 'NFS';
            //break;
          }
        }
      }
      var o = document.getElementById('backupBackEnd');
      o.setAttribute('value', backendType);
    } else if (role.childType === 'OpenStackComputeApiRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'memcachedServers');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_memcachedServers',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('autoResolveLocalMemcached', one, category);
      role_checkbox('notifyApiFaults', one, category);
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackComputeSchedulerRole') {
    } else if (role.childType === 'OpenStackComputeApiEC2Role') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackComputeVNCProxyRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_text('novncProxyBaseURL', one, category);
    } else if (role.childType === 'OpenStackComputeApiMetadataRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackOrchestrationRole') {
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackOrchestrationApiRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_text('apiPortCnf', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
//      role_text('workers', one, category, '^[0-9]*$');
      role_text('maxHeaderLine', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackVolumeApiRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackVolumeSchedulerRole') {
      role_text('volumeScheduleAttempts', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackObjectApiRole') {
      role_text('apiPort', one, category);
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('allowPublicContainerAccess', one, category);
      role_text('workers', one, category);
    } else if (role.childType === 'OpenStackObjectAccountRole') {
      role_text('apiPort', one, category);
      role_resolve('network', one, category, 'Network', '', true);
      role_text('workers', one, category);
    } else if (role.childType === 'OpenStackObjectContainerRole') {
      role_text('apiPort', one, category);
      role_resolve('network', one, category, 'Network', '', true);
      role_text('workers', one, category);
    } else if (role.childType === 'OpenStackObjectStoreRole') {
      role_text('apiPort', one, category);
      role_resolve('network', one, category, 'Network', '', true);
      role_text('workers', one, category);
    } else if (role.childType === 'OpenStackImageApiRole') {
      if (category !== "") {
        document.getElementById('OpenStackImageApiRole').setAttribute('hidden', true);
      } else {
        document.getElementById('OpenStackImageApiRole').removeAttribute('hidden');
      }
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_checkbox('enableHTTPStore', one, category);
      role_text('workers', one, category, '^[0-9]*$');
      var backendType = 'None/custom';
      for (var i = 0; i < role.imageBackends.length; ++i) {
        if (!role.imageBackends[i].toBeRemoved) {
          if ( role.imageBackends[i].childType === 'OpenStackImageBackendCeph' ){
            backendType = 'Ceph';
            break;
          } else if ( role.imageBackends[i].childType === 'OpenStackImageBackendFS' ){
            backendType = 'Filesystem';
            break;
          }
        }
      }
      var o = document.getElementById('glanceBackEnd');
      o.setAttribute('value', backendType);
    } else if (role.childType === 'OpenStackImageRegistryRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'OpenStackNetworkApiRole') {
      role_text('apiPort', one, category, '^[0-9]*$');
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_text('workers', one, category, '^[0-9]*$');
    } else if (role.childType === 'HAProxyRole') {
      role_text('HAProxyName', one, category);
      role_text('logTag', one, category);
      role_text('description', one, category);
      role_text('log', one, category);
      role_text('maxConnections', one, category);
      role_text('maxConnectionRate', one, category);
      role_checkbox('addEndpointsFromOpenStack', one, category);
      role_checkbox('isBackupBackend', one, category);
      role_checkbox('isOpenStackBackendHAProxy', one, category);
      role_text('availabilityZone', one, category);
      role_checkbox('onlyAutoIncludeEndpointsFromSameAZ', one, category);
      //role_text('backendWeight', one, category);
      role_checkbox('preferIPs', one, category);
      role_checkbox('preserveOpenStackEntriesWithCustomServers', one, category);

      role_checkbox('statsSocketEnabled', one, category);
      document.getElementById('HAProxyRole_statsSocketEnabled').addEventListener("click", function(event) {
        var disabled = !event.target.checked;
        setViewConditional('checkStatsSocketEnabled', disabled);
      }, false);
      role_text('statsSocket', one, category);
      setViewConditional('checkStatsSocketEnabled', !one.get('statsSocketEnabled'));

      role_checkbox('statsEnabled', one, category);
      document.getElementById('HAProxyRole_statsEnabled').addEventListener("click", function(event) {
        var disabled = !event.target.checked;
        setViewConditional('checkStatsEnabled', disabled);
      }, false);

      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'statsScopes');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_statsScopes',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();

      role_text('statsPort', one, category);
      role_checkbox('statsUseAuth', one, category);
      role_text('statsUsername', one, category);
      role_text('statsPassword', one, category);
      role_text('statsURI', one, category);

      setViewConditional('checkStatsEnabled', !one.get('statsEnabled'));

      role_text('openStackEndpointDefaultBindLocation', one, category);
      //TODO openStackEndpointDefaultBindNetwork
      role_text('nbProc', one, category, '^[0-9]+$');
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'cpuMap');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_cpuMap',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();


  //this.sharedSettings = new cvHAProxySharedSettings();
  //this.entries = new Array();

  //this.openStackEndpointDefaultBindNetwork = 0;

      role_checkbox('includeOpenStackComputeEndpoints', one, category);
      role_checkbox('includeOpenStackComputeMetadataEndpoints', one, category);
      role_checkbox('includeOpenStackComputeEC2Endpoints', one, category);
      role_checkbox('includeOpenStackNetworkEndpoints', one, category);
      role_checkbox('includeOpenStackAuthPublicEndpoints', one, category);
      role_checkbox('includeOpenStackAuthAdminEndpoints', one, category);
      role_checkbox('includeOpenStackImageStorageEndpoints', one, category);
      role_checkbox('includeOpenStackImageStorageRegistries', one, category);
      role_checkbox('includeOpenStackBlockStorageEndpoints', one, category);
      role_checkbox('includeOpenStackOrchestrationEndpoints', one, category);
      role_checkbox('includeOpenStackDashboardEndpoints', one, category);
      role_checkbox('includeOpenStackObjectStorageEndpoints', one, category);
      role_checkbox('includeMemcachedEndpoints', one, category);

      var customHAProxy = 0;
      if(role.customGlobalCode.length) {
        customHAProxy++;
      }
      if(role.customDefaultCode.length) {
        customHAProxy++;
      }
      if(role.customAppendCode.length) {
        customHAProxy++;
      }
      if(customHAProxy>1) {
        document.getElementById('customHAProxy').setAttribute('value', customHAProxy + ' customizations');
      } else if(customHAProxy===1){
        document.getElementById('customHAProxy').setAttribute('value', '1 customization');
      } else {
        document.getElementById('customHAProxy').setAttribute('value', 'No customizations');
      }

      var entriesCount = 0;
      for(var i = 0; i < role.entries.length; i++) {
        if(role.entries[i].toBeRemoved===false) {
          entriesCount++;
        }
      }
      if(entriesCount>1) {
        document.getElementById('entriesHAProxy').setAttribute('value', entriesCount + ' entries');
      } else if(entriesCount===1){
        document.getElementById('entriesHAProxy').setAttribute('value', '1 entry');
      } else {
        document.getElementById('entriesHAProxy').setAttribute('value', 'No entries');
      }
    } else if (role.childType === 'MemcachedRole') {
      role_text('port', one, category);
      role_resolve('network', one, category, 'Network', '', true);
      role_checkbox('bindToLocalInterfaceByDefault', one, category);
      role_text('connections', one, category);
      role_checkbox('includeInHAProxy', one, category);
      var arrayAttributeListable = new SingleArrayAttributeListable(one, 'frontendHAProxyNames');
      var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
      textboxListDataViewMapper.setNewItem(['']);
      textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '120px'}]);
      var addDelListWidget = new AddDelListWidget({
        'rootNodeId': role.childType + '_frontendHAProxyNames',
        'dataViewMapper': textboxListDataViewMapper
      });
      addDelListWidget.populate();
      role_checkbox('isBackupEndpoint', one, category);
      role_checkbox('daemonize', one, category);
      role_text('user', one, category);
      role_text('initialMemoryCap', one, category);
      role_checkbox('lockMem', one, category);
      role_checkbox('errorOnExhaust', one, category);
      role_checkbox('maxCoreFile', one, category);
      role_checkbox('enableLogFile', one, category);
      role_text('logfile', one, category);
      role_text('logLevel', one, category);
      role_checkbox('disableCAS', one, category);
      role_checkbox('useLargePages', one, category);
      role_text('memGrowthFactor', one, category);
      role_text('minItemSize', one, category);
      role_text('threads', one, category);
      role_text('otherOptions', one, category);
    } else {
      println("Warning unsupported OpenStack role: " + role.childType);
    }
  } else {
    println("Warning unknown OpenStack role: " + role.childType);
  }
}
*/

function setViewConditional(className, hidden){
  var elements = document.getElementsByClassName(className);
  for(var i = 0; i < elements.length; i++) {
    elements[i].setAttribute('hidden', hidden);
  }
}

function sortRoles() {
  var view = document.getElementById('groupRoles');

  var viewsList = [
    'view1',
    'view2',
    'view3'
  ];
  var rolesList = [
    'haproxyrole',
    'memcachedrole',
    'openstackidentityapirole',
    'openstackvolumeapirole',
    'openstackvolumerole',
    'openstackvolumebackuprole',
    'openstackvolumeschedulerrole',
    'openstackcomputeapirole',
    'openstackcomputeapiec2role',
    'openstackcomputeapimetadatarole',
    'openstackcomputeconductorrole',
    'openstackcomputerole',
    'openstackcomputeschedulerrole',
    'openstackcomputevncproxyrole',
    'openstackdashboardrole',
    'openstackobjectapirole',
    'openstackobjectaccountrole',
    'openstackobjectcontainerrole',
    'openstackobjectstorerole',
    'openstackimageapirole',
    'openstackimageregistryrole',
    'openstackmessagequeueserverrole',
    'openstacknetworkapirole',
    'openstacknetworkrole',
    'openstacknoderole',
    'openstackorchestrationrole',
    'openstackorchestrationapirole'
  ];

  for(var i = 0; i < viewsList.length; i++) {
    if(viewsList[i]!==view.value) {
      document.getElementById(viewsList[i]).setAttribute('hidden', true);
    } else {
      document.getElementById(viewsList[i]).setAttribute('hidden', false);
    }
  }
  for(var i = 0; i < rolesList.length; i++) {
    var element1 = document.getElementById(rolesList[i]);
    var element2 = document.getElementById(view.value).querySelector('vbox[' + rolesList[i]+ ']');

    if(element1!==null && element2!==null) {
      swapElements(element1, element2);
    }
  }
}


function swapElements(obj1, obj2) {
  var temp = document.createElement("div");
  obj1.parentNode.insertBefore(temp, obj1);
  obj2.parentNode.insertBefore(obj1, obj2);
  temp.parentNode.insertBefore(obj2, temp);
  temp.parentNode.removeChild(temp);
}

function apiPortDisplay(value, view) {
  if (view===true && value===0) {
    return '';
  } else if (view===false && value==='') {
    return 0;
  } else {
    return value;
  }
}

function checkOpenstackRole(name) {
  incrementManualAction(name.toLowerCase());
  checkRole(name);
}

function incrementManualAction(name) {
  var rootElement = document.getElementById(name);
  if (rootElement) {
    var manualAction = rootElement.getAttribute('manual-action');
    rootElement.setAttribute('manual-action', ++manualAction);
  }
}

function isFirstClickManualAction(name) {
  var rootElement = document.getElementById(name);
  if (rootElement && rootElement.getAttribute('manual-action')==="1") {
    return true;
  }
  return false;
}

function initView(elementId) {
  clearLabel(elementId);
  var toolbarElement = document.getElementById('toolbar' + elementId + 'Role');
  if (toolbarElement) {
    toolbarElement.setAttribute('hidden', true);
  }
  var editElement = document.getElementById('edit' + elementId + 'Role');
  if (editElement) {
    editElement.setAttribute('hidden', true);
  }
}

function setToolBar(role) {
  var toolbarElement = document.getElementById('toolbar' + role.childType);
  if (toolbarElement) {
    toolbarElement.setAttribute('hidden', false);

    if (isFirstClickManualAction(role.childType.toLowerCase())) {
      incrementManualAction(role.childType.toLowerCase());
      toolbarElement.children[1].checked = true;
    }

    var index = 1;
    if (toolbarElement.children[1].checked) {
      index = 2;
    }
    if (toolbarElement.children[2].checked) {
      index = 3;
    }
    changeView(index, 'edit' + role.childType);
  }
}
