/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var cluster;

function onLoad() {
  dock = getDock();
  println(".Load: " + document.title);
}

function refresh(use) {
  var enableSaveButton = function() {
    document.getElementById('save').removeAttribute('disabled');
  };

  if (!!use) cluster = use;
  println("Refresh OpenStack settings");

  var openstacks = cluster.find("OpenStack");

  if (openstacks.length > 0) {
    current = openstacks[0];
    openstacks[0].object.settings['OpenStackAuthBackendSQL'] = new cvOpenStackAuthBackendSQL();
    openstacks[0].object.settings['OpenStackAuthBackendLDAP'] = new cvOpenStackAuthBackendLDAP();
    openstacks[0].object.settings['OpenStackAuthBackendHybrid'] = new cvOpenStackAuthBackendHybrid();

    var currentSettings = new dock.cvObject(openstacks[0].cluster, openstacks[0].object.settings, openstacks[0], 'settings');
    openstacks[0].object.settings.authentication.currentAuthBackend = "";
    for(var i = 0; i < openstacks[0].object.settings. authentication.authBackends.length; i++) {
      var obj = openstacks[0].object.settings.authentication.authBackends[i];
      openstacks[0].object.settings[obj.childType] = obj;
      openstacks[0].object.settings.authentication.currentAuthBackend = obj.childType;
    }
    switchAuthBackend(openstacks[0].object.settings.authentication.currentAuthBackend);

    document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
    enableAll();

    var cvObjecOpenStackAuthBackendHybrid = new dock.cvObject(currentSettings.cluster,
                                                              openstacks[0].object.settings['OpenStackAuthBackendHybrid']);
    // root
    check('enabled');
    text('version');
    text('imageForBrightInstances');
    fillKenumDefaultFlavor(current);

    // settings auth
    text({what: 'authentication', format: '^', subscript: 'defaultDomainId', currentObject: currentSettings});
    text({what: 'authentication', format: '^', subscript: 'domainConfigDir', currentObject: currentSettings});
    kenum({what: 'authentication', list: ['PKI', 'PKZ', 'UUID', 'CUSTOM', 'FERNET'],
           subscript: 'keystoneTokenFormat', currentObject: currentSettings});
    text({what: 'authentication', format: '^', subscript: 'customPublicAuthHost', currentObject: currentSettings});
    text({what: 'authentication', format: '^', subscript: 'customInternalAuthHost', currentObject: currentSettings});
    text({what: 'authentication', format: '^[0-9]+$', subscript: 'tokenValidityMinutes', currentObject: currentSettings});
    kenum({what: 'authentication', 
           list: [ [ 'OpenStackAuthBackendSQL', 'Database'],
                   [ 'OpenStackAuthBackendLDAP', 'LDAP'],
                   ['OpenStackAuthBackendHybrid', 'Hybrid'] ],
           subscript: 'currentAuthBackend',
           currentObject: currentSettings});
    check({what: 'OpenStackAuthBackendLDAP', subscript: 'useSqlBackendForAssignments',  currentObject : currentSettings});
    addViewConditional({
      'type': 'check',
      'elementContext': document,
      'elementId': 'OpenStackAuthBackendLDAPuseSqlBackendForAssignments',
      'callName': 'checkLDAPuseSqlBackendForAssignments',
      'inverseCallName': 'uncheckLDAPuseSqlBackendForAssignments',
      'initialValue': openstacks[0].object.settings['OpenStackAuthBackendLDAP'].useSqlBackendForAssignments
    });
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'url', currentObject: currentSettings});
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'username', currentObject: currentSettings});
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'password', currentObject: currentSettings});
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'suffix', currentObject: currentSettings});
    check({what: 'OpenStackAuthBackendLDAP', subscript: 'useDumbMember',  currentObject : currentSettings});
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'dumbMember', currentObject: currentSettings});
    addViewConditional({
      'type': 'check',
      'elementContext': document,
      'elementId': 'OpenStackAuthBackendLDAPuseDumbMember',
      'callName': 'checkLDAPuseDumpMember',
      'initialValue': openstacks[0].object.settings['OpenStackAuthBackendLDAP'].useDumbMember
    });

    check({what: 'OpenStackAuthBackendLDAP', subscript: 'allowSubtreeDelete',  currentObject : currentSettings});
    kenum({what: 'OpenStackAuthBackendLDAP', 
           list: [ 'Single', 'Subtree'],
           subscript: 'queryScope',
           currentObject: currentSettings});
    kenum({what: 'OpenStackAuthBackendLDAP', 
           list: ["Never", "Searching", "Always", "Finding", "Default"],
           subscript: 'aliasDereferencing',
           currentObject: currentSettings});
    check({what: 'OpenStackAuthBackendLDAP', subscript: 'chaseReferrals',  currentObject : currentSettings});
    check({what: 'OpenStackAuthBackendLDAP', subscript: 'tls',  currentObject : currentSettings});
    addViewConditional({
      'type': 'check',
      'elementContext': document,
      'elementId': 'OpenStackAuthBackendLDAPtls',
      'callName': 'checkLDAPtls',
      'initialValue': openstacks[0].object.settings['OpenStackAuthBackendLDAP'].tls
    });
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'ca', currentObject: currentSettings});
    text({what: 'OpenStackAuthBackendLDAP', format: '^', subscript: 'caDir', currentObject: currentSettings});

    check({what: 'OpenStackAuthBackendLDAP', subscript: 'useConnectionPool',  currentObject : currentSettings});
    addViewConditional({
      'type': 'check',
      'elementContext': document,
      'elementId': 'OpenStackAuthBackendLDAPuseConnectionPool',
      'callName': 'checkLDAPuseConnectionPool',
      'initialValue': openstacks[0].object.settings['OpenStackAuthBackendLDAP'].useConnectionPool
    });

    text({what: 'OpenStackAuthBackendLDAP', format: '^[0-9]+$', subscript: 'connectionPoolSize', currentObject: currentSettings});
    //cmshconditional="cdata->useConnectionPool" 
    text({what: 'OpenStackAuthBackendLDAP', format: '^[0-9]+$', subscript: 'connectionPoolLifetime', currentObject: currentSettings});
    //cmshconditional="cdata->useConnectionPool" 
    check({what: 'OpenStackAuthBackendLDAP', subscript: 'useAuthPool',  currentObject : currentSettings});
    addViewConditional({
      'type': 'check',
      'elementContext': document,
      'elementId': 'OpenStackAuthBackendLDAPuseAuthPool',
      'callName': 'checkLDAPuseAuthPool',
      'initialValue': openstacks[0].object.settings['OpenStackAuthBackendLDAP'].useAuthPool
    });
    text({what: 'OpenStackAuthBackendLDAP', format: '^[0-9]+$', subscript: 'authPoolSize', currentObject: currentSettings});
    text({what: 'OpenStackAuthBackendLDAP', format: '^[0-9]+$', subscript: 'authPoolLifetime', currentObject: currentSettings});

    // hybrid backend
    var arrayAttributeListable = new SingleArrayAttributeListable(cvObjecOpenStackAuthBackendHybrid, 'defaultRoles');
    arrayAttributeListable.saveCallback = enableSaveButton;
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'OpenStackAuthBackendHybriddefaultRoles',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    text({what: 'OpenStackAuthBackendHybrid', format: '^', subscript: 'defaultProject', currentObject: currentSettings});
    text({what: 'OpenStackAuthBackendHybrid', format: '^', subscript: 'defaultDomain', currentObject: currentSettings});

    // settings advanced
    text({what: 'advanced', format: '^', subscript: 'customAMQPHost', currentObject: currentSettings});

    // check('advanced', false, 'encryptApiEndpoints'); CM-3751
    kenum({what: 'advanced', list: ['PKI', 'PKZ', 'UUID', 'CUSTOM'], subscript: 'keystoneTokenFormat', currentObject: currentSettings});
    text({what: 'advanced', format: '^', subscript: 'rbdSecretUuid', currentObject: currentSettings});
    text({what: 'advanced', format: '^[0-9]{1,10}$', subscript: 'agentDownTime', currentObject: currentSettings});
    text({what: 'advanced', format: '^[0-9]{1,10}$', subscript: 'agentReportInterval', currentObject: currentSettings});
    //check('advanced', false, 'enableTelemetryService');
    //check('advanced', false, 'enableDataProcessingService');
    //check('advanced', false, 'enableBareMetalService');
/*
 * Not implemented in cmdaemon yet
    check('advanced', false, 'enableCallbacksFromOpenStack');
    check('advanced', false, 'maintainServicesInOpenStack');
    check('advanced', false, 'maintainEndpointsInOpenStack');
    text('advanced', '^', 'customPublicHostnameForMaintainedEndpoints');
    text('advanced', '^', 'customInternalHostnameForMaintainedEndpoints');
    check('advanced', false, 'maintainHostAggregates');
*/
    // check('advanced', false, 'enableRabbitMqSsl'); CM-3751
    text({what: 'advanced', format: '^[0-9]{1,10}$', subscript: 'revocationCacheTime', currentObject: currentSettings});
    editableKenum(currentSettings, {parent: 'advanced', child: 'revocationCacheTime'}, 'advancedrevocationCacheTime', [['0', 'Default']], '^Default$|^[0-9]{1,10}$');
    

    // settings compute
    var cvObjectSettingsCompute = new dock.cvObject(currentSettings.cluster, currentSettings.get('compute'), currentSettings, 'compute');

    text({what: 'compute', format: '^', subscript: 'VNCProxyHostname', currentObject: currentSettings}); // domain name
    displayfunction('compute', 'sprintf("%.5f", value);', 'cpuAllocationRatio');
    text({what: 'compute', format: '^[0-9]+(\.[0-9]+)?$', subscript: 'cpuAllocationRatio', currentObject: currentSettings});
    displayfunction('compute', 'sprintf("%.5f", value);', 'ramAllocationRatio');
    text({what: 'compute', format: '^[0-9]+(\.[0-9]+)?$', subscript: 'ramAllocationRatio', currentObject: currentSettings});
    displayfunction('compute', 'sprintf("%.5f", value);', 'diskAllocationRatio');
    text({what: 'compute', format: '^[0-9]+(\.[0-9]+)?$', subscript: 'diskAllocationRatio', currentObject: currentSettings});
    text({what: 'compute', format: '^[0-9]+$', subscript: 'maxInstancesPerHost', currentObject: currentSettings});
    displayfunction('compute', 'formatKMGselect(value, "B");', 'reservedHostMemory');
    parsefunction('compute', 'parseKMG(value);', 'reservedHostMemory');
    text({what: 'compute', format: '^[0-9]+(\.[0-9]+)?[ ]?([KkMmGgTT][Bb])?$', subscript: 'reservedHostMemory', currentObject: currentSettings});
    text({what: 'compute', format: '^[0-9]+$', subscript: 'schedulerMaxAttempts', currentObject: currentSettings});
    var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsCompute, 'schedulerFilters');
    arrayAttributeListable.saveCallback = enableSaveButton;
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'computeschedulerFilters',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    text({what: 'compute', format: '^', subscript: 'defaultAvailabilityZone', currentObject: currentSettings});

    // settings credentials
    text({what: 'credentials', format: '^', subscript: 'serviceProjectName', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'adminToken', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'adminUserPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'CMDaemonOpenStackUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'CMDaemonOpenStackPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'novaUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'novaPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'userEC2Username', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'userEC2Password', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'keystoneUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'keystonePassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'glanceUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'glancePassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'cinderUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'cinderPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'heatUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'heatPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'neutronUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'neutronPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'metadataProxySharedSecret', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'troveUsername', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'trovePassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'messageQueueUsername', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'messageQueuePassword', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'ceilometerUsername', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'ceilometerPassword', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'saharaUsername', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'saharaPassword', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'ironicUsername', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'ironicPassword', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'swiftUsername', currentObject: currentSettings});
    //text({what: 'credentials', format: '^', subscript: 'swiftPassword', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'CMDaemonOpenStackProjectUUID', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'CMDaemonOpenStackProjectName', currentObject: currentSettings});
    text({what: 'credentials', format: '^', subscript: 'CMDaemonOpenStackDomainUUID', currentObject: currentSettings});


    // settings database
    text({what: 'database', format: '^', subscript: 'novaDBName', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'novaDBUsername', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'novaDBPassword', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'novaDBHost', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'cinderDBName', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'cinderDBUsername', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'cinderDBPassword', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'cinderDBHost', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'glanceDBName', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'glanceDBUsername', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'glanceDBPassword', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'glanceDBHost', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'keystoneDBName', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'keystoneDBUsername', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'keystoneDBPassword', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'keystoneDBHost', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'swiftDBName', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'swiftDBUsername', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'swiftDBPassword', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'swiftDBHost', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'heatDBName', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'heatDBUsername', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'heatDBPassword', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'heatDBHost', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'neutronDBName', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'neutronDBUsername', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'neutronDBPassword', currentObject: currentSettings});
    text({what: 'database', format: '^', subscript: 'neutronDBHost', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'troveDBName', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'troveDBUsername', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'troveDBPassword', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'troveDBHost', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ceilometerDBName', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ceilometerDBUsername', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ceilometerDBPassword', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ceilometerDBHost', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'saharaDBName', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'saharaDBUsername', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'saharaDBPassword', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'saharaDBHost', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ironicDBName', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ironicDBUsername', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ironicDBPassword', currentObject: currentSettings});
    //text({what: 'database', format: '^', subscript: 'ironicDBHost', currentObject: currentSettings});

    // settings logging
    var cvObjectSettingsLogging = new dock.cvObject(currentSettings.cluster, currentSettings.get('logging'), currentSettings, 'logging');

    check({what: 'logging', subscript: 'centralizedLogging', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalComputeDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalComputeVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalNetworkDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalNetworkVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalImageStorageDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalImageStorageVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalBlockStorageDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalBlockStorageVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalOrchestrationDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalOrchestrationVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalAuthenticationDebug', currentObject: currentSettings});
    check({what: 'logging', subscript: 'globalAuthenticationVerbose', currentObject: currentSettings});
    //check({what: 'logging', subscript: 'globalDataProcessingDebug', currentObject: currentSettings});
    //check({what: 'logging', subscript: 'globalDataProcessingVerbose', currentObject: currentSettings});
    //check({what: 'logging', subscript: 'globalMeteringDebug', currentObject: currentSettings});
    //check({what: 'logging', subscript: 'globalMeteringVerbose', currentObject: currentSettings});
    //check({what: 'logging', subscript: 'globalBareMetalDebug', currentObject: currentSettings});
    //check({what: 'logging', subscript: 'globalBareMetalVerbose', currentObject: currentSettings});
    check({what: 'logging', subscript: 'debugApiCalls', currentObject: currentSettings});
    var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsLogging, 'apiCallsToDebug');
    arrayAttributeListable.saveCallback = enableSaveButton;
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'loggingapiCallsToDebug',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    kenum({what: 'logging', list: [['MINIMAL', 'MINIMAL'], ['HEADERS', 'HEADERS'], ['FULL', 'FULL']], subscript: 'defaultApiCallLogLevelRequest', currentObject: currentSettings});
    kenum({what: 'logging', list: [['MINIMAL', 'MINIMAL'], ['HEADERS', 'HEADERS'], ['FULL', 'FULL']], subscript: 'defaultApiCallLogLevelReply', currentObject: currentSettings});
    kenum({what: 'logging', list: [['NEVER', 'NEVER'], ['INDEBUG', 'INDEBUG'], ['ALWAYS', 'ALWAYS']], subscript: 'logTokens', currentObject: currentSettings});
    text({what: 'logging', format: '^[0-9]{1,10}$', subscript: 'maxContentToLog', currentObject: currentSettings});
    text({what: 'logging', format: '^[0-9]{1,10}$', subscript: 'maxTokenToLog', currentObject: currentSettings});

    // settings networking
    //check({what: 'networking', subscript: 'rescheduleNetworkResources', currentObject: currentSettings});
    kenum({what: 'networking', list: [[null, ''], [true, 'enabled'], [false, 'disabled']], subscript: 'l3HAEnabled', currentObject: currentSettings});
    text({what: 'networking', format: '^', subscript: 'l3HAMinAgentsPerRouter', currentObject: currentSettings});
    text({what: 'networking', format: '^', subscript: 'l3HAMaxAgentsPerRouter', currentObject: currentSettings});
    text({what: 'networking', format: '^', subscript: 'DHCPAgentsPerNetwork', currentObject: currentSettings});
    kenum({what: 'networking', list: [[null, ''], [true, 'enabled'], [false, 'disabled']], subscript: 'automaticL3AgentFailover', currentObject: currentSettings});
    kenum({what: 'networking', list: [[null, ''], [true, 'enabled'], [false, 'disabled']], subscript: 'routerAutoSchedule', currentObject: currentSettings});
    kenum({what: 'networking', list: [[null, ''], [true, 'enabled'], [false, 'disabled']], subscript: 'networkAutoSchedule', currentObject: currentSettings});
    text({what: 'networking', format: '^', subscript: 'VXLANGroupIP', currentObject: currentSettings});
    text({what: 'networking', format: '^', subscript: 'routerInternalNetworkIP', currentObject: currentSettings});
    check({what: 'networking', subscript: 'L2Population', currentObject: currentSettings});
    check({what: 'networking', subscript: 'enableFloatingIPs', currentObject: currentSettings});
    check({what: 'networking', subscript: 'enableRouters', currentObject: currentSettings});
    check({what: 'networking', subscript: 'enableFirewalls', currentObject: currentSettings});
    //check({what: 'networking', subscript: 'enableLoadBalancers', currentObject: currentSettings});
    //check({what: 'networking', subscript: 'enableVPNs', currentObject: currentSettings});

    // settings ports
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'AMQPPort', currentObject: currentSettings});
    //text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'ceilometerEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'cinderEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'glanceEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'glanceRegistryPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'heatEndpointPort', currentObject: currentSettings});
    //text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'ironicEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'keystoneAuthAdminPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'keystoneAuthPublicPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'neutronEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'novaEC2APIEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'novaMetaAPIEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'novaNoVNCProxyPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'novaOSAPIEndpointPort', currentObject: currentSettings});
    //text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'saharaEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'swiftEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'swiftAccountPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'swiftContainerPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'swiftObjectPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'troveEndpointPort', currentObject: currentSettings});
    text({what: 'ports', format: '^[0-9]{4,5}$', subscript: 'backendEndpointPortOffset', currentObject: currentSettings});
    check({what: 'ports', subscript: 'offsetEndpointPortsOnlyOnConflict', currentObject: currentSettings});

    // user settings
    var cvObjectSettingsUsers = new dock.cvObject(currentSettings.cluster, currentSettings.get('users'), currentSettings, 'users');
    text({what: 'users', format: '^', subscript: 'defaultUserRoleName', currentObject: currentSettings}); 
    kenum({what: 'users', 
           list: [ [ 'Off', 'Do not write any rc file'],
                   ['MatchingHomeDirectories', 'Write only to the matching home directories' ],
                   ['AllHomeDirectories', 'Write to all home directories'] ],
           subscript: 'rcWriteOutMode', currentObject: currentSettings});
    check({what: 'users', subscript: 'writeOutPassword', currentObject: currentSettings});
    // text({what: 'users', format: '^', subscript: 'defaultDomainUUID', currentObject: currentSettings});
    // kenum({what: 'users', list: [['RANDOM', 'Random'], ['SAMEASUSERNAME', 'Same as username']], subscript: 'passwordTypeForNewUsers', currentObject: currentSettings});



    // removed field CM-6961
    // check({what: 'users', subscript: 'addLDAPUsersToOpenStackAutomatically', currentObject: currentSettings});
    // addViewConditional({
    //  'type': 'check',
    //  'elementContext': document,
    //  'elementId': 'usersaddLDAPUsersToOpenStackAutomatically',
    // 'callName': 'checkAddLDAPUsersToOpenStackAutomatically',
    //  'initialValue': cvObjectSettingsUsers.get('addLDAPUsersToOpenStackAutomatically')
    //});
    //kenum({what: 'users', list: ['always', 'never'], subscript: 'createNonExistTenant', currentObject: currentSettings});
    // text({what: 'users', format: '^', subscript: 'defaultDomainUUID', currentObject: currentSettings});
    // kenum({what: 'users', list: [['RANDOM', 'Random'], ['SAMEASUSERNAME', 'Same as username']], subscript: 'passwordTypeForNewUsers', currentObject: currentSettings});
    text({what: 'users', format: '', subscript: 'migrationScriptPath', currentObject: currentSettings});
    text({what: 'users', format: '', subscript: 'initScriptPath', currentObject: currentSettings});
    //check({what: 'users', subscript: 'writeOpenStackRCFilesForUsers', currentObject: currentSettings});
    //var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsUsers, 'usersToExclude');
    //arrayAttributeListable.saveCallback = enableSaveButton;
    //var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    //textboxListDataViewMapper.setNewItem(['']);
    //textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    //var addDelListWidget = new AddDelListWidget({
    //  'rootNodeId': 'usersusersToExclude',
    //  'dataViewMapper': textboxListDataViewMapper
    //});
    //addDelListWidget.populate();
    //var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsUsers, 'groupsToExclude');
    //arrayAttributeListable.saveCallback = enableSaveButton;
    //var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    //textboxListDataViewMapper.setNewItem(['']);
    //textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    //var addDelListWidget = new AddDelListWidget({
    //  'rootNodeId': 'usersgroupsToExclude',
    //  'dataViewMapper': textboxListDataViewMapper
    //});
    //addDelListWidget.populate();
    //var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsUsers, 'groupsToInclude');
    //arrayAttributeListable.saveCallback = enableSaveButton;
    //var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    //textboxListDataViewMapper.setNewItem(['']);
    //textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    //var addDelListWidget = new AddDelListWidget({
    //  'rootNodeId': 'usersgroupsToInclude',
    //  'dataViewMapper': textboxListDataViewMapper
    //});
    //addDelListWidget.populate();

    //var defaultUserRoles = cvObjectSettingsUsers.get('defaultUserRoles');
    //var nDefaultUserRoles = 0;
    //for(var i = 0; i < defaultUserRoles.length; i++) {
    //  if(defaultUserRoles[i].toBeRemoved===false) {
    //   nDefaultUserRoles++;
    // }
    //}
    //if (nDefaultUserRoles>1) {
    //  document.getElementById('defaultUserRoles').setAttribute('value', nDefaultUserRoles + ' configurations');
    //} else {
    //  document.getElementById('defaultUserRoles').setAttribute('value', nDefaultUserRoles + ' configuration');
    //}


    // settings quota
    check({what: 'quota', subscript: 'makeStickyForNewTenants', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaInstances', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaVCPUs', currentObject: currentSettings});
    displayfunction('quota', 'formatter.format.MiB(value);', 'quotaRam');
    parsefunction('quota', 'formatter.parse.MiB(value);', 'quotaRam');
    text({what: 'quota', format: '^[0-9]+ ?MiB$', subscript: 'quotaRam', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaInjectedFiles', currentObject: currentSettings});
    displayfunction('quota', 'formatter.format.iB(value);', 'quotaInjectedFilesContentSize');
    parsefunction('quota', 'formatter.parse.iB(value);', 'quotaInjectedFilesContentSize');
    text({what: 'quota', format: '^[0-9]+ ?Bytes$', subscript: 'quotaInjectedFilesContentSize', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaKeyPairs', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaMetadataItems', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaServerGroups', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaServerGroupMembers', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaVolumes', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaVolumeSnapshots', currentObject: currentSettings});
    displayfunction('quota', 'formatter.format.GiB(value);', 'quotaVolumesAndSnapshotsSize');
    parsefunction('quota', 'formatter.parse.GiB(value);', 'quotaVolumesAndSnapshotsSize');
    text({what: 'quota', format: '^[0-9]+ ?GiB$', subscript: 'quotaVolumesAndSnapshotsSize', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaBackups', currentObject: currentSettings});
    displayfunction('quota', 'formatter.format.GiB(value);', 'quotaBackupsSize');
    parsefunction('quota', 'formatter.parse.GiB(value);', 'quotaBackupsSize');
    text({what: 'quota', format: '^[0-9]+ ?GiB$', subscript: 'quotaBackupsSize', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaConsistencyGroups', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaSecurityGroups', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaSecurityGroupRules', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaNetworks', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaPorts', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaSubnets', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaFloatingIPs', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaRouters', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaFirewalls', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaFirewallPolicies', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaFirewallRules', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaPools', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaVIPs', currentObject: currentSettings});
    displayfunction('quota', 'formatter.format.MiB(value);', 'quotaImagesSize');
    parsefunction('quota', 'formatter.parse.MiB(value);', 'quotaImagesSize');
    text({what: 'quota', format: '^[0-9]+ ?MiB$', subscript: 'quotaImagesSize', currentObject: currentSettings});
    displayfunction('quota', 'formatter.format.MiB(value);', 'quotaMaxSingleImageSize');
    parsefunction('quota', 'formatter.parse.MiB(value);', 'quotaMaxSingleImageSize');
    text({what: 'quota', format: '^[0-9]+ ?MiB$', subscript: 'quotaMaxSingleImageSize', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaImageProperties', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaImageTags', currentObject: currentSettings});
    text({what: 'quota', format: '^', subscript: 'quotaImageMembers', currentObject: currentSettings});

    // settings User Portal
    var cvObjectSettingsUserPortal = new dock.cvObject(currentSettings.cluster, currentSettings.get('userPortal'), currentSettings, 'userPortal');

    check({what: 'userPortal', subscript: 'enabled', currentObject: currentSettings});
    check({what: 'userPortal', subscript: 'displayOverviewOnlyOpenStackUsers', currentObject: currentSettings});
    check({what: 'userPortal', subscript: 'displayEntityOverview', currentObject: currentSettings});
    check({what: 'userPortal', subscript: 'displayNodeOverview', currentObject: currentSettings});
    check({what: 'userPortal', subscript: 'displayNumOfUsersInProject', currentObject: currentSettings});
    check({what: 'userPortal', subscript: 'displayNamesOfOtherUsersInProject', currentObject: currentSettings});
    check({what: 'userPortal', subscript: 'determineCloudStatusAutomatically', currentObject: currentSettings});
    kenum({what: 'userPortal', list: [['UP', 'UP'], ['DOWN', 'DOWN'], ['WARNING', 'WARNING'], ['MAINTENANCE', 'MAINTENANCE']], subscript: 'cloudStatus', currentObject: currentSettings});
    var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsUserPortal, 'cloudStatusText');
    arrayAttributeListable.saveCallback = enableSaveButton;
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'userPortalcloudStatusText',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    check({what: 'userPortal', subscript: 'determineDashboardURLsAutomatically', currentObject: currentSettings});
    var arrayAttributeListable = new SingleArrayAttributeListable(cvObjectSettingsUserPortal, 'dashboardURLs');
    arrayAttributeListable.saveCallback = enableSaveButton;
    var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
    textboxListDataViewMapper.setNewItem(['']);
    textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'userPortaldashboardURLs',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
    check({what: 'userPortal', subscript: 'determineKeystoneURLsAutomatically', currentObject: currentSettings});
    text({what: 'userPortal', format: '^', subscript: 'keystonePublicURL', currentObject: currentSettings});
    text({what: 'userPortal', format: '^', subscript: 'keystoneInternalURL', currentObject: currentSettings});

  } else {
    cluster = undefined; // test
    disableAll();
  }
}

function saveOpenStackSettings() {
  var auth_backend = current.object.settings[current.object.settings.authentication.currentAuthBackend];
  if(auth_backend && auth_backend.modified) {
    printall("auth backend modified");
    current.object.settings.authentication.modified = true
  }
  current.object.settings.authentication.authBackends = [ auth_backend ];
  save();
}

function switchAuthBackend(value) {
  var elems = [ 'OpenStackAuthBackendLDAP', 
                'OpenStackAuthBackendSQL',
                'OpenStackAuthBackendHybrid' ];
  for(var i = 0; i < elems.length; i++) {
    var elem = document.getElementById("authbackend-" + elems[i]);
    if(elems[i] == value) {
      elem.removeAttribute('hidden');
    } else {
      elem.setAttribute('hidden', true);
    }
  }
}

function authBackendChange() {
  switchAuthBackend(document.getElementById("authenticationcurrentAuthBackend").value);
}


function fillKenumDefaultFlavor(current) {
  var flavors = current.cluster.find('OpenStackApiFlavor');
  var kenum_list = [];
  for(var i = 0; i < flavors.length; i++) {
    var flavor_name = flavors[i].resolveName();
    kenum_list.push([flavor_name, flavor_name] );
  }
  kenum('defaultFlavor',kenum_list)
}

function fieldNames() {

  return [
    'databasenovaDBName',
    'databasenovaDBUsername',
    'databasenovaDBPassword',
    'databasenovaDBHost',
    'databasecinderDBName',
    'databasecinderDBUsername',
    'databasecinderDBPassword',
    'databasecinderDBHost',
    'databaseglanceDBName',
    'databaseglanceDBUsername',
    'databaseglanceDBPassword',
    'databaseglanceDBHost',
    'databasekeystoneDBName',
    'databasekeystoneDBUsername',
    'databasekeystoneDBPassword',
    'databasekeystoneDBHost',
    'databaseheatDBName',
    'databaseheatDBUsername',
    'databaseheatDBPassword',
    'databaseheatDBHost',
    'databaseneutronDBName',
    'databaseneutronDBUsername',
    'databaseneutronDBPassword',
    'databaseneutronDBHost',

    'networkingl3HAEnabled',
    'networkingl3HAMinAgentsPerRouter',
    'networkingl3HAMaxAgentsPerRouter',
    'networkingDHCPAgentsPerNetwork',
    'networkingautomaticL3AgentFailover',
    'networkingrouterAutoSchedule',
    'networkingnetworkAutoSchedule',
    'networkingVXLANGroupIP',
    'networkingrouterInternalNetworkIP',
    'networkingL2Population',
    'networkingenableFloatingIPs',
    'networkingenableRouters',
    'networkingenableFirewalls',

    'computeVNCProxyHostname',
    'computecpuAllocationRatio',
    'computeramAllocationRatio',
    'computeramdiskAllocationRatio',
    'computemaxInstancesPerHost',
    'computereservedHostMemory',
    'computeschedulerMaxAttempts',
    'computeschedulerFilters',
    'computesdefaultAvailabilityZone',

    'usersdefaultDomainUUID',
    'usersdefaultUserRoleName', 

    'quotamakeStickyForNewTenants',
    'quotaquotaInstances',
    'quotaquotaVCPUs',
    'quotaquotaRam',
    'quotaquotaInjectedFiles',
    'quotaquotaInjectedFilesContentSize',
    'quotaquotaKeyPairs',
    'quotaquotaMetadataItems',
    'quotaquotaServerGroups',
    'quotaquotaServerGroupMembers',
    'quotaquotaVolumes',
    'quotaquotaVolumeSnapshots',
    'quotaquotaVolumesAndSnapshotsSize',
    'quotaquotaBackups',
    'quotaquotaBackupsSize',
    'quotaquotaConsistencyGroups',
    'quotaquotaSecurityGroups',
    'quotaquotaSecurityGroupRules',
    'quotaquotaNetworks',
    'quotaquotaPorts',
    'quotaquotaSubnets',
    'quotaquotaFloatingIPs',
    'quotaquotaRouters',
    'quotaquotaFirewalls',
    'quotaquotaFirewallPolicies',
    'quotaquotaFirewallRules',
    'quotaquotaPools',
    'quotaquotaVIPs',
    'quotaquotaImagesSize',
    'quotaquotaMaxSingleImageSize',
    'quotaquotaImageProperties',
    'quotaquotaImageTags',
    'quotaquotaImageMembers'
  ];
}

function enableAll() {
  document.getElementById('enabled').removeAttribute('disabled');
  document.getElementById('save').removeAttribute('disabled');

  var fields = fieldNames();
  for(var i = 0; i < fields.length; i++) {
    var obj = document.getElementById(fields[i]);
    if(obj) {
      obj.removeAttribute('disabled');
    }
  }
}

function disableAll() {
  document.getElementById('enabled').setAttribute('disabled', true);
  document.getElementById('enabled').setAttribute('checked', false);

  document.getElementById('revert').setAttribute('disabled', true);
  document.getElementById('save').setAttribute('disabled', true);

  var fields = fieldNames();
  for(var i = 0; i < fields.length; i++) {
    var obj = document.getElementById(fields[i]);
    if(obj) {
      obj.removeAttribute('disabled');
      obj.value = '';
    }
  }
}

function openDefaultUserRoleEditor() {
  var currentSettings = new dock.cvObject(current.cluster, current.object.settings, current, 'settings');
  var cvObjectSettingsUsers = new dock.cvObject(currentSettings.cluster, currentSettings.get('users'), currentSettings, 'users');

  var args = new Object();
  args['object'] = currentSettings;
  args['subobject'] = cvObjectSettingsUsers;
  var d = new dock.cvDialog('chrome://cmgui/content/openstack/settings/defaultUserRole.xul', args);
  d.onOk = function() {
    refresh();
  };
  dock.dialogs.showDialog(d);
  return;
}

function openLDAPAuthSettings(name) {
  var args = new Object();
  //var currentSettings = new dock.cvObject(current.cluster, current.object.settings, current, 'settings');
  //var subobject = new dock.cvObject(currentSettings.cluster, currentSettings.get('users'), currentSettings, 'users');
  args['object'] = new dock.cvObject(current.cluster, current.object.settings['OpenStackAuthBackendLDAP']);
  args['subobject'] = new dock.cvObject(current.cluster, args['object'].object[name], args['object'], name);
  var d = new dock.cvDialog('chrome://cmgui/content/openstack/settings/LDAP' + name + '.xul', args);
  d.onOk = function() {
    var auth_backend = current.object.settings[current.object.settings.authentication.currentAuthBackend];
    if(auth_backend.modified) {
      current.object.settings.modified = true;
      document.getElementById('save').removeAttribute('disabled');
    }
  };
  dock.dialogs.showDialog(d);
  return;
}

