/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleProject() {
  this.addTitle = "Add Project";
  this.editTitle = "Edit Project";
  this.api = 'Project';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiProject = new editorController.dock.cvOpenStackApiProject();
      cvDataOpenStackApiProject.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiProject, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('description', '^');
    check('enabled');

    resolve('domainKey', 'OpenStackApiDomain');
    extraeval('domainKey', 'current.correctAllUUID();');
    autorefresh('domainKey');

    resolve('parentProjectKey', 'OpenStackApiProject');
    extraeval('parentProjectKey', 'current.correctAllUUID();');
    autorefresh('parentProjectKey');

    text('motd', '^');

    // Quota compute
    text('quotaInstances', '^');
    text('quotaVCPUs', '^');
    displayfunction('quotaRam', 'formatter.format.DynamiciB(value);');
    parsefunction('quotaRam', 'formatter.parse.DynamiciB(value);');
    text('quotaRam', '^[0-9]+ ?[MG]iB$');
    text('quotaInjectedFiles', '^');
    displayfunction('quotaInjectedFileContent', 'formatter.format.iB(value);');
    parsefunction('quotaInjectedFileContent', 'formatter.parse.iB(value);');
    text('quotaInjectedFileContent', '^[0-9]+ ?Bytes$');

    // Quota volume
    text('quotaVolumes', '^');
    text('quotaVolumeSnapshots', '^');
    displayfunction('quotaTotalSizeOfVolumesAndSnapshots', 'formatter.format.GiB(value);');
    parsefunction('quotaTotalSizeOfVolumesAndSnapshots', 'formatter.parse.GiB(value);');
    text('quotaTotalSizeOfVolumesAndSnapshots', '^[0-9]+ ?GiB$');

    // Quota networking
    text('quotaSecurityGroups', '^');
    text('quotaSecurityGroupRules', '^');
    text('quotaFloatingIPs', '^');
    text('quotaNetworks', '^');
    text('quotaPorts', '^');
    text('quotaSubnets', '^');
    text('quotaRouters', '^');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleProject.prototype = new EditorRuleBase();
EditorRuleProject.prototype.constructor = EditorRuleProject;