/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleRoleAssignment() {
  this.addTitle = "Add RoleAssignment";
  this.editTitle = "Edit RoleAssignment";
  this.api = 'RoleAssignment';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiRoleAssignment = new editorController.dock.cvOpenStackApiRoleAssignment();
      cvDataOpenStackApiRoleAssignment.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiRoleAssignment, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');
    resolve('domainKey', 'OpenStackApiDomain');
    extraeval('domainKey', 'current.correctAllUUID();');
    autorefresh('domainKey');

    var projectSelectable = new MenuListElementSelectable({
      'rootNodeId': 'projectKey',
      'currentObject': editorController.currentObject,
      'attribute': 'projectKey',
      'label': 'Project'
    });
    projectSelectable.registerUnsetFunction(editorController.currentObject.set.bind(editorController.currentObject, 'projectKey', 0));
    projectSelectable.registerUnsetFunction(editorController.currentObject.correctAllUUID.bind(editorController.currentObject));

    var domainSelectable = new MenuListElementSelectable({
      'rootNodeId': 'domainKey',
      'currentObject': editorController.currentObject,
      'attribute': 'domainKey',
      'label': 'Domain'
    });
    domainSelectable.registerUnsetFunction(editorController.currentObject.set.bind(editorController.currentObject, 'domainKey', 0));
    domainSelectable.registerUnsetFunction(editorController.currentObject.correctAllUUID.bind(editorController.currentObject));
    var prjDomSelectOneWidget = new SelectOneWidget({
      'rootNodeId': 'ctrlProjectDomain'
    });

    prjDomSelectOneWidget.addItem(projectSelectable);
    prjDomSelectOneWidget.addItem(domainSelectable);
    prjDomSelectOneWidget.populate();

    resolve('userKey', 'OpenStackApiUser');
    extraeval('userKey', 'current.correctAllUUID();');
    autorefresh('userKey');
    resolve('groupKey', 'OpenStackApiGroup');
    extraeval('groupKey', 'current.correctAllUUID();');
    autorefresh('groupKey');

    var userSelectable = new MenuListElementSelectable({
      'rootNodeId': 'userKey',
      'currentObject': editorController.currentObject,
      'attribute': 'userKey',
      'label': 'User'
    });
    userSelectable.registerUnsetFunction(editorController.currentObject.set.bind(editorController.currentObject, 'userKey', 0));
    userSelectable.registerUnsetFunction(editorController.currentObject.correctAllUUID.bind(editorController.currentObject));

    var groupSelectable = new MenuListElementSelectable({
      'rootNodeId': 'groupKey',
      'currentObject': editorController.currentObject,
      'attribute': 'groupKey',
      'label': 'Group'
    });
    groupSelectable.registerUnsetFunction(editorController.currentObject.set.bind(editorController.currentObject, 'groupKey', 0));
    groupSelectable.registerUnsetFunction(editorController.currentObject.correctAllUUID.bind(editorController.currentObject));

    var usrGrpSelectOneWidget = new SelectOneWidget({
      'rootNodeId': 'ctrlUserGroup'
    });

    usrGrpSelectOneWidget.addItem(groupSelectable);
    usrGrpSelectOneWidget.addItem(userSelectable);
    usrGrpSelectOneWidget.populate();

    resolve('roleKey', 'OpenStackApiRole');
    extraeval('roleKey', 'current.correctAllUUID();');
    autorefresh('roleKey');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleRoleAssignment.prototype = new EditorRuleBase();
EditorRuleRoleAssignment.prototype.constructor = EditorRuleRoleAssignment;