/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleRouter() {
  this.addTitle = "Add Router";
  this.editTitle = "Edit Router";
  this.api = 'Router';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiRouter = new editorController.dock.cvOpenStackApiRouter();
      cvDataOpenStackApiRouter.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiRouter, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('status', '^');
    check('adminStateUp');
    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');

    resolve('externalGatewayNetworkKey', 'OpenStackApiNetwork', '', true, '', function(network) {
      return !network.object.routerExternal;
    });
    extraeval('externalGatewayNetworkKey', 'current.correctAllUUID();');

    addViewConditional({
      'type': 'enum',
      'elementContext': document,
      'elementId': 'externalGatewayNetworkKey',
      'callName': 'checkExternalGatewayNetworkKey',
      'initialValue': editorController.currentObject.get('externalGatewayNetworkKey'),
      'evalFunc': function(key) {
        return (key!==0 && key!=='0') ? false : true;
      }
    });

    check('externalGatewayEnableSNAT');

    text('host', '^');
    kenum('ha', [[null, ''], [true, 'enabled'], [false, 'disabled']]);
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleRouter.prototype = new EditorRuleBase();
EditorRuleRouter.prototype.constructor = EditorRuleRouter;
