/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleServer() {
  this.addTitle = "Add Server";
  this.editTitle = "Edit Server";
  this.api = 'Server';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiServer = new editorController.dock.cvOpenStackApiServer();
      cvDataOpenStackApiServer.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiServer, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');
    resolve('userKey', 'OpenStackApiUser');
    extraeval('userKey', 'current.correctAllUUID();');
    autorefresh('userKey');
    resolve('flavorKey', 'OpenStackApiFlavor');
    extraeval('flavorKey', 'current.correctAllUUID();');
    autorefresh('flavorKey');
    resolve('imageKey', 'OpenStackApiImage');
    extraeval('imageKey', 'current.correctAllUUID();');
    autorefresh('imageKey');
    text('status', '^');
    text('vmState', '^');
    text('createdAt', '^');
    text('updatedAt', '^');
    text('launchedAt', '^');
    text('host', '^');
    text('hostUUID', '^');
    text('hypervisorHostname', '^');
    text('instanceName', '^');
    text('availabilityZone', '^');
    text('faultCreatedAt', '^');
    text('faultDetails', '^');
    text('faultMessage', '^');
    //TODO defaultHost

    var list = editorController.currentObject.cluster.find('OpenStackApiSecurityGroup');

    var objectDualViewAttributeListable = new ObjectDualViewAttributeListable(list, editorController.currentObject, 'securityGroupKeys');
    objectDualViewAttributeListable.setColumnOrder({
      'name': 0
    });
    objectDualViewAttributeListable.initInputValue();

    var customListDataViewMapper = new CustomDualListDataViewMapper(objectDualViewAttributeListable);
    customListDataViewMapper.setElementsConfig([
      [
        {'type': 'label', 'attributes': [{'name': 'width', 'value': '100px'}], 'events': []}
      ]
    ]);

    var groupSelectorWidget = new GroupSelectorWidget({
      'context': document.getElementById('securityGroupKeys'),
      'rootNodeId': 'securityGroupSelected',
      'rootNodeIdSelection': 'securityGroupSelection',
      'rootNodeIdAdd': 'securityGroupButtonAdd',
      'rootNodeIdDel': 'securityGroupButtonDel',
      'dataViewMapper': customListDataViewMapper
    });
    groupSelectorWidget.populate();

    groupSelectorWidget.addItemCallBack = function() {
      current.correctAllUUID();
    };
    groupSelectorWidget.delItemCallBack = function() {
      current.correctAllUUID();
    };

    setAttributeRecursive(document.getElementById('securityGroupKeys'), 'disabled', 'true');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleServer.prototype = new EditorRuleBase();
EditorRuleServer.prototype.constructor = EditorRuleServer;