/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function ViewConsoleServer(chromeWindow) {

  this.refresh = function() {
    if(!this.currentObject) {
      document.getElementById('messageError').removeAttribute('hidden');
      return;
    }
    var instance = this;
    document.getElementById('message').setAttribute('hidden', 'true');
    document.getElementById('messageError').setAttribute('hidden', 'true');

    this.waitIcon();
    this.dock.workerpool.getWorker(this.cluster.actualurl).call('cmopenstack', 'getOpenStackInstanceVNCURL', [0, this.currentObject.get('UUID')], function(code, data) {
      if(code === 0) {
        if(data.success && data.URL!=='') {
          document.getElementById('message').loadURI(data.URL, null, instance.dock.ENCODING);
          document.getElementById('message').removeAttribute('hidden');
        } else {
          document.getElementById('messageError').removeAttribute('hidden');
        }
      } else {
        instance.dock.jsonCallError(this, code, data);
      }
      instance.unWaitIcon();
    }, this.cluster);
  };

  this.init(chromeWindow);
}

ViewConsoleServer.prototype = new ViewerController();
ViewConsoleServer.prototype.constructor = ViewConsoleServer;


var viewer = new ViewConsoleServer(this);