/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
function ViewLogServer(chromeWindow) {
  this.workFile = 0;

  this.refresh = function() {
    if(!this.currentObject) {
      return;
    }
    var instance = this;
    if(this.workFile) {
      this.workFile.remove(false);
    }

    this.waitIcon();
    this.dock.workerpool.getWorker(this.cluster.actualurl).call('cmopenstack', 'consolelog', [0, this.currentObject.get('uniqueKey')], function(code, data) {
      if(code === 0) {
        var file = instance.dock.cacheFile('openstacklog.txt');
        var outputStream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
        outputStream.init(file, 0x02 | 0x08 | 0x20, 0600, 0);
        outputStream.write(data, data.length);
        outputStream.close();
        document.getElementById('message').loadURI('file://' + file.path, null, instance.dock.ENCODING);
        instance.workFile = file;
      } else {
        dock.jsonCallError(this, code, data);
      }
      instance.unWaitIcon();
    }, this.cluster);
  };

  this.ok = function() {
    this.onClose();
    this.chromeWindow.close();
  };

  this.onClose = function() {
    if(this.workFile) {
      this.workFile.remove(false);
    }
  };

  this.init(chromeWindow);
}

ViewLogServer.prototype = new ViewerController();
ViewLogServer.prototype.constructor = ViewLogServer;


var viewer = new ViewLogServer(this);