/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleService() {
  this.addTitle = "Add Service";
  this.editTitle = "Edit Service";
  this.api = 'Service';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiService = new editorController.dock.cvOpenStackApiService();
      cvDataOpenStackApiService.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiService, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('description', '^');
    check('enabled');
    editableKenum(editorController.currentObject, 'type', 'type', [
      ['identity', 'identity'],
      ['compute', 'compute'],
      ['network', 'network'],
      ['image', 'image'],
      ['object-store', 'object-store'],
      ['volume', 'volume'],
      ['volumev2', 'volumev2'],
      ['orchestration', 'orchestration']
    ]);
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleService.prototype = new EditorRuleBase();
EditorRuleService.prototype.constructor = EditorRuleService;