
var object;
var old;
var current;
var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  object = myDialog.arguments.object;
  current = myDialog.arguments.subobject;
  old = current.old(false, true);
  refresh();
}

function refresh() {
  println("Refresh LDAP settings " + current.object.baseType);
  if(current.object.baseType == 'OpenStackAuthBackendLDAPRoleSettings') {
    refreshRoleSettings();
  } else if(current.object.baseType == 'OpenStackAuthBackendLDAPUserSettings') {
    refreshUserSettings();
  } else if(current.object.baseType == 'OpenStackAuthBackendLDAPGroupSettings') {
    refreshGroupSettings();
  } else if(current.object.baseType == 'OpenStackAuthBackendLDAPProjectSettings') {
    refreshProjectSettings();
  }
}

function createIgnoreAttributes() {
  var arrayAttributeListable = new SingleArrayAttributeListable(current, 'ignoredAttributes');
  //arrayAttributeListable.saveCallback = enableSaveButton;
  var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
  textboxListDataViewMapper.setNewItem(['']);
  textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
  var addDelListWidget = new AddDelListWidget({
    'rootNodeId': 'ignoredAttributes',
    'dataViewMapper': textboxListDataViewMapper
  });
  addDelListWidget.populate();
}

function createAdditionalAttributes() {
  var arrayAttributeListable = new SingleArrayAttributeListable(current, 'additionalAttributeMappings');
  //arrayAttributeListable.saveCallback = enableSaveButton;
  var textboxListDataViewMapper = new TextboxListDataViewMapper(arrayAttributeListable);
  textboxListDataViewMapper.setNewItem(['']);
  textboxListDataViewMapper.setCommonAttributes([{'name': 'width', 'value': '170px'}]);
  var addDelListWidget = new AddDelListWidget({
    'rootNodeId': 'additionalAttributeMappings',
    'dataViewMapper': textboxListDataViewMapper
  });
  addDelListWidget.populate();
}

function refreshRoleSettings() {
  println("refreshRoleSettings");
  text({what: 'treeDn'});
  text({what: 'filter'});
  text({what: 'objectClass'});
  text({what: 'idAttribute'});
  text({what: 'nameAttribute'});
  text({what: 'memberAttribute'});
  createIgnoreAttributes();
  check({what: 'allowCreate'}); 
  check({what: 'allowUpdate'}); 
  check({what: 'allowDelete'}); 
  createAdditionalAttributes();
}

function refreshUserSettings() {

  println("refreshUserSettings");
  text({what: 'treeDn'});
  text({what: 'filter'});
  text({what: 'objectClass'});
  text({what: 'idAttribute'});
  text({what: 'nameAttribute'});
  text({what: 'mailAttribute'});
  text({what: 'passwordAttribute'});
  text({what: 'enabledAttribute'});
  check({what: 'enabledAttributeInverted'}); 
  text({what: 'groupMemberMappedAttribute'});
  text({what: 'enabledMask', filter: '^[0-9]+$'});
  text({what: 'enabledDefault'});
  createIgnoreAttributes();

  text({what: 'defaultProjectIdAttribute'});
  check({what: 'allowCreate'}); 
  check({what: 'allowUpdate'}); 
  check({what: 'allowDelete'}); 
  check({what: 'enabledEmulation'}); 
  text({what: 'enabledEmulationDn'}); 
  //conditional
  addViewConditional({
    'type': 'check',
    'elementContext': document,
    'elementId': 'enabledEmulation',
    'callName': 'checkEnabledEmulation',
    'initialValue': current.object.enabledEmulation
  });
  createAdditionalAttributes();
}

function refreshGroupSettings() {
  println("refreshRoleSettings");
  text({what: 'treeDn'});
  text({what: 'filter'});
  text({what: 'objectClass'});
  text({what: 'idAttribute'});
  text({what: 'nameAttribute'});
  text({what: 'memberAttribute'});
  text({what: 'descAttribute'});
  createIgnoreAttributes();
  check({what: 'allowCreate'}); 
  check({what: 'allowUpdate'}); 
  check({what: 'allowDelete'}); 
  createAdditionalAttributes();
}

function refreshProjectSettings() {
  text({what: 'treeDn'});
  text({what: 'filter'});
  text({what: 'objectClass'});
  text({what: 'idAttribute'});
  text({what: 'nameAttribute'});
  text({what: 'memberAttribute'});
  text({what: 'descAttribute'});
  text({what: 'enabledAttribute'});
  text({what: 'domainIdAttribute'});
  createIgnoreAttributes();
  check({what: 'allowCreate'}); 
  check({what: 'allowUpdate'}); 
  check({what: 'allowDelete'}); 
  check({what: 'enabledEmulation'}); 
  text({what: 'enabledEmulationDn'}); 
  //conditional
  addViewConditional({
    'type': 'check',
    'elementContext': document,
    'elementId': 'enabledEmulation',
    'callName': 'checkEnabledEmulation',
    'initialValue': current.object.enabledEmulation
  });
  createAdditionalAttributes();
}

function ok() {
  if(current.get('modified')) object.set('modified', true);
  close();
  myDialog.onOk();
}

function cancel() {
  if(!window.closed) {
    current.old(old);
    close();
  }
}
