/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var loadFramesWaitForChildFrames = true;
var dock;
var container = null;

function SubTabController(subTabConf) {
  this.subTabConf = subTabConf;
  this.container = null;
  this.subtabs = null;

  this.onLoad = function() {
    dock = getDock();
    println('.Load: ' + document.title);
    this.readInputParams();
    this.initSubTabs();
  }

  this.initSubTabs = function() {
    this.subtabs = this.subTabConf.getContainer(this.container);

    var tabs = document.getElementById('sub-tabs');
    var tabpanels = document.getElementById('sub-tabpanels');

    for(var i = 0; i < this.subtabs.length; i++) {
      this.addShadowTab(tabs, this.subtabs[i]);
      this.addIFrame(tabpanels, this.subtabs[i]);
    }

    tabs.selectedIndex = 0;
  };

  this.readInputParams = function() {
    var params = parseUrlParams(document.documentURI);
    this.container = params['container'];
    container = this.container;
  };

  this.addShadowTab = function(node, subtab) {
    var shadowtab = document.createElement('shadowtab');
    shadowtab.setAttribute('label', subtab.title.plural);
    shadowtab.setAttribute('id', 'shadowtab-' + subtab.api);
    node.appendChild(shadowtab);
  };

  this.addIFrame = function(node, subtab) {
    var iframe = document.createElement('iframe');
    var url = "chrome://cmgui/content/openstack/openstackapi.xul?container=" + subtab.container + "&api=" + subtab.api + "&upperboard=1";
    if(typeof(subtab.filter)!=='undefined') {
      url += "&filter=" + JSON.stringify(subtab.filter);
    }
    iframe.setAttribute('src', url);
    iframe.setAttribute('id', 'iframe-' + subtab.api);
    node.appendChild(iframe);
  };
}

var subTabConf = new SubTabConf();
var subTabController = new SubTabController(subTabConf);

function onLoad() {
  subTabController.onLoad();
}