/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleUser() {
  this.addTitle = "Add User";
  this.editTitle = "Edit User";
  this.api = 'User';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiUser = new editorController.dock.cvOpenStackApiUser();
      cvDataOpenStackApiUser.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiUser, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('description');
    text('email');
    resolve('domainKey', 'OpenStackApiDomain');
    extraeval('domainKey', 'current.correctAllUUID();');
    autorefresh('domainKey');
    resolve('defaultProjectKey', 'OpenStackApiProject');
    extraeval('defaultProjectKey', 'current.correctAllUUID();');
    autorefresh('defaultProjectKey');
    text('password', '');
    document.getElementById('password2').value = current.get('password');
    check('enabled');
    deviceselect(); //for groups
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return;
    }
    if(document.getElementById('password2').value !== editorController.currentObject.get('password')) {
      editorController.dock.displayError("Password mismatch");
      return;
    }
    return true;
  };
}

EditorRuleUser.prototype = new EditorRuleBase();
EditorRuleUser.prototype.constructor = EditorRuleUser;