/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function ViewerController(chromeWindow) {
  this.dock = null;
  this.myDialog = null;
  this.currentObject = null;
  this.chromeWindow = null;
  this.cluster = null;

  this.init = function(chromeWindow) {
    this.chromeWindow = chromeWindow;
  };

  this.onLoad = function() {
    println("ViewerController initialized: " + this.chromeWindow.name);
    this.initDock();
    this.initMyDialog();
    this.initCluster();
    this.initCurrentObject();

    document.getElementById('ok').focus();

    this.refresh();
  };

  this.initDock = function() {
    this.dock = getDock();
  };

  this.initMyDialog = function() {
    var s = this.chromeWindow.name.indexOf('[');
    var e = this.chromeWindow.name.indexOf(']');
    var index = this.chromeWindow.name.substr(s + 1, e - s - 1);
    this.myDialog = this.dock.dialogs.list[index];
  };

  this.initCluster = function() {
    this.cluster = this.myDialog.arguments.cluster;
  };

  this.initCurrentObject = function() {
    if(this.myDialog.arguments.uniqueKey) {
      var uniqueKey = this.myDialog.arguments.uniqueKey;
      this.currentObject = this.cluster.find(uniqueKey);
    } else if(this.myDialog.arguments.UUID) {
      var uuid = this.myDialog.arguments.UUID;
      var servers = this.cluster.findBy({
        baseType: 'OpenStackApiServer',
        filter: function(server) {
          if(server.get('UUID') === uuid) {
            return true;
          }
          return false;
        }
      });
      if(servers.length===1) {
        this.currentObject = servers[0];
      }
    }
  };

  this.refresh = function() {
  };

  this.waitIcon = function() {
    this.chromeWindow.setCursor("wait");
  };

  this.unWaitIcon = function() {
    this.chromeWindow.setCursor("auto");
  };

  this.onClose = function () {

  };

  this.ok = function () {
    this.chromeWindow.close();
  };
}

var viewer = new ViewerController(this);

/*
 * WRAPPERS
 */
function onLoad() {
  viewer.onLoad();
}

function onClose() {
  viewer.onClose();
}

function refresh() {
  viewer.refresh();
}

function ok() {
  viewer.ok();
}