/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleVolume() {
  this.addTitle = "Add Volume";
  this.editTitle = "Edit Volume";
  this.api = 'Volume';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiVolume = new editorController.dock.cvOpenStackApiVolume();
      cvDataOpenStackApiVolume.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiVolume, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('description', '^');
    text('availabilityZone', '^');
    text('status', '^');
    text('createdAt', '^');
    displayfunction('size', 'formatter.format.GiB(value);');
    parsefunction('size', 'formatter.parse.GiB(value);');
    text('size', '^[0-9]+ ?GiB$');
    resolve('volumeTypeKey', 'OpenStackApiVolumeType');
    extraeval('volumeTypeKey', 'current.correctAllUUID();');
    autorefresh('volumeTypeKey');
    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');
    check('encrypted');
    resolve('userKey', 'OpenStackApiUser');
    extraeval('userKey', 'current.correctAllUUID();');
    autorefresh('userKey');
    check('bootable');
    resolve('snapshotKey', 'OpenStackApiVolumeSnapshot');
    extraeval('snapshotKey', 'current.correctAllUUID();');
    autorefresh('snapshotKey');
    resolve('sourceVolumeKey', 'OpenStackApiVolume');
    extraeval('sourceVolumeKey', 'current.correctAllUUID();');
    autorefresh('sourceVolumeKey');
    text('attachmentDevice', '^');
    text('attachmentHostname', '^');
    text('attachmentUUID', '^');
    resolve('attachmentServerKey', 'OpenStackApiServer');
    extraeval('attachmentServerKey', 'current.correctAllUUID();');
    autorefresh('attachmentServerKey');
    text('attachmentVolumeUUID', '^');
    text('metadataAttachedMode', '^');
    text('metadataReadonly', '^');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleVolume.prototype = new EditorRuleBase();
EditorRuleVolume.prototype.constructor = EditorRuleVolume;