/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleVolumeSnapshot() {
  this.addTitle = "Add Volume Snapshot";
  this.editTitle = "Edit Volume Snapshot";
  this.api = 'VolumeSnapshot';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiVolumeSnapshot = new editorController.dock.cvOpenStackApiVolumeSnapshot();
      cvDataOpenStackApiVolumeSnapshot.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiVolumeSnapshot, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    text('description', '^');
    text('status', '^');
    text('createdAt', '^');
    displayfunction('size', 'formatter.format.GiB(value);');
    parsefunction('size', 'formatter.parse.GiB(value);');
    text('size', '^[0-9]+ ?GiB$');
    resolve('volumeKey', 'OpenStackApiVolume');
    extraeval('volumeKey', 'current.correctAllUUID();');
    autorefresh('volumeKey');
    resolve('projectKey', 'OpenStackApiProject');
    extraeval('projectKey', 'current.correctAllUUID();');
    autorefresh('projectKey');
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleVolumeSnapshot.prototype = new EditorRuleBase();
EditorRuleVolumeSnapshot.prototype.constructor = EditorRuleVolumeSnapshot;