/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function EditorRuleVolumeType() {
  this.addTitle = "Add Volume Type";
  this.editTitle = "Edit Volume Type";
  this.api = 'VolumeType';

  this.getCurrentObject = function(editorController) {
    if(editorController.isAdd()) {
      var cvDataOpenStackApiVolumeType = new editorController.dock.cvOpenStackApiVolumeType();
      cvDataOpenStackApiVolumeType.ownerUniqueKey = editorController.object.get('uniqueKey');
      return new editorController.dock.cvObject(editorController.object.cluster, cvDataOpenStackApiVolumeType, 0, 0, false);
    } else {
      return editorController.object.cluster.find(editorController.myDialog.arguments.subobject);
    }
  };

  this.dataBindingAndCheck = function(editorController) {
    this.dataBindingAndCheckCommon(editorController);

    var objectAttributeListable = new ObjectAttributeListable(editorController.currentObject, 'extraSpecs');
    var textboxListDataViewMapper = new TextboxListDataViewMapper(objectAttributeListable);
    textboxListDataViewMapper.setNewItem(['', '']);
    var addDelListWidget = new AddDelListWidget({
      'rootNodeId': 'extraSpecs',
      'dataViewMapper': textboxListDataViewMapper
    });
    addDelListWidget.populate();
  };

  this.inputCheck = function(editorController) {
    if(blank(editorController.currentObject.get('name'))) {
      editorController.dock.displayError("Name cannot be empty");
      return false;
    }
    return true;
  };
}

EditorRuleVolumeType.prototype = new EditorRuleBase();
EditorRuleVolumeType.prototype.constructor = EditorRuleVolumeType;