/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh powerdistributionunit overview" + ' - ' + document.documentURI);

  var obj = document.getElementById('ports');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);

  overviewValue('state', current.fullStateString());
  dock.workerpool.getWorker(current.cluster.actualurl).call('cmgui', 'getPDUOverview', [current.cluster.sessionid, current.get('uniqueKey')], function(code, data) {
      if(code == 0 && data) {
        document.getElementById('model').setAttribute('value', 'Please wait');
      } else {
        document.getElementById('model').setAttribute('value', 'N/A');
        if(code) dock.jsonCallError(this, code, data);
      }
    }, current);
}

function update(event) {
  println("Update powerdistributionunit overview");
  document.getElementById('model').setAttribute('value', event.model);

  var obj = document.getElementById('ports');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  var data = event.outletStatus;
  for(var i = 0; i < data.length; i++) {
    obj.appendChild(outletRow(data[i]));
  }

  function outletRow(data) {
    var row = document.createElement('row');
    row.setAttribute("class", "staticdatarow");
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "19px");
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.outlet);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.status);
    row.appendChild(label);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", data.detected);
    row.appendChild(label);
    return row;
  }
}
