/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh powerdistributionunit tasks" + ' - ' + document.documentURI);

  var ports = document.getElementById('ports');
  while(ports.childNodes.length > 1) ports.removeChild(ports.lastChild);

  var n = current.get('ports');
  if(n > 64) {
    println("The number of ports is very high: " + n + " (disabled)");
    n = 0;
  }
  for(var i = 1; i <= n; i++) {
    var row = document.createElement('row');
    row.setAttribute('align', 'center');
    var hbox = document.createElement('hbox');
    hbox.setAttribute('pack', 'end');
    var label = document.createElement('label');
    label.setAttribute('value', 'Outlet ' + i);
    label.setAttribute('class', 'staticdataheader');
    hbox.appendChild(label);
    row.appendChild(hbox);
    var button = document.createElement('button');
    button.setAttribute('class', 'bluebutton');
    button.setAttribute('label', 'On');
    button.setAttribute('oncommand', 'powerOn(' + i + ')');
    row.appendChild(button);
    var button = document.createElement('button');
    button.setAttribute('class', 'bluebutton');
    button.setAttribute('label', 'Off');
    button.setAttribute('oncommand', 'powerOff(' + i + ')');
    row.appendChild(button);
    var button = document.createElement('button');
    button.setAttribute('class', 'bluebutton');
    button.setAttribute('label', 'Reset');
    button.setAttribute('oncommand', 'powerReset(' + i + ')');
    row.appendChild(button);
    ports.appendChild(row);
  }
}

function powerOff(port) {
  var pdus = [current.get('uniqueKey')];
  var args = new Object();
  if(port) {
    args['question'] = "Are you sure you want to power off outlet " + port;
  } else {
    args['question'] = "Are you sure you want to power off all outlets";
  }
  args['check'] = "Also closed devices";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(force) {
    var ports = [port];
    var delay = current.cluster.setup.powerOffDelay;
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'powerOffPort', [pdus, ports, delay, current.cluster.sessionid, true], function(code, data) {
      if(code == 0) {
        if(!data) {
          dock.displayError("Power off failed");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
  dock.dialogs.showDialog(d);
}

function powerOn(port) {
  var pdus = [current.get('uniqueKey')];
  var args = new Object();
  if(port) {
    args['question'] = "Are you sure you want to power on outlet " + port;
  } else {
    args['question'] = "Are you sure you want to power on all outlets";
  }
  args['check'] = "Also closed devices";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(force) {
    var ports = [port];
    var delay = current.cluster.setup.powerOffDelay;
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'powerOnPort', [pdus, ports, delay, current.cluster.sessionid, true], function(code, data) {
      if(code == 0) {
        if(!data) {
          dock.displayError("Power on failed");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
  dock.dialogs.showDialog(d);
}
function powerReset(port) {
  var pdus = [current.get('uniqueKey')];
  var args = new Object();
  if(port) {
    args['question'] = "Are you sure you want to power reset outlet " + port;
  } else {
    args['question'] = "Are you sure you want to power reset all outlets";
  }
  args['check'] = "Also closed devices";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function(force) {
    var ports = [port];
    var delay = current.cluster.setup.powerOffDelay;
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'powerCyclePort', [pdus, ports, delay, current.cluster.sessionid, true], function(code, data) {
      if(code == 0) {
        if(!data) {
          dock.displayError("Power reset failed");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  }
  dock.dialogs.showDialog(d);
}

function locateInRack() {
  current.cluster.locate(current);
}
