/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var cluster;
var myDialog;
var dock;
var requestId;
var overview;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  cluster = myDialog.arguments.cluster;
  requestId = myDialog.arguments.requestId;
  refresh();
}

function refresh() {
  dock.workerpool.getWorker(cluster.actualurl).call('cmprov', 'getProvisioningStatus', [[]], function(code, data) {
    if(code == 0) {
      setCallbackResult(data);
    } else {
      dock.jsonCallError(this, code, data);
    }
  }, cluster);
}

function setCallbackResult(info) {
  if(info == null) {
    overviewValue('requestIDs', 'invalid / completed');
  } else {
    overview = info.provisioningRequestStatusList;
    if(overview.length < 1) {
      overviewValue('requestIDs', 'invalid / completed');
    } else {
      overview = overview[0];
      var ids = overview.requestIDs;
      overviewValue('requestIDs', ids.join(','));
      var name = cluster.resolveName(overview.sourceNodeKey);
      if(name.length == 0) name = '< unassigned >';
      overviewValue('sourceNode', name);
      var srcPath = overview.sourcePath;
      if(srcPath.length == 0) srcPath = '< unassigned >';
      overviewValue('sourcePath', srcPath);
      overviewValue('destinationNode', cluster.resolveName(overview.destinationNodeKey));
      overviewValue('destinationPath');
      if(overview.dryRun) {
        overviewValue('dryRun', 'yes');
      } else {
        overviewValue('dryRun', 'no');
      }
      if(overview.isFromNodeInstaller) {
        overviewValue('fromNodeInstaller', 'yes');
      } else {
        overviewValue('fromNodeInstaller', 'no');
      }
      var state;
      switch(overview.state) {
        case(dock.PROVISIONINGPROCESSORJOBSTATUS_NOT_STARTED): state =  "Not started" ; break;
        case(dock.PROVISIONINGPROCESSORJOBSTATUS_STARTED): state =  "Started" ; break;
        case(dock.PROVISIONINGPROCESSORJOBSTATUS_COMPLETED): state =  "Completed" ; break;
        case(dock.PROVISIONINGPROCESSORJOBSTATUS_FAILED): state =  "Failed" ; break;
        case(dock.PROVISIONINGPROCESSORJOBSTATUS_FAILED_FATAL): state =  "Fatal failure" ; break;
        defaut: state = "Unknown";
      }
      overviewValue('state', state);
      var syncMode;
      switch(overview.syncMode) {
          case(dock.SYNCMODE_FULL): syncMode = "Full" ; break;
          case(dock.SYNCMODE_SYNC): syncMode = "Sync" ; break;
          case(dock.SYNCMODE_UPDATE): syncMode = "Update" ; break;
          case(dock.SYNCMODE_GRAB): syncMode = "Grab" ; break;
          case(dock.SYNCMODE_GRABNEW): syncMode = "Grab new" ; break;
          default: syncMode = "Unknown" ;
      }
      overviewValue('syncMode', syncMode);
      overviewValue('failureCount', overview.jobFailureCounter);
      overviewLines('schedulerInfo', overview.schedulerInfo);
      var error = overview.errorMessage;
      if(error.length == 0) {
        overviewValue('errorMessage', '< no error >');
      } else {
        overviewValue('errorMessage');
      }
      var error = overview.errorDetails;
      if(error.length == 0) {
        overviewLines('errorInfo', ['< no error details >']);
      } else {
        overviewLines('errorInfo', error.split('\n'));
      }
    }
  }
}

function cancel() {
  if(!window.closed) {
    close();
  }
}
