/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
var dock;
var puppet_declaration_key;
var puppet_declaration;
var current;
var puppet_role = null;

var factory = null;

var view = {
  all_parameters      : null,
  selected_parameters : null,
  puppet_declaration  : null,
  puppet_declaration_object : null,

  selected_parameters_list : [],
  selected_parameters_input_fields : {},


  addAllNonExistingInputFields : function(factory) {
    for(var i = 0; i < this.selected_parameters_list.length; i++) {
      var key = parseInt(this.selected_parameters_list[i].get('uniqueKey'));
      if(!this.selected_parameters_input_fields.hasOwnProperty(key)) {
        var parameters_config_element = document.getElementById("parametersConfig");
        this.selected_parameters_input_fields[key] = this.createNewParameterInputElement(this.selected_parameters_list[i], factory,parameters_config_element);
      }
    }
  },

  removeParameter : function(key) {
    if(view.puppet_declaration.hasOwnProperty("classConfiguration")) {
      for(var j = 0; j < view.puppet_declaration.classConfiguration.length; j++) {
        if(view.puppet_declaration.classConfiguration[j].uniqueKey == key)  {
          view.puppet_declaration.classConfiguration[j].toBeRemoved = true;
        }
      }
    }
    else if(view.puppet_declaration.hasOwnProperty("resourceConfiguration")) {
      for(var j = 0; j < view.puppet_declaration.resourceConfiguration.length; j++) {
        if(view.puppet_declaration.resourceConfiguration[j].uniqueKey == key)  {
          view.puppet_declaration.resourceConfiguration[j].toBeRemoved = true;
        }
      }
    }
    var hbox = document.getElementById('input_hbox_' + key);
    var parameters_config_element = document.getElementById("parametersConfig");
    parameters_config_element.removeChild(hbox);
    if(this.selected_parameters.hasOwnProperty(key)) {
      delete this.selected_parameters[key];
    }
    if(this.selected_parameters_input_fields.hasOwnProperty(key)) {
      delete this.selected_parameters_input_fields[key];
    }
    this.selected_parameters_list = this.selected_parameters_list.filter(function(obj) { return obj.object.uniqueKey != key; } );
  },


  refreshSelectableParameters : function (factory) {
    // refresh select list
    var all_element    = document.getElementById('allparameters');
    var select_element = document.getElementById('selectedparameters');
    while (all_element.childNodes.length > 1) {
      all_element.removeChild(all_element.lastChild);
    }
    for(var i = 0; i < factory.classFactory.parameters.length; i++) {
      var item = document.createElement('listitem');
      item.setAttribute('key',                       factory.classFactory.parameters[i].name);
      item.setAttribute('puppetParameterFactoryKey', factory.classFactory.parameters[i].uniqueKey);
      var label = document.createElement('label');
      label.setAttribute('value', factory.classFactory.parameters[i].name);
      item.appendChild(label);
      if(this.selected_parameters.hasOwnProperty(factory.classFactory.parameters[i].name) && 
         !this.selected_parameters[factory.classFactory.parameters[i].name].object.toBeRemoved) {
      }
      else {
        all_element.appendChild(item);
      }
    }
  },

  createNewParameterInputElement : function(parameter, factory,parameters_config_element) {
    var key  = parseInt(parameter.get('uniqueKey'));
    var hbox = document.createElement('hbox');
    var name = parameter.get('key')
    hbox.setAttribute('align', 'center');
    hbox.setAttribute('id',    'input_hbox_' + key);
    var remove_button = document.createElement('button');
    remove_button.setAttribute('class','arrowleft-button'); 
    remove_button.setAttribute('oncommand','removeParameterAndRefresh(' + key + ')'); 
    var hbox_label = document.createElement('hbox');
    hbox_label.setAttribute('pack', 'end');
    hbox_label.setAttribute('width', '100px');
    var label = document.createElement('shadowlabel'); 
    label.setAttribute('value', name);
    label.setAttribute('class', 'staticheader');
    hbox_label.appendChild(label);
    var hbox_tooltip = document.createElement('hbox');
    hbox_tooltip.setAttribute('width', '30px');
    hbox_tooltip.setAttribute('flex', '0');
    hbox_tooltip.setAttribute('align', 'center');

    var hbox_type = document.createElement('hbox');
    var menulist_type = document.createElement('menulist');
    menulist_type.setAttribute('id', 'input_type_' + key);
    var menupopup_type = document.createElement('menupopup');
    var type_list = [];
    menulist_type.appendChild(menupopup_type);
    hbox_type.appendChild(menulist_type);
    if(factory && factory.parameterLookup.hasOwnProperty(name))  {
      if(factory.parameterLookup[name].documentation) {
        var descr = document.createElement("image");
        descr.setAttribute("src", "chrome://cmgui/content/icons/notice.png");
        descr.setAttribute("tooltiptext", factory.parameterLookup[name].documentation);
        hbox_tooltip.appendChild(descr);
      }
      var types = factory.getTypesForParameter(factory.parameterLookup[name]);
      for(var i = 0; i < types.length; i++) {
        var menuitem = document.createElement('menuitem');
        type_list.push([ types[i].value, types[i].label ]);
      }
    }
    var hbox_textbox = document.createElement('hbox');
    hbox_textbox.setAttribute('id',    'input_box_' + key);
    hbox_textbox.setAttribute("width", "400px");
    hbox_textbox.setAttribute("flex",  "1");
    hbox_textbox.setAttribute('style', "overflow: auto;");

    hbox.appendChild(remove_button);
    hbox.appendChild(hbox_type);
    hbox.appendChild(hbox_label);
    hbox.appendChild(hbox_tooltip);
    hbox.appendChild(hbox_textbox);

    parameters_config_element.appendChild(hbox);
    kenum("type", type_list, undefined, 'input_type_'  + key, parameter);
    if(inputElementCreator.hasOwnProperty(parameter.get('type'))) {
      inputElementCreator[parameter.get('type')](factory, 
                                                 parameter, 'input_value_' + key, 'input_box_' + key, inputChangedEventListener, 'value');
    }
    puppetRegisterChangeTypeEvent('input_type_'  + key,
                                  parameter, 
                                  'input_value_' + key, 
                                  'input_box_' + key, 
                                  factory,
                                  inputChangedEventListener, 
                                  'value');
    return hbox;
  },

};


function onLoad() {
  printall("onLoad: " + document.location);
  dock = getDock();
  var hash = document.location.hash;
  var re = new RegExp("^#(\\d+)$");
  var found = hash.match(re);
  var declaration_key;
  if(found) {
    declaration_key = parseInt(found[1]);
  }
  this.refresh(window.parent.window.current, declaration_key);
}


function refresh(use, key) {
  if(!!use) current=use;
  if(!!key) puppet_declaration_key = key;
  if(!current) return;
  var roles  = current.get('roles');
  for(var i = 0; i < roles.length; i++) {
    if(roles[i].childType == 'PuppetRole') {
      puppet_role = roles[i];
      break;
    }
  }
  if(!puppet_role) return;
  view.puppet_declaration = null;
  for(var i = 0; i < puppet_role.classDeclarations.length; i++) {
    if(puppet_role.classDeclarations[i].uniqueKey == puppet_declaration_key) {
      view.puppet_declaration = puppet_role.classDeclarations[i];
    }
  }
  for(var i = 0; i < puppet_role.resourceDeclarations.length; i++) {
    if(puppet_role.resourceDeclarations[i].uniqueKey == puppet_declaration_key) {
      view.puppet_declaration = puppet_role.resourceDeclarations[i];
    }
  }
  view.puppet_declaration_object = new dock.cvObject(current.cluster, view.puppet_declaration);      
  if(!view.puppet_declaration) {
    println("no such declaration " + puppet_declaration_key);
  }
  var config = [];
  if(view.puppet_declaration.hasOwnProperty('resourceConfiguration')) {
    config = view.puppet_declaration.resourceConfiguration;
  }
  else if(view.puppet_declaration.hasOwnProperty('classConfiguration')) {
    config = view.puppet_declaration.classConfiguration;
  }

  if(!view.selected_parameters) view.selected_parameters = {};
  for(var i = 0; i < config.length; i++) {
    if(config[i].toBeRemoved) {
      continue;
    }
    if(!view.selected_parameters.hasOwnProperty(config[i].key)) {
      view.selected_parameters[config[i].key] = new dock.cvObject(current.cluster, config[i]);      
      view.selected_parameters_list.push(view.selected_parameters[config[i].key]);
    }
  }
  var elem = document.getElementById("classnamelabel");
  if(elem) {
    var name = "";
    if(view.puppet_declaration.baseType == "PuppetResourceDeclaration") {
      name = view.puppet_declaration.resourceType;
      registerTitleChangeHandler();
      text("titles_0", false, undefined, undefined, undefined, undefined, undefined, view.puppet_declaration_object);
    }
    else {
      name = view.puppet_declaration.className;
    }
    elem.setAttribute("value", name); 
  }
  if(factory == null) {
    factory = new PuppetFactory(view.puppet_declaration.puppetClassFactoryKey, current.cluster);
    factory.load(function(factory) { 
      if(factory.classFactory.documentation) {
        var descr = document.createElement("image");
        descr.setAttribute("src", "chrome://cmgui/content/icons/notice.png");
        descr.setAttribute("tooltiptext", factory.classFactory.documentation);
        var hbox_tooltip = document.getElementById("tooltipclass");
        hbox_tooltip.appendChild(descr);
      }
      view.addAllNonExistingInputFields(factory);
      view.refreshSelectableParameters(factory); 
    });
  }
  else {
    view.refreshSelectableParameters(factory);
    view.addAllNonExistingInputFields(factory);
  }
}

function removeParameterAndRefresh(key) {
  view.removeParameter(key);
  setModified();
  refresh();
}

function showClassDetails()  
{
  factory.load(function(_factory) { 
    var args = {
      moduleData  : null,
      classData   : _factory.puppetClass,
      factory     : _factory
    };
    var d = new dock.cvDialog("chrome://cmgui/content/puppet/puppetclassdetails.xul", args);
    dock.dialogs.showDialog(d);
  });
}


function inputChangedEventListener(event) {
  setModified();
}

function registerTitleChangeHandler() {
  var title_box = document.getElementById('resourceTitleHbox');
  title_box.removeAttribute('hidden');
  var obj = document.getElementById('titles_0');
  obj.addEventListener("change",   titleChangedEventListener, true);
  obj.addEventListener("keypress", titleChangedEventListener, true);
  obj.addEventListener("input", titleChangedEventListener, true);
}

function titleChangedEventListener(event) {
  // refresh tab label of parent
  var title = document.getElementById("titles_0");
  if(view.puppet_declaration.hasOwnProperty('resourceType')) {
    var tab = window.parent.document.getElementById('tab_' + puppet_declaration_key);   
    if(tab) {
      tab.setAttribute('label', title.value);
    }
  }
  setModified();
  view.puppet_declaration.modified = true;
}

function addParametersToGroup() {
  var all_element = document.getElementById('allparameters');
  for(var i = 0; i < all_element.childNodes.length; i++) {
    var item = all_element.childNodes[i];
    if(item.getAttribute('selected')) {
      var name = item.getAttribute('key');
      if(!view.selected_parameters.hasOwnProperty(name)) {
        var parameter = new dock.cvPuppetConfigurationEntry();
        parameter.key   = name;
        parameter.type  = "String";
        parameter.value = '';
        parameter.puppetParameterFactoryKey  = parseInt(item.getAttribute('puppetParameterFactoryKey'));
        if(factory) {
          factory.setDefaultValue(name, parameter);
        }
        var cluster_param = current.cluster.addObject(parameter, false,false);
        setModified();
        cluster_param.setModified(true);
        if(view.puppet_declaration.hasOwnProperty("classConfiguration")) {
          view.puppet_declaration.classConfiguration.push(parameter);
        }
        else if(view.puppet_declaration.hasOwnProperty("resourceConfiguration")) {
          view.puppet_declaration.resourceConfiguration.push(parameter);
        }
        view.selected_parameters[name] = cluster_param;
        view.selected_parameters_list.push(cluster_param);
      }
      else if(view.selected_parameters[name].object.toBeRemoved) {
        view.selected_parameters[name].object.toBeRemoved = false;
        view.selected_parameters_list.push(view.selected_parameters[name]);
      }
    }
  }
  refresh();
}

function setModified() {
  current.setModified(true);
  puppet_role.modified = true;
  view.puppet_declaration.modified = true;
}
