/* Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */
var dock;
var current;
var overlay;
var object_lookup = {};

function onLoad() {
  printall("onLoad: " + document.location);
  dock = getDock();
  this.refresh(window.parent.window.puppet_role, true, window.parent.current);
}


function refresh(use, is_loaded, use_overlay) {
  printall("refresh: ConfigOverlayPuppetSettings");
  if(!is_loaded) {
    return;
  }
  if(!!use) current=use;
  if(!!use_overlay) overlay = use_overlay;
  if(!current) {
    return;
  }

  var decl_values = [ [ "NoInheritance", "override" ], 
                      [ "DeclarationInheritance" ,"declaration" ],
                      /* [ "ParameterInheritance",   "parameter" ] removed due to complexity */ ];

  var var_values = [  [ "NoInheritance",               "override" ], 
                      [ "DeclarationInheritance" ,     "declaration" ] ];
  var preamble_values = [  [ "NoInheritance",          "override" ], 
                           [ "DeclarationInheritance" ,"append" ] ];
  if(current.object.preambleDeclarations.length < 1) {
    current.object.preambleDeclarations.push("");
  }
  text({ what: "preambleDeclarations_0",   currentObject: current});
  kenum("classDeclarationGranularity",     decl_values,undefined,undefined,current);
  kenum("resourceDeclarationGranularity",  decl_values,undefined,undefined,current);
  kenum("variableDeclarationGranularity",  var_values,undefined,undefined,current);
  kenum("preambleGranularity",             preamble_values,undefined,undefined,current);
  for(var i = 0; i < current.object.variableDeclarations.length; i++) {
    if(!current.object.variableDeclarations[i].toBeRemoved) {
      var parameter_object = new dock.cvObject(current.cluster, current.object.variableDeclarations[i]);
      addVariableInputElement(parameter_object, parameter_object.object.uniqueKey);
    }
  }
}



function addVariableInputElement(parameter, key, index) {
  object_lookup[parameter.object.uniqueKey] = parameter;
  var variables_box = document.getElementById("variables_box");
  var hbox = document.createElement('hbox');
  hbox.setAttribute('pack',  'begin');
  hbox.setAttribute('align', 'start');
  hbox.setAttribute('id',    'input_pair_' + key);

  var label0 = document.createElement('shadowlabel'); 
  label0.setAttribute('value', '$');
  label0.setAttribute('class', 'staticheader');
  label0.setAttribute('pack', 'center');

  var textbox_key = document.createElement('textbox'); 
  textbox_key.setAttribute("type", "timed");
  textbox_key.setAttribute("width", "250px");
  textbox_key.setAttribute('id',   'input_key_' + key);
  textbox_key.addEventListener("change",   variableChangedEventListener);
  textbox_key.addEventListener("keypress", inputChangedEventListener);
  textbox_key.setAttribute("oninput",   "validateVariableKey(event); inputChangedEventListener(event);");
  

  var hbox_textbox = document.createElement('hbox');
  hbox_textbox.setAttribute('id',    'input_box_' + key);
  hbox_textbox.setAttribute("width", "400px");
  hbox_textbox.setAttribute("flex",  "1");
  hbox_textbox.setAttribute('style', "overflow: auto;");
  var menulist_type = document.createElement('menulist');
  menulist_type.setAttribute('id', 'input_type_' + key);

  var menupopup_type = document.createElement('menupopup');
  menulist_type.appendChild(menupopup_type);

  var label = document.createElement('shadowlabel'); 
  label.setAttribute('value', '=');
  label.setAttribute('class', 'staticheader');
  label.setAttribute('pack', 'center');

  var hbox_remove = document.createElement('hbox');
  hbox_remove.setAttribute('pack',  'center');
  hbox_remove.setAttribute('flex',  '0');
  hbox_remove.setAttribute('align', 'center');
  hbox_remove.setAttribute('width', '40px');

  var remove_button = document.createElement('button'); 
  remove_button.setAttribute('class',       'minus-button');
  remove_button.setAttribute('tooltiptext', 'Remove');
  remove_button.setAttribute('oncommand','removeVariable(' + key + ');');
  hbox_remove.appendChild(remove_button);

  var add_button = document.createElement('button'); 
  add_button.setAttribute('class','plus-button');
  add_button.setAttribute('tooltiptext', 'Remove');
  add_button.setAttribute('oncommand','addVariable(' + key + ');');
  hbox_remove.appendChild(add_button);

  hbox.appendChild(label0);
  hbox.appendChild(textbox_key);
  hbox.appendChild(label);
  hbox.appendChild(menulist_type);
  hbox.appendChild(hbox_textbox);
  hbox.appendChild(hbox_remove);


  if(!variables_box.firstChild) {
    variables_box.appendChild(hbox);
  }
  else if(index == null || index == -1) {
    variables_box.insertBefore(hbox, variables_box.firstChild);
  }
  else {
    var child = variables_box.firstChild;
    var found = false;
    var added = false;
    while(child) {
      if(found) {
        variables_box.insertBefore(hbox, child);
        added = true;
        break;
      }
      if(child.getAttribute('id') == 'input_pair_'+index) {
        found = true;
      }
      child = child.nextSibling;
    }
    if(!added) {
      variables_box.appendChild(hbox);
    }
  }

  var types =  getPuppetTypes();
  var type_values = [];
  for(var i = 0; i < types.length; i++) {
    var menuitem = document.createElement('menuitem');
    if(types[i].value != 'Select') {
      // select does not make sense for variable settings
      type_values.push([ types[i].value, types[i].label] );        
    }
  }
  text("key",  '@FUNCTION@checkPuppetVariableValue', undefined, undefined, undefined, undefined, 'input_key_'   + key, parameter);
  kenum("type", type_values, undefined, 'input_type_'  + key, parameter);
  if(inputElementCreator.hasOwnProperty(parameter.get('type'))) {
    inputElementCreator[parameter.get('type')](null, parameter, 'input_value_' + key, 'input_box_' + key, inputChangedEventListener, 'value');
  }
  puppetRegisterChangeTypeEvent('input_type_'  + key,
                                parameter, 
                                'input_value_' + key, 
                                'input_box_' + key, 
                                null,
                                inputChangedEventListener, 
                                'value');
}

function validateVariableKey(event) {
  var target = event.target;
  if(checkPuppetVariableValue(target.value)) {
    target.setAttribute("style", "");
  }
  else {
    target.setAttribute("style", "color: red;");
  }
}

function variableChangedEventListener(event) {
  current.object.modified = true;
  overlay.object.modified = true;
}


function inputChangedEventListener(event) {
  current.object.modified = true;
  overlay.object.modified = true;
}

function setModified() {
  current.object.modified = true;
  overlay.object.modified = true;
}

function typeChanged() {
 var obj = document.getElementById(elementNodeId);
}

function removeVariable(index) {
  if(object_lookup[index]) {
    object_lookup[index].object.toBeRemoved = true;
    setModified();
    var box = document.getElementById('input_pair_' + index);
    if(box) {
      box.setAttribute('hidden', 'true');
    }
  }
}


function addVariable(index=null) {
  var parameter = new dock.cvPuppetConfigurationEntry();
  parameter.key = '';
  parameter.type = 'String';
  parameter.value = '';
  parameter.modified = true;
  var parameter_object = new dock.cvObject(current.cluster, parameter);
  var pos = -1;
  if(index != null) {
    for(var i = 0; i < current.object.variableDeclarations.length; i++) {
      if(current.object.variableDeclarations[i].uniqueKey == index) {
        pos = i;
        break;
      }
    }
  }
  var input_element_counter = current.object.variableDeclarations.length;
  if(pos == -1) {
    current.object.variableDeclarations.push(parameter);
  }
  else {
    current.object.variableDeclarations.splice(pos+1, 0, parameter);    
  }
  setModified();
  addVariableInputElement(parameter_object, parameter.uniqueKey, index);
}



