/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function closePuppetClassDetails() {
  close();
}


function onLoad() {
  var dock = getDock();
  println("Puppet Install Wizard initialized: " + this.name);
  var s      = this.name.indexOf('[');
  var e      = this.name.indexOf(']');
  var index  = this.name.substr(s + 1, e - s - 1);
  var myDialog   = dock.dialogs.list[index];     
  if(myDialog.arguments.moduleData) {
    showModuleData(myDialog.arguments.moduleData);
  }
  else {
    var elem = document.getElementById("moduledata"); 
    elem.setAttribute("style", "visibility: collapse;");
  }
  if(myDialog.arguments.factory) {
    showFactoryData(myDialog.arguments.classData, myDialog.arguments.factory);
    window.innerHeight = 600;
  }
  else {
    var elem = document.getElementById("classdata"); 
    elem.setAttribute("style", "visibility: collapse;");
    window.innerHeight = 320;
  }
  window.innerWidth = 600;
}


function showModuleData(data)
{
    var fields = [ "name",
                   "author",
                   "baseType",
                   "firstAppeared",
                   "installed",
                   "issuesUrl",
                   "license",
                   "projectPage",
                   "source",
                   "summary",
                   "version"
                 ];
    for(var i =0; i < fields.length; i++)
    {
        var elem = document.getElementById("module-" + fields[i]); 
        if(elem)
        {
            if(fields[i] == "firstAppeared") 
            {
                var d = new Date(data[fields[i]]*1000);
                elem.setAttribute("value", d.toLocaleFormat("%Y-%m-%d %H:%M"));
            }
            else 
            {
              elem.setAttribute("value", data[fields[i]]);
            }
        }
    }
}

function showFactoryData(cls, factory) {
  function createLabel(value) {
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", value);
    return label;
  }

  function createTip(value) {
    if(value) {
      var hbox = document.createElement("hbox");
      var descr = document.createElement("image");
      descr.setAttribute("src", "chrome://cmgui/content/icons/notice.png");
      descr.setAttribute("tooltiptext", value);
      hbox.appendChild(descr);
      hbox.setAttribute("flex", "0");
      hbox.setAttribute("align", "left");
      hbox.setAttribute("pack", "begin");
      return hbox;
    }
    else {
      var label = document.createElement('label');
      return label;
    }
  }
  var image = document.getElementById("class-documentation"); 
  if(factory.classFactory.documentation) {
    image.setAttribute("tooltiptext", factory.classFactory.documentation);
    image.removeAttribute("hidden");
  }
  else {
    image.setAttribute("hidden","true");
  }
  var elem = document.getElementById("class-name"); 
  elem.setAttribute("value", cls.name);
  var elem = document.getElementById("class-puppettype"); 
  elem.setAttribute("value", cls.puppetType);
  var obj = document.getElementById('parameters');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);

  for(var i = 0; i < factory.classFactory.parameters.length; i++) {
    var item = factory.classFactory.parameters[i];
    var row = document.createElement('row');
    row.setAttribute("flex", "1");
    row.setAttribute("align", "center");
    row.setAttribute("height", "17px");
    
    row.appendChild(createLabel(item.name));        
    row.appendChild(createLabel(factory.formatType(item)));        
    row.appendChild(createLabel(factory.shortFormatDefault(item)));        
    row.appendChild(createTip(item.documentation));
    obj.appendChild(row);
  }
}


