var puppet_separator = '---';
var myDialog;
var puppetClass;
var puppet;
var current;
var dock;
var nodes = new Object();
var role_name;
var puppet_class_name;

var assignto = '';
var current_selection = new Array();
var current_selection_modified = false;
var enableOnSelectionChange = true;
var enableOnCodeChange     = true;
var enableMultipleTextEdit = false;

var current_modified = new Object();
var num_extra_resource=0;
var extra_resource = new Object();

function onLoad()
{

    nodes = new Object();
    assignto = '';
    current_selection = new Array();
    current_selection_modified = false;
    enableOnSelectionChange = true;
    enableOnCodeChange     = true;
    enableMultipleTextEdit = false;
    current_modified = new Object();
    num_extra_resource=0;
    extra_resource = new Object();


    dock = getDock();
    println("Puppet Roles initialized: " + this.name);
    var s       = this.name.indexOf('[');
    var e       = this.name.indexOf(']');
    var index   = this.name.substr(s + 1, e - s - 1);
    var preselect = new Object();
    var has_preselect = false;
    myDialog    = dock.dialogs.list[index];     
    puppetClass = myDialog.arguments.object;
    assignto    = myDialog.arguments.assignto;
    if(typeof(myDialog.arguments.preselect) != 'undefined') 
    {
        for(var i = 0; i < myDialog.arguments.preselect.length; i++) 
        {
            current_selection.push(myDialog.arguments.preselect[i]);
            preselect[myDialog.arguments.preselect[i]]=true;
            has_preselect = true;
        }
    }
    var all     = puppetClass.cluster.find('Puppet');
    if(all.length == 1) 
    {
        puppet = all[0];
    } 
    puppet_class_name = puppetClass.get('name').toLowerCase();
    current     = myDialog.arguments.current;
    role_name = 'puppet::' + puppet_class_name;
    var before          = document.getElementById("label_before_puppetcode0");
    var after           = document.getElementById("label_after_puppetcode0");
    var addresource     = document.getElementById("addresource");
    var puppettype      = 'class';
    var textarea=document.getElementById("puppetcode0");
    var headline=document.getElementById("label_headline");
    var human_assignto = assignto == "Node" ? "nodes" : "categories";
    var inputbox = document.getElementById("inputbox");
    if(puppetClass.get('puppetType') == 'Class') 
    {
        inputbox.height = "150";
        puppettype = 'class';
        before.innerHTML = 'class { \'' + puppet_class_name + '\':';
        after.innerHTML = '}';
        addresource.collapsed = true;
        headline.value = "Select one or more " + human_assignto + " and declare the puppet class " + puppet_class_name;
    }
    else if(puppetClass.get('puppetType') == 'Dependencies' || 
            puppetClass.get('puppetType') == 'Globals') 
    {
        inputbox.height = "150";
        puppettype = 'globals';
        before.innerHTML = '';
        after.innerHTML = '';
        addresource.collapsed = true;
        if(puppetClass.get('puppetType') == 'Dependencies') 
        {
            headline.value = "Select one or more " + human_assignto + " and define dependencies.";
        }
        else 
        {
            headline.value = "Select one or more " + human_assignto + " and define global definitions outside classes and resources.";
        }
    }
    else 
    {
        inputbox.height = "200";
        headline.value = "Select one or more " + human_assignto + " and declare the Puppet resource " + puppet_class_name;
        puppettype = 'resource';
        textarea.setAttribute('rows','3');
        before.innerHTML =  puppet_class_name + '{';
        after.innerHTML = '}';
        addresource.setAttribute("hidden","true");
    }
    initNodeList(preselect);
    tree = document.getElementById("tree");
    loadTable(tree,data);
    if(has_preselect)
    {
        enableOnSelectionChange = false;
        for(var t = 0; t < tree.view.rowCount; t++) 
        {
            var key = tree.view.getCellText(t,null);
            if(preselect[key]) 
            {
                tree.view.selection.rangedSelect(t,t,true);
            }
        }
        enableOnSelectionChange = true;
        onSelectionChanged(current_selection);
    }
}

/////////////////////////////////////////////////////////////////
//
// init functions 
//
/////////////////////////////////////////////////////////////////
function initNodeList(preselect)
{
    data = new Array();
    var node_list = current.cluster.find(assignto);
    var name_field = (assignto == 'Node') ? "hostname" : "name";
    node_list.sort(function(x, y) {
            if(x.get(name_field).toLowerCase() < y.get(name_field).toLowerCase())
            {
                return -1;
            }
            else if(x.get(name_field).toLowerCase() > y.get(name_field).toLowerCase())
            {
                return 1;
            }
            return 0;
    });
    for(var i = 0; i < node_list.length; i++)
    {
        var key = node_list[i].get('uniqueKey');
        var has_role = false;
        var roles_list = node_list[i].get('roles');
        var role = null;
        for(var j = 0; j < roles_list.length; j++) 
        {
            if(roles_list[j].name.toLowerCase()==role_name)
            {
                role = roles_list[j];
                has_role = true;
                break;
            }
        }
        var name = '';
        if(assignto == 'Node') name = node_list[i].get('hostname');
        else                   name = node_list[i].get('name');
        nodes[key] = {
            hostname      : name,
            modified      : false,
            config_modified : false,
            key           : key,
            assigned      : has_role,
            node          : node_list[i],
            role          : role,
            orig_assigned : has_role,
            assigned      : has_role,
            config        : '',
            index         : i,
            preselect     : preselect[key]?true:false
        };
        data.push(nodes[key]);
    }
}



/////////////////////////////////////////////////////////////////
//
// refresh & update elements functions 
//
/////////////////////////////////////////////////////////////////
function refresh(use) {
  current_selection = new Array();
  current_selection_modified = false;
  tree = document.getElementById("tree");
  loadTable(tree,data);
  //refreshHostList();
  return true;
}

function refreshSaveRevertButtons()
{
    var revertbutton  = document.getElementById("revertbutton");
    var savebutton    = document.getElementById("savebutton");
    var changed       = (Object.keys(current_modified).length > 0);
    if(changed) 
    {
        revertbutton.removeAttribute("disabled");
        savebutton.removeAttribute("disabled");
    }
    else 
    {
        revertbutton.setAttribute("disabled","true");
        savebutton.setAttribute("disabled","true");
    }
}


function refreshHostList()
{
    var backup = new Array();
    if(tree.view && tree.view.selection) 
    {
        for(var t = 0; t < tree.view.selection.getRangeCount(); t++)
        {
            var start = {};
            var end   = {};
            tree.view.selection.getRangeAt(t,start,end);
            backup.push([start.value, end.value]);
        }
    }
    tree = document.getElementById("tree");
    enableOnSelectionChange = false;
    loadTable(tree,data);
    for(var t = 0; t < backup.length; t++)
    {   
        tree.view.selection.rangedSelect(backup[t][0],backup[t][1],true);
    }
    enableOnSelectionChange = true;
}


function backupSelectionAndSort(view_col)
{
    backupSelection(current_selection);
    current_selection = new Array();
    current_selection_modified = false;
    onSelectionChanged(current_selection);
    sort(view_col);
}

function backupSelection(sel)
{
    var textarea        = document.getElementById("puppetcode0");
    if(enableMultipleTextEdit) 
    {
        var value = textarea.value;
        if(puppetClass.get('puppetType') == 'Resource' || puppetClass.get('puppetType') == 'BuiltinTypes') 
        {
            for(var i in  extra_resource) 
            {
                var textarea_extra = document.getElementById("puppetcode" + i);
                value+= puppet_separator;
                value+= textarea_extra.value;
            }
        }
        for(var i = 0; i < sel.length; i++) 
        {
            var n  = nodes[sel[i]];
            if(n.assigned)
            {
                n.config = value;
            }
        }
    }
}

function onPuppetCodeChange()
{
    if(!enableOnCodeChange) 
    {
        return ;
    }
    if(current_selection.length > 0) 
    {
        if(!current_selection_modified)
        {
            current_selection_modified = true;
            for(var i = 0; i < current_selection.length; i++) 
            {
                var n  = nodes[current_selection[i]];
                n.config_modified = true;
                var changed = ((n.orig_assigned != n.assigned || (n.assigned && n.config_modified)));
                n.modified = changed;
                //n.modified = changed;
                if(changed) 
                {
                    current_modified[n.key] = true;
                }
                else 
                {
                    delete current_modified[n.key];
                }
            }
            refreshSaveRevertButtons();
            refreshHostList();
        }
    }
    return true;
}

function onAssign()
{
    for(var i = 0; i < current_selection.length; i++) 
    {
        var n = nodes[current_selection[i]];
        n.assigned = true;
        var changed = (n.orig_assigned != n.assigned || n.config_modified);
        n.modified = changed;
        //data[n.index].assigned = true;
        //data[n.index].modified = changed;
        if(changed) 
        {
            current_modified[n.key] = true;            
            current_selection_modified = true;
        }
        else 
        {
            delete current_modified[n.key];
        }
    }
    onSelectionChanged(current_selection);
    refreshSaveRevertButtons();
    refreshHostList();
}

function onUnassign()
{
    for(var i = 0; i < current_selection.length; i++) 
    {
        var n = nodes[current_selection[i]];
        n.assigned = false;
        var changed = (n.orig_assigned != n.assigned);
        n.modified = changed;
        //data[n.index].modified = changed;
        if(changed) 
        {
            current_modified[n.key] = true;
            current_selection_modified = true;
        }
        else 
        {
            delete current_modified[n.key];
        }
    }

    onSelectionChanged(current_selection);
    refreshSaveRevertButtons();
    refreshHostList();
}

function addResource(onchange=true)
{
    var vbox     = document.getElementById("codevbox");
    var newvbox  = document.createElement('vbox');
    num_extra_resource++;
    newvbox.setAttribute('align','left');
    newvbox.setAttribute('id','extra_resource' + num_extra_resource);
    var descr1  = document.createElement('description');
    var textbox = document.createElement('textbox');
    var button  = document.createElement('button');
    var descr2  = document.createElement('description');
    var space   = document.createElement('hbox');
    var hbox   = document.createElement('hbox');
    space.appendChild(button);
    hbox.appendChild(textbox);
    hbox.appendChild(space);
    newvbox.appendChild(descr1);
    newvbox.appendChild(hbox);
    newvbox.appendChild(descr2);


    space.setAttribute('align','center');
    space.setAttribute('width','30px');
    space.setAttribute('flex','0');
    descr1.innerHTML = puppet_class_name + '{';
    descr1.setAttribute('align','center');
    textbox.setAttribute('id','puppetcode' + num_extra_resource);
    textbox.setAttribute('wrap','off');
    textbox.setAttribute('multiline','true');
    textbox.setAttribute('rows','3');
    textbox.setAttribute('cols','80');
    textbox.setAttribute('flex','1');
    textbox.setAttribute('oninput','onPuppetCodeChange();');
    textbox.setAttribute('class','textarea');
    button.setAttribute('class','removecluster-button');
    button.setAttribute('tooltiptext', 'Remove');
    button.setAttribute('oncommand','removeResource(' + num_extra_resource + ');');
    descr2.innerHTML = '}';
    descr2.setAttribute('align','center');
    vbox.insertBefore(newvbox, vbox.lastChild);

    extra_resource[num_extra_resource] = true;
    if(onchange)
    {
        onPuppetCodeChange();
    }
}

function closeAllExtraResources()
{
    var back = enableOnCodeChange;
    enableOnCodeChange = false;
    for(var i in extra_resource) 
    {
        removeResource(i);
    }
    enableOnCodeChange = back;
    extra_resource = new Object();
    num_extra_resource = 0;
}

function removeResource(i)
{
    var extra = document.getElementById('extra_resource' + i);
    var vbox     = document.getElementById("codevbox");
    delete extra_resource[i];
    vbox.removeChild(extra);
    onPuppetCodeChange();
}

function onSelectionChanged(sel)
{
    var selection_has_assigned   = false;
    var selection_has_unassigned = false;
    var selection_is_uniform     = true;

    var unassign_button = document.getElementById("unassignbutton");
    var assign_button   = document.getElementById("assignbutton");
    var textarea        = document.getElementById("puppetcode0");
    var addresource     = document.getElementById("addresource");

    var first = true;
    var config = "";
    for(var i = 0; i < sel.length; i++) 
    {
        var n = nodes[sel[i]];
        if(n) 
        {
            if(n.assigned) selection_has_assigned = true;
            else           selection_has_unassigned = true;
            if(n.assigned) 
            {
                if(n.modified) 
                {
                    if(first) 
                        config=n.config;
                    else if(config != n.config) 
                        selection_is_uniform = false;
                }
                else if(n.orig_assigned)
                {
                    if(first) 
                        config = n.role.config;
                    else if(config != n.role.config) 
                        selection_is_uniform = false;
                }
                first = false;
            }
        }
    }

    current_selection_modified = false;
    enableMultipleTextEdit = false;
    closeAllExtraResources();
    if(selection_has_assigned)
    {
        unassign_button.removeAttribute("disabled");
        if(selection_is_uniform && !selection_has_unassigned) 
        {
            textarea.removeAttribute("disabled");
            enableMultipleTextEdit = true;
            if(puppetClass.get('puppetType') == 'Resource' || puppetClass.get('puppetType') == "BuiltinTypes") 
            {
                var tmp = config.split(puppet_separator);
                config = tmp[0];
                for(var i = 1; i < tmp.length; i++) 
                {
                    addResource(false);
                    var extra_textarea = document.getElementById("puppetcode" + num_extra_resource);                    
                    extra_textarea.value = tmp[i];
                }
                addresource.removeAttribute("disabled");
                addresource.removeAttribute("hidden");
                
            }
            textarea.value = config;
        }
        else 
        {
            textarea.setAttribute("disabled","true");
            textarea.value = "Selected nodes have different Puppet codes or are unassigned.\n" +
                             "Please edit the configurations individual for each node.";
            addresource.setAttribute("disabled","true");
            addresource.setAttribute("hidden","true");
        }
    }
    else 
    {
        textarea.setAttribute("disabled","true");
        addresource.setAttribute("disabled","true");
        textarea.value = '';
        unassign_button.setAttribute("disabled","true");
    }

    if(selection_has_unassigned)
    {
        assign_button.removeAttribute("disabled");
    }
    else 
    {
        assign_button.setAttribute("disabled","true");
    }
}



function editSubObject()
{
    if(!enableOnSelectionChange) 
        return true;
  var list = document.getElementById('list');
  var tree = list.parentNode;
  var select = new Array();
  var start = new Object();
  var end = new Object();
  if(tree.view && tree.view.selection) 
    {
        for(var t = 0; t < tree.view.selection.getRangeCount(); t++)
        {
            tree.view.selection.getRangeAt(t,start,end);
            for(var v = start.value; v <= end.value; v++) 
            {
                var key = tree.view.getCellText(v,null);
                if(key) select.push(key);
            }
        }
    }
    if(select.length == 0) 
    {
        dock.displayError('No node selected');
    }
    else 
    {
        backupSelection(current_selection);
        onSelectionChanged(select);
    }
    current_selection = select;
}


//////////////////////////////////////////////////////////////////////
function commitPuppetRolesNode(save_list)
{
    for(var i = 0; i < save_list.length; i++) 
    {
        var modified = true;
        if(save_list[i].role)
        {
            if(save_list[i].assigned && save_list[i].modified) 
            {
                // update
                save_list[i].role.config = save_list[i].config;
                save_list[i].role.modified = true;
                modified = true;
            }
            else if(save_list[i].orig_assigned && !save_list[i].assigned)
            {
                // remove 
                save_list[i].role.toBeRemoved = true;
                modified = true;
            }
        }
        else if(save_list[i].assigned && !save_list[i].orig_assigned) 
        {
            var roles = save_list[i].node.get('roles');
            // new 
            var new_obj = new dock.cvPuppetRole();
            roles.push(new_obj);
            new_obj.name = role_name;
            new_obj.config = save_list[i].config;
            new_obj.modified = true;
            new_obj.puppetClassKey = puppetClass.get('uniqueKey');
            new_obj.puppetObjectKey = puppet.get('uniqueKey');
            new_obj.puppetObject = puppet.get('uniqueKey');
            var boxed_new_obj = new dock.cvObject(puppet.cluster, new_obj, save_list[i].node,'roles');
            modified = true;
        }
        if(modified)
        {
            save_list[i].node.commit(0, false, 1);
            //var millis = 10000;
            //var date = new Date();
            //var curDate = null;
            //do { curDate = new Date(); }
            //while(curDate-date < millis);
        }
    }
    current_selection_modified = false;
    current_modified  = new Object();
    for(var i in nodes)
    {
        nodes[i].orig_assigned = nodes[i].assigned;
        nodes[i].modified = false;
        //data[nodes[i].index].modified = false;
    }
    refreshSaveRevertButtons();
    refreshHostList();
    //window.top.refresh();
}

function commitPuppetRoles(save_list)
{
    if(!puppetClass.get('available'))
    {
        puppetClass.set('available',true);
        puppet.commit(0, function() { commitPuppetRolesNode(save_list); });
    }
    else 
    {
        commitPuppetRolesNode(save_list);
    }
}

function savePuppetRole()
{
    var revertbutton  = document.getElementById("revertbutton");
    var savebutton    = document.getElementById("savebutton");
    revertbutton.setAttribute("disabled","true");
    savebutton.setAttribute("disabled","true");
    backupSelection(current_selection);
    var savelist = new Array();
    for(var i in nodes)
    {
        if(nodes[i].orig_assigned != nodes[i].assigned || 
           ( nodes[i].assigned && nodes[i].config_modified))
        {
            savelist.push(nodes[i]);
        }
    }
    if(savelist.length != 0) 
    {
        commitPuppetRoles(savelist);
    }
}

function revertPuppetRole()
{
    var revertbutton  = document.getElementById("revertbutton");
    var savebutton    = document.getElementById("savebutton");
    revertbutton.setAttribute("disabled","true");
    savebutton.setAttribute("disabled","true");
    backupSelection(current_selection);
    current_modified  = new Object();
    for(var i in nodes)
    {
        nodes[i].assigned = nodes[i].orig_assigned;
        nodes[i].modified = false;
        nodes[i].config_modified = false;
        //data[nodes[i].index].modified = false;
        //data[nodes[i].index].assigned = nodes[i].assigned;
    }
    enableOnCodeChange = false;
    refreshSaveRevertButtons();
    refreshHostList();
    onSelectionChanged(current_selection);
    enableOnCodeChange = true;
    current_selection_modified = false;
}

function cancel()
{
  if(!window.closed) {
    myDialog.doCancel();
    close();
  }
}


