/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current = 0;
var old;
var singular = 'puppet';




function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function revert() {
  current.old(old);
  refresh();
}

function save() {
  var work = current;
  if(typeof(globalCurrent) != 'undefined') work = current;
  work.commit();
  if(work.object.uniqueKey < dock.MAX_LOCAL_KEY) {
    document.getElementById('revert').setAttribute('disabled', true);
  } else {
    document.getElementById('revert').removeAttribute('disabled');
  }
}



function refresh(use) {
  println("Refresh puppet settings" + ' - ' + document.documentURI);
  if(!!use) {
    current = use.find('Puppet');
    if(current.length == 1) {
      current = current[0];
    } else {
      current = 0;
      return;
    }
  } else if(!current) {
    return;
  }
  old = current.old(false, true);
  
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  
  text('name', '^[a-zA-Z]+$');
  text('baseDirectory', '');
  text('puppetExecutable', '');
  text('moduleDirectory', '');
  text('customModuleDirectory', '');
  text('rubyLibraryDirectory', '');
  text('rubyGemDirectory', '');

  text('rescanExecutable', '');
  text('applyDirectory', '');

  text('puppetForgeVersion', '');
  text('puppetForgeUrl', '');
  text('puppetForgePort', '');
  text('puppetForgeHttpProxy', '');
  text('puppetForgeHttpProxyPort', '');
  text('puppetForgeHttpsProxy', '');
  text('puppetForgeHttpsProxyPort', '');

  displayfunction('applyTimeout', 'formatTimespan(value);');
  parsefunction('applyTimeout', 'parseTimespan(value);');
  text('applyTimeout', '');

  displayfunction('scheduleInterval', 'formatTimespan(value);');
  parsefunction('scheduleInterval', 'parseTimespan(value);');
  text('scheduleInterval', '');
  
  displayfunction('rescanTimeout', 'formatTimespan(value);');
  parsefunction('rescanTimeout', 'parseTimespan(value);');  
  text('rescanTimeout', '');

  check("onNodeUp", false);     
  check("onSchedule", false);  
}
