/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;

function onLoad() {
  dock = getDock();
  println("Initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];


  var host = myDialog.arguments[0];
  var port = myDialog.arguments[1];
  var token = myDialog.arguments[2];
  var name = myDialog.arguments[3];
  var title = myDialog.arguments[4];

  // TODO uncomment to enable client-side part of clipboard
  //addSiteToPreferences('https://' + host + ':' + port);

  var connectUrl = 'https://' + host + ':' + port + '/ajaxterm.html';

  connect(connectUrl, {host: host, port: port, token: token});
  document.title = title + ' - ' + name;
}

function connect(connectUrl, options) {
  var browser = document.getElementById('browser');
  var args = new Array();
  for(var x in options) {
    args.push(escape(x) + '=' + escape(options[x]));
  }
  var url = connectUrl + '?' + args.join('&');
  //alert(url);
  browser.loadURI(url, null, dock.ENCODING);
  browser.focus();
}

function addSiteToPreferences(site) {
  var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var branch = prefs.getBranch("capability.policy.allowclipboard.");

  var oldValue = branch.getComplexValue("sites", Components.interfaces.nsISupportsString).data;
  var newValue = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

  if (oldValue == "") { // first site
    newValue.data = site;
    branch.setComplexValue("sites", Components.interfaces.nsISupportsString, newValue);
  } else if (oldValue.search(site) == -1) { // append
    newValue.data = oldValue + " " + site;    
    branch.setComplexValue("sites", Components.interfaces.nsISupportsString, newValue);
  }
}

function checkForClose() {
  if (myDialog.arguments[5] && (myDialog.arguments[5] == "false")) {
    return true; // do not ask
  } else {
    var result = confirm('Close this terminal?');
    return result;
  }
}
