/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function refresh(use) {
  if(!!use) current = use;
  println("Refresh roles" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  var checks = document.getElementsByTagName('checkimage');
  for(var i = 0; i < checks.length; i++) {
    checks[i].checked = false;
    var next = checks[i].nextSibling;
    if(next) next.setAttribute('hidden', true);
  }

  clearLabel('Login');
  clearLabel('Storage');
  clearLabel('UGEClient');
  clearLabel('UGEServer');
  clearLabel('SGEClient');
  clearLabel('SGEServer');
  clearLabel('TorqueClient');
  clearLabel('TorqueServer');
  clearLabel('PbsProClient');
  clearLabel('PbsProServer');
  clearLabel('SlurmClient');
  clearLabel('SlurmServer');
  clearLabel('LSFClient');
  clearLabel('LSFServer');
  clearLabel('OpenLavaClient');
  clearLabel('OpenLavaServer');
  clearLabel('Master');
  clearLabel('Provisioning');
  clearLabel('SubnetManager');
//   clearLabel('LicenseManager');
  clearLabel('Failover');
  clearLabel('Database');
  //clearLabel('Monitoring');
  clearLabel('Backup');
  clearLabel('Boot');
  clearLabel('CloudGateway');
  clearLabel('CloudDirector');
  clearLabel('MICHost');
  clearLabel('Memcached');
  clearLabel('HAProxy');
  clearLabel('Galera');

  var cloudRoles = document.getElementById('cloudRoles');
  var masterFailoverRoles = document.getElementById('masterFailoverRoles');
  if(current.get('baseType') == "Category") {
    masterFailoverRoles.setAttribute('hidden', true);
    cloudRoles.setAttribute('hidden', true);
  } else if(dock.baseChildTypeCheck(current.object, 'CloudNode') || dock.baseChildTypeCheck(current.object, 'MasterNode')) {
    masterFailoverRoles.setAttribute('hidden', false);
    cloudRoles.setAttribute('hidden', false);
  } else {
    masterFailoverRoles.setAttribute('hidden', true);
    cloudRoles.setAttribute('hidden', true);
  }

  var cloudDirectorRole = document.getElementById('clouddirectorrole');
  if(current.get('childType') == "CloudNode") {
    cloudDirectorRole.parentNode.selectedIndex = 0;
  } else {
    cloudDirectorRole.parentNode.selectedIndex = 1;
  }

  var micRoles = document.getElementById('micRoles');
  
  var roles = current.get(subfield);
  for(var i = 0; i < roles.length; i++) {
    if(!roles[i].toBeRemoved && !startswith(roles[i].childType, 'Hadoop')) {
      setRole(roles[i], '');
    }
  }

  if(dock.baseChildTypeCheck(current.object, 'SlaveNode')) {
    var cat = current.get('category');
    if(cat) {
      cat = current.cluster.find(cat);
      if(cat) {
        var catroles = cat.get(subfield);
        cat = cat.resolveName();
        for(var i = 0; i < catroles.length; i++) {
          if(!catroles[i].toBeRemoved) {
            var found = false;
            for(var j = 0; !found && (j < roles.length); j++) {
              if(!roles[j].toBeRemoved) {
                found = (catroles[i].childType == roles[j].childType);
              }
            }
            if(!found) setRole(catroles[i], cat);
          }
        }
      }
    }
  }
}
