/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock;
var current;
var configs;
var xname;
var original;
var description;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  var current = myDialog.arguments['node'];
  var list = document.getElementById('configs');
  var popup = list.firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  var partition = current.cluster.find(current.get('partition'));
  if(partition) {
    var val = '';
    var find = partition.get('defaultBurnConfig');
    configs = partition.get('burnConfigs');
    for(var i = 0; i < configs.length; i++) {
      var item = document.createElement("menuitem");
      item.setAttribute('key', configs[i].uniqueKey);
      item.setAttribute('label', configs[i].name);
      popup.appendChild(item);
      if(configs[i].uniqueKey == find) {
        val = configs[i].name;
        document.getElementById('xml').value = configs[i].configuration;
      }
    }
    if(configs.length == 0) {
      var item = document.createElement("menuitem");
      item.setAttribute('key', 0);
      item.setAttribute('label', '');
      popup.appendChild(item);
    }
    list.setAttribute('label', val);
    popup.addEventListener("command", select, true);
  }
}

function select(event) {
  var item = event.target;
  var value = parseInt(item.getAttribute('key'));
  for(var i = 0; i < configs.length; i++) {
    if(configs[i].uniqueKey == value) {
      xname = configs[i].name;
      description = configs[i].description;
      original = configs[i].configuration;
      document.getElementById('xml').value = original;
      break;
    }
  }
}

function ok() {
  var text = document.getElementById('xml').value;
  if(text != original) xname += ' (edited)';
  myDialog.onOk(xname, description, text);
  close();
}

function cancel() {
  close();
}
