/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock

function onLoad() {
  dock = getDock();
  println("Select initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  setDialogTitle(myDialog.arguments.title);

  refresh();
}

function refresh() {
  var list = document.getElementById('list');
  while(list.firstChild) list.removeChild(list.firstChild);
  for(var i = 0; i < dock.eventFilters.length; i++) {
    var item = document.createElement('listitem');
    item.setAttribute('label', dock.eventFilters[i].name);
    list.appendChild(item);
  }
}

function deleteFilter() {
  var list = document.getElementById('list');
  var item = list.selectedItem;
  if(item) {
    var name = item.getAttribute('label');
    dock.removeFilter(name);
    refresh();
  } else {
    dock.displayInfo("Nothing selected");
  }
}

function ok() {
  if(myDialog.onOk) {
    var list = document.getElementById('list');
    var item = list.selectedItem;
    if(item) {
      myDialog.onOk(item.getAttribute('label'));
      close();
    } else {
      dock.displayInfo("Nothing selected");
    }
  }
}
