/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var myDialog;
var dock

function onLoad() {
  dock = getDock();
  println("Select object initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  if(typeof(myDialog.arguments.check) != 'undefined') {
    document.getElementById('check').setAttribute('hidden', false);
    document.getElementById('check').setAttribute('label', myDialog.arguments.check);
    document.getElementById('check').checked = myDialog.arguments.checked;
  }

  setDialogTitle(myDialog.arguments.title)

  var cluster = myDialog.arguments.cluster;
  var list = document.getElementById('objects');
  var objects = cluster.find(myDialog.arguments.type);
  for(var i = 0; i < objects.length; i++) {
    var item = document.createElement("listitem");
    item.setAttribute('key', objects[i].get('uniqueKey'));
    item.setAttribute('label', objects[i].resolveName());
    list.appendChild(item);
  }

  if(typeof(myDialog.arguments.yes) != "undefined") document.getElementById('yesbutton').setAttribute('disabled', myDialog.arguments.yes);
  if(typeof(myDialog.arguments.no) != "undefined") document.getElementById('nobutton').setAttribute('hidden', !myDialog.arguments.no);
  if(typeof(myDialog.arguments.cancel) != "undefined") document.getElementById('cancelbutton').setAttribute('hidden', !myDialog.arguments.cancel);

}

function yes() {
  var list = document.getElementById('objects');
  if(list.selectedCount == 0) {
    dock.displayInfo("Nothing selected");
    return;
  }
  var index = list.selectedItem;
  index = index.getAttribute('key');
  if(myDialog.onOk) {
    if(myDialog.arguments.check) {
      myDialog.onOk(index, document.getElementById('check').checked);
    } else {
      myDialog.onOk(index);
    }
  }
  close();
}

function no() {
  if(myDialog.onNo) myDialog.onNo();
  close();
}

function cancel() {
  if(myDialog.onCancel) myDialog.onCancel();
  close();
}
