/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function cvSettings() {
  this.statusRefresh = 60;
  this.monitoringRefresh = 120;
  this.eventTimespan = 608400;
  this.timespan = 3600;
  this.intervals = 200;
  this.quietQuit = false;
  this.autoOpenChanges = false;
  this.newVersionNag = true;
  this.showAllBrightVersions = false;
  this.console2 = '';
  if(startswith(getOS(), "WIN")) this.console2 = 'Console2\\console.exe';
  this.javaws = '';
  this.cmsh = ''; // no longer used, keep for compatibility (KDR)
  this.maxHealthNodes = 1000;
  this.maxRackNodes = 1000;
  this.maxAutoRefreshBurnNodes = 100;
  this.burnsort = 1;
  this.monitoringAutoFill = false;
  this.jobOnlyCgroup = false;
  this.rackTopColumns = 0;
  this.shellSingle = false;
  this.shellPrepend = true;
  this.eventCache = 256;
  this.invertedRack = true;
  this.rackGaps = false;
  this.ucsfaultsort = 1;
  this.heatmapSmooth = [250, 250];
  this.autoServiceRefresh = false;
  this.autoProcessesRefresh = false;
  this.badConnection = false;
  this.autoReconnect = true;
  this.defaultMonitoringSetup = '';
  this.delayedMonConfLoad = false;
  this.maxWaitForAll = 180;
}

cvSettings.prototype.save = function() {
  var list = new Array();
  list.push("statusRefresh = " + this.statusRefresh + ";");
  list.push("monitoringRefresh = " + this.monitoringRefresh + ";");
  list.push("eventTimespan = " + this.eventTimespan + ";");
  list.push("timespan = " + this.timespan + ";");
  list.push("intervals = " + this.intervals + ";");
  list.push("quietQuit = " + this.quietQuit + ";");
  list.push("autoOpenChanges = " + this.autoOpenChanges + ";");
  list.push("newVersionNag = " + this.newVersionNag + ";");
  list.push("showAllBrightVersions = " + this.showAllBrightVersions + ";");
  if(dock.getDirectorySeparator() == '\\') {
    list.push("console2 = '" + this.console2.replace(/\\/g, "\\\\") + "';");
  } else {
    list.push("console2 = '" + this.console2 + "';");
  }
  if(dock.getDirectorySeparator() == '\\') {
    list.push("javaws = '" + this.javaws.replace(/\\/g, "\\\\") + "';");
  } else {
    list.push("javaws = '" + this.javaws + "';");
  }
  list.push("maxHealthNodes = " + this.maxHealthNodes + ";");
  list.push("maxRackNodes = " + this.maxRackNodes + ";");
  list.push("maxAutoRefreshBurnNodes = " + this.maxAutoRefreshBurnNodes + ";");
  list.push("burnsort = " + this.burnsort + ";");
  list.push("ucsfaultsort = " + this.ucsfaultsort + ";");
  list.push("shellSingle = " + this.shellSingle + ";");
  list.push("shellPrepend = " + this.shellPrepend + ";");
  list.push("monitoringAutoFill = " + this.monitoringAutoFill + ";");
  list.push("jobOnlyCgroup = " + this.jobOnlyCgroup + ";");
  list.push("eventCache = " + this.eventCache + ";");
  list.push("invertedRack = " + this.invertedRack + ";");
  list.push("rackGaps = " + this.rackGaps + ";");
  list.push("heatmapSmooth = " + this.heatmapSmooth.toSource() + ";");
  list.push("autoServiceRefresh = " + this.autoServiceRefresh + ";");
  list.push("autoProcessesRefresh = " + this.autoProcessesRefresh + ";");
  list.push("badConnection = " + this.badConnection + ";");
  list.push("autoReconnect = " + this.autoReconnect + ";");
  list.push("delayedMonConfLoad = " + this.delayedMonConfLoad + ";");
  list.push("maxWaitForAll = " + this.maxWaitForAll + ";");
  if(dock.getDirectorySeparator() == '\\') {
    list.push("defaultMonitoringSetup = '" + this.defaultMonitoringSetup.replace(/\\/g, "\\\\") + "';");
  } else {
    list.push("defaultMonitoringSetup = '" + this.defaultMonitoringSetup + "';");
  }
  saveListToFile(BASE_PATH + "cmgui.settings", list);
}

cvSettings.prototype.load = function() {
  var list = readListFromFile(BASE_PATH + "cmgui.settings");
  for(var i = 0; i < list.length; i++) {
    try {
      eval('this.' + list[i]);
    } catch(err) {
      println("Error reading cmgui.settings: " + err);
    }
  }
  if(dock.getDirectorySeparator() == '\\') {
    var i = 0;
    while(i < this.console2.length - 1) {
      if((this.console2[i] == '\\') && (this.console2[i + 1] == '\\')) {
        this.console2 = this.console2.substr(0, i) + this.console2.substr(i + 1);
      } else {
        i++;
      }
    }
  }
}
