/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var myDialog;
var settings;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);
  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];
  settings = dock.generalSettings;

  refresh();
}

function refresh() {
  var rates = [[60, '1 minute'], [120, '2 minutes'], [300, '5 minutes'], [600, '10 minutes'], [1800, '30 minutes'], [3600, '1 hour']];
  var timeList = [[3600, '1 hour'], [43200, '12 hours'], [86400, '1 day'], [259200, '3 days'],
                  [608400, '7 days'], [2678400, '1 month'], [31526000, '1 year'], [94578000, '3 years']];
  var myTime = 3600;

  var popup = document.getElementById('eventtime').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < timeList.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', timeList[i][1]);
    item.setAttribute('time', timeList[i][0]);
    popup.appendChild(item);
    if(timeList[i][0] == settings.eventTimespan) document.getElementById('eventtime').selectedIndex = i;
  }

  var popup = document.getElementById('mainrate').firstChild;
  while(popup.firstChild) popup.removeChild(popup.firstChild);
  for(var i = 0; i < rates.length; i++) {
    var item = document.createElement('menuitem');
    item.setAttribute('label', rates[i][1]);
    item.setAttribute('time', rates[i][0]);
    popup.appendChild(item);
    if(rates[i][0] == settings.statusRefresh) document.getElementById('mainrate').selectedIndex = i;
  }
  
  document.getElementById('newVersionNag').checked = settings.newVersionNag;
  document.getElementById('showAllBrightVersions').checked = settings.showAllBrightVersions;
  document.getElementById('shellSingle').checked = settings.shellSingle;
  document.getElementById('invertedRack').checked = settings.invertedRack;
  document.getElementById('rackGaps').checked = settings.rackGaps;
  document.getElementById('autoReconnect').checked = settings.autoReconnect;
  document.getElementById('badConnection').checked = settings.badConnection;
}

function ok() {
  apply();
  cancel();
}

function apply() {
  var item = document.getElementById('mainrate').selectedItem;
  if(item) settings.statusRefresh = parseInt(item.getAttribute('time'));

  if(settings.invertedRack != document.getElementById('invertedRack').checked) {
    var clusters = dock.connectedClusters();
    for(var i = 0; i < clusters.length; i++) {
      clusters[i].updateRack = true;
    }
  }
  if(settings.rackGaps != document.getElementById('rackGaps').checked) {
    var clusters = dock.connectedClusters();
    for(var i = 0; i < clusters.length; i++) {
      clusters[i].updateRack = true;
    }
  }
  settings.newVersionNag = document.getElementById('newVersionNag').checked;
  settings.showAllBrightVersions = document.getElementById('showAllBrightVersions').checked;
  settings.shellSingle = document.getElementById('shellSingle').checked;
  settings.invertedRack = document.getElementById('invertedRack').checked;
  settings.rackGaps = document.getElementById('rackGaps').checked;
  settings.autoReconnect = document.getElementById('autoReconnect').checked;
  settings.badConnection = document.getElementById('badConnection').checked;
  settings.save();
}

function cancel() {
  close();
}
