/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var alsoRemoved = false;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh softwareimage nodes" + ' - ' + document.documentURI);
  tree = document.getElementById('tree');
  var list = current.cluster.find("SlaveNode");
  data = new Array();
  var modified = false;
  var cats = new Array();
  var categories = current.cluster.find("NodeCategory");
  var softkey = current.get('uniqueKey');
  for(var i = 0; i < categories.length; i++) {
    if(categories[i].getSoftwareImage() == softkey) {
      cats.push(categories[i].get('uniqueKey'));
    }
  }
  for(var i = 0; i < list.length; i++) {
    if(cats.find(list[i].get('category')) >= 0) {
      if(!list[i].get('toBeRemoved') || alsoRemoved) {
        data.push(createTreeItem(list[i]));
        modified = modified || list[i].get('modified') || list[i].get('toBeRemoved');
      } else {
        modified = true;
      }
    }
  }
  for(var i = data.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function getSelected() {
  return selected('list');
}

function createTreeItem(one) {
  var ip = getManagementIP(one);
  var item = new Object();
  item['key'] = one.get('uniqueKey');
  item['modified'] = one.get('modified');
  item['hostname'] = one.get('hostname');
  item['mac'] = one.get('mac');
  item['tag'] = one.get('tag');
  item['category'] = one.cluster.resolveName(one.get('category'));
  if(ip[0]) {
    item['ip'] = ip[1] + ' (' + ip[0].resolveName() + ')';
  } else {
    item['ip'] = ip[1];
  }
  var sw = one.get('ethernetSwitch');
  if(sw && sw.ethernetSwitch) {
    item['switchPort'] = one.cluster.resolveName(sw.ethernetSwitch) + ':' + sw.prt;
  } else {
    item['switchPort'] = '';
  }
  if(one.get('powerControl').toLowerCase() == 'apc') {
    item['power'] = '';
    var pdu = one.get('powerDistributionUnits');
    for(var i = 0; i < pdu.length; i++) {
      if(item['power'].length > 0) item['power'] += ', ';
      item['power'] += one.cluster.resolveName(pdu[i].pdu) + ':' + pdu[i].prt;
    }
  } else {
    item['power'] = one.get('powerControl');
  }
  return item;
}

function editObject() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a node");
  } else if(select.length > 1) {
    dock.displayError("Please select only one node");
  } else {
    current.cluster.select(select[0]);
  }
}
