/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh softwareimage tasks" + ' - ' + document.documentURI);
}

function rootShell() {
  if(current.get('uniqueKey') > dock.MAX_LOCAL_KEY) {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmproc', 'startShellInSoftwareImage', current.get('uniqueKey'), function(code, data) {
      if(code == 0) {
        if(data.length) {
          var args = [this.current.cluster.host, this.current.cluster.port, data, this.current.resolveName(), 'Root Shell'];
          var d = new dock.cvDialog("remoteshell.xul", args);
          dock.dialogs.showShell(d);
        } else {
          dock.displayInfo("The software image did not return a login token");
        }
      } else {
        dock.jsonCallError(this, code, data);
      }
      refresh();
    }, current);
  } else {
    dock.displayInfo('Commit the software image first');
  }
}
