/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

/* Insert new element into a sorted listbox */
function sortedInsertListbox(tl, selectedItem, ascending) {
  ascending = (typeof ascending == 'undefined') ? true : ascending;
  var item = tl.firstChild;
  while(item) {
    if(((item.label > selectedItem.label) && ascending) ||
       ((item.label < selectedItem.label) && !ascending)) {
      tl.insertBefore(selectedItem, item);
      return;
    }
    item = item.nextSibling;
  }
  tl.appendChild(selectedItem);
}

/* Sort a listbox */
function sortListbox(list, ascending) {
  ascending = (typeof ascending == 'undefined') ? true : ascending;
  var curitem = list.firstChild;
  if(curitem) {
    do {
      var minitem = curitem;
      var item = curitem;
      while(item) {
        if(((item.label < minitem.label) && ascending) ||
           ((item.label > minitem.label) && !ascending)) {
          minitem = item;
        }
        item = item.nextSibling;
      }
      if(minitem != curitem) {
        list.insertBefore(minitem, curitem);
      } else {
        curitem = minitem.nextSibling;
      }
    } while(curitem != list.lastChild);
  }
}

/* Insert new element into a sorted multicolumn listbox */
function sortedInsertMultiListbox(tl, selectedItem, index, ascending) {
  index = (typeof ascending == 'undefined') ? 0 : index;
  ascending = (typeof ascending == 'undefined') ? true : ascending;
  var item = tl.firstChild;
  while(item) {
    if(item.nodeName == "listitem") {
      break;
    }
    item = item.nextSibling;
  }
  while(item) {
    if(((item.label > selectedItem.label) && ascending) ||
       ((item.label < selectedItem.label) && !ascending)) {
      tl.insertBefore(selectedItem, item);
      return;
    }
    item = item.nextSibling;
  }
  tl.appendChild(selectedItem);
}

/* Sort a multicolumn listbox
 * some bug prevents it from being displayed correctly
 * internal structure is fine
 */
function sortMultiListbox(list, index, ascending) {
  index = (typeof ascending == 'undefined') ? 0 : index;
  ascending = (typeof ascending == 'undefined') ? true : ascending;
  var curitem = list.firstChild;
  while(curitem) {
    if(curitem.nodeName == "listitem") {
      break;
    }
    curitem = curitem.nextSibling;
  }

  if(curitem) {
    do {
      var minitem = curitem;
      var item = curitem;
      while(item) {
        dump(item.childNodes[index].value + " " + minitem.childNodes[index].value + "\n");
        if(((item.childNodes[index].value < minitem.childNodes[index].value) && ascending) ||
           ((item.childNodes[index].value > minitem.childNodes[index].value) && !ascending)) {
          minitem = item;
          dump("set\n");
        }
        item = item.nextSibling;
      }
      if(minitem != curitem) {
        list.insertBefore(minitem, curitem);
        dump(" " + minitem.childNodes[index].value + " " + curitem.childNodes[index].value + "\n");
        dump("before\n");
      } else {
        dump("nothing\n");
        curitem = minitem.nextSibling;
      }
      /* verify sorting */
      var x = list.firstChild;
      while(x) {
        dump(x.nodeName + "\n");
        if(x.nodeName == "listitem") {
          dump("   " + x.childNodes[0].value + " " + x.childNodes[6].value + "\n");
        }
        x = x.nextSibling;
      }
      dump("\n");
    } while(curitem != list.lastChild);
  }
}
