/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var cluster;
var overview;
var lastnames;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function getCurrentSelection() {
  return [[current], 0, ""];
}

function refresh(use) {
  var old = current;
  if(!!use) current = use;
  println("Refresh switch folder port overview" + ' - ' + document.documentURI);

  if(old != current) {
    var obj = document.getElementById('ports');
    while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
    lastnames = new Array();
  }
  cluster = current;

  var notfoundnames = lastnames;
  lastnames = new Array();
  var switches = current.find('EthernetSwitch');
  for(var i = 0; i < switches.length; i++) {
    var hostname = switches[i].get('hostname');
    if(switches[i].stateString() == 'Up') {
      dock.workerpool.getWorker(current.actualurl).call('cmgui', 'getNetSwitchOverview', [current.sessionid, switches[i].get('uniqueKey')], function(code, data) {
          if(code) dock.jsonCallError(this, code, data);
        }, switches[i]);
      lastnames.push(hostname);
      notfoundnames.remove(hostname);
    }
  }

  if(notfoundnames.length) {
    var obj = document.getElementById('ports');
    var i = 2;
    var idx = -1;
    while(i < obj.childNodes.length) {
      var child = obj.childNodes[i];
      var rname = child.getAttribute('hostname');
      if(idx < 0 || (notfoundnames[idx] != rname)) {
        idx = notfoundnames.find(rname);
      }
      if(idx >= 0) {
        obj.removeChild(child);
      } else {
        i++;
      }
    }
  }
}

function update(event) {
  println("Update switch folder port overview");
  var obj = document.getElementById('ports');
  var swi = current.find(event.switchKey);
  if(swi) {
    var before = 0;
    var name = swi.resolveName();
    var i = 2;
    while(i < obj.childNodes.length) {
      var child = obj.childNodes[i];
      var rname = child.getAttribute('hostname');
      if(rname == name) {
        obj.removeChild(child);
      } else if(rname > name) {
        before = child;
        break;
      } else {
        i++;
      }
    }
    
    var data = event.status;
    for(var i = 0; i < data.length; i++) {
      switchOverviewRow(obj, i, data[i], name, before);
    }
  } else {
    println('No such switch: ' + event.switchKey);
  }
}
