/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function switchOverviewRow(rows, index, data, hostname, before) {  
  hostname = isundefined(hostname, 0);
  before = isundefined(before, 0);
  
  var npl = 4;
  var multi = 0;
  var row = document.createElement('row');
  row.setAttribute("class", "staticdatarow");
  row.setAttribute("flex", "1");
  row.setAttribute("align", "center");
  row.setAttribute("height", "19px");
  if(index % 2 == 0) row.setAttribute("style", "background-color: #dcdcdc;");
  if(hostname) {
    row.setAttribute("hostname", hostname);
    var label = document.createElement('label');
    label.setAttribute("class", "staticdatavaluesmall");
    label.setAttribute("value", hostname);
    row.appendChild(label);
  }
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", data.prt);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", data.revision);
  row.appendChild(label);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", data.status);
  row.appendChild(label);

  var label1 = document.createElement('label');
  label1.setAttribute("class", "staticdatavaluesmall");
  var ass;
  if(data.assigned) {
    ass = cluster.find(data.assigned);
    if(!!ass) {
      ass = ass.resolveName();
    } else {
      ass = "Key not found: " + data.assigned;
    }
  } else {
    ass = "None";
  }
  label1.setAttribute("value", ass);
  row.appendChild(label1);

  var label2 = document.createElement('label');
  var det;
  if(!blank(data.detected) && isNumeric(data.detected)) {
    var det = cluster.find(parseInt(data.detected));
    if(det) {
      det = det.resolveName();
    } else {
      det = "Key not found: " + data.detected;
    }
  } else {
    multi = data.detected.split(/,\s+/);
    if(multi.length > npl) {
      var first = multi.splice(0, npl);
      det = first.join(', ');
    } else {
      det = data.detected;
      multi = 0;
    }
  }
  label2.setAttribute("value", det);
  row.appendChild(label2);
//     if((ass == det) || (ass == "None") && (det == "")) {
    label1.setAttribute("class", "staticdatavaluesmall");
    label2.setAttribute("class", "staticdatavaluesmall");
//     } else {
//       label1.setAttribute("class", "staticdatavaluesmallbad");
//       label2.setAttribute("class", "staticdatavaluesmallbad");
//     }
  var hbox = document.createElement('hbox');
  hbox.setAttribute("align", "left");
  if(data.uplink) {
    var spacer = document.createElement('spacer');
    spacer.setAttribute("width", "16px");
    hbox.appendChild(spacer);
    var image = document.createElement('image');
    image.setAttribute("src", "chrome://cmgui/content/icons/checked_16.png");
    hbox.appendChild(image);
  }
  row.appendChild(hbox);
  var label = document.createElement('label');
  label.setAttribute("class", "staticdatavaluesmall");
  label.setAttribute("value", formatKMG10(data.speed) + "b");
  row.appendChild(label);
  if(before) {
    rows.insertBefore(row, before);
  } else {
    rows.appendChild(row);
  }
  if(multi) {
    while(multi.length > 0) {
      var row = document.createElement('row');
      row.setAttribute("class", "staticdatarow");
      row.setAttribute("flex", "1");
      row.setAttribute("align", "center");
      row.setAttribute("height", "19px");
      if(index % 2 == 0) row.setAttribute("style", "background-color: #dcdcdc;");
      if(hostname) row.appendChild(document.createElement('spacer'));
      row.appendChild(document.createElement('spacer'));
      row.appendChild(document.createElement('spacer'));
      row.appendChild(document.createElement('spacer'));
      var label2 = document.createElement('label');
      var first = multi.splice(0, npl);
      var det = first.join(', ');        
      label2.setAttribute("value", det);
      label2.setAttribute("class", "staticdatavaluesmall");
      row.appendChild(label2);
      row.appendChild(document.createElement('spacer'));
      row.appendChild(document.createElement('spacer'));
      if(hostname) row.setAttribute("hostname", hostname);
      if(before) {
        rows.insertBefore(row, before);        
      } else {
        rows.appendChild(row);
      }
    }
  }
}
