/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var current;
var myDialog;
var dock;
var old;
var alsoRemoved = false;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  myDialog = dock.dialogs.list[index];

  current = myDialog.arguments.object;
  document.getElementById("monconf").setAttribute('value', myDialog.arguments.name);
  var metric = current.cluster.find(current.get('metric'));
  document.getElementById("metric").setAttribute('value', metric.resolveName());
  document.getElementById("metricParam").setAttribute('value', current.get('metricParam'));
  old = current.get('thresholds');
  refresh();

  if(myDialog.arguments.sub) {
    var args = new Object();
    args['object'] = current;
    args['threshold'] = myDialog.arguments.sub;
    args['container'] = myDialog.arguments.container;
    var d = new dock.cvDialog("editthreshold.xul", args);
    d.onOk = function() { }
    dock.dialogs.showDialog(d);
    myDialog.arguments.window.refresh();
    close();
  }
}

function refresh() {
  tree = document.getElementById('tree');
  data = new Array();
  var thresholds = current.get('thresholds');
  current.cluster.currentSubObjectType = "Threshold";
  current.cluster.currentSubObjectList = thresholds;
  for(var i = 0; i < thresholds.length; i++) {
    if(alsoRemoved || !thresholds[i].toBeRemoved) {
      data.push(createTreeItem(thresholds[i]));
    }
  }
  for(var i = thresholds.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
}

function createTreeItem(one) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['name'] = one.name;
  item['bound'] = one.bound;
  item['severity'] = one.severity;
  item['actions'] = thresActionString(current.cluster, one, 'actionConfs');
  return item;
}

function newThreshold() {
  var args = new Object();
  args['object'] = current;
  args['container'] = myDialog.arguments.container;
  args['threshold'] = 0;
  var d = new dock.cvDialog("editthreshold.xul", args);
  d.onOk = function() {
    refresh();
  }
  dock.dialogs.showDialog(d);
}
function editThreshold() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("No threshold selected");
  } else if(select.length == 1) {
    var args = new Object();
    args['object'] = current;
    args['container'] = myDialog.arguments.container;
    args['threshold'] = select[0];
    var d = new dock.cvDialog("editthreshold.xul", args);
    d.onOk = function() {
      refresh();
    }
    dock.dialogs.showDialog(d);
  } else {
    dock.displayError("Please select only one threshold");
  }
}
function removeThreshold() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("No threshold selected");
  } else {
    var args = new Object();
    args['question'] = "Are you sure you want to remove these thresholds?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      for(var i = 0; i < select.length; i++) current.deleteSubObjectFromKey('thresholds', select[i]);
      myDialog.arguments.container.set('modified', true);
      refresh();
    }
    dock.dialogs.showDialog(d);
  }
}

function saveThreshold() {
  if(myDialog.onOk) myDialog.onOk();
  close();
}

function revertThreshold() {
  current.set('thresholds', old);
  refresh();
}
