/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var globalCurrent;
var current;
var currentUCS
var bootOrderCache = new Object();
var currentBootOrder = new Object();

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) {
    globalCurrent = use;
  }
  println("Refresh UCS bios settings" + ' - ' + document.documentURI);
  
  document.getElementById('revert').setAttribute('disabled', globalCurrent.get('uniqueKey') < dock.MAX_LOCAL_KEY);
  document.getElementById('save').setAttribute('disabled', !globalCurrent.get('modified'));
  
  currentUCS = globalCurrent.getUCS();
  if(currentUCS && currentUCS.biosSettings) {
    currentBootOrder = currentUCS.lsbootDef;
    currentUCS = new dock.cvObject(globalCurrent.cluster, currentUCS, globalCurrent);
    current = new dock.cvObject(globalCurrent.cluster, currentUCS.object.biosSettings, currentUCS);
    kenum("biosVfAdjacentCacheLinePrefetch", ['disabled', 'enabled', 'platform-default'], "vpAdjacentCacheLinePrefetch");
    kenum("biosVfAltitude", ['auto', '300-m', '900-m', '1500-m', '3000-m', 'platform-default'], "vpAltitude");
    kenum("biosVfASPMSupport", ['Disabled', 'Force L0s', 'Auto', 'platform-default'], "vpASPMSupport");
    kenum("biosVfConsoleRedirection", ['9600', '19200', '38400', '57600', '115200', 'platform-default'], "vpBaudRate");
    kenum("biosVfConsoleRedirection", ['platform-default', 'disabled', 'com-0', 'com-1'], "vpConsoleRedirection");
    kenum("biosVfConsoleRedirection", ['platform-default', 'none', 'rts-cts'], "vpFlowControl");
    kenum("biosVfConsoleRedirection", ['platform-default', 'VT100', 'LINUX', 'XTERMR6', 'SCO', 'ESCN', 'VT400'], "vpPuttyKeyPad");
    kenum("biosVfConsoleRedirection", ['platform-default', 'Always Enable', 'Bootloader'], "vpRedirectionAfterPOST");
    kenum("biosVfConsoleRedirection", ['platform-default', 'pc-ansi', 'vt100', 'vt100-plus', 'vt-utf8'], "vpTerminalType");
    kenum("biosVfCoreMultiProcessing", ['all', '1', '2', '4', '6', 'platform-default'], "vpCoreMultiProcessing");
    kenum("biosVfCPUEnergyPerformance", ['performance', 'balanced-performance', 'balanced-energy', 'energy-efficient', 'platform-default'], "vpCPUEnergyPerformance");
    kenum("biosVfCPUFrequencyFloor", ['disabled', 'enabled', 'platform-default'], "vpCPUFrequencyFloor");
    kenum("biosVfCPUPerformance", ['enterprise', 'high-throughput', 'hpc', 'custom', 'platform-default'], "vpCPUPerformance");
    kenum("biosVfCPUPowerManagement", ['custom', 'disabled', 'energy-efficient', 'platform-default'], "vpCPUPowerManagement");
    kenum("biosVfDCUPrefetch", ['disabled', 'enabled', 'platform-default'], "vpIPPrefetch");
    kenum("biosVfDCUPrefetch", ['disabled', 'enabled', 'platform-default'], "vpStreamerPrefetch");
    kenum("biosVfDemandScrub", ['disabled', 'enabled', 'platform-default'], "vpDemandScrub");
    kenum("biosVfDirectCacheAccess", ['disabled', 'enabled', 'platform-default'], "vpDirectCacheAccess");
    kenum("biosVfDRAMClockThrottling", ['Balanced', 'Performance', 'Energy Efficient', 'platform-default'], "vpDRAMClockThrottling");
    kenum("biosVfDramRefreshRate", ['platform-default', '1x', '2x', '3x', '4x'], "vpDramRefreshRate");
    kenum("biosVfEnhancedIntelSpeedStepTech", ['disabled', 'platform-default', 'enabled'], "vpEnhancedIntelSpeedStepTech");
    kenum("biosVfExecuteDisableBit", ['disabled', 'enabled', 'platform-default'], "vpExecuteDisableBit");
    kenum("biosVfFRB2Enable", ['disabled', 'enabled', 'platform-default'], "vpFRB2Enable");
    kenum("biosVfHardwarePrefetch", ['disabled', 'enabled', 'platform-default'], "vpHardwarePrefetch");
    kenum("biosVfIntelHyperThreadingTech", ['platform-default', 'disabled', 'enabled'], "vpIntelHyperThreadingTech");
    kenum("biosVfIntelTurboBoostTech", ['disabled', 'enabled', 'platform-default'], "vpIntelTurboBoostTech");
    kenum("biosVfIntelVirtualizationTechnology", ['disabled', 'enabled', 'platform-default'], "vpIntelVirtualizationTechnology");
    kenum("biosVfIntelVTForDirectedIO", ['disabled', 'enabled', 'platform-default'], "vpIntelVTDATSSupport");
    kenum("biosVfIntelVTForDirectedIO", ['disabled', 'enabled', 'platform-default'], "vpIntelVTDCoherencySupport");
    kenum("biosVfIntelVTForDirectedIO", ['disabled', 'enabled', 'platform-default'], "vpIntelVTForDirectedIO");
    kenum("biosVfLegacyUSBSupport", ['auto', 'disabled', 'enabled', 'platform-default'], "vpLegacyUSBSupport");
    kenum("biosVfLOMPortOptionROM", ['Disabled', 'Enabled', 'UEFI Only', 'Legacy Only', 'platform-default'], "vpLOMPort0State");
    kenum("biosVfLOMPortOptionROM", ['Disabled', 'Enabled', 'UEFI Only', 'Legacy Only', 'platform-default'], "vpLOMPort1State");
    kenum("biosVfLOMPortOptionROM", ['Disabled', 'Enabled', 'platform-default'], "vpLOMPortsAllState");
    kenum("biosVfLvDIMMSupport", ['power-saving-mode', 'performance-mode', 'platform-default'], "vpLvDDRMode");
    kenum("biosVfMemoryInterleave", ['auto', '1-way', '2-way', '3-way', '4-way', 'platform-default'], "vpChannelInterLeave");
    kenum("biosVfMemoryInterleave", ['auto', '1-way', '2-way', '4-way', '8-way', 'platform-default'], "vpRankInterLeave");
    kenum("biosVfMemoryMappedIOAbove4GB", ['platform-default', 'disabled', 'enabled'], "vpMemoryMappedIOAbove4GB");
    kenum("biosVfNUMAOptimized", ['disabled', 'enabled', 'platform-default'], "vpNUMAOptimized");
    kenum("biosVfOnboardStorage", ['disabled', 'enabled', 'platform-default'], "vpOnboardSCUStorageSupport");
    kenum("biosVfOnboardStorageSWStack", ['LSI SW RAID', 'Intel RSTe', 'platform-default'], "vpOnboardSCUStorageSWStack");
    kenum("biosVfOSBootWatchdogTimer", ['disabled', 'enabled', 'platform-default'], "vpOSBootWatchdogTimer");
    kenum("biosVfOSBootWatchdogTimerPolicy", ['power-off', 'reset', 'do-nothing', 'platform-default'], "vpOSBootWatchdogTimerPolicy");
    kenum("biosVfOSBootWatchdogTimerTimeout", ['5-minutes', '10-minutes', '15-minutes', '20-minutes', 'platform-default'], "vpOSBootWatchdogTimerTimeout");
    kenum("biosVfPatrolScrub", ['disabled', 'enabled', 'platform-default'], "vpPatrolScrub");
    kenum("biosVfPCIOptionROMs", ['Disabled', 'Enabled', 'UEFI Only', 'Legacy Only', 'platform-default'], "vpPCIOptionROMs");
    kenum("biosVfPCISlotOptionROMEnable", ['GEN1', 'GEN2', 'GEN3', 'Disabled', 'platform-default'], "vpSlot1LinkSpeed");
    kenum("biosVfPCISlotOptionROMEnable", ['Disabled', 'Enabled', 'UEFI Only', 'Legacy Only', 'platform-default'], "vpSlot1State");
    kenum("biosVfPCISlotOptionROMEnable", ['GEN1', 'GEN2', 'GEN3', 'Disabled', 'platform-default'], "vpSlot2LinkSpeed");
    kenum("biosVfPCISlotOptionROMEnable", ['Disabled', 'Enabled', 'UEFI Only', 'Legacy Only', 'platform-default'], "vpSlot2State");
    kenum("biosVfPCISlotOptionROMEnable", ['Disabled', 'Enabled', 'UEFI Only', 'Legacy Only', 'platform-default'], "vpSlotMezzState");
    kenum("biosVfProcessorC1E", ['disabled', 'enabled', 'platform-default'], "vpProcessorC1E");
    kenum("biosVfProcessorC6Report", ['disabled', 'enabled', 'platform-default'], "vpProcessorC6Report");
    kenum("biosVfPStateCoordType", ['platform-default', 'HW ALL', 'SW ALL', 'SW ANY'], "vpPStateCoordType");
    kenum("biosVfQPIConfig", ['auto', '6.4-gt/s', '7.2-gt/s', '8.0-gt/s', 'platform-default'], "vpQPILinkFrequency");
    kenum("biosVfSelectMemoryRASConfiguration", ['lockstep', 'maximum-performance', 'mirroring', 'platform-default'], "vpSelectMemoryRASConfiguration");
    kenum("biosVfTPMSupport", ['disabled', 'enabled', 'platform-default'], "vpTPMSupport");
    kenum("biosVfUCSMBootOrderRuleControl", ['Strict', 'Loose', 'platform-default'], "vpUCSMBootOrderRule");
    kenum("biosVfUSBEmulation", ['disabled', 'enabled', 'platform-default'], "vpUSBEmul6064");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpAllUsbDevices");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpUsbPortFront");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpUsbPortInternal");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpUsbPortKVM");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpUsbPortRear");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpUsbPortSDCard");
    kenum("biosVfUSBPortsConfig", ['disabled', 'enabled', 'platform-default'], "vpUsbPortVMedia");
    kenum("biosVfVgaPriority", ['Onboard', 'Offboard', 'Onboard VGA Disabled', 'platform-default'], "vpVgaPriority");    
 
    /* Populate bios boot order */ 
    for (var i = 0; i < currentBootOrder.lsbootLan.length; i++) {
      //bootOrderCache[currentBootOrder.lsbootStorage[i].order] = "PXE";
      bootOrderCache[currentBootOrder.lsbootLan[i].order] = currentBootOrder.lsbootLan[i].prot;
    }
    for (var i = 0; i < currentBootOrder.lsbootVirtualMedia.length; i++) {
      bootOrderCache[currentBootOrder.lsbootVirtualMedia[i].order] = currentBootOrder.lsbootVirtualMedia[i].type;
    }
    for (var i = 0; i < currentBootOrder.lsbootStorage.length; i++) {
      //bootOrderCache[currentBootOrder.lsbootStorage[i].order] = "HDD";
      bootOrderCache[currentBootOrder.lsbootStorage[i].order] = currentBootOrder.lsbootStorage[i].type;
    }
    for (var i = 0; i < currentBootOrder.lsbootEfi.length; i++) {
      //bootOrderCache[currentBootOrder.lsbootStorage[i].order] = "EFI";
      bootOrderCache[currentBootOrder.lsbootEfi[i].order] = currentBootOrder.lsbootEfi[i].type;
    }
    var ucsbiosbootorderrows = document.getElementById('ucsbiosbootorder');
    while(ucsbiosbootorderrows.firstChild) ucsbiosbootorderrows.removeChild(ucsbiosbootorderrows.firstChild);   
    for ( var j in bootOrderCache ) {
      var row = document.createElement("row");
      row.setAttribute('align', 'center');
      var shadowlabel = document.createElement('shadowlabel');
      shadowlabel.setAttribute('width', '20px');
      shadowlabel.setAttribute('value', j);
      var menulist = document.createElement('menulist');
      var menupopup = document.createElement('menupopup');
      menulist.setAttribute('selectedIndex', 0); 
      menulist.setAttribute('id', 'bootorderlist_' + j); 
      menupopup.setAttribute('id', 'bootorder_' + j); 
      for ( var k in bootOrderCache ) {
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute('label', bootOrderCache[k]);
        menuitem.setAttribute('id', 'bootdevice_' + bootOrderCache[k] + '_' + j);
        menuitem.setAttribute('oncommand', "updateBootOrder(this);");
        menupopup.appendChild(menuitem);
      }
      menulist.appendChild(menupopup);
      row.appendChild(shadowlabel);
      row.appendChild(menulist);
      ucsbiosbootorderrows.appendChild(row);
      menulist.selectedIndex = parseInt(j - 1); 
    }
  }
}

function updateBootOrder(elem) {
  var current = elem.id.split('_')[2];
  var newsel = elem.id.split('_')[1];
  var prevsel = bootOrderCache[current];
  var replace;
  var modified = false;
  if ( newsel != prevsel ) {
    for ( var i in bootOrderCache ) {
      if ( bootOrderCache[i] == newsel ) {
        replace = i;
        modified = true;
        break;
      }
    }
    bootOrderCache[replace] = prevsel;
    bootOrderCache[current] = newsel;
    for ( var j in bootOrderCache ) {
      var orderelems = document.getElementById('bootorder_' + j).childNodes;
      for ( var k = 0; k < orderelems.length; k++) {
        var descr = orderelems[k].id.split('_')[1];
        if ( descr == bootOrderCache[j] ) {
          document.getElementById('bootorderlist_' + j).selectedIndex = k;
        }
      }
    }
    if (modified) {
      for ( var x in bootOrderCache ) {
        for ( var y = 0; y < currentBootOrder.length; y++ ) {
          if ( (currentBootOrder[y].type == bootOrderCache[x]) || (currentBootOrder[y].prot == bootOrderCache[x]) ) {
            currentBootOrder[y].order = x;
            currentBootOrder[y].modified = true;
            break;
          }
        }
      }
      var save = document.getElementById('save');
      if(!save) save = document.parent.getElementById('save');
      if(save) save.removeAttribute('disabled');
      currentUCS.set('modified', modified);
      globalCurrent.set('modified', modified);
    }
  }
}
