/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var overview;
var led = 0;
var leds = 0;
var ledTimer = 0;
var ledCounter = 0;

var goodColors = ['green', 'blue', 'red', 'amber'];

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh UCS" + ' - ' + document.documentURI);

  current.isIdentified(createObjectCallback(document, updateIndicator));
  
  var configUCS = current.getUCS(false);
  var liveUCS = current.getLiveUCS();
  if(liveUCS) {
    refreshLive();
    refreshAll();
  } else {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmdevice', 'getLiveUCS', [[current.get('uniqueKey')], false], function(code, data) {
        if(code == 0) {
          setCallbackResult(data);
        } else {
          dock.jsonCallError(this, code, data);
        }
      }, current);
    if(configUCS) refreshAll();
  }
}

function setCallbackResult(data) {
  if(isArray(data) && data.length) {
    current.ucsInfo = data[0];
    refreshLive();
    var configUCS = current.getUCS(false);
    if(!configUCS) refreshAll();
  }
}

function stop() {
  println("Stop ucs settings");
  if(ledTimer) window.clearTimeout(ledTimer);
  ledCounter = 0;
}


function refreshLive() {
  println("++ UCS refreshLive");
  overview = current.ucsInfo.ucsStatus;
  
  overviewValue('model');
  overviewValue('vendor');
  overviewValue('serial');
  overviewValue('uuid');  
  overviewValue('vics', current.ucsInfo.vicAdapterSettings.length);
  overviewValue('fcs', current.ucsInfo.fcAdapterSettings.length);

  var firmware = current.ucsInfo.firmwareRunning;
  for(var i = 0; i < firmware.length; i++) {
    var obj = document.getElementById('firmware' + firmware[i].type);
    if(obj) obj.setAttribute('value', firmware[i].version);
  }
  
  stop();
  led = overview.equipmentLocatorLed;
  leds = overview.equipmentIndicatorLed;  
  blinking();
}

function updateIndicator() {
  var obj = document.getElementById('locator-led');
  if(obj) {
    var color;
    switch(current.identified) {
      case(0) : color = 'blue'; break;
      default : color = 'blank';
    }
    obj.setAttribute("src", "./skin/image/LED_" + color + ".png");
  }
}

function blinking() {
  var needTimer = false;
//   if(led) {
//     var obj = document.getElementById('locator-led');
//     if(obj) {
//       var color = led.color;
//       obj.setAttribute("tooltiptext", color + ' ' + led.operState);
//       if(goodColors.find(color) >= 0) {
//         if(led.operState == 'blinking') {
//           needTimer = true;
//           if(ledCounter % 2 == 1) color = 'blank';
//         }
//         if(ledCounter == 0 || led.operState == 'blinking') obj.setAttribute("src", "./skin/image/LED_" + color + ".png");
//       }
//     }
//   }
  if(leds) {
    for(var i = 0; i < leds.length; i++) {
      var name = leds[i].name;
      var obj = document.getElementById(name);
      if(obj) {
        var color = leds[i].color;
        obj.setAttribute("tooltiptext", color + ' ' + leds[i].operState);
        if(goodColors.find(color) >= 0) {
          if(leds[i].operState == 'blinking') {
            needTimer = true;
            if(ledCounter % 2 == 1) color = 'blank';
          } else if(ledCounter) {
            continue;
          }
          obj.setAttribute("src", "./skin/image/LED_" + color + ".png");
        }
      }
    }
  }
  ledCounter++;
  if(needTimer) ledTimer = window.setTimeout('blinking();', 1000);
}

function refreshAll() {
  println("++ UCS refreshAll");
  for(var i = 0; i < window.frames.length; i++) {
    if(!!window.frames[i].refresh) {
      window.frames[i].refresh(current);
    }
  }
}

