/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var MINUSONE = 4294967295;

function updateHealth(srwi, showSeverity, hostname) {
  showSeverity = isundefined(showSeverity, true);
  health = srwi;
  if(dock.DEMO) {
    // TODO
  }
  if(typeof(hostname) != 'undefined') {
    var obj = document.getElementById('healthstatustitle');
    obj.setAttribute('value', 'Health Status for ' + hostname);
  }

  var list = new Array();
  var obj = document.getElementById('healthstatusrows');
  while(obj.childNodes.length > 2) obj.removeChild(obj.lastChild);
  for(var i = 0; i < srwi.length; i++) {
    if(srwi[i].thresholdId > 0) {
      var one = current.cluster.find(srwi[i].metricId);
      if(one) {
        var name = one.resolveName();
        if(srwi[i].metricParam.length > 0) name += ':' + srwi[i].metricParam;
        var severity = srwi[i].severity;
        var value;
        if(one.get('baseType') == 'HealthCheck') {
          var conf = current.cluster.getMonHealthConf(current.get('uniqueKey'), srwi[i].thresholdId);
//           if(!conf) continue;
          if(srwi[i].rate < 0.5) {
            value = 'PASS';
          } else if(srwi[i].rate > 1.5) {
            value = 'FAIL';
            if((severity >= MINUSONE) && conf) severity = conf.failSeverity;
          } else if(kisNaN(srwi[i].rate)) {
            value = 'no data';
          } else {
            value = 'UNKNOWN';
            if(conf) severity = conf.unknownSeverity;
          }
        } else {
          var conf = current.cluster.getThreshold(current.get('uniqueKey'), srwi[i].thresholdId);
          value = srwi[i].rate;
          if(conf) {
            if((severity >= MINUSONE) && conf) severity = conf.severity;
            if(conf.isUpper) {
              value += ' > ';
            } else {
              value += ' < ';
            }
            value += conf.bound;
          } else {
            println("Unknown threshold " + current.resolveName(), srwi[i].thresholdId);
          }
        }
        if(severity >= MINUSONE) severity = 0;
        var date = new Date();
        date.setTime(srwi[i].timeStamp * 1000);
        list.push([-severity, date.format("dd/mmm/yyyy HH:MM:ss"), name, value, srwi[i].infoMessage, one.get('notes')]);
      }
    }
  }
  list = list.sort();
  for(var i = 0; i < list.length; i++) {
    healthRows(obj, list[i], showSeverity);
  }

  function healthRows(obj, data, showSeverity) {
    var MAX_INFO_LEN = 96;
    var info = data[4];
    for(var i = 0; i < 10; i++) {
      var row = document.createElement('row');
      row.setAttribute("class", "staticdatarow");
      row.setAttribute("flex", "1");
      row.setAttribute("align", "center");
      row.setAttribute("height", "19px");
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      if(i == 0) label.setAttribute("value", data[1]);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      if(i == 0) {
        label.setAttribute("value", data[2]);
        if(data[5].length > 0) label.setAttribute("tooltiptext", data[5]);
      }
      row.appendChild(label);
      if(showSeverity) {
        var label = document.createElement('label');
        label.setAttribute("class", "staticdatavaluesmall");
        if(i == 0) label.setAttribute("value", -data[0]);
        row.appendChild(label);
      }
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      if(i == 0) label.setAttribute("value", data[3]);
      row.appendChild(label);
      var label = document.createElement('label');
      label.setAttribute("class", "staticdatavaluesmall");
      row.appendChild(label);
      obj.appendChild(row);
      var k = info.indexOf("\n");
      if((k > 0) && (k <= MAX_INFO_LEN)) {
        label.setAttribute("value", info.substr(0, k));
        info = info.substr(k + 1);
      } else {
        if(info.length <= MAX_INFO_LEN) {
          label.setAttribute("value", info);
          break;
        } else {
          var j = info.lastIndexOf(' ', MAX_INFO_LEN);
          if(j >= MAX_INFO_LEN * 0.8) {
            label.setAttribute("value", info.substr(0, j));
            info = info.substr(j + 1);
          } else {
            label.setAttribute("value", info.substr(0, MAX_INFO_LEN));
            info = info.substr(MAX_INFO_LEN);
          }
        }
      }
    }
  }
}

function updatePowerState(status) {
  var image;
  if(status.name) {
    image = status.name;
  } else {
    image = status.powerDistributionUnit + '_' + status.prt;
  }
  switch(status.state) {
  case('ON'):
    window.setTimeout('setIcon("' + image + '", "./skin/image/LED_green.png", true);', 100);
    break;
  case('OFF'):
    window.setTimeout('setIcon("' + image + '", "./skin/image/LED_red.png", true);', 100);
    break;
  default:
  }
}

function setIcon(name, icon, retry) {
  var image = document.getElementById(name);
  if(image) {
    image.setAttribute('src', icon);  
  } else if(retry) {
    window.setTimeout('setIcon("' + name + '", "' + icon + '", false);', 1000);
  } else {
    println('Unable to set power icon ' + name + ' : ' + icon);
  }
}
