/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

function onLoad() {
  dock = getDock();
  println("Window initialized: " + this.name);

  var s = this.name.indexOf('[');
  var e = this.name.indexOf(']');
  var index = this.name.substr(s + 1, e - s - 1);
  var myDialog = dock.dialogs.list[index];
  var error = myDialog.arguments.validate;

  current = myDialog.arguments.object;

  setDialogTitle('Validation of ' + current.resolveName())

  tree = document.getElementById('tree');
  data = new Array();
  var warningsOnly = true;
  for(var i = 0; i < error.length; i++) {
    warningsOnly = warningsOnly && (error[i].warning >= 0);
    var lines = longLineSplit(error[i].msg, 80); // TODO: based on width
    var k = lines.length;
    while(k > 0) {
      if(lines[k - 1].length > 0) break;
      k--;
    }
    var first = true;
    for(var j = 0; j < k; j++) {
      data.push(createTreeItem(error[i], lines[j], first));
      first = false;
    }
  }
  if(error.length == 0) {
    var one = new dock.cvValidation();
    one.code = -1;
    one.field = 'None';
    one.msg = 'Internal error, contact your Cluster Manager reseller';
    data.push(createTreeItem(one));
    warningsOnly = false;
  }

  loadTable();
  
  var revert = document.getElementById('revert');
  if(warningsOnly || (current.get('uniqueKey') < dock.MAX_LOCAL_KEY)) {
    revert.setAttribute('hidden', true);
  } else {
    revert.removeAttribute('hidden');
  }
}

function revert() {
  current.refresh();
  close();
}

function createTreeItem(one, line, first) {
  var item = new Object();
  item['key'] = one.uniqueKey;
  item['code'] = one.code;
  item['parameter'] = one.field;
  if(first) {
    if(one.warning >= 0) {
      line = 'Warning: ' + line;
    } else {
      line = 'Error: ' + line;
    }
  } else {
    line = ' . . . . ' + line;
  }
  item['message'] = line;
  return item;
}
