/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

function terminate() {
  var args = new Object();
  args['question'] = "Are you sure you want to terminate this node?";
  var d = new dock.cvDialog("question.xul", args);
  d.onOk = function() {
    dock.workerpool.getWorker(current.cluster.actualurl).call('cmopenstack', 'openStackApiEntityOperation', [[0], [getInstanceId()], 'server', 'serverTerminate', []], function(code, data) {
      if(code == 0) {
        // TODO
      } else {
        dock.jsonCallError(this, code, data);
      }
    }, current);
  }
  dock.dialogs.showDialog(d);
}

function getInstanceId() {
  var settings = current.get('virtualNodeSettings');
  if(settings) return settings.instanceID;
  return "";
}

function viewConsole() {
  var args = new Object();
  args['UUID'] = getInstanceId();
  args['cluster'] = current.cluster;
  var d = new dock.cvDialog("chrome://cmgui/content/openstack/server/viewConsoleServer.xul", args);
  dock.dialogs.showDialog(d);
}

function viewLog() {
  var args = new Object();
  args['UUID'] = getInstanceId();
  args['cluster'] = current.cluster;
  var d = new dock.cvDialog("chrome://cmgui/content/openstack/server/viewLogServer.xul", args);
  dock.dialogs.showDialog(d);
}

window.addEventListener('load', function() {
  this.originalRefresh = refresh;
  refresh = function(use) {
    this.originalRefresh(use);
    if(getInstanceId()==='') {
      document.getElementById('viewConsoleOpenStack').setAttribute('disabled', 'true');
      document.getElementById('viewLogOpenStack').setAttribute('disabled', 'true');
      document.getElementById('viewTerminateOpenStack').setAttribute('disabled', 'true');
    } else {
      document.getElementById('viewConsoleOpenStack').removeAttribute('disabled');
      document.getElementById('viewLogOpenStack').removeAttribute('disabled');
      document.getElementById('viewTerminateOpenStack').removeAttribute('disabled');
    }
  };
});
