/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;

var fieldname = 'members';
var displayInTree = true;
var subtype = 'PhysicalNode';
var singular = 'node';
var plural = 'nodes';
var nodeSelectionProperties = [['','', false],
            ['hostname', 'hostname', false],
            ['MAC', 'mac', false],
            ['tag', 'tag', false],
            ['category', 'category', true],
            ['installmode', 'installMode', false],
            ['rack', 'rack.rack', true],
            ['position', 'rack.position', false]];
var belongs = '0';
var noloop = 'true';
var extraName = 'displayPrimary(key)';
var extraEvalOnAdd = '';
var extraEvalOnRemove = '';

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  if(!!use) current = use;
  println("Refresh node settings" + ' - ' + document.documentURI);
  document.getElementById('revert').setAttribute('disabled', current.object.uniqueKey < dock.MAX_LOCAL_KEY);
  check('disableVSMPNode');
  deviceselect();

  var settings = current.get('vsmpSettings');
  if(settings.childType == 'VScaleMPSettings') {
    number('vsmpSettings', 0, 100, '%', 0, 'systemMemory');
    number('vsmpSettings', 2, 256, '', 0, 'minimalBoards');
    text('vsmpSettings', '', 'bootDevice');
    text('vsmpSettings', '', 'consoleRedirection');
    text('vsmpSettings', '', 'systemBoards');

    kenum('vsmpSettings', [['YES', 'Yes'], ['NO', 'No'], ['RESTART', 'Restart']], 'autoBootOnMinBoards');
//     check('vsmpSettings', false, 'hyperThreading');
//     check('vsmpSettings', false, 'extendedAcpi');
//     check('vsmpSettings', false, 'failureAutoRestart');
//     check('vsmpSettings', false, 'updateBackplane');
    kenum('vsmpSettings', [[true, 'Enabled'], [false, 'Disabled']], 'hyperThreading');
    kenum('vsmpSettings', [[true, 'Enabled'], [false, 'Disabled']], 'extendedAcpi');
    kenum('vsmpSettings', [[true, 'Yes'], [false, 'No']], 'failureAutoRestart');
    kenum('vsmpSettings', [[true, 'Yes'], [false, 'No']], 'updateBackplane');
  }
}

function dblClickRight(event) {
  var old = current.get('primaryNode');
  var key = parseInt(event.target.getAttribute('key'));
  if(old != key) {
    current.set('primaryNode', key);
    if(dock.SUBTREE) {
      old = current.cluster.find(old);
      if(old) {
        for(var i = 0; i < old.treeitemChild.length; i++) {
          var item = old.treeitemChild[i].parentNode.parentNode;
          if(item.parentNode == current.branch) {
            old.treeitemChild[i].setAttribute('label', ' ' + old.resolveName());
            break;
          }
        }
      }
      var obj = current.cluster.find(key);
      for(var i = 0; i < obj.treeitemChild.length; i++) {
        var item = obj.treeitemChild[i].parentNode.parentNode;
        if(item.parentNode == current.branch) {
          obj.treeitemChild[i].setAttribute('label', ' ' + obj.resolveName() + ' (primary)');
          break;
        }
      }
    }
    refresh();
  }
}

function displayPrimary(key) {
  if(key == current.get('primaryNode')) {
    var members = current.get('members');
    if(members.find(key) >= 0) {
      return ' (primary)';
    }
  }
  return '';
}
