/*
 * Copyright (c) 2004-2015 Bright Computing Holding BV. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Bright Computing Holding BV ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Bright Computing Holding BV or its subsidiaries.
 */

var dock;
var current;
var timer = 0;

function onLoad() {
  dock = getDock();
  println('.Load: ' + document.title + ' - ' + document.documentURI);
}

function refresh(use) {
  var wi = false;
  if(!!use) {
    if(typeof(use) == 'boolean') {
      wi = use;
    } else {
      current = use;
    }
  }
  println("Refresh job folder overview" + ' - ' + document.documentURI);

  if(wi) dock.waitIcon();
  dock.workerpool.getWorker(current.actualurl).call('cmjob', 'getJobs', '', function(code, data) {
      if(code == 0) {
        setCallbackResult(data);
      } else {
        dock.jsonCallError(this, code, data);
      }
      if(wi) dock.unwaitIcon();
    }, current);

  if(timer) window.clearTimeout(timer);
  timer = window.setTimeout('refresh();', dock.generalSettings.statusRefresh * 10000);
}

function setCallbackResult(value) {
  var list = value;

  // TEST
//   var job = new dock.cvSGEJob();
//   job.jobID = 'job.0001';
//   nodes = ['node001', 'node003'];
//   job.setNodes(nodes.length, nodes);
//   list.push(job);  
  // TEST
  
  tree = document.getElementById('tree');
  data = new Array();
  for(var i = 0; i < list.length; i++) {
    data.push(createTreeItem(list[i]));
  }
  if(dock.DEMO || dock.CLOUDDEMO) {
    var one = new dock.cvSGEJob();
//     one.username = "alex";
//     one.jobID = "gromacs";
//     one.queue = "long.q";
//     one.status = "running";
//     data.push(createTreeItem(one));
//     data.push(createTreeItem(one));
//     data.push(createTreeItem(one));
//     one.status = "queued";
//     data.push(createTreeItem(one));
//     one.queue = "medium.local";
//     data.push(createTreeItem(one));

    one.username = "kate";
    one.queue = "long.cloud";
    one.jobID = "modflow";
    one.status = "running";
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    one.status = "queued";
    data.push(createTreeItem(one));

    one.username = "kate";
    one.queue = "short.mixed";
    one.jobID = "modflow";
    one.status = "running";
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    one.status = "queued";
    data.push(createTreeItem(one));
    
    one.username = "matthew";
    one.jobID = "xhpl";
    one.queue = "short.local";
    one.status = "running";
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));

//     one.username = "jodi";
//     one.jobID = "fluent";
//     one.queue = "medium.local";
//     one.status = "running";
//     data.push(createTreeItem(one));
//     one.status = "queued";
//     data.push(createTreeItem(one));
//     data.push(createTreeItem(one));
//     data.push(createTreeItem(one));

    one.username = "jodi";
    one.jobID = "myparallelapp";
    one.queue = "medium.local";
    one.status = "running";
    data.push(createTreeItem(one));
    one.status = "queued";

/*    one.username = "james";
    one.jobID = "magmasteel";
    one.queue = "medium.mixed";
    one.status = "running";
    data.push(createTreeItem(one));
    one.status = "queued";
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));*/
    
    one.username = "alice";
    one.queue = "serial.cloud";
    one.jobID = "serial1";
    one.status = "running";
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    one.queue = "serial.mixed";
    data.push(createTreeItem(one));
    data.push(createTreeItem(one));
    one.status = "queued";
    data.push(createTreeItem(one));
    
  }

  for(var i = list.length + list.length; i < MINTREEITEMS; i++) data.push(blankTreeItem());
  var select = selected('list');
  loadTable();
  setSelected('list', select);
  
  current.processJobCache(list);
}


function createTreeItem(one) {
  var item = new Object();
  item['scheduler'] = one.childType.replace('Job','').toLowerCase();
  item['key'] = item['scheduler'] + '|' + one.jobID;
  item['name'] = one.jobID;
  item['user'] = one.username;
  item['queue'] = one.queue;
  item['status'] = one.status;
  var nodes = one.nodes;
  item['nodes'] = commaListToDotFormat(nodes, new RegExp("\\..*$"));
  return item;
}

function stop() {
  if(timer) window.clearTimeout(timer);
}

function showJob() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else if(select.length > 1) {
    dock.displayError("Please select only one job");
  } else {
    var x = select[0].split('|');
    dock.workerpool.getWorker(current.actualurl).call('cmjob', 'getJob', x, function(code, data) {
        if(code == 0) {
          var args = new Object();
          args['cluster'] = current;
          args['job'] = data;
          if(isObject(args['job']) && (args['job'] != null)) {
            var d = new dock.cvDialog("showjob.xul", args);
            dock.dialogs.showDialog(d);
          } else {
            dock.displayInfo("Job no longer found: '" + x[0] + "' '" + x[1] + "'");
            refresh();
          }
        } else {
          dock.jsonCallError(this, code, data);
        }
        refresh();
      }, current);
  }
}

function removeJob() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else {
    var args = new Object();
    args['question'] = "Are you sure you want to remove these jobs?";
    var d = new dock.cvDialog("question.xul", args);
    d.onOk = function() {
      dock.waitIcon();
      var work = {'cluster': current, 'todo': select.length, 'firsterror': true};
      for(var i = 0; i < select.length; i++) {
        var x = select[i].split('|');
        dock.workerpool.getWorker(current.actualurl).call('cmjob', 'removeJob', x, function(code, data) {
            if(code != 0 && this.current.firsterror) {
              this.current.firsterror = false;
              dock.jsonCallError(this, code, data);
            }
            this.current.todo--;
            if(this.current.todo <= 0) {              
              refresh();
              dock.unwaitIcon();
            }
          }, work);
      }
    }
    dock.dialogs.showDialog(d);
  }
}


function holdJob() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else {
    dock.waitIcon();
    var work = {'cluster': current, 'todo': select.length, 'firsterror': true};
    for(var i = 0; i < select.length; i++) {
      var x = select[i].split('|');
      dock.workerpool.getWorker(current.actualurl).call('cmjob', 'holdJob', x, function(code, data) {
          if(code != 0 && this.current.firsterror) {
            this.current.firsterror = false;
            dock.jsonCallError(this, code, data);
          }
          this.current.todo--;
          if(this.current.todo <= 0) {              
            refresh();
            dock.unwaitIcon();
          }
        }, work);
    }
  }
}

function releaseJob() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else {
    dock.waitIcon();
    var work = {'cluster': current, 'todo': select.length, 'firsterror': true};
    for(var i = 0; i < select.length; i++) {
      var x = select[i].split('|');
      dock.workerpool.getWorker(current.actualurl).call('cmjob', 'releaseJob', x, function(code, data) {
          if(code != 0 && this.current.firsterror) {
            this.current.firsterror = false;
            dock.jsonCallError(this, code, data);
          }
          this.current.todo--;
          if(this.current.todo <= 0) {              
            refresh();
            dock.unwaitIcon();
          }
        }, work);
    }
  }
}

function suspendJob() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else {
    dock.waitIcon();
    var work = {'cluster': current, 'todo': select.length, 'firsterror': true};
    for(var i = 0; i < select.length; i++) {
      var x = select[i].split('|');
      dock.workerpool.getWorker(current.actualurl).call('cmjob', 'suspendJob', x, function(code, data) {
          if(code != 0 && this.current.firsterror) {
            this.current.firsterror = false;
            dock.jsonCallError(this, code, data);
          }
          this.current.todo--;
          if(this.current.todo <= 0) {              
            refresh();
            dock.unwaitIcon();
          }
        }, work);
    }
  }
}

function resumeJob() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else {
    dock.waitIcon();
    var work = {'cluster': current, 'todo': select.length, 'firsterror': true};
    for(var i = 0; i < select.length; i++) {
      var x = select[i].split('|');
      dock.workerpool.getWorker(current.actualurl).call('cmjob', 'resumeJob', x, function(code, data) {
          if(code != 0 && this.current.firsterror) {
            this.current.firsterror = false;
            dock.jsonCallError(this, code, data);
          }
          this.current.todo--;
          if(this.current.todo <= 0) {              
            refresh();
            dock.unwaitIcon();
          }
        }, work);
    }
  }
}


function jobHealth() {
  var select = selected('list');
  if(select.length == 0) {
    dock.displayError("Please select a job");
  } else {
    var nodes = new Array();
    for(var i = 0; i < select.length; i++) {
      var nn = current.getJobNodeCache(select[i]);
      nodes = nodes.concat(nn);
    }    
    current.healthDeviceSelection = sort_unique(nodes);
    dock.doOpenBookmark(current.key + '|health');
  }
}
